/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/base/common/strings","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","os","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],D=0,L=K.length;D<L;D++)e[D]=Z[K[D]];return e};define(Z[90],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(n){const w=[];for(let f in n)D.call(n,f)&&w.push(n[f]);return w}e.values=L;function R(n,w){for(let f in n)if(D.call(n,f)&&w({key:f,value:n[f]},function(){delete n[f]})===!1)return}e.forEach=R;function T(n,w){const f=Object.create(null);for(const d of n){const l=w(d);let m=f[l];m||(m=f[l]=[]),m.push(d)}return f}e.groupBy=T;function A(n){const w=Object.create(null);return n&&n.forEach((f,d)=>{w[d]=f}),w}e.fromMap=A;function P(n,w){const f=[],d=[];for(let l of n)w.has(l)||f.push(l);for(let l of w)n.has(l)||d.push(l);return{removed:f,added:d}}e.diffSets=P;function y(n,w){const f=[],d=[];for(let[l,m]of n)w.has(l)||f.push(m);for(let[l,m]of w)n.has(l)||d.push(m);return{removed:f,added:d}}e.diffMaps=y;class b{constructor(){this.map=new Map}add(w,f){let d=this.map.get(w);d||(d=new Set,this.map.set(w,d)),d.add(f)}delete(w,f){const d=this.map.get(w);!d||(d.delete(f),d.size===0&&this.map.delete(w))}forEach(w,f){const d=this.map.get(w);!d||d.forEach(f)}}e.SetMap=b}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(P,y,b)=>{let n=null,w=null;if(typeof b.value=="function"?(n="value",w=b.value):typeof b.get=="function"&&(n="get",w=b.get),!w)throw new Error("not supported");b[n]=A(w,y)}}e.createDecorator=D;function L(A,P,y){let b=null,n=null;if(typeof y.value=="function"?(b="value",n=y.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(b="get",n=y.get),!n)throw new Error("not supported");const w=`$memoize$${P}`;y[b]=function(...f){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,f)}),this[w]}}e.memoize=L;function R(A,P,y){return D((b,n)=>{const w=`$debounce$${n}`,f=`$debounce$result$${n}`;return function(...d){this[f]||(this[f]=y?y():void 0),clearTimeout(this[w]),P&&(this[f]=P(this[f],...d),d=[this[f]]),this[w]=setTimeout(()=>{b.apply(this,d),this[f]=y?y():void 0},A)}})}e.debounce=R;function T(A,P,y){return D((b,n)=>{const w=`$throttle$timer$${n}`,f=`$throttle$result$${n}`,d=`$throttle$lastRun$${n}`,l=`$throttle$pending$${n}`;return function(...m){if(this[f]||(this[f]=y?y():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...m)),this[l])return;const I=this[d]+A;I<=Date.now()?(this[d]=Date.now(),b.apply(this,[this[f]]),this[f]=y?y():void 0):(this[l]=!0,this[w]=setTimeout(()=>{this[l]=!1,this[d]=Date.now(),b.apply(this,[this[f]]),this[f]=y?y():void 0},I-Date.now()))}})}e.throttle=T}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=L;function R(o){y(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=R;function T(o){y(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=T;function A(o){if(o instanceof Error){let{name:t,message:r}=o;const i=o.stacktrace||o.stack;return{$isError:!0,name:t,message:r,stack:i}}return o}e.transformErrorForSerialization=A;const P="Canceled";function y(o){return o instanceof Error&&o.name===P&&o.message===P}e.isPromiseCanceledError=y;class b extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=b;function n(){const o=new Error(P);return o.name=o.message,o}e.canceled=n;function w(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=w;function f(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=f;function d(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function l(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=m;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function v(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function a(o,t=Object.create(null)){const r=new Error(o);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=a}),define(Z[22],ee([0,1,11]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(_,G=0){return _[_.length-(1+G)]}e.tail=L;function R(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=R;function T(_,G,W=(X,Q)=>X===Q){if(_===G)return!0;if(!_||!G||_.length!==G.length)return!1;for(let X=0,Q=_.length;X<Q;X++)if(!W(_[X],G[X]))return!1;return!0}e.equals=T;function A(_,G,W){let X=0,Q=_.length-1;for(;X<=Q;){const ie=(X+Q)/2|0,te=W(_[ie],G);if(te<0)X=ie+1;else if(te>0)Q=ie-1;else return ie}return-(X+1)}e.binarySearch=A;function P(_,G){let W=0,X=_.length;if(X===0)return 0;for(;W<X;){const Q=Math.floor((W+X)/2);G(_[Q])?X=Q:W=Q+1}return W}e.findFirstInSorted=P;function y(_,G,W){if(_=_|0,_>=G.length)throw new TypeError("invalid index");let X=G[Math.floor(G.length*Math.random())],Q=[],ie=[],te=[];for(let oe of G){const ue=W(oe,X);ue<0?Q.push(oe):ue>0?ie.push(oe):te.push(oe)}return _<Q.length?y(_,Q,W):_<Q.length+te.length?te[0]:y(_-(Q.length+te.length),ie,W)}e.quickSelect=y;function b(_,G){const W=[];let X;for(const Q of _.slice(0).sort(G))!X||G(X[0],Q)!==0?(X=[Q],W.push(X)):X.push(Q);return W}e.groupBy=b;function n(_,G,W){const X=[];function Q(oe,ue,de){if(ue===0&&de.length===0)return;const ve=X[X.length-1];ve&&ve.start+ve.deleteCount===oe?(ve.deleteCount+=ue,ve.toInsert.push(...de)):X.push({start:oe,deleteCount:ue,toInsert:de})}let ie=0,te=0;for(;;){if(ie===_.length){Q(ie,0,G.slice(te));break}if(te===G.length){Q(ie,_.length-ie,[]);break}const oe=_[ie],ue=G[te],de=W(oe,ue);de===0?(ie+=1,te+=1):de<0?(Q(ie,1,[]),ie+=1):de>0&&(Q(ie,0,[ue]),te+=1)}return X}e.sortedDiff=n;function w(_,G,W){const X=n(_,G,W),Q=[],ie=[];for(const te of X)Q.push(..._.slice(te.start,te.start+te.deleteCount)),ie.push(...te.toInsert);return{removed:Q,added:ie}}e.delta=w;function f(_,G,W){if(W===0)return[];const X=_.slice(0,W).sort(G);return l(_,G,X,W,_.length),X}e.top=f;function d(_,G,W,X,Q){return W===0?Promise.resolve([]):new Promise((ie,te)=>{(async()=>{const oe=_.length,ue=_.slice(0,W).sort(G);for(let de=W,ve=Math.min(W+X,oe);de<oe;de=ve,ve=Math.min(ve+X,oe)){if(de>W&&await new Promise(Re=>setTimeout(Re)),Q&&Q.isCancellationRequested)throw(0,D.canceled)();l(_,G,ue,de,ve)}return ue})().then(ie,te)})}e.topAsync=d;function l(_,G,W,X,Q){for(const ie=W.length;X<Q;X++){const te=_[X];if(G(te,W[ie-1])<0){W.pop();const oe=P(W,ue=>G(te,ue)<0);W.splice(oe,0,te)}}}function m(_){return _.filter(G=>!!G)}e.coalesce=m;function I(_){let G=0;for(let W=0;W<_.length;W++)_[W]&&(_[G]=_[W],G+=1);_.length=G}e.coalesceInPlace=I;function E(_,G,W){_.splice(W,0,_.splice(G,1)[0])}e.move=E;function C(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=C;function v(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=v;function a(_,G){if(!G)return _.filter((X,Q)=>_.indexOf(X)===Q);const W=Object.create(null);return _.filter(X=>{const Q=G(X);return W[Q]?!1:(W[Q]=!0,!0)})}e.distinct=a;function o(_){const G=new Set;return _.filter(W=>G.has(W)?!1:(G.add(W),!0))}e.distinctES6=o;function t(_){const G=Object.create(null);return W=>{const X=_(W);return G[X]?!1:(G[X]=!0,!0)}}e.uniqueFilter=t;function r(_,G){for(let W=_.length-1;W>=0;W--){const X=_[W];if(G(X))return W}return-1}e.lastIndex=r;function i(_,G){return _.length>0?_[0]:G}e.firstOrDefault=i;function s(_,G,W=(X,Q)=>X===Q){let X=0;for(let Q=0,ie=Math.min(_.length,G.length);Q<ie&&W(_[Q],G[Q]);Q++)X++;return X}e.commonPrefixLength=s;function u(_){return[].concat(..._)}e.flatten=u;function c(_,G){let W=typeof G=="number"?_:0;typeof G=="number"?W=_:(W=0,G=_);const X=[];if(W<=G)for(let Q=W;Q<G;Q++)X.push(Q);else for(let Q=W;Q>G;Q--)X.push(Q);return X}e.range=c;function h(_,G,W){return _.reduce((X,Q)=>(X[G(Q)]=W?W(Q):Q,X),Object.create(null))}e.index=h;function p(_,G){return _.push(G),()=>S(_,G)}e.insert=p;function S(_,G){const W=_.indexOf(G);if(W>-1)return _.splice(W,1),G}e.remove=S;function g(_,G,W){const X=_.slice(0,G),Q=_.slice(G);return X.concat(W,Q)}e.arrayInsert=g;function k(_,G){let W;if(typeof G=="number"){let X=G;W=()=>{const Q=Math.sin(X++)*179426549;return Q-Math.floor(Q)}}else W=Math.random;for(let X=_.length-1;X>0;X-=1){const Q=Math.floor(W()*(X+1)),ie=_[X];_[X]=_[Q],_[Q]=ie}}e.shuffle=k;function O(_,G){const W=_.indexOf(G);W>-1&&(_.splice(W,1),_.unshift(G))}e.pushToStart=O;function x(_,G){const W=_.indexOf(G);W>-1&&(_.splice(W,1),_.push(G))}e.pushToEnd=x;function z(_,G){return Array.isArray(_)?_.map(G):G(_)}e.mapArrayOrNot=z;function H(_){return Array.isArray(_)?_:[_]}e.asArray=H;function B(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=B;function U(_,G){for(const W of _){const X=G(W);if(X!==void 0)return X}}e.mapFind=U;function $(_,G,W){const X=N(_,G),Q=_.length,ie=W.length;_.length=Q+ie;for(let te=Q-1;te>=X;te--)_[te+ie]=_[te];for(let te=0;te<ie;te++)_[te+X]=W[te]}e.insertInto=$;function M(_,G,W,X){const Q=N(_,G),ie=_.splice(Q,W);return $(_,Q,X),ie}e.splice=M;function N(_,G){return G<0?Math.max(G+_.length,0):Math.min(G,_.length)}function j(_,G){let W=Number.MAX_SAFE_INTEGER,X=0;return _.forEach((Q,ie)=>{const te=G(Q);te<W&&(W=te,X=ie)}),X}e.minIndex=j;function F(_,G){let W=Number.MIN_SAFE_INTEGER,X=0;return _.forEach((Q,ie)=>{const te=G(Q);te>W&&(W=te,X=ie)}),X}e.maxIndex=F;class q{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let W=this.firstIdx;for(;W<this.items.length&&G(this.items[W]);)W++;const X=W===this.firstIdx?null:this.items.slice(this.firstIdx,W);return this.firstIdx=W,X}takeFromEndWhile(G){let W=this.lastIdx;for(;W>=0&&G(this.items[W]);)W--;const X=W===this.lastIdx?null:this.items.slice(W+1,this.lastIdx+1);return this.lastIdx=W,X}}e.ArrayQueue=q}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let T=!1,A;return function(){return T||(T=!0,A=L.apply(R,arguments)),A}}e.once=D}),define(Z[55],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}L.is=R;const T=Object.freeze([]);function A(){return T}L.empty=A;function*P(o){yield o}L.single=P;function y(o){return o||T}L.from=y;function b(o){return!o||o[Symbol.iterator]().next().done===!0}L.isEmpty=b;function n(o){return o[Symbol.iterator]().next().value}L.first=n;function w(o,t){for(const r of o)if(t(r))return!0;return!1}L.some=w;function f(o,t){for(const r of o)if(t(r))return r}L.find=f;function*d(o,t){for(const r of o)t(r)&&(yield r)}L.filter=d;function*l(o,t){let r=0;for(const i of o)yield t(i,r++)}L.map=l;function*m(...o){for(const t of o)for(const r of t)yield r}L.concat=m;function*I(o){for(const t of o)for(const r of t)yield r}L.concatNested=I;function E(o,t,r){let i=r;for(const s of o)i=t(i,s);return i}L.reduce=E;function*C(o,t,r=o.length){for(t<0&&(t+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);t<r;t++)yield o[t]}L.slice=C;function v(o,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,o];const i=o[Symbol.iterator]();for(let s=0;s<t;s++){const u=i.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=v;function a(o,t,r=(i,s)=>i===s){const i=o[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=i.next(),c=s.next();if(u.done!==c.done)return!1;if(u.done)return!0;if(!r(u.value,c.value))return!1}}L.equals=a})(D=e.Iterable||(e.Iterable={}))}),define(Z[33],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,s=t.length,u="",c=0,h=16,p=0;function S(B){let U=0,$=0;for(;U<B;){const M=t.charCodeAt(i);if(M>=48&&M<=57)$=$*16+M-48;else if(M>=65&&M<=70)$=$*16+M-65+10;else if(M>=97&&M<=102)$=$*16+M-97+10;else break;i++,U++}return U<B&&($=-1),$}function g(B){i=B,u="",c=0,h=16,p=0}function k(){const B=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&b(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&b(t.charCodeAt(i)))for(i++;i<t.length&&b(t.charCodeAt(i));)i++;else return p=3,t.substring(B,i);let U=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&b(t.charCodeAt(i))){for(i++;i<t.length&&b(t.charCodeAt(i));)i++;U=i}else p=3;return t.substring(B,U)}function O(){let B="",U=i;for(;;){if(i>=s){B+=t.substring(U,i),p=2;break}const $=t.charCodeAt(i);if($===34){B+=t.substring(U,i),i++;break}if($===92){if(B+=t.substring(U,i),i++,i>=s){p=2;break}switch(t.charCodeAt(i++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const N=S(4);N>=0?B+=String.fromCharCode(N):p=4;break;default:p=5}U=i;continue}if($>=0&&$<=31)if(y($)){B+=t.substring(U,i),p=2;break}else p=6;i++}return B}function x(){if(u="",p=0,c=i,i>=s)return c=s,h=17;let B=t.charCodeAt(i);if(P(B)){do i++,u+=String.fromCharCode(B),B=t.charCodeAt(i);while(P(B));return h=15}if(y(B))return i++,u+=String.fromCharCode(B),B===13&&t.charCodeAt(i)===10&&(i++,u+=`
`),h=14;switch(B){case 123:return i++,h=1;case 125:return i++,h=2;case 91:return i++,h=3;case 93:return i++,h=4;case 58:return i++,h=6;case 44:return i++,h=5;case 34:return i++,u=O(),h=10;case 47:const U=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!y(t.charCodeAt(i));)i++;return u=t.substring(U,i),h=12}if(t.charCodeAt(i+1)===42){i+=2;const $=s-1;let M=!1;for(;i<$;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,M=!0;break}i++}return M||(i++,p=1),u=t.substring(U,i),h=13}return u+=String.fromCharCode(B),i++,h=16;case 45:if(u+=String.fromCharCode(B),i++,i===s||!b(t.charCodeAt(i)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=k(),h=11;default:for(;i<s&&z(B);)i++,B=t.charCodeAt(i);if(c!==i){switch(u=t.substring(c,i),u){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return u+=String.fromCharCode(B),i++,h=16}}function z(B){if(P(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:g,getPosition:()=>i,scan:r?H:x,getToken:()=>h,getTokenValue:()=>u,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>p}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function w(t,r){const i=[],s=new Object;let u;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function p(S,g,k,O){c.value=S,c.offset=g,c.length=k,c.type=O,c.colonOffset=void 0,u=c}try{v(t,{onObjectBegin:(S,g)=>{if(r<=S)throw s;u=void 0,h=r>S,i.push("")},onObjectProperty:(S,g,k)=>{if(r<g||(p(S,g,k,"property"),i[i.length-1]=S,r<=g+k))throw s},onObjectEnd:(S,g)=>{if(r<=S)throw s;u=void 0,i.pop()},onArrayBegin:(S,g)=>{if(r<=S)throw s;u=void 0,i.push(0)},onArrayEnd:(S,g)=>{if(r<=S)throw s;u=void 0,i.pop()},onLiteralValue:(S,g,k)=>{if(r<g||(p(S,g,k,o(S)),r<=g+k))throw s},onSeparator:(S,g,k)=>{if(r<=g)throw s;if(S===":"&&u&&u.type==="property")u.colonOffset=g,h=!1,u=void 0;else if(S===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(h=!0,i[i.length-1]=""),u=void 0}}})}catch(S){if(S!==s)throw S}return{path:i,previousNode:u,isAtPropertyKey:h,matches:S=>{let g=0;for(let k=0;g<S.length&&k<i.length;k++)if(S[g]===i[k]||S[g]==="*")g++;else if(S[g]!=="**")return!1;return g===S.length}}}e.getLocation=w;function f(t,r=[],i=T.DEFAULT){let s=null,u=[];const c=[];function h(S){Array.isArray(u)?u.push(S):s!==null&&(u[s]=S)}return v(t,{onObjectBegin:()=>{const S={};h(S),c.push(u),u=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{u=c.pop()},onArrayBegin:()=>{const S=[];h(S),c.push(u),u=S,s=null},onArrayEnd:()=>{u=c.pop()},onLiteralValue:h,onError:(S,g,k)=>{r.push({error:S,offset:g,length:k})}},i),u[0]}e.parse=f;function d(t,r=[],i=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function c(S){return s.children.push(S),S}v(t,{onObjectBegin:S=>{s=c({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,g,k)=>{s=c({type:"property",offset:g,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:g,length:k,parent:s})},onObjectEnd:(S,g)=>{s.length=S+g-s.offset,s=s.parent,u(S+g)},onArrayBegin:(S,g)=>{s=c({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,g)=>{s.length=S+g-s.offset,s=s.parent,u(S+g)},onLiteralValue:(S,g,k)=>{c({type:o(S),offset:g,length:k,parent:s,value:S}),u(g+k)},onSeparator:(S,g,k)=>{s.type==="property"&&(S===":"?s.colonOffset=g:S===","&&u(g))},onError:(S,g,k)=>{r.push({error:S,offset:g,length:k})}},i);const p=s.children[0];return p&&delete p.parent,p}e.parseTree=d;function l(t,r){if(!t)return;let i=t;for(let s of r)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===s){i=c.children[1],u=!0;break}if(!u)return}else{const u=s;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=l;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=m;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const r=Object.create(null);for(let i of t.children){const s=i.children[1];s&&(r[i.children[0].value]=I(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function E(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=E;function C(t,r,i=!1){if(E(t,r,i)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=r;u++){const c=C(s[u],r,i);if(c)return c}return t}}e.findNodeAtOffset=C;function v(t,r,i=T.DEFAULT){const s=A(t,!1);function u(W){return W?()=>W(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(W){return W?X=>W(X,s.getTokenOffset(),s.getTokenLength()):()=>!0}const h=u(r.onObjectBegin),p=c(r.onObjectProperty),S=u(r.onObjectEnd),g=u(r.onArrayBegin),k=u(r.onArrayEnd),O=c(r.onLiteralValue),x=c(r.onSeparator),z=u(r.onComment),H=c(r.onError),B=i&&i.disallowComments,U=i&&i.allowTrailingComma;function $(){for(;;){const W=s.scan();switch(s.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:B||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(W){case 12:case 13:B?M(10):z();break;case 16:M(1);break;case 15:case 14:break;default:return W}}}function M(W,X=[],Q=[]){if(H(W),X.length+Q.length>0){let ie=s.getToken();for(;ie!==17;){if(X.indexOf(ie)!==-1){$();break}else if(Q.indexOf(ie)!==-1)break;ie=$()}}}function N(W){const X=s.getTokenValue();return W?O(X):p(X),$(),!0}function j(){switch(s.getToken()){case 11:let W=0;try{W=JSON.parse(s.getTokenValue()),typeof W!="number"&&(M(2),W=0)}catch(X){M(2)}O(W);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return $(),!0}function F(){return s.getToken()!==10?(M(3,[],[2,5]),!1):(N(!1),s.getToken()===6?(x(":"),$(),G()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function q(){h(),$();let W=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(W||M(4,[],[]),x(","),$(),s.getToken()===2&&U)break}else W&&M(6,[],[]);F()||M(4,[],[2,5]),W=!0}return S(),s.getToken()!==2?M(7,[2],[]):$(),!0}function _(){g(),$();let W=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(W||M(4,[],[]),x(","),$(),s.getToken()===4&&U)break}else W&&M(6,[],[]);G()||M(4,[],[4,5]),W=!0}return k(),s.getToken()!==4?M(8,[4],[]):$(),!0}function G(){switch(s.getToken()){case 3:return _();case 1:return q();case 10:return N(!0);default:return j()}}return $(),s.getToken()===17?i.allowEmptyContent?!0:(M(4,[],[]),!1):G()?(s.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=v;function a(t,r){let i=A(t),s=[],u,c=0,h;do switch(h=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:c!==h&&s.push(t.substring(c,h)),r!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(u!==17);return s.join("")}e.stripComments=a;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(Z[47],ee([0,1,33]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(y,b,n){let w,f,d,l,m;if(b){for(l=b.offset,m=l+b.length,d=l;d>0&&!P(y,d-1);)d--;let c=m;for(;c<y.length&&!P(y,c);)c++;f=y.substring(d,c),w=T(f,n)}else f=y,w=0,d=0,l=0,m=y.length;const I=A(n,y);let E=!1,C=0,v;n.insertSpaces?v=R(" ",n.tabSize||4):v="	";const a=(0,D.createScanner)(f,!1);let o=!1;function t(){return I+R(v,w+C)}function r(){let c=a.scan();for(E=!1;c===15||c===14;)E=E||c===14,c=a.scan();return o=c===16||a.getTokenError()!==0,c}const i=[];function s(c,h,p){!o&&h<m&&p>l&&y.substring(h,p)!==c&&i.push({offset:h,length:p-h,content:c})}let u=r();if(u!==17){const c=a.getTokenOffset()+d,h=R(v,w);s(h,d,c)}for(;u!==17;){let c=a.getTokenOffset()+a.getTokenLength()+d,h=r(),p="";for(;!E&&(h===12||h===13);){const g=a.getTokenOffset()+d;s(" ",c,g),c=a.getTokenOffset()+a.getTokenLength()+d,p=h===12?t():"",h=r()}if(h===2)u!==1&&(C--,p=t());else if(h===4)u!==3&&(C--,p=t());else{switch(u){case 3:case 1:C++,p=t();break;case 5:case 12:p=t();break;case 13:E?p=t():p=" ";break;case 6:p=" ";break;case 10:if(h===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?p=" ":h!==5&&h!==17&&(o=!0);break;case 16:o=!0;break}E&&(h===12||h===13)&&(p=t())}const S=a.getTokenOffset()+d;s(p,c,S),u=h}return i}e.format=L;function R(y,b){let n="";for(let w=0;w<b;w++)n+=y;return n}function T(y,b){let n=0,w=0;const f=b.tabSize||4;for(;n<y.length;){const d=y.charAt(n);if(d===" ")w++;else if(d==="	")w+=f;else break;n++}return Math.floor(w/f)}function A(y,b){for(let n=0;n<b.length;n++){const w=b.charAt(n);if(w==="\r")return n+1<b.length&&b.charAt(n+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=A;function P(y,b){return`\r
`.indexOf(y.charAt(b))!==-1}e.isEOL=P}),define(Z[43],ee([0,1,33,47]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(b,n,w){return T(b,n,void 0,w)}e.removeProperty=R;function T(b,n,w,f,d){const l=n.slice(),m=[],I=(0,D.parseTree)(b,m);let E,C;for(;l.length>0&&(C=l.pop(),E=(0,D.findNodeAtLocation)(I,l),E===void 0&&w!==void 0);)typeof C=="string"?w={[C]:w}:w=[w];if(E)if(E.type==="object"&&typeof C=="string"&&Array.isArray(E.children)){const v=(0,D.findNodeAtLocation)(E,[C]);if(v!==void 0)if(w===void 0){if(!v.parent)throw new Error("Malformed AST");const a=E.children.indexOf(v.parent);let o,t=v.parent.offset+v.parent.length;if(a>0){const r=E.children[a-1];o=r.offset+r.length}else o=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return A(b,{offset:o,length:t-o,content:""},f)}else return A(b,{offset:v.offset,length:v.length,content:JSON.stringify(w)},f);else{if(w===void 0)return[];const a=`${JSON.stringify(C)}: ${JSON.stringify(w)}`,o=d?d(E.children.map(r=>r.children[0].value)):E.children.length;let t;if(o>0){const r=E.children[o-1];t={offset:r.offset+r.length,length:0,content:","+a}}else E.children.length===0?t={offset:E.offset+1,length:0,content:a}:t={offset:E.offset+1,length:0,content:a+","};return A(b,t,f)}}else if(E.type==="array"&&typeof C=="number"&&Array.isArray(E.children))if(w!==void 0){const v=`${JSON.stringify(w)}`;let a;if(E.children.length===0||C===0)a={offset:E.offset+1,length:0,content:E.children.length===0?v:v+","};else{const o=C===-1||C>E.children.length?E.children.length:C,t=E.children[o-1];a={offset:t.offset+t.length,length:0,content:","+v}}return A(b,a,f)}else{const v=C,a=E.children[v];let o;if(E.children.length===1)o={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===v){const t=E.children[v-1],r=t.offset+t.length,i=E.offset+E.length;o={offset:r,length:i-2-r,content:""}}else o={offset:a.offset,length:E.children[v+1].offset-a.offset,content:""};return A(b,o,f)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${E.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(b,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(w)},f)}}e.setProperty=T;function A(b,n,w){let f=P(b,n),d=n.offset,l=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;d>0&&!(0,L.isEOL)(f,d-1);)d--;for(;l<f.length&&!(0,L.isEOL)(f,l);)l++}const m=(0,L.format)(f,{offset:d,length:l-d},w);for(let E=m.length-1;E>=0;E--){const C=m[E];f=P(f,C),d=Math.min(d,C.offset),l=Math.max(l,C.offset+C.length),l+=C.content.length-C.length}const I=b.length-(f.length-l)-d;return[{offset:d,length:I,content:f.substring(d,l)}]}e.withFormatting=A;function P(b,n){return b.substring(0,n.offset)+n.content+b.substring(n.offset+n.length)}e.applyEdit=P;function y(b,n){let w=n.slice(0).sort((d,l)=>{const m=d.offset-l.offset;return m===0?d.length-l.length:m}),f=b.length;for(let d=w.length-1;d>=0;d--){let l=w[d];if(l.offset+l.length<=f)b=P(b,l);else throw new Error("Overlapping edit");f=l.offset}return b}e.applyEdits=y}),define(Z[2],ee([0,1,65,55]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function A(i){T=i}if(e.setDisposableTracker=A,R){const i="__is_disposable_tracked__";A(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==C.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==C.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function P(i){return T?.trackDisposable(i),i}function y(i){T?.markAsDisposed(i)}function b(i,s){T?.setParent(i,s)}function n(i,s){if(!!T)for(const u of i)T.setParent(u,s)}function w(i){return T?.markAsSingleton(i),i}e.markAsSingleton=w;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function d(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=d;function l(i){if(L.Iterable.is(i)){let s=[];for(const u of i)if(u)try{u.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=l;function m(...i){const s=I(()=>l(i));return n(i,s),s}e.combinedDisposable=m;function I(i){const s=P({dispose:(0,D.once)(()=>{y(s),i()})});return s}e.toDisposable=I;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new E,P(this),b(this._store,this)}dispose(){y(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=v;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class o{constructor(){this.references=new Map}acquire(s,...u){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,c));const{object:h}=c,p=(0,D.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:h,dispose:p}}}e.ReferenceCollection=o;class t{constructor(s){this.referenceCollection=s}async acquire(s,...u){const c=this.referenceCollection.acquire(s,...u);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(h){throw c.dispose(),h}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(Z[91],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const A=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(A){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function K(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function A(y){T.push(y,Date.now())}function P(){const y=[];for(let b=0;b<T.length;b+=2)y.push({name:T[b],startTime:T[b+1]});return y}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(R+A.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,T=!1,A=!1,P=!1,y=!1,b=!1,n,w=D,f,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const m=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=m&&l?.sandboxed,typeof navigator=="object"&&!m)d=navigator.userAgent,L=d.indexOf("Windows")>=0,R=d.indexOf("Macintosh")>=0,b=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=d.indexOf("Linux")>=0,y=!0,n=navigator.language,w=n;else if(typeof l=="object"){L=l.platform==="win32",R=l.platform==="darwin",T=l.platform==="linux",A=T&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,n=D,w=D;const i=l.env.VSCODE_NLS_CONFIG;if(i)try{const s=JSON.parse(i),u=s.availableLanguages["*"];n=s.locale,w=u||D,f=s._translationsConfigFile}catch(s){}P=!0}else console.error("Unable to resolve platform.");var I;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function E(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let C=0;R?C=1:L?C=3:T&&(C=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=A,e.isNative=P,e.isWeb=y,e.isIOS=b,e.platform=C,e.userAgent=d,e.language=w;var v;(function(i){function s(){return e.language}i.value=s;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=u;function c(){return e.language==="en"}i.isDefault=c})(v=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let p=0,S=u.length;p<S;p++){const g=u[p];if(g.id===h.data.vscodeSetImmediateId){u.splice(p,1),g.callback();return}}});let c=0;return h=>{const p=++c;u.push({id:p,callback:h}),e.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const s=Promise.resolve();return u=>s.then(u)}();var a;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:L?1:3;let o=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,o=new Uint16Array(i.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=r}),define(Z[35],ee([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(T){return(0,D.setImmediate)(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(Z[8],ee([0,1,35]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,T=90,A=122,P=46,y=47,b=92,n=58,w=63;class f extends Error{constructor(a,o,t){let r;typeof o=="string"&&o.indexOf("not ")===0?(r="must not be",o=o.replace(/^not /,"")):r="must be";const i=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${i} ${r} of type ${o}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function d(v,a){if(typeof v!="string")throw new f(a,"string",v)}function l(v){return v===y||v===b}function m(v){return v===y}function I(v){return v>=L&&v<=T||v>=R&&v<=A}function E(v,a,o,t){let r="",i=0,s=-1,u=0,c=0;for(let h=0;h<=v.length;++h){if(h<v.length)c=v.charCodeAt(h);else{if(t(c))break;c=y}if(t(c)){if(!(s===h-1||u===1))if(u===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const p=r.lastIndexOf(o);p===-1?(r="",i=0):(r=r.slice(0,p),i=r.length-1-r.lastIndexOf(o)),s=h,u=0;continue}else if(r.length!==0){r="",i=0,s=h,u=0;continue}}a&&(r+=r.length>0?`${o}..`:"..",i=2)}else r.length>0?r+=`${o}${v.slice(s+1,h)}`:r=v.slice(s+1,h),i=h-s-1;s=h,u=0}else c===P&&u!==-1?++u:u=-1}return r}function C(v,a){if(a===null||typeof a!="object")throw new f("pathObject","Object",a);const o=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return o?o===a.root?`${o}${t}`:`${o}${v}${t}`:t}e.win32={resolve(...v){let a="",o="",t=!1;for(let r=v.length-1;r>=-1;r--){let i;if(r>=0){if(i=v[r],d(i,"path"),i.length===0)continue}else a.length===0?i=D.cwd():(i=D.env[`=${a}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==a.toLowerCase()&&i.charCodeAt(2)===b)&&(i=`${a}\\`));const s=i.length;let u=0,c="",h=!1;const p=i.charCodeAt(0);if(s===1)l(p)&&(u=1,h=!0);else if(l(p))if(h=!0,l(i.charCodeAt(1))){let S=2,g=S;for(;S<s&&!l(i.charCodeAt(S));)S++;if(S<s&&S!==g){const k=i.slice(g,S);for(g=S;S<s&&l(i.charCodeAt(S));)S++;if(S<s&&S!==g){for(g=S;S<s&&!l(i.charCodeAt(S));)S++;(S===s||S!==g)&&(c=`\\\\${k}\\${i.slice(g,S)}`,u=S)}}}else u=1;else I(p)&&i.charCodeAt(1)===n&&(c=i.slice(0,2),u=2,s>2&&l(i.charCodeAt(2))&&(h=!0,u=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(t){if(a.length>0)break}else if(o=`${i.slice(u)}\\${o}`,t=h,h&&a.length>0)break}return o=E(o,!t,"\\",l),t?`${a}\\${o}`:`${a}${o}`||"."},normalize(v){d(v,"path");const a=v.length;if(a===0)return".";let o=0,t,r=!1;const i=v.charCodeAt(0);if(a===1)return m(i)?"\\":v;if(l(i))if(r=!0,l(v.charCodeAt(1))){let u=2,c=u;for(;u<a&&!l(v.charCodeAt(u));)u++;if(u<a&&u!==c){const h=v.slice(c,u);for(c=u;u<a&&l(v.charCodeAt(u));)u++;if(u<a&&u!==c){for(c=u;u<a&&!l(v.charCodeAt(u));)u++;if(u===a)return`\\\\${h}\\${v.slice(c)}\\`;u!==c&&(t=`\\\\${h}\\${v.slice(c,u)}`,o=u)}}}else o=1;else I(i)&&v.charCodeAt(1)===n&&(t=v.slice(0,2),o=2,a>2&&l(v.charCodeAt(2))&&(r=!0,o=3));let s=o<a?E(v.slice(o),!r,"\\",l):"";return s.length===0&&!r&&(s="."),s.length>0&&l(v.charCodeAt(a-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(v){d(v,"path");const a=v.length;if(a===0)return!1;const o=v.charCodeAt(0);return l(o)||a>2&&I(o)&&v.charCodeAt(1)===n&&l(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let a,o;for(let i=0;i<v.length;++i){const s=v[i];d(s,"path"),s.length>0&&(a===void 0?a=o=s:a+=`\\${s}`)}if(a===void 0)return".";let t=!0,r=0;if(typeof o=="string"&&l(o.charCodeAt(0))){++r;const i=o.length;i>1&&l(o.charCodeAt(1))&&(++r,i>2&&(l(o.charCodeAt(2))?++r:t=!1))}if(t){for(;r<a.length&&l(a.charCodeAt(r));)r++;r>=2&&(a=`\\${a.slice(r)}`)}return e.win32.normalize(a)},relative(v,a){if(d(v,"from"),d(a,"to"),v===a)return"";const o=e.win32.resolve(v),t=e.win32.resolve(a);if(o===t||(v=o.toLowerCase(),a=t.toLowerCase(),v===a))return"";let r=0;for(;r<v.length&&v.charCodeAt(r)===b;)r++;let i=v.length;for(;i-1>r&&v.charCodeAt(i-1)===b;)i--;const s=i-r;let u=0;for(;u<a.length&&a.charCodeAt(u)===b;)u++;let c=a.length;for(;c-1>u&&a.charCodeAt(c-1)===b;)c--;const h=c-u,p=s<h?s:h;let S=-1,g=0;for(;g<p;g++){const O=v.charCodeAt(r+g);if(O!==a.charCodeAt(u+g))break;O===b&&(S=g)}if(g!==p){if(S===-1)return t}else{if(h>p){if(a.charCodeAt(u+g)===b)return t.slice(u+g+1);if(g===2)return t.slice(u+g)}s>p&&(v.charCodeAt(r+g)===b?S=g:g===2&&(S=3)),S===-1&&(S=0)}let k="";for(g=r+S+1;g<=i;++g)(g===i||v.charCodeAt(g)===b)&&(k+=k.length===0?"..":"\\..");return u+=S,k.length>0?`${k}${t.slice(u,c)}`:(t.charCodeAt(u)===b&&++u,t.slice(u,c))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const a=e.win32.resolve(v);if(a.length<=2)return v;if(a.charCodeAt(0)===b){if(a.charCodeAt(1)===b){const o=a.charCodeAt(2);if(o!==w&&o!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(I(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===b)return`\\\\?\\${a}`;return v},dirname(v){d(v,"path");const a=v.length;if(a===0)return".";let o=-1,t=0;const r=v.charCodeAt(0);if(a===1)return l(r)?v:".";if(l(r)){if(o=t=1,l(v.charCodeAt(1))){let u=2,c=u;for(;u<a&&!l(v.charCodeAt(u));)u++;if(u<a&&u!==c){for(c=u;u<a&&l(v.charCodeAt(u));)u++;if(u<a&&u!==c){for(c=u;u<a&&!l(v.charCodeAt(u));)u++;if(u===a)return v;u!==c&&(o=t=u+1)}}}}else I(r)&&v.charCodeAt(1)===n&&(o=a>2&&l(v.charCodeAt(2))?3:2,t=o);let i=-1,s=!0;for(let u=a-1;u>=t;--u)if(l(v.charCodeAt(u))){if(!s){i=u;break}}else s=!1;if(i===-1){if(o===-1)return".";i=o}return v.slice(0,i)},basename(v,a){a!==void 0&&d(a,"ext"),d(v,"path");let o=0,t=-1,r=!0,i;if(v.length>=2&&I(v.charCodeAt(0))&&v.charCodeAt(1)===n&&(o=2),a!==void 0&&a.length>0&&a.length<=v.length){if(a===v)return"";let s=a.length-1,u=-1;for(i=v.length-1;i>=o;--i){const c=v.charCodeAt(i);if(l(c)){if(!r){o=i+1;break}}else u===-1&&(r=!1,u=i+1),s>=0&&(c===a.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=u))}return o===t?t=u:t===-1&&(t=v.length),v.slice(o,t)}for(i=v.length-1;i>=o;--i)if(l(v.charCodeAt(i))){if(!r){o=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":v.slice(o,t)},extname(v){d(v,"path");let a=0,o=-1,t=0,r=-1,i=!0,s=0;v.length>=2&&v.charCodeAt(1)===n&&I(v.charCodeAt(0))&&(a=t=2);for(let u=v.length-1;u>=a;--u){const c=v.charCodeAt(u);if(l(c)){if(!i){t=u+1;break}continue}r===-1&&(i=!1,r=u+1),c===P?o===-1?o=u:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||r===-1||s===0||s===1&&o===r-1&&o===t+1?"":v.slice(o,r)},format:C.bind(null,"\\"),parse(v){d(v,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return a;const o=v.length;let t=0,r=v.charCodeAt(0);if(o===1)return l(r)?(a.root=a.dir=v,a):(a.base=a.name=v,a);if(l(r)){if(t=1,l(v.charCodeAt(1))){let S=2,g=S;for(;S<o&&!l(v.charCodeAt(S));)S++;if(S<o&&S!==g){for(g=S;S<o&&l(v.charCodeAt(S));)S++;if(S<o&&S!==g){for(g=S;S<o&&!l(v.charCodeAt(S));)S++;S===o?t=S:S!==g&&(t=S+1)}}}}else if(I(r)&&v.charCodeAt(1)===n){if(o<=2)return a.root=a.dir=v,a;if(t=2,l(v.charCodeAt(2))){if(o===3)return a.root=a.dir=v,a;t=3}}t>0&&(a.root=v.slice(0,t));let i=-1,s=t,u=-1,c=!0,h=v.length-1,p=0;for(;h>=t;--h){if(r=v.charCodeAt(h),l(r)){if(!c){s=h+1;break}continue}u===-1&&(c=!1,u=h+1),r===P?i===-1?i=h:p!==1&&(p=1):i!==-1&&(p=-1)}return u!==-1&&(i===-1||p===0||p===1&&i===u-1&&i===s+1?a.base=a.name=v.slice(s,u):(a.name=v.slice(s,i),a.base=v.slice(s,u),a.ext=v.slice(i,u))),s>0&&s!==t?a.dir=v.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let a="",o=!1;for(let t=v.length-1;t>=-1&&!o;t--){const r=t>=0?v[t]:D.cwd();d(r,"path"),r.length!==0&&(a=`${r}/${a}`,o=r.charCodeAt(0)===y)}return a=E(a,!o,"/",m),o?`/${a}`:a.length>0?a:"."},normalize(v){if(d(v,"path"),v.length===0)return".";const a=v.charCodeAt(0)===y,o=v.charCodeAt(v.length-1)===y;return v=E(v,!a,"/",m),v.length===0?a?"/":o?"./":".":(o&&(v+="/"),a?`/${v}`:v)},isAbsolute(v){return d(v,"path"),v.length>0&&v.charCodeAt(0)===y},join(...v){if(v.length===0)return".";let a;for(let o=0;o<v.length;++o){const t=v[o];d(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(v,a){if(d(v,"from"),d(a,"to"),v===a||(v=e.posix.resolve(v),a=e.posix.resolve(a),v===a))return"";const o=1,t=v.length,r=t-o,i=1,s=a.length-i,u=r<s?r:s;let c=-1,h=0;for(;h<u;h++){const S=v.charCodeAt(o+h);if(S!==a.charCodeAt(i+h))break;S===y&&(c=h)}if(h===u)if(s>u){if(a.charCodeAt(i+h)===y)return a.slice(i+h+1);if(h===0)return a.slice(i+h)}else r>u&&(v.charCodeAt(o+h)===y?c=h:h===0&&(c=0));let p="";for(h=o+c+1;h<=t;++h)(h===t||v.charCodeAt(h)===y)&&(p+=p.length===0?"..":"/..");return`${p}${a.slice(i+c)}`},toNamespacedPath(v){return v},dirname(v){if(d(v,"path"),v.length===0)return".";const a=v.charCodeAt(0)===y;let o=-1,t=!0;for(let r=v.length-1;r>=1;--r)if(v.charCodeAt(r)===y){if(!t){o=r;break}}else t=!1;return o===-1?a?"/":".":a&&o===1?"//":v.slice(0,o)},basename(v,a){a!==void 0&&d(a,"ext"),d(v,"path");let o=0,t=-1,r=!0,i;if(a!==void 0&&a.length>0&&a.length<=v.length){if(a===v)return"";let s=a.length-1,u=-1;for(i=v.length-1;i>=0;--i){const c=v.charCodeAt(i);if(c===y){if(!r){o=i+1;break}}else u===-1&&(r=!1,u=i+1),s>=0&&(c===a.charCodeAt(s)?--s==-1&&(t=i):(s=-1,t=u))}return o===t?t=u:t===-1&&(t=v.length),v.slice(o,t)}for(i=v.length-1;i>=0;--i)if(v.charCodeAt(i)===y){if(!r){o=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":v.slice(o,t)},extname(v){d(v,"path");let a=-1,o=0,t=-1,r=!0,i=0;for(let s=v.length-1;s>=0;--s){const u=v.charCodeAt(s);if(u===y){if(!r){o=s+1;break}continue}t===-1&&(r=!1,t=s+1),u===P?a===-1?a=s:i!==1&&(i=1):a!==-1&&(i=-1)}return a===-1||t===-1||i===0||i===1&&a===t-1&&a===o+1?"":v.slice(a,t)},format:C.bind(null,"/"),parse(v){d(v,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return a;const o=v.charCodeAt(0)===y;let t;o?(a.root="/",t=1):t=0;let r=-1,i=0,s=-1,u=!0,c=v.length-1,h=0;for(;c>=t;--c){const p=v.charCodeAt(c);if(p===y){if(!u){i=c+1;break}continue}s===-1&&(u=!1,s=c+1),p===P?r===-1?r=c:h!==1&&(h=1):r!==-1&&(h=-1)}if(s!==-1){const p=i===0&&o?1:i;r===-1||h===0||h===1&&r===s-1&&r===i+1?a.base=a.name=v.slice(p,s):(a.name=v.slice(p,r),a.base=v.slice(p,s),a.ext=v.slice(r,s))}return i>0?a.dir=v.slice(0,i-1):o&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:K)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return K[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=K,D.c=e,D.d=function(L,R,T){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:T})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var A in L)D.d(T,A,function(P){return L[P]}.bind(null,A));return T},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(K,e,D){(function(L){var R;e=K.exports=Q,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],y=e.src=[],b=0,n=b++;y[n]="0|[1-9]\\d*";var w=b++;y[w]="[0-9]+";var f=b++;y[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=b++;y[d]="("+y[n]+")\\.("+y[n]+")\\.("+y[n]+")";var l=b++;y[l]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var m=b++;y[m]="(?:"+y[n]+"|"+y[f]+")";var I=b++;y[I]="(?:"+y[w]+"|"+y[f]+")";var E=b++;y[E]="(?:-("+y[m]+"(?:\\."+y[m]+")*))";var C=b++;y[C]="(?:-?("+y[I]+"(?:\\."+y[I]+")*))";var v=b++;y[v]="[0-9A-Za-z-]+";var a=b++;y[a]="(?:\\+("+y[v]+"(?:\\."+y[v]+")*))";var o=b++,t="v?"+y[d]+y[E]+"?"+y[a]+"?";y[o]="^"+t+"$";var r="[v=\\s]*"+y[l]+y[C]+"?"+y[a]+"?",i=b++;y[i]="^"+r+"$";var s=b++;y[s]="((?:<|>)?=?)";var u=b++;y[u]=y[w]+"|x|X|\\*";var c=b++;y[c]=y[n]+"|x|X|\\*";var h=b++;y[h]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[E]+")?"+y[a]+"?)?)?";var p=b++;y[p]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[C]+")?"+y[a]+"?)?)?";var S=b++;y[S]="^"+y[s]+"\\s*"+y[h]+"$";var g=b++;y[g]="^"+y[s]+"\\s*"+y[p]+"$";var k=b++;y[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=b++;y[O]="(?:~>?)";var x=b++;y[x]="(\\s*)"+y[O]+"\\s+",P[x]=new RegExp(y[x],"g");var z=b++;y[z]="^"+y[O]+y[h]+"$";var H=b++;y[H]="^"+y[O]+y[p]+"$";var B=b++;y[B]="(?:\\^)";var U=b++;y[U]="(\\s*)"+y[B]+"\\s+",P[U]=new RegExp(y[U],"g");var $=b++;y[$]="^"+y[B]+y[h]+"$";var M=b++;y[M]="^"+y[B]+y[p]+"$";var N=b++;y[N]="^"+y[s]+"\\s*("+r+")$|^$";var j=b++;y[j]="^"+y[s]+"\\s*("+t+")$|^$";var F=b++;y[F]="(\\s*)"+y[s]+"\\s*("+r+"|"+y[h]+")",P[F]=new RegExp(y[F],"g");var q=b++;y[q]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var _=b++;y[_]="^\\s*("+y[p]+")\\s+-\\s+("+y[p]+")\\s*$";var G=b++;y[G]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)R(W,y[W]),P[W]||(P[W]=new RegExp(y[W]));function X(J,re){if(J instanceof Q)return J;if(typeof J!="string"||J.length>T||!(re?P[i]:P[o]).test(J))return null;try{return new Q(J,re)}catch(se){return null}}function Q(J,re){if(J instanceof Q){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Q))return new Q(J,re);R("SemVer",J,re),this.loose=re;var se=J.trim().match(re?P[i]:P[o]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var pe=+me;if(pe>=0&&pe<A)return pe}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=X,e.valid=function(J,re){var se=X(J,re);return se?se.version:null},e.clean=function(J,re){var se=X(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return R("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),te(this.major,J.major)||te(this.minor,J.minor)||te(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=J.prerelease[re];if(R("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return te(se,me)}while(++re)},Q.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new Q(J,se).inc(re,me).version}catch(pe){return null}},e.diff=function(J,re){if(ve(J,re))return null;var se=X(J),me=X(re);if(se.prerelease.length||me.prerelease.length){for(var pe in se)if((pe==="major"||pe==="minor"||pe==="patch")&&se[pe]!==me[pe])return"pre"+pe;return"prerelease"}for(var pe in se)if((pe==="major"||pe==="minor"||pe==="patch")&&se[pe]!==me[pe])return pe},e.compareIdentifiers=te;var ie=/^[0-9]+$/;function te(J,re){var se=ie.test(J),me=ie.test(re);return se&&me&&(J=+J,re=+re),se&&!me?-1:me&&!se?1:J<re?-1:J>re?1:0}function oe(J,re,se){return new Q(J,se).compare(new Q(re,se))}function ue(J,re,se){return oe(J,re,se)>0}function de(J,re,se){return oe(J,re,se)<0}function ve(J,re,se){return oe(J,re,se)===0}function Re(J,re,se){return oe(J,re,se)!==0}function Te(J,re,se){return oe(J,re,se)>=0}function Ne(J,re,se){return oe(J,re,se)<=0}function Oe(J,re,se,me){var pe;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),pe=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),pe=J!==se;break;case"":case"=":case"==":pe=ve(J,se,me);break;case"!=":pe=Re(J,se,me);break;case">":pe=ue(J,se,me);break;case">=":pe=Te(J,se,me);break;case"<":pe=de(J,se,me);break;case"<=":pe=Ne(J,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return pe}function ke(J,re){if(J instanceof ke){if(J.loose===re)return J;J=J.value}if(!(this instanceof ke))return new ke(J,re);R("comparator",J,re),this.loose=re,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(J,re){return te(re,J)},e.major=function(J,re){return new Q(J,re).major},e.minor=function(J,re){return new Q(J,re).minor},e.patch=function(J,re){return new Q(J,re).patch},e.compare=oe,e.compareLoose=function(J,re){return oe(J,re,!0)},e.rcompare=function(J,re,se){return oe(re,J,se)},e.sort=function(J,re){return J.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(J,re){return J.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=ue,e.lt=de,e.eq=ve,e.neq=Re,e.gte=Te,e.lte=Ne,e.cmp=Oe,e.Comparator=ke;var _e={};function Ie(J,re){if(J instanceof Ie)return J.loose===re?J:new Ie(J.raw,re);if(J instanceof ke)return new Ie(J.value,re);if(!(this instanceof Ie))return new Ie(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ae(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ye(J,re,se,me,pe,Pe,be,De,Ce,V,ne,ae,ce){return((re=Ae(se)?"":Ae(me)?">="+se+".0.0":Ae(pe)?">="+se+"."+me+".0":">="+re)+" "+(De=Ae(Ce)?"":Ae(V)?"<"+(+Ce+1)+".0.0":Ae(ne)?"<"+Ce+"."+(+V+1)+".0":ae?"<="+Ce+"."+V+"."+ne+"-"+ae:"<="+De)).trim()}function Je(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(R(J[se].semver),J[se].semver!==_e&&J[se].semver.prerelease.length>0){var me=J[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function $e(J,re,se){try{re=new Ie(re,se)}catch(me){return!1}return re.test(J)}function je(J,re,se,me){var pe,Pe,be,De,Ce;switch(J=new Q(J,me),re=new Ie(re,me),se){case">":pe=ue,Pe=Ne,be=de,De=">",Ce=">=";break;case"<":pe=de,Pe=Te,be=ue,De="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,re,me))return!1;for(var V=0;V<re.set.length;++V){var ne=re.set[V],ae=null,ce=null;if(ne.forEach(function(fe){fe.semver===_e&&(fe=new ke(">=0.0.0")),ae=ae||fe,ce=ce||fe,pe(fe.semver,ae.semver,me)?ae=fe:be(fe.semver,ce.semver,me)&&(ce=fe)}),ae.operator===De||ae.operator===Ce||(!ce.operator||ce.operator===De)&&Pe(J,ce.semver)||ce.operator===Ce&&be(J,ce.semver))return!1}return!0}ke.prototype.parse=function(J){var re=this.loose?P[N]:P[j],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=_e},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(J){return R("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new Q(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(J,re){if(!(J instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(J.value,re),$e(this.value,se,re);if(J.operator==="")return se=new Ie(this.value,re),$e(J.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Pe=this.semver.version===J.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),De=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ce=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return me||pe||Pe&&be||De||Ce},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),R("range",J,re);var se=re?P[_]:P[q];J=J.replace(se,Ye),R("hyphen replace",J),J=J.replace(P[F],"$1$2$3"),R("comparator trim",J,P[F]),J=(J=(J=J.replace(P[x],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var me=re?P[N]:P[j],pe=J.split(" ").map(function(Pe){return function(be,De){return R("comp",be),be=function(Ce,V){return Ce.trim().split(/\s+/).map(function(ne){return function(ae,ce){R("caret",ae,ce);var fe=ce?P[M]:P[$];return ae.replace(fe,function(Se,ge,ye,we,Ee){var le;return R("caret",ae,Se,ge,ye,we,Ee),Ae(ge)?le="":Ae(ye)?le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ae(we)?le=ge==="0"?">="+ge+"."+ye+".0 <"+ge+"."+(+ye+1)+".0":">="+ge+"."+ye+".0 <"+(+ge+1)+".0.0":Ee?(R("replaceCaret pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),le=ge==="0"?ye==="0"?">="+ge+"."+ye+"."+we+Ee+" <"+ge+"."+ye+"."+(+we+1):">="+ge+"."+ye+"."+we+Ee+" <"+ge+"."+(+ye+1)+".0":">="+ge+"."+ye+"."+we+Ee+" <"+(+ge+1)+".0.0"):(R("no pr"),le=ge==="0"?ye==="0"?">="+ge+"."+ye+"."+we+" <"+ge+"."+ye+"."+(+we+1):">="+ge+"."+ye+"."+we+" <"+ge+"."+(+ye+1)+".0":">="+ge+"."+ye+"."+we+" <"+(+ge+1)+".0.0"),R("caret return",le),le})}(ne,V)}).join(" ")}(be,De),R("caret",be),be=function(Ce,V){return Ce.trim().split(/\s+/).map(function(ne){return function(ae,ce){var fe=ce?P[H]:P[z];return ae.replace(fe,function(Se,ge,ye,we,Ee){var le;return R("tilde",ae,Se,ge,ye,we,Ee),Ae(ge)?le="":Ae(ye)?le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ae(we)?le=">="+ge+"."+ye+".0 <"+ge+"."+(+ye+1)+".0":Ee?(R("replaceTilde pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),le=">="+ge+"."+ye+"."+we+Ee+" <"+ge+"."+(+ye+1)+".0"):le=">="+ge+"."+ye+"."+we+" <"+ge+"."+(+ye+1)+".0",R("tilde return",le),le})}(ne,V)}).join(" ")}(be,De),R("tildes",be),be=function(Ce,V){return R("replaceXRanges",Ce,V),Ce.split(/\s+/).map(function(ne){return function(ae,ce){ae=ae.trim();var fe=ce?P[g]:P[S];return ae.replace(fe,function(Se,ge,ye,we,Ee,le){R("xRange",ae,Se,ge,ye,we,Ee,le);var Le=Ae(ye),Ue=Le||Ae(we),Fe=Ue||Ae(Ee);return ge==="="&&Fe&&(ge=""),Le?Se=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Fe?(Ue&&(we=0),Fe&&(Ee=0),ge===">"?(ge=">=",Ue?(ye=+ye+1,we=0,Ee=0):Fe&&(we=+we+1,Ee=0)):ge==="<="&&(ge="<",Ue?ye=+ye+1:we=+we+1),Se=ge+ye+"."+we+"."+Ee):Ue?Se=">="+ye+".0.0 <"+(+ye+1)+".0.0":Fe&&(Se=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0"),R("xRange return",Se),Se})}(ne,V)}).join(" ")}(be,De),R("xrange",be),be=function(Ce,V){return R("replaceStars",Ce,V),Ce.trim().replace(P[G],"")}(be,De),R("stars",be),be}(Pe,re)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Pe){return!!Pe.match(me)})),pe=pe.map(function(Pe){return new ke(Pe,re)})},Ie.prototype.intersects=function(J,re){if(!(J instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return J.set.some(function(pe){return pe.every(function(Pe){return me.intersects(Pe,re)})})})})},e.toComparators=function(J,re){return new Ie(J,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,re,se){var me=null,pe=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(me&&pe.compare(be)!==-1||(pe=new Q(me=be,se)))}),me},e.minSatisfying=function(J,re,se){var me=null,pe=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(me&&pe.compare(be)!==1||(pe=new Q(me=be,se)))}),me},e.validRange=function(J,re){try{return new Ie(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return je(J,re,"<",se)},e.gtr=function(J,re,se){return je(J,re,">",se)},e.outside=je,e.prerelease=function(J,re){var se=X(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new Ie(J,se),re=new Ie(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var re=J.match(P[k]);return re==null?null:X((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,D(1))},function(K,e){var D,L,R=K.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(I){if(D===setTimeout)return setTimeout(I,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(I,0);try{return D(I,0)}catch(E){try{return D.call(null,I,0)}catch(C){return D.call(this,I,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch(I){D=T}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(I){L=A}})();var y,b=[],n=!1,w=-1;function f(){n&&y&&(n=!1,y.length?b=y.concat(b):w=-1,b.length&&d())}function d(){if(!n){var I=P(f);n=!0;for(var E=b.length;E;){for(y=b,b=[];++w<E;)y&&y[w].run();w=-1,E=b.length}y=null,n=!1,function(C){if(L===clearTimeout)return clearTimeout(C);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(C);try{L(C)}catch(v){try{return L.call(null,C)}catch(a){return L.call(this,C)}}}(I)}}function l(I,E){this.fun=I,this.array=E}function m(){}R.nextTick=function(I){var E=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)E[C-1]=arguments[C];b.push(new l(I,E)),b.length!==1||n||P(d)},l.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=m,R.addListener=m,R.once=m,R.off=m,R.removeListener=m,R.removeAllListeners=m,R.emit=m,R.prependListener=m,R.prependOnceListener=m,R.listeners=function(I){return[]},R.binding=function(I){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(I){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Z[92],ee([0,1,4]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new R(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[3],ee([0,1,11,65,2,91,92]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(v){v.None=()=>R.Disposable.None;function a(B){return(U,$=null,M)=>{let N=!1,j;return j=B(F=>{if(!N)return j?j.dispose():N=!0,U.call($,F)},null,M),N&&j.dispose(),j}}v.once=a;function o(B,U){return c(($,M=null,N)=>B(j=>$.call(M,U(j)),null,N))}v.map=o;function t(B,U){return c(($,M=null,N)=>B(j=>{U(j),$.call(M,j)},null,N))}v.forEach=t;function r(B,U){return c(($,M=null,N)=>B(j=>U(j)&&$.call(M,j),null,N))}v.filter=r;function i(B){return B}v.signal=i;function s(...B){return(U,$=null,M)=>(0,R.combinedDisposable)(...B.map(N=>N(j=>U.call($,j),null,M)))}v.any=s;function u(B,U,$){let M=$;return o(B,N=>(M=U(M,N),M))}v.reduce=u;function c(B){let U;const $=new f({onFirstListenerAdd(){U=B($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}function h(B,U,$=100,M=!1,N){let j,F,q,_=0;const G=new f({leakWarningThreshold:N,onFirstListenerAdd(){j=B(W=>{_++,F=U(F,W),M&&!q&&(G.fire(F),F=void 0),clearTimeout(q),q=setTimeout(()=>{const X=F;F=void 0,q=void 0,(!M||_>1)&&G.fire(X),_=0},$)})},onLastListenerRemove(){j.dispose()}});return G.event}v.debounce=h;function p(B,U=($,M)=>$===M){let $=!0,M;return r(B,N=>{const j=$||!U(N,M);return $=!1,M=N,j})}v.latch=p;function S(B,U){return[v.filter(B,U),v.filter(B,$=>!U($))]}v.split=S;function g(B,U=!1,$=[]){let M=$.slice(),N=B(q=>{M?M.push(q):F.fire(q)});const j=()=>{M&&M.forEach(q=>F.fire(q)),M=null},F=new f({onFirstListenerAdd(){N||(N=B(q=>F.fire(q)))},onFirstListenerDidAdd(){M&&(U?setTimeout(j):j())},onLastListenerRemove(){N&&N.dispose(),N=null}});return F.event}v.buffer=g;class k{constructor(U){this.event=U}map(U){return new k(o(this.event,U))}forEach(U){return new k(t(this.event,U))}filter(U){return new k(r(this.event,U))}reduce(U,$){return new k(u(this.event,U,$))}latch(){return new k(p(this.event))}debounce(U,$=100,M=!1,N){return new k(h(this.event,U,$,M,N))}on(U,$,M){return this.event(U,$,M)}once(U,$,M){return a(this.event)(U,$,M)}}function O(B){return new k(B)}v.chain=O;function x(B,U,$=M=>M){const M=(...q)=>F.fire($(...q)),N=()=>B.on(U,M),j=()=>B.removeListener(U,M),F=new f({onFirstListenerAdd:N,onLastListenerRemove:j});return F.event}v.fromNodeEventEmitter=x;function z(B,U,$=M=>M){const M=(...q)=>F.fire($(...q)),N=()=>B.addEventListener(U,M),j=()=>B.removeEventListener(U,M),F=new f({onFirstListenerAdd:N,onLastListenerRemove:j});return F.event}v.fromDOMEventEmitter=z;function H(B){return new Promise(U=>a(B)(U))}v.toPromise=H})(P=e.Event||(e.Event={}));class y{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${y._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let b=-1;function n(v){const a=b;return b=v,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=n;class w{constructor(a,o=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let o=b;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||a<o)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,s=0;for(const[u,c]of this._stacks)(!i||s<c)&&(i=u,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class f{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(a,o,t)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[a,o]:a);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,o);const s=this._leakageMon?.check(this._listeners.size),u=(0,R.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof R.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(r){(0,D.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class d extends f{async fireAsync(a,o,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,a]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],u={...i,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof r=="function"?r:r[0])),s.push(c)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(c){(0,D.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const h of c)h.status==="rejected"&&(0,D.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=d;class l extends f{constructor(a){super(a);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=l;class m extends l{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=m;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const o={event:a,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const t=()=>{this.hasListeners&&this.unhook(o);const r=this.events.indexOf(o);this.events.splice(r,1)};return(0,R.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(o=>this.emitter.fire(o))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class E{constructor(){this.buffers=[]}wrapEvent(a){return(o,t,r)=>a(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>o.call(t,i)):o.call(t,i)},void 0,r)}bufferEvents(a){const o=[];this.buffers.push(o);const t=a();return this.buffers.pop(),o.forEach(r=>r()),t}}e.EventBufferer=E;class C{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(Z[29],ee([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,y){const b=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(b)}}});var R;(function(P){function y(b){return b===P.None||b===P.Cancelled||b instanceof T?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=A}),define(Z[48],ee([0,1,3]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(w){const f=this._icons.get(w.id);f?w.description?f.description=w.description:console.error(`Duplicate registration of codicon ${w.id}`):(this._icons.set(w.id,w),this._onDidRegister.fire(w))}get(w){return this._icons.get(w)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function T(n,w){return new P(n,w)}e.registerCodicon=T;function A(n){return n?n.replace(/\$\((.*?)\)/g,(w,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(w,f,d){this.id=w,this.definition=f,this.description=d,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function y(n,w){const f=["codicon","codicon-"+n];return w&&f.push("codicon-modifier-"+w),f}e.getClassNamesArray=y;var b;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const w=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function f(m){if(m instanceof P)return["codicon","codicon-"+m.id];const I=w.exec(m.id);if(!I)return f(P.error);let[,E,C]=I;const v=["codicon","codicon-"+E];return C&&v.push("codicon-modifier-"+C.substr(1)),v}n.asClassNameArray=f;function d(m){return f(m).join(" ")}n.asClassName=d;function l(m){return"."+f(m).join(".")}n.asCSSSelector=l})(b=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[49],ee([0,1,11,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(v){const a=v;return a?[a.on,a.pause,a.resume,a.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=R;function T(v){const a=v;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(v,a){return new P(v,a)}e.newWriteableStream=A;class P{constructor(a,o){this.reducer=a,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(o=>o(a))}emitError(a){this.listeners.error.length===0?(0,D.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(o=>o(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,o){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(a,o){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(o);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(v,a){const o=[];let t;for(;(t=v.read())!==null;)o.push(t);return a(o)}e.consumeReadable=y;function b(v,a,o){const t=[];let r;for(;(r=v.read())!==null&&t.length<o;)t.push(r);return r===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return v.read()}}}e.peekReadable=b;function n(v,a){return new Promise((o,t)=>{const r=[];w(v,{onData:i=>{a&&r.push(i)},onError:i=>{a?t(i):o(void 0)},onEnd:()=>{o(a?a(r):void 0)}})})}e.consumeStream=n;function w(v,a){v.on("error",o=>a.onError(o)),v.on("end",()=>a.onEnd()),v.on("data",o=>a.onData(o))}e.listenStream=w;function f(v,a){return new Promise((o,t)=>{const r=new L.DisposableStore,i=[],s=h=>{if(i.push(h),i.length>a)return r.dispose(),v.pause(),o({stream:v,buffer:i,ended:!1})},u=h=>t(h),c=()=>o({stream:v,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>v.removeListener("error",u))),v.on("error",u),r.add((0,L.toDisposable)(()=>v.removeListener("end",c))),v.on("end",c),r.add((0,L.toDisposable)(()=>v.removeListener("data",s))),v.on("data",s)})}e.peekStream=f;function d(v,a){const o=A(a);return o.end(v),o}e.toStream=d;function l(){const v=A(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=l;function m(v){let a=!1;return{read:()=>a?null:(a=!0,v)}}e.toReadable=m;function I(v,a,o){const t=A(o);return w(v,{onData:r=>t.write(a.data(r)),onError:r=>t.error(a.error?a.error(r):r),onEnd:()=>t.end()}),t}e.transform=I;function E(v,a,o){let t=!1;return{read:()=>{const r=a.read();return t?r:(t=!0,r!==null?o([v,r]):v)}}}e.prefixedReadable=E;function C(v,a,o){let t=!1;const r=A(o);return w(a,{onData:i=>t?r.write(i):(t=!0,r.write(o([v,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(v)),r.end()}}),r}e.prefixedStream=C}),define(Z[25],ee([0,1,49]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,T;class A{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new A(Buffer.allocUnsafe(s)):new A(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new A(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(s)):(R||(R=new TextEncoder),new A(R.encode(s)))}static concat(s,u){if(typeof u=="undefined"){u=0;for(let p=0,S=s.length;p<S;p++)u+=s[p].byteLength}const c=A.alloc(u);let h=0;for(let p=0,S=s.length;p<S;p++){const g=s[p];c.set(g,h),h+=g.byteLength}return c}toString(){return L?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(s,u){return new A(this.buffer.subarray(s,u))}set(s,u){s instanceof A?this.buffer.set(s.buffer,u):this.buffer.set(s,u)}readUInt32BE(s){return b(this.buffer,s)}writeUInt32BE(s,u){n(this.buffer,s,u)}readUInt32LE(s){return w(this.buffer,s)}writeUInt32LE(s,u){f(this.buffer,s,u)}readUInt8(s){return d(this.buffer,s)}writeUInt8(s,u){l(this.buffer,s,u)}}e.VSBuffer=A;function P(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0}e.readUInt16LE=P;function y(i,s,u){i[u+0]=s&255,s=s>>>8,i[u+1]=s&255}e.writeUInt16LE=y;function b(i,s){return i[s]*2**24+i[s+1]*2**16+i[s+2]*2**8+i[s+3]}e.readUInt32BE=b;function n(i,s,u){i[u+3]=s,s=s>>>8,i[u+2]=s,s=s>>>8,i[u+1]=s,s=s>>>8,i[u]=s}e.writeUInt32BE=n;function w(i,s){return i[s+0]<<0>>>0|i[s+1]<<8>>>0|i[s+2]<<16>>>0|i[s+3]<<24>>>0}e.readUInt32LE=w;function f(i,s,u){i[u+0]=s&255,s=s>>>8,i[u+1]=s&255,s=s>>>8,i[u+2]=s&255,s=s>>>8,i[u+3]=s&255}e.writeUInt32LE=f;function d(i,s){return i[s]}e.readUInt8=d;function l(i,s,u){i[u]=s}e.writeUInt8=l;function m(i){return D.consumeReadable(i,s=>A.concat(s))}e.readableToBuffer=m;function I(i){return D.toReadable(i)}e.bufferToReadable=I;function E(i){return D.consumeStream(i,s=>A.concat(s))}e.streamToBuffer=E;async function C(i){return i.ended?A.concat(i.buffer):A.concat([...i.buffer,await E(i.stream)])}e.bufferedStreamToBuffer=C;function v(i){return D.toStream(i,s=>A.concat(s))}e.bufferToStream=v;function a(i){return D.transform(i,{data:s=>typeof s=="string"?A.fromString(s):A.wrap(s)},s=>A.concat(s))}e.streamToBufferReadableStream=a;function o(i){return D.newWriteableStream(s=>A.concat(s),i)}e.newWriteableBufferStream=o;function t(i,s){return D.prefixedReadable(i,s,u=>A.concat(u))}e.prefixedBufferReadable=t;function r(i,s){return D.prefixedStream(i,s,u=>A.concat(u))}e.prefixedBufferStream=r}),define(Z[23],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(V){return!V||typeof V!="string"?!0:V.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(V,...ne){return ne.length===0?V:V.replace(L,function(ae,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ne.length?ae:ne[fe]})}e.format=R;const T=/{([^}]+)}/g;function A(V,ne){return V.replace(T,(ae,ce)=>ne[ce]??ae)}e.format2=A;function P(V){return V.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=P;function y(V){return V.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function b(V,ne){let ae=0;const ce=ne.charCodeAt(0);for(let fe=V.length-1;fe>=0;fe--)V.charCodeAt(fe)===ce&&ae++;return ae}e.count=b;function n(V,ne,ae="\u2026"){return V.length<=ne?V:`${V.substr(0,ne)}${ae}`}e.truncate=n;function w(V,ne=" "){const ae=f(V,ne);return d(ae,ne)}e.trim=w;function f(V,ne){if(!V||!ne)return V;const ae=ne.length;if(ae===0||V.length===0)return V;let ce=0;for(;V.indexOf(ne,ce)===ce;)ce=ce+ae;return V.substring(ce)}e.ltrim=f;function d(V,ne){if(!V||!ne)return V;const ae=ne.length,ce=V.length;if(ae===0||ce===0)return V;let fe=ce,Se=-1;for(;Se=V.lastIndexOf(ne,fe-1),!(Se===-1||Se+ae!==fe);){if(Se===0)return"";fe=Se}return V.substring(0,fe)}e.rtrim=d;function l(V){return V.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function m(V){return V.replace(/\*/g,"")}e.stripWildcards=m;function I(V,ne,ae={}){if(!V)throw new Error("Cannot create regex from empty string");ne||(V=y(V)),ae.wholeWord&&(/\B/.test(V.charAt(0))||(V="\\b"+V),/\B/.test(V.charAt(V.length-1))||(V=V+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(V,ce)}e.createRegExp=I;function E(V){return V.source==="^"||V.source==="^$"||V.source==="$"||V.source==="^\\s*$"?!1:!!(V.exec("")&&V.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function C(V){return!!V.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function v(V){return(V.global?"g":"")+(V.ignoreCase?"i":"")+(V.multiline?"m":"")+(V.unicode?"u":"")}e.regExpFlags=v;function a(V){return V.split(/\r\n|\r|\n/)}e.splitLines=a;function o(V){for(let ne=0,ae=V.length;ne<ae;ne++){const ce=V.charCodeAt(ne);if(ce!==32&&ce!==9)return ne}return-1}e.firstNonWhitespaceIndex=o;function t(V,ne=0,ae=V.length){for(let ce=ne;ce<ae;ce++){const fe=V.charCodeAt(ce);if(fe!==32&&fe!==9)return V.substring(ne,ce)}return V.substring(ne,ae)}e.getLeadingWhitespace=t;function r(V,ne=V.length-1){for(let ae=ne;ae>=0;ae--){const ce=V.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(V,ne){return V<ne?-1:V>ne?1:0}e.compare=i;function s(V,ne,ae=0,ce=V.length,fe=0,Se=ne.length){for(;ae<ce&&fe<Se;ae++,fe++){let we=V.charCodeAt(ae),Ee=ne.charCodeAt(fe);if(we<Ee)return-1;if(we>Ee)return 1}const ge=ce-ae,ye=Se-fe;return ge<ye?-1:ge>ye?1:0}e.compareSubstring=s;function u(V,ne){return c(V,ne,0,V.length,0,ne.length)}e.compareIgnoreCase=u;function c(V,ne,ae=0,ce=V.length,fe=0,Se=ne.length){for(;ae<ce&&fe<Se;ae++,fe++){let we=V.charCodeAt(ae),Ee=ne.charCodeAt(fe);if(we===Ee)continue;const le=we-Ee;if(!(le===32&&p(Ee))&&!(le===-32&&p(we)))return h(we)&&h(Ee)?le:s(V.toLowerCase(),ne.toLowerCase(),ae,ce,fe,Se)}const ge=ce-ae,ye=Se-fe;return ge<ye?-1:ge>ye?1:0}e.compareSubstringIgnoreCase=c;function h(V){return V>=97&&V<=122}e.isLowerAsciiLetter=h;function p(V){return V>=65&&V<=90}e.isUpperAsciiLetter=p;function S(V){return h(V)||p(V)}function g(V,ne){return V.length===ne.length&&k(V,ne)}e.equalsIgnoreCase=g;function k(V,ne,ae=V.length){for(let ce=0;ce<ae;ce++){const fe=V.charCodeAt(ce),Se=ne.charCodeAt(ce);if(fe!==Se){if(S(fe)&&S(Se)){const ge=Math.abs(fe-Se);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function O(V,ne){const ae=ne.length;return ne.length>V.length?!1:k(V,ne,ae)}e.startsWithIgnoreCase=O;function x(V,ne){let ae,ce=Math.min(V.length,ne.length);for(ae=0;ae<ce;ae++)if(V.charCodeAt(ae)!==ne.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=x;function z(V,ne){let ae,ce=Math.min(V.length,ne.length);const fe=V.length-1,Se=ne.length-1;for(ae=0;ae<ce;ae++)if(V.charCodeAt(fe-ae)!==ne.charCodeAt(Se-ae))return ae;return ce}e.commonSuffixLength=z;function H(V){return 55296<=V&&V<=56319}e.isHighSurrogate=H;function B(V){return 56320<=V&&V<=57343}e.isLowSurrogate=B;function U(V,ne){return(V-55296<<10)+(ne-56320)+65536}e.computeCodePoint=U;function $(V,ne,ae){const ce=V.charCodeAt(ae);if(H(ce)&&ae+1<ne){const fe=V.charCodeAt(ae+1);if(B(fe))return U(ce,fe)}return ce}e.getNextCodePoint=$;function M(V,ne){const ae=V.charCodeAt(ne-1);if(B(ae)&&ne>1){const ce=V.charCodeAt(ne-2);if(H(ce))return U(ce,ae)}return ae}function N(V,ne){const ae=se.getInstance(),ce=ne,fe=V.length,Se=$(V,fe,ne);ne+=Se>=65536?2:1;let ge=ae.getGraphemeBreakType(Se);for(;ne<fe;){const ye=$(V,fe,ne),we=ae.getGraphemeBreakType(ye);if(J(ge,we))break;ne+=ye>=65536?2:1,ge=we}return ne-ce}e.nextCharLength=N;function j(V,ne){const ae=se.getInstance(),ce=ne,fe=M(V,ne);ne-=fe>=65536?2:1;let Se=ae.getGraphemeBreakType(fe);for(;ne>0;){const ge=M(V,ne),ye=ae.getGraphemeBreakType(ge);if(J(ye,Se))break;ne-=ge>=65536?2:1,Se=ye}return ce-ne}e.prevCharLength=j;function F(V,ne){const ae=se.getInstance(),ce=V.length,fe=ne,Se=$(V,ce,ne),ge=ae.getGraphemeBreakType(Se);ne+=Se>=65536?2:1;let ye=ge;for(;ne<ce;){const Ee=$(V,ce,ne),le=ae.getGraphemeBreakType(Ee);if(J(ye,le))break;ne+=Ee>=65536?2:1,ye=le}const we=ne;for(ne=fe,ye=ge;ne>0;){const Ee=M(V,ne),le=ae.getGraphemeBreakType(Ee);if(J(le,ye))break;ne-=Ee>=65536?2:1,ye=le}return[ne,we]}function q(V,ne){return ne>0&&B(V.charCodeAt(ne))?F(V,ne-1):F(V,ne)}e.getCharContainingOffset=q;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(V){return _.test(V)}e.containsRTL=G;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(V){return W.test(V)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function ie(V){return Q.test(V)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function te(V){return e.UNUSUAL_LINE_TERMINATORS.test(V)}e.containsUnusualLineTerminators=te;function oe(V){for(let ne=0,ae=V.length;ne<ae;ne++)if(ue(V.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=oe;function ue(V){return V=+V,V>=11904&&V<=55215||V>=63744&&V<=64255||V>=65281&&V<=65374}e.isFullWidthCharacter=ue;function de(V){return V>=127462&&V<=127487||V===8986||V===8987||V===9200||V===9203||V>=9728&&V<=10175||V===11088||V===11093||V>=127744&&V<=128591||V>=128640&&V<=128764||V>=128992&&V<=129003||V>=129280&&V<=129535||V>=129648&&V<=129750}e.isEmojiImprecise=de;function ve(V,ne){if(V.length<ne)return V;const ae=/\b/g;let ce=0;for(;ae.test(V)&&!(V.length-ae.lastIndex<ne);)ce=ae.lastIndex,ae.lastIndex+=1;return V.substring(ce).replace(/^\s/,"")}e.lcut=ve;const Re=/\x1B\x5B[12]?K/g,Te=/\x1b\[\d+m/g,Ne=/\x1b\[0?m/g;function Oe(V){return V&&(V=V.replace(Re,""),V=V.replace(Te,""),V=V.replace(Ne,"")),V}e.removeAnsiEscapeCodes=Oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(V){return!!(V&&V.length>0&&V.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function _e(V){return ke(V)?V.substr(1):V}e.stripUTF8BOM=_e;function Ie(V,ne){if(!V||!ne||V.length<ne.length)return!1;const ae=ne.length,ce=V.toLowerCase();let fe=0,Se=-1;for(;fe<ae;){const ge=ce.indexOf(ne[fe],Se+1);if(ge<0)return!1;Se=ge,fe++}return!0}e.fuzzyContains=Ie;function Ae(V,ne=!1){return V?(ne&&(V=V.replace(/\\./g,"")),V.toLowerCase()!==V):!1}e.containsUppercaseCharacter=Ae;function Ye(V){return V.charAt(0).toUpperCase()+V.slice(1)}e.uppercaseFirstLetter=Ye;function Je(V,ne=1){if(ne===0)return"";let ae=-1;do ae=V.indexOf(`
`,ae+1),ne--;while(ne>0&&ae>=0);return ae===-1?V:(V[ae-1]==="\r"&&ae--,V.substr(0,ae))}e.getNLines=Je;function $e(V){const ne=90-65+1;return V=V%(2*ne),V<ne?String.fromCharCode(97+V):String.fromCharCode(65+V-ne)}e.singleLetterHash=$e;function je(V){return se.getInstance().getGraphemeBreakType(V)}e.getGraphemeBreakType=je;function J(V,ne){return V===0?ne!==5&&ne!==7:V===2&&ne===3?!1:V===4||V===2||V===3||ne===4||ne===2||ne===3?!0:!(V===8&&(ne===8||ne===9||ne===11||ne===12)||(V===11||V===9)&&(ne===9||ne===10)||(V===12||V===10)&&ne===10||ne===5||ne===13||ne===7||V===1||V===13&&ne===14||V===6&&ne===6)}e.breakBetweenGraphemeBreakType=J;var re;(function(V){V[V.Other=0]="Other",V[V.Prepend=1]="Prepend",V[V.CR=2]="CR",V[V.LF=3]="LF",V[V.Control=4]="Control",V[V.Extend=5]="Extend",V[V.Regional_Indicator=6]="Regional_Indicator",V[V.SpacingMark=7]="SpacingMark",V[V.L=8]="L",V[V.V=9]="V",V[V.T=10]="T",V[V.LV=11]="LV",V[V.LVT=12]="LVT",V[V.ZWJ=13]="ZWJ",V[V.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ae=this._data,ce=ae.length/3;let fe=1;for(;fe<=ce;)if(ne<ae[3*fe])fe=2*fe;else if(ne>ae[3*fe+1])fe=2*fe+1;else return ae[3*fe+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function pe(V,ne){if(V===0)return 0;const ae=Pe(V,ne);if(ae!==void 0)return ae;const ce=M(ne,V);return V-=be(ce),V}e.getLeftDeleteOffset=pe;function Pe(V,ne){let ae=M(ne,V);for(V-=be(ae);De(ae)||ae===65039||ae===8419;){if(V===0)return;ae=M(ne,V),V-=be(ae)}if(!!de(ae)){if(V>=0){const ce=M(ne,V);ce===8205&&(V-=be(ce))}return V}}function be(V){return V>=65536?2:1}function De(V){return 127995<=V&&V<=127999}var Ce;(function(V){V[V.zwj=8205]="zwj",V[V.emojiVariantSelector=65039]="emojiVariantSelector",V[V.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={}))}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(h){return Array.isArray(h)}e.isArray=D;function L(h){return typeof h=="string"}e.isString=L;function R(h){return Array.isArray(h)&&h.every(p=>L(p))}e.isStringArray=R;function T(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=T;function A(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=A;function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=P;function y(h){return h===!0||h===!1}e.isBoolean=y;function b(h){return typeof h=="undefined"}e.isUndefined=b;function n(h){return!w(h)}e.isDefined=n;function w(h){return b(h)||h===null}e.isUndefinedOrNull=w;function f(h,p){if(!h)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=f;function d(h){if(w(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=d;function l(...h){const p=[];for(let S=0;S<h.length;S++){const g=h[S];if(w(g))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);p.push(g)}return p}e.assertAllDefined=l;const m=Object.prototype.hasOwnProperty;function I(h){if(!T(h))return!1;for(let p in h)if(m.call(h,p))return!1;return!0}e.isEmptyObject=I;function E(h){return typeof h=="function"}e.isFunction=E;function C(...h){return h.length>0&&h.every(E)}e.areFunctions=C;function v(h,p){const S=Math.min(h.length,p.length);for(let g=0;g<S;g++)a(h[g],p[g])}e.validateConstraints=v;function a(h,p){if(L(p)){if(typeof h!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(E(p)){try{if(h instanceof p)return}catch{}if(!w(h)&&h.constructor===p||p.length===1&&p.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function o(h){let p=[],S=Object.getPrototypeOf(h);for(;Object.prototype!==S;)p=p.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return p}e.getAllPropertyNames=o;function t(h){const p=[];for(const S of o(h))typeof h[S]=="function"&&p.push(S);return p}e.getAllMethodNames=t;function r(h,p){const S=k=>function(){const O=Array.prototype.slice.call(arguments,0);return p(k,O)};let g={};for(const k of h)g[k]=S(k);return g}e.createProxyObject=r;function i(h){return h===null?void 0:h}e.withNullAsUndefined=i;function s(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=s;function u(h){return class{constructor(){return new Proxy({},{get(p,S){if(p[S])return p[S];throw new Error(`Not Implemented: ${h}->${String(S)}`)}})}}}e.NotImplementedProxy=u;function c(h,p="Unreachable"){throw new Error(p)}e.assertNever=c}),define(Z[39],ee([0,1,8,4,23,16]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function P(i){return i.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function y(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=y;function b(i,s=D.posix.sep){if(!i)return"";const u=i.length,c=i.charCodeAt(0);if(A(c)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let p=3;const S=p;for(;p<u&&!A(i.charCodeAt(p));p++);if(S!==p&&!A(i.charCodeAt(p+1))){for(p+=1;p<u;p++)if(A(i.charCodeAt(p)))return i.slice(0,p+1).replace(/[\\/]/g,s)}}return s}else if(E(c)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let h=i.indexOf("://");if(h!==-1){for(h+=3;h<u;h++)if(A(i.charCodeAt(h)))return i.slice(0,h+1)}return""}e.getRoot=b;function n(i){if(!L.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let u=2;const c=u;for(;u<i.length&&(s=i.charCodeAt(u),s!==92);u++);return!(c===u||(s=i.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=n;const w=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(i,s=L.isWindows){const u=s?w:f;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||s&&d.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=l;function m(i,s,u){const c=i===s;return!u||c?c:!i||!s?!1:(0,R.equalsIgnoreCase)(i,s)}e.isEqual=m;function I(i,s,u,c=D.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let p=s.length;return s.charAt(s.length-1)===c&&p--,i.charAt(p)===c}return s.charAt(s.length-1)!==c&&(s+=c),i.indexOf(s)===0}e.isEqualOrParent=I;function E(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=E;function C(i,s){return L.isWindows&&i.endsWith(":")&&(i+=D.sep),(0,D.isAbsolute)(i)||(i=(0,D.join)(s,i)),i=(0,D.normalize)(i),L.isWindows?(i=(0,R.rtrim)(i,D.sep),i.endsWith(":")&&(i+=D.sep)):(i=(0,R.rtrim)(i,D.sep),i||(i=D.sep)),i}e.sanitizeFilePath=C;function v(i){const s=(0,D.normalize)(i);return L.isWindows?i.length>3?!1:a(s)&&(i.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=v;function a(i){return L.isWindows?E(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function o(i){return a(i)?i[0]:void 0}e.getDriveLetter=o;function t(i,s,u){return s.length>i.length?-1:i===s?0:(u&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=t;function r(i){const s=i.split(":");let u,c,h;if(s.forEach(p=>{const S=Number(p);(0,T.isNumber)(S)?c===void 0?c=S:h===void 0&&(h=S):u=u?[u,p].join(":"):p}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:c!==void 0?c:void 0,column:h!==void 0?h:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const I=Array.isArray(m)?[]:{};return Object.keys(m).forEach(E=>{m[E]&&typeof m[E]=="object"?I[E]=L(m[E]):I[E]=m[E]}),I}e.deepClone=L;function R(m){if(!m||typeof m!="object")return m;const I=[m];for(;I.length>0;){const E=I.shift();Object.freeze(E);for(const C in E)if(T.call(E,C)){const v=E[C];typeof v=="object"&&!Object.isFrozen(v)&&I.push(v)}}return m}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function A(m,I){return P(m,I,new Set)}e.cloneAndChange=A;function P(m,I,E){if((0,D.isUndefinedOrNull)(m))return m;const C=I(m);if(typeof C!="undefined")return C;if((0,D.isArray)(m)){const v=[];for(const a of m)v.push(P(a,I,E));return v}if((0,D.isObject)(m)){if(E.has(m))throw new Error("Cannot clone recursive data-structure");E.add(m);const v={};for(let a in m)T.call(m,a)&&(v[a]=P(m[a],I,E));return E.delete(m),v}return m}function y(m,I,E=!0){return(0,D.isObject)(m)?((0,D.isObject)(I)&&Object.keys(I).forEach(C=>{C in m?E&&((0,D.isObject)(m[C])&&(0,D.isObject)(I[C])?y(m[C],I[C],E):m[C]=I[C]):m[C]=I[C]}),m):I}e.mixin=y;function b(m,I){if(m===I)return!0;if(m==null||I===null||I===void 0||typeof m!=typeof I||typeof m!="object"||Array.isArray(m)!==Array.isArray(I))return!1;let E,C;if(Array.isArray(m)){if(m.length!==I.length)return!1;for(E=0;E<m.length;E++)if(!b(m[E],I[E]))return!1}else{const v=[];for(C in m)v.push(C);v.sort();const a=[];for(C in I)a.push(C);if(a.sort(),!b(v,a))return!1;for(E=0;E<v.length;E++)if(!b(m[v[E]],I[v[E]]))return!1}return!0}e.equals=b;function n(m){const I=new Set;return JSON.stringify(m,(E,C)=>{if((0,D.isObject)(C)||Array.isArray(C)){if(I.has(C))return"[Circular]";I.add(C)}return C})}e.safeStringify=n;function w(m,I,E){const C=I(m);return typeof C=="undefined"?E:C}e.getOrDefault=w;function f(m,I){const E=Object.create(null);return!m||!I||Object.keys(I).forEach(v=>{const a=m[v],o=I[v];b(a,o)||(E[v]=o)}),E}e.distinct=f;function d(m,I){const E=I.toLowerCase(),C=Object.keys(m).find(v=>v.toLowerCase()===E);return C?m[C]:m[I]}e.getCaseInsensitive=d;function l(m,I){const E=Object.create(null);for(const C of Object.keys(m))I(C,m[C])&&(E[C]=m[C]);return E}e.filter=l}),define(Z[5],ee([0,1,8,4]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function P(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!R.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(i,s){return!i&&!s?"file":i}function b(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==w&&(s=w+s):s=w;break}return s}const n="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(s,u,c,h,p,S=!1){typeof s=="object"?(this.scheme=s.scheme||n,this.authority=s.authority||n,this.path=s.path||n,this.query=s.query||n,this.fragment=s.fragment||n):(this.scheme=y(s,S),this.authority=u||n,this.path=b(this.scheme,c||n),this.query=h||n,this.fragment=p||n,P(this,S))}static isUri(s){return s instanceof d?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return v(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:c,path:h,query:p,fragment:S}=s;return u===void 0?u=this.scheme:u===null&&(u=n),c===void 0?c=this.authority:c===null&&(c=n),h===void 0?h=this.path:h===null&&(h=n),p===void 0?p=this.query:p===null&&(p=n),S===void 0?S=this.fragment:S===null&&(S=n),u===this.scheme&&c===this.authority&&h===this.path&&p===this.query&&S===this.fragment?this:new m(u,c,h,p,S)}static parse(s,u=!1){const c=f.exec(s);return c?new m(c[2]||n,r(c[4]||n),r(c[5]||n),r(c[7]||n),r(c[9]||n),u):new m(n,n,n,n,n)}static file(s){let u=n;if(L.isWindows&&(s=s.replace(/\\/g,w)),s[0]===w&&s[1]===w){const c=s.indexOf(w,2);c===-1?(u=s.substring(2),s=w):(u=s.substring(2,c),s=s.substring(c)||w)}return new m("file",u,s,n,n)}static from(s){const u=new m(s.scheme,s.authority,s.path,s.query,s.fragment);return P(u,!0),u}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&s.scheme==="file"?c=d.file(D.win32.join(v(s,!0),...u)).path:c=D.posix.join(s.path,...u),s.with({path:c})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof d)return s;{const u=new m(s);return u._formatted=s.external,u._fsPath=s._sep===l?s.fsPath:null,u}}else return s}}e.URI=d;const l=L.isWindows?1:void 0;class m extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=l),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(i,s){let u,c=-1;for(let h=0;h<i.length;h++){const p=i.charCodeAt(h);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||s&&p===47)c!==-1&&(u+=encodeURIComponent(i.substring(c,h)),c=-1),u!==void 0&&(u+=i.charAt(h));else{u===void 0&&(u=i.substr(0,h));const S=I[p];S!==void 0?(c!==-1&&(u+=encodeURIComponent(i.substring(c,h)),c=-1),u+=S):c===-1&&(c=h)}}return c!==-1&&(u+=encodeURIComponent(i.substring(c))),u!==void 0?u:i}function C(i){let s;for(let u=0;u<i.length;u++){const c=i.charCodeAt(u);c===35||c===63?(s===void 0&&(s=i.substr(0,u)),s+=I[c]):s!==void 0&&(s+=i[u])}return s!==void 0?s:i}function v(i,s){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,L.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=v;function a(i,s){const u=s?C:E;let c="",{scheme:h,authority:p,path:S,query:g,fragment:k}=i;if(h&&(c+=h,c+=":"),(p||h==="file")&&(c+=w,c+=w),p){let O=p.indexOf("@");if(O!==-1){const x=p.substr(0,O);p=p.substr(O+1),O=x.indexOf(":"),O===-1?c+=u(x,!1):(c+=u(x.substr(0,O),!1),c+=":",c+=u(x.substr(O+1),!1)),c+="@"}p=p.toLowerCase(),O=p.indexOf(":"),O===-1?c+=u(p,!1):(c+=u(p.substr(0,O),!1),c+=p.substr(O))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const O=S.charCodeAt(1);O>=65&&O<=90&&(S=`/${String.fromCharCode(O+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const O=S.charCodeAt(0);O>=65&&O<=90&&(S=`${String.fromCharCode(O+32)}:${S.substr(2)}`)}c+=u(S,!0)}return g&&(c+="?",c+=u(g,!1)),k&&(c+="#",c+=s?k:E(k,!1)),c}function o(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+o(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,s=>o(s)):i}}),define(Z[93],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(b){const n=b;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function R(b){const n=[];let w;try{const f=JSON.parse(b.arguments),d=f[f.length-1];d&&d.__$stack&&(f.pop(),w=d.__$stack),n.push(...f)}catch(f){n.push("Unable to log remote console arguments",b.arguments)}return{args:n,stack:w}}e.parse=R;function T(b){if(typeof b!="string")return T(R(b).stack);const n=b;if(n){const w=A(n),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=T;function A(b){if(!b)return b;const n=b.indexOf(`
`);return n===-1?b:b.substring(0,n)}function P(b,n){const{args:w,stack:f}=R(b),d=typeof w[0]=="string"&&w.length===1;let l=A(f);l&&(l=`(${l.trim()})`);let m=[];if(typeof w[0]=="string"?l&&d?m=[`%c[${n}] %c${w[0]} %c${l}`,y("blue"),y(""),y("grey")]:m=[`%c[${n}] %c${w[0]}`,y("blue"),y(""),...w.slice(1)]:m=[`%c[${n}]%`,y("blue"),...w],l&&!d&&m.push(l),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,m)}e.log=P;function y(b){return`color: ${b}`}});var ut=this&&this.__classPrivateFieldSet||function(K,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!R:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(K,D):R?R.value=D:e.set(K,D),D},ze=this&&this.__classPrivateFieldGet||function(K,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(K):L?L.value:e.get(K)};define(Z[40],ee([0,1,23,5]),function(K,e,D,L){"use strict";var R,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,i){let s=t.get(r);return s===void 0&&(s=i,t.set(r,s)),s}e.getOrSet=P;function y(t){const r=[];return t.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=y;function b(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=b;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=n;class w{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,D.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class f{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,D.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,D.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new l(r))}static forPaths(){return new I(new f)}static forStrings(){return new I(new n)}static forConfigKeys(){return new I(new w)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let u;for(this._root||(this._root=new m,this._root.segment=s.value()),u=this._root;;){const h=s.cmp(u.segment);if(h>0)u.left||(u.left=new m,u.left.segment=s.value()),u=u.left;else if(h<0)u.right||(u.right=new m,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new m,u.mid.segment=s.value()),u=u.mid;else break}const c=u.value;return u.value=i,u.key=r,c}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const u=i.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),u=[];let c=this._root;for(;c;){const h=s.cmp(c.segment);if(h>0)u.push([1,c]),c=c.left;else if(h<0)u.push([-1,c]),c=c.right;else if(s.hasNext())s.next(),u.push([0,c]),c=c.mid;else{for(i?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;u.length>0&&c.isEmpty();){let[p,S]=u.pop();switch(p){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}c=S}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,u;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const u=i.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=I;class E{constructor(r,i){this[R]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=i??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,u]of this.map)r(u,L.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var C;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class v{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let u=this._map.get(r);if(u)u.value=i,s!==0&&this.touch(u,s);else{switch(u={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:s.key,done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:s.value,done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const c={value:[s.key,s.value],done:!1};return s=s.next,c}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,u=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=v;class a extends v{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class o{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return ze(this,A,"f").size}forEach(r,i){ze(this,A,"f").forEach(r,i)}get(r){return ze(this,A,"f").get(r)}has(r){return ze(this,A,"f").has(r)}entries(){return ze(this,A,"f").entries()}keys(){return ze(this,A,"f").keys()}values(){return ze(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return ze(this,A,"f").entries()}}e.ReadonlyMapView=o}),define(Z[94],ee([0,1,25,23,5]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,y)}e.stringify=T;function A(n){let w=JSON.parse(n);return w=b(w),w}e.parse=A;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function y(n,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,L.regExpFlags)(w)}:w}function b(n,w=0){if(!n||w>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof D.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let f=0;f<n.length;++f)n[f]=b(n[f],w+1);else for(const f in n)Object.hasOwnProperty.call(n,f)&&(n[f]=b(n[f],w+1))}return n}e.revive=b}),define(Z[17],ee([0,1,4,5]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,b,n){this._hosts[y]=b,this._ports[y]=n}setConnectionToken(y,b){this._connectionTokens[y]=b}rewrite(y){if(this._delegate)return this._delegate(y);const b=y.authority;let n=this._hosts[b];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const w=this._ports[b],f=this._connectionTokens[b];let d=`path=${encodeURIComponent(y.path)}`;return typeof f=="string"&&(d+=`&tkn=${encodeURIComponent(f)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${n}:${w}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class A{asBrowserUri(y,b){const n=this.toUri(y,b);return n.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?n.with({scheme:R.vscodeFileResource,authority:n.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(y,b){const n=this.toUri(y,b);return n.scheme===R.vscodeFileResource?n.with({scheme:R.file,authority:n.authority!==A.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(y,b){return L.URI.isUri(y)?y:L.URI.parse(b.toUrl(y))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(Z[66],ee([0,1,40]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(b){return y(b,"NFC",L)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function A(b){return y(b,"NFD",T)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function y(b,n,w){if(!b)return b;const f=w.get(b);if(f)return f;let d;return P.test(b)?d=b.normalize(n):d=b,w.set(b,d),d}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(n){return A(n).replace(b,"")}}()}),define(Z[15],ee([0,1,39,17,8,4,23,5]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(d){return(0,P.uriToFsPath)(d,!0)}e.originalFSPath=y;class b{constructor(l){this._ignorePathCasing=l}compare(l,m,I=!1){return l===m?0:(0,A.compare)(this.getComparisonKey(l,I),this.getComparisonKey(m,I))}isEqual(l,m,I=!1){return l===m?!0:!l||!m?!1:this.getComparisonKey(l,I)===this.getComparisonKey(m,I)}getComparisonKey(l,m=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,m,I=!1){if(l.scheme===m.scheme){if(l.scheme===L.Schemas.file)return D.isEqualOrParent(y(l),y(m),this._ignorePathCasing(l))&&l.query===m.query&&(I||l.fragment===m.fragment);if((0,e.isEqualAuthority)(l.authority,m.authority))return D.isEqualOrParent(l.path,m.path,this._ignorePathCasing(l),"/")&&l.query===m.query&&(I||l.fragment===m.fragment)}return!1}joinPath(l,...m){return P.URI.joinPath(l,...m)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return R.posix.basename(l.path)}extname(l){const m=R.posix.extname(l.path),I=m.indexOf("?");return I!==-1?m.substr(0,I):m}dirname(l){if(l.path.length===0)return l;let m;return l.scheme===L.Schemas.file?m=P.URI.file(R.dirname(y(l))).path:(m=R.posix.dirname(l.path),l.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),m="/")),l.with({path:m})}normalizePath(l){if(!l.path.length)return l;let m;return l.scheme===L.Schemas.file?m=P.URI.file(R.normalize(y(l))).path:m=R.posix.normalize(l.path),l.with({path:m})}relativePath(l,m){if(l.scheme!==m.scheme||!(0,e.isEqualAuthority)(l.authority,m.authority))return;if(l.scheme===L.Schemas.file){const C=R.relative(y(l),y(m));return T.isWindows?D.toSlashes(C):C}let I=l.path||"/",E=m.path||"/";if(this._ignorePathCasing(l)){let C=0;for(const v=Math.min(I.length,E.length);C<v&&!(I.charCodeAt(C)!==E.charCodeAt(C)&&I.charAt(C).toLowerCase()!==E.charAt(C).toLowerCase());C++);I=E.substr(0,C)+I.substr(C)}return R.posix.relative(I,E)}resolvePath(l,m){if(l.scheme===L.Schemas.file){const I=P.URI.file(R.resolve(y(l),m));return l.with({authority:I.authority,path:I.path})}return m=D.toPosixPath(m),l.with({path:R.posix.resolve(l.path,m)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,m){return l===m||(0,A.equalsIgnoreCase)(l,m)}hasTrailingPathSeparator(l,m=R.sep){if(l.scheme===L.Schemas.file){const I=y(l);return I.length>D.getRoot(I).length&&I[I.length-1]===m}else{const I=l.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,m=R.sep){return(0,e.hasTrailingPathSeparator)(l,m)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,m=R.sep){let I=!1;if(l.scheme===L.Schemas.file){const E=y(l);I=E!==void 0&&E.length===D.getRoot(E).length&&E[E.length-1]===m}else{m="/";const E=l.path;I=E.length===1&&E.charCodeAt(E.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(l,m)?l.with({path:l.path+"/"}):l}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(d=>d.scheme===L.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new b(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(d,l){const m=[];for(let I=0;I<d.length;I++){const E=l(d[I]);d.some((C,v)=>v===I?!1:(0,e.isEqualOrParent)(E,l(C)))||m.push(d[I])}return m}e.distinctParents=n;var w;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function l(m){const I=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(v=>{const[a,o]=v.split(":");a&&o&&I.set(a,o)});const C=m.path.substring(0,m.path.indexOf(";"));return C&&I.set(d.META_DATA_MIME,C),I}d.parseMetaData=l})(w=e.DataUri||(e.DataUri={}));function f(d,l,m){if(l){let I=d.path;return I&&I[0]!==R.posix.sep&&(I=R.posix.sep+I),d.with({scheme:m,authority:l,path:I})}return d.with({scheme:m})}e.toLocalResource=f}),define(Z[6],ee([0,1,29,11,3,2,15]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P($){return!!$&&typeof $.then=="function"}e.isThenable=P;function y($){const M=new D.CancellationTokenSource,N=$(M.token),j=new Promise((F,q)=>{const _=M.token.onCancellationRequested(()=>{_.dispose(),M.dispose(),q((0,L.canceled)())});Promise.resolve(N).then(G=>{_.dispose(),M.dispose(),F(G)},G=>{_.dispose(),M.dispose(),q(G)})});return new class{cancel(){M.cancel()}then(F,q){return j.then(F,q)}catch(F){return this.then(void 0,F)}finally(F){return j.finally(F)}}}e.createCancelablePromise=y;function b($,M,N){return Promise.race([$,new Promise(j=>M.onCancellationRequested(()=>j(N)))])}e.raceCancellation=b;async function n($){let M=-1;const N=$.map((F,q)=>F.then(_=>(M=q,_))),j=await Promise.race(N);return $.forEach((F,q)=>{q!==M&&F.cancel()}),j}e.raceCancellablePromises=n;function w($,M,N){let j;const F=setTimeout(()=>{j?.(void 0),N?.()},M);return Promise.race([$.finally(()=>clearTimeout(F)),new Promise(q=>j=q)])}e.raceTimeout=w;function f($){return new Promise((M,N)=>{const j=$();P(j)?j.then(M,N):M(j)})}e.asPromise=f;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(N,N).then(j)})}return new Promise((N,j)=>{this.queuedPromise.then(N,j)})}return this.activePromise=M(),new Promise((N,j)=>{this.activePromise.then(F=>{this.activePromise=null,N(F)},F=>{this.activePromise=null,j(F)})})}}e.Throttler=d;class l{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=l;class m{constructor(){this.promiseMap=new Map}queue(M,N){const F=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(M)===F&&this.promiseMap.delete(M)});return this.promiseMap.set(M,F),F}}e.SequencerByKey=m;class I{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,N=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,F)=>{this.doResolve=j,this.doReject=F}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class E{constructor(M){this.delayer=new I(M),this.throttler=new d}trigger(M,N){return this.delayer.trigger(()=>this.throttler.queue(M),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class C{constructor(){this._isOpen=!1,this._promise=new Promise((M,N)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=C;class v extends C{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function a($,M){return M?new Promise((N,j)=>{const F=setTimeout(()=>{q.dispose(),N()},$),q=M.onCancellationRequested(()=>{clearTimeout(F),q.dispose(),j((0,L.canceled)())})}):y(N=>a($,N))}e.timeout=a;function o($,M=0){const N=setTimeout($,M);return(0,T.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=o;function t($){const M=[];let N=0;const j=$.length;function F(){return N<j?$[N++]():null}function q(_){_!=null&&M.push(_);const G=F();return G?G.then(q):Promise.resolve(M)}return Promise.resolve(null).then(q)}e.sequence=t;function r($,M=j=>!!j,N=null){let j=0;const F=$.length,q=()=>{if(j>=F)return Promise.resolve(N);const _=$[j++];return Promise.resolve(_()).then(W=>M(W)?Promise.resolve(W):q())};return q()}e.first=r;function i($,M=j=>!!j,N=null){if($.length===0)return Promise.resolve(N);let j=$.length;const F=()=>{j=-1;for(const q of $)q.cancel?.()};return new Promise((q,_)=>{for(const G of $)G.then(W=>{--j>=0&&M(W)?(F(),q(W)):j===0&&q(N)}).catch(W=>{--j>=0&&(F(),_(W))})})}e.firstParallel=i;class s{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((N,j)=>{this.outstandingPromises.push({factory:M,c:N,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const N=M.factory();N.then(M.c,M.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class c{constructor(){this.queues=new Map}queueFor(M,N=A.extUri){const j=N.getComparisonKey(M);let F=this.queues.get(j);return F||(F=new u,R.Event.once(F.onFinished)(()=>{F?.dispose(),this.queues.delete(j)}),this.queues.set(j,F)),F}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=c;class h{constructor(M,N){this._token=-1,typeof M=="function"&&typeof N=="number"&&this.setIfNotSet(M,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},N)}setIfNotSet(M,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},N))}}e.TimeoutTimer=h;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,N){this.cancel(),this._token=setInterval(()=>{M()},N)}}e.IntervalTimer=p;class S{constructor(M,N){this.timeoutToken=-1,this.runner=M,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=S;class g extends S{constructor(M,N){super(M,N);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=g;class k extends T.Disposable{constructor(M,N,j,F){super();this.maxWorkChunkSize=M,this.maxPendingWork=N,this.throttleDelay=j,this.handler=F,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.maxPendingWork)return!1}else if(this.pending+M.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...M),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new S(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=k,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const N=setTimeout(()=>M($));let j=!1;return{dispose(){j||(j=!0,clearTimeout(N))}}}}else e.runWhenIdle=($,M)=>{const N=requestIdleCallback($,typeof M=="number"?{timeout:M}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(N))}}}}();class O{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=O;async function x($,M,N){let j;for(let F=0;F<N;F++)try{return await $()}catch(q){j=q,await a(M)}throw j}e.retry=x;class z{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(M,N,j){return this._pending={taskId:M,cancel:()=>j?.(),promise:N},N.then(()=>this.donePending(M),()=>this.donePending(M)),N}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let N,j;const F=new Promise((q,_)=>{N=q,j=_});this._next={run:M,promise:F,promiseResolve:N,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=z;class H{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,N)=>{this.completeCallback=M,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(N=>{this.completeCallback(M),this.resolved=!0,N()})}error(M){return new Promise(N=>{this.errorCallback(M),this.rejected=!0,N()})}cancel(){new Promise(M=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=B;var U;(function($){async function M(N){let j;const F=await Promise.all(N.map(q=>q.then(_=>_,_=>{j||(j=_)})));if(typeof j!="undefined")throw j;return F}$.settled=M})(U=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,6,39,40,8,23]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const y="**",b="/",n="[/\\\\]",w="[^/\\\\]",f=/\//g;function d(F){switch(F){case 0:return"";case 1:return`${w}*?`;default:return`(?:${n}|${w}+${n}|${n}${w}+)*?`}}function l(F,q){if(!F)return[];const _=[];let G=!1,W=!1,X="";for(const Q of F){switch(Q){case q:if(!G&&!W){_.push(X),X="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":W=!0;break;case"]":W=!1;break}X+=Q}return X&&_.push(X),_}e.splitGlobAware=l;function m(F){if(!F)return"";let q="";const _=l(F,b);if(_.every(G=>G===y))q=".*";else{let G=!1;_.forEach((W,X)=>{if(W===y){G||(q+=d(2),G=!0);return}let Q=!1,ie="",te=!1,oe="";for(const ue of W){if(ue!=="}"&&Q){ie+=ue;continue}if(te&&(ue!=="]"||!oe)){let de;ue==="-"?de=ue:(ue==="^"||ue==="!")&&!oe?de="^":ue===b?de="":de=A.escapeRegExpCharacters(ue),oe+=de;continue}switch(ue){case"{":Q=!0;continue;case"[":te=!0;continue;case"}":q+=`(?:${l(ie,",").map(Re=>m(Re)).join("|")})`,Q=!1,ie="";break;case"]":q+="["+oe+"]",te=!1,oe="";break;case"?":q+=w;continue;case"*":q+=d(1);continue;default:q+=A.escapeRegExpCharacters(ue)}}X<_.length-1&&(_[X+1]!==y||X+2<_.length)&&(q+=n),G=!1})}return q}const I=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),r=function(){return!1},i=function(){return null};function s(F,q){if(!F)return i;let _;typeof F!="string"?_=F.pattern:_=F,_=_.trim();const G=`${_}_${!!q.trimForExclusions}`;let W=t.get(G);if(W)return u(W,F);let X;if(I.test(_)){const Q=_.substr(4);W=function(ie,te){return typeof ie=="string"&&ie.endsWith(Q)?_:null}}else(X=E.exec(c(_,q)))?W=h(X[1],_):(q.trimForExclusions?v:C).test(_)?W=p(_,q):(X=a.exec(c(_,q)))?W=S(X[1].substr(1),_,!0):(X=o.exec(c(_,q)))?W=S(X[1],_,!1):W=g(_);return t.set(G,W),u(W,F)}function u(F,q){return typeof q=="string"?F:function(_,G){return L.isEqualOrParent(_,q.base)?F(T.relative(q.base,_),G):null}}function c(F,q){return q.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function h(F,q){const _=`/${F}`,G=`\\${F}`,W=function(Q,ie){return typeof Q!="string"?null:ie?ie===F?q:null:Q===F||Q.endsWith(_)||Q.endsWith(G)?q:null},X=[F];return W.basenames=X,W.patterns=[q],W.allBasenames=X,W}function p(F,q){const _=j(F.slice(1,-1).split(",").map(ie=>s(ie,q)).filter(ie=>ie!==i),F),G=_.length;if(!G)return i;if(G===1)return _[0];const W=function(ie,te){for(let oe=0,ue=_.length;oe<ue;oe++)if(_[oe](ie,te))return F;return null},X=_.find(ie=>!!ie.allBasenames);X&&(W.allBasenames=X.allBasenames);const Q=_.reduce((ie,te)=>te.allPaths?ie.concat(te.allPaths):ie,[]);return Q.length&&(W.allPaths=Q),W}function S(F,q,_){const G=T.sep===T.posix.sep,W=G?F:F.replace(f,T.sep),X=T.sep+W,Q=T.posix.sep+F,ie=_?function(te,oe){return typeof te=="string"&&(te===W||te.endsWith(X)||!G&&(te===F||te.endsWith(Q)))?q:null}:function(te,oe){return typeof te=="string"&&(te===W||!G&&te===F)?q:null};return ie.allPaths=[(_?"*/":"./")+F],ie}function g(F){try{const q=new RegExp(`^${m(F)}$`);return function(_){return q.lastIndex=0,typeof _=="string"&&q.test(_)?F:null}}catch(q){return i}}function k(F,q,_){return!F||typeof q!="string"?!1:O(F)(q,void 0,_)}e.match=k;function O(F,q={}){if(!F)return r;if(typeof F=="string"||B(F)){const _=s(F,q);if(_===i)return r;const G=function(W,X){return!!_(W,X)};return _.allBasenames&&(G.allBasenames=_.allBasenames),_.allPaths&&(G.allPaths=_.allPaths),G}return M(F,q)}e.parse=O;function x(F){if(!F)return;let q;return _=>(q||(q=(F()||Promise.resolve([])).then(G=>G?H(G):{})),q.then(G=>!!G[_]))}e.hasSiblingPromiseFn=x;function z(F){if(!F)return;let q;return _=>{if(!q){const G=F();q=G?H(G):{}}return!!q[_]}}e.hasSiblingFn=z;function H(F){const q={};for(const _ of F)q[_]=!0;return q}function B(F){const q=F;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=B;function U(F){return F.allBasenames||[]}e.getBasenameTerms=U;function $(F){return F.allPaths||[]}e.getPathTerms=$;function M(F,q){const _=j(Object.getOwnPropertyNames(F).map(ie=>N(ie,F[ie],q)).filter(ie=>ie!==i)),G=_.length;if(!G)return i;if(!_.some(ie=>!!ie.requiresSiblings)){if(G===1)return _[0];const ie=function(ue,de){for(let ve=0,Re=_.length;ve<Re;ve++){const Te=_[ve](ue,de);if(Te)return Te}return null},te=_.find(ue=>!!ue.allBasenames);te&&(ie.allBasenames=te.allBasenames);const oe=_.reduce((ue,de)=>de.allPaths?ue.concat(de.allPaths):ue,[]);return oe.length&&(ie.allPaths=oe),ie}const W=function(ie,te,oe){let ue;for(let de=0,ve=_.length;de<ve;de++){const Re=_[de];Re.requiresSiblings&&oe&&(te||(te=T.basename(ie)),ue||(ue=te.substr(0,te.length-T.extname(ie).length)));const Te=Re(ie,te,ue,oe);if(Te)return Te}return null},X=_.find(ie=>!!ie.allBasenames);X&&(W.allBasenames=X.allBasenames);const Q=_.reduce((ie,te)=>te.allPaths?ie.concat(te.allPaths):ie,[]);return Q.length&&(W.allPaths=Q),W}function N(F,q,_){if(q===!1)return i;const G=s(F,_);if(G===i)return i;if(typeof q=="boolean")return G;if(q){const W=q.when;if(typeof W=="string"){const X=(Q,ie,te,oe)=>{if(!oe||!G(Q,ie))return null;const ue=W.replace("$(basename)",te),de=oe(ue);return(0,D.isThenable)(de)?de.then(ve=>ve?F:null):de?F:null};return X.requiresSiblings=!0,X}}return G}function j(F,q){const _=F.filter(ie=>!!ie.basenames);if(_.length<2)return F;const G=_.reduce((ie,te)=>{const oe=te.basenames;return oe?ie.concat(oe):ie},[]);let W;if(q){W=[];for(let ie=0,te=G.length;ie<te;ie++)W.push(q)}else W=_.reduce((ie,te)=>{const oe=te.patterns;return oe?ie.concat(oe):ie},[]);const X=function(ie,te){if(typeof ie!="string")return null;if(!te){let ue;for(ue=ie.length;ue>0;ue--){const de=ie.charCodeAt(ue-1);if(de===47||de===92)break}te=ie.substr(ue)}const oe=G.indexOf(te);return oe!==-1?W[oe]:null};X.basenames=G,X.patterns=W,X.allBasenames=G;const Q=F.filter(ie=>!ie.basenames);return Q.push(X),Q}}),define(Z[95],ee([0,1,67,17,8,15,23]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let y=[],b=[],n=[];function w(s,u=!1){const c=f(s);y.push(c),c.userConfigured?n.push(c):b.push(c),u&&!c.userConfigured&&y.forEach(h=>{h.mime===c.mime||h.userConfigured||(c.extension&&h.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&h.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&h.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&h.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=w;function f(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(R.posix.sep)>=0:!1}}function d(s){s?(y=y.filter(u=>!u.userConfigured),n=[]):(y=[],b=[],n=[])}e.clearTextMimes=d;function l(s,u){let c;if(s)switch(s.scheme){case L.Schemas.file:c=s.fsPath;break;case L.Schemas.data:c=T.DataUri.parseMetaData(s).get(T.DataUri.META_DATA_LABEL);break;default:c=s.path}if(!c)return[P.unknown];c=c.toLowerCase();const h=(0,R.basename)(c),p=m(c,h,n);if(p)return[p,P.text];const S=m(c,h,b);if(S)return[S,P.text];if(u){const g=I(u);if(g)return[g,P.text]}return[P.unknown]}e.guessMimeTypes=l;function m(s,u,c){let h=null,p=null,S=null;for(let g=c.length-1;g>=0;g--){const k=c[g];if(u===k.filenameLowercase){h=k;break}if(k.filepattern&&(!p||k.filepattern.length>p.filepattern.length)){const O=k.filepatternOnPath?s:u;(0,D.match)(k.filepatternLowercase,O)&&(p=k)}k.extension&&(!S||k.extension.length>S.extension.length)&&u.endsWith(k.extensionLowercase)&&(S=k)}return h?h.mime:p?p.mime:S?S.mime:null}function I(s){if((0,A.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let u=y.length-1;u>=0;u--){const c=y[u];if(!c.firstline)continue;const h=s.match(c.firstline);if(h&&h.length>0)return c.mime}return null}function E(s){return s?typeof s=="string"?s===P.binary||s===P.text||s===P.unknown:s.length===1&&E(s[0]):!0}e.isUnspecific=E;const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(s){const u=(0,R.extname)(s),c=C[u.toLowerCase()];return c!==void 0?c:o(s)}e.getMediaOrTextMime=a;function o(s){const u=(0,R.extname)(s);return v[u.toLowerCase()]}e.getMediaMime=o;function t(s){for(const u in v)if(v[u]===s)return u}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function i(s,u){const c=r.exec(s);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:u?void 0:s}e.normalizeMimeType=i}),define(Z[96],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class R{constructor(w){this._uriTransformer=w}transformIncoming(w){const f=this._uriTransformer.transformIncoming(w);return f===w?w:L(D.URI.from(f))}transformOutgoing(w){const f=this._uriTransformer.transformOutgoing(w);return f===w?w:L(D.URI.from(f))}transformOutgoingURI(w){const f=this._uriTransformer.transformOutgoing(w);return f===w?w:D.URI.from(f)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,w,f){if(!n||f>200)return null;if(typeof n=="object"){if(n instanceof D.URI)return w.transformOutgoing(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const l=T(n[d],w,f+1);l!==null&&(n[d]=l)}}return null}function A(n,w){const f=T(n,w,0);return f===null?n:f}e.transformOutgoingURIs=A;function P(n,w,f,d){if(!n||d>200)return null;if(typeof n=="object"){if(n.$mid===1)return f?D.URI.revive(w.transformIncoming(n)):w.transformIncoming(n);for(let l in n)if(Object.hasOwnProperty.call(n,l)){const m=P(n[l],w,f,d+1);m!==null&&(n[l]=m)}}return null}function y(n,w){const f=P(n,w,!1,0);return f===null?n:f}e.transformIncomingURIs=y;function b(n,w){const f=P(n,w,!0,0);return f===null?n:f}e.transformAndReviveIncomingURIs=b}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(y){return D.test(y)}e.isUUID=L;const R=new Uint8Array(16),T=[];for(let y=0;y<256;y++)T.push(y.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(y){for(let b=0;b<y.length;b++)y[b]=Math.floor(Math.random()*256);return y};function P(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,b="";return b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+="-",b+=T[R[y++]],b+=T[R[y++]],b+="-",b+=T[R[y++]],b+=T[R[y++]],b+="-",b+=T[R[y++]],b+=T[R[y++]],b+="-",b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b+=T[R[y++]],b}e.generateUuid=P}),define(Z[68],ee([0,1,218]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return A;let y=0,b,n=y;for(;n<P.length;)if(b=P.charCodeAt(n),b===13||b===10){if(A.push(P.substring(y,n)),n++,n<P.length){const w=b;b=P.charCodeAt(n),(w===13&&b===10||w===10&&b===13)&&n++}y=n}else n++;return this.remaining=y<P.length?P.substr(y):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(Z[97],ee([0,1,34]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const y=P.replace(/\-/g,":").toLowerCase();return!L.has(y)}function T(){return new Promise(async(P,y)=>{const b=setTimeout(()=>y("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(n){y(n)}finally{clearTimeout(b)}})}e.getMac=T;function A(){return new Promise((P,y)=>{try{const b=(0,D.networkInterfaces)();for(let n in b){const w=b[n];if(w){for(const{mac:f}of w)if(R(f))return P(f)}}y("Unable to retrieve mac address (unexpected format)")}catch(b){y(b)}})}}),define(Z[98],ee([0,1,34,11,40,30,97]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,w=0;const f=(0,D.networkInterfaces)();for(let d in f){const l=f[d];if(l)for(const{mac:m,internal:I}of l)I||(w+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(n+=1))}this._value=w>0?n/w:0}return this._value}};let P;async function y(){return P||(P=(async()=>await b()||T.generateUuid())()),P}e.getMachineId=y;async function b(){try{const n=await new Promise((f,d)=>{K(["crypto"],f,d)}),w=await(0,A.getMac)();return n.createHash("sha256").update(w,"utf8").digest("hex")}catch(n){L.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,50,34,219,6,39,66,8,4,15,5,30]),function(K,e,D,L,R,T,A,P,y,b,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var d;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(d=e.RimRafMode||(e.RimRafMode={}));async function l(U,$=d.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return $===d.UNLINK?I(U):m(U)}async function m(U){try{const $=(0,y.join)((0,L.tmpdir)(),(0,f.generateUuid)());try{await e.Promises.rename(U,$)}catch(M){return I(U)}I($).catch(M=>{})}catch($){if($.code!=="ENOENT")throw $}}async function I(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function E(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=E;async function C(U,$){return o(await($?v(U):(0,R.promisify)(D.readdir)(U)))}async function v(U){try{return await(0,R.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const $=[],M=await C(U);for(const N of M){let j=!1,F=!1,q=!1;try{const _=await e.Promises.lstat((0,y.join)(U,N));j=_.isFile(),F=_.isDirectory(),q=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}$.push({name:N,isFile:()=>j,isDirectory:()=>F,isSymbolicLink:()=>q})}return $}function a(U){return o(D.readdirSync(U))}e.readdirSync=a;function o(U){return U.map($=>typeof $=="string"?b.isMacintosh?(0,P.normalizeNFC)($):$:($.name=b.isMacintosh?(0,P.normalizeNFC)($.name):$.name,$))}async function t(U){const $=await C(U),M=[];for(const N of $)await i.existsDirectory((0,y.join)(U,N))&&M.push(N);return M}function r(U,$=1e3){return new Promise(M=>{let N=!1;const j=setInterval(()=>{N||(N=!0,D.access(U,F=>{N=!1,F&&(clearInterval(j),M(void 0))}))},$)})}e.whenDeleted=r;var i;(function(U){async function $(j){let F;try{if(F=await e.Promises.lstat(j),!F.isSymbolicLink())return{stat:F}}catch(q){}try{return{stat:await e.Promises.stat(j),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(b.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw _}throw q}}U.stat=$;async function M(j){try{const{stat:F,symbolicLink:q}=await U.stat(j);return F.isFile()&&q?.dangling!==!0}catch(F){}return!1}U.existsFile=M;async function N(j){try{const{stat:F,symbolicLink:q}=await U.stat(j);return F.isDirectory()&&q?.dangling!==!0}catch(F){}return!1}U.existsDirectory=N})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new T.ResourceQueue;function u(U,$,M){return s.queueFor(w.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const N=S(M);return new Promise((j,F)=>h(U,$,N,q=>q?F(q):j()))})}let c=!0;function h(U,$,M,N){if(!c)return D.writeFile(U,$,{mode:M.mode,flag:M.flag},N);D.open(U,M.flag,M.mode,(j,F)=>{if(j)return N(j);D.writeFile(F,$,q=>{if(q)return D.close(F,()=>N(q));D.fdatasync(F,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),c=!1),D.close(F,G=>N(G))))})})}function p(U,$,M){const N=S(M);if(!c)return D.writeFileSync(U,$,{mode:N.mode,flag:N.flag});const j=D.openSync(U,N.flag,N.mode);try{D.writeFileSync(j,$);try{D.fdatasyncSync(j)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),c=!1}}finally{D.closeSync(j)}}e.writeFileSync=p;function S(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function g(U,$){if(U===$)return;async function M(N){try{const j=await e.Promises.lstat(N);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes(N,j.atime,new Date)}catch(j){}}try{await e.Promises.rename(U,$),await M($)}catch(N){if(U.toLowerCase()!==$.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await k(U,$,{preserveSymlinks:!1}),await l(U,d.MOVE),await M($);else throw N}}async function k(U,$,M){return x(U,$,{root:{source:U,target:$},options:M,handledSourcePaths:new Set})}const O=511;async function x(U,$,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:N,symbolicLink:j}=await i.stat(U);if(j){if(M.options.preserveSymlinks)try{return await B(U,$,M)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(j.dangling)return}return N.isDirectory()?z(U,$,N.mode&O,M):H(U,$,N.mode&O)}async function z(U,$,M,N){await e.Promises.mkdir($,{recursive:!0,mode:M});const j=await C(U);for(const F of j)await x((0,y.join)(U,F),(0,y.join)($,F),N)}async function H(U,$,M){await e.Promises.copyFile(U,$),await e.Promises.chmod($,M)}async function B(U,$,M){let N=await e.Promises.readlink(U);(0,A.isEqualOrParent)(N,M.root.source,!b.isLinux)&&(N=(0,y.join)(M.root.target,N.substr(M.root.source.length+1))),await e.Promises.symlink(N,$)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return C}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return l}get move(){return g}get copy(){return k}}}),define(Z[99],ee([0,1,50,8,23,18]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const w=(0,L.dirname)(n);if(n===w)return n;const f=((0,L.basename)(n)||n).toLowerCase();try{const l=(0,T.readdirSync)(w).filter(m=>m.toLowerCase()===f);if(l.length===1){const m=A(w);if(m)return(0,L.join)(m,l[0])}else if(l.length>1){const m=l.indexOf(f);if(m>=0){const I=A(w);if(I)return(0,L.join)(I,l[m])}}}catch(d){}return null}e.realcaseSync=A;async function P(n){try{return await T.Promises.realpath(n)}catch(w){const f=b(n);return await T.Promises.access(f,D.constants.R_OK),f}}e.realpath=P;function y(n){try{return D.realpathSync(n)}catch(w){const f=b(n);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=y;function b(n){return(0,R.rtrim)((0,L.normalize)(n),L.sep)}}),define(Z[69],ee([0,1,34,8,18]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(y||(y={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class w{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:a=!1}={}){return a?b===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:a=!1,findPreview:o=!1}={}){const t=f({useAlternateBitness:a});if(!t)return null;const r=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let i=-1,s=null;for(const h of await R.Promises.readdir(r)){let p=-1;if(o){const g=h.indexOf("-");if(g<0)continue;const k=h.substring(0,g);if(!T.test(k)||h.substring(g+1)!=="preview")continue;p=parseInt(k,10)}else{if(!T.test(h))continue;p=parseInt(h,10)}if(p<=i)continue;const S=L.join(r,h,"pwsh.exe");!await R.SymlinkSupport.existsFile(S)||(s=S,i=p)}if(!s)return null;const u=t.includes("x86")?" (x86)":"",c=o?" Preview":"";return new w(s,`PowerShell${c}${u}`,!0)}async function l({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const o=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(o))if(t.test(i)){const s=L.join(o,i,"pwsh.exe");return new w(s,r)}return null}function m(){const a=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(a,".NET Core PowerShell Global Tool")}function I(){const a=L.join(process.env.windir,b===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(a,"Windows PowerShell",!0)}async function*E(){let a=await d();a&&(yield a),a=await d({useAlternateBitness:!0}),a&&(yield a),a=await l(),a&&(yield a),a=m(),a&&(yield a),a=await d({findPreview:!0}),a&&(yield a),a=await l({findPreview:!0}),a&&(yield a),a=await d({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=I(),a&&(yield a)}async function*C(){for await(const a of E())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=C;async function v(){for await(const a of C())return a;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Z[100],ee([0,1,41,17]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(A){return new Promise((P,y)=>{let b;const n=new Map;function w(d,l,m,I,E){const C=n.get(l);if(d===A||C){const v={name:f(m),cmd:m,pid:d,ppid:l,load:I,mem:E};n.set(d,v),d===A&&(b=v),C&&(C.children||(C.children=[]),C.children.push(v),C.children.length>1&&(C.children=C.children.sort((a,o)=>a.pid-o.pid)))}}function f(d){const l=/--disable-blink-features=Auxclick/,m=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,E=/\\pipe\\winpty-control/,C=/conhost\.exe/,v=/--type=([a-zA-Z-]+)/;if(m.exec(d))return"watcherService ";if(I.exec(d))return"electron-crash-reporter";if(E.exec(d))return"winpty-process";if(C.exec(d))return"console-window-host (Windows internal process)";let a=v.exec(d);if(a&&a.length===2)return a[1]==="renderer"?l.exec(d)?"shared-process":"window":a[1];const o=/[a-zA-Z-]+\.js/g;let t="";do a=o.exec(d),a&&(t+=a+" ");while(a);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${t}`:d}if(process.platform==="win32"){const d=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substr(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substr(5):l;new Promise((l,m)=>{K(["windows-process-tree"],l,m)}).then(l=>{l.getProcessList(A,m=>{l.getProcessCpuUsage(m,I=>{const E=new Map;I.forEach(C=>{const v=d(C.commandLine||"");E.set(C.pid,{name:f(v),cmd:v,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),b=E.get(A),b?(E.forEach(C=>{const v=E.get(C.ppid);v&&(v.children||(v.children=[]),v.children.push(C))}),E.forEach(C=>{C.children&&(C.children=C.children.sort((v,a)=>v.pid-a.pid))}),P(b)):y(new Error(`Root process ${A} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let d=function(){let l=[b];const m=[];for(;l.length;){const E=l.shift();E&&(m.push(E.pid),E.children&&(l=l.concat(E.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);I+=" "+m.join(" "),(0,D.exec)(I,{},(E,C,v)=>{if(E||v)y(E||new Error(v.toString()));else{const a=C.toString().split(`
`);for(let o=0;o<m.length;o++){const t=n.get(m[o]);t.load=parseFloat(a[o])}if(!b){y(new Error(`Root process ${A} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(l,m,I)=>{if(l||I)if(process.platform!=="linux")y(l||new Error(I.toString()));else{const E=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,D.exec)(E,{},(C,v,a)=>{C||a?y(C||new Error(a.toString())):(T(v,w),d())})}else{const E=m.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${E} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,a,o)=>{v||o&&!o.includes("screen size is bogus")?y(v||new Error(o.toString())):(T(a,w),process.platform==="linux"?d():b?P(b):y(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=R;function T(A,P){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=A.toString().split(`
`);for(const n of b){const w=y.exec(n.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(Z[101],ee([0,1,50,39,2,66,8,4,18]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function b(f,d,l){return w({path:f,isDirectory:!1},d,l)}e.watchFile=b;function n(f,d,l){return w({path:f,isDirectory:!0},d,l)}e.watchFolder=n,e.CHANGE_BUFFER_DELAY=100;function w(f,d,l){if(P.isMacintosh&&(0,L.isEqualOrParent)(f.path,"/Volumes/"))return l(`Refusing to watch ${f.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const m=(0,A.basename)(f.path),I=new Map;let E=!1,C=[(0,R.toDisposable)(()=>{I.forEach(v=>(0,R.dispose)(v)),I.clear()})];try{const v=(0,D.watch)(f.path);C.push((0,R.toDisposable)(()=>{v.removeAllListeners(),v.close()}));const a=new Set;f.isDirectory&&y.Promises.readdir(f.path).then(o=>o.forEach(t=>a.add(t))),v.on("error",(o,t)=>{E||l(`Failed to watch ${f.path} for changes using fs.watch() (${o}, ${t})`)}),v.on("change",(o,t)=>{if(E)return;let r="";if(t&&(r=t.toString(),P.isMacintosh&&(r=(0,T.normalizeNFC)(r))),!r||o!=="change"&&o!=="rename")return;const i=f.isDirectory?(0,A.join)(f.path,r):f.path;if(f.isDirectory)if(o==="rename"){const s=I.get(i);s&&(0,R.dispose)(s);const u=setTimeout(async()=>{I.delete(i);const c=await y.Promises.exists(i);if(E)return;let h;c?a.has(r)?h="changed":(h="added",a.add(r)):(a.delete(r),h="deleted"),d(h,i)},e.CHANGE_BUFFER_DELAY);I.set(i,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let s;a.has(r)?s="changed":(s="added",a.add(r)),d(s,i)}else if(o==="rename"||r!==m){const s=setTimeout(async()=>{const u=await y.Promises.exists(i);E||(u?(d("changed",i),C=[w(f,d,l)]):d("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(C),C=[(0,R.toDisposable)(()=>clearTimeout(s))]}else d("changed",i)})}catch(v){y.Promises.exists(f.path).then(a=>{a&&!E&&l(`Failed to watch ${f.path} for changes using fs.watch() (${v.toString()})`)})}return(0,R.toDisposable)(()=>{E=!0,C=(0,R.dispose)(C)})}});var he=this&&this.__decorate||function(K,e,D,L){var R=arguments.length,T=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(K,e,D,L);else for(var P=K.length-1;P>=0;P--)(A=K[P])&&(T=(R<3?A(T):R>3?A(e,D,T):A(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(Z[36],ee([0,1,22,6,25,29,64,11,3,2,94,23,16]),function(K,e,D,L,R,T,A,P,y,b,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var d;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(d=e.RequestType||(e.RequestType={}));function l(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function I(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(E||(E={}));class C{constructor(F){this.buffer=F,this.pos=0}read(F){const q=this.buffer.slice(this.pos,this.pos+F);return this.pos+=q.byteLength,q}}class v{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var a;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object"})(a||(a={}));function o(j){const F=R.VSBuffer.alloc(4);return F.writeUInt32BE(j,0),F}function t(j){return j.read(4).readUInt32BE(0)}function r(j){const F=R.VSBuffer.alloc(1);return F.writeUInt8(j,0),F}const i={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object)},s=typeof Buffer!="undefined";function u(j,F){if(typeof F=="undefined")j.write(i.Undefined);else if(typeof F=="string"){const q=R.VSBuffer.fromString(F);j.write(i.String),j.write(o(q.byteLength)),j.write(q)}else if(s&&Buffer.isBuffer(F)){const q=R.VSBuffer.wrap(F);j.write(i.Buffer),j.write(o(q.byteLength)),j.write(q)}else if(F instanceof R.VSBuffer)j.write(i.VSBuffer),j.write(o(F.byteLength)),j.write(F);else if(Array.isArray(F)){j.write(i.Array),j.write(o(F.length));for(const q of F)u(j,q)}else{const q=R.VSBuffer.fromString(JSON.stringify(F));j.write(i.Object),j.write(o(q.byteLength)),j.write(q)}}function c(j){switch(j.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return j.read(t(j)).toString();case a.Buffer:return j.read(t(j)).buffer;case a.VSBuffer:return j.read(t(j));case a.Array:{const q=t(j),_=[];for(let G=0;G<q;G++)_.push(c(j));return _}case a.Object:return JSON.parse(j.read(t(j)).toString())}}class h{constructor(F,q,_=null,G=1e3){this.protocol=F,this.ctx=q,this.logger=_,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(F,q){this.channels.set(F,q),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const q=this.send([F.type]);this.logger&&this.logger.logOutgoing(q,0,1,I(F.type));return}case 201:case 202:case 204:case 203:{const q=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(q,F.id,1,I(F.type),F.data);return}}}send(F,q=void 0){const _=new v;return u(_,F),u(_,q),this.sendBuffer(_.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(q){return 0}}onRawMessage(F){const q=new C(F),_=c(q),G=c(q),W=_[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${l(W)}: ${_[2]}.${_[3]}`,G),this.onPromise({type:W,id:_[1],channelName:_[2],name:_[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${l(W)}: ${_[2]}.${_[3]}`,G),this.onEventListen({type:W,id:_[1],channelName:_[2],name:_[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${l(W)}`),this.disposeActiveRequest({type:W,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],1,`${l(W)}`),this.disposeActiveRequest({type:W,id:_[1]})}}onPromise(F){const q=this.channels.get(F.channelName);if(!q){this.collectPendingRequest(F);return}const _=new T.CancellationTokenSource;let G;try{G=q.call(this.ctx,F.name,F.arg,_.token)}catch(Q){G=Promise.reject(Q)}const W=F.id;G.then(Q=>{this.sendResponse({id:W,data:Q,type:201}),this.activeRequests.delete(F.id)},Q=>{Q instanceof Error?this.sendResponse({id:W,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:W,data:Q,type:203}),this.activeRequests.delete(F.id)});const X=(0,b.toDisposable)(()=>_.cancel());this.activeRequests.set(F.id,X)}onEventListen(F){const q=this.channels.get(F.channelName);if(!q){this.collectPendingRequest(F);return}const _=F.id,W=q.listen(this.ctx,F.name,F.arg)(X=>this.sendResponse({id:_,data:X,type:204}));this.activeRequests.set(F.id,W)}disposeActiveRequest(F){const q=this.activeRequests.get(F.id);q&&(q.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let q=this.pendingRequests.get(F.channelName);q||(q=[],this.pendingRequests.set(F.channelName,q));const _=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:F,timeoutTimer:_})}flushPendingRequests(F){const q=this.pendingRequests.get(F);if(q){for(const _ of q)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var p;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(F,q=null){this.protocol=F,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=q}getChannel(F){const q=this;return{call(_,G,W){return q.isDisposed?Promise.reject(P.canceled()):q.requestPromise(F,_,G,W)},listen(_,G){return q.isDisposed?Promise.reject(P.canceled()):q.requestEvent(F,_,G)}}}requestPromise(F,q,_,G=T.CancellationToken.None){const W=this.lastRequestId++,Q={id:W,type:100,channelName:F,name:q,arg:_};if(G.isCancellationRequested)return Promise.reject(P.canceled());let ie;return new Promise((oe,ue)=>{if(G.isCancellationRequested)return ue(P.canceled());const de=()=>{const Ne=Oe=>{switch(Oe.type){case 201:this.handlers.delete(W),oe(Oe.data);break;case 202:this.handlers.delete(W);const ke=new Error(Oe.data.message);ke.stack=Oe.data.stack,ke.name=Oe.data.name,ue(ke);break;case 203:this.handlers.delete(W),ue(Oe.data);break}};this.handlers.set(W,Ne),this.sendRequest(Q)};let ve=null;this.state===E.Idle?de():(ve=(0,L.createCancelablePromise)(Ne=>this.whenInitialized()),ve.then(()=>{ve=null,de()}));const Re=()=>{ve?(ve.cancel(),ve=null):this.sendRequest({id:W,type:101}),ue(P.canceled())},Te=G.onCancellationRequested(Re);ie=(0,b.combinedDisposable)((0,b.toDisposable)(Re),Te),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(F,q,_){const G=this.lastRequestId++,X={id:G,type:102,channelName:F,name:q,arg:_};let Q=null;const ie=new y.Emitter({onFirstListenerAdd:()=>{Q=(0,L.createCancelablePromise)(oe=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ie),this.sendRequest(X)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ie),this.sendRequest({id:G,type:103}))}}),te=oe=>ie.fire(oe.data);return this.handlers.set(G,te),ie.event}sendRequest(F){switch(F.type){case 100:case 102:{const q=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(q,F.id,0,`${l(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const q=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(q,F.id,0,l(F.type));return}}}send(F,q=void 0){const _=new v;return u(_,F),u(_,q),this.sendBuffer(_.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(q){return 0}}onBuffer(F){const q=new C(F),_=c(q),G=c(q),W=_[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,I(W)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,_[1],0,I(W),G),this.onResponse({type:_[0],id:_[1],data:G})}}onResponse(F){if(F.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(F.id);q&&q(F)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}he([A.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class g{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:q,onDidClientDisconnect:_})=>{y.Event.once(q.onMessage)(W=>{const X=new C(W),Q=c(X),ie=new h(q,Q),te=new S(q);this.channels.forEach((ue,de)=>ie.registerChannel(de,ue));const oe={channelServer:ie,channelClient:te,ctx:Q};this._connections.add(oe),this._onDidAddConnection.fire(oe),_(()=>{ie.dispose(),te.dispose(),this._connections.delete(oe),this._onDidRemoveConnection.fire(oe)})})})}get connections(){const F=[];return this._connections.forEach(q=>F.push(q)),F}getChannel(F,q){const _=this;return{call(G,W,X){let Q;if((0,f.isFunction)(q)){let te=(0,D.getRandomElement)(_.connections.filter(q));Q=te?Promise.resolve(te):y.Event.toPromise(y.Event.filter(_.onDidAddConnection,q))}else Q=q.routeCall(_,G,W);const ie=Q.then(te=>te.channelClient.getChannel(F));return O(ie).call(G,W,X)},listen(G,W){if((0,f.isFunction)(q))return _.getMulticastEvent(F,q,G,W);const X=q.routeEvent(_,G,W).then(Q=>Q.channelClient.getChannel(F));return O(X).listen(G,W)}}}getMulticastEvent(F,q,_,G){const W=this;let X=new b.DisposableStore;const Q=new y.Emitter({onFirstListenerAdd:()=>{X=new b.DisposableStore;const ie=new y.EventMultiplexer,te=new Map,oe=de=>{const Re=de.channelClient.getChannel(F).listen(_,G),Te=ie.add(Re);te.set(de,Te)},ue=de=>{const ve=te.get(de);!ve||(ve.dispose(),te.delete(de))};W.connections.filter(q).forEach(oe),y.Event.filter(W.onDidAddConnection,q)(oe,void 0,X),W.onDidRemoveConnection(ue,void 0,X),ie.event(Q.fire,Q,X),X.add(ie)},onLastListenerRemove:()=>{X.dispose()}});return Q.event}registerChannel(F,q){this.channels.set(F,q),this._connections.forEach(_=>{_.channelServer.registerChannel(F,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=g;class k{constructor(F,q,_=null){const G=new v;u(G,q),F.send(G.buffer),this.channelClient=new S(F,_),this.channelServer=new h(F,q,_)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,q){this.channelServer.registerChannel(F,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function O(j){return{call(F,q,_){return j.then(G=>G.call(F,q,_))},listen(F,q){const _=new y.Relay;return j.then(G=>_.input=G.listen(F,q)),_.event}}}e.getDelayedChannel=O;function x(j){let F=!1;return{call(q,_,G){return F?j.call(q,_,G):(0,L.timeout)(0).then(()=>F=!0).then(()=>j.call(q,_,G))},listen(q,_){if(F)return j.listen(q,_);const G=new y.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>G.input=j.listen(q,_)),G.event}}}e.getNextTickChannel=x;class z{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const q of F.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await y.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=z;var H;(function(j){function F(G,W){const X=G,Q=W&&W.disableMarshalling,ie=new Map;for(const te in X)_(te)&&ie.set(te,y.Event.buffer(X[te],!0));return new class{listen(te,oe){const ue=ie.get(oe);if(ue)return ue;throw new Error(`Event not found: ${oe}`)}call(te,oe,ue){const de=X[oe];if(typeof de=="function"){if(!Q&&Array.isArray(ue))for(let ve=0;ve<ue.length;ve++)ue[ve]=(0,n.revive)(ue[ve]);return de.apply(X,ue)}throw new Error(`Method not found: ${oe}`)}}}j.fromService=F;function q(G,W){const X=W&&W.disableMarshalling;return new Proxy({},{get(Q,ie){if(typeof ie=="string")return W?.properties?.has(ie)?W.properties.get(ie):_(ie)?G.listen(ie):async function(...te){let oe;W&&!(0,f.isUndefinedOrNull)(W.context)?oe=[W.context,...te]:oe=te;const ue=await G.call(ie,oe);return X?ue:(0,n.revive)(ue)};throw new Error(`Property not found: ${String(ie)}`)}})}j.toService=q;function _(G){return G[0]==="o"&&G[1]==="n"&&w.isUpperAsciiLetter(G.charCodeAt(2))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){let F=j.toString();if(F!=="[object Object]")return F}return j}function $(j){return Array.isArray(j)?j.map(U):U(j)}function M(j,F,q,_,G,W,X){X=$(X);const Q=B[G],ie=Q[_%Q.length];let te=[`%c[${j}]%c[${String(F).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(W)?(te=te.concat(X),te.push(")")):te.push(X),console.log.apply(console,te)}e.logWithColors=M;class N{constructor(F,q){this._outgoingPrefix=F,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,q,_,G,W){this._totalOutgoing+=F,M(this._outgoingPrefix,this._totalOutgoing,F,q,_,G,W)}logIncoming(F,q,_,G,W){this._totalIncoming+=F,M(this._incomingPrefix,this._totalIncoming,F,q,_,G,W)}}e.IPCLogger=N}),define(Z[102],ee([0,1,25,3,36]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(y){this.port=y,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends R.IPCClient{constructor(y,b){const n=new T(y);super(n,b);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(Z[103],ee([0,1,104,3,36,102]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends R.IPCServer{static getOnDidClientConnect(){const y=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,n)=>n);return L.Event.map(y,b=>{const{port1:n,port2:w}=new MessageChannel,d={protocol:new T.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[w]),d})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(Z[105],ee([0,1,25,11]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,y){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((n,w)=>{b.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(b,P),b.responseType="arraybuffer",b.onerror=f=>w(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=f=>{n({res:{statusCode:b.status,headers:A(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=f=>w(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(b.timeout=P.timeout),b.send(P.data),y.onCancellationRequested(()=>{b.abort(),w((0,L.canceled)())})})}e.request=R;function T(P,y){if(y.headers){e:for(let b in y.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(b,y.headers[b])}}}function A(P){const y=Object.create(null);for(const b of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const n=b.indexOf(":");y[b.substr(0,n).trim().toLowerCase()]=b.substr(n+1).trim()}return y}}),define(Z[70],ee([0,1,6,3,2,16]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var P;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(P||(P={}));class y extends R.Disposable{constructor(w,f=Object.create(null)){super();this.database=w,this.options=f,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(w=>this.onDidChangeItemsExternal(w)))}onDidChangeItemsExternal(w){w.changed?.forEach((f,d)=>this.accept(d,f)),w.deleted?.forEach(f=>this.accept(f,void 0))}accept(w,f){if(this.state===P.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(f)?d=this.cache.delete(w):this.cache.get(w)!==f&&(this.cache.set(w,f),d=!0),d&&this._onDidChangeStorage.fire(w)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(w,f){const d=this.cache.get(w);return(0,T.isUndefinedOrNull)(d)?f:d}getBoolean(w,f){const d=this.get(w);return(0,T.isUndefinedOrNull)(d)?f:d==="true"}getNumber(w,f){const d=this.get(w);return(0,T.isUndefinedOrNull)(d)?f:parseInt(d,10)}async set(w,f){if(this.state===P.Closed)return;if((0,T.isUndefinedOrNull)(f))return this.delete(w);const d=String(f);if(this.cache.get(w)!==d)return this.cache.set(w,d),this.pendingInserts.set(w,d),this.pendingDeletes.delete(w),this._onDidChangeStorage.fire(w),this.flushDelayer.trigger(()=>this.flushPending())}async delete(w){if(!(this.state===P.Closed||!this.cache.delete(w)))return this.pendingDeletes.has(w)||this.pendingDeletes.add(w),this.pendingInserts.delete(w),this._onDidChangeStorage.fire(w),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(w){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const w={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(w).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(w=>this.whenFlushedCallbacks.push(w))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(w){w.insert&&w.insert.forEach((f,d)=>this.items.set(d,f)),w.delete&&w.delete.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=b}),define(Z[106],ee([9,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[56],ee([0,1,106]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,T=R*24,A=T*7,P=T*30,y=T*365;function b(w,f){typeof w!="number"&&(w=w.getTime());const d=Math.round((new Date().getTime()-w)/1e3);if(d<-30)return(0,D.localize)(0,null,b(new Date().getTime()+d*1e3,!1));if(d<30)return(0,D.localize)(1,null);let l;return d<L?(l=d,f?l===1?(0,D.localize)(2,null,l):(0,D.localize)(3,null,l):l===1?(0,D.localize)(4,null,l):(0,D.localize)(5,null,l)):d<R?(l=Math.floor(d/L),f?l===1?(0,D.localize)(6,null,l):(0,D.localize)(7,null,l):l===1?(0,D.localize)(8,null,l):(0,D.localize)(9,null,l)):d<T?(l=Math.floor(d/R),f?l===1?(0,D.localize)(10,null,l):(0,D.localize)(11,null,l):l===1?(0,D.localize)(12,null,l):(0,D.localize)(13,null,l)):d<A?(l=Math.floor(d/T),f?l===1?(0,D.localize)(14,null,l):(0,D.localize)(15,null,l):l===1?(0,D.localize)(16,null,l):(0,D.localize)(17,null,l)):d<P?(l=Math.floor(d/A),f?l===1?(0,D.localize)(18,null,l):(0,D.localize)(19,null,l):l===1?(0,D.localize)(20,null,l):(0,D.localize)(21,null,l)):d<y?(l=Math.floor(d/P),f?l===1?(0,D.localize)(22,null,l):(0,D.localize)(23,null,l):l===1?(0,D.localize)(24,null,l):(0,D.localize)(25,null,l)):(l=Math.floor(d/y),f?l===1?(0,D.localize)(26,null,l):(0,D.localize)(27,null,l):l===1?(0,D.localize)(28,null,l):(0,D.localize)(29,null,l))}e.fromNow=b;function n(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[107],ee([9,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[37],ee([0,1,22,16,107]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(b,n){return n&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),A(b.stack)||A(b.stacktrace)):P(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function y(b=null,n=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const w=D.coalesce(b),f=y(w[0],n);return w.length>1?R.localize(4,null,f,w.length):f}if(L.isString(b))return b;if(b.detail){const w=b.detail;if(w.error)return T(w.error,n);if(w.exception)return T(w.exception,n)}return b.stack?T(b,n):b.message?b.message:R.localize(5,null)}e.toErrorMessage=y}),define(Z[108],ee([9,10]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[71],ee([0,1,41,39,17,26,8,4,35,16,68,18,108]),function(K,e,D,L,R,T,A,P,y,b,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(a,o){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};o&&(t.cwd=o);const r=D.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],t);return new Promise(i=>{r.once("error",s=>{i({success:!1,error:s})}),r.once("exit",(s,u)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?d(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{D.execFile(t,[a.pid.toString()],{encoding:"utf8",shell:!0},(i,s,u)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function m(a=y.env){return a.comspec||"cmd.exe"}e.getWindowsShell=m;class I{constructor(o,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=o,this.args=t,this.shell=r,this.options=i;else{const s=o;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(y.env).forEach(u=>{s[u]=y.env[u]}),Object.keys(this.options.env).forEach(u=>{s[u]=this.options.env[u]}),this.options.env=s}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const t=o.lastIndexOf(A.sep);return t!==-1&&(o=o.substring(t+1)),I.WellKnowCommands[o]?o:"other"}start(o){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(y.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(t=>{let r,i;const s=new Promise((u,c)=>{r=u,i=c});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(c,h,p)=>{this.childProcess=null;const S=c;S&&S.killed?i({killed:this.terminateRequested,stdout:h.toString(),stderr:p.toString()}):this.handleExec(r,o,c,h,p)})}else{let u=null;const c=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,o,i);const p={terminated:this.terminateRequested};b.isNumber(h)&&(p.cmdCode=h),r(p)};if(this.shell&&P.isWindows){const h=T.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let p=!1,S=!1;const g=[];let k=this.ensureQuotes(this.cmd);g.push(k.value),p=k.quoted,this.args&&this.args.forEach(x=>{k=this.ensureQuotes(x),g.push(k.value),S=S&&k.quoted});const O=["/s","/c"];p?S?O.push('"'+g.join(" ")+'"'):g.length>1?O.push('"'+g[0]+'" '+g.slice(1).join(" ")):O.push('"'+g[0]+'"'):O.push(g.join(" ")),u=D.spawn(m(),O,h)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(b.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",h=>{this.childProcess=null,i({terminated:this.terminateRequested,error:h})}),u.pid&&(this.childProcess.on("close",c),this.handleSpawn(u,r,o,i,!0)))}return s})}handleClose(o,t,r,i){}ensureQuotes(o){return I.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,l(o,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!P.isWindows)return o(!1);const t=D.spawn(m(),["/s","/c"]);t.on("error",r=>o(!0)),t.on("exit",r=>o(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class E extends I{constructor(o,t,r,i){super(o,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,t,r,i,s){[i,s].forEach((u,c)=>{const h=new n.LineDecoder;h.write(u).forEach(g=>{t({line:g,source:c===0?0:1})});const S=h.end();S&&t({line:S,source:c===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,t,r,i,s){const u=new n.LineDecoder,c=new n.LineDecoder;o.stdout.on("data",h=>{u.write(h).forEach(S=>r({line:S,source:0}))}),o.stderr.on("data",h=>{c.write(h).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=c}handleClose(o,t,r,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=E;function C(a){let o=[],t=!1;const r=function(i){if(t){o.push(i);return}(!a.send(i,u=>{if(u&&console.error(u),t=!1,o.length>0){const c=o.slice(0);o=[],c.forEach(h=>r(h))}})||P.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=C;var v;(function(a){async function o(t,r,i){if(A.isAbsolute(t))return t;if(r===void 0&&(r=y.cwd()),A.dirname(t)!=="."||(i===void 0&&b.isString(y.env.PATH)&&(i=y.env.PATH.split(A.delimiter)),i===void 0||i.length===0))return A.join(r,t);async function u(c){return await w.Promises.exists(c)?!(await w.Promises.stat(c)).isDirectory():!1}for(let c of i){let h;if(A.isAbsolute(c)?h=A.join(c,t):h=A.join(r,c,t),await u(h))return h;let p=h+".com";if(await u(p)||(p=h+".exe",await u(p)))return p}return A.join(r,t)}a.findExecutable=o})(v=e.win32||(e.win32={}))}),define(Z[109],ee([0,1,34,4,69,71]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(d,l){return d===1?L.isWindows?w():T.getWindowsShell(l):b(d,l)}e.getSystemShell=A;function P(d,l){return d===1?L.isWindows?f(l):T.getWindowsShell(l):b(d,l)}e.getSystemShellSync=P;let y=null;function b(d,l){if(L.isLinux&&d===2||L.isMacintosh&&d===3)return"/bin/bash";if(!y){let m;if(L.isWindows)m="/bin/bash";else{if(m=l.SHELL,!m)try{m=(0,D.userInfo)().shell}catch(I){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}y=m}return y}let n=null;async function w(){return n||(n=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),n}function f(d){if(n)return n;const l=L.isWindows&&parseFloat((0,D.release)())>=10,m=d.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${d.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?I:T.getWindowsShell(d)}}),define(Z[51],ee([0,1,41,6,25,29,93,11,3,2,26,4,71,36]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class l extends d.ChannelServer{constructor(E){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(v){}},onMessage:y.Event.fromNodeEventEmitter(process,"message",C=>R.VSBuffer.wrap(Buffer.from(C,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=l;class m{constructor(E,C){this.modulePath=E,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new L.Delayer(v),this.child=null,this._client=null}getChannel(E){const C=this;return{call(v,a,o){return C.requestPromise(E,v,a,o)},listen(v,a){return C.requestEvent(E,v,a)}}}requestPromise(E,C,v,a=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(E),t=(0,L.createCancelablePromise)(s=>o.call(C,v,s)),r=a.onCancellationRequested(()=>t.cancel()),i=(0,b.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,C,v){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let a;const o=new y.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(E).listen(C,v)(o.fire,o),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(C.env={...C.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),w.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,E,C);const v=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,A.isRemoteConsoleLog)(u)){(0,A.log)(u,`IPC Library: ${this.options.serverName}`);return}v.fire(R.VSBuffer.wrap(Buffer.from(u,"base64")))});const o=this.options.useQueue?(0,f.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&o.send(u.buffer.toString("base64")),r=v.event,i={send:t,onMessage:r};this._client=new d.ChannelClient(i);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,c)=>{process.removeListener("exit",s),this.activeRequests.forEach(h=>(0,b.dispose)(h)),this.activeRequests.clear(),u!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:c})})}return this._client}getCachedChannel(E){let C=this.channels.get(E);return C||(C=this.client.getChannel(E),this.channels.set(E,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(Z[110],ee([9,10]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[111],ee([9,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[112],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[113],ee([9,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[114],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[115],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[116],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[117],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[118],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[119],ee([9,10]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[120],ee([9,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[121],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[122],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[123],ee([9,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[124],ee([9,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[125],ee([9,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[126],ee([9,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[127],ee([9,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[128],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[129],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[130],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[131],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[132],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[133],ee([9,10]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[134],ee([0,1,56,64,17,8,35,15,5]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(l,m,I){this._args=l,this.paths=m,this.productService=I}get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",K).fsPath)}get userHome(){return y.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return y.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return y.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(y.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return y.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return y.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=A.env.VSCODE_PORTABLE;return l?y.URI.file((0,T.join)(l,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,T.resolve)(l):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,T.resolve)(l):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,T.resolve)(l);const m=A.env.VSCODE_EXTENSIONS;if(m)return m;const I=A.env.VSCODE_PORTABLE;return I?(0,T.join)(I,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(m=>/^[^:/?#]+?:\/\//.test(m)?y.URI.parse(m):y.URI.file((0,T.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?y.URI.parse(l):y.URI.file((0,T.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return y.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],b.prototype,"appRoot",null),he([L.memoize],b.prototype,"userHome",null),he([L.memoize],b.prototype,"userDataPath",null),he([L.memoize],b.prototype,"appSettingsHome",null),he([L.memoize],b.prototype,"tmpDir",null),he([L.memoize],b.prototype,"userRoamingDataHome",null),he([L.memoize],b.prototype,"settingsResource",null),he([L.memoize],b.prototype,"userDataSyncHome",null),he([L.memoize],b.prototype,"userDataSyncLogResource",null),he([L.memoize],b.prototype,"sync",null),he([L.memoize],b.prototype,"machineSettingsResource",null),he([L.memoize],b.prototype,"globalStorageHome",null),he([L.memoize],b.prototype,"workspaceStorageHome",null),he([L.memoize],b.prototype,"keybindingsResource",null),he([L.memoize],b.prototype,"keyboardLayoutResource",null),he([L.memoize],b.prototype,"argvResource",null),he([L.memoize],b.prototype,"snippetsHome",null),he([L.memoize],b.prototype,"isExtensionDevelopment",null),he([L.memoize],b.prototype,"untitledWorkspacesHome",null),he([L.memoize],b.prototype,"installSourcePath",null),he([L.memoize],b.prototype,"builtinExtensionsPath",null),he([L.memoize],b.prototype,"extensionsPath",null),he([L.memoize],b.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],b.prototype,"extensionDevelopmentKind",null),he([L.memoize],b.prototype,"extensionTestsLocationURI",null),he([L.memoize],b.prototype,"debugExtensionHost",null),he([L.memoize],b.prototype,"serviceMachineIdResource",null),he([L.memoize],b.prototype,"telemetryLogResource",null),he([L.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function n(d,l){return f(d["inspect-extensions"],d["inspect-brk-extensions"],5870,l,d.debugId)}e.parseExtensionHostPort=n;function w(d,l){return f(d["inspect-search"],d["inspect-brk-search"],5876,l)}e.parseSearchPort=w;function f(d,l,m,I,E){const v=Number(l||d)||(I?null:m),a=v?Boolean(!!l):!1;return{port:v,break:a,debugId:E}}}),define(Z[135],ee([0,1,220,4,112]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(l,m,I=A){const E={},C=[],v=[];for(let r in m){const i=m[r];i.alias&&(E[r]=i.alias),i.type==="string"||i.type==="string[]"?(C.push(r),i.deprecates&&C.push(i.deprecates)):i.type==="boolean"&&(v.push(r),i.deprecates&&v.push(i.deprecates))}const a=D(l,{string:C,boolean:v,alias:E}),o={},t=a;o._=a._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in m){const i=m[r];i.alias&&delete t[i.alias];let s=t[r];i.deprecates&&t.hasOwnProperty(i.deprecates)&&(s||(s=t[i.deprecates]),delete t[i.deprecates]),typeof s!="undefined"&&(i.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):i.type==="string"&&Array.isArray(s)&&(s=s.pop(),I.onMultipleValues(r,s)),o[r]=s),delete t[r]}for(let r in t)I.onUnknownOption(r);return o}e.parseArgs=P;function y(l,m){let I="";return m.args&&(Array.isArray(m.args)?I=` <${m.args.join("> <")}>`:I=` <${m.args}>`),m.alias?`-${m.alias} --${l}${I}`:`--${l}${I}`}function b(l,m){let I=0,E=[];for(const o in l){const t=l[o],r=y(o,t);I=Math.max(I,r.length),E.push([r,t.description])}let C=I+2+1;if(m-C<25)return E.reduce((o,t)=>o.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let v=m-C-1,a=[];for(const o of E){let t=o[0],r=w(o[1],v),i=n(C-t.length-2);a.push("  "+t+i+r[0]);for(let s=1;s<r.length;s++)a.push(n(C)+r[s])}return a}e.formatOptions=b;function n(l){return" ".repeat(l)}function w(l,m){let I=[];for(;l.length;){let E=l.length<m?l.length:l.lastIndexOf(" ",m),C=l.slice(0,E).trim();l=l.slice(E),I.push(C)}return I}function f(l,m,I,E,C=!0){const v=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${l} ${I}`];a.push(""),a.push(`${(0,R.localize)(32,null)}: ${m} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),a.push(""),C&&(L.isWindows?a.push((0,R.localize)(35,null,m)):a.push((0,R.localize)(36,null,m)),a.push(""));const o={};for(const t in E){const r=E[t];if(r.description&&r.cat){let i=o[r.cat];i||(o[r.cat]=i={}),i[t]=r}}for(let t in o){const r=t;let i=o[r];i&&(a.push(T[r]),a.push(...b(i,v)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=f;function d(l,m){return`${l||(0,R.localize)(37,null)}
${m||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=d}),function(){"use strict";function K(e,D,L,R){function T(P){const y=A(P),b=[y];return e.isAbsolute(y)||b.unshift(R),e.resolve(...b)}function A(P){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,L);const n=P["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(w,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,L)}return{getUserDataPath:T}}if(typeof define=="function")define(Z[136],ee([0,137,34,17,15,35]),function(e,D,L,R,T,A){const P=T.dirname(R.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return K(D,L,y.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=K(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[138],ee([0,1,34,134,136]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends L.AbstractNativeEnvironmentService{constructor(P,y){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},y)}}e.NativeEnvironmentService=T}),define(Z[139],ee([0,1,5]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,y=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(I){const E=I.match(A);return E?E[1]:null}function n(I){if(I.indexOf("://")===-1){const E=I.match(L);return E?b(E[2]):null}try{const E=D.URI.parse(I);if(E.authority)return b(E.authority)}catch(E){}return null}function w(I,E){const C=new Set;let v;for(;v=P.exec(I);){const o=n(v[1]);o&&C.add(o)}const a=new Set(E);return Array.from(C).map(o=>a.has(o)?o:o.replace(y,"a"))}e.getDomainsOfRemotes=w;function f(I){const E=I.match(T);return E?E[2]:null}function d(I,E,C){return I&&E?(C&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${I}${E}`:`${I}/${E}`):null}function l(I,E){if(I.indexOf("://")===-1){const C=I.match(R);if(C)return d(C[2],C[3],E)}try{const C=D.URI.parse(I);if(C.authority)return d(f(C.authority),C.path,E)}catch(C){}return null}function m(I,E=!1){const C=[];let v;for(;v=P.exec(I);){const a=l(v[1],E);a&&C.push(a)}return C}e.getRemotes=m}),define(Z[140],ee([0,1,3,2,26,5,96]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(l,m){return T.URI.revive(m?m.transformIncoming(l):l)}function y(l,m){return m?m.transformOutgoingURI(l):l}function b(l,m){m=m||A.DefaultURITransformer;const I=l.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...l,manifest:void 0},m),manifest:I}}function n(l,m){return m?(0,R.cloneAndChange)(l,I=>I instanceof T.URI?m.transformOutgoingURI(I):void 0):l}class w{constructor(m,I){this.service=m,this.getUriTransformer=I,this.onInstallExtension=D.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,I){const E=this.getUriTransformer(m);switch(I){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,C=>C.map(v=>({...v,local:v.local?n(v.local,E):v.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,I,E){const C=this.getUriTransformer(m);switch(I){case"zip":return this.service.zip(b(E[0],C)).then(v=>y(v,C));case"unzip":return this.service.unzip(P(E[0],C));case"install":return this.service.install(P(E[0],C),E[1]);case"getManifest":return this.service.getManifest(P(E[0],C));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(b(E[0],C),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(b(E[0],C));case"getInstalled":return this.service.getInstalled(E[0]).then(v=>v.map(a=>n(a,C)));case"updateMetadata":return this.service.updateMetadata(b(E[0],C),E[1]).then(v=>n(v,C));case"updateExtensionScope":return this.service.updateExtensionScope(b(E[0],C),E[1]).then(v=>n(v,C));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=w;class f extends L.Disposable{constructor(m){super();this.channel=m,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(I=>this._onInstallExtension.fire({identifier:I.identifier,source:this.isUriComponents(I.source)?T.URI.revive(I.source):I.source}))),this._register(this.channel.listen("onDidInstallExtensions")(I=>this._onDidInstallExtensions.fire(I.map(E=>({...E,local:E.local?b(E.local,null):E.local,source:this.isUriComponents(E.source)?T.URI.revive(E.source):E.source}))))),this._register(this.channel.listen("onUninstallExtension")(I=>this._onUninstallExtension.fire(I))),this._register(this.channel.listen("onDidUninstallExtension")(I=>this._onDidUninstallExtension.fire(I)))}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(I=>T.URI.revive(I)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,I){return Promise.resolve(this.channel.call("install",[m,I])).then(E=>b(E,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}async canInstall(m){return!0}installFromGallery(m,I){return Promise.resolve(this.channel.call("installFromGallery",[m,I])).then(E=>b(E,null))}uninstall(m,I){return Promise.resolve(this.channel.call("uninstall",[m,I]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null){return Promise.resolve(this.channel.call("getInstalled",[m])).then(I=>I.map(E=>b(E,null)))}updateMetadata(m,I){return Promise.resolve(this.channel.call("updateMetadata",[m,I])).then(E=>b(E,null))}updateExtensionScope(m,I){return Promise.resolve(this.channel.call("updateExtensionScope",[m,I])).then(E=>b(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class d{constructor(m){this.service=m}listen(m,I){throw new Error("Invalid listen")}call(m,I,E){switch(I){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=d}),define(Z[141],ee([0,1,26]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(T,A){const P=y=>{if(typeof y!="string")return;const b=L.exec(y);if(!b)return;const n=A[b[1]]??y;return typeof n=="string"?n:typeof n.message=="string"?n.message:y};return(0,D.cloneAndChange)(T,P)}e.localizeManifest=R}),define(Z[142],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,P,y){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,P,y])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[72],ee([0,1,120]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function T(f){return f=f.trim(),f==="*"||L.test(f)}e.isValidVersionStr=T;function A(f){if(!T(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=f.match(L);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=A;function P(f){if(!f)return null;let d=f.majorBase,l=f.majorMustEqual,m=f.minorBase,I=f.minorMustEqual,E=f.patchBase,C=f.patchMustEqual;f.hasCaret&&(d===0||(I=!1),C=!1);let v=0;if(f.preRelease){const a=R.exec(f.preRelease);if(a){const[,o,t,r]=a;v=Date.UTC(Number(o),Number(t)-1,Number(r))}}return{majorBase:d,majorMustEqual:l,minorBase:m,minorMustEqual:I,patchBase:E,patchMustEqual:C,isMinimum:f.hasGreaterEquals,notBefore:v}}e.normalizeVersion=P;function y(f,d,l){let m;typeof f=="string"?m=P(A(f)):m=f;let I;d instanceof Date?I=d.getTime():typeof d=="string"&&(I=new Date(d).getTime());let E;if(typeof l=="string"?E=P(A(l)):E=l,!m||!E)return!1;let C=m.majorBase,v=m.minorBase,a=m.patchBase,o=E.majorBase,t=E.minorBase,r=E.patchBase,i=E.notBefore,s=E.majorMustEqual,u=E.minorMustEqual,c=E.patchMustEqual;return E.isMinimum?C>o?!0:C<o?!1:v>t?!0:v<t||I&&I<i?!1:a>=r:(C===1&&o===0&&(!s||!u||!c)&&(o=1,t=0,r=0,s=!0,u=!1,c=!1),C<o?!1:C>o?!s:v<t?!1:v>t?!u:a<r?!1:a>r?!c:!(I&&I<i))}e.isValidVersion=y;function b(f,d,l,m){return l.isBuiltin||typeof l.main=="undefined"?!0:w(f,d,l.engines.vscode,m)}e.isValidExtensionVersion=b;function n(f,d,l){return f==="*"||w(d,l,f)}e.isEngineValid=n;function w(f,d,l,m=[]){let I=P(A(l));if(!I)return m.push(D.localize(0,null,l)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return m.push(D.localize(1,null,l)),!1}else if(!I.majorMustEqual)return m.push(D.localize(2,null,l)),!1;return y(f,d,I)?!0:(m.push(D.localize(3,null,f,l)),!1)}}),define(Z[143],ee([0,1,2,17,36,51]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends D.Disposable{constructor(y,b,n,w){super();this.folders=y,this.onDidFilesChange=b,this.onLogMessage=n,this.verboseLogging=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.setFolders(this.folders)}setVerboseLogging(y){this.verboseLogging=y,!this.isDisposed&&this.service&&this.service.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[144],ee([0,1,2,17,36,51]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends D.Disposable{constructor(y,b,n,w,f={}){super();this.folders=y,this.onDidFilesChange=b,this.onLogMessage=n,this.verboseLogging=w,this.watcherOptions=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(y.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.service.setRoots(this.folders)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${y}`})}setVerboseLogging(y){this.verboseLogging=y,this.service&&this.service.setVerboseLogging(y)}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(Z[145],ee([0,1,41,67,17,68]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(y,b,n,w,f){this.watchedFolder=y,this.eventCallback=n,this.logCallback=w,this.verboseLogging=f,this.restartCounter=0,Array.isArray(b)?this.ignored=b.map(d=>(0,L.parse)(d)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${y}, excludes: ${b.join(",")}`),this.startWatcher()}startWatcher(){const y=[this.watchedFolder];this.verboseLogging&&y.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,y);const b=new T.LineDecoder;this.handle.stdout.on("data",n=>{const w=[];for(const f of b.write(n)){const d=f.split("|");if(d.length===2){const l=Number(d[0]),m=d[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(I=>I(m))){this.verboseLogging&&this.log(m);continue}w.push({type:A.changeTypeMap[l],path:m})}else this.log(d[1])}}w.length>0&&this.eventCallback(w)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,w)=>this.onExit(n,w))}onError(y){this.error("process error: "+y.toString())}onExit(y,b){this.handle&&(this.error(`terminated unexpectedly (code: ${y}, signal: ${b})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(y){this.logCallback({type:"error",message:`[File Watcher (C#)] ${y}`})}log(y){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${y}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(Z[146],ee([0,1,8,23,145]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(P,y,b,n){this.onDidFilesChange=y,this.onLogMessage=b,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(Z[52],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],A=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(Z[147],ee([0,1,52]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(A,P,y){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],y)),L.push([A,P])}e.registerSingleton=R;function T(){return L}e.getSingletonServiceDescriptors=T}),define(Z[148],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const P=this.lookupOrInsertNode(T),y=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),y),y.incoming.set(this._hashFn(T),P)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let P=this._nodes.get(A);return P||(P=new D(T),this._nodes.set(A,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,P]of this._nodes)T.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const P=new Set([T]),y=this._findCycle(A,P);if(y)return y}}_findCycle(T,A){for(let[P,y]of T.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const b=this._findCycle(y,A);if(b)return b;A.delete(P)}}}e.Graph=L}),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function y(b){return b[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=y})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,y,b,n){y[D.DI_TARGET]===y?y[D.DI_DEPENDENCIES].push({id:P,index:b,optional:n}):(y[D.DI_DEPENDENCIES]=[{id:P,index:b,optional:n}],y[D.DI_TARGET]=y)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const y=function(b,n,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(y,b,w,!1)};return y.toString=()=>P,D.serviceIds.set(P,y),y}e.createDecorator=R;function T(P){return P}e.refineServiceDecorator=T;function A(P){return function(y,b,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,y,n,!0)}}e.optional=A}),define(Z[149],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(Z[150],ee([0,1,4,23,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",D.isMacintosh),A.set("isLinux",D.isLinux),A.set("isWindows",D.isWindows),A.set("isWeb",D.isWeb),A.set("isMacNative",D.isMacintosh&&!D.isWeb),A.set("isEdge",T.indexOf("Edg/")>=0),A.set("isFirefox",T.indexOf("Firefox")>=0),A.set("isChrome",T.indexOf("Chrome")>=0),A.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var y;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return w.INSTANCE}static true(){return f.INSTANCE}static has(g){return d.create(g)}static equals(g,k){return l.create(g,k)}static notEquals(g,k){return E.create(g,k)}static regex(g,k){return r.create(g,k)}static in(g,k){return m.create(g,k)}static not(g){return C.create(g)}static and(...g){return s.create(g)}static or(...g){return u.create(g)}static greater(g,k){return v.create(g,k)}static less(g,k){return o.create(g,k)}static deserialize(g,k=!1){if(!!g)return this._deserializeOrExpression(g,k)}static _deserializeOrExpression(g,k){let O=g.split("||");return u.create(O.map(x=>this._deserializeAndExpression(x,k)))}static _deserializeAndExpression(g,k){let O=g.split("&&");return s.create(O.map(x=>this._deserializeOne(x,k)))}static _deserializeOne(g,k){if(g=g.trim(),g.indexOf("!=")>=0){let O=g.split("!=");return E.create(O[0].trim(),this._deserializeValue(O[1],k))}if(g.indexOf("==")>=0){let O=g.split("==");return l.create(O[0].trim(),this._deserializeValue(O[1],k))}if(g.indexOf("=~")>=0){let O=g.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],k))}if(g.indexOf(" in ")>=0){let O=g.split(" in ");return m.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const O=g.split(">=");return a.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const O=g.split(">");return v.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const O=g.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const O=g.split("<");return o.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(g)?C.create(g.substr(1).trim()):d.create(g)}static _deserializeValue(g,k){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let O=/^'([^']*)'$/.exec(g);return O?O[1].trim():g}static _deserializeRegexValue(g,k){if((0,L.isFalsyOrWhitespace)(g)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=g.indexOf("/"),x=g.lastIndexOf("/");if(O===x||O<0){if(k)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let z=g.slice(O+1,x),H=g[x+1]==="i"?"i":"";try{return new RegExp(z,H)}catch(B){if(k)throw new Error(`bad regexp-value '${g}', parse error: ${B}`);return console.warn(`bad regexp-value '${g}', parse error: ${B}`),null}}}e.ContextKeyExpr=b;function n(S,g){return S.cmp(g)}class w{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class f{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class d{constructor(g){this.key=g,this.type=2}static create(g){const k=A.get(g);return typeof k=="boolean"?k?f.INSTANCE:w.INSTANCE:new d(g)}cmp(g){return g.type!==this.type?this.type-g.type:h(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return C.create(this.key)}}e.ContextKeyDefinedExpr=d;class l{constructor(g,k){this.key=g,this.value=k,this.type=4}static create(g,k){if(typeof k=="boolean")return k?d.create(g):C.create(g);const O=A.get(g);return typeof O=="boolean"?k===(O?"true":"false")?f.INSTANCE:w.INSTANCE:new l(g,k)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class m{constructor(g,k){this.key=g,this.valueKey=k,this.type=10}static create(g,k){return new m(g,k)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}evaluate(g){const k=g.getValue(this.valueKey),O=g.getValue(this.key);return Array.isArray(k)?k.indexOf(O)>=0:typeof O=="string"&&typeof k=="object"&&k!==null?P.call(k,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return I.create(this)}}e.ContextKeyInExpr=m;class I{constructor(g){this._actual=g,this.type=11}static create(g){return new I(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new I(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class E{constructor(g,k){this.key=g,this.value=k,this.type=5}static create(g,k){if(typeof k=="boolean")return k?C.create(g):d.create(g);const O=A.get(g);return typeof O=="boolean"?k===(O?"true":"false")?w.INSTANCE:f.INSTANCE:new E(g,k)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class C{constructor(g){this.key=g,this.type=3}static create(g){const k=A.get(g);return typeof k=="boolean"?k?w.INSTANCE:f.INSTANCE:new C(g)}cmp(g){return g.type!==this.type?this.type-g.type:h(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=C;class v{constructor(g,k){this.key=g,this.value=k,this.type=12}static create(g,k){return new v(g,k)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=v;class a{constructor(g,k){this.key=g,this.value=k,this.type=13}static create(g,k){return new a(g,k)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class o{constructor(g,k){this.key=g,this.value=k,this.type=14}static create(g,k){return new o(g,k)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(g,k){this.key=g,this.value=k,this.type=15}static create(g,k){return new t(g,k)}cmp(g){return g.type!==this.type?this.type-g.type:p(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}evaluate(g){return parseFloat(g.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(g,k){this.key=g,this.regexp=k,this.type=7}static create(g,k){return new r(g,k)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const k=this.regexp?this.regexp.source:"",O=g.regexp?g.regexp.source:"";return k<O?-1:k>O?1:0}equals(g){if(g.type===this.type){const k=this.regexp?this.regexp.source:"",O=g.regexp?g.regexp.source:"";return this.key===g.key&&k===O}return!1}evaluate(g){let k=g.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(g){this._actual=g,this.type=8}static create(g){return new i(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new i(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class s{constructor(g){this.expr=g,this.type=6}static create(g){return s._normalizeArr(g)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const x=n(this.expr[k],g.expr[k]);if(x!==0)return x}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(g.expr[k]))return!1;return!0}return!1}evaluate(g){for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].evaluate(g))return!1;return!0}static _normalizeArr(g){const k=[];let O=!1;for(const x of g)if(!!x){if(x.type===1){O=!0;continue}if(x.type===0)return w.INSTANCE;if(x.type===6){k.push(...x.expr);continue}k.push(x)}if(k.length===0&&O)return f.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(n);k.length>1;){const x=k[k.length-1];if(x.type!==9)break;k.pop();const z=k.pop(),H=u.create(x.expr.map(B=>s.create([B,z])));H&&(k.push(H),k.sort(n))}return k.length===1?k[0]:new s(k)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let k of this.expr)g.push(...k.keys());return g}map(g){return new s(this.expr.map(k=>k.map(g)))}negate(){let g=[];for(let k of this.expr)g.push(k.negate());return u.create(g)}}e.ContextKeyAndExpr=s;class u{constructor(g){this.expr=g,this.type=9}static create(g){const k=u._normalizeArr(g);if(k.length!==0)return k.length===1?k[0]:new u(k)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let k=0,O=this.expr.length;k<O;k++){const x=n(this.expr[k],g.expr[k]);if(x!==0)return x}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let k=0,O=this.expr.length;k<O;k++)if(!this.expr[k].equals(g.expr[k]))return!1;return!0}return!1}evaluate(g){for(let k=0,O=this.expr.length;k<O;k++)if(this.expr[k].evaluate(g))return!0;return!1}static _normalizeArr(g){let k=[],O=!1;if(g){for(let x=0,z=g.length;x<z;x++){const H=g[x];if(!!H){if(H.type===0){O=!0;continue}if(H.type===1)return[f.INSTANCE];if(H.type===9){k=k.concat(H.expr);continue}k.push(H)}}if(k.length===0&&O)return[w.INSTANCE];k.sort(n)}return k}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let k of this.expr)g.push(...k.keys());return g}map(g){return new u(this.expr.map(k=>k.map(g)))}negate(){let g=[];for(let O of this.expr)g.push(O.negate());const k=O=>O.type===9?O.expr:[O];for(;g.length>1;){const O=g.shift(),x=g.shift(),z=[];for(const H of k(O))for(const B of k(x))z.push(b.and(H,B));g.unshift(b.or(...z))}return g[0]}}e.ContextKeyOrExpr=u;class c extends d{constructor(g,k,O){super(g);this._defaultValue=k,typeof O=="object"?c._info.push({...O,key:g}):O!==!0&&c._info.push({key:g,description:O,type:k!=null?typeof k:void 0})}static all(){return c._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return b.not(this.key)}isEqualTo(g){return b.equals(this.key,g)}notEqualsTo(g){return b.notEquals(this.key,g)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(S,g){return S<g?-1:S>g?1:0}function p(S,g,k,O){return S<k?-1:S>k?1:g<O?-1:g>O?1:0}}),define(Z[73],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[74],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Z[12],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[27],ee([0,1,17,115,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=T;var A;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=5]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var y;(function(w){w.Install="install",w.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var b;(function(w){w[w.None=0]="None",w[w.Install=1]="Install",w[w.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(f,d){super(f);this.code=d,this.name=d}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var Y=this&&this.__param||function(K,e){return function(D,L){e(D,L,K)}};define(Z[151],ee([0,1,2,27]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=he([Y(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(Z[75],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[76],ee([0,1,23,7]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=R;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,f){if(typeof w=="undefined"||w===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof w=="string"||typeof f=="string"){let d=typeof w=="string"?w:w.value,l=typeof f=="string"?f:f.value;return D.equalsIgnoreCase(d,l)}return w._lower===f._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=P;function y(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function b(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=b,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[31],ee([0,1,23,76]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(l,m){return l.uuid&&m.uuid?l.uuid===m.uuid:l.id===m.id?!0:(0,D.compareIgnoreCase)(l.id,m.id)===0}e.areSameExtensions=R;class T{constructor(m,I){this.version=I,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof T?R(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(l,m){return`${l}.${m}`}e.getExtensionId=A;function P(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(l,m){return P(A(l,m))}e.getGalleryExtensionId=y;function b(l,m){const I=[],E=C=>{for(const v of I)if(v.some(a=>R(m(a),m(C))))return v;return null};for(const C of l){const v=E(C);v?v.push(C):I.push([C])}return I}e.groupByExtension=b;function n(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function w(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function f(l){const m=new Set;for(const I of l)I.malicious&&m.add(I.id.id);return m}e.getMaliciousExtensionsSet=f;function d(l,m){const I=[],E=m.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const C=E.shift();if(C&&I.every(v=>!R(v.identifier,{id:C}))){const v=l.filter(a=>R(a.identifier,{id:C}));v.length===1&&(I.push(v[0]),E.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=d}),define(Z[152],ee([0,1,2,8,18,76]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(y,b){super();this.environmentService=y,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(b.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(y){y.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(y){y.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(Z[13],ee([0,1,40,8,23,16,5,122,7]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function b(U){return U.create===!0}e.isFileOpenForWriteOptions=b;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var w;(function(U){U[U.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var f;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=d;function l(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=l;function m(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function I(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=I;var E;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor($,M){super($);this.code=M}}e.FileSystemProviderError=C;function v(U,$){const M=new C(U.toString(),$);return o(M,$),M}e.createFileSystemProviderError=v;function a(U){return U||v((0,P.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=a;function o(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=o;function t(U){if(!U)return E.Unknown;if(U instanceof C)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return E.Unknown;switch($[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof p)return U.fileOperationResult;switch(t(U)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor($,M,N){this.resource=$,this.operation=M,this.target=N}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor($,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of $)switch(N.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>M)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>M)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>M)),this.deleted.set(N.resource,N);break}}contains($,...M){return this.doContains($,{includeChildren:!1},...M)}affects($,...M){return this.doContains($,{includeChildren:!0},...M)}doContains($,M,...N){if(!$)return!1;const j=N.length>0;return!!((!j||N.includes(1))&&(this.added?.get($)||M.includeChildren&&this.added?.findSuperstr($))||(!j||N.includes(0))&&(this.updated?.get($)||M.includeChildren&&this.updated?.findSuperstr($))||(!j||N.includes(2))&&(this.deleted?.findSubstr($)||M.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function h(U,$,M){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),M?(0,R.startsWithIgnoreCase)(U,$):U.indexOf($)===0)}e.isParent=h;class p extends Error{constructor($,M,N){super($);this.fileOperationResult=M,this.options=N}}e.FileOperationError=p;class S extends p{constructor($,M,N){super($,2,N);this.stat=M}}e.NotModifiedSinceFileOperationError=S;var g;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function x(U,$){if(!$.canHandleResource(A.URI.from({scheme:U.scheme})))return new Promise(M=>{const N=$.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===U.scheme&&j.added&&(N.dispose(),M())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize($){return(0,T.isNumber)($)||($=0),$<z.KB?(0,P.localize)(1,null,$.toFixed(0)):$<z.MB?(0,P.localize)(2,null,($/z.KB).toFixed(2)):$<z.GB?(0,P.localize)(3,null,($/z.MB).toFixed(2)):$<z.TB?(0,P.localize)(4,null,($/z.GB).toFixed(2)):(0,P.localize)(5,null,($/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var H;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function B(U){return{maxFileSize:U===0?300*z.MB:16*z.GB,maxHeapSize:U===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=B}),define(Z[153],ee([0,1,154,49,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(y,b)=>{const n=(0,D.createHash)("md5"),w=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(w,{onData:f=>n.update(f.buffer),onError:f=>b(f),onEnd:()=>y(n.digest("base64").replace(/=+$/,""))})})}};T=he([Y(0,R.IFileService)],T),e.ChecksumService=T}),define(Z[155],ee([0,1,221,113,135,13]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(f,d){const l={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,E)=>{console.warn((0,L.localize)(1,null,I,E))}},m=(0,R.parseArgs)(f,R.OPTIONS,d?l:void 0);return m.goto&&m._.forEach(I=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),m["max-memory"]&&D(parseInt(m["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function P(f){const d=f.findIndex(l=>!/^-/.test(l));if(d>-1)return[...f.slice(0,d),...f.slice(d+1)]}function y(f){let[,...d]=f;process.env.VSCODE_DEV&&(d=P(d)||[]);const l=!w(process.env);return A(d,l)}e.parseMainProcessArgv=y;function b(f){const[,,...d]=f;return A(d,!0)}e.parseCLIProcessArgv=b;function n(f,...d){const l=f.indexOf("--");return l===-1?f.push(...d):f.splice(l,0,...d),f}e.addArg=n;function w(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),define(Z[156],ee([0,1,41,137,29,37,11,4,30,109,155]),function(K,e,D,L,R,T,A,P,y,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function w(l,m,I){return m["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,n.isLaunchedFromCli)(I)&&!m["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,n.isLaunchedFromCli)(I)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=new Promise(async E=>{const C=new R.CancellationTokenSource,v=setTimeout(()=>{l.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),C.dispose(!0),E({})},1e4);try{const a=await d(l,C.token);E(a)}catch(a){(0,A.isPromiseCanceledError)(a)||l.error(`[resolve shell env] Unable to resolve shell environment (${a}). Proceeding without shell environment...`),E({})}finally{clearTimeout(v),C.dispose()}})),f)}e.resolveShellEnv=w;let f;async function d(l,m){const I=new Promise(async(E,C)=>{const v=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",v);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",a);const o=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",r);const i=await(0,b.getSystemShell)(P.OS,r);if(l.trace("getUnixShellEnvironment#shell",i),m.isCancellationRequested)return C(A.canceled);const s=L.basename(i);let u,c;/^pwsh(-preview)?$/.test(s)?(u=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,c=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,c=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(c),u);const h=(0,D.spawn)(i,[...c,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(h.kill(),C(A.canceled))),h.on("error",g=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(g)),E({})});const p=[];h.stdout.on("data",g=>p.push(g));const S=[];h.stderr.on("data",g=>S.push(g)),h.on("close",(g,k)=>{const O=Buffer.concat(p).toString("utf8");l.trace("getUnixShellEnvironment#raw",O);const x=Buffer.concat(S).toString("utf8");if(x.trim()&&l.trace("getUnixShellEnvironment#stderr",x),g||k)return C(new Error(`Failed to get environment (code ${g}, signal ${k})`));const z=t.exec(O),H=z?z[1]:"{}";try{const B=JSON.parse(H);v?B.ELECTRON_RUN_AS_NODE=v:delete B.ELECTRON_RUN_AS_NODE,a?B.ELECTRON_NO_ATTACH_CONSOLE=a:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",B),E(B)}catch(B){l.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(B)),C(B)}})});try{return await I}catch(E){return l.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(E)),{}}}}),define(Z[77],ee([0,1,4,5,13]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(y){return y.map(b=>({type:b.type,resource:L.URI.file(b.path)}))}e.toFileChanges=T;function A(y){const b=new P;for(const n of y)b.processEvent(n);return b.normalize()}e.normalizeFileChanges=A;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(b){const n=this.mapPathToChange.get(b.path);if(n){const w=n.type,f=b.type;w===1&&f===2?(this.mapPathToChange.delete(b.path),this.normalized.splice(this.normalized.indexOf(n),1)):w===2&&f===1?n.type=0:w===1&&f===0||(n.type=f)}else this.normalized.push(b),this.mapPathToChange.set(b.path,b)}normalize(){const b=[],n=[];return this.normalized.filter(w=>w.type!==2?(b.push(w),!1):!0).sort((w,f)=>w.path.length-f.path.length).filter(w=>n.some(f=>(0,R.isParent)(w.path,f,!D.isLinux))?!1:(n.push(w.path),!0)).concat(b)}}}),define(Z[157],ee([0,1,6,2,8,99,18,101,77]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends L.Disposable{constructor(w,f,d,l){super();this.path=w,this.onDidFilesChange=f,this.onLogMessage=d,this.verboseLogging=l,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(w){this.verboseLogging=w}async startWatching(){try{const{stat:w,symbolicLink:f}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let d=this.path;if(f)try{d=await(0,T.realpath)(d)}catch(l){if(this.onError(l),f.dangling)return}w.isDirectory()?this._register((0,P.watchFolder)(d,(l,m)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(m))})},l=>this.onError(l))):this._register((0,P.watchFile)(d,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(w){w.code!=="ENOENT"&&this.onError(w)}}onFileChange(w){this.fileChangesBuffer.push(w),this.verboseLogging&&this.onVerbose(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,y.normalizeFileChanges)(f);if(this.verboseLogging)for(const l of d)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);d.length>0&&this.onDidFilesChange(d)})}onError(w){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${w}`})}onVerbose(w){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(Z[78],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[T,A]of R)this.set(T,A)}set(R,T){const A=this._entries.get(R);return this._entries.set(R,T),A}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(Z[158],ee([0,1,6,11,52,148,7,78]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class b extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class n{constructor(l=new P.ServiceCollection,m=!1,I){this._activeInstantiations=new Set,this._services=l,this._strict=m,this._parent=I,this._services.set(A.IInstantiationService,this)}createChild(l){return new n(l,this._strict,this)}invokeFunction(l,...m){let I=f.traceInvocation(l),E=!1;try{return l({get:(v,a)=>{if(E)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(v,I);if(!o&&a!==A.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return o}},...m)}finally{E=!0,I.stop()}}createInstance(l,...m){let I,E;return l instanceof R.SyncDescriptor?(I=f.traceCreation(l.ctor),E=this._createInstance(l.ctor,l.staticArguments.concat(m),I)):(I=f.traceCreation(l),E=this._createInstance(l,m,I)),I.stop(),E}_createInstance(l,m=[],I){let E=A._util.getServiceDependencies(l).sort((a,o)=>a.index-o.index),C=[];for(const a of E){let o=this._getOrCreateServiceInstance(a.id,I);if(!o&&this._strict&&!a.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${a.id}.`);C.push(o)}let v=E.length>0?E[0].index:m.length;if(m.length!==v){console.warn(`[createInstance] First service dependency of ${l.name} at position ${v+1} conflicts with ${m.length} static arguments`);let a=v-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,v)}return new l(...[...m,...C])}_setServiceInstance(l,m){if(this._services.get(l)instanceof R.SyncDescriptor)this._services.set(l,m);else if(this._parent)this._parent._setServiceInstance(l,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let m=this._services.get(l);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):m}_getOrCreateServiceInstance(l,m){let I=this._getServiceInstanceOrDescriptor(l);return I instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,I,m.branch(l,!0)):(m.branch(l,!1),I)}_safeCreateAndCacheServiceInstance(l,m,I){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,m,I)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,m,I){const E=new T.Graph(a=>a.id.toString());let C=0;const v=[{id:l,desc:m,_trace:I}];for(;v.length;){const a=v.pop();if(E.lookupOrInsertNode(a),C++>1e3)throw new b(E);for(let o of A._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${l} depends on ${o.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:o.id,desc:t,_trace:a._trace.branch(o.id,!0)};E.insertEdge(a,r),v.push(r)}}}for(;;){const a=E.roots();if(a.length===0){if(!E.isEmpty())throw new b(E);break}for(const{data:o}of a){if(this._getServiceInstanceOrDescriptor(o.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}E.removeNode(o)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,m,I=[],E,C){if(this._services.get(l)instanceof R.SyncDescriptor)return this._createServiceInstance(m,I,E,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,m,I,E,C);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(l,m=[],I,E){if(I){const C=new D.IdleValue(()=>this._createInstance(l,m,E));return new Proxy(Object.create(null),{get(v,a){if(a in v)return v[a];let o=C.value,t=o[a];return typeof t!="function"||(t=t.bind(o),v[a]=t),t},set(v,a,o){return C.value[a]=o,!0}})}else return this._createInstance(l,m,E)}}e.InstantiationService=n;var w;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(w||(w={}));class f{constructor(l,m){this.type=l,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return y?new f(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(l){return y?new f(0,l.name):f._None}branch(l,m){let I=new f(2,l.toString());return this._dep.push([l,m,I]),I}stop(){let l=Date.now()-this._start;f._totals+=l;let m=!1;function I(C,v){let a=[],o=new Array(C+1).join("	");for(const[t,r,i]of v._dep)if(r&&i){m=!0,a.push(`${o}CREATES -> ${t}`);let s=I(C+1,i);s&&a.push(s)}else a.push(`${o}uses -> ${t}`);return a.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(l>2||m)&&console.log(E.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(Z[159],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(Z[160],ee([0,1,36,52,147,7]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(d,l,m){const I=m.getChannel(d);return P(l)?new l.channelClientCtor(I):D.ProxyChannel.toService(I,l?.proxyOptions)}}function P(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let y=class extends A{constructor(d,l,m){super(d,l,m)}};y=he([Y(2,e.IMainProcessService)],y);function b(f,d,l){(0,R.registerSingleton)(f,new L.SyncDescriptor(y,[d,l],l?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let n=class extends A{constructor(d,l,m){super(d,l,m)}};n=he([Y(2,e.ISharedProcessService)],n);function w(f,d,l){(0,R.registerSingleton)(f,new L.SyncDescriptor(n,[d,l],l?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=w}),define(Z[57],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const T of R.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[161],ee([0,1,2,57]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=he([Y(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(Z[14],ee([0,1,37,3,2,4,7]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var y;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class b extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class n extends b{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(y.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(y.Error,this.format(i))}else this.log(y.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let s=t[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}r+=(i>0?" ":"")+s}return r}}e.AbstractMessageLogger=n;class w extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...r){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class f extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=f;class d extends b{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class l extends b{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class m extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=m;class I extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?y.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class E{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return y.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=E;function C(o){if(o.verbose)return y.Trace;if(typeof o.logLevel=="string"){const t=v(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function v(o){switch(o){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=v;function a(o){switch(o){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=a}),define(Z[162],ee([0,1,6,11,2,8,18,12,14]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends R.Disposable{constructor(w,f){super();this.environmentService=w,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,T.basename)(this.environmentService.logsPath),f=(0,T.dirname)(this.environmentService.logsPath),m=(await A.Promises.readdir(f)).filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter(E=>E!==w),I=m.slice(0,Math.max(0,m.length-9));I.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${I.join(", ")}'`),await Promise.all(I.map(E=>A.Promises.rm((0,T.join)(f,E)))))}catch(w){(0,L.onUnexpectedError)(w)}}};b=he([Y(0,P.IEnvironmentService),Y(1,y.ILogService)],b),e.LogsDataCleaner=b}),define(Z[163],ee([0,1,6,11,2,8,18,12,14]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class lt extends R.Disposable{constructor(w,f,d){super();this.backupWorkspacesPath=w,this.environmentService=f,this.logService=d,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const w=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),d=JSON.parse(w).emptyWorkspaceInfos.map(m=>m.backupFolder),l=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(l.map(async m=>{m.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&d.indexOf(m)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${m}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,m)))}))}catch(w){(0,L.onUnexpectedError)(w)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=he([Y(1,P.INativeEnvironmentService),Y(2,y.ILogService)],b),e.StorageDataCleaner=b}),define(Z[164],ee([0,1,6,11,2,4,15,58,5,30,18,12,27,31,13,14]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends R.Disposable{constructor(v,a,o,t){super();this.fileService=a,this.extensionGalleryService=o,this.logService=t,this.extensionsDownloadDir=y.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,a){await this.cleanUpPromise;const o=this.getName(v),t=(0,A.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(t)){const r=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(v,r,a);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(s){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(v){}async rename(v,a,o){try{await n.Promises.rename(v.fsPath,a.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${v} to ${a} with 'EPERM' error. Trying again...`),this.rename(v,a,o);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const a=[],o=[];for(const i of v.children){const s=this.parse(i.name);s&&o.push([s,i])}const t=(0,d.groupByExtension)(o,([i])=>i),r=[];for(const i of t)i.sort((s,u)=>P.rcompare(s[0].version,u[0].version)),a.push(...i.slice(1).map(s=>s[1].resource)),r.push(i[0][1]);r.sort((i,s)=>i.mtime-s.mtime),a.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await D.Promises.settled(a.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new d.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():(0,b.generateUuid)()}parse(v){const a=I.exec(v);return a&&a[1]&&a[2]?new d.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};E=he([Y(0,w.INativeEnvironmentService),Y(1,l.IFileService),Y(2,f.IExtensionGalleryService),Y(3,m.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[165],ee([0,1,41,6,37,3,2,17,8,18,12,14]),function(K,e,D,L,R,T,A,P,y,b,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends A.Disposable{constructor(l,m){super();this.environmentService=l,this.logService=m,this.processesLimiter=new L.Limiter(5)}async postUninstall(l){const m=this.parseScript(l,"uninstall");return m&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${I}`)))),b.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(l,m){const I=`vscode:${m}`;if(l.location.scheme===P.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[I]=="string"){const E=l.manifest.scripts[I].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${I} should be a node script`),null):{script:(0,y.join)(l.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(l,m,I,E,C){return new Promise((v,a)=>{const o=this.start(l,m,I,C);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?a(i):v(void 0)};o.on("error",i=>{r((0,R.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,s)=>{r(i?`post-${m} process exited with code ${i}`:void 0)}),E&&(t=setTimeout(()=>{t=null,o.kill(),a("timed out")},5e3))})}start(l,m,I,E){const C={silent:!0,execArgv:void 0},v=(0,D.fork)(l,[`--type=extension-post-${m}`,...I],C);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const a=T.Event.fromNodeEventEmitter(v.stdout,"data"),o=T.Event.fromNodeEventEmitter(v.stderr,"data");a(i=>this.logService.info(E.identifier.id,E.manifest.version,`post-${m}`,i)),o(i=>this.logService.error(E.identifier.id,E.manifest.version,`post-${m}`,i));const t=T.Event.any(T.Event.map(a,i=>({data:`%c${i}`,format:[""]})),T.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(E.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),v}getExtensionStoragePath(l){return(0,y.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};f=he([Y(0,n.IEnvironmentService),Y(1,w.ILogService)],f),e.ExtensionsLifecycle=f}),define(Z[166],ee([0,1,3,2,15,5,12,31,13,14]),function(K,e,D,L,R,T,A,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends L.Disposable{constructor(f,d,l,m){super();this.extensionsManagementService=f,this.logService=m,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(C=>this.onInstallExtension(C))),this._register(f.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(f.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const I=T.URI.file(l.extensionsPath),E=new R.ExtUri(C=>!d.hasCapability(C,1024));this._register(d.watch(I)),this._register(D.Event.filter(d.onDidChangeFilesRaw,C=>C.changes.some(v=>this.doesChangeAffects(v,I,E)))(()=>this.onDidChange()))}doesChangeAffects(f,d,l){return l.isEqual(l.dirname(f.resource),d)?l.isEqual(f.resource,l.joinPath(d,".obsolete"))?!0:!(f.type!==1&&f.type!==2||l.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const d of f)this.removeInstallingExtension(d.identifier),d.local&&this.addInstalledExtension(d.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(d=>!(0,P.areSameExtensions)(d,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(d=>!(0,P.areSameExtensions)(d,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),d=f.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,P.areSameExtensions)(I,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),l=this.installedExtensions.filter(m=>this.installingExtensions.some(I=>(0,P.areSameExtensions)(I,m))?!1:f.every(I=>!(0,P.areSameExtensions)(I.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=f.map(m=>m.identifier),(d.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:d,removed:l})}}};n=he([Y(1,y.IFileService),Y(2,A.INativeEnvironmentService),Y(3,b.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[167],ee([0,1,154,22,6,2,17,8,18,12,27,31,57,14]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let l=class extends T.Disposable{constructor(E,C,v){super();this.extensionManagementService=E,this.logService=v,this.cache=this._register(new m(C,v)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getLanguageIds(){const E=await this.cache.getLanguagePacks(),C=["en",...Object.keys(E)];return(0,L.distinct)(C)}async postInstallExtension(E){E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",E.identifier.id),await this.update())}async postUninstallExtension(E){const C=await this.cache.getLanguagePacks();Object.keys(C).some(v=>C[v]&&C[v].extensions.some(a=>(0,w.areSameExtensions)(a.extensionIdentifier,E.identifier)))&&(this.logService.info("Removing language packs from the extension",E.identifier.id),await this.update())}async update(){const[E,C]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(C);return!(0,L.equals)(Object.keys(E),Object.keys(v))}};l=he([Y(0,n.IExtensionManagementService),Y(1,b.INativeEnvironmentService),Y(2,d.ILogService)],l),e.LocalizationsService=l;let m=class extends T.Disposable{constructor(E,C){super();this.logService=C,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(E.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(E){return this.withLanguagePacks(C=>{Object.keys(C).forEach(v=>delete C[v]),this.createLanguagePacksFromExtensions(C,...E)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(E,...C){for(const v of C)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(E,v);Object.keys(E).forEach(v=>this.updateHash(E[v]))}createLanguagePacksFromExtension(E,C){const v=C.identifier,a=C.manifest.contributes&&C.manifest.contributes.localizations?C.manifest.contributes.localizations:[];for(const o of a)if(C.location.scheme===A.Schemas.file&&(0,f.isValidLocalization)(o)){let t=E[o.languageId];t||(t={hash:"",extensions:[],translations:{}},E[o.languageId]=t);let r=t.extensions.filter(i=>(0,w.areSameExtensions)(i.extensionIdentifier,v))[0];r?r.version=C.manifest.version:t.extensions.push({extensionIdentifier:v,version:C.manifest.version});for(const i of o.translations)t.translations[i.id]=(0,P.join)(C.location.fsPath,i.path)}}updateHash(E){if(E){const C=(0,D.createHash)("md5");for(const v of E.extensions)C.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);E.hash=C.digest("hex")}}withLanguagePacks(E=()=>null){return this.languagePacksFileLimiter.queue(()=>{let C=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch(a){return{}}}).then(v=>(C=E(v),v)).then(v=>{for(const o of Object.keys(v))v[o]||delete v[o];this.languagePacks=v,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),y.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>C,v=>this.logService.error(v))})}};m=he([Y(0,b.INativeEnvironmentService),Y(1,d.ILogService)],m)}),define(Z[79],ee([0,1,3,5,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,d){switch(d){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${d}`)}async call(f,d,l){switch(d){case"setLevel":return this.service.setLevel(l)}throw new Error(`Call not found: ${d}`)}}e.LogLevelChannel=T;class A{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){A.setLevel(this.channel,f)}static setLevel(f,d){return f.call("setLevel",d)}}e.LogLevelChannelClient=A;class P{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,d){throw new Error(`Event not found: ${d}`)}async call(f,d,l){switch(d){case"createLogger":this.createLogger(L.URI.revive(l[0]),l[1]);return;case"log":return this.log(L.URI.revive(l[0]),l[1]);case"consoleLog":return this.consoleLog(l[0],l[1])}throw new Error(`Call not found: ${d}`)}createLogger(f,d){this.loggers.set(f.toString(),this.loggerService.createLogger(f,d))}consoleLog(f,d){let l=console.log;switch(f){case R.LogLevel.Error:l=console.error;break;case R.LogLevel.Warning:l=console.warn;break;case R.LogLevel.Info:l=console.info;break}l.call(console,...d)}log(f,d){const l=this.loggers.get(f.toString());if(!l)throw new Error("Create the logger before logging");for(const[m,I]of d)switch(m){case R.LogLevel.Trace:l.trace(I);break;case R.LogLevel.Debug:l.debug(I);break;case R.LogLevel.Info:l.info(I);break;case R.LogLevel.Warning:l.warn(I);break;case R.LogLevel.Error:l.error(I);break;case R.LogLevel.Critical:l.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class y extends R.AbstractLoggerService{constructor(f,d,l){super(f,d);this.channel=l}createConsoleMainLogger(){return new R.AdapterLogger({log:(f,d)=>{this.channel.call("consoleLog",[f,d])}})}doCreateLogger(f,d,l){return new b(this.channel,f,d,l)}}e.LoggerChannelClient=y;class b extends R.AbstractMessageLogger{constructor(f,d,l,m){super(m?.always);this.channel=f,this.file=d,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.channel.call("createLogger",[d,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,d){const l=[[f,d]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(f){this.channel.call("log",[this.file,f])}}class n extends R.LogService{constructor(f,d){super(d);this.parent=f,this._register(f.onDidChangeLogLevel(l=>d.setLevel(l)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=n}),define(Z[59],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(Z[44],ee([0,1,17,4,35,15]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",K));A=K.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const y=K.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:y.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(Z[80],ee([0,1,25,11,123,13,44]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(w,f,d,l,m,I){let E;try{await y(w,f,d,l,m,I)}catch(C){E=C}finally{E&&m.errorTransformer&&(E=m.errorTransformer(E)),typeof E!="undefined"&&d.error(E),d.end()}}e.readFileIntoStream=P;async function y(w,f,d,l,m,I){b(I);const E=await w.open(f,{create:!1});try{b(I);let C=0,v=0,a=m&&typeof m.length=="number"?m.length:void 0,o=D.VSBuffer.alloc(Math.min(m.bufferSize,typeof a=="number"?a:m.bufferSize)),t=m&&typeof m.position=="number"?m.position:0,r=0;do v=await w.read(E,t,o.buffer,r,o.byteLength-r),t+=v,r+=v,C+=v,typeof a=="number"&&(a-=v),r===o.byteLength&&(await d.write(l(o)),o=D.VSBuffer.alloc(Math.min(m.bufferSize,typeof a=="number"?a:m.bufferSize)),r=0);while(v>0&&(typeof a!="number"||a>0)&&b(I)&&n(C,m));if(r>0){let i=r;typeof a=="number"&&(i=Math.min(r,a)),d.write(l(o.slice(0,i)))}}catch(C){throw(0,T.ensureFileSystemProviderError)(C)}finally{await w.close(E)}}function b(w){if(w.isCancellationRequested)throw(0,L.canceled)();return!0}function n(w,f){if(f?.limits){if(typeof f.limits.memory=="number"&&w>f.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null,A.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof f.limits.size=="number"&&w>f.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[168],ee([0,1,22,6,25,29,3,55,2,40,17,169,15,49,121,13,80,14]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class qe extends y.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new m.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,qe.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new m.FileChangesEvent(o,!0)))),this.watchedResources=b.TernarySearchTree.forUris(o=>{const t=this.getProvider(o.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(a,o){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:o});const t=new y.DisposableStore;return t.add(o.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(o)))),t.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:a}))),typeof o.onDidErrorOccur=="function"&&t.add(o.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:o}),this.provider.delete(a),(0,y.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){o.push(t)}}),!this.provider.has(a)&&await L.Promises.settled(o)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,o){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return P.Iterable.map(this.provider,([a,o])=>({scheme:a,capabilities:o.capabilities}))}async withProvider(a){if(!(0,f.isAbsolutePath)(a))throw new m.FileOperationError((0,l.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const o=this.provider.get(a.scheme);if(!o){const t=new Error;throw t.name="ENOPRO",t.message=(0,l.localize)(1,null,a.toString()),t}return o}async withReadProvider(a){const o=await this.withProvider(a);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o)||(0,m.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const o=await this.withProvider(a);if((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,o){try{return await this.doResolveFile(a,o)}catch(t){throw(0,m.toFileSystemProviderErrorCode)(t)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,l.localize)(2,null,this.resourceForError(a)),1):(0,m.ensureFileSystemProviderError)(t)}}async doResolveFile(a,o){const t=await this.withProvider(a),r=this.isPathCaseSensitive(t),i=o?.resolveTo,s=o?.resolveSingleChildDescendants,u=o?.resolveMetadata,c=await t.stat(a);let h;return this.toFileStat(t,a,c,void 0,!!u,(p,S)=>(h||(h=b.TernarySearchTree.forUris(()=>!r),h.set(a,!0),(0,D.isNonEmptyArray)(i)&&i.forEach(g=>h.set(g,!0))),Boolean(h.findSuperstr(p.resource)||h.get(p.resource))?!0:p.isDirectory&&s?S===1:!1))}async toFileStat(a,o,t,r,i,s){const{providerExtUri:u}=this.getExtUri(a),c={resource:o,name:u.basename(o),isFile:(t.type&m.FileType.File)!=0,isDirectory:(t.type&m.FileType.Directory)!=0,isSymbolicLink:(t.type&m.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&m.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,m.etag)({mtime:t.mtime,size:t.size})};if(c.isDirectory&&s(c,r)){try{const h=await a.readdir(o),p=await L.Promises.settled(h.map(async([S,g])=>{try{const k=u.joinPath(o,S),O=i?await a.stat(k):{type:g};return await this.toFileStat(a,k,O,h.length,i,s)}catch(k){return this.logService.trace(k),null}}));c.children=(0,D.coalesce)(p)}catch(h){this.logService.trace(h),c.children=[]}return c}return c}async resolveAll(a){return L.Promises.settled(a.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const o=await this.withProvider(a);try{return!!await o.stat(a)}catch(t){return!1}}async canCreateFile(a,o){try{await this.doValidateCreateFile(a,o)}catch(t){return t}return!0}async doValidateCreateFile(a,o){if(!o?.overwrite&&await this.exists(a))throw new m.FileOperationError((0,l.localize)(3,null,this.resourceForError(a)),3,o)}async createFile(a,o=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const r=await this.writeFile(a,o);return this._onDidRunOperation.fire(new m.FileOperationEvent(a,0,r)),r}async writeFile(a,o,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,a,t)||await this.mkdirp(r,i.dirname(a));let u;if((0,m.hasReadWriteCapability)(r)&&!(o instanceof R.VSBuffer))if((0,d.isReadableStream)(o)){const c=await(0,d.peekStream)(o,3);c.ended?u=R.VSBuffer.concat(c.buffer):u=c}else u=(0,d.peekReadable)(o,c=>R.VSBuffer.concat(c),3);else u=o;!(0,m.hasOpenReadWriteCloseCapability)(r)||(0,m.hasReadWriteCapability)(r)&&u instanceof R.VSBuffer?await this.doWriteUnbuffered(r,a,t,u):await this.doWriteBuffered(r,a,t,u instanceof R.VSBuffer?(0,R.bufferToReadable)(u):u)}catch(s){throw new m.FileOperationError((0,l.localize)(4,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,o,t){if(!!t?.unlock&&!(a.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(o)));let i;try{i=await a.stat(o)}catch(s){return}if((i.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,l.localize)(6,null,this.resourceForError(o)),0,t);if(this.throwIfFileIsReadonly(o,i),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==m.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,m.etag)({mtime:t.mtime,size:i.size}))throw new m.FileOperationError((0,l.localize)(7,null),3,t);return i}async readFile(a,o){const t=await this.withReadProvider(a);return o?.atomic?this.doReadFileAtomic(t,a,o):this.doReadFile(t,a,o)}async doReadFileAtomic(a,o,t){return new Promise((r,i)=>{this.writeQueue.queueFor(o,this.getExtUri(a).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(a,o,t);r(s)}catch(s){i(s)}})})}async doReadFile(a,o,t){const r=await this.doReadFileStream(a,o,{...t,preferUnbuffered:!0});return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(a,o){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,o)}async doReadFileStream(a,o,t){const r=new T.CancellationTokenSource,i=this.validateReadFile(o,t).then(u=>u,u=>{throw r.cancel(),u});let s;try{return typeof t?.etag=="string"&&t.etag!==m.ETAG_DISABLED&&await i,!((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasFileReadStreamCapability)(a))||(0,m.hasReadWriteCapability)(a)&&t?.preferUnbuffered?s=this.readFileUnbuffered(a,o,t):(0,m.hasFileReadStreamCapability)(a)?s=this.readFileStreamed(a,o,r.token,t):s=this.readFileBuffered(a,o,r.token,t),{...await i,value:s}}catch(u){s&&await(0,d.consumeStream)(s);const c=(0,l.localize)(8,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(u).toString());throw u instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(c,u.stat,t):new m.FileOperationError(c,(0,m.toFileOperationResult)(u),t)}}readFileStreamed(a,o,t,r=Object.create(null)){const i=a.readFileStream(o,r,t);return(0,d.transform)(i,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new m.FileOperationError((0,l.localize)(9,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),r)},s=>R.VSBuffer.concat(s))}readFileBuffered(a,o,t,r=Object.create(null)){const i=(0,R.newWriteableBufferStream)();return(0,I.readFileIntoStream)(a,o,i,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new m.FileOperationError((0,l.localize)(10,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(s).toString()),(0,m.toFileOperationResult)(s),r)},t),i}readFileUnbuffered(a,o,t){const r=(0,d.newWriteableStream)(i=>R.VSBuffer.concat(i));return(async()=>{try{let i=await a.readFile(o);typeof t?.position=="number"&&(i=i.slice(t.position)),typeof t?.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(o,i.byteLength,t),r.end(R.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(a,o){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new m.FileOperationError((0,l.localize)(11,null,this.resourceForError(a)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.ETAG_DISABLED&&o.etag===t.etag)throw new m.NotModifiedSinceFileOperationError((0,l.localize)(12,null),t,o);return this.validateReadFileLimits(a,t.size,o),t}validateReadFileLimits(a,o,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&o>t.limits.size&&(r=7),typeof r=="number")throw new m.FileOperationError((0,l.localize)(13,null,this.resourceForError(a)),r)}}async canMove(a,o,t){return this.doCanMoveCopy(a,o,"move",t)}async canCopy(a,o,t){return this.doCanMoveCopy(a,o,"copy",t)}async doCanMoveCopy(a,o,t,r){if(a.toString()!==o.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,a,s,o,t,r)}catch(i){return i}return!0}async move(a,o,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,a,i,o,"move",!!t),u=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(a,s==="move"?2:3,u)),u}async copy(a,o,t){const r=await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(r,a,i,o,"copy",!!t),u=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(a,s==="copy"?3:2,u)),u}async doMoveCopy(a,o,t,r,i,s){if(o.toString()===r.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(a,o,t,r,i,s);if(u&&!c&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(a===t&&(0,m.hasFileFolderCopyCapability)(a))await a.copy(o,r,{overwrite:s});else{const h=await this.resolve(o);h.isDirectory?await this.doCopyFolder(a,h,t,r):await this.doCopyFile(a,o,t,r)}return i}else return a===t?(await a.rename(o,r,{overwrite:s}),i):(await this.doMoveCopy(a,o,t,r,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(a,o,t,r){if((0,m.hasOpenReadWriteCloseCapability)(a)&&(0,m.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,o,t,r);if((0,m.hasOpenReadWriteCloseCapability)(a)&&(0,m.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,o,t,r);if((0,m.hasReadWriteCapability)(a)&&(0,m.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,o,t,r);if((0,m.hasReadWriteCapability)(a)&&(0,m.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,o,t,r)}async doCopyFolder(a,o,t,r){await t.mkdir(r),Array.isArray(o.children)&&await L.Promises.settled(o.children.map(async i=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(a,await this.resolve(i.resource),t,s):this.doCopyFile(a,i.resource,t,s)}))}async doValidateMoveCopy(a,o,t,r,i,s){let u=!1;if(a===t){const{providerExtUri:h,isPathCaseSensitive:p}=this.getExtUri(a);if(p||(u=h.isEqual(o,r)),u&&i==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(o),this.resourceForError(r)));if(!u&&h.isEqualOrParent(r,o))throw new Error((0,l.localize)(15,null,this.resourceForError(o),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!u){if(!s)throw new m.FileOperationError((0,l.localize)(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(a===t){const{providerExtUri:h}=this.getExtUri(a);if(h.isEqualOrParent(o,r))throw new Error((0,l.localize)(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:u}}getExtUri(a){const o=this.isPathCaseSensitive(a);return{providerExtUri:o?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(o,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(a,0,t)),t}async mkdirp(a,o){const t=[],{providerExtUri:r}=this.getExtUri(a);for(;!r.isEqual(o,r.dirname(o));)try{if(((await a.stat(o)).type&m.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(o)),o=r.dirname(o)}for(let i=t.length-1;i>=0;i--){o=r.joinPath(o,t[i]);try{await a.mkdir(o)}catch(s){if((0,m.toFileSystemProviderErrorCode)(s)!==m.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,o){try{await this.doValidateDelete(a,o)}catch(t){return t}return!0}async doValidateDelete(a,o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!o?.useTrash&&!(t.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(a)));let i;try{i=await t.stat(a)}catch(u){}if(i)this.throwIfFileIsReadonly(a,i);else throw new m.FileOperationError((0,l.localize)(20,null,this.resourceForError(a)),1);if(!!!o?.recursive){const u=await this.resolve(a);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(a)))}return t}async del(a,o){const t=await this.doValidateDelete(a,o),r=!!o?.useTrash,i=!!o?.recursive;await t.delete(a,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new m.FileOperationEvent(a,1))}onDidChangeFile(a,o){this._onDidChangeFilesRaw.fire({changes:a});let t,r;{for(const i of a)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new m.FileChangesEvent(t,!o))}if(r){const i=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&qe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,o={recursive:!1,excludes:[]}){const t=new y.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,y.toDisposable)(()=>i())),this.doWatch(a,o).then(s=>{r?(0,y.dispose)(s):i=()=>(0,y.dispose)(s)},s=>this.logService.error(s))}return o.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),t.add((0,y.toDisposable)(()=>{const r=this.watchedResources.get(a);typeof r=="number"&&(r<=1?this.watchedResources.delete(a):this.watchedResources.set(a,r-1))}))),t}async doWatch(a,o){const t=await this.withProvider(a),r=this.toWatchKey(t,a,o),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(a,o)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,y.toDisposable)(()=>{i.count--,i.count===0&&((0,y.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(a,o,t){const{providerExtUri:r}=this.getExtUri(a);return[r.getComparisonKey(o),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,y.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,o,t,r){return this.writeQueue.queueFor(o,this.getExtUri(a).providerExtUri).queue(async()=>{const i=await a.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,d.isReadableStream)(r)||(0,d.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(a,i,r):await this.doWriteReadableBufferedQueued(a,i,r)}catch(s){throw(0,m.ensureFileSystemProviderError)(s)}finally{await a.close(i)}})}async doWriteStreamBufferedQueued(a,o,t){let r=0,i;if((0,d.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,o,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(s,u)=>{(0,d.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(a,o,c,c.byteLength,r,0)}catch(h){return u(h)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>u(c),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,o,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(a,o,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(a,o,t,r,i,s){let u=0;for(;u<r;)u+=await a.write(o,i+u,t.buffer,s+u,r-u)}async doWriteUnbuffered(a,o,t,r){return this.writeQueue.queueFor(o,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,o,t,r))}async doWriteUnbufferedQueued(a,o,t,r){let i;r instanceof R.VSBuffer?i=r:(0,d.isReadableStream)(r)?i=await(0,R.streamToBuffer)(r):(0,d.isReadableBufferedStream)(r)?i=await(0,R.bufferedStreamToBuffer)(r):i=(0,R.readableToBuffer)(r),await a.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(a,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,o,t,r))}async doPipeBufferedQueued(a,o,t,r){let i,s;try{i=await a.open(o,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const u=R.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,h=0,p=0;do p=await a.read(i,c,u.buffer,h,u.byteLength-h),await this.doWriteBuffer(t,s,u,p,c,h),c+=p,h+=p,h===u.byteLength&&(h=0);while(p>0)}catch(u){throw(0,m.ensureFileSystemProviderError)(u)}finally{await L.Promises.settled([typeof i=="number"?a.close(i):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,o,t,r))}async doPipeUnbufferedQueued(a,o,t,r){return t.writeFile(r,await a.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,o,t,r))}async doPipeUnbufferedToBufferedQueued(a,o,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const s=await a.readFile(o);await this.doWriteBuffer(t,i,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,m.ensureFileSystemProviderError)(s)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(a,o,t,r){const i=await(0,R.streamToBuffer)(this.readFileBuffered(a,o,T.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(a,o){if(a.capabilities&2048)throw new m.FileOperationError((0,l.localize)(22,null,this.resourceForError(o)),6);return a}throwIfFileIsReadonly(a,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,l.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===n.Schemas.file?a.fsPath:a.toString(!0)}};C.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},C=he([Y(0,E.ILogService)],C),e.FileService=C}),define(Z[170],ee([0,1,22,6,25,3,39,2,8,4,15,49,18,124,13,80,157,143,144,77,146,14]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends P.Disposable{constructor(i,s){super();this.logService=i,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:s,symbolicLink:u}=await f.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(i){try{const s=await f.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async c=>{try{let h;c.isSymbolicLink()?h=(await this.stat((0,n.joinPath)(i,c.name))).type:h=this.toType(c),u.push([c.name,h])}catch(h){this.logService.trace(h)}})),u}catch(s){throw this.toFileSystemProviderError(s)}}toType(i,s){let u;return s?.dangling?u=l.FileType.Unknown:i.isFile()?u=l.FileType.File:i.isDirectory()?u=l.FileType.Directory:u=l.FileType.Unknown,s&&(u|=l.FileType.SymbolicLink),u}async readFile(i){try{const s=this.toFilePath(i);return await f.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(i,s,u){const c=(0,w.newWriteableStream)(h=>R.VSBuffer.concat(h.map(p=>R.VSBuffer.wrap(p))).buffer);return(0,m.readFileIntoStream)(this,i,c,h=>h.buffer,{...s,bufferSize:this.BUFFER_SIZE},u),c}async writeFile(i,s,u){let c;try{const h=this.toFilePath(i);if(!u.create||!u.overwrite){if(await f.Promises.exists(h)){if(!u.overwrite)throw(0,l.createFileSystemProviderError)((0,d.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,l.createFileSystemProviderError)((0,d.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:u.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(i,h)}finally{typeof c=="number"&&await this.close(c)}}async open(i,s){try{const u=this.toFilePath(i);if((0,l.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:p}=await f.SymlinkSupport.stat(u);p.mode&128||await f.Promises.chmod(u,p.mode|128)}catch(p){this.logService.trace(p)}let c;if((0,l.isFileOpenForWriteOptions)(s)){if(b.isWindows)try{await f.Promises.truncate(u,0),c="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}c||(c="w")}else c="r";const h=await f.Promises.open(u,c);return this.mapHandleToPos.set(h,0),(0,l.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(h,i),h}catch(u){throw(0,l.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await f.Promises.fdatasync(i)}catch(s){this.canFlush=!1,this.logService.error(s)}return await f.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}}async read(i,s,u,c,h){const p=this.normalizePos(i,s);let S=null;try{const g=await f.Promises.read(i,u,c,h,p);return typeof g=="number"?S=g:S=g.bytesRead,S}catch(g){throw this.toFileSystemProviderError(g)}finally{this.updatePos(i,p,S)}}normalizePos(i,s){return s===this.mapHandleToPos.get(i)?null:s}updatePos(i,s,u){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof s=="number"||(typeof u=="number"?this.mapHandleToPos.set(i,c+u):this.mapHandleToPos.delete(i)))}async write(i,s,u,c,h){return(0,L.retry)(()=>this.doWrite(i,s,u,c,h),100,3)}async doWrite(i,s,u,c,h){const p=this.normalizePos(i,s);let S=null;try{const g=await f.Promises.write(i,u,c,h,p);return typeof g=="number"?S=g:S=g.bytesWritten,S}catch(g){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),g)}finally{this.updatePos(i,p,S)}}async mkdir(i){try{await f.Promises.mkdir(this.toFilePath(i))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(i,s){try{const u=this.toFilePath(i);await this.doDelete(u,s)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(i,s){s.recursive?await f.Promises.rm(i,f.RimRafMode.MOVE):await f.Promises.unlink(i)}async rename(i,s,u){const c=this.toFilePath(i),h=this.toFilePath(s);if(c!==h)try{await this.validateTargetDeleted(i,s,"move",u.overwrite),await f.Promises.move(c,h)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,d.localize)(2,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(h)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(i,s,u){const c=this.toFilePath(i),h=this.toFilePath(s);if(c!==h)try{await this.validateTargetDeleted(i,s,"copy",u.overwrite),await f.Promises.copy(c,h,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,d.localize)(3,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(h)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(i,s,u,c){const h=this.toFilePath(i),p=this.toFilePath(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,A.isEqual)(h,p,!0)),S&&u==="copy")throw(0,l.createFileSystemProviderError)((0,d.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!S&&await f.Promises.exists(p)){if(!c)throw(0,l.createFileSystemProviderError)((0,d.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(i,s){return s.recursive?this.watchRecursive(i,s.excludes):this.watchNonRecursive(i)}watchRecursive(i,s){const u={path:this.toFilePath(i),excludes:s},c=(0,D.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof E.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,s;this.options?.watcher?.usePolling?(i=C.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?b.isWindows?i=a.FileWatcher:i=C.FileWatcher:i=E.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,v.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===o.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)}))}}watchNonRecursive(i){const s=new I.FileWatcher(this.toFilePath(i),c=>this._onDidChangeFile.fire((0,v.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===o.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)});return(0,P.combinedDisposable)(s,u)}toFilePath(i){return(0,y.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof l.FileSystemProviderError)return i;let s;switch(i.code){case"ENOENT":s=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=l.FileSystemProviderErrorCode.NoPermissions;break;default:s=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(i,s)}async toFileSystemProviderWriteError(i,s){let u=this.toFileSystemProviderError(s);if(i&&u.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(u=(0,l.createFileSystemProviderError)(s,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return u}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[28],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(Z[171],ee([0,1,6,11,2,8,18,14,28]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends R.Disposable{constructor(w,f,d){super();this.productService=f,this.logService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},30*1e3)).schedule()}async cleanUpCodeCaches(w){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),d=(0,T.dirname)(w),l=(0,T.basename)(w),m=await A.Promises.readdir(d);await Promise.all(m.map(async I=>{if(I===l)return;const E=(0,T.join)(d,I),C=await A.Promises.stat(E);if(C.isDirectory()&&f-C.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${I}.`),A.Promises.rm(E)}))}catch(f){(0,L.onUnexpectedError)(f)}}};b=he([Y(1,y.IProductService),Y(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(Z[172],ee([0,1,6,11,2,8,18,12,14,28]),function(K,e,D,L,R,T,A,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends R.Disposable{constructor(f,d,l){super();this.environmentService=f,this.logService=d,this.productService=l,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),d=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let C of Object.keys(d)){const v=d[C];f[`${v.hash}.${C}`]=!0}const l=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(l))return;const I=await A.Promises.readdir(l);for(const C of I){if(f[C]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${C}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${C}`),await A.Promises.rm((0,T.join)(l,C))}const E=Date.now();for(const C of Object.keys(f)){const v=(0,T.join)(l,C),a=await A.Promises.readdir(v);for(const o of a){if(o==="tcf.json")continue;const t=(0,T.join)(v,o),r=await A.Promises.stat(t);r.isDirectory()&&E-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(C,o)}`),await A.Promises.rm(t))}}}catch(f){(0,L.onUnexpectedError)(f)}}};n=he([Y(0,P.INativeEnvironmentService),Y(1,y.ILogService),Y(2,b.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[32],ee([0,1,90,16]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(A,P){D.ok(L.isString(A)),D.ok(L.isObject(P)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new R}),define(Z[81],ee([0,1,3,32]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,b){this.schemasById[R(y)]=b,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;L.Registry.add(e.Extensions.JSONContribution,A)}),define(Z[38],ee([0,1,3,16,111,81,32]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const b=A.Registry.as(T.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,v=!0){this.registerConfigurations([C],v)}registerConfigurations(C,v=!0){const a=[];C.forEach(o=>{a.push(...this.validateAndRegisterProperties(o,v,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(C){const v=[],a=o=>{if(o.properties)for(const t in o.properties)v.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,o.properties[t]);o.allOf&&o.allOf.forEach(t=>a(t))};for(const o of C){a(o);const t=this.configurationContributors.indexOf(o);t!==-1&&this.configurationContributors.splice(t,1)}b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(C){const v=[],a=[];for(const o of C)for(const t in o)if(v.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...o[t]};const r={type:"object",default:this.defaultValues[t],description:R.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};a.push(f(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=o[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(C){const v=[];for(const a of C)for(const o in a)if(v.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const v of C)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,v=!0,a,o=3){o=L.isUndefinedOrNull(C.scope)?o:C.scope;let t=[],r=C.properties;if(r)for(let s in r){if(v&&m(s)){delete r[s];continue}const u=r[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=L.isUndefinedOrNull(u.scope)?o:u.scope,u.restricted=L.isUndefinedOrNull(u.restricted)?!!a?.restrictedConfigurations?.includes(s):u.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let i=C.allOf;if(i)for(let s of i)t.push(...this.validateAndRegisterProperties(s,v,a,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const v=a=>{let o=a.properties;if(o)for(const r in o)this.updateSchema(r,o[r]);let t=a.allOf;t&&t.forEach(v)};v(C)}updateSchema(C,v){switch(e.allSettings.properties[C]=v,v.scope){case 1:e.applicationSettings.properties[C]=v;break;case 2:e.machineSettings.properties[C]=v;break;case 6:e.machineOverridableSettings.properties[C]=v;break;case 3:e.windowSettings.properties[C]=v;break;case 4:e.resourceSettings.properties[C]=v;break;case 5:e.resourceSettings.properties[C]=v,this.resourceLanguageSettingsSchema.properties[C]=v;break}}removeFromSchema(C,v){switch(delete e.allSettings.properties[C],v.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const v=`[${C}]`,a={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,a),e.allSettings.properties[v]=a,e.applicationSettings.properties[v]=a,e.machineSettings.properties[v]=a,e.machineOverridableSettings.properties[v]=a,e.windowSettings.properties[v]=a,e.resourceSettings.properties[v]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,v){let a=this.defaultValues[C];L.isUndefined(a)&&(a=v.default),L.isUndefined(a)&&(a=d(v.type)),v.default=a}}const w="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(w);function f(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=f;function d(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const l=new n;A.Registry.add(e.Extensions.Configuration,l);function m(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?R.localize(5,null,E):l.getConfigurationProperties()[E]!==void 0?R.localize(6,null,E):null:R.localize(4,null)}e.validateProperty=m;function I(){const E=[],C=l.getConfigurationProperties();for(const v of Object.keys(C))E.push([v,C[v].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=I}),define(Z[24],ee([0,1,26,16,5,38,7,32]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=y;var b;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function w(r,i){const s=i?r?i.keys.filter(k=>r.keys.indexOf(k)===-1):[...i.keys]:[],u=r?i?r.keys.filter(k=>i.keys.indexOf(k)===-1):[...r.keys]:[],c=[];if(i&&r){for(const k of r.keys)if(i.keys.indexOf(k)!==-1){const O=E(r.contents,k),x=E(i.contents,k);D.equals(O,x)||c.push(k)}}const h=[],p=k=>{const O={};for(const x of k)for(const z of x.identifiers)O[o(z)]=x;return O},S=i?p(i.overrides):{},g=r?p(r.overrides):{};if(Object.keys(S).length)for(const k of s){const O=S[k];O&&h.push([(0,T.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(g).length)for(const k of u){const O=g[k];O&&h.push([(0,T.overrideIdentifierFromKey)(k),O.keys])}if(Object.keys(S).length&&Object.keys(g).length)for(const k of c){const O=g[k],x=S[k];if(O&&x){const z=w({contents:O.contents,keys:O.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});h.push([(0,T.overrideIdentifierFromKey)(k),[...z.added,...z.removed,...z.updated]])}}return{added:s,removed:u,updated:c,overrides:h}}e.compare=w;function f(r,i){const s=[];for(const u of Object.keys(r))if(T.OVERRIDE_PROPERTY_PATTERN.test(u)){const c={};for(const h in r[u])c[h]=r[u][h];s.push({identifiers:[(0,T.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(c),contents:d(c,i)})}return s}e.toOverrides=f;function d(r,i){const s=Object.create(null);for(let u in r)l(s,u,r[u],i);return s}e.toValuesTree=d;function l(r,i,s,u){const c=i.split("."),h=c.pop();let p=r;for(let S=0;S<c.length;S++){let g=c[S],k=p[g];switch(typeof k){case"undefined":k=p[g]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${c.slice(0,S+1).join(".")} is ${JSON.stringify(k)}`);return}p=k}if(typeof p=="object"&&p!==null)try{p[h]=s}catch(S){u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(p)}`)}else u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(p)}`)}e.addToValueTree=l;function m(r,i){const s=i.split(".");I(r,s)}e.removeFromValueTree=m;function I(r,i){const s=i.shift();if(i.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const u=r[s];typeof u=="object"&&!Array.isArray(u)&&(I(u,i),Object.keys(u).length===0&&delete r[s])}}function E(r,i,s){function u(p,S){let g=p;for(const k of S){if(typeof g!="object"||g===null)return;g=g[k]}return g}const c=i.split("."),h=u(r,c);return typeof h=="undefined"?s:h}e.getConfigurationValue=E;function C(r,i,s){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(i[u])?C(r[u],i[u],s):s&&(r[u]=i[u]):r[u]=i[u])})}e.merge=C;function v(){const r=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=v;function a(){const r=Object.create(null),i=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let s in i){let u=i[s].default;l(r,s,u,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=a;function o(r){return`[${r}]`}e.keyFromOverrideIdentifier=o;function t(r,i,s){const u=r.inspect(i),c=r.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[173],ee([0,1,22,3,33,2,40,26,16,5,24,38,32]),function(K,e,D,L,R,T,A,P,y,b,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,n.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[s],c=r[s];c&&(typeof u=="object"&&typeof c=="object"?(u=P.deepClone(u),this.mergeContents(u,c)):u=c),i[s]=u}return new d(i,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),i=P.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const c of u.overrides){const[h]=i.filter(p=>D.equals(p.identifiers,c.identifiers));h?this.mergeContents(h.contents,c.contents):i.push(P.deepClone(c))}for(const c of u.keys)s.indexOf(c)===-1&&s.push(c)}return new d(r,s,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&y.isObject(t[i])&&y.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=P.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,n.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=d;class l extends d{constructor(){const t=(0,n.getDefaultValues)(),r=(0,n.getConfigurationKeys)(),i=[];for(const s of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(s)&&i.push({identifiers:[(0,w.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,n.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,i)}}e.DefaultConfigurationModel=l;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!y.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:s,overrides:u,restricted:c}=this.doParseRaw(t,r);this._configurationModel=new d(i,s,u),this._restrictedConfigurations=c||[]}doParseContent(t){let r={},i=null,s=[],u=[],c=[];function h(S){Array.isArray(s)?s.push(S):i!==null&&(s[i]=S)}let p={onObjectBegin:()=>{let S={};h(S),u.push(s),s=S,i=null},onObjectProperty:S=>{i=S},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let S=[];h(S),u.push(s),s=S,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:h,onError:(S,g,k)=>{c.push({error:S,offset:g,length:k})}};if(t)try{R.visit(t,p),r=s[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(t,r){const i=f.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,i,!0,r);t=s.raw;const u=(0,n.toValuesTree)(t,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),c=Object.keys(t),h=(0,n.toOverrides)(t,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:u,keys:c,overrides:h,restricted:s.restricted}}filter(t,r,i,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const u={},c=[];for(let h in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(h)&&i){const p=this.filter(t[h],r,!1,s);u[h]=p.raw,c.push(...p.restricted)}else{const p=r[h],S=p?typeof p.scope!="undefined"?p.scope:3:void 0;p?.restricted&&c.push(h),(S===void 0||s.scopes===void 0||s.scopes.includes(S))&&(s.skipRestricted&&p?.restricted||(u[h]=t[h]))}return{raw:u,restricted:c}}}e.ConfigurationModelParser=m;class I extends T.Disposable{constructor(t,r,i,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class E{constructor(t,r,i=new d,s=new d,u=new A.ResourceMap,c=new d,h=new A.ResourceMap,p=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=c,this._memoryConfigurationByResource=h,this._freeze=p,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let s;i.resource?(s=this._memoryConfigurationByResource.get(i.resource),s||(s=new d,this._memoryConfigurationByResource.set(i.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const s=this.getConsolidateConfigurationModel(r,i),u=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,h=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),p=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,x=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),z=s.getValue(t),H=D.distinct(D.flatten(s.overrides.map(B=>B.identifiers))).filter(B=>s.getOverrideValue(t,B)!==void 0);return{defaultValue:h,userValue:p,userLocalValue:S,userRemoteValue:g,workspaceValue:k,workspaceFolderValue:O,memoryValue:x,value:z,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:p!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(s=>w.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,w.overrideIdentifierFromKey)(s),c=this._defaultConfiguration.getKeysForOverrideIdentifier(u),h=t.getKeysForOverrideIdentifier(u),p=[...h.filter(S=>c.indexOf(S)===-1),...c.filter(S=>h.indexOf(S)===-1),...c.filter(S=>!P.equals(this._defaultConfiguration.override(u).getValue(S),t.override(u).getValue(S)))];return[u,p]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,n.compare)(this.localUserConfiguration,t),c=[...r,...i,...s];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,n.compare)(this.remoteUserConfiguration,t);let c=[...r,...i,...s];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:s,overrides:u}=(0,n.compare)(this.workspaceConfiguration,t);let c=[...r,...i,...s];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:s,updated:u,removed:c,overrides:h}=(0,n.compare)(i,r);let p=[...s,...u,...c];return(p.length||!i)&&this.updateFolderConfiguration(t,r),{keys:p,overrides:h}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:s,removed:u,overrides:c}=(0,n.compare)(r,void 0);return{keys:[...i,...s,...u],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(i=this.getFolderConsolidatedConfiguration(s.uri)||i);const u=this._memoryConfigurationByResource.get(t);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=i.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:s,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((c,h)=>(c.set(b.URI.revive(h[0]),this.parseConfigurationModel(h[1])),c),new A.ResourceMap);return new E(r,i,new d,s,u,new d,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function C(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,r=new Map;for(const s of o)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,c])=>{const h=(0,A.getOrSet)(r,u,new Set);c.forEach(p=>h.add(p))});const i=[];return r.forEach((s,u)=>i.push([u,[...s.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=C;class v{constructor(t,r,i,s){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(h=>u.add(h)),t.overrides.forEach(([,h])=>h.forEach(p=>u.add(p))),this.affectedKeys=[...u.values()];const c=new d;this.affectedKeys.forEach(h=>c.setValue(h,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(i,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,n.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof i=="object"&&(s=Object.keys(i)[0]);){if(t=t[s],!t)return!1;i=i[s]}return!0}}e.ConfigurationChangeEvent=v;class a extends v{constructor(t,r,i,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=a}),define(Z[174],ee([0,1,6,3,2,15,24,173,38,32]),function(K,e,D,L,R,T,A,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends R.Disposable{constructor(f,d){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,d)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,d){const l=typeof f=="string"?f:void 0,m=(0,A.isConfigurationOverrides)(f)?f:(0,A.isConfigurationOverrides)(d)?d:{};return this.configuration.getValue(l,m,void 0)}updateValue(f,d,l,m){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const d=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(l,d,1)}onDidDefaultConfigurationChange(f){const d=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,f);this.trigger(l,d,6)}trigger(f,d,l){const m=new P.ConfigurationChangeEvent(f,{data:d},this.configuration);m.source=l,m.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[175],ee([0,1,105,24,14]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,y){this.configurationService=P,this.logService=y}request(P,y){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,y)}async resolveProxy(P){}};T=he([Y(0,L.IConfigurationService),Y(1,R.ILogService)],T),e.RequestService=T}),define(Z[42],ee([0,1,25,125,38,7,32]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}e.isSuccess=P;function y(l){return l.res.statusCode===204}async function b(l){if(!P(l))throw new Error("Server returned "+l.res.statusCode);return y(l)?null:(await(0,D.streamToBuffer)(l.stream)).toString()}e.asText=b;async function n(l){if(!P(l))throw new Error("Server returned "+l.res.statusCode);if(y(l))return null;const I=(await(0,D.streamToBuffer)(l.stream)).toString();try{return JSON.parse(I)}catch(E){throw E.message+=`:
`+I,E}}e.asJson=n;function w(l){d(l)}e.updateProxyConfigurationsScope=w;let f;function d(l){const m=A.Registry.as(R.Extensions.Configuration);f&&m.deregisterConfigurations([f]),f={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},m.registerConfiguration(f)}d(2)}),define(Z[176],ee([0,1,29,17,13,42]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(y,b){this.requestService=y,this.fileService=b}async download(y,b,n=D.CancellationToken.None){if(y.scheme===L.Schemas.file||y.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(y,b);return}const w={type:"GET",url:y.toString()},f=await this.requestService.request(w,n);if(f.res.statusCode===200)await this.fileService.writeFile(b,f.stream);else{const d=await(0,T.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${d}`)}}};A=he([Y(0,T.IRequestService),Y(1,R.IFileService)],A),e.DownloadService=A}),define(Z[177],ee([0,1,22,29,63,2,15,139,13,14,28,42]),function(K,e,D,L,R,T,A,P,y,b,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends T.Disposable{constructor(l,m,I,E){super();this.fileService=l,this.productService=m,this.requestService=I,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:C})=>this.allConfigBasedTips.set(C.configPath,C))}getConfigBasedTips(l){return this.getValidConfigBasedTips(l)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(l){const m=[];for(const[I,E]of this.allConfigBasedTips)try{const C=await this.fileService.readFile((0,A.joinPath)(l,I)),v=new Map;(0,R.forEach)(E.recommendations,({key:o,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const r of t.remotes)v.set(r,{extensionId:o,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else m.push({extensionId:o,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const a=(0,P.getDomainsOfRemotes)(C.value.toString(),[...v.keys()]);for(const o of a){const t=v.get(o);t&&m.push(t)}}catch(C){}return m}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const l=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(l.res.statusCode!==200)return[];const m=await(0,w.asJson)(l);return m?m.workspaceRecommendations||[]:[]}catch(l){return this.logService.error(l),[]}}};f=he([Y(0,y.IFileService),Y(1,n.IProductService),Y(2,w.IRequestService),Y(3,b.ILogService)],f),e.ExtensionTipsService=f}),define(Z[45],ee([0,1,25,30]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,A,P){let y=P&&P.get("storage.serviceMachineId",0)||null;if(y)return y;try{const n=(await A.readFile(T.serviceMachineIdResource)).value.toString();y=(0,L.isUUID)(n)?n:null}catch(b){y=null}if(!y){y=(0,L.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(y))}catch(b){}}return P&&P.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=R}),define(Z[19],ee([0,1,6,3,2,16,70,7]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var b;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var w;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));class f extends R.Disposable{constructor(I={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,E){E===y?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:E,target:this.getKeyTargets(I)[E]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,E,C){return this.getStorage(E)?.get(I,C)}getBoolean(I,E,C){return this.getStorage(E)?.getBoolean(I,C)}getNumber(I,E,C){return this.getStorage(E)?.getNumber(I,C)}store(I,E,C,v){if((0,T.isUndefinedOrNull)(E)){this.remove(I,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,C,v),this.getStorage(C)?.set(I,E)})}remove(I,E){this.withPausedEmitters(()=>{this.updateKeyTarget(I,E,void 0),this.getStorage(E)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,E){const C=[],v=this.getKeyTargets(I);for(const a of Object.keys(v))v[a]===E&&C.push(a);return C}updateKeyTarget(I,E,C){const v=this.getKeyTargets(E);typeof C=="number"?v[I]!==C&&(v[I]=C,this.getStorage(E)?.set(y,JSON.stringify(v))):typeof v[I]=="number"&&(delete v[I],this.getStorage(E)?.set(y,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const E=this.get(y,I);if(E)try{return JSON.parse(E)}catch(C){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=b.NONE){this._onWillSaveState.fire({reason:I}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return l(I,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends f{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=d;async function l(m,I,E,C){const v=u=>{try{return JSON.parse(u)}catch(c){return u}},a=new Map,o=new Map;m.forEach((u,c)=>{a.set(c,u),o.set(c,v(u))});const t=new Map,r=new Map;I.forEach((u,c)=>{t.set(c,u),r.set(c,v(u))}),console.group(`Storage: Global (path: ${E})`);let i=[];a.forEach((u,c)=>{i.push({key:c,value:u})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${C})`);let s=[];t.forEach((u,c)=>{s.push({key:c,value:u})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=l}),define(Z[178],ee([0,1,3,2,16,27,31,19]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let y=class extends L.Disposable{constructor(w){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(w)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"})))}async enableExtension(w,f){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:f}),!0):!1}async disableExtension(w,f){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){let f=this.getDisabledExtensions();return f.every(d=>!(0,A.areSameExtensions)(d,w))?(f.push(w),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(w){let f=this.getDisabledExtensions();for(let d=0;d<f.length;d++){const l=f[d];if((0,A.areSameExtensions)(l,w))return f.splice(d,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(w){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,f){this.storageManger.set(w,f,0)}};y=he([Y(0,P.IStorageService)],y),e.GlobalExtensionEnablementService=y;class b extends L.Disposable{constructor(w){super();this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(w,f){let d;return f===0?((0,R.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,f)),d=this.storage[w]):d=this._get(w,f),JSON.parse(d)}set(w,f,d){let l=JSON.stringify(f.map(({id:I,uuid:E})=>({id:I,uuid:E})));this._get(w,d)!==l&&(d===0&&(f.length?this.storage[w]=l:delete this.storage[w]),this._set(w,f.length?l:void 0,d))}onDidStorageChange(w){if(w.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const d=this.get(w.key,w.scope);delete this.storage[w.key];const l=this.get(w.key,w.scope),m=d.filter(E=>!l.some(C=>(0,A.areSameExtensions)(E,C))),I=l.filter(E=>!d.some(C=>(0,A.areSameExtensions)(C,E)));(m.length||I.length)&&this._onDidChange.fire([...m,...I])}}_get(w,f){return this.storageService.get(w,f,"[]")}_set(w,f,d){f?this.storageService.store(w,f,d,1):this.storageService.remove(w,d)}}e.StorageManager=b}),define(Z[179],ee([0,1,3,2]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(b,n){super();this.channel=b,this.workspace=n}async getItems(){const b={workspace:this.workspace},n=await this.channel.call("getItems",b);return new Map(n)}updateItems(b){const n={workspace:this.workspace};return b.insert&&(n.insert=Array.from(b.insert.entries())),b.delete&&(n.delete=Array.from(b.delete.values())),this.channel.call("updateItems",n)}}class T extends R{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class A extends R{constructor(b,n){super(b,n);this.onDidChangeItemsExternal=D.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class P extends L.Disposable{constructor(b,n){super();this.channel=b,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[180],ee([0,1,6,2,169,15,70,19,179]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends P.AbstractStorageService{constructor(w,f,d){super();this.mainProcessService=f,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(w)}createGlobalStorage(){const w=new y.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),f=new A.Storage(w.globalStorage);return this._register(f.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),f}createWorkspaceStorage(w){const f=new y.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),w);if(f.workspaceStorage){const d=new A.Storage(f.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(l=>this.emitDidChangeValue(1,l)),this.workspaceStorageId=w?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(w){const f=this.workspaceStorage,d=f?.items??new Map;f&&(await f.close(),f.dispose()),this.workspaceStorage=this.createWorkspaceStorage(w),await this.workspaceStorage.init();for(const[l,m]of d)this.workspaceStorage.set(l,m)}}e.NativeStorageService=b}),define(Z[181],ee([0,1,4,35,5,30]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,n,w,f,d,l,m,I,E,C){const v=Object.create(null);v["common.machineId"]=m,v.sessionID=(0,T.generateUuid)()+Date.now(),v.commitHash=d,v.version=l,v["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,D.PlatformToString)(D.platform),v["common.nodePlatform"]=L.platform,v["common.nodeArch"]=f,v["common.product"]=C||"desktop";const a=y(I||[]);a&&(v["common.msftInternal"]=a);let o=0;const t=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),D.isLinuxSnap&&(v["common.snap"]="true");const r=A(w);r&&(v["common.platformDetail"]=r);try{const i=await b.readFile(R.URI.file(E));v["common.source"]=i.value.toString().slice(0,30)}catch(i){}return v}e.resolveCommonProperties=P;function y(b){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const w=n.toLowerCase();return b.some(f=>w===f)}e.verifyMicrosoftInternalDomain=y}),define(Z[20],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[182],ee([0,1,34,55,33,17,8,4,5,98,18,100,73,13,28,20]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(o,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,s=new Map,u=2e4;function c(S,g,k,O){const x=g.substring(S.length+1);return new Promise(async z=>{let H;try{H=await n.Promises.readdir(g,{withFileTypes:!0})}catch($){z();return}if(O.count>=u){O.count+=H.length,O.maxReached=!0,z();return}let B=H.length;if(B===0){z();return}let U=H;O.count+H.length>u&&(O.maxReached=!0,B=u-O.count,U=H.slice(0,B)),O.count+=H.length;for(const $ of U)if($.isDirectory()){if(k.includes($.name)||await c(S,(0,A.join)(g,$.name),k,O),--B==0){z();return}}else{const M=$.name.lastIndexOf(".");if(M>=0){const N=$.name.substring(M+1);N&&i.set(N,(i.get(N)??0)+1)}for(const N of r)N.relativePathPattern?.test(x)!==!1&&N.filePattern.test($.name)&&s.set(N.tag,(s.get(N.tag)??0)+1);if(--B==0){z();return}}})}const h={count:0,maxReached:!1};await c(o,o,t,h);const p=await v(o);return{configFiles:E(s),fileTypes:E(i),fileCount:h.count,maxFilesReached:h.maxReached,launchConfigFiles:p}}e.collectWorkspaceStats=I;function E(o){return[...L.Iterable.map(o.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function C(){const o={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=C;async function v(o){try{const t=new Map,r=(0,A.join)(o,".vscode","launch.json"),i=await n.Promises.readFile(r),s=[],u=(0,R.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(u)==="object"&&u.configurations)for(const c of u.configurations){const h=c.type;h&&(t.has(h)?t.set(h,t.get(h)+1):t.set(h,1))}return E(t)}catch(t){return[]}}e.collectLaunchConfigs=v;let a=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||r.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,w.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[s,u]=i,c=this.formatProcessList(t,s);return r.forEach(h=>{if((0,f.isRemoteDiagnosticError)(h))c+=`
${h.errorMessage}`,u+=`
${h.errorMessage}`;else if(c+=`

Remote: ${h.hostName}`,h.processes&&(c+=`
${this.formatProcessList(t,h.processes)}`),h.workspaceMetadata){u+=`
|  Remote: ${h.hostName}`;for(const p of Object.keys(h.workspaceMetadata)){const S=h.workspaceMetadata[p];let g=`${S.fileCount} files`;S.maxFilesReached&&(g=`more than ${g}`),u+=`|    Folder (${p}): ${g}`,u+=this.formatWorkspaceStats(S)}}}),{processInfo:c,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:i,vmHint:s,os:u,cpus:c}=C(),h={os:u,memory:i,cpus:c,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return P.isWindows||(h.load=`${D.loadavg().map(p=>Math.round(p)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(t,r){const i=[];return(0,w.listProcesses)(t.mainPID).then(async s=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,s)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if((0,f.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const c of Object.keys(u.workspaceMetadata)){const h=u.workspaceMetadata[c];let p=`${h.fileCount} files`;h.maxFilesReached&&(p=`more than ${p}`),i.push(`Folder (${c}): ${p}`),i.push(this.formatWorkspaceStats(h))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let s=0;const u=(S,g)=>{const k=` ${S}(${g})`;s+k.length>i?(r.push(c),c="|                 ",s=c.length):s+=k.length,c+=k};let c="|      File types:";const h=10;let p=t.fileTypes.length>h?h:t.fileTypes.length;for(let S=0;S<p;S++){const g=t.fileTypes[S];u(g.name,g.count)}if(r.push(c),t.configFiles.length>=0&&(c="|      Conf files:",s=0,t.configFiles.forEach(S=>{u(S.name,S.count)}),r.push(c)),t.launchConfigFiles.length>0){let S="|      Launch Configs:";t.launchConfigFiles.forEach(g=>{S+=g.count>1?` ${g.name}(${g.count})`:` ${g.name}`}),r.push(S)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const c=y.URI.revive(u);if(c.scheme===T.Schemas.file){const h=c.fsPath;i.push(I(h,["node_modules",".git"]).then(p=>{let S=`${p.fileCount} files`;p.maxFilesReached&&(S=`more than ${S}`),r.push(`|    Folder (${(0,A.basename)(h)}): ${S}`),r.push(this.formatWorkspaceStats(p))}).catch(p=>{r.push(`|      Error: Unable to collect workspace stats for folder ${h} (${p.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(u=>i.set(u.pid,u.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,s,r,0),s.join(`
`)}formatProcessItem(t,r,i,s,u){const c=u===0;let h;c?h=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(u)} ${s.name}`,s.name==="window"&&(h=`${h} (${r.get(s.pid)})`));const p=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(p/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(S=>this.formatProcessItem(t,r,i,S,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=y.URI.revive(r);if(i.scheme!==T.Schemas.file)continue;const s=i.fsPath;try{const u=await I(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};a=he([Y(0,m.ITelemetryService),Y(1,l.IProductService)],a),e.DiagnosticsService=a}),define(Z[183],ee([0,1,6,29,11,3,2,4,5,114,27,31,14,44,20]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let m=class extends A.Disposable{constructor(a,o,t){super();this.galleryService=a,this.telemetryService=o,this.logService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,A.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(a,o={}){if(!this.galleryService.isEnabled())throw new Error(b.localize(0,null));try{a=await this.checkAndGetCompatibleVersion(a)}catch(r){throw this.logService.error((0,R.getErrorMessage)(r)),E(this.telemetryService,"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(a),void 0,r),r}if(!await this.canInstall(a)){const r=new n.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",a.identifier.id,r.message),E(this.telemetryService,"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(a),void 0,r),r}const t=await this.galleryService.getManifest(a,L.CancellationToken.None);if(t===null){const r=new n.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,r.message),E(this.telemetryService,"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(a),void 0,r),r}return this.installExtension(t,a,o)}async uninstall(a,o={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,o)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const o=await this.findGalleryExtension(a);if(!o)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,o,t){if(!y.URI.isUri(o)){let c=this.installingExtensions.get(new w.ExtensionIdentifierWithVersion(o.identifier,o.version).key());if(c)return this.logService.info("Extensions is already requested to install",o.identifier.id),c.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],s=this.createInstallExtensionTask(a,o,t);y.URI.isUri(o)||this.installingExtensions.set(new w.ExtensionIdentifierWithVersion(s.identifier,a.version).key(),s),this._onInstallExtension.fire({identifier:s.identifier,source:o}),this.logService.info("Installing extension:",s.identifier.id),r.push({task:s,manifest:a});let u=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",s.identifier.id);else try{const h=await this.getAllDepsAndPackExtensionsToInstall(s.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:S}of h)if(u=u||!!S.extensionDependencies?.some(g=>(0,w.areSameExtensions)({id:g},s.identifier)),this.installingExtensions.has(new w.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const g=this.createInstallExtensionTask(S,p,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new w.ExtensionIdentifierWithVersion(g.identifier,S.version).key(),g),this._onInstallExtension.fire({identifier:g.identifier,source:p}),this.logService.info("Installing extension:",g.identifier.id),r.push({task:g,manifest:S})}}catch(h){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",s.identifier.id),this.logService.error(h),h}const c=r.reduce((h,{task:p,manifest:S})=>(h.set(p.identifier.id.toLowerCase(),{task:p,manifest:S}),h),new Map);for(;c.size;){let h;const p=[...c.values()].filter(({manifest:S})=>!S.extensionDependencies?.some(g=>c.has(g.toLowerCase())));p.length?h=c.size===1?p:p.filter(({task:S})=>!(S===s&&!u)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:S})=>S.identifier.id)),h=[...c.values()]),await this.joinAllSettled(h.map(async({task:S})=>{const g=new Date().getTime();try{const k=await S.run();if(await this.joinAllSettled(this.participants.map(O=>O.postInstall(k,S.source,t,L.CancellationToken.None))),!y.URI.isUri(S.source)&&(E(this.telemetryService,S.operation===2?"extensionGallery:update":"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(S.source),new Date().getTime()-g,void 0),P.isWeb&&S.operation===1))try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"install")}catch(O){}i.push({local:k,identifier:S.identifier,operation:S.operation,source:S.source})}catch(k){throw y.URI.isUri(S.source)||E(this.telemetryService,S.operation===2?"extensionGallery:update":"extensionGallery:install",(0,w.getGalleryExtensionTelemetryData)(S.source),new Date().getTime()-g,k),this.logService.error("Error while installing the extension:",S.identifier.id),this.logService.error(k),k}finally{c.delete(S.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:h})=>this.logService.info("Extension installed successfully:",h.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:h})=>(0,w.areSameExtensions)(h,s.identifier))[0].local}catch(c){if(r.forEach(({task:h})=>h.cancel()),i.length)try{const h=await Promise.allSettled(i.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<h.length;p++){const S=h[p],{identifier:g}=i[p];S.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",g.id):this.logService.warn("Rollback: Error while uninstalling extension",g.id,(0,R.getErrorMessage)(S.reason))}}catch(h){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(h),i.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",s.identifier.id,(0,R.getErrorMessage)(c)),this._onDidInstallExtensions.fire(r.map(({task:h})=>({identifier:h.identifier,operation:1,source:h.source}))),c instanceof Error&&(c.name=c&&c.code?c.code:e.ERROR_UNKNOWN),c}finally{for(const{task:c,manifest:h}of r)if(!y.URI.isUri(c.source)){const p=new w.ExtensionIdentifierWithVersion(c.identifier,h.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(a){const o=[],t=[],r=await Promise.allSettled(a);for(const i of r)i.status==="fulfilled"?o.push(i.value):t.push(i.reason);if(t.length)throw I(t);return o}async getAllDepsAndPackExtensionsToInstall(a,o,t){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const i=[a,...r.map(c=>c.identifier)],s=[],u=async(c,h)=>{const p=h.extensionDependencies||[];if(h.extensionPack){const S=t?r.find(g=>(0,w.areSameExtensions)(g.identifier,c)):void 0;for(const g of h.extensionPack)S&&S.manifest.extensionPack&&S.manifest.extensionPack.some(k=>(0,w.areSameExtensions)({id:k},{id:g}))||p.every(k=>!(0,w.areSameExtensions)({id:k},{id:g}))&&p.push(g)}if(p.length){const S=[...i,...s.map(k=>k.gallery.identifier)],g=p.filter(k=>S.every(O=>!(0,w.areSameExtensions)(O,{id:k})));if(g.length){const k=await this.galleryService.query({names:g,pageSize:p.length},L.CancellationToken.None);for(const O of k.firstPage){if(S.find(H=>(0,w.areSameExtensions)(H,O.identifier)))continue;const x=await this.checkAndGetCompatibleVersion(O);if(!await this.canInstall(x)){this.logService.info("Skipping the extension as it cannot be installed",x.identifier.id);continue}const z=await this.galleryService.getManifest(x,L.CancellationToken.None);if(z===null)throw new n.ExtensionManagementError(`Missing manifest for extension ${x.identifier.id}`,e.INSTALL_ERROR_VALIDATING);s.push({gallery:x,manifest:z}),await u(x.identifier,z)}}}};return await u(a,o),r=await this.getInstalled(),s.filter(c=>!r.some(h=>(0,w.areSameExtensions)(h.identifier,c.gallery.identifier)))}async checkAndGetCompatibleVersion(a){if(await this.isMalicious(a))throw new n.ExtensionManagementError(b.localize(3,null,a.identifier.id),n.INSTALL_ERROR_MALICIOUS);const o=await this.galleryService.getCompatibleExtension(a);if(!o)throw new n.ExtensionManagementError(b.localize(4,null,a.identifier.id,d.default.version),n.INSTALL_ERROR_INCOMPATIBLE);return o}async isMalicious(a){const o=await this.getExtensionsReport();return(0,w.getMaliciousExtensionsSet)(o).has(a.identifier.id)}async unininstallExtension(a,o){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const r=(c,h)=>{const p=this.createUninstallExtensionTask(c,h);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",c.identifier.id),this._onUninstallExtension.fire(c.identifier),p},i=(c,h)=>{h?this.logService.error("Failed to uninstall extension:",c.identifier.id,h.message):this.logService.info("Successfully uninstalled extension:",c.identifier.id),E(this.telemetryService,"extensionGallery:uninstall",(0,w.getLocalExtensionTelemetryData)(c),void 0,h),this._onDidUninstallExtension.fire({identifier:c.identifier,error:h?.code})},s=[],u=[];try{s.push(r(a,{}));const c=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const h=this.getAllPackExtensionsToUninstall(a,c);for(const p of h)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):s.push(r(p,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(s.map(h=>h.extension),c,a),await this.joinAllSettled(s.map(async h=>{try{if(await h.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(h.extension,o,L.CancellationToken.None))),h.extension.identifier.uuid)try{await this.galleryService.reportStatistic(h.extension.manifest.publisher,h.extension.manifest.name,h.extension.manifest.version,"uninstall")}catch(p){}i(h.extension)}catch(p){const S=p instanceof n.ExtensionManagementError?p:new n.ExtensionManagementError((0,R.getErrorMessage)(p),e.ERROR_UNKNOWN);throw i(h.extension,S),S}finally{u.push(h)}}))}catch(c){const h=c instanceof n.ExtensionManagementError?c:new n.ExtensionManagementError((0,R.getErrorMessage)(c),e.ERROR_UNKNOWN);for(const p of s){try{p.cancel()}catch(S){}u.includes(p)||i(p.extension,h)}throw h}finally{for(const c of s)this.uninstallingExtensions.delete(c.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",c.extension.identifier.id)}}checkForDependents(a,o,t){for(const r of a){const i=this.getDependents(r,o);if(i.length){const s=i.filter(u=>a.indexOf(u)===-1);if(s.length)throw new Error(this.getDependentsErrorMessage(r,s,t))}}}getDependentsErrorMessage(a,o,t){return t===a?o.length===1?b.localize(5,null,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?b.localize(6,null,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):b.localize(7,null,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?b.localize(8,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?b.localize(9,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):b.localize(10,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(a,o,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const r=a.manifest.extensionPack?a.manifest.extensionPack:[];if(r.length){const i=o.filter(u=>!u.isBuiltin&&r.some(c=>(0,w.areSameExtensions)({id:c},u.identifier))),s=[];for(const u of i)s.push(...this.getAllPackExtensionsToUninstall(u,o,t));return[...i,...s]}return[]}getDependents(a,o){return o.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,w.areSameExtensions)({id:r},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const o=await this.findGalleryExtensionById(a.identifier.uuid);return o||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};m=he([Y(0,n.IExtensionGalleryService),Y(1,l.ITelemetryService),Y(2,f.ILogService)],m),e.AbstractExtensionManagementService=m;function I(v){const a=Array.isArray(v)?v:[v];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((o,t)=>new Error(`${o.message}${o.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=I;function E(v,a,o,t,r){const i=r?r instanceof n.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;v.publicLogError(a,{...o,success:!r,duration:t,errorcode:i})}e.reportTelemetry=E;class C{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(a=>new Promise((o,t)=>{const r=a.onCancellationRequested(()=>{r.dispose(),t((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=C}),define(Z[184],ee([0,1,29,11,26,4,5,12,27,31,72,13,7,14,28,42,45,19,20]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var v;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(v||(v={}));function a(...M){return String(M.reduce((N,j)=>N|j,0))}var o;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:v.None,criteria:[],assetTypes:[]};class u{constructor(N=s){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,j=this.state.pageSize){return new u({...this.state,pageNumber:N,pageSize:j})}withFilter(N,...j){const F=[...this.state.criteria,...j.length?j.map(q=>({filterType:N,value:q})):[{filterType:N}]];return new u({...this.state,criteria:F})}withSortBy(N){return new u({...this.state,sortBy:N})}withSortOrder(N){return new u({...this.state,sortOrder:N})}withFlags(...N){return new u({...this.state,flags:N.reduce((j,F)=>j|F,0)})}withAssetTypes(...N){return new u({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:j,pageSize:F,sortBy:q,sortOrder:_,flags:G,assetTypes:W}=this.state;return{filters:[{criteria:N,pageNumber:j,pageSize:F,sortBy:q,sortOrder:_}],assetTypes:W,flags:G}}get searchText(){const N=this.state.criteria.filter(j=>j.filterType===o.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(M,N){const j=(M||[]).filter(F=>F.statisticName===N)[0];return j?j.value:0}function h(M){const N="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(F=>F.assetType.indexOf(N)===0).reduce((F,q)=>{const _=k(M,q.assetType);return _&&F.push([q.assetType.substring(N.length),_]),F},[])}function p(M){if(M.properties){const N=M.properties.filter(q=>q.key===t.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=N.filter(q=>j.test(q.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return k(M,t.Repository)}function S(M){return{uri:`${M.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${M.fallbackAssetUri}/${t.VSIX}`}}function g(M){const N=k(M,t.Icon);if(N)return N;const j=y.DefaultIconPath;return{uri:j,fallbackUri:j}}function k(M,N){return M.files.filter(F=>F.assetType===N)[0]?{uri:`${M.assetUri}/${N}`,fallbackUri:`${M.fallbackAssetUri}/${N}`}:null}function O(M,N){const j=M.properties?M.properties.filter(q=>q.key===N):[],F=j.length>0&&j[0].value;return F?F.split(",").map(q=>(0,b.adoptToGalleryExtensionId)(q)):[]}function x(M){const N=M.properties?M.properties.filter(j=>j.key===r.Engine):[];return N.length>0&&N[0].value||""}function z(M){const N=M.properties?M.properties.filter(F=>F.key===r.LocalizedLanguages):[],j=N.length>0&&N[0].value||"";return j?j.split(","):[]}function H(M){return M.indexOf("preview")!==-1}function B(M,N,j,F,q){const _={manifest:k(N,t.Manifest),readme:k(N,t.Details),changelog:k(N,t.Changelog),license:k(N,t.License),repository:p(N),download:S(N),icon:g(N),coreTranslations:h(N)};return{identifier:{id:(0,b.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:N.version,date:N.lastUpdated,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,description:M.shortDescription||"",installCount:c(M.statistics,"install"),rating:c(M.statistics,"averagerating"),ratingCount:c(M.statistics,"ratingcount"),assetUri:A.URI.parse(N.assetUri),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),webExtension:!!M.tags?.includes(y.WEB_EXTENSION_TAG),assetTypes:N.files.map(({assetType:G})=>G),assets:_,properties:{dependencies:O(N,r.Dependency),extensionPack:O(N,r.ExtensionPack),engine:x(N),localizedLanguages:z(N)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+j,querySource:q},preview:H(M.flags)}}let U=class{constructor(N,j,F,q,_,G,W){this.requestService=N,this.logService=j,this.environmentService=F,this.telemetryService=q,this.fileService=_,this.productService=G;const X=G.extensionsGallery;this.extensionsGalleryUrl=X&&X.serviceUrl,this.extensionsControlUrl=X&&X.controlUrl,this.commonHeadersPromise=$(G.version,this.environmentService,this.fileService,W)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,j){const F=[];let{total:q,firstPage:_,getPage:G}=await this.query({names:N,pageSize:N.length},j);F.push(..._);for(let W=1;F.length<q&&(_=await G(W,j),_.length);W++)F.push(..._);return F}async getCompatibleExtension(N,j){return this.getCompatibleExtensionByEngine(N,j)}async getCompatibleExtensionByEngine(N,j){const F=(0,y.isIExtensionIdentifier)(N)?null:N;if(F&&F.properties.engine&&(0,n.isEngineValid)(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:q,uuid:_}=F?F.identifier:N;let G=new u().withFlags(v.IncludeAssetUri,v.IncludeStatistics,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");_?G=G.withFilter(o.ExtensionId,_):G=G.withFilter(o.ExtensionName,q);const{galleryExtensions:W}=await this.queryGallery(G,D.CancellationToken.None),[X]=W;if(!X||!X.versions.length)return null;if(j){const ie=X.versions.filter(te=>te.version===j)[0];if(ie){const te=B(X,ie,0,G);if(te.properties.engine&&(0,n.isEngineValid)(te.properties.engine,this.productService.version,this.productService.date))return te}return null}const Q=await this.getLastValidExtensionVersion(X,X.versions);return Q?B(X,Q,0,G):null}async query(N,j){const F=D.CancellationToken.isCancellationToken(N)?{}:N,q=D.CancellationToken.isCancellationToken(N)?N:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let _=F.text||"";const G=(0,R.getOrDefault)(F,oe=>oe.pageSize,50);let W=new u().withFlags(v.IncludeLatestVersionOnly,v.IncludeAssetUri,v.IncludeStatistics,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,G).withFilter(o.Target,"Microsoft.VisualStudio.Code");_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,ue,de)=>(W=W.withFilter(o.Category,de||ue),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,ue,de)=>(W=W.withFilter(o.Tag,de||ue),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(o.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),W=W.withFilter(o.SearchText,_)),W=W.withSortBy(0)):F.ids?W=W.withFilter(o.ExtensionId,...F.ids):F.names?W=W.withFilter(o.ExtensionName,...F.names):W=W.withSortBy(4),typeof F.sortBy=="number"&&(W=W.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(W=W.withSortOrder(F.sortOrder));const{galleryExtensions:X,total:Q}=await this.queryGallery(W,q),ie=X.map((oe,ue)=>B(oe,oe.versions[0],ue,W,F.source)),te=async(oe,ue)=>{if(ue.isCancellationRequested)throw(0,L.canceled)();const de=W.withPage(oe+1),{galleryExtensions:ve}=await this.queryGallery(de,ue);return ve.map((Re,Te)=>B(Re,Re.versions[0],Te,de,F.source))};return{firstPage:ie,total:Q,pageSize:W.pageSize,getPage:te}}async queryGallery(N,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,v.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,a(v.Unpublished));const F=await this.commonHeadersPromise,q=JSON.stringify(N.raw),_={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},G=new Date().getTime();let W,X,Q=0;try{if(W=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:q,headers:_},j),W.res.statusCode&&W.res.statusCode>=400&&W.res.statusCode<500)return{galleryExtensions:[],total:Q};const ie=await(0,m.asJson)(W);if(ie){const te=ie.results[0],oe=te.extensions,ue=te.resultMetadata&&te.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return Q=ue&&ue.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:oe,total:Q}}return{galleryExtensions:[],total:Q}}catch(ie){throw X=ie,ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-G,success:!!W&&(0,m.isSuccess)(W),responseBodySize:W?.res.headers["Content-Length"],statusCode:W?String(W.res.statusCode):void 0,errorCode:X?(0,L.isPromiseCanceledError)(X)?"canceled":(0,L.getErrorMessage)(X).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(N,j,F,q){if(!this.isEnabled())return;const _=T.isWeb?this.api(`/itemName/${N}.${j}/version/${F}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${j}/${F}/stats?statType=${q}`),G=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",X={...await this.commonHeadersPromise,Accept:G};try{await this.requestService.request({type:"POST",url:_,headers:X},D.CancellationToken.None)}catch(Q){}}async download(N,j,F){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const q=(0,b.getGalleryExtensionTelemetryData)(N),_=new Date().getTime(),G=ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:ie}),W=F===1?"install":F===2?"update":"",X=W?{uri:`${N.assets.download.uri}&${W}=true`,fallbackUri:`${N.assets.download.fallbackUri}?${W}=true`}:N.assets.download,Q=await this.getAsset(X);await this.fileService.writeFile(j,Q.stream),G(new Date().getTime()-_)}async getReadme(N,j){if(N.assets.readme){const F=await this.getAsset(N.assets.readme,{},j);return await(0,m.asText)(F)||""}return""}async getManifest(N,j){if(N.assets.manifest){const F=await this.getAsset(N.assets.manifest,{},j),q=await(0,m.asText)(F);return q?JSON.parse(q):null}return null}async getCoreTranslation(N,j){const F=N.assets.coreTranslations.filter(q=>q[0]===j.toUpperCase())[0];if(F){const q=await this.getAsset(F[1]),_=await(0,m.asText)(q);return _?JSON.parse(_):null}return null}async getChangelog(N,j){if(N.assets.changelog){const F=await this.getAsset(N.assets.changelog,{},j);return await(0,m.asText)(F)||""}return""}async getAllVersions(N,j){let F=new u().withFlags(v.IncludeVersions,v.IncludeCategoryAndTags,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?F=F.withFilter(o.ExtensionId,N.identifier.uuid):F=F.withFilter(o.ExtensionName,N.identifier.id);const q=[],{galleryExtensions:_}=await this.queryGallery(F,D.CancellationToken.None);return _.length&&(j?await Promise.all(_[0].versions.map(async G=>{let W;try{W=await this.getEngine(G)}catch(X){}W&&(0,n.isEngineValid)(W,this.productService.version,this.productService.date)&&q.push({version:G.version,date:G.lastUpdated})})):q.push(..._[0].versions.map(G=>({version:G.version,date:G.lastUpdated})))),q}async getAsset(N,j={},F=D.CancellationToken.None){const q=await this.commonHeadersPromise,_={type:"GET"},G={...q,...j.headers||{}};j={...j,..._,headers:G};const W=N.uri,X=N.fallbackUri,Q={...j,url:W};try{const ie=await this.requestService.request(Q,F);if(ie.res.statusCode===200)return ie;const te=await(0,m.asText)(ie);throw new Error(`Expected 200, got back ${ie.res.statusCode} instead.

${te}`)}catch(ie){if((0,L.isPromiseCanceledError)(ie))throw ie;const te=(0,L.getErrorMessage)(ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:W,message:te});const oe={...j,url:X};return this.requestService.request(oe,F)}}async getLastValidExtensionVersion(N,j){const F=this.getLastValidExtensionVersionFromProperties(N,j);return F||this.getLastValidExtensionVersionRecursively(N,j)}getLastValidExtensionVersionFromProperties(N,j){for(const F of j){const q=x(F);if(!q)return null;if((0,n.isEngineValid)(q,this.productService.version,this.productService.date))return F}return null}async getEngine(N){const j=x(N);if(j)return j;const F=k(N,t.Manifest);if(!F)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},_=await this.getAsset(F,{headers:q}),G=await(0,m.asJson)(_);if(G)return G.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(N,j){if(!j.length)return null;const F=j[0],q=await this.getEngine(F);return(0,n.isEngineValid)(q,this.productService.version,this.productService.date)?{...F,properties:[...F.properties||[],{key:r.Engine,value:q}]}:this.getLastValidExtensionVersionRecursively(N,j.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,m.asJson)(N),F=new Map;if(j)for(const q of j.malicious){const _=F.get(q)||{id:{id:q},malicious:!0,slow:!1};_.malicious=!0,F.set(q,_)}return[...F.values()]}};U=he([Y(0,m.IRequestService),Y(1,d.ILogService),Y(2,P.IEnvironmentService),Y(3,C.ITelemetryService),Y(4,w.IFileService),Y(5,l.IProductService),Y(6,(0,f.optional)(E.IStorageService))],U),e.ExtensionGalleryService=U;async function $(M,N,j,F){const q={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},_=await(0,I.getServiceMachineId)(N,j,F);return q["X-Market-User-Id"]=_,q}e.resolveMarketplaceHeaders=$}),define(Z[185],ee([0,1,22,6,63,3,8,4,35,5,116,12,27,177,75,13,14,59,28,42,19,20]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends d.ExtensionTipsService{constructor(u,c,h,p,S,g,k,O,x,z){super(k,O,x,z);this.environmentService=u,this.telemetryService=c,this.extensionManagementService=h,this.storageService=p,this.nativeHostService=S,this.extensionRecommendationNotificationService=g,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,R.forEach)(O.exeBasedExtensionTips,({key:H,value:B})=>{const U=[],$=[],M=[];(0,R.forEach)(B.recommendations,({key:N,value:j})=>{j.important?B.important?U.push({extensionId:N,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):$.push({extensionId:N,extensionName:j.name,isExtensionPack:!!j.isExtensionPack}):M.push({extensionId:N,extensionName:j.name,isExtensionPack:!!j.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(H,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:U}),$.length&&this.mediumImportanceExecutableTips.set(H,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:$}),M.length&&this.allOtherExecutableTips.set(H,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:M})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),h=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,h),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,h)}groupImportantTipsByExe(u,c){const h=new Map;u.forEach(O=>h.set(O.extensionId.toLowerCase(),O));const{installed:p,uninstalled:S}=this.groupByInstalled([...h.keys()],c);for(const O of p){const x=h.get(O);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:x.exeName})}for(const O of S){const x=h.get(O);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:x.exeName})}const g=this.getPromptedExecutableTips(),k=new Map;for(const O of S){const x=h.get(O);if(x&&(!g[x.exeName]||!g[x.exeName].includes(x.extensionId))){let z=k.get(x.exeName);z||(z=[],k.set(x.exeName,z)),z.push(x)}}return k}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(h=>{switch(h){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const p=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(p(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const S=this._register((0,L.disposableTimeout)(()=>{S.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),c=Date.now()-u,h=7*24*60*60*1e3;if(c<h){const g=this._register((0,L.disposableTimeout)(()=>{g.dispose(),this.promptMediumImportanceExeBasedTip()},h-c));return}const[p,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(g=>{switch(g){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(p),this.addToRecommendedExecutables(S[0].exeName,S);const k=this._register((0,L.disposableTimeout)(()=>{k.dispose(),this.promptMediumImportanceExeBasedTip()},h));break;case"ignored":this.mediumImportanceTipsByExe.delete(p),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const x=this._register((0,L.disposableTimeout)(()=>{x.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const c=u.map(({extensionId:p})=>p.toLowerCase()),h=(0,n.localize)(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,h,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,c){const h=this.getPromptedExecutableTips();h[u]=c.map(({extensionId:p})=>p.toLowerCase()),this.storageService.store(t,JSON.stringify(h),0,0)}groupByInstalled(u,c){const h=[],p=[],S=c.reduce((g,k)=>(g.add(k.identifier.id.toLowerCase()),g),new Set);return u.forEach(g=>{S.has(g.toLowerCase())?h.push(g):p.push(g)}),{installed:h,uninstalled:p}}async getValidExecutableBasedExtensionTips(u){const c=[],h=new Map;for(const p of u.keys()){const S=u.get(p);if(!S||!(0,D.isNonEmptyArray)(S.recommendations))continue;const g=[];P.isWindows?S.windowsPath&&g.push(S.windowsPath.replace("%USERPROFILE%",y.env.USERPROFILE).replace("%ProgramFiles(x86)%",y.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",y.env.ProgramFiles).replace("%APPDATA%",y.env.APPDATA).replace("%WINDIR%",y.env.WINDIR)):(g.push((0,A.join)("/usr/local/bin",p)),g.push((0,A.join)("/usr/bin",p)),g.push((0,A.join)(this.environmentService.userHome.fsPath,p)));for(const k of g){let O=h.get(k);if(O===void 0&&(O=await this.fileService.exists(b.URI.file(k)),h.set(k,O)),O)for(const{extensionId:x,extensionName:z,isExtensionPack:H}of S.recommendations)c.push({extensionId:x,extensionName:z,isExtensionPack:H,exeName:p,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath})}}return c}};i=he([Y(0,w.INativeEnvironmentService),Y(1,o.ITelemetryService),Y(2,f.IExtensionManagementService),Y(3,a.IStorageService),Y(4,E.INativeHostService),Y(5,l.IExtensionRecommendationNotificationService),Y(6,m.IFileService),Y(7,C.IProductService),Y(8,v.IRequestService),Y(9,I.ILogService)],i),e.ExtensionTipsService=i}),define(Z[82],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appender=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:P,data:y}){return this.appender.log(P,y),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[83],ee([0,1,2,26,23,126,24,38,7,44,32]),function(K,e,D,L,R,T,A,P,y,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(l,m){this._configurationService=m,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const E=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(l,m){this._experimentProperties[l]=m}setEnabled(l){this._enabled=l}_updateUserOptIn(){const l=this._configurationService?.getValue(f);this._userOptIn=l?l.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let m=l.sessionID,I=l["common.instanceId"],E=l["common.machineId"],C=l["common.firstSessionDate"],v=l["common.msftInternal"];return{sessionId:m,instanceId:I,machineId:E,firstSessionDate:C,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(l,m,I){return this.isOptedIn?this._commonProperties.then(E=>{m=(0,L.mixin)(m,E),m=(0,L.mixin)(m,this._experimentProperties),m=(0,L.cloneAndChange)(m,C=>{if(typeof C=="string")return this._cleanupInfo(C,I)}),this._appender.log(l,m)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(l,m,I){return this.publicLog(l,m,I)}publicLogError(l,m){return this.sendErrorTelemetry?this.publicLog(l,m,!0):Promise.resolve(void 0)}publicLogError2(l,m){return this.publicLogError(l,m)}_cleanupInfo(l,m){let I=l;if(m){const E=[];for(let o of this._cleanupPatterns)for(;;){const t=o.exec(l);if(!t)break;E.push([t.index,o.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(I="";;){const o=v.exec(l);if(!o)break;!C.test(o[0])&&E.every(([t,r])=>o.index<t||o.index>=r)&&(I+=l.substring(a,o.index)+"<REDACTED: user-file-path>",a=v.lastIndex)}a<l.length&&(I+=l.substr(a))}for(let E of this._cleanupPatterns)I=I.replace(E,"");return I}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=he([Y(1,(0,y.optional)(A.IConfigurationService))],w),e.TelemetryService=w;const f="telemetry";n.Registry.as(P.Extensions.Configuration).registerConfiguration({id:f,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,T.localize)(2,null,b.default.nameLong,b.default.privacyStatementUrl):(0,T.localize)(1,null,b.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[53],ee([0,1,6,26,16,24]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(l,m){return Promise.resolve(void 0)}publicLog2(l,m){return this.publicLog(l,m)}publicLogError(l,m){return Promise.resolve(void 0)}publicLogError2(l,m){return this.publicLogError(l,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(m,I,E){}async publicLogError(m,I,E){}}e.NullEndpointTelemetryService=A;function P(...l){return{log:(m,I)=>l.forEach(E=>E.log(m,I)),flush:()=>D.Promises.settled(l.map(m=>m.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(l,m){return m.onDidChangeConfiguration(I=>{I.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(I.source),configurationKeys:f(I.sourceConfig)})})}e.configurationTelemetry=y;function b(l){const m=Object.create(null),I=Object.create(null),E=Object.create(null);w(l,E);for(let C in E){C=C.length>150?C.substr(C.length-149):C;const v=E[C];typeof v=="number"?I[C]=v:typeof v=="boolean"?I[C]=v?1:0:typeof v=="string"?m[C]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(m[C]=v)}return{properties:m,measurements:I}}e.validateTelemetryData=b;function n(l){if(!l)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{l.indexOf(`${E}+`)===0&&(m=E)}),m}e.cleanRemoteAuthority=n;function w(l,m,I=0,E){if(!!l)for(let C of Object.getOwnPropertyNames(l)){const v=l[C],a=E?E+C:C;Array.isArray(v)?m[a]=(0,L.safeStringify)(v):v instanceof Date?m[a]=v.toISOString():(0,R.isObject)(v)?I<2?w(v,m,I+1,a+"."):m[a]=(0,L.safeStringify)(v):m[a]=v}}function f(l){if(!l)return[];const m=[];return d(m,"",l),m}function d(l,m,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(E=>d(l,m?`${m}.${E}`:E,I[E])):l.push(m)}}),define(Z[84],ee([0,1,2,12,14,53]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(y,b,n=""){super();this.prefix=n;const w=y.getLogger(b.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(y.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(y,b){this.logger.trace(`${this.prefix}telemetry/${y}`,(0,T.validateTelemetryData)(b))}};A=he([Y(0,R.ILoggerService),Y(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(Z[186],ee([0,1,11,26,53]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P){const y=await new Promise((n,w)=>{K(["applicationinsights"],n,w)});let b;return y.defaultClient?(b=new y.TelemetryClient(P),b.channel.setUseDiskRetryCaching(!0)):(y.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=y.defaultClient),P.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class A{constructor(y,b,n){this._eventPrefix=y,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(y){if(!!this._aiClient){if(typeof this._aiClient!="string"){y(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(b=>{y(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(y,b){!this._aiClient||(b=(0,L.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+y,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(y=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,y(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(Z[187],ee([0,1,17,51,24,12,14,20,82,84,83,53]),function(K,e,D,L,R,T,A,P,y,b,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let f=class{constructor(l,m,I,E){this.configurationService=l,this.telemetryService=m,this.loggerService=I,this.environmentService=E,this.customTelemetryServices=new Map}async getCustomTelemetryService(l){if(!this.customTelemetryServices.has(l.id)){const{machineId:m,sessionId:I}=await this.telemetryService.getTelemetryInfo(),E=Object.create(null);E["common.vscodemachineid"]=m,E["common.vscodesessionid"]=I;const C=[l.id,JSON.stringify(E),l.aiKey],a=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:C,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),o=(0,w.combinedAppender)(new y.TelemetryAppenderClient(a),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${l.id}] `));this.customTelemetryServices.set(l.id,new n.TelemetryService({appender:o,sendErrorTelemetry:l.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(l.id)}async publicLog(l,m,I){await(await this.getCustomTelemetryService(l)).publicLog(m,I)}async publicLogError(l,m,I){await(await this.getCustomTelemetryService(l)).publicLogError(m,I)}};f=he([Y(0,R.IConfigurationService),Y(1,P.ITelemetryService),Y(2,A.ILoggerService),Y(3,T.IEnvironmentService)],f),e.CustomEndpointTelemetryService=f}),define(Z[188],ee([0,1,6,29,3,2,14]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(b,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((n,w)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,n),this._onCreateRequest.fire({requestId:f,...b});const d=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,d.token).then(()=>w(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,T.toDisposable)(()=>d.cancel())])})}acceptReply(b,n){const w=this._pendingRequests.get(b);w?(this._pendingRequests.delete(b),(0,T.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),w(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=he([Y(1,A.ILogService)],P),e.RequestStore=P}),define(Z[85],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.TitleMode="terminal.integrated.titleMode",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var y;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y=e.HeartbeatConstants||(e.HeartbeatConstants={}));var b;(function(d){d.TerminalView="view",d.Editor="editor"})(b=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var w;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(w=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}))}),define(Z[189],ee([0,1,7]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(Z[190],ee([0,1,34,26,8,4,35,16,18]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return w&&w.length===4&&(f=parseInt(w[3])),f}e.getWindowsBuildNumber=b;async function n(w,f,d,l=A.env,m=y.Promises.exists){if(R.isAbsolute(w))return await m(w)?w:void 0;if(f===void 0&&(f=A.cwd()),R.dirname(w)!=="."){const v=R.join(f,w);return await m(v)?v:void 0}const E=(0,L.getCaseInsensitive)(l,"PATH");if(d===void 0&&(0,P.isString)(E)&&(d=E.split(R.delimiter)),d===void 0||d.length===0){const v=R.join(f,w);return await m(v)?v:void 0}for(let v of d){let a;if(R.isAbsolute(v)?a=R.join(v,w):a=R.join(f,v,w),await m(a))return a;if(T.isWindows){let o=a+".com";if(await m(o)||(o=a+".exe",await m(o)))return o}}const C=R.join(f,w);return await m(C)?C:void 0}e.findExecutable=n}),define(Z[191],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(Z[86],ee([0,1,48,3,2,7,32,191]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var y;(function(I){function E(C){return C&&typeof C=="object"&&typeof C.id=="string"}I.isThemeColor=E})(y=e.ThemeColor||(e.ThemeColor={}));function b(I){return{id:I}}e.themeColorFromId=b;var n;(function(I){function E(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||y.isThemeColor(r.color))}I.isThemeIcon=E;const C=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function v(r){const i=C.exec(r);if(!i)return;let[,s]=i;return{id:s}}I.fromString=v;function a(r,i){let s=r.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),i&&(s=`${s}~${i}`),{id:s}}I.modify=a;function o(r,i){return r.id===i.id&&r.color?.id===i.color?.id}I.isEqual=o;function t(r,i){return{id:r.id,color:i?b(i):void 0}}I.asThemeIcon=t,I.asClassNameArray=D.CSSIcon.asClassNameArray,I.asClassName=D.CSSIcon.asClassName,I.asCSSSelector=D.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function w(I){switch(I){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,R.toDisposable)(()=>{const C=this.themingParticipants.indexOf(E);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new f;A.Registry.add(e.Extensions.ThemingContribution,d);function l(I){return d.onColorThemeChange(I)}e.registerThemingParticipant=l;class m extends R.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,C){let v=this.theme.getColor(E);return v&&C&&(v=C(v,this.theme)),v?v.toString():null}}e.Themable=m}),define(Z[192],ee([0,1,48,86]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,y){const b=P.map(n=>({name:n.profileName,description:T(n)}));return y&&b.push(...y.map(n=>({name:n.title,description:A(n)}))),{values:b.map(n=>n.name),markdownDescriptions:b.map(n=>n.description)}}e.createProfileSchemaEnums=R;function T(P){let y=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?y+=`
- args: "${P.args}"`:y+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(y+=`
- overrideName: ${P.overrideName}`),P.color&&(y+=`
- color: ${P.color}`),P.env&&(y+=`
- env: ${JSON.stringify(P.env)}`),y}function A(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(Z[193],ee([0,1,48,127,38,32,192]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,I=>I.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,I=>`$(${I.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.persistentSessionExperimentalSerializer"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(38,null),type:"boolean",default:!0}}};function d(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(f),m()}e.registerTerminalPlatformConfiguration=d;let l;function m(I,E){const C=T.Registry.as(R.Extensions.Configuration);l&&C.deregisterConfigurations([l]);let v;I&&(v=(0,A.createProfileSchemaEnums)(I?.profiles,E)),l={id:"terminal",order:100,title:(0,L.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:I?.os===3?v?.values:void 0,markdownEnumDescriptions:I?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:I?.os===2?v?.values:void 0,markdownEnumDescriptions:I?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:I?.os===1?v?.values:void 0,markdownEnumDescriptions:I?.os===1?v?.markdownDescriptions:void 0}}},C.registerConfiguration(l)}e.registerTerminalDefaultProfileConfiguration=m}),define(Z[194],ee([0,1,41,48,8,4,18,69,190,86]),function(K,e,D,L,R,T,A,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function w(t,r,i,s,u=process.env,c,h,p,S){return c=c||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?f(i,c,u,h,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),S,p):v(c,h,i,t&&typeof t=="object"?{...t}:s.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),S,p,u)}e.detectAvailableProfiles=w;async function f(t,r,i,s,u,c,h,p,S){const g=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),k=`${process.env.windir}\\${g?"Sysnative":"System32"}`;let O=!1;(0,y.getWindowsBuildNumber)()>=16299&&(O=!0),await m(p);const x=new Map;t&&(x.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),x.set("Windows PowerShell",{path:`${k}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),x.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),x.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),x.set("Command Prompt",{path:`${k}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),a(c,x);const z=await d(x.entries(),h,r,i,s,S);if(t||!t&&u)try{const H=await E(`${k}\\${O?"wsl":"bash"}.exe`,h);for(const B of H)(!c||!(B.profileName in c))&&z.push(B)}catch(H){s?.info("WSL is not installed, so could not detect WSL profiles")}return z}async function d(t,r,i,s=process.env,u,c){const h=[];for(const[p,S]of t){if(S===null)continue;let g,k,O;if("source"in S){const H=n?.get(S.source);if(!H)continue;g=H.paths,k=S.args||H.args,S.icon?O=l(S.icon):H.icon&&(O=H.icon)}else g=Array.isArray(S.path)?S.path:[S.path],k=T.isWindows||Array.isArray(S.args)?S.args:void 0,O=l(S.icon)||void 0;const x=await c?.(g)||g.slice(),z=await o(p,r,x,i,s,k,S.env,S.overrideName,S.isAutoDetected,u);z?(z.isAutoDetected=S.isAutoDetected,z.icon=O,z.color=S.color,h.push(z)):u?.trace("profile not validated",p,g)}return h}function l(t){return typeof t=="string"?{id:t}:t}async function m(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await I(),icon:b.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function I(){const t=[];for await(const r of(0,P.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function E(t,r){const i=[],s=await new Promise((h,p)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(S,g)=>{if(S)return p("Problem occurred when getting wsl distros");h(g)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),c=s.split(u).filter(h=>h.trim().length>0&&h!=="");for(const h of c){if(h===""||h.startsWith("docker-desktop"))continue;const p=`${h} (WSL)`,S={profileName:p,path:t,args:["-d",`${h}`],isDefault:p===r,icon:C(h)};i.push(S)}return i}function C(t){return t.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function v(t,r,i,s,u,c,h,p){const S=new Map;if(i){const g=(await t.readFile("/etc/shells")).toString(),k=c||g.split(`
`).filter(x=>x.trim().indexOf("#")!==0&&x.trim().length>0),O=new Map;for(const x of k){let z=(0,R.basename)(x),H=O.get(z)||0;H++,H>1&&(z=`${z} (${H})`),O.set(z,H),S.set(z,{path:x,isAutoDetected:!0})}}return a(s,S),await d(S.entries(),u,t,p,r,h)}function a(t,r){if(!!t)for(const[i,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(i):r.set(i,s)}async function o(t,r,i,s,u,c,h,p,S,g){if(i.length===0)return Promise.resolve(void 0);const k=i.shift();if(k==="")return o(t,r,i,s,u,c,h,p,S);const O={profileName:t,path:k,args:c,env:h,overrideName:p,isAutoDetected:S,isDefault:t===r};if((0,R.basename)(k)===k){const z=u.PATH?u.PATH.split(R.delimiter):void 0;return await(0,y.findExecutable)(k,void 0,z,void 0,s.existsFile)?O:o(t,r,i,s,u,c)}return await s.existsFile((0,R.normalize)(k))?O:o(t,r,i,s,u,c,h,p,S)}}),define(Z[195],ee([0,1,3,2,17,4,36,51,24,156,14,79,20,188,85,193,194]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var E;(function(a){a[a.MaxRestarts=5]="MaxRestarts"})(E||(E={}));let C=0,v=class extends L.Disposable{constructor(o,t,r,i){super();this._reconnectConstants=o,this._configurationService=t,this._logService=r,this._telemetryService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=T.isWindows?Promise.resolve(process.env):(0,b.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const o=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback,VSCODE_RECONNECT_EXPERIMENTAL_SERIALIZATION:this._reconnectConstants.useExperimentalSerialization?1:0}});this._onPtyHostStart.fire(),A.ProxyChannel.toService(o.getChannel(l.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(o.onDidProcessExit(s=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=E.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const r=o.getChannel(l.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const i=A.ProxyChannel.toService(o.getChannel(l.TerminalIpcChannels.PtyHost));return this._register(i.onProcessData(s=>this._onProcessData.fire(s))),this._register(i.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(i.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(i.onProcessTitleChanged(s=>this._onProcessTitleChanged.fire(s))),this._register(i.onProcessShellTypeChanged(s=>this._onProcessShellTypeChanged.fire(s))),this._register(i.onProcessOverrideDimensions(s=>this._onProcessOverrideDimensions.fire(s))),this._register(i.onProcessResolvedShellLaunchConfig(s=>this._onProcessResolvedShellLaunchConfig.fire(s))),this._register(i.onProcessDidChangeHasChildProcesses(s=>this._onProcessDidChangeHasChildProcesses.fire(s))),this._register(i.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(i.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(i.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[o,i]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,t,r,i,s,u,c,h,p,S){const g=setTimeout(()=>this._handleUnresponsiveCreateProcess(),l.HeartbeatConstants.CreateProcessTimeout),k=await this._proxy.createProcess(o,t,r,i,s,u,c,h,p,S);return clearTimeout(g),C=Math.max(C,k),k}updateTitle(o,t,r){return this._proxy.updateTitle(o,t,r)}updateIcon(o,t,r){return this._proxy.updateIcon(o,t,r)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,t){return this._proxy.shutdown(o,t)}input(o,t){return this._proxy.input(o,t)}processBinary(o,t){return this._proxy.processBinary(o,t)}resize(o,t,r){return this._proxy.resize(o,t,r)}acknowledgeDataEvent(o,t){return this._proxy.acknowledgeDataEvent(o,t)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,t,r,i=!1){const s=await this._shellEnv;return(0,I.detectAvailableProfiles)(t,r,i,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,t){return this._proxy.requestDetachInstance(o,t)}async acceptDetachInstanceReply(o,t){return this._proxy.acceptDetachInstanceReply(o,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.FirstWaitMultiplier+l.HeartbeatConstants.BeatInterval*l.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${l.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:t})}async acceptPtyHostResolvedVariables(o,t){this._resolveVariablesRequestStore.acceptReply(o,t)}};v=he([Y(1,y.IConfigurationService),Y(2,n.ILogService),Y(3,f.ITelemetryService)],v),e.PtyHostService=v}),define(Z[54],ee([0,1,43]),function(K,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,P,y,b){const n=(0,D.setProperty)(A,P,y,b)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=L;function R(A,P,y){let b=y;for(;b>=0;){if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&A.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=R;function T(A,P,y){let b=y;for(;b>=0;)if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&A.charAt(b)===P.charAt(1)))return b;return A.length-1}e.getLineEndOffset=T}),define(Z[196],ee([0,1,26,58]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(w,f,d,l,m){const I=[],E=[],C=[];if(!f){const k=w.filter(({identifier:O})=>m.every(x=>x.toLowerCase()!==O.id.toLowerCase()));return{local:{added:I,removed:E,updated:C},remote:k.length>0?{added:k,updated:[],removed:[],all:k}:null}}w=w.map(b),f=f.map(b),d=d?d.map(b):null;const v=new Map,a=k=>{k.uuid&&v.set(k.id.toLowerCase(),k.uuid)};w.forEach(({identifier:k})=>a(k)),f.forEach(({identifier:k})=>a(k)),d&&d.forEach(({identifier:k})=>a(k));const o=k=>{const O=k.identifier.uuid||v.get(k.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${k.identifier.id.toLowerCase()}`},t=(k,O)=>(k.set(o(O),O),k),r=w.reduce(t,new Map),i=f.reduce(t,new Map),s=f.reduce((k,O)=>{const x=o(O);O=(0,D.deepClone)(O);const z=r.get(x);return z&&(z.installed&&(O.installed=!0),O.version||(O.version=z.version)),t(k,O)},new Map),u=d?d.reduce(t,new Map):null,c=l.reduce(t,new Map),h=m.reduce((k,O)=>{const x=v.get(O.toLowerCase());return k.add(x?`uuid:${x}`:`id:${O.toLowerCase()}`)},new Set),p=T(r,i,h);if(p.added.size>0||p.removed.size>0||p.updated.size>0){const k=T(u,r,h),O=T(u,i,h),x=(z,H)=>{const B=r.get(z);if(B){const U=i.get(z);return{...H?U:B,version:(U.version&&L.gt(U.version,B.version),B.version),state:A(B,U,u?.get(z))}}};for(const z of O.removed.values()){const H=r.get(z);H&&E.push(H.identifier)}for(const z of O.added.values())if(k.added.has(z)){if(p.updated.has(z)){const H=x(z,!0);H&&(C.push(n(H,z)),s.set(z,H))}}else{const H=i.get(z);H.installed&&I.push(n(H,z))}for(const z of O.updated.values()){const H=x(z,!0);H&&(C.push(n(H,z)),s.set(z,H))}for(const z of k.added.values())O.added.has(z)||s.set(z,r.get(z));for(const z of k.updated.values())if(!O.removed.has(z)&&!O.updated.has(z)){const H=x(z,!1);H&&(s.get(z)?.installed&&(H.installed=!0),s.set(z,H))}for(const z of k.removed.values())!c.has(z)&&!O.updated.has(z)&&u?.get(z)?.installed&&s.delete(z)}const S=[],g=T(i,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(g.added.size>0||g.updated.size>0||g.removed.size>0)&&s.forEach((k,O)=>S.push(n(k,O))),{local:{added:I,removed:E,updated:C},remote:S.length?{added:[...g.added].map(k=>s.get(k)),updated:[...g.updated].map(k=>s.get(k)),removed:[...g.removed].map(k=>i.get(k)),all:S}:null}}e.merge=R;function T(w,f,d,{checkInstalledProperty:l,checkVersionProperty:m}={checkInstalledProperty:!1,checkVersionProperty:!1}){const I=w?[...w.keys()].filter(o=>!d.has(o)):[],E=[...f.keys()].filter(o=>!d.has(o)),C=E.filter(o=>I.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),v=I.filter(o=>E.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),a=new Set;for(const o of I){if(v.has(o))continue;const t=w.get(o),r=f.get(o);(!r||t.disabled!==r.disabled||!y(t.state,r.state)||m&&t.version!==r.version||l&&t.installed!==r.installed)&&a.add(o)}return{added:C,removed:v,updated:a}}function A(w,f,d){const l=w.state,m=f.state,I=d?.state;if(!f.version||l&&L.gt(w.version,f.version))return l;if(m&&L.gt(f.version,w.version)||!l)return m;if(!m)return l;const E=(0,D.deepClone)(l),C=I?P(I,m):{added:Object.keys(m).reduce((a,o)=>(a.add(o),a),new Set),removed:new Set,updated:new Set},v=I?P(I,l):{added:Object.keys(l).reduce((a,o)=>(a.add(o),a),new Set),removed:new Set,updated:new Set};for(const a of[...C.added.values(),...C.updated.values()])E[a]=m[a];for(const a of C.removed.values())v.updated.has(a)||delete E[a];return E}function P(w,f){const d=Object.keys(w),l=Object.keys(f),m=l.filter(C=>d.indexOf(C)===-1).reduce((C,v)=>(C.add(v),C),new Set),I=d.filter(C=>l.indexOf(C)===-1).reduce((C,v)=>(C.add(v),C),new Set),E=new Set;for(const C of d){if(I.has(C))continue;const v=w[C],a=f[C];(0,D.equals)(v,a)||E.add(C)}return{added:m,removed:I,updated:E}}function y(w={},f={}){const{added:d,removed:l,updated:m}=P(w,f);return d.size===0&&l.size===0&&m.size===0}function b(w){return{...w,disabled:!!w.disabled,installed:!!w.installed}}function n(w,f){const d={identifier:{id:w.identifier.id,uuid:f.startsWith("uuid:")?f.substring("uuid:".length):void 0}};return w.version&&(d.version=w.version),w.disabled&&(d.disabled=!0),w.installed&&(d.installed=!0),w.state&&(d.state=w.state),d}}),define(Z[87],ee([0,1,22,3,2,31,7,28,19]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends R.Disposable{constructor(f,d){super();this.storageService=f,this.productService=d,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(l=>this.onDidChangeStorageValue(l)))}static toKey(f){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const d=b.exec(f);if(d&&d[1])return{id:d[1],version:d[2]}}initialize(){const f=this.storageService.keys(0,1);for(const d of f){const l=Ze.fromKey(d);l&&this.extensionsWithKeysForSync.add(l.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const d=Ze.fromKey(f.key);if(d){this.extensionsWithKeysForSync.add(d.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,d){this.storageService.store(Ze.toKey(f),JSON.stringify(d),0,1)}getKeysForSync(f){const d=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],l=this.storageService.get(Ze.toKey(f),0),m=l?JSON.parse(l):void 0;return m&&d?(0,D.distinct)([...m,...d]):m||d}};n=he([Y(0,y.IStorageService),Y(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[88],ee([0,1,22,24,7]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,y){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return b=b.filter(n=>n!==P&&n!==`-${P}`),y&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(P,y){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return b=b.filter(n=>n!==P&&n!==`-${P}`),y&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(P){const y=P.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),n=[],w=[];if(Array.isArray(b))for(const f of b)f.startsWith("-")?w.push(f.substring(1)):n.push(f);return(0,D.distinct)([...y,...n].filter(f=>w.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(y=>y.toLowerCase())}};T=he([Y(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(Z[197],ee([0,1,22,33,26,150,54]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(a){return(0,L.parse)(a)||[]}e.parseKeybindings=P;async function y(a,o,t,r,i){const s=P(a),u=P(o),c=t?P(t):null,h=[...s,...u,...c||[]].map($=>$.key),p=await i.resolveUserBindings(h);let S=n(s,u,c,p);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:a,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};const g=f(s),k=f(u),O=c?f(c):null,x=l(g,k,p),z=O?l(O,g,p):{added:[...g.keys()].reduce(($,M)=>($.add(M),$),new Set),removed:new Set,updated:new Set},H=O?l(O,k,p):{added:[...k.keys()].reduce(($,M)=>($.add(M),$),new Set),removed:new Set,updated:new Set},B=b(x,z,H);let U=a;for(const $ of B.removed.values())B.conflicts.has($)||(U=C(U,$,r));for(const $ of B.added.values()){if(B.conflicts.has($))continue;const M=k.get($);if(M.some(N=>N.command!==`-${$}`&&S.conflicts.has(p[N.key]))){B.conflicts.add($);continue}U=E(U,M,r)}for(const $ of B.updated.values()){if(B.conflicts.has($))continue;const M=k.get($);if(M.some(N=>N.command!==`-${$}`&&S.conflicts.has(p[N.key]))){B.conflicts.add($);continue}U=v(U,$,M,r)}return{mergeContent:U,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.merge=y;function b(a,o,t){const r=new Set,i=new Set,s=new Set,u=new Set;for(const c of o.removed.values())t.updated.has(c)&&u.add(c);for(const c of t.removed.values())u.has(c)||(o.updated.has(c)?u.add(c):i.add(c));for(const c of o.added.values())u.has(c)||t.added.has(c)&&a.updated.has(c)&&u.add(c);for(const c of t.added.values())u.has(c)||(o.added.has(c)?a.updated.has(c)&&u.add(c):r.add(c));for(const c of o.updated.values())u.has(c)||t.updated.has(c)&&a.updated.has(c)&&u.add(c);for(const c of t.updated.values())u.has(c)||(o.updated.has(c)?a.updated.has(c)&&u.add(c):s.add(c));return{added:r,removed:i,updated:s,conflicts:u}}function n(a,o,t,r){const i=new Set,s=w(a,r),u=w(o,r),c=t?w(t,r):null,h=d(s,u);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const p=c?d(c,s):{added:[...s.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const S=c?d(c,u):{added:[...u.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:g,removed:k,updated:O,conflicts:x}=b(h,p,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:g,removed:k,updated:O,conflicts:x}}function w(a,o){const t=new Map;for(const r of a){const i=o[r.key];let s=t.get(i);s||(s=[],t.set(i,s)),s.push(r)}return t}function f(a){const o=new Map;for(const t of a){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=o.get(r);i||(i=[],o.set(r,i)),i.push(t)}return o}function d(a,o){const t=[...a.keys()],r=[...o.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),s=t.filter(c=>r.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),u=new Set;for(const c of t){if(s.has(c))continue;const h=a.get(c).map(S=>({...S,key:c})),p=o.get(c).map(S=>({...S,key:c}));(0,D.equals)(h,p,(S,g)=>I(S,g))||u.add(c)}return{added:i,removed:s,updated:u}}function l(a,o,t){const r=[...a.keys()],i=[...o.keys()],s=i.filter(h=>r.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),u=r.filter(h=>i.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),c=new Set;for(const h of r){if(u.has(h))continue;const p=a.get(h).map(g=>({...g,key:t[g.key]})),S=o.get(h).map(g=>({...g,key:t[g.key]}));m(p,S)||c.add(h)}return{added:s,removed:u,updated:c}}function m(a,o){return!(!(0,D.equals)(a.filter(({command:t})=>t[0]!=="-"),o.filter(({command:t})=>t[0]!=="-"),(t,r)=>I(t,r))||!(0,D.equals)(a.filter(({command:t})=>t[0]==="-"),o.filter(({command:t})=>t[0]==="-"),(t,r)=>I(t,r)))}function I(a,o){if(a.command!==o.command||a.key!==o.key)return!1;const t=T.ContextKeyExpr.deserialize(a.when),r=T.ContextKeyExpr.deserialize(o.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!R.equals(a.args,o.args))}function E(a,o,t){for(const r of o)a=A.edit(a,[-1],r,t);return a}function C(a,o,t){const r=P(a);for(let i=r.length-1;i>=0;i--)(r[i].command===o||r[i].command===`-${o}`)&&(a=A.edit(a,[i],void 0,t));return a}function v(a,o,t,r){const i=P(a),s=i.findIndex(u=>u.command===o||u.command===`-${o}`);for(let u=i.length-1;u>=0;u--)(i[u].command===o||i[u].command===`-${o}`)&&(a=A.edit(a,[u],void 0,r));for(let u=t.length-1;u>=0;u--)a=A.edit(a,[s],t[u],r);return a}}),define(Z[198],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,A,P){const y={},b={},n=new Set;if(!A)return{local:{added:y,updated:b,removed:[...n.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const w=L(T,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:y,updated:b,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=L(P,T),d=L(P,A),l={},m={},I=new Set,E=new Set;for(const C of f.removed.values())d.updated.has(C)?y[C]=A[C]:I.add(C);for(const C of d.removed.values())E.has(C)||(f.updated.has(C)?E.add(C):n.add(C));for(const C of f.updated.values())E.has(C)||(d.updated.has(C)?w.updated.has(C)&&E.add(C):m[C]=T[C]);for(const C of d.updated.values())E.has(C)||(f.updated.has(C)?w.updated.has(C)&&E.add(C):T[C]!==void 0&&(b[C]=A[C]));for(const C of f.added.values())E.has(C)||(d.added.has(C)?w.updated.has(C)&&E.add(C):l[C]=T[C]);for(const C of d.added.values())E.has(C)||(f.added.has(C)?w.updated.has(C)&&E.add(C):y[C]=A[C]);return{local:{added:y,removed:[...n.values()],updated:b},remote:{added:l,removed:[...I.values()],updated:m},conflicts:[...E.values()]}}e.merge=D;function L(T,A){const P=T?Object.keys(T):[],y=A?Object.keys(A):[],b=y.filter(f=>P.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),n=P.filter(f=>y.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),w=new Set;for(const f of P){if(n.has(f))continue;const d=T[f],l=A[f];d!==l&&w.add(f)}return{added:b,removed:n,updated:w}}function R(T,A){const{added:P,removed:y,updated:b}=L(T,A);return P.size===0&&y.size===0&&b.size===0}e.areSame=R}),define(Z[21],ee([0,1,22,15,16,132,38,27,7,81,32]),function(K,e,D,L,R,T,A,P,y,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const c=n.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(h=>!!c[h].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function f(){const c=n.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(c).filter(g=>!!c[g].ignoreSync),p=Object.keys(c).filter(g=>c[g].scope===2||c[g].scope===6),S=w();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...h,...p,...S])}e.getDefaultIgnoredSettings=f;function d(){const c="vscode://schemas/ignoredSettings",h=n.Registry.as(A.Extensions.Configuration);h.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const p=n.Registry.as(b.Extensions.JSONContribution),S=()=>{const g=w(),k=f().filter(H=>H!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(H=>k.indexOf(H)===-1),x=k.filter(H=>g.indexOf(H)===-1),z={items:{type:"string",enum:[...O,...x.map(H=>`-${H}`)]}};p.registerSchema(c,z)};return h.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=d;function l(c){return c&&(0,R.isObject)(c)&&(0,R.isString)(c.id)&&(0,R.isArray)(c.scopes)}e.isAuthenticationProvider=l;var m;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(m=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function I(c,h,p){return p.joinPath(h.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=I,e.IUserDataSyncStoreManagementService=(0,y.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,y.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,y.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function E(c){const h={};return h[e.HEADER_EXECUTION_ID]=c,h}e.createSyncHeaders=E;var C;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(h,p,S,g){super(h);this.code=p,this.resource=S,this.operationId=g,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class a extends v{constructor(h,p,S,g,k){super(h,S,void 0,k);this.url=p,this.serverCode=g}}e.UserDataSyncStoreError=a;class o extends v{constructor(h,p){super(h,p)}}e.UserDataAutoSyncError=o,function(c){function h(p){if(p instanceof c)return p;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(p.name);if(S&&S[1]){const g=S[2]==="unknown"?void 0:S[2],k=S[3]==="unknown"?void 0:S[3];return new c(p.message,S[1],g,k)}return new c(p.message,"Unknown")}c.toUserDataSyncError=h}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(c){return`sync.enable.${c}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,y.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,y.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,y.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,y.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,y.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,y.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(c,h){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:h.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(p=>(0,L.isEqualOrParent)(c,(0,L.joinPath)(h.userDataSyncHome,p,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(Z[46],ee([0,1,22,6,25,29,3,33,2,15,23,16,5,128,24,12,13,45,19,20,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function o(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=o;let t=class extends y.Disposable{constructor(c,h,p,S,g,k,O,x,z,H){super();this.resource=c,this.fileService=h,this.environmentService=p,this.userDataSyncStoreService=g,this.userDataSyncBackupStoreService=k,this.userDataSyncResourceEnablementService=O,this.telemetryService=x,this.logService=z,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,n.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(p.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(p.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,a.PREVIEW_DIR_NAME),this.lastSyncResource=(0,a.getLastSyncResourceUri)(c,p,this.extUri),this.currentMachineIdPromise=(0,E.getServiceMachineId)(p,h,S)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,T.CancellationToken.None)).resourcePreviews.some(({remoteChange:p})=>p!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const h=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,h={}){await this._sync(c,!0,h)}async preview(c,h={}){return this._sync(c,!1,h)}async apply(c,h={}){try{this.syncHeaders={...h};const p=await this.doApply(c);return this.setStatus(p),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,h,p){try{if(this.syncHeaders={...p},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let S="idle";try{const g=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(c,g);return S=await this.performSync(k,g,h),S==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):S==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(S)}}finally{this.syncHeaders={}}}async replace(c){const h=await this.resolveContent(c);if(!h)return!1;const p=this.parseSyncData(h);if(!p)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const S=await this.getLastSyncUserData(),g=await this.getLatestRemoteUserData(null,S),k=await this.isRemoteDataFromCurrentMachine(g),O=await this.generateSyncPreview({ref:g.ref,syncData:p},S,k,T.CancellationToken.None),x=[];for(const z of O){const H=await this.getAcceptResult(z,z.remoteResource,void 0,T.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,T.CancellationToken.None);x.push([z,{...H,remoteChange:B!==0?B:2}])}await this.applyResult(g,S,x,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const h=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===h}async getLatestRemoteUserData(c,h){if(h){const p=c&&c.latest?c.latest[this.resource]:void 0;if(h.ref===p||p===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(c,h,p){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new a.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,h,p)}catch(S){if(S instanceof a.UserDataSyncError)switch(S.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,h,p);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(c,h,p)}throw S}}async doSync(c,h,p){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(g=>this.doGenerateSyncResourcePreview(c,h,p,g)));const S=await this.syncPreviewPromise;return this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":p?await this.doApply(!1):"syncing"}catch(S){throw this.syncPreviewPromise=null,S}}async merge(c){return await this.updateSyncResourcePreview(c,async h=>{const p=await this.getMergeResult(h,T.CancellationToken.None);await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(p?.content||""));const S=p&&!p.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,T.CancellationToken.None):void 0;return h.acceptResult=S,h.mergeState=p.hasConflicts?"conflict":S?"accepted":"preview",h.localChange=S?S.localChange:p.localChange,h.remoteChange=S?S.remoteChange:p.remoteChange,h}),this.syncPreviewPromise}async accept(c,h){return await this.updateSyncResourcePreview(c,async p=>{const S=await this.getAcceptResult(p,c,h,T.CancellationToken.None);return p.acceptResult=S,p.mergeState="accepted",p.localChange=S.localChange,p.remoteChange=S.remoteChange,p}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async h=>{const p=await this.getMergeResult(h,T.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,R.VSBuffer.fromString(p.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=p.localChange,h.remoteChange=p.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(c,h){if(!this.syncPreviewPromise)return;let p=await this.syncPreviewPromise;const S=p.resourcePreviews.findIndex(({localResource:g,remoteResource:k,previewResource:O})=>this.extUri.isEqual(g,c)||this.extUri.isEqual(k,c)||this.extUri.isEqual(O,c));S!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async g=>{const k=[...p.resourcePreviews];return k[S]=await h(k[S]),{...p,resourcePreviews:k}}),p=await this.syncPreviewPromise,this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:g})=>g==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(p=>[p,p.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const h=c.filter(({mergeState:p})=>p==="conflict");(0,D.equals)(this._conflicts,h,(p,S)=>this.extUri.isEqual(p.previewResource,S.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:p})=>({created:h,uri:this.toRemoteBackupResource(p)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:p})=>({created:h,uri:this.toLocalBackupResource(p)}))}toRemoteBackupResource(c){return f.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return f.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:p}=await this.getUserData(h);if(p)return this.parseSyncData(p)?.machineId}}async resolveContent(c){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:p}=await this.getUserData(h);return p}return this.extUri.isEqual(c,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(c){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const p of h.resourcePreviews){if(this.extUri.isEqual(p.acceptedResource,c))return p.acceptResult?p.acceptResult.content:null;if(this.extUri.isEqual(p.remoteResource,c))return p.remoteContent;if(this.extUri.isEqual(p.localResource,c))return p.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,h,p,S){const g=await this.isRemoteDataFromCurrentMachine(c),k=await this.generateSyncPreview(c,h,g,S),O=[];for(const x of k){const z=x.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)O.push({...x,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=p?await this.getMergeResult(x,S):void 0;if(S.isCancellationRequested)break;await this.fileService.writeFile(x.previewResource,R.VSBuffer.fromString(H?.content||""));const B=H&&!H.hasConflicts?await this.getAcceptResult(x,x.previewResource,void 0,S):void 0;O.push({...x,acceptResult:B,mergeState:H?.hasConflicts?"conflict":B?"accepted":"preview",localChange:B?B.localChange:H?H.localChange:x.localChange,remoteChange:B?B.remoteChange:H?H.remoteChange:x.remoteChange})}}return{remoteUserData:c,lastSyncUserData:h,resourcePreviews:O,isLastSyncFromCurrentMachine:g}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(c.value.toString()),p=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&p&&h.version!==p,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;const S=h;if(S.content===null)return{ref:h.ref,syncData:null};const g=JSON.parse(S.content);if(o(g))return{...h,syncData:g,content:void 0}}catch(c){c instanceof I.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const p=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),S={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:p,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(S)))}async getRemoteUserData(c){const{ref:h,content:p}=await this.getUserData(c);let S=null;return p!==null&&(S=this.parseSyncData(p)),{ref:h,syncData:S}}parseSyncData(c){try{const h=JSON.parse(c);if(o(h))return h}catch(h){this.logService.error(h)}throw new a.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,w.isString)(c)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:h}}else{const h=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(c,h){const p=await this.currentMachineIdPromise,S={version:this.version,machineId:p,content:c};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(S),h,this.syncHeaders),{ref:h,syncData:S}}async backupLocal(c){const h={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=he([Y(1,I.IFileService),Y(2,m.IEnvironmentService),Y(3,C.IStorageService),Y(4,a.IUserDataSyncStoreService),Y(5,a.IUserDataSyncBackupStoreService),Y(6,a.IUserDataSyncResourceEnablementService),Y(7,v.ITelemetryService),Y(8,a.IUserDataSyncLogService),Y(9,l.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(c,h,p,S,g,k,O,x,z,H,B){super(h,p,S,g,k,O,x,z,H,B);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,h,p){try{h?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(c),p?void 0:h):await this.fileService.createFile(this.file,R.VSBuffer.fromString(c),{overwrite:p})}catch(S){throw S instanceof I.FileOperationError&&S.fileOperationResult===1||S instanceof I.FileOperationError&&S.fileOperationResult===3?new a.UserDataSyncError(S.message,"LocalPreconditionFailed"):S}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=he([Y(2,I.IFileService),Y(3,m.IEnvironmentService),Y(4,C.IStorageService),Y(5,a.IUserDataSyncStoreService),Y(6,a.IUserDataSyncBackupStoreService),Y(7,a.IUserDataSyncResourceEnablementService),Y(8,v.ITelemetryService),Y(9,a.IUserDataSyncLogService),Y(10,l.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(c,h,p,S,g,k,O,x,z,H,B,U){super(c,h,p,S,g,k,O,x,z,H,U);this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(c){const h=[];return(0,P.parse)(c,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=he([Y(2,I.IFileService),Y(3,m.IEnvironmentService),Y(4,C.IStorageService),Y(5,a.IUserDataSyncStoreService),Y(6,a.IUserDataSyncBackupStoreService),Y(7,a.IUserDataSyncResourceEnablementService),Y(8,v.ITelemetryService),Y(9,a.IUserDataSyncLogService),Y(10,a.IUserDataSyncUtilService),Y(11,l.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let s=class{constructor(c,h,p,S){this.resource=c,this.environmentService=h,this.logService=p,this.fileService=S,this.extUri=this.fileService.hasCapability(h.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,a.getLastSyncResourceUri)(this.resource,h,b.extUri)}async initialize({ref:c,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const p=this.parseSyncData(h);if(!p)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:p})}catch(g){this.logService.error(g)}}parseSyncData(c){try{const h=JSON.parse(c);if(o(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,h={}){const p={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(p)))}};s=he([Y(1,m.IEnvironmentService),Y(2,a.IUserDataSyncLogService),Y(3,I.IFileService)],s),e.AbstractInitializer=s}),define(Z[199],ee([0,1,6,11,3,43,47,23,5,24,12,27,31,13,19,20,46,196,87,88,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function o(u,c){const h=JSON.parse(u.content);if(u.version===1||u.version===2){const p=(await c.getInstalled(0)).filter(S=>S.isBuiltin);for(const S of h)u.version===1&&(S.enabled===!1&&(S.disabled=!0),delete S.enabled),u.version===2&&p.every(g=>!(0,f.areSameExtensions)(g.identifier,S.identifier))&&(S.installed=!0)}return h}function t(u,c,h){const p=h.get((0,f.getExtensionId)(u,c),0)||"{}";return JSON.parse(p)}e.getExtensionStorageState=t;function r(u,c,h,p){p.store((0,f.getExtensionId)(u,c),JSON.stringify(h),0,1)}e.storeExtensionStorageState=r;let i=class at extends I.AbstractSynchroniser{constructor(c,h,p,S,g,k,O,x,z,H,B,U,$,M){super("extensions",h,c,p,S,g,U,$,z,B);this.storageService=p,this.extensionManagementService=k,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=x,this.extensionGalleryService=H,this.extensionsStorageSyncService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,N=>N.some(({local:j})=>!!j)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,N=>!N.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,h){const p=c.syncData?await o(c.syncData,this.extensionManagementService):null,S=h?.skippedExtensions||[],g=h?.syncData?await o(h.syncData,this.extensionManagementService):null,k=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(k),x=this.ignoredExtensionsManagementService.getIgnoredExtensions(k);p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:H}=(0,E.merge)(O,p,g,S,x),B={local:z,remote:H,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:S,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:p?this.format(p):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,h,p,S){const g=[...h,...p],k=new Set,O=x=>{k.add(x.id.toLowerCase()),x.uuid&&k.add(x.uuid)};g.forEach(({identifier:x})=>O(x)),S.forEach(O);for(const x of c)k.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&k.has(x.identifier.uuid)||g.push(x);return this.format(g)}async getMergeResult(c,h){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,h,p,S){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(h,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(c){const h=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),S=(0,E.merge)(c.localExtensions,null,null,c.skippedExtensions,p),{local:g,remote:k}=S;return{content:c.localContent,local:g,remote:k,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?2:0,remoteChange:k!==null?2:0}}async acceptRemote(c){const h=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),S=c.remoteContent?JSON.parse(c.remoteContent):null;if(S!==null){const g=(0,E.merge)(c.localExtensions,S,c.localExtensions,[],p),{local:k,remote:O}=g;return{content:c.remoteContent,local:k,remote:O,localChange:k.added.length>0||k.removed.length>0||k.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,h,p,S){let{skippedExtensions:g,localExtensions:k}=p[0][0],{local:O,remote:x,localChange:z,remoteChange:H}=p[0][1];if(z===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(k)),g=await this.updateLocalExtensions(O.added,O.removed,O.updated,g)),x){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const B=JSON.stringify(x.all);c=await this.updateRemoteUserData(B,S?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${x.added.length?` Added: ${JSON.stringify(x.added.map(U=>U.identifier.id))}.`:""}${x.updated.length?` Updated: ${JSON.stringify(x.updated.map(U=>U.identifier.id))}.`:""}${x.removed.length?` Removed: ${JSON.stringify(x.removed.map(U=>U.identifier.id))}.`:""}`)}h?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:g}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${g.length?` Skipped: ${JSON.stringify(g.map(B=>B.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,at.EXTENSIONS_DATA_URI)){const p=await this.extensionManagementService.getInstalled(),S=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),g=this.getLocalExtensions(p).filter(k=>!S.some(O=>(0,f.areSameExtensions)({id:O},k.identifier)));return this.format(g)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let h=await super.resolveContent(c);if(h)return h;if(h=await super.resolveContent(this.extUri.dirname(c)),h){const p=this.parseSyncData(h);if(p)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(p))}}return null}format(c){c.sort((S,g)=>!S.identifier.uuid&&g.identifier.uuid?-1:S.identifier.uuid&&!g.identifier.uuid?1:(0,P.compare)(S.identifier.id,g.identifier.id));const h=JSON.stringify(c),p=(0,A.format)(h,void 0,{});return(0,T.applyEdits)(h,p)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(p=>p.installed||p.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,h,p,S){const g=[],k=[],O=await this.extensionManagementService.getInstalled();if(h.length){const z=O.filter(({identifier:H,isBuiltin:B})=>!B&&h.some(U=>(0,f.areSameExtensions)(H,U)));await D.Promises.settled(z.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),g.push(H.identifier)}))}(c.length||p.length)&&await D.Promises.settled([...c,...p].map(async z=>{const H=O.find(U=>(0,f.areSameExtensions)(U.identifier,z.identifier));if(H&&H.isBuiltin){z.state&&H.manifest.version===z.version&&this.updateExtensionState(z.state,H.manifest.publisher,H.manifest.name,H.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),g.push(z.identifier);return}const B=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(H?H.manifest.version===z.version:!!B)){const U=H?H.manifest.publisher:B.publisher,$=H?H.manifest.name:B.name;this.updateExtensionState(z.state,U,$,H?.manifest.version)}if(B)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,B.version)),H||(await this.extensionManagementService.canInstall(B)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,B.version),g.push(B.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),k.push(z)))}catch(U){k.push(z),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.identifier.id),k.push(z)}));const x=[];for(const z of S)g.some(H=>(0,f.areSameExtensions)(H,z.identifier))||x.push(z);for(const z of k)x.some(H=>(0,f.areSameExtensions)(H.identifier,z.identifier))||x.push(z);return x}updateExtensionState(c,h,p,S){const g=t(h,p,this.storageService),k=S?this.extensionsStorageSyncService.getKeysForSync({id:(0,f.getGalleryExtensionId)(h,p),version:S}):void 0;k?k.forEach(O=>{g[O]=c[O]}):Object.keys(c).forEach(O=>g[O]=c[O]),r(h,p,g,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const h=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:p,isBuiltin:S,manifest:g})=>{const k={identifier:p,version:g.version};h.some(O=>(0,f.areSameExtensions)(O,p))&&(k.disabled=!0),S||(k.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:p.id,version:g.version});if(O){const x=t(g.publisher,g.name,this.storageService);k.state=Object.keys(x).reduce((z,H)=>(O.includes(H)&&(z[H]=x[H]),z),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(O))}return k})}};i.EXTENSIONS_DATA_URI=y.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=he([Y(0,n.IEnvironmentService),Y(1,d.IFileService),Y(2,l.IStorageService),Y(3,a.IUserDataSyncStoreService),Y(4,a.IUserDataSyncBackupStoreService),Y(5,w.IExtensionManagementService),Y(6,w.IGlobalExtensionEnablementService),Y(7,v.IIgnoredExtensionsManagementService),Y(8,a.IUserDataSyncLogService),Y(9,w.IExtensionGalleryService),Y(10,b.IConfigurationService),Y(11,a.IUserDataSyncResourceEnablementService),Y(12,m.ITelemetryService),Y(13,C.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let s=class extends I.AbstractInitializer{constructor(c,h,p,S,g){super("extensions",S,g,p);this.extensionManagementService=c,this.ignoredExtensionsManagementService=h}async parseExtensions(c){return c.syncData?await o(c.syncData,this.extensionManagementService):null}generatePreview(c,h){const p=[],S=[],g=[];for(const k of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(k.identifier.id))continue;const O=h.find(x=>(0,f.areSameExtensions)(x.identifier,k.identifier));O?(p.push(O),k.disabled&&g.push(k.identifier)):k.installed&&(S.push(k.identifier),k.disabled&&g.push(k.identifier))}return{installedExtensions:p,newExtensions:S,disabledExtensions:g,remoteExtensions:c}}};s=he([Y(0,w.IExtensionManagementService),Y(1,v.IIgnoredExtensionsManagementService),Y(2,d.IFileService),Y(3,n.IEnvironmentService),Y(4,a.IUserDataSyncLogService)],s),e.AbstractExtensionsInitializer=s}),define(Z[200],ee([0,1,26,21]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,y,b,n,w){if(!y)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const f=T(P,y);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const d=b?T(b,y):{added:Object.keys(y).reduce((C,v)=>(C.add(v),C),new Set),removed:new Set,updated:new Set},l=b?T(b,P):{added:Object.keys(P).reduce((C,v)=>(C.add(v),C),new Set),removed:new Set,updated:new Set},m={added:{},removed:[],updated:{}},I=D.deepClone(y),E=!b;for(const C of l.added.values())C!==L.SYNC_SERVICE_URL_TYPE&&E&&d.added.has(C)||(I[C]=P[C]);for(const C of l.updated.values())I[C]=P[C];for(const C of l.removed.values())n.unregistered.includes(C)||delete I[C];for(const C of d.added.values()){const v=y[C];if(n.machine.includes(C)){w.info(`GlobalState: Skipped adding ${C} in local storage because it is declared as machine scoped.`);continue}if(b&&l.added.has(C))continue;const a=P[C];a&&a.value===v.value||C===L.SYNC_SERVICE_URL_TYPE&&E&&l.added.has(C)||(a?m.updated[C]=v:m.added[C]=v)}for(const C of d.updated.values()){const v=y[C];if(n.machine.includes(C)){w.info(`GlobalState: Skipped updating ${C} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(C)||l.removed.has(C))continue;const a=P[C];a&&a.value===v.value||(m.updated[C]=v)}for(const C of d.removed.values()){if(n.machine.includes(C)){w.trace(`GlobalState: Skipped removing ${C} in local storage because it is declared as machine scoped.`);continue}l.updated.has(C)||l.removed.has(C)||m.removed.push(C)}return{local:m,remote:A(I,y)?null:I}}e.merge=R;function T(P,y){const b=Object.keys(P),n=Object.keys(y),w=n.filter(l=>b.indexOf(l)===-1).reduce((l,m)=>(l.add(m),l),new Set),f=b.filter(l=>n.indexOf(l)===-1).reduce((l,m)=>(l.add(m),l),new Set),d=new Set;for(const l of b){if(f.has(l))continue;const m=P[l],I=y[l];D.equals(m,I)||d.add(l)}return{added:w,removed:f,updated:d}}function A(P,y){const{added:b,removed:n,updated:w}=T(P,y);return b.size===0&&n.size===0&&w.size===0}}),define(Z[201],ee([0,1,25,3,33,43,47,4,5,30,24,12,13,14,45,19,20,46,54,200,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",t=["locale"];function r(h){const p=h.storage?Object.keys(h.storage).sort():[],S={};p.forEach(O=>S[O]=h.storage[O]),h.storage=S;const g=JSON.stringify(h),k=(0,A.format)(g,void 0,{});return(0,T.applyEdits)(g,k)}const i=1;let s=class ot extends E.AbstractSynchroniser{constructor(p,S,g,k,O,x,z,H,B){super("globalState",p,O,B,S,g,x,z,k,H);this.storageService=B,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:a.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(p.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(p.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter(B.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:B.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(p,S,g,k){const O=p.syncData?JSON.parse(p.syncData.content):null;S=S===null&&g?p:S;const x=S&&S.syncData?JSON.parse(S.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=this.getStorageKeys(x),{local:B,remote:U}=(0,v.merge)(z.storage,O?O.storage:null,x?x.storage:null,H,this.logService),$={content:null,local:B,remote:U,localChange:Object.keys(B.added).length>0||Object.keys(B.updated).length>0||B.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async getMergeResult(p,S){return{...p.previewResult,hasConflicts:!1}}async getAcceptResult(p,S,g,k){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(p);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(p);if(this.extUri.isEqual(S,this.previewResource))return p.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(p){return{content:p.localContent,local:{added:{},removed:[],updated:{}},remote:p.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(p){if(p.remoteContent!==null){const S=JSON.parse(p.remoteContent),{local:g,remote:k}=(0,v.merge)(p.localUserData.storage,S.storage,null,p.storageKeys,this.logService);return{content:p.remoteContent,local:g,remote:k,localChange:Object.keys(g.added).length>0||Object.keys(g.updated).length>0||g.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:p.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(p,S,g,k){let{localUserData:O}=g[0][0],{local:x,remote:z,localChange:H,remoteChange:B}=g[0][1];if(H===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),H!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState(x),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:z});p=await this.updateRemoteUserData(U,k?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}S?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:p}){return[{resource:this.extUri.joinPath(p,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(p){if(this.extUri.isEqual(p,ot.GLOBAL_STATE_DATA_URI)){const g=await this.getLocalGlobalState();return r(g)}if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let S=await super.resolveContent(p);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(p)),S){const g=this.parseSyncData(S);if(g)switch(this.extUri.basename(p)){case"globalState.json":return r(JSON.parse(g.content))}}return null}async hasLocalData(){try{const{storage:p}=await this.getLocalGlobalState();if(Object.keys(p).length>1||p[`${o}.locale`]?.value!=="en")return!0}catch(p){}return!1}async getLocalGlobalState(){const p={},S=await this.getLocalArgvContent(),g=(0,R.parse)(S);for(const k of t)g[k]!==void 0&&(p[`${o}${k}`]={version:1,value:g[k]});for(const k of this.storageService.keys(0,0)){const O=this.storageService.get(k,0);O&&(p[k]={version:1,value:O})}return{storage:p}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(p){}return"{}"}async writeLocalGlobalState({added:p,removed:S,updated:g}){const k={},O={},x=(H,B)=>{for(const U of H){if(U.startsWith(o)){k[U.substring(o.length)]=B?B[U].value:void 0;continue}if(B){const $=B[U];$.value!==String(this.storageService.get(U,0))&&(O[U]=$.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if(x(Object.keys(p),p),x(Object.keys(g),g),x(S),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const H of Object.keys(O))this.storageService.store(H,O[H],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(p){const S=await this.getLocalArgvContent();let g=S;for(const k of Object.keys(p))g=(0,C.edit)(g,[k],p[k],{});S!==g&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(g)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(p){const S=this.storageService.keys(0,0),g=this.storageService.keys(0,1),k=[...S,...g],O=p?.storage?Object.keys(p.storage).filter(x=>!x.startsWith(o)&&!k.includes(x)&&this.storageService.get(x,0)!==void 0):[];if(!P.isWeb){const x=[...a.ALL_SYNC_RESOURCES.map(z=>(0,a.getEnablementKey)(z)),a.SYNC_SERVICE_URL_TYPE];O.push(...x),g.push(...x)}return{user:S,machine:g,unregistered:O}}};s.GLOBAL_STATE_DATA_URI=y.URI.from({scheme:a.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=he([Y(0,f.IFileService),Y(1,a.IUserDataSyncStoreService),Y(2,a.IUserDataSyncBackupStoreService),Y(3,a.IUserDataSyncLogService),Y(4,w.IEnvironmentService),Y(5,a.IUserDataSyncResourceEnablementService),Y(6,I.ITelemetryService),Y(7,n.IConfigurationService),Y(8,m.IStorageService)],s),e.GlobalStateSynchroniser=s;let u=class extends E.AbstractInitializer{constructor(p,S,g,k){super("globalState",g,k,S);this.storageService=p}async doInitialize(p){const S=p.syncData?JSON.parse(p.syncData.content):null;if(!S){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const g={},k={};for(const O of Object.keys(S.storage))O.startsWith(o)?g[O.substring(o.length)]=S.storage[O].value:this.storageService.get(O,0)===void 0&&(k[O]=S.storage[O].value);if(Object.keys(g).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(x){}for(const x of Object.keys(g))O=(0,C.edit)(O,[x],g[x],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(O))}if(Object.keys(k).length)for(const O of Object.keys(k))this.storageService.store(O,k[O],0,0)}};u=he([Y(0,m.IStorageService),Y(1,f.IFileService),Y(2,w.IEnvironmentService),Y(3,a.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let c=class{constructor(p,S,g,k,O){this.userDataSyncStoreClient=p,this.storageService=S,this.environmentService=g,this.fileService=k,this.logService=O}getSyncStoreType(p){return this.parseGlobalState(p)?.storage[a.SYNC_SERVICE_URL_TYPE]?.value}async sync(p){const S=(0,a.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(p,S)}catch(g){if(g instanceof a.UserDataSyncError)switch(g.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(p,S)}throw g}}async doSync(p,S){const g=await this.userDataSyncStoreClient.read("globalState",null,S),k=this.parseGlobalState(g)||{storage:{}};k.storage[a.SYNC_SERVICE_URL_TYPE]={value:p,version:i};const O=await(0,l.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),x={version:i,machineId:O,content:r(k)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(x),g.ref,S)}parseGlobalState({content:p}){if(!p)return null;const S=JSON.parse(p);if((0,E.isSyncData)(S))return S?JSON.parse(S.content):null;throw new Error("Invalid remote data")}};c=he([Y(1,m.IStorageService),Y(2,w.IEnvironmentService),Y(3,f.IFileService),Y(4,d.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[202],ee([0,1,22,25,3,33,4,16,129,24,12,13,19,20,46,197,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(a,o){const t=JSON.parse(a);if(!o)return(0,P.isUndefined)(t.all)?null:t.all;switch(A.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let C=class extends l.AbstractJsonFileSynchroniser{constructor(o,t,r,i,s,u,c,h,p,S){super(c.keybindingsResource,"keybindings",u,c,h,o,t,s,S,r,p,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(i.onDidChangeConfiguration,g=>g.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,r,i){const s=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;t=t===null&&r?o:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),h=await this.getFormattingOptions();let p=null,S=!1,g=!1,k=!1;if(s){let x=c?c.value.toString():"[]";if(x=x||"[]",this.hasErrors(x))throw new I.UserDataSyncError((0,y.localize)(0,null),"LocalInvalidContent",this.resource);if(!u||u!==x||u!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,m.merge)(x,s,u,h,this.userDataSyncUtilService);z.hasChanges&&(p=z.mergeContent,k=z.hasConflicts,S=k||z.mergeContent!==x,g=k||z.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),p=c.value.toString(),g=!0);const O={content:p,localChange:S?c?2:1:0,remoteChange:g?2:0,hasConflicts:k};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,r,i){const{fileContent:s}=r[0][0];let{content:u,localChange:c,remoteChange:h}=r[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new I.UserDataSyncError((0,y.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(u||"[]",s,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const p=this.toSyncContent(u||"[]",o.syncData?.content);o=await this.updateRemoteUserData(p,i?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(p){}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,T.parse)(o.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"keybindings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(o)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(o.syncData.content)}getKeybindingsContentFromSyncContent(o){try{return E(o,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(o,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=o,A.OS){case 2:r.mac=o;break;case 3:r.linux=o;break;case 1:r.windows=o;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let o=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return o!==void 0||(o=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,o!==void 0)?o:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};C=he([Y(0,I.IUserDataSyncStoreService),Y(1,I.IUserDataSyncBackupStoreService),Y(2,I.IUserDataSyncLogService),Y(3,b.IConfigurationService),Y(4,I.IUserDataSyncResourceEnablementService),Y(5,w.IFileService),Y(6,n.IEnvironmentService),Y(7,f.IStorageService),Y(8,I.IUserDataSyncUtilService),Y(9,d.ITelemetryService)],C),e.KeybindingsSynchroniser=C;let v=class extends l.AbstractInitializer{constructor(o,t,r){super("keybindings",t,r,o)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(o.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return E(o,!0)}catch(t){return this.logService.error(t),null}}};v=he([Y(0,w.IFileService),Y(1,n.IEnvironmentService),Y(2,I.IUserDataSyncLogService)],v),e.KeybindingsInitializer=v}),define(Z[203],ee([0,1,22,33,43,47,26,54,21]),function(K,e,D,L,R,T,A,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(c,h,p){let S=[];p?S=w(p):S=n(h);const g=[],k=[...(0,y.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const O of S)O.startsWith("-")?k.push(O.substring(1)):g.push(O);return(0,D.distinct)([...c,...g].filter(O=>k.indexOf(O)===-1))}e.getIgnoredSettings=b;function n(c){let h=c.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=c.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:c.getValue("settingsSync.ignoredSettings")||[]}function w(c){const h=(0,L.parse)(c);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function f(c,h,p,S){if(p.length){const g=u(h),k=(0,L.parse)(h),O=(0,L.parse)(c),x=[];for(const z of p){const H=k[z],B=O[z];H===void 0?c=P.edit(c,[z],void 0,S):B!==void 0?c=P.edit(c,[z],H,S):x.push(o(z,g))}x.sort((z,H)=>z.startOffset-H.startOffset),x.forEach(z=>c=E(z.setting.key,h,c,S))}return c}e.updateIgnoredSettings=f;function d(c,h,p,S,g,k){const O=f(c,h,S,k),x=p!==O,z=p!==h;if(!x&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(x&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!x)return{conflictsSettings:[],localContent:f(h,c,S,k),remoteContent:null,hasConflicts:!1};if(p===null&&m(c)){const te=l(c,h,S)?null:f(h,c,S,k);return{conflictsSettings:[],localContent:te,remoteContent:null,hasConflicts:!1}}let H=c,B=h;const U=(0,L.parse)(c),$=(0,L.parse)(h),M=p?(0,L.parse)(p):null,N=S.reduce((te,oe)=>(te.add(oe),te),new Set),j=I(U,$,N),F=I(M,U,N),q=I(M,$,N),_=new Map,G=new Set,W=te=>{G.add(te);const oe=g.filter(({key:ue})=>ue===te)[0];oe?(H=P.edit(H,[te],oe.value,k),B=P.edit(B,[te],oe.value,k)):_.set(te,{key:te,localValue:U[te],remoteValue:$[te]})};for(const te of F.removed.values())q.updated.has(te)?W(te):B=P.edit(B,[te],void 0,k);for(const te of q.removed.values())G.has(te)||(F.updated.has(te)?W(te):H=P.edit(H,[te],void 0,k));for(const te of F.updated.values())G.has(te)||(q.updated.has(te)?j.updated.has(te)&&W(te):B=P.edit(B,[te],U[te],k));for(const te of q.updated.values())G.has(te)||(F.updated.has(te)?j.updated.has(te)&&W(te):H=P.edit(H,[te],$[te],k));for(const te of F.added.values())G.has(te)||(q.added.has(te)?j.updated.has(te)&&W(te):B=E(te,H,B,k));for(const te of q.added.values())G.has(te)||(F.added.has(te)?j.updated.has(te)&&W(te):H=E(te,B,H,k));const X=_.size>0||!l(H,B,S),Q=X||!l(H,c,[]),ie=X||!l(B,h,[]);return{localContent:Q?H:null,remoteContent:ie?B:null,conflictsSettings:[..._.values()],hasConflicts:X}}e.merge=d;function l(c,h,p){if(c===h)return!0;const S=(0,L.parse)(c),g=(0,L.parse)(h),k=p.reduce((z,H)=>(z.add(H),z),new Set),O=u(c).filter(z=>!(z.setting&&k.has(z.setting.key))),x=u(h).filter(z=>!(z.setting&&k.has(z.setting.key)));if(O.length!==x.length)return!1;for(let z=0;z<O.length;z++){const H=O[z],B=x[z];if(H.setting&&B.setting){if(H.setting.key!==B.setting.key||!A.equals(S[H.setting.key],g[H.setting.key]))return!1}else if(!H.setting&&!B.setting){if(H.value!==B.value)return!1}else return!1}return!0}e.areSame=l;function m(c){return c?u(c).length===0:!0}e.isEmpty=m;function I(c,h,p){const S=c?Object.keys(c).filter(z=>!p.has(z)):[],g=Object.keys(h).filter(z=>!p.has(z)),k=g.filter(z=>S.indexOf(z)===-1).reduce((z,H)=>(z.add(H),z),new Set),O=S.filter(z=>g.indexOf(z)===-1).reduce((z,H)=>(z.add(H),z),new Set),x=new Set;if(c)for(const z of S){if(O.has(z))continue;const H=c[z],B=h[z];A.equals(H,B)||x.add(z)}return{added:k,removed:O,updated:x}}function E(c,h,p,S){const g=(0,L.parse)(h),k=u(h),O=u(p),x=C(c,k,O);return v(p,c,g[c],x,O,S)}e.addSetting=E;function C(c,h,p){const S=h.findIndex(k=>k.setting?.key===c),g=h[S-1];if(g){if(g.setting){const O=o(g.setting.key,p);if(O)return{index:p.indexOf(O),insertAfter:!0}}else{const O=t(S,h);if(O){const x=o(O.setting.key,p);if(x){const z=r(p.indexOf(x),p),H=i(h,O,h[S]);if(z){const B=i(p,x,z),U=s(H,B);return U?{index:p.indexOf(U),insertAfter:!0}:{index:p.indexOf(z),insertAfter:!1}}else{const B=i(p,x,p[p.length-1]),U=s(H,B);return U?{index:p.indexOf(U),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const k=h[S+1];if(k)if(k.setting){const O=o(k.setting.key,p);if(O)return{index:p.indexOf(O),insertAfter:!1}}else{const O=r(S,h);if(O){const x=o(O.setting.key,p);if(x){const z=t(p.indexOf(x),p),H=i(h,h[S],O);if(z){const B=i(p,z,x),U=s(H.reverse(),B.reverse());return U?{index:p.indexOf(U),insertAfter:!1}:{index:p.indexOf(z),insertAfter:!0}}else{const B=i(p,p[0],x),U=s(H.reverse(),B.reverse());return U?{index:p.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function v(c,h,p,S,g,k){let O;return S.index===-1?O=(0,R.setProperty)(c,[h],p,k):O=a(c,h,p,S,g,k).map(x=>(0,R.withFormatting)(c,x,k)[0]),(0,R.applyEdits)(c,O)}function a(c,h,p,S,g,k){const O=`${JSON.stringify(h)}: ${JSON.stringify(p)}`,x=(0,T.getEOL)(k,c),z=g[S.index];if(S.insertAfter){const H=[];if(z.setting)H.push({offset:z.endOffset,length:0,content:","+O});else{const B=r(S.index,g),U=t(S.index,g),$=U?.setting?.commaOffset;U&&$===void 0&&H.push({offset:U.endOffset,length:0,content:","});const M=$!==void 0&&$>z.endOffset;H.push({offset:M?$+1:z.endOffset,length:0,content:B?x+O+",":x+O})}return H}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const H=(g[S.index-1]&&!g[S.index-1].setting?x:"")+O+(r(S.index,g)?",":"")+x;return[{offset:z.startOffset,length:0,content:H}]}}function o(c,h){return h.filter(p=>p.setting?.key===c)[0]}function t(c,h){for(let p=c-1;p>=0;p--)if(h[p].setting)return h[p]}function r(c,h){for(let p=c+1;p<h.length;p++)if(h[p].setting)return h[p]}function i(c,h,p){const S=c.indexOf(h),g=c.indexOf(p);return c.filter((k,O)=>S<O&&O<g)}function s(c,h){if(c.length&&h.length){let p=0;for(;p<h.length&&p<c.length;p++)if(c[p].value!==h[p].value)return h[p-1];return h[p-1]}}function u(c){const h=[];let p=-1,S,g;const k={onObjectBegin:O=>{p++},onObjectProperty:(O,x,z)=>{p===0&&(S=x,g=O)},onObjectEnd:(O,x)=>{p--,p===0&&h.push({startOffset:S,endOffset:O+x,value:c.substring(S,O+x),setting:{key:g,commaOffset:void 0}})},onArrayBegin:(O,x)=>{p++},onArrayEnd:(O,x)=>{p--,p===0&&h.push({startOffset:S,endOffset:O+x,value:c.substring(S,O+x),setting:{key:g,commaOffset:void 0}})},onLiteralValue:(O,x,z)=>{p===0&&h.push({startOffset:S,endOffset:x+z,value:c.substring(S,x+z),setting:{key:g,commaOffset:void 0}})},onSeparator:(O,x,z)=>{if(p===0&&O===","){let H=h.length-1;for(;H>=0&&!h[H].setting;H--);const B=h[H];B&&h.splice(H,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:x}})}},onComment:(O,x)=>{p===0&&h.push({startOffset:O,endOffset:O+x,value:c.substring(O,O+x)})}};return(0,L.visit)(c,k),h}}),define(Z[204],ee([0,1,25,3,43,130,24,12,27,13,19,20,46,54,203,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function I(o){return o&&o.settings&&typeof o.settings=="string"&&Object.keys(o).length===1}function E(o){const t=JSON.parse(o);return I(t)?t:{settings:o}}e.parseSettingsSyncContent=E;let C=class extends f.AbstractJsonFileSynchroniser{constructor(t,r,i,s,u,c,h,p,S,g,k){super(r.settingsResource,"settings",t,r,i,s,u,S,g,c,h,p);this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,s){const u=await this.getLocalFileContent(),c=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const p=r?this.getSettingsSyncContent(r):null,S=await this.getIgnoredSettings();let g=null,k=!1,O=!1,x=!1;if(h){let H=u?u.value.toString().trim():"{}";H=H||"{}",this.validateContent(H),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const B=(0,l.merge)(H,h.settings,p?p.settings:null,S,[],c);g=B.localContent||B.remoteContent,k=B.localContent!==null,O=B.remoteContent!==null,x=B.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),g=u.value.toString(),O=!0);const z={content:g,localChange:k?2:0,remoteChange:O?2:0,hasConflicts:x};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:h?h.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,l.updateIgnoredSettings)(t.previewResult.content,"{}",s,i):null}}async getAcceptResult(t,r,i,s){const u=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,l.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",c,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,l.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,l.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,s){const{fileContent:u}=i[0][0];let{content:c,localChange:h,remoteChange:p}=i[0][1];if(h===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(c,u,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),p!==0){const S=await this.getFormattingOptions(),g=this.getSettingsSyncContent(t),k=await this.getIgnoredSettings(c);c=(0,l.updateIgnoredSettings)(c,g?g.settings:"{}",k,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(S){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,d.edit)(t.value.toString(),[m.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,l.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const s=this.parseSettingsSyncContent(i.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,l.updateIgnoredSettings)(r,"{}",s,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:u})=>!!u)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,l.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new m.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!a(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let s=i.settings;const u=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const h=(0,R.setProperty)(s,[c],r[c],u);h.length&&(s=(0,R.applyEdits)(s,h))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(s))}catch(t){}}};C=he([Y(0,b.IFileService),Y(1,P.IEnvironmentService),Y(2,n.IStorageService),Y(3,m.IUserDataSyncStoreService),Y(4,m.IUserDataSyncBackupStoreService),Y(5,m.IUserDataSyncLogService),Y(6,m.IUserDataSyncUtilService),Y(7,A.IConfigurationService),Y(8,m.IUserDataSyncResourceEnablementService),Y(9,w.ITelemetryService),Y(10,y.IExtensionManagementService)],C),e.SettingsSynchroniser=C;let v=class extends f.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,l.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(r){this.logService.error(r)}return null}};v=he([Y(0,b.IFileService),Y(1,P.IEnvironmentService),Y(2,m.IUserDataSyncLogService)],v),e.SettingsInitializer=v;function a(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&o.machineId!==void 0&&typeof o.machineId=="string")}}),define(Z[205],ee([0,1,25,3,26,24,12,13,19,20,46,198,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let d=class extends n.AbstractSynchroniser{constructor(I,E,C,v,a,o,t,r,i){super("snippets",E,I,C,v,a,r,i,o,t);this.version=1,this.snippetsFolder=I.snippetsHome,this._register(this.fileService.watch(I.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(I,E,C,v){const a=await this.getSnippetsFileContents(),o=this.toSnippetsContents(a),t=I.syncData?this.parseSnippets(I.syncData):null;E=E===null&&C?I:E;const r=E&&E.syncData?this.parseSnippets(E.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,w.merge)(o,t,r);return this.getResourcePreviews(i,a,t||{})}async getMergeResult(I,E){return I.previewResult}async getAcceptResult(I,E,C,v){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:0,remoteChange:I.fileContent?I.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return C===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:C,localChange:C===null?I.fileContent!==null?3:0:2,remoteChange:C===null?I.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(I,E,C,v){const a=C.map(([o,t])=>({...o,acceptResult:t}));a.every(({localChange:o,remoteChange:t})=>o===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),a.some(({localChange:o})=>o!==0)&&(await this.updateLocalBackup(a),await this.updateLocalSnippets(a,v)),a.some(({remoteChange:o})=>o!==0)&&(I=await this.updateRemoteSnippets(a,I,v)),E?.ref!==I.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(I),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of a)try{await this.fileService.del(o)}catch(t){}}getResourcePreviews(I,E,C){const v=new Map;for(const a of Object.keys(I.local.added)){const o={content:I.local.added[a],hasConflicts:!1,localChange:1,remoteChange:0};v.set(a,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(I.local.updated)){const o={content:I.local.updated[a],hasConflicts:!1,localChange:2,remoteChange:0};v.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a],localContent:E[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of I.local.removed){const o={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a],localContent:E[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(I.remote.added)){const o={content:I.remote.added[a],hasConflicts:!1,localChange:0,remoteChange:1};v.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a],localContent:E[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(I.remote.updated)){const o={content:I.remote.updated[a],hasConflicts:!1,localChange:0,remoteChange:2};v.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a],localContent:E[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of I.remote.removed){const o={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of I.conflicts){const o={content:E[a]?E[a].value.toString():null,hasConflicts:!0,localChange:E[a]?2:1,remoteChange:C[a]?2:1};v.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a]||null,localContent:E[a]?E[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(E))if(!v.has(a)){const o={content:E[a]?E[a].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a]||null,localContent:E[a]?E[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:I}){let E=await super.resolveContent(I);if(E){const C=this.parseSyncData(E);if(C){const v=this.parseSnippets(C),a=[];for(const o of Object.keys(v)){const t=this.extUri.joinPath(I,o),r=this.extUri.joinPath(this.snippetsFolder,o),i=await this.fileService.exists(r);a.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})})}return a}}return[]}async resolveContent(I){if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(I);let E=await super.resolveContent(I);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(I)),E){const C=this.parseSyncData(E);if(C)return this.parseSnippets(C)[this.extUri.basename(I)]||null}return null}async hasLocalData(){try{const I=await this.getSnippetsFileContents();if(Object.keys(I).length)return!0}catch(I){}return!1}async updateLocalBackup(I){const E={};for(const C of I)C.fileContent&&(E[this.extUri.basename(C.localResource)]=C.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(I,E){for(const{fileContent:C,acceptResult:v,localResource:a,remoteResource:o,localChange:t}of I)if(t!==0){const r=o?this.extUri.basename(o):this.extUri.basename(a),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,D.VSBuffer.fromString(v.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,D.VSBuffer.fromString(v.content),E?void 0:C),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(I,E,C){const v=E.syncData?this.parseSnippets(E.syncData):{},a=(0,R.deepClone)(v);for(const{acceptResult:o,localResource:t,remoteResource:r,remoteChange:i}of I)if(i!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete a[s]:a[s]=o.content}return(0,w.areSame)(v,a)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(a),C?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(I){return JSON.parse(I.content)}toSnippetsContents(I){const E={};for(const C of Object.keys(I))E[C]=I[C].value.toString();return E}async getSnippetsFileContents(){const I={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(C){if(C instanceof P.FileOperationError&&C.fileOperationResult===1)return I;throw C}for(const C of E.children||[]){const v=C.resource,a=this.extUri.extname(v);if(a===".json"||a===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,v),t=await this.fileService.readFile(v);I[o]=t}}return I}};d=he([Y(0,A.IEnvironmentService),Y(1,P.IFileService),Y(2,y.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncBackupStoreService),Y(5,f.IUserDataSyncLogService),Y(6,T.IConfigurationService),Y(7,f.IUserDataSyncResourceEnablementService),Y(8,b.ITelemetryService)],d),e.SnippetsSynchroniser=d;let l=class extends n.AbstractInitializer{constructor(I,E,C){super("snippets",E,C,I)}async doInitialize(I){const E=I.syncData?JSON.parse(I.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(E)){const a=E[v];if(a){const o=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(o,D.VSBuffer.fromString(a)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(I)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===1}}};l=he([Y(0,P.IFileService),Y(1,A.IEnvironmentService),Y(2,f.IUserDataSyncLogService)],l),e.SnippetsInitializer=l}),define(Z[60],ee([0,1,3,2,7,21]),function(K,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(y){super();this.userDataSyncStoreService=y,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(y.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(y.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(y){(y&&this._account?y.token!==this._account.token||y.authenticationProviderId!==this._account.authenticationProviderId:y!==this._account)&&(this._account=y,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(y))}};A=he([Y(0,T.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(Z[206],ee([0,1,6,25,56,2,15,24,12,13,21]),function(K,e,D,L,R,T,A,P,y,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends T.Disposable{constructor(d,l,m,I){super();this.environmentService=d,this.fileService=l,this.configurationService=m,this.logService=I,n.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(d){const l=(0,A.joinPath)(this.environmentService.userDataSyncHome,d),m=await this.fileService.resolve(l);return m.children?m.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(d,l){if(!l){const m=await this.getAllRefs(d);m.length&&(l=m[m.length-1].ref)}if(l){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,d,l);return(await this.fileService.readFile(m)).value.toString()}return null}async backup(d,l){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,d),I=(0,A.joinPath)(m,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(I,L.VSBuffer.fromString(l))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(d)}catch(E){}}async cleanUpBackup(d){const l=(0,A.joinPath)(this.environmentService.userDataSyncHome,d);try{try{if(!await this.fileService.exists(l))return}catch(I){return}const m=await this.fileService.resolve(l);if(m.children){const I=m.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let C=I.filter(a=>Date.now()-this.getCreationTime(a)>E);const v=I.length-C.length;v<10&&(C=C.slice(10-v)),await D.Promises.settled(C.map(async a=>{this.logService.info("Deleting from backup",a.resource.path),await this.fileService.del(a.resource)}))}}catch(m){this.logService.error(m)}}getCreationTime(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};w=he([Y(0,y.IEnvironmentService),Y(1,b.IFileService),Y(2,P.IConfigurationService),Y(3,n.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(Z[207],ee([0,1,2,5]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(f){this.service=f}listen(f,d){switch(d){case"onError":return this.service.onError}throw new Error(`Event not found: ${d}`)}call(f,d,l){switch(d){case"triggerSync":return this.service.triggerSync(l[0],l[1],l[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(l[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(f){this.service=f}listen(f,d){throw new Error(`Event not found: ${d}`)}call(f,d,l){switch(d){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(l[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(l[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(f){this.service=f}listen(f,d){switch(d){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${d}`)}async call(f,d,l){switch(d){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(l[0],l[1]);case"setEnablement":return this.service.setEnablement(l[0],l[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class y{constructor(f){this.service=f}listen(f,d){switch(d){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${d}`)}call(f,d,l){switch(d){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(l)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=y;class b{constructor(f){this.service=f}listen(f,d){switch(d){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${d}`)}call(f,d,l){switch(d){case"switch":return this.service.switch(l[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class n extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:L.URI.revive(f.url),type:f.type,defaultUrl:L.URI.revive(f.defaultUrl),insidersUrl:L.URI.revive(f.insidersUrl),stableUrl:L.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[208],ee([0,1,12,14]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};R=he([Y(0,L.ILoggerService),Y(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(Z[61],ee([0,1,3,2,4,23,133,12,13,7,28,45,19,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const l="sync.currentMachineName";let m=class Ke extends L.Disposable{constructor(E,C,v,a,o,t){super();this.storageService=v,this.userDataSyncStoreService=a,this.logService=o,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(E,C,v)}async getMachines(E){const C=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(a=>({...a,isCurrent:a.id===C}))}async addCurrentMachine(E){const C=await this.currentMachineIdPromise,v=await this.readMachinesData(E);v.machines.some(({id:a})=>a===C)||(v.machines.push({id:C,name:this.computeCurrentMachineName(v.machines)}),await this.writeMachinesData(v))}async removeCurrentMachine(E){const C=await this.currentMachineIdPromise,v=await this.readMachinesData(E),a=v.machines.filter(({id:o})=>o!==C);a.length!==v.machines.length&&(v.machines=a,await this.writeMachinesData(v))}async renameMachine(E,C,v){const a=await this.currentMachineIdPromise,o=await this.readMachinesData(v),t=o.machines.find(({id:r})=>r===E);t&&(t.name=C,await this.writeMachinesData(o),o.machines.some(({id:r})=>r===a)&&this.storageService.store(l,C,0,1))}async setEnablement(E,C){const v=await this.readMachinesData(),a=v.machines.find(({id:o})=>o===E);a&&(a.disabled=C?void 0:!0,await this.writeMachinesData(v))}computeCurrentMachineName(E){const C=this.storageService.get(l,0);if(C)return C;const v=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,a=new RegExp(`${(0,T.escapeRegExpCharacters)(v)}\\s#(\\d+)`);let o=0;for(const t of E){const r=a.exec(t.name),i=r?parseInt(r[1]):0;o=i>o?i:o}return`${v} #${o+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const C=this.parse(this.userData);if(C.version!==Ke.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return C}async writeMachinesData(E){const C=JSON.stringify(E),v=await this.userDataSyncStoreService.write(Ke.RESOURCE,C,this.userData?.ref||null);this.userData={ref:v,content:C},this._onDidChange.fire()}async readUserData(E){if(this.userData){const C=E&&E.latest?E.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===C)return this.userData;if(C===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(C){this.logService.error(C)}return{version:Ke.VERSION,machines:[]}}};m.VERSION=1,m.RESOURCE="machines",m=he([Y(0,P.IEnvironmentService),Y(1,y.IFileService),Y(2,f.IStorageService),Y(3,d.IUserDataSyncStoreService),Y(4,d.IUserDataSyncLogService),Y(5,n.IProductService)],m),e.UserDataSyncMachinesService=m}),define(Z[89],ee([0,1,6,56,37,11,3,2,4,15,5,131,12,28,19,20,21,60,61]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const v="sync.enable",a="sync.disableMachineEventually",o="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let i=class extends P.Disposable{constructor(h,p,S){super();this.storageService=h,this.environmentService=p,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new A.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(h.onDidChangeValue(g=>this.onDidStorageChange(g)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||this.storageService.store(v,h,0,1)}onDidStorageChange(h){if(h.scope===0&&v===h.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([Y(0,l.IStorageService),Y(1,f.IEnvironmentService),Y(2,I.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let s=class extends P.Disposable{constructor(h,p,S,g,k,O,x,z,H,B,U){super();this.userDataSyncStoreManagementService=p,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=g,this.userDataSyncService=k,this.logService=O,this.userDataSyncAccountService=x,this.telemetryService=z,this.userDataSyncMachinesService=H,this.storageService=B,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=p.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=h.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(p.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,p.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=p.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(x.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(k.onDidChangeLocal,($,M)=>$?[...$,M]:[M],1e3)($=>this.triggerSync($,!1,!1))),this._register(A.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const h=this.storageService.get(t,0);return h?n.URI.parse(h):void 0}set syncUrl(h){h?this.storageService.store(t,h.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(h){h?this.storageService.store(r,h,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:h,message:p}=this.isAutoSyncEnabled();h?this.autoSync.value===void 0&&(this.autoSync.value=new u(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(p&&this.logService.info(p),this.autoSync.clear()):p&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(p))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(h,p,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),h?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(g){if(p)this.logService.error(g),this.updateEnablement(!1);else throw g}}updateEnablement(h){this.userDataAutoSyncEnablementService.isEnabled()!==h&&(this.telemetryService.publicLog2(v,{enabled:h}),this.userDataAutoSyncEnablementService.setEnablement(h),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(h){if(!h){this.successiveFailures=0;return}const p=I.UserDataSyncError.toUserDataSyncError(h);p instanceof I.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:p.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),p.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):p.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):p.code==="LocalTooManyRequests"||p.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):p.code==="UpgradeRequired"||p.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):p.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${p.resource} content with newer version than of client. Requires client upgrade.`)):p.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${p.resource} content with older version than of client. Requires server reset.`)):p.code==="ServiceChanged"||p.code==="DefaultServiceChanged"?y.isWeb&&p.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(p),this.successiveFailures++),this._onError.fire(p)}async disableMachineEventually(){this.storageService.store(a,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(a,0,!1)}stopDisableMachineEventually(){this.storageService.remove(a,0)}async triggerSync(h,p,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(p&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...h),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=he([Y(0,d.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncResourceEnablementService),Y(4,I.IUserDataSyncService),Y(5,I.IUserDataSyncLogService),Y(6,E.IUserDataSyncAccountService),Y(7,m.ITelemetryService),Y(8,C.IUserDataSyncMachinesService),Y(9,l.IStorageService),Y(10,I.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class u extends P.Disposable{constructor(h,p,S,g,k,O,x,z){super();this.lastSyncUrl=h,this.interval=p,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=g,this.userDataSyncService=k,this.userDataSyncMachinesService=O,this.logService=x,this.storageService=z,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(u.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(u.INTERVAL_SYNCING,!1),this.interval)}sync(h,p){const S=(0,D.createCancelablePromise)(async g=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(k){if((0,T.isPromiseCanceledError)(k))return}return this.doSync(h,p,g)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const h=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),p=this.userDataSyncStoreManagementService.userDataSyncStore;return!!p&&!!h&&(!(0,b.isEqual)(p.defaultUrl,h.defaultUrl)||!(0,b.isEqual)(p.insidersUrl,h.insidersUrl)||!(0,b.isEqual)(p.stableUrl,h.stableUrl))}async doSync(h,p,S){this.logService.info(`Auto Sync: Triggered by ${h}`),this._onDidStartSync.fire();let g;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,p),S.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new I.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new I.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new I.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const k=this.storageService.get(o,0);if(k&&this.manifest&&k!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new I.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new I.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new I.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(S.isCancellationRequested)return;const x=O.find(z=>z.isCurrent);if(x?.disabled)throw new I.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(z){throw new I.UserDataAutoSyncError((0,R.toErrorMessage)(z),z instanceof I.UserDataSyncError?z.code:"Unknown")}if(this.manifest&&this.manifest.session!==k&&this.storageService.store(o,this.manifest.session,0,1),S.isCancellationRequested)return;x||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(k){this.logService.error(k),g=k}this._onDidFinishSync.fire(g)}register(h){return super._register(h)}}u.INTERVAL_SYNCING="Interval"}),define(Z[209],ee([0,1,3,2,4,19,20,21]),function(K,e,D,L,R,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let y=class extends L.Disposable{constructor(n,w){super();this.storageService=n,this.telemetryService=w,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(f=>this.onDidStorageChange(f)))}isResourceEnabled(n){return this.storageService.getBoolean((0,P.getEnablementKey)(n),0,!0)}setResourceEnablement(n,w){if(this.isResourceEnabled(n)!==w){const f=(0,P.getEnablementKey)(n);this.telemetryService.publicLog2(f,{enabled:w}),this.storeResourceEnablement(f,w)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,w){this.storageService.store(n,w,0,R.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const w=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===n.key)[0];if(w){this._onDidChangeResourceEnablement.fire([w,this.isResourceEnabled(w)]);return}}}};y=he([Y(0,T.IStorageService),Y(1,A.ITelemetryService)],y),e.UserDataSyncResourceEnablementService=y}),define(Z[210],ee([0,1,22,6,37,11,3,2,15,30,7,19,20,199,201,202,204,205,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const v="sync.lastSyncTime";let a=class extends P.Disposable{constructor(i,s,u,c,h,p){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=s,this.instantiationService=u,this.logService=c,this.telemetryService=h,this.storageService=p,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(I.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(m.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(E.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(l.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(d.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(v,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeLocal,()=>S.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i,s){await this.checkEnablement();const u=(0,b.generateUuid)();try{const S=(0,C.createSyncHeaders)(u);s&&(S["Cache-Control"]="no-cache"),i=await this.userDataSyncStoreService.manifest(i,S)}catch(S){const g=C.UserDataSyncError.toUserDataSyncError(S);throw this.reportUserDataSyncError(g,u),g}let c=!1;const h=this;let p;return{manifest:i,run(){if(c)throw new Error("Can run a task only once");return p=(0,L.createCancelablePromise)(S=>h.sync(i,u,S)),p.finally(()=>p=void 0)},async stop(){if(p&&p.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,b.generateUuid)(),s=(0,C.createSyncHeaders)(i);let u;try{u=await this.userDataSyncStoreService.manifest(null,s)}catch(c){const h=C.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(h,i),h}return new o(i,u,s,this.synchronisers,this.logService)}async sync(i,s,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,C.createSyncHeaders)(s);for(const p of this.synchronisers){if(u.isCancellationRequested)return;try{await p.sync(i,h)}catch(S){let g=!1;if(S instanceof C.UserDataSyncError)switch(S.code){case"TooLarge":S=new C.UserDataSyncError(S.message,S.code,p.resource),g=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":g=!0;break}const k=C.UserDataSyncError.toUserDataSyncError(S);if(this.reportUserDataSyncError(k,s),g)throw k;this.logService.error(S),this.logService.error(`${p.resource}: ${(0,R.toErrorMessage)(S)}`),this._syncErrors.push([p.resource,k])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(h){const p=C.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(p,s),p}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(s){this.logService.error(s)}}async replace(i){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(i))return}async accept(i,s,u,c){await this.checkEnablement();const h=this.getSynchroniser(i);await h.accept(s,u),c&&await h.apply(!1,(0,C.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(i){for(const s of this.synchronisers){const u=await s.resolveContent(i);if(u)return u}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,s){return this.getSynchroniser(i).getAssociatedResources(s)}getMachineId(i,s){return this.getSynchroniser(i).getMachineId(s)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of i)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(v,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(s){this.logService.error(`${i.resource}: ${(0,R.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const s=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,D.equals)(this._conflicts,i,([s,u],[c,h])=>s===s&&(0,D.equals)(u,h,(p,S)=>(0,y.isEqual)(p.previewResource,S.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(v,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,s){this.telemetryService.publicLog2("sync/error",{code:i.code,serverCode:i instanceof C.UserDataSyncStoreError?String(i.serverCode):void 0,url:i instanceof C.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(s=>s.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=he([Y(0,C.IUserDataSyncStoreService),Y(1,C.IUserDataSyncStoreManagementService),Y(2,n.IInstantiationService),Y(3,C.IUserDataSyncLogService),Y(4,f.ITelemetryService),Y(5,w.IStorageService)],a),e.UserDataSyncService=a;class o extends P.Disposable{constructor(i,s,u,c,h){super();this.id=i,this.manifest=s,this.syncHeaders=u,this.synchronisers=c,this.logService=h,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,s){try{return await this.performAction(i,u=>u.accept(i,s))}catch(u){throw this.logService.error(u),u}}async merge(i){try{return i?await this.performAction(i,s=>s.merge(i)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(i){try{return await this.performAction(i,s=>s.discard(i))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,s]of this.previews)for(const u of s.resourcePreviews)u.mergeState==="conflict"&&i.push(u.previewResource);for(const s of i)await this.discard(s);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(p=>p.resource===s);for(const p of u.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&await c.merge(p.previewResource);const h=await c.apply(!1,this.syncHeaders);h&&i.push(this.toSyncResourcePreview(c.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of s.resourcePreviews)await u.accept(c.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,s]of this.previews){this.synchronizingResources.push([i,s.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of s.resourcePreviews)await u.accept(c.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(s){(0,T.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(i,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,x])=>x.resourcePreviews.some(({localResource:z,previewResource:H,remoteResource:B})=>(0,y.isEqual)(i,z)||(0,y.isEqual)(i,H)||(0,y.isEqual)(i,B)));if(u===-1)return this.previews;const[c,h]=this.previews[u],p=h.resourcePreviews.find(({localResource:x,remoteResource:z,previewResource:H})=>(0,y.isEqual)(x,i)||(0,y.isEqual)(z,i)||(0,y.isEqual)(H,i));if(!p)return this.previews;let S=this.synchronizingResources.find(x=>x[0]===c);S||(S=[c,[]],this.synchronizingResources.push(S)),S[1].some(x=>(0,y.isEqual)(x,p.localResource))||(S[1].push(p.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const g=this.synchronisers.find(x=>x.resource===this.previews[u][0]),k=await s(g);k?this.previews.splice(u,1,this.toSyncResourcePreview(g.resource,k)):this.previews.splice(u,1);const O=this.synchronizingResources.findIndex(x=>x[0]===c);return this.synchronizingResources[O][1].splice(S[1].findIndex(x=>(0,y.isEqual)(x,p.localResource)),1),S[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(p=>p.resource===s);let h=u;for(const p of u.resourcePreviews)(p.localChange!==0||p.remoteChange!==0)&&p.mergeState==="preview"&&(h=await c.merge(p.previewResource));h&&i.push(this.toSyncResourcePreview(c.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const s=[];for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const c=await u.preview(this.manifest,this.syncHeaders);c&&s.push(this.toSyncResourcePreview(u.resource,c))}return s}toSyncResourcePreview(i,s){return[i,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[211],ee([0,1,3,2,16,5,21]),function(K,e,D,L,R,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(w,f){this.service=w,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(w,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(w,f,d){try{return await this._call(w,f,d)}catch(l){throw this.logService.error(l),l}}async _call(w,f,d){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(d[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(d[0],T.URI.revive(d[1]),d[2],d[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(d[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(d[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(d[0]);case"getAssociatedResources":return this.service.getAssociatedResources(d[0],{created:d[1].created,uri:T.URI.revive(d[1].uri)});case"getMachineId":return this.service.getMachineId(d[0],{created:d[1].created,uri:T.URI.revive(d[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const l=f.substring("manualSync/".length),m=d[0],I=this.getManualSyncTask(m);switch(d=d.slice(1),l){case"preview":return I.preview();case"accept":return I.accept(T.URI.revive(d[0]),d[1]);case"merge":return I.merge(T.URI.revive(d[0]));case"discard":return I.discard(T.URI.revive(d[0]));case"discardConflicts":return I.discardConflicts();case"apply":return I.apply();case"pull":return I.pull();case"push":return I.push();case"stop":return I.stop();case"_getStatus":return I.status;case"dispose":return this.disposeManualSyncTask(I)}}throw new Error("Invalid call")}getManualSyncTask(w){const f=this.manualSyncTasks.get(this.createKey(w));if(!f)throw new Error(`Manual sync taks not found: ${w}`);return f.manualSyncTask}async createManualSyncTask(){const w=new L.DisposableStore,f=w.add(await this.service.createManualSyncTask());return w.add(f.onSynchronizeResources(d=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:d}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:w}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(w){w.dispose();const f=this.createKey(w.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(w){return`manualSyncTask-${w}`}}e.UserDataSyncChannel=P;class y extends L.Disposable{constructor(w){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,d,l){return w.call(f,d,l).then(null,m=>{throw A.UserDataSyncError.toUserDataSyncError(m)})},listen(f,d){return w.listen(f,d)}},this.channel.call("_getInitialData").then(([f,d,l])=>{this.updateStatus(f),this.updateConflicts(d),l&&this.updateLastSyncTime(l),this._register(this.channel.listen("onDidChangeStatus")(m=>this.updateStatus(m))),this._register(this.channel.listen("onDidChangeLastSyncTime")(m=>this.updateLastSyncTime(m)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([d,l])=>[d,A.UserDataSyncError.toUserDataSyncError(l)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:w,manifest:f,status:d}=await this.channel.call("createManualSyncTask"),l=this,m=new b(w,f,d,{async call(I,E,C){return l.channel.call(`manualSync/${I}`,[w,...(0,R.isArray)(E)?E:[E]],C)},listen(I,E){return D.Event.map(D.Event.filter(l.channel.listen(`manualSync/${I}`,E),C=>!m.isDiposed()&&C.manualSyncTaskId===w),C=>C.data)}});return m}replace(w){return this.channel.call("replace",[w])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(w,f,d,l){return this.channel.call("accept",[w,f,d,l])}resolveContent(w){return this.channel.call("resolveContent",[w])}async getLocalSyncResourceHandles(w){return(await this.channel.call("getLocalSyncResourceHandles",[w])).map(({created:d,uri:l})=>({created:d,uri:T.URI.revive(l)}))}async getRemoteSyncResourceHandles(w){return(await this.channel.call("getRemoteSyncResourceHandles",[w])).map(({created:d,uri:l})=>({created:d,uri:T.URI.revive(l)}))}async getAssociatedResources(w,f){return(await this.channel.call("getAssociatedResources",[w,f])).map(({resource:l,comparableResource:m})=>({resource:T.URI.revive(l),comparableResource:T.URI.revive(m)}))}async getMachineId(w,f){return this.channel.call("getMachineId",[w,f])}async updateStatus(w){this._status=w,this._onDidChangeStatus.fire(w)}async updateConflicts(w){this._conflicts=w.map(([f,d])=>[f,d.map(l=>({...l,localResource:T.URI.revive(l.localResource),remoteResource:T.URI.revive(l.remoteResource),previewResource:T.URI.revive(l.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(w){this._lastSyncTime!==w&&(this._lastSyncTime=w,this._onDidChangeLastSyncTime.fire(w))}}e.UserDataSyncChannelClient=y;class b extends L.Disposable{constructor(w,f,d,l){super();this.id=w,this.manifest=f,this._disposed=!1,this._status=d;const m=this;this.channel={async call(I,E,C){try{const v=await l.call(I,E,C);return m.isDiposed()||(m._status=await l.call("_getStatus")),v}catch(v){throw A.UserDataSyncError.toUserDataSyncError(v)}},listen(I,E){return l.listen(I,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const w=await this.channel.call("preview");return this.deserializePreviews(w)}async accept(w,f){const d=await this.channel.call("accept",[w,f]);return this.deserializePreviews(d)}async merge(w){const f=await this.channel.call("merge",[w]);return this.deserializePreviews(f)}async discard(w){const f=await this.channel.call("discard",[w]);return this.deserializePreviews(f)}async discardConflicts(){const w=await this.channel.call("discardConflicts");return this.deserializePreviews(w)}async apply(){const w=await this.channel.call("apply");return this.deserializePreviews(w)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(w){return w.map(([f,d])=>[f,{isLastSyncFromCurrentMachine:d.isLastSyncFromCurrentMachine,resourcePreviews:d.resourcePreviews.map(l=>({...l,localResource:T.URI.revive(l.localResource),remoteResource:T.URI.revive(l.remoteResource),previewResource:T.URI.revive(l.previewResource),acceptedResource:T.URI.revive(l.acceptedResource)}))}])}}}),define(Z[212],ee([0,1,6,29,11,3,2,95,4,15,16,5,30,24,12,13,28,42,45,19,21]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",s=100,u=1e3*60*5;let c=class extends A.Disposable{constructor(O,x,z){super();this.productService=O,this.configurationService=x,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(z.onDidChangeValue,H=>H.key===a.SYNC_SERVICE_URL_TYPE&&H.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(a.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(a.SYNC_SERVICE_URL_TYPE,O,0,y.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[a.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(a.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,x){O=y.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},...x||{}};if(z&&(0,n.isString)(z.url)&&(0,n.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(H=>(0,n.isArray)(z.authenticationProviders[H].scopes))){const H=z,B=!!H.canSwitch&&!x?.url,U=H.url===H.insidersUrl?"insiders":"stable",$=(B?this.userDataSyncStoreType:void 0)||U,M=x?.url||($==="insiders"?H.insidersUrl:$==="stable"?H.stableUrl:H.url);return{url:w.URI.parse(M),type:$,defaultType:U,defaultUrl:w.URI.parse(H.url),stableUrl:w.URI.parse(H.stableUrl),insidersUrl:w.URI.parse(H.insidersUrl),canSwitch:B,authenticationProviders:Object.keys(H.authenticationProviders).reduce((N,j)=>(N.push({id:j,scopes:H.authenticationProviders[j].scopes}),N),[])}}}};c=he([Y(0,I.IProductService),Y(1,d.IConfigurationService),Y(2,v.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let h=class extends c{constructor(O,x,z){super(O,x,z);const H=this.storageService.get(o,0);H&&(this.previousConfigurationSyncStore=JSON.parse(H));const B=this.productService[a.CONFIGURATION_SYNC_STORE_KEY];B?this.storageService.store(o,JSON.stringify(B),0,1):this.storageService.remove(o,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};h=he([Y(0,I.IProductService),Y(1,d.IConfigurationService),Y(2,v.IStorageService)],h),e.UserDataSyncStoreManagementService=h;let p=class extends A.Disposable{constructor(O,x,z,H,B,U,$){super();this.requestService=z,this.logService=H,this.storageService=$,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,C.getServiceMachineId)(B,U,$).then(M=>{const N={"X-Client-Name":`${x.applicationName}${y.isWeb?"-web":""}`,"X-Client-Version":x.version,"X-Machine-Id":M};return x.commit&&(N["X-Client-Commit"]=x.commit),N}),this.session=new g(s,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,x){this.authToken={token:O,type:x}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,b.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(x=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),x).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,x=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},H=await this.request(x.toString(),{type:"GET",headers:z},[],L.CancellationToken.None);return(await(0,E.asJson)(H)||[]).map(({url:U,created:$})=>({ref:(0,b.relativePath)(x,x.with({path:U})),created:$*1e3}))}async resolveContent(O,x){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,x).toString(),H={};H["Cache-Control"]="no-cache";const B=await this.request(z,{type:"GET",headers:H},[],L.CancellationToken.None);return await(0,E.asText)(B)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request(x,{type:"DELETE",headers:z},[],L.CancellationToken.None)}async read(O,x,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",x&&(z["If-None-Match"]=x.ref);const B=await this.request(H,{type:"GET",headers:z},[304],L.CancellationToken.None);let U=null;if(B.res.statusCode===304&&(U=x),U===null){const $=B.res.headers.etag;if(!$)throw new a.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",B.res.statusCode,B.res.headers[a.HEADER_OPERATION_ID]);const M=await(0,E.asText)(B);if(!M&&B.res.statusCode===304)throw new a.UserDataSyncStoreError("Empty response",H,"EmptyResponse",B.res.statusCode,B.res.headers[a.HEADER_OPERATION_ID]);U={ref:$,content:M}}return U}async write(O,x,z,H={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();H={...H},H["Content-Type"]=P.Mimes.text,z&&(H["If-Match"]=z);const U=await this.request(B,{type:"POST",data:x,headers:H},[],L.CancellationToken.None),$=U.res.headers.etag;if(!$)throw new a.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",U.res.statusCode,U.res.headers[a.HEADER_OPERATION_ID]);return $}async manifest(O,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();x={...x},x["Content-Type"]="application/json",O&&(x["If-None-Match"]=O.ref);const H=await this.request(z,{type:"GET",headers:x},[304],L.CancellationToken.None);let B=null;if(H.res.statusCode===304&&(B=O),!B){const $=H.res.headers.etag;if(!$)throw new a.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[a.HEADER_OPERATION_ID]);const M=await(0,E.asText)(H);if(!M&&H.res.statusCode===304)throw new a.UserDataSyncStoreError("Empty response",z,"EmptyResponse",H.res.statusCode,H.res.headers[a.HEADER_OPERATION_ID]);M&&(B={...JSON.parse(M),ref:$})}const U=this.storageService.get(r,0);return U&&B&&U!==B.session&&this.clearSession(),B===null&&U&&this.clearSession(),B&&this.storageService.store(r,B.session,0,1),B}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),x={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:x},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,x,z,H){if(!this.authToken)throw new a.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new a.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const B=await this.commonHeadersPromise;x.headers={...x.headers||{},...B,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(x.headers),this.logService.trace("Sending request to server",{url:O,type:x.type,headers:{...x.headers,authorization:void 0}});let U;try{U=await this.session.request(O,x,H)}catch(j){if(!(j instanceof a.UserDataSyncStoreError)){let F="RequestFailed";const q=(0,R.getErrorMessage)(j).toLowerCase();q.includes("xhr timeout")?F="RequestTimeout":q.includes("protocol")&&q.includes("not supported")?F="RequestProtocolNotSupported":q.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":q.includes("headers must be an object")?F="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(j)&&(F="RequestCanceled"),j=new a.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,F,void 0,void 0)}throw this.logService.info("Request failed",O),j}const $=U.res.headers[a.HEADER_OPERATION_ID],M={url:O,status:U.res.statusCode,"execution-id":x.headers[a.HEADER_EXECUTION_ID],"operation-id":$},N=(0,E.isSuccess)(U)||U.res.statusCode&&z.indexOf(U.res.statusCode)!==-1;if(N?this.logService.trace("Request succeeded",M):this.logService.info("Request failed",M),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new a.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,$);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new a.UserDataSyncStoreError(`${x.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,$);if(U.res.statusCode===410)throw new a.UserDataSyncStoreError(`${x.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,$);if(U.res.statusCode===412)throw new a.UserDataSyncStoreError(`${x.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,$);if(U.res.statusCode===413)throw new a.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,$);if(U.res.statusCode===426)throw new a.UserDataSyncStoreError(`${x.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,$);if(U.res.statusCode===429){const j=U.res.headers["retry-after"];throw j?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(j)*1e3)),new a.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,$)):new a.UserDataSyncStoreError(`${x.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,$)}if(!N)throw new a.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,$);return U}addSessionHeaders(O){let x=this.storageService.get(i,0);x===void 0&&(x=(0,f.generateUuid)(),this.storageService.store(i,x,0,1)),O["X-Machine-Session-Id"]=x;const z=this.storageService.get(r,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};p=he([Y(1,I.IProductService),Y(2,E.IRequestService),Y(3,a.IUserDataSyncLogService),Y(4,l.IEnvironmentService),Y(5,m.IFileService),Y(6,v.IStorageService)],p),e.UserDataSyncStoreClient=p;let S=class extends p{constructor(O,x,z,H,B,U,$){super(O.userDataSyncStore?.url,x,z,H,B,U,$);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};S=he([Y(0,a.IUserDataSyncStoreManagementService),Y(1,I.IProductService),Y(2,E.IRequestService),Y(3,a.IUserDataSyncLogService),Y(4,l.IEnvironmentService),Y(5,m.IFileService),Y(6,v.IStorageService)],S),e.UserDataSyncStoreService=S;class g{constructor(O,x,z,H){this.limit=O,this.interval=x,this.requestService=z,this.logService=H,this.requests=[],this.startTime=void 0}request(O,x,z){if(this.isExpired()&&this.reset(),x.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new a.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(x,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=g}),define(Z[213],ee([0,1,3,59,28,19,20,89,21,60,61]),function(K,e,D,L,R,T,A,P,y,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends P.UserDataAutoSyncService{constructor(d,l,m,I,E,C,v,a,o,t,r,i){super(d,l,m,I,E,v,a,o,t,r,i);this._register(D.Event.debounce(D.Event.any(D.Event.map(C.onDidFocusWindow,()=>"windowFocus"),D.Event.map(C.onDidOpenWindow,()=>"windowOpen")),(s,u)=>s?[...s,u]:[u],1e3)(s=>this.triggerSync(s,!0,!1)))}};w=he([Y(0,R.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncResourceEnablementService),Y(4,y.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,y.IUserDataSyncLogService),Y(7,b.IUserDataSyncAccountService),Y(8,A.ITelemetryService),Y(9,n.IUserDataSyncMachinesService),Y(10,T.IStorageService),Y(11,y.IUserDataAutoSyncEnablementService)],w),e.UserDataAutoSyncService=w}),define(Z[214],ee([0,1,6,3,2]),function(K,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:y,getActiveWindowId:b}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch(w){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(Z[62],ee([0,1,50,6,8,16,18,110,222,223]),function(K,e,D,L,R,T,A,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function w(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function f(o){if(o instanceof n)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new n(t,o)}function d(o,t,r,i,s,u){const c=R.dirname(t),h=R.join(i,c);if(!h.startsWith(i))return Promise.reject(new Error(P.localize(0,null,t)));const p=R.join(i,t);let S;return u.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(A.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((g,k)=>{if(!u.isCancellationRequested)try{S=(0,D.createWriteStream)(p,{mode:r}),S.once("close",()=>g()),S.once("error",k),o.once("error",k),o.pipe(S)}catch(O){k(O)}}))}function l(o,t,r,i){let s=(0,L.createCancelablePromise)(()=>Promise.resolve()),u=0;return i.onCancellationRequested(()=>{s.cancel(),o.close()}),new Promise((c,h)=>{const p=new L.Sequencer,S=g=>{g.isCancellationRequested||(u++,o.readEntry())};o.once("error",h),o.once("close",()=>s.then(()=>{i.isCancellationRequested||o.entryCount===u?c():h(new n("Incomplete",new Error(P.localize(1,null,u,o.entryCount))))},h)),o.readEntry(),o.on("entry",g=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(g.fileName)){S(i);return}const k=g.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(k)){const z=R.join(t,k);s=(0,L.createCancelablePromise)(H=>A.Promises.mkdir(z,{recursive:!0}).then(()=>S(H)).then(void 0,h));return}const O=I(o,g),x=w(g);s=(0,L.createCancelablePromise)(z=>p.queue(()=>O.then(H=>d(H,k,x,t,r,z).then(()=>S(z)))).then(null,h))})})}function m(o,t=!1){return new Promise((r,i)=>{(0,y.open)(o,t?{lazyEntries:!0}:void 0,(s,u)=>{s?i(f(s)):r((0,T.assertIsDefined)(u))})})}function I(o,t){return new Promise((r,i)=>{o.openReadStream(t,(s,u)=>{s?i(f(s)):r((0,T.assertIsDefined)(u))})})}function E(o,t){return new Promise((r,i)=>{const s=new b.ZipFile;t.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const u=(0,D.createWriteStream)(o);s.outputStream.pipe(u),s.outputStream.once("error",i),u.once("error",i),u.once("finish",()=>r(o))})}e.zip=E;function C(o,t,r={},i){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=m(o,!0);return r.overwrite&&(u=u.then(c=>A.Promises.rm(t).then(()=>c))),u.then(c=>l(c,t,{sourcePathRegex:s},i))}e.extract=C;function v(o,t){return m(o).then(r=>new Promise((i,s)=>{r.on("entry",u=>{u.fileName===t&&I(r,u).then(c=>i(c),c=>s(c))}),r.once("close",()=>s(new Error(P.localize(2,null,t))))}))}function a(o,t){return v(o,t).then(r=>new Promise((i,s)=>{const u=[];r.once("error",s),r.on("data",c=>u.push(c)),r.on("end",()=>i(Buffer.concat(u)))}))}e.buffer=a}),define(Z[215],ee([0,1,62,118]),function(K,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(Z[216],ee([0,1,22,6,11,2,17,8,4,15,58,5,30,18,62,119,12,27,31,141,13,14,28]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",s="extracting",u="deleting",c="renaming";let h=class extends T.Disposable{constructor(S,g,k,O,x){super();this.beforeRemovingExtension=S,this.fileService=g,this.logService=k,this.environmentService=O,this.productService=x,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(S){const g=[];(S===null||S===0)&&g.push(this.scanSystemExtensions().then(null,k=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(k).message,r)))),(S===null||S===1)&&g.push(this.scanUserExtensions(!0).then(null,k=>Promise.reject(new E.ExtensionManagementError(this.joinErrors(k).message,i))));try{const k=await Promise.all(g);return(0,D.flatten)(k)}catch(k){throw this.joinErrors(k)}}async scanUserExtensions(S){this.logService.trace("Started scanning user extensions");let[g,k]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return k=k.filter(O=>!g[new C.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),S&&(k=(0,C.groupByExtension)(k,x=>x.identifier).map(x=>x.sort((z,H)=>n.rcompare(z.manifest.version,H.manifest.version))[0])),this.logService.trace("Scanned user extensions:",k.length),k}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(S,g,k){const O=S.key(),x=P.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),z=P.join(this.extensionsPath,O);try{await d.Promises.rm(z)}catch(B){try{await d.Promises.rm(z)}catch(U){}throw new E.ExtensionManagementError((0,m.localize)(0,null,z,S.id),u)}await this.extractAtLocation(S,g,x,k);let H=await this.scanExtension(w.URI.file(x),1);if(!H)throw new Error((0,m.localize)(1,null,x));await this.storeMetadata(H,{installedTimestamp:Date.now()});try{await this.rename(S,x,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(B){try{await d.Promises.rm(x)}catch(U){}if(B.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",S.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(B)}. Deleted from extracted location`,x),B}try{H=await this.scanExtension(w.URI.file(z),1)}catch(B){}if(H)return H;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(S,g){return this.setMetadata(S,g),await this.storeMetadata(S,{...g,installedTimestamp:S.installedTimestamp}),S}async storeMetadata(S,g){g.isMachineScoped=g.isMachineScoped||void 0,g.isBuiltin=g.isBuiltin||void 0,g.installedTimestamp=g.installedTimestamp||void 0;const k=P.join(S.location.fsPath,"package.json"),O=await d.Promises.readFile(k,"utf8"),{manifest:x}=await this.parseManifest(O);return x.__metadata=g,await d.Promises.writeFile(k,JSON.stringify(x,null,"	")),S}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...S){const g=S.map(k=>new C.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version));await this.withUninstalledExtensions(k=>{g.forEach(O=>k[O.key()]=!0)})}async setInstalled(S){await this.withUninstalledExtensions(O=>delete O[S.key()]);const k=(await this.scanExtensions(1)).find(O=>new C.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(S))||null;return k?(await this.storeMetadata(k,{installedTimestamp:Date.now()}),this.scanExtension(k.location,1)):null}async withUninstalledExtensions(S){return this.uninstalledFileLimiter.queue(async()=>{let g;try{g=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let k={};if(g)try{k=JSON.parse(g)}catch(O){}return S&&(S(k),Object.keys(k).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(k)):await d.Promises.rm(this.uninstalledPath)),k})}async removeExtension(S,g){this.logService.trace(`Deleting ${g} extension from disk`,S.identifier.id,S.location.fsPath),await d.Promises.rm(S.location.fsPath),this.logService.info("Deleted from disk",S.identifier.id,S.location.fsPath)}async removeUninstalledExtension(S){await this.removeExtension(S,"uninstalled"),await this.withUninstalledExtensions(g=>delete g[new C.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()])}async extractAtLocation(S,g,k,O){this.logService.trace(`Started extracting the extension from ${g} to ${k}`);try{await d.Promises.rm(k)}catch(x){throw new E.ExtensionManagementError(this.joinErrors(x).message,u)}try{await(0,l.extract)(g,k,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${k}:`,S.id)}catch(x){try{await d.Promises.rm(k)}catch(z){}throw new E.ExtensionManagementError(x.message,x instanceof l.ExtractError&&x.type?x.type:s)}}async rename(S,g,k,O){try{await d.Promises.rename(g,k)}catch(x){if(y.isWindows&&x&&x.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${g} to ${k} with 'EPERM' error. Trying again...`,S.id),this.rename(S,g,k,O);throw new E.ExtensionManagementError(x.message||(0,m.localize)(3,null,g,k),x.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const S=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return S;const g=this.scanDevSystemExtensions(),[k,O]=await Promise.all([S,g]);return[...k,...O]}async scanExtensionsInDir(S,g){const k=new L.Limiter(10),O=await this.fileService.resolve(w.URI.file(S));return O.children?(await Promise.all(O.children.filter(z=>z.isDirectory).map(z=>k.queue(async()=>g===1&&(0,b.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,g))))).filter(z=>z&&z.identifier):[]}async scanExtension(S,g){try{const k=await this.fileService.resolve(S);if(k.children){const{manifest:O,metadata:x}=await this.readManifest(S.fsPath),z=k.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,H=k.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource,B={id:(0,C.getGalleryExtensionId)(O.publisher,O.name)},U={type:g,identifier:B,manifest:O,location:S,readmeUrl:z,changelogUrl:H,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:g===0};return x&&(this.setMetadata(U,x),U.installedTimestamp=x.installedTimestamp),U}}catch(k){g!==0&&this.logService.trace(k)}return null}async scanDefaultSystemExtensions(){const S=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",S.length),S}async scanDevSystemExtensions(){const S=this.getDevSystemExtensionsList();if(S.length){const g=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",g.length),g.filter(k=>S.some(O=>(0,C.areSameExtensions)(k.identifier,{id:O})))}else return[]}setMetadata(S,g){S.publisherDisplayName=g.publisherDisplayName||null,S.publisherId=g.publisherId||null,S.identifier.uuid=g.id,S.isMachineScoped=!!g.isMachineScoped,S.isBuiltin=S.type===0||!!g.isBuiltin}async removeUninstalledExtensions(){const S=await this.getUninstalledExtensions(),g=await this.scanAllUserExtensions(),k=new Set;for(const z of g)S[new C.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||k.add(z.identifier.id.toLowerCase());const O=(0,C.groupByExtension)(g,z=>z.identifier);await L.Promises.settled(O.map(async z=>{const H=z.sort((B,U)=>n.rcompare(B.manifest.version,U.manifest.version))[0];k.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(H)}));const x=g.filter(z=>S[new C.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await L.Promises.settled(x.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const S=await this.scanAllUserExtensions(),g=[],k=(0,C.groupByExtension)(S,O=>O.identifier);g.push(...(0,D.flatten)(k.map(O=>O.sort((x,z)=>n.rcompare(x.manifest.version,z.manifest.version)).slice(1)))),await L.Promises.settled(g.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(S=>S.name)}joinErrors(S){const g=Array.isArray(S)?S:[S];return g.length===1?g[0]instanceof Error?g[0]:new Error(g[0]):g.reduce((k,O)=>new Error(`${k.message}${k.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(A.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(S){const g=[d.Promises.readFile(P.join(S,"package.json"),"utf8").then(z=>this.parseManifest(z)),d.Promises.readFile(P.join(S,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:k,metadata:O},x]=await Promise.all(g);return{manifest:(0,v.localizeManifest)(k,x),metadata:O}}parseManifest(S){return new Promise((g,k)=>{try{const O=JSON.parse(S),x=O.__metadata||null;g({manifest:O,metadata:x})}catch(O){k(new Error((0,m.localize)(4,null)))}})}};h=he([Y(1,a.IFileService),Y(2,o.ILogService),Y(3,I.INativeEnvironmentService),Y(4,t.IProductService)],h),e.ExtensionsScanner=h}),define(Z[217],ee([0,1,37,17,8,4,15,58,5,30,18,62,117,74,12,183,27,31,164,165,215,152,216,166,72,13,7,14,44,20]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a,o,t,r,i,s,u,c,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const S="unsetUninstalled",g="downloading";let k=class extends m.AbstractExtensionManagementService{constructor(U,$,M,N,j,F,q){super(U,$,M);this.environmentService=N,this.downloadService=j;const _=this._register(F.createInstance(v.ExtensionsLifecycle));this.extensionsScanner=this._register(F.createInstance(t.ExtensionsScanner,W=>_.postUninstall(W))),this.manifestCache=this._register(new o.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(F.createInstance(C.ExtensionsDownloader));const G=this._register(new r.ExtensionsWatcher(this,q,N,M));this._register(G.onDidChangeExtensionsByAnotherSource(({added:W,removed:X})=>{W.length&&this._onDidInstallExtensions.fire(W.map(Q=>({identifier:Q.identifier,operation:0,local:Q}))),X.forEach(Q=>this._onDidUninstallExtension.fire({identifier:Q}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const $=await this.collectFiles(U),M=await(0,w.zip)((0,A.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)()).fsPath,$);return y.URI.file(M)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const $=await this.downloadVsix(U),M=R.resolve($.fsPath);return(0,a.getManifest)(M)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,$={}){this.logService.trace("ExtensionManagementService#install",U.toString());const M=await this.downloadVsix(U),N=await(0,a.getManifest)(R.resolve(M.fsPath));if(N.engines&&N.engines.vscode&&!(0,i.isEngineValid)(N.engines.vscode,h.default.version,h.default.date))throw new Error(f.localize(0,null,(0,E.getGalleryExtensionId)(N.publisher,N.name),h.default.version));return this.installExtension(N,M,$)}async updateMetadata(U,$){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...$}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,$){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:$}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===L.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const $=(0,A.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)());return await this.downloadService.download(U,$),$}createInstallExtensionTask(U,$,M){return y.URI.isUri($)?new z(U,$,M,this.galleryService,this.extensionsScanner,this.logService):new x($,M,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,$){return new H(U,$,this.extensionsScanner)}async collectFiles(U){const $=async N=>{let j=await n.Promises.readdir(N);j=j.map(_=>R.join(N,_));const F=await Promise.all(j.map(_=>n.Promises.stat(_)));let q=Promise.resolve([]);return F.forEach((_,G)=>{const W=j[G];_.isFile()&&(q=q.then(X=>[...X,W])),_.isDirectory()&&(q=q.then(X=>$(W).then(Q=>[...X,...Q])))}),q};return(await $(U.location.fsPath)).map(N=>({path:`extension/${R.relative(U.location.fsPath,N)}`,localPath:N}))}};k=he([Y(0,I.IExtensionGalleryService),Y(1,p.ITelemetryService),Y(2,c.ILogService),Y(3,l.INativeEnvironmentService),Y(4,(0,u.optional)(d.IDownloadService)),Y(5,u.IInstantiationService),Y(6,s.IFileService)],k),e.ExtensionManagementService=k;class O extends m.AbstractExtensionTask{constructor(U,$,M,N){super();this.identifier=U,this.source=$,this.extensionsScanner=M,this.logService=N,this._operation=1}get operation(){return this._operation}async installExtension(U,$){try{const M=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(M)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,U.metadata):M}catch(M){throw T.isMacintosh?new I.ExtensionManagementError(f.localize(1,null),S):new I.ExtensionManagementError(f.localize(2,null),S)}return this.extract(U,$)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const M=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),M}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:$,metadata:M},N){let j=await this.extensionsScanner.extractUserExtension($,U,N);return this.logService.info("Extracting completed.",$.id),M&&(j=await this.extensionsScanner.saveMetadataForLocalExtension(j,M)),j}}class x extends O{constructor(U,$,M,N,j){super(U.identifier,U,N,j);this.gallery=U,this.options=$,this.extensionsDownloader=M}async doRun(U){const M=(await this.extensionsScanner.scanExtensions(null)).find(F=>(0,E.areSameExtensions)(F.identifier,this.gallery.identifier));M&&(this._operation=2);const N=await this.downloadInstallableExtension(this.gallery,this._operation);N.metadata.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,N.metadata.isBuiltin=this.options.isBuiltin||M?.isBuiltin;const j=await this.installExtension(N,U);M&&P.neq(M.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(M);try{await this.extensionsDownloader.delete(y.URI.file(N.zipPath))}catch(F){}return j}async downloadInstallableExtension(U,$){const M={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",U.identifier.id),N=(await this.extensionsDownloader.downloadExtension(U,$)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,N)}catch(j){throw new I.ExtensionManagementError((0,m.joinErrors)(j).message,g)}try{const j=await(0,a.getManifest)(N);return{zipPath:N,identifierWithVersion:new E.ExtensionIdentifierWithVersion(U.identifier,j.version),metadata:M}}catch(j){throw new I.ExtensionManagementError((0,m.joinErrors)(j).message,m.INSTALL_ERROR_VALIDATING)}}}class z extends O{constructor(U,$,M,N,j,F){super({id:(0,E.getGalleryExtensionId)(U.publisher,U.name)},$,j,F);this.manifest=U,this.location=$,this.options=M,this.galleryService=N}async doRun(U){const $=new E.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1)).find(F=>(0,E.areSameExtensions)(this.identifier,F.identifier)),j=await this.getMetadata(this.identifier.id,U);if(N)if(j.isMachineScoped=this.options.isMachineScoped||N.isMachineScoped,j.isBuiltin=this.options.isBuiltin||N.isBuiltin,this._operation=2,$.equals(new E.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch(F){throw new Error(f.localize(3,null,this.manifest.displayName||this.manifest.name))}else P.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const F=await this.unsetUninstalledAndGetLocal($);if(F)try{await this.extensionsScanner.removeExtension(F,"existing")}catch(q){throw new Error(f.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:$,metadata:j},U)}async getMetadata(U,$){try{const M=(await this.galleryService.query({names:[U],pageSize:1},$)).firstPage[0];if(M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId}}catch(M){}return{}}}class H extends m.AbstractExtensionTask{constructor(U,$,M){super();this.extension=U,this.options=$,this.extensionsScanner=M}async doRun(U){const $=[],M=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=new E.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);$.push(...M.filter(j=>N.equals(new E.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else $.push(...M.filter(N=>(0,E.areSameExtensions)(N.identifier,this.extension.identifier)));if(!$.length)throw new Error(f.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...$),this.options.remove)for(const N of $)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(j){throw new Error(f.localize(6,null,(0,D.toErrorMessage)(j)))}}}}),define(Z[224],ee([0,1,104,50,225,34,37,11,2,17,15,5,36,103,171,151,172,161,162,163,149,153,24,174,73,182,74,176,12,138,178,184,27,140,185,217,75,142,13,168,170,52,7,158,78,159,160,57,167,14,79,59,44,28,175,42,19,180,181,20,82,84,83,53,186,187,85,189,195,87,88,89,21,60,206,207,208,61,209,210,211,212,213,214]),function(K,e,D,L,R,T,A,P,y,b,n,w,f,d,l,m,I,E,C,v,a,o,t,r,i,s,u,c,h,p,S,g,k,O,x,z,H,B,U,$,M,N,j,F,q,_,G,W,X,Q,ie,te,oe,ue,de,ve,Re,Te,Ne,Oe,ke,_e,Ie,Ae,Ye,Je,$e,je,J,re,se,me,pe,Pe,be,De,Ce,V,ne,ae,ce,fe,Se,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends y.Disposable{constructor(le){super();this.configuration=le,this.server=this._register(new d.Server),(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const le=()=>this.dispose();process.once("exit",le),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",le)}async open(){const le=await this.initServices();(0,pe.registerConfiguration)(),le.invokeFunction(Le=>{const Ue=Le.get(Q.ILogService);Ue.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Le),this.registerErrorHandler(Ue)}),this._register((0,y.combinedDisposable)(le.createInstance(l.CodeCacheCleaner,this.configuration.codeCachePath),le.createInstance(I.LanguagePackCachedDataCleaner),le.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),le.createInstance(C.LogsDataCleaner),le.createInstance(E.LocalizationsUpdater),le.createInstance(m.DeprecatedExtensionsCleaner)))}async initServices(){const le=new q.ServiceCollection,Le={_serviceBrand:void 0,...oe.default};le.set(ue.IProductService,Le);const Ue=new f.StaticRouter(We=>We==="main"),Fe=new _.MessagePortMainProcessService(this.server,Ue);le.set(G.IMainProcessService,Fe);const Me=new p.NativeEnvironmentService(this.configuration.args,Le);le.set(h.INativeEnvironmentService,Me);const et=new ie.LogLevelChannelClient(this.server.getChannel("logLevel",Ue)),Be=new ie.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));le.set(Q.ILoggerService,Be);const nt=this._register(new Q.MultiplexLogService([this._register(new Q.ConsoleLogger(this.configuration.logLevel)),this._register(Be.createLogger((0,n.joinPath)(w.URI.file(Me.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new ie.FollowerLogService(et,nt));le.set(Q.ILogService,Ve);const He=this._register(new $.FileService(Ve));le.set(U.IFileService,He);const it=this._register(new M.DiskFileSystemProvider(Ve));He.registerProvider(b.Schemas.file,it);const xe=this._register(new r.ConfigurationService(Me.settingsResource,He));le.set(t.IConfigurationService,xe),await xe.initialize();const Xe=new Te.NativeStorageService(void 0,Fe,Me);le.set(Re.IStorageService,Xe),await Xe.initialize(),this._register((0,y.toDisposable)(()=>Xe.flush())),le.set(ve.IRequestService,new N.SyncDescriptor(de.RequestService)),le.set(a.IChecksumService,new N.SyncDescriptor(o.ChecksumService));const tt=f.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});le.set(te.INativeHostService,tt),le.set(u.IDownloadService,new N.SyncDescriptor(c.DownloadService));const rt=this._register(new ge.ActiveWindowManager(tt)),ht=new f.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));le.set(H.IExtensionRecommendationNotificationService,new B.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,Ge;if(!Me.isExtensionDevelopment&&!Me.disableTelemetry&&Le.enableTelemetry){Ge=new _e.TelemetryLogAppender(Be,Me);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Me;if(Le.aiConfig&&Le.aiConfig.asimovKey&&dt){const ct=new Ye.AppInsightsAppender("monacoworkbench",null,Le.aiConfig.asimovKey);this._register((0,y.toDisposable)(()=>ct.flush())),Ge=(0,Ae.combinedAppender)(ct,Ge)}Qe=new Ie.TelemetryService({appender:Ge,commonProperties:(0,Ne.resolveCommonProperties)(He,(0,T.release)(),(0,T.hostname)(),process.arch,Le.commit,Le.version,this.configuration.machineId,Le.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},xe)}else Qe=Ae.NullTelemetryService,Ge=Ae.NullAppender;this.server.registerChannel("telemetryAppender",new ke.TelemetryAppenderChannel(Ge)),le.set(Oe.ITelemetryService,Qe);const ft=new Je.CustomEndpointTelemetryService(xe,Qe,Be,Me);return le.set(Oe.ICustomEndpointTelemetryService,ft),le.set(k.IExtensionManagementService,new N.SyncDescriptor(z.ExtensionManagementService)),le.set(k.IExtensionGalleryService,new N.SyncDescriptor(g.ExtensionGalleryService)),le.set(k.IExtensionTipsService,new N.SyncDescriptor(x.ExtensionTipsService)),le.set(W.ILocalizationsService,new N.SyncDescriptor(X.LocalizationsService)),le.set(i.IDiagnosticsService,new N.SyncDescriptor(s.DiagnosticsService)),le.set(Pe.IUserDataSyncAccountService,new N.SyncDescriptor(Pe.UserDataSyncAccountService)),le.set(pe.IUserDataSyncLogService,new N.SyncDescriptor(Ce.UserDataSyncLogService)),le.set(pe.IUserDataSyncUtilService,new De.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),le.set(k.IGlobalExtensionEnablementService,new N.SyncDescriptor(S.GlobalExtensionEnablementService)),le.set(se.IIgnoredExtensionsManagementService,new N.SyncDescriptor(se.IgnoredExtensionsManagementService)),le.set(re.IExtensionsStorageSyncService,new N.SyncDescriptor(re.ExtensionsStorageSyncService)),le.set(pe.IUserDataSyncStoreManagementService,new N.SyncDescriptor(fe.UserDataSyncStoreManagementService)),le.set(pe.IUserDataSyncStoreService,new N.SyncDescriptor(fe.UserDataSyncStoreService)),le.set(V.IUserDataSyncMachinesService,new N.SyncDescriptor(V.UserDataSyncMachinesService)),le.set(pe.IUserDataSyncBackupStoreService,new N.SyncDescriptor(be.UserDataSyncBackupStoreService)),le.set(pe.IUserDataAutoSyncEnablementService,new N.SyncDescriptor(me.UserDataAutoSyncEnablementService)),le.set(pe.IUserDataSyncResourceEnablementService,new N.SyncDescriptor(ne.UserDataSyncResourceEnablementService)),le.set(pe.IUserDataSyncService,new N.SyncDescriptor(ae.UserDataSyncService)),le.set(je.ILocalPtyService,this._register(new J.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")||1,useExperimentalSerialization:!!xe.getValue("terminal.integrated.persistentSessionExperimentalSerializer")},xe,Ve,Qe))),new F.InstantiationService(le)}initChannels(le){const Le=new O.ExtensionManagementChannel(le.get(k.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Le);const Ue=f.ProxyChannel.fromService(le.get(W.ILocalizationsService));this.server.registerChannel("localizations",Ue);const Fe=f.ProxyChannel.fromService(le.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Me=new O.ExtensionTipsChannel(le.get(k.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Me);const et=f.ProxyChannel.fromService(le.get(a.IChecksumService));this.server.registerChannel("checksum",et);const Be=new De.UserDataSyncMachinesServiceChannel(le.get(V.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Be);const nt=f.ProxyChannel.fromService(le.get(Oe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ve=new De.UserDataSyncAccountServiceChannel(le.get(Pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new De.UserDataSyncStoreManagementServiceChannel(le.get(pe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const it=new ce.UserDataSyncChannel(le.get(pe.IUserDataSyncService),le.get(Q.ILogService));this.server.registerChannel("userDataSync",it);const xe=this._register(le.get(j.IInstantiationService).createInstance(Se.UserDataAutoSyncService)),Xe=new De.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",Xe);const tt=le.get(je.ILocalPtyService),rt=f.ProxyChannel.fromService(tt);this.server.registerChannel($e.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(le){window.addEventListener("unhandledrejection",Le=>{(0,P.onUnexpectedError)(Le.reason),Le.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Le=>{const Ue=(0,A.toErrorMessage)(Le,!0);!Ue||le.error(`[uncaught exception in sharedProcess]: ${Ue}`)})}}async function we(Ee){const le=new ye(Ee);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await le.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58454f7bec838f79fe2422ab5914419147d82e40/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
