/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/errors","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/arrays","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],te=function(_){for(var t=[],T=0,D=_.length;T<D;T++)t[T]=Z[_[T]];return t};define(Z[57],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function T(D,S){if(!D)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}t.ok=T}),define(Z[44],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function T(O){return(C,u,h)=>{let g=null,p=null;if(typeof h.value=="function"?(g="value",p=h.value):typeof h.get=="function"&&(g="get",p=h.get),!p)throw new Error("not supported");h[g]=O(p,u)}}t.createDecorator=T;function D(O,C,u){let h=null,g=null;if(typeof u.value=="function"?(h="value",g=u.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(h="get",g=u.get),!g)throw new Error("not supported");const p=`$memoize$${C}`;u[h]=function(...m){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,m)}),this[p]}}t.memoize=D;function S(O,C,u){return T((h,g)=>{const p=`$debounce$${g}`,m=`$debounce$result$${g}`;return function(...L){this[m]||(this[m]=u?u():void 0),clearTimeout(this[p]),C&&(this[m]=C(this[m],...L),L=[this[m]]),this[p]=setTimeout(()=>{h.apply(this,L),this[m]=u?u():void 0},O)}})}t.debounce=S;function A(O,C,u){return T((h,g)=>{const p=`$throttle$timer$${g}`,m=`$throttle$result$${g}`,L=`$throttle$lastRun$${g}`,a=`$throttle$pending$${g}`;return function(...c){if(this[m]||(this[m]=u?u():void 0),(this[L]===null||this[L]===void 0)&&(this[L]=-Number.MAX_VALUE),C&&(this[m]=C(this[m],...c)),this[a])return;const b=this[L]+O;b<=Date.now()?(this[L]=Date.now(),h.apply(this,[this[m]]),this[m]=u?u():void 0):(this[a]=!0,this[p]=setTimeout(()=>{this[a]=!1,this[L]=Date.now(),h.apply(this,[this[m]]),this[m]=u?u():void 0},b-Date.now()))}})}t.throttle=A}),define(Z[24],te([0,1,8]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function D(y,F=0){return y[y.length-(1+F)]}t.tail=D;function S(y){if(y.length===0)throw new Error("Invalid tail call");return[y.slice(0,y.length-1),y[y.length-1]]}t.tail2=S;function A(y,F,P=(x,j)=>x===j){if(y===F)return!0;if(!y||!F||y.length!==F.length)return!1;for(let x=0,j=y.length;x<j;x++)if(!P(y[x],F[x]))return!1;return!0}t.equals=A;function O(y,F,P){let x=0,j=y.length-1;for(;x<=j;){const $=(x+j)/2|0,H=P(y[$],F);if(H<0)x=$+1;else if(H>0)j=$-1;else return $}return-(x+1)}t.binarySearch=O;function C(y,F){let P=0,x=y.length;if(x===0)return 0;for(;P<x;){const j=Math.floor((P+x)/2);F(y[j])?x=j:P=j+1}return P}t.findFirstInSorted=C;function u(y,F,P){if(y=y|0,y>=F.length)throw new TypeError("invalid index");let x=F[Math.floor(F.length*Math.random())],j=[],$=[],H=[];for(let ee of F){const ne=P(ee,x);ne<0?j.push(ee):ne>0?$.push(ee):H.push(ee)}return y<j.length?u(y,j,P):y<j.length+H.length?H[0]:u(y-(j.length+H.length),$,P)}t.quickSelect=u;function h(y,F){const P=[];let x;for(const j of y.slice(0).sort(F))!x||F(x[0],j)!==0?(x=[j],P.push(x)):x.push(j);return P}t.groupBy=h;function g(y,F,P){const x=[];function j(ee,ne,re){if(ne===0&&re.length===0)return;const ce=x[x.length-1];ce&&ce.start+ce.deleteCount===ee?(ce.deleteCount+=ne,ce.toInsert.push(...re)):x.push({start:ee,deleteCount:ne,toInsert:re})}let $=0,H=0;for(;;){if($===y.length){j($,0,F.slice(H));break}if(H===F.length){j($,y.length-$,[]);break}const ee=y[$],ne=F[H],re=P(ee,ne);re===0?($+=1,H+=1):re<0?(j($,1,[]),$+=1):re>0&&(j($,0,[ne]),H+=1)}return x}t.sortedDiff=g;function p(y,F,P){const x=g(y,F,P),j=[],$=[];for(const H of x)j.push(...y.slice(H.start,H.start+H.deleteCount)),$.push(...H.toInsert);return{removed:j,added:$}}t.delta=p;function m(y,F,P){if(P===0)return[];const x=y.slice(0,P).sort(F);return a(y,F,x,P,y.length),x}t.top=m;function L(y,F,P,x,j){return P===0?Promise.resolve([]):new Promise(($,H)=>{(async()=>{const ee=y.length,ne=y.slice(0,P).sort(F);for(let re=P,ce=Math.min(P+x,ee);re<ee;re=ce,ce=Math.min(ce+x,ee)){if(re>P&&await new Promise(me=>setTimeout(me)),j&&j.isCancellationRequested)throw(0,T.canceled)();a(y,F,ne,re,ce)}return ne})().then($,H)})}t.topAsync=L;function a(y,F,P,x,j){for(const $=P.length;x<j;x++){const H=y[x];if(F(H,P[$-1])<0){P.pop();const ee=C(P,ne=>F(H,ne)<0);P.splice(ee,0,H)}}}function c(y){return y.filter(F=>!!F)}t.coalesce=c;function b(y){let F=0;for(let P=0;P<y.length;P++)y[P]&&(y[F]=y[P],F+=1);y.length=F}t.coalesceInPlace=b;function v(y,F,P){y.splice(P,0,y.splice(F,1)[0])}t.move=v;function w(y){return!Array.isArray(y)||y.length===0}t.isFalsyOrEmpty=w;function f(y){return Array.isArray(y)&&y.length>0}t.isNonEmptyArray=f;function s(y,F){if(!F)return y.filter((x,j)=>y.indexOf(x)===j);const P=Object.create(null);return y.filter(x=>{const j=F(x);return P[j]?!1:(P[j]=!0,!0)})}t.distinct=s;function o(y){const F=new Set;return y.filter(P=>F.has(P)?!1:(F.add(P),!0))}t.distinctES6=o;function e(y){const F=Object.create(null);return P=>{const x=y(P);return F[x]?!1:(F[x]=!0,!0)}}t.uniqueFilter=e;function i(y,F){for(let P=y.length-1;P>=0;P--){const x=y[P];if(F(x))return P}return-1}t.lastIndex=i;function n(y,F){return y.length>0?y[0]:F}t.firstOrDefault=n;function r(y,F,P=(x,j)=>x===j){let x=0;for(let j=0,$=Math.min(y.length,F.length);j<$&&P(y[j],F[j]);j++)x++;return x}t.commonPrefixLength=r;function l(y){return[].concat(...y)}t.flatten=l;function d(y,F){let P=typeof F=="number"?y:0;typeof F=="number"?P=y:(P=0,F=y);const x=[];if(P<=F)for(let j=P;j<F;j++)x.push(j);else for(let j=P;j>F;j--)x.push(j);return x}t.range=d;function R(y,F,P){return y.reduce((x,j)=>(x[F(j)]=P?P(j):j,x),Object.create(null))}t.index=R;function M(y,F){return y.push(F),()=>I(y,F)}t.insert=M;function I(y,F){const P=y.indexOf(F);if(P>-1)return y.splice(P,1),F}t.remove=I;function k(y,F,P){const x=y.slice(0,F),j=y.slice(F);return x.concat(P,j)}t.arrayInsert=k;function z(y,F){let P;if(typeof F=="number"){let x=F;P=()=>{const j=Math.sin(x++)*179426549;return j-Math.floor(j)}}else P=Math.random;for(let x=y.length-1;x>0;x-=1){const j=Math.floor(P()*(x+1)),$=y[x];y[x]=y[j],y[j]=$}}t.shuffle=z;function q(y,F){const P=y.indexOf(F);P>-1&&(y.splice(P,1),y.unshift(F))}t.pushToStart=q;function J(y,F){const P=y.indexOf(F);P>-1&&(y.splice(P,1),y.push(F))}t.pushToEnd=J;function ie(y,F){return Array.isArray(y)?y.map(F):F(y)}t.mapArrayOrNot=ie;function se(y){return Array.isArray(y)?y:[y]}t.asArray=se;function Y(y){return y[Math.floor(Math.random()*y.length)]}t.getRandomElement=Y;function X(y,F){for(const P of y){const x=F(P);if(x!==void 0)return x}}t.mapFind=X;function Q(y,F,P){const x=W(y,F),j=y.length,$=P.length;y.length=j+$;for(let H=j-1;H>=x;H--)y[H+$]=y[H];for(let H=0;H<$;H++)y[H+x]=P[H]}t.insertInto=Q;function B(y,F,P,x){const j=W(y,F),$=y.splice(j,P);return Q(y,j,x),$}t.splice=B;function W(y,F){return F<0?Math.max(F+y.length,0):Math.min(F,y.length)}function U(y,F){let P=Number.MAX_SAFE_INTEGER,x=0;return y.forEach((j,$)=>{const H=F(j);H<P&&(P=H,x=$)}),x}t.minIndex=U;function E(y,F){let P=Number.MIN_SAFE_INTEGER,x=0;return y.forEach((j,$)=>{const H=F(j);H>P&&(P=H,x=$)}),x}t.maxIndex=E;class N{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let P=this.firstIdx;for(;P<this.items.length&&F(this.items[P]);)P++;const x=P===this.firstIdx?null:this.items.slice(this.firstIdx,P);return this.firstIdx=P,x}takeFromEndWhile(F){let P=this.lastIdx;for(;P>=0&&F(this.items[P]);)P--;const x=P===this.lastIdx?null:this.items.slice(P+1,this.lastIdx+1);return this.lastIdx=P,x}}t.ArrayQueue=N}),define(Z[58],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var T;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(T=t.ScanError||(t.ScanError={}));var D;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(D=t.SyntaxKind||(t.SyntaxKind={}));var S;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(S=t.ParseErrorCode||(t.ParseErrorCode={}));var A;(function(e){e.DEFAULT={allowTrailingComma:!0}})(A=t.ParseOptions||(t.ParseOptions={}));function O(e,i=!1){let n=0,r=e.length,l="",d=0,R=16,M=0;function I(Y){let X=0,Q=0;for(;X<Y;){const B=e.charCodeAt(n);if(B>=48&&B<=57)Q=Q*16+B-48;else if(B>=65&&B<=70)Q=Q*16+B-65+10;else if(B>=97&&B<=102)Q=Q*16+B-97+10;else break;n++,X++}return X<Y&&(Q=-1),Q}function k(Y){n=Y,l="",d=0,R=16,M=0}function z(){const Y=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&h(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&h(e.charCodeAt(n)))for(n++;n<e.length&&h(e.charCodeAt(n));)n++;else return M=3,e.substring(Y,n);let X=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&h(e.charCodeAt(n))){for(n++;n<e.length&&h(e.charCodeAt(n));)n++;X=n}else M=3;return e.substring(Y,X)}function q(){let Y="",X=n;for(;;){if(n>=r){Y+=e.substring(X,n),M=2;break}const Q=e.charCodeAt(n);if(Q===34){Y+=e.substring(X,n),n++;break}if(Q===92){if(Y+=e.substring(X,n),n++,n>=r){M=2;break}switch(e.charCodeAt(n++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const W=I(4);W>=0?Y+=String.fromCharCode(W):M=4;break;default:M=5}X=n;continue}if(Q>=0&&Q<=31)if(u(Q)){Y+=e.substring(X,n),M=2;break}else M=6;n++}return Y}function J(){if(l="",M=0,d=n,n>=r)return d=r,R=17;let Y=e.charCodeAt(n);if(C(Y)){do n++,l+=String.fromCharCode(Y),Y=e.charCodeAt(n);while(C(Y));return R=15}if(u(Y))return n++,l+=String.fromCharCode(Y),Y===13&&e.charCodeAt(n)===10&&(n++,l+=`
`),R=14;switch(Y){case 123:return n++,R=1;case 125:return n++,R=2;case 91:return n++,R=3;case 93:return n++,R=4;case 58:return n++,R=6;case 44:return n++,R=5;case 34:return n++,l=q(),R=10;case 47:const X=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!u(e.charCodeAt(n));)n++;return l=e.substring(X,n),R=12}if(e.charCodeAt(n+1)===42){n+=2;const Q=r-1;let B=!1;for(;n<Q;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,M=1),l=e.substring(X,n),R=13}return l+=String.fromCharCode(Y),n++,R=16;case 45:if(l+=String.fromCharCode(Y),n++,n===r||!h(e.charCodeAt(n)))return R=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=z(),R=11;default:for(;n<r&&ie(Y);)n++,Y=e.charCodeAt(n);if(d!==n){switch(l=e.substring(d,n),l){case"true":return R=8;case"false":return R=9;case"null":return R=7}return R=16}return l+=String.fromCharCode(Y),n++,R=16}}function ie(Y){if(C(Y)||u(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let Y;do Y=J();while(Y>=12&&Y<=15);return Y}return{setPosition:k,getPosition:()=>n,scan:i?se:J,getToken:()=>R,getTokenValue:()=>l,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>M}}t.createScanner=O;function C(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function h(e){return e>=48&&e<=57}var g;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(g||(g={}));function p(e,i){const n=[],r=new Object;let l;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let R=!1;function M(I,k,z,q){d.value=I,d.offset=k,d.length=z,d.type=q,d.colonOffset=void 0,l=d}try{f(e,{onObjectBegin:(I,k)=>{if(i<=I)throw r;l=void 0,R=i>I,n.push("")},onObjectProperty:(I,k,z)=>{if(i<k||(M(I,k,z,"property"),n[n.length-1]=I,i<=k+z))throw r},onObjectEnd:(I,k)=>{if(i<=I)throw r;l=void 0,n.pop()},onArrayBegin:(I,k)=>{if(i<=I)throw r;l=void 0,n.push(0)},onArrayEnd:(I,k)=>{if(i<=I)throw r;l=void 0,n.pop()},onLiteralValue:(I,k,z)=>{if(i<k||(M(I,k,z,o(I)),i<=k+z))throw r},onSeparator:(I,k,z)=>{if(i<=k)throw r;if(I===":"&&l&&l.type==="property")l.colonOffset=k,R=!1,l=void 0;else if(I===","){const q=n[n.length-1];typeof q=="number"?n[n.length-1]=q+1:(R=!0,n[n.length-1]=""),l=void 0}}})}catch(I){if(I!==r)throw I}return{path:n,previousNode:l,isAtPropertyKey:R,matches:I=>{let k=0;for(let z=0;k<I.length&&z<n.length;z++)if(I[k]===n[z]||I[k]==="*")k++;else if(I[k]!=="**")return!1;return k===I.length}}}t.getLocation=p;function m(e,i=[],n=A.DEFAULT){let r=null,l=[];const d=[];function R(I){Array.isArray(l)?l.push(I):r!==null&&(l[r]=I)}return f(e,{onObjectBegin:()=>{const I={};R(I),d.push(l),l=I,r=null},onObjectProperty:I=>{r=I},onObjectEnd:()=>{l=d.pop()},onArrayBegin:()=>{const I=[];R(I),d.push(l),l=I,r=null},onArrayEnd:()=>{l=d.pop()},onLiteralValue:R,onError:(I,k,z)=>{i.push({error:I,offset:k,length:z})}},n),l[0]}t.parse=m;function L(e,i=[],n=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(I){r.type==="property"&&(r.length=I-r.offset,r=r.parent)}function d(I){return r.children.push(I),I}f(e,{onObjectBegin:I=>{r=d({type:"object",offset:I,length:-1,parent:r,children:[]})},onObjectProperty:(I,k,z)=>{r=d({type:"property",offset:k,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:I,offset:k,length:z,parent:r})},onObjectEnd:(I,k)=>{r.length=I+k-r.offset,r=r.parent,l(I+k)},onArrayBegin:(I,k)=>{r=d({type:"array",offset:I,length:-1,parent:r,children:[]})},onArrayEnd:(I,k)=>{r.length=I+k-r.offset,r=r.parent,l(I+k)},onLiteralValue:(I,k,z)=>{d({type:o(I),offset:k,length:z,parent:r,value:I}),l(k+z)},onSeparator:(I,k,z)=>{r.type==="property"&&(I===":"?r.colonOffset=k:I===","&&l(k))},onError:(I,k,z)=>{i.push({error:I,offset:k,length:z})}},n);const M=r.children[0];return M&&delete M.parent,M}t.parseTree=L;function a(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===r){n=d.children[1],l=!0;break}if(!l)return}else{const l=r;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}t.findNodeAtLocation=a;function c(e){if(!e.parent||!e.parent.children)return[];const i=c(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=c;function b(e){switch(e.type){case"array":return e.children.map(b);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=b(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=b;function v(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=v;function w(e,i,n=!1){if(v(e,i,n)){const r=e.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=i;l++){const d=w(r[l],i,n);if(d)return d}return e}}t.findNodeAtOffset=w;function f(e,i,n=A.DEFAULT){const r=O(e,!1);function l(P){return P?()=>P(r.getTokenOffset(),r.getTokenLength()):()=>!0}function d(P){return P?x=>P(x,r.getTokenOffset(),r.getTokenLength()):()=>!0}const R=l(i.onObjectBegin),M=d(i.onObjectProperty),I=l(i.onObjectEnd),k=l(i.onArrayBegin),z=l(i.onArrayEnd),q=d(i.onLiteralValue),J=d(i.onSeparator),ie=l(i.onComment),se=d(i.onError),Y=n&&n.disallowComments,X=n&&n.allowTrailingComma;function Q(){for(;;){const P=r.scan();switch(r.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:Y||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(P){case 12:case 13:Y?B(10):ie();break;case 16:B(1);break;case 15:case 14:break;default:return P}}}function B(P,x=[],j=[]){if(se(P),x.length+j.length>0){let $=r.getToken();for(;$!==17;){if(x.indexOf($)!==-1){Q();break}else if(j.indexOf($)!==-1)break;$=Q()}}}function W(P){const x=r.getTokenValue();return P?q(x):M(x),Q(),!0}function U(){switch(r.getToken()){case 11:let P=0;try{P=JSON.parse(r.getTokenValue()),typeof P!="number"&&(B(2),P=0)}catch(x){B(2)}q(P);break;case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return Q(),!0}function E(){return r.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(J(":"),Q(),F()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function N(){R(),Q();let P=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(P||B(4,[],[]),J(","),Q(),r.getToken()===2&&X)break}else P&&B(6,[],[]);E()||B(4,[],[2,5]),P=!0}return I(),r.getToken()!==2?B(7,[2],[]):Q(),!0}function y(){k(),Q();let P=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(P||B(4,[],[]),J(","),Q(),r.getToken()===4&&X)break}else P&&B(6,[],[]);F()||B(4,[],[4,5]),P=!0}return z(),r.getToken()!==4?B(8,[4],[]):Q(),!0}function F(){switch(r.getToken()){case 3:return y();case 1:return N();case 10:return W(!0);default:return U()}}return Q(),r.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):F()?(r.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}t.visit=f;function s(e,i){let n=O(e),r=[],l,d=0,R;do switch(R=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:d!==R&&r.push(e.substring(d,R)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),d=n.getPosition();break}while(l!==17);return r.join("")}t.stripComments=s;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function _(S){const A=[];typeof S=="number"&&A.push("code/timeOrigin",S);function O(u){A.push(u,Date.now())}function C(){const u=[];for(let h=0;h<A.length;h+=2)u.push({name:A[h],startTime:A[h+1]});return u}return{mark:O,getMarks:C}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(S+O.startTime)});return A}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function T(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=t()),S.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=T(D))}(),function(_,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var T=t();for(var D in T)(typeof exports=="object"?exports:_)[D]=T[D]}}(typeof self!="undefined"?self:this,function(){return function(_){var t={};function T(D){if(t[D])return t[D].exports;var S=t[D]={i:D,l:!1,exports:{}};return _[D].call(S.exports,S,S.exports,T),S.l=!0,S.exports}return T.m=_,T.c=t,T.d=function(D,S,A){T.o(D,S)||Object.defineProperty(D,S,{enumerable:!0,get:A})},T.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},T.t=function(D,S){if(1&S&&(D=T(D)),8&S||4&S&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(T.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&S&&typeof D!="string")for(var O in D)T.d(A,O,function(C){return D[C]}.bind(null,O));return A},T.n=function(D){var S=D&&D.__esModule?function(){return D.default}:function(){return D};return T.d(S,"a",S),S},T.o=function(D,S){return Object.prototype.hasOwnProperty.call(D,S)},T.p="",T(T.s=0)}([function(_,t,T){(function(D){var S;t=_.exports=j,S=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,C=t.re=[],u=t.src=[],h=0,g=h++;u[g]="0|[1-9]\\d*";var p=h++;u[p]="[0-9]+";var m=h++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var L=h++;u[L]="("+u[g]+")\\.("+u[g]+")\\.("+u[g]+")";var a=h++;u[a]="("+u[p]+")\\.("+u[p]+")\\.("+u[p]+")";var c=h++;u[c]="(?:"+u[g]+"|"+u[m]+")";var b=h++;u[b]="(?:"+u[p]+"|"+u[m]+")";var v=h++;u[v]="(?:-("+u[c]+"(?:\\."+u[c]+")*))";var w=h++;u[w]="(?:-?("+u[b]+"(?:\\."+u[b]+")*))";var f=h++;u[f]="[0-9A-Za-z-]+";var s=h++;u[s]="(?:\\+("+u[f]+"(?:\\."+u[f]+")*))";var o=h++,e="v?"+u[L]+u[v]+"?"+u[s]+"?";u[o]="^"+e+"$";var i="[v=\\s]*"+u[a]+u[w]+"?"+u[s]+"?",n=h++;u[n]="^"+i+"$";var r=h++;u[r]="((?:<|>)?=?)";var l=h++;u[l]=u[p]+"|x|X|\\*";var d=h++;u[d]=u[g]+"|x|X|\\*";var R=h++;u[R]="[v=\\s]*("+u[d]+")(?:\\.("+u[d]+")(?:\\.("+u[d]+")(?:"+u[v]+")?"+u[s]+"?)?)?";var M=h++;u[M]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[w]+")?"+u[s]+"?)?)?";var I=h++;u[I]="^"+u[r]+"\\s*"+u[R]+"$";var k=h++;u[k]="^"+u[r]+"\\s*"+u[M]+"$";var z=h++;u[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=h++;u[q]="(?:~>?)";var J=h++;u[J]="(\\s*)"+u[q]+"\\s+",C[J]=new RegExp(u[J],"g");var ie=h++;u[ie]="^"+u[q]+u[R]+"$";var se=h++;u[se]="^"+u[q]+u[M]+"$";var Y=h++;u[Y]="(?:\\^)";var X=h++;u[X]="(\\s*)"+u[Y]+"\\s+",C[X]=new RegExp(u[X],"g");var Q=h++;u[Q]="^"+u[Y]+u[R]+"$";var B=h++;u[B]="^"+u[Y]+u[M]+"$";var W=h++;u[W]="^"+u[r]+"\\s*("+i+")$|^$";var U=h++;u[U]="^"+u[r]+"\\s*("+e+")$|^$";var E=h++;u[E]="(\\s*)"+u[r]+"\\s*("+i+"|"+u[R]+")",C[E]=new RegExp(u[E],"g");var N=h++;u[N]="^\\s*("+u[R]+")\\s+-\\s+("+u[R]+")\\s*$";var y=h++;u[y]="^\\s*("+u[M]+")\\s+-\\s+("+u[M]+")\\s*$";var F=h++;u[F]="(<|>)?=?\\s*\\*";for(var P=0;P<35;P++)S(P,u[P]),C[P]||(C[P]=new RegExp(u[P]));function x(V,G){if(V instanceof j)return V;if(typeof V!="string"||V.length>A||!(G?C[n]:C[o]).test(V))return null;try{return new j(V,G)}catch(K){return null}}function j(V,G){if(V instanceof j){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof j))return new j(V,G);S("SemVer",V,G),this.loose=G;var K=V.trim().match(G?C[n]:C[o]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var ae=+oe;if(ae>=0&&ae<O)return ae}return oe}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=x,t.valid=function(V,G){var K=x(V,G);return K?K.version:null},t.clean=function(V,G){var K=x(V.trim().replace(/^[=v]+/,""),G);return K?K.version:null},t.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(V){return S("SemVer.compare",this.version,this.loose,V),V instanceof j||(V=new j(V,this.loose)),this.compareMain(V)||this.comparePre(V)},j.prototype.compareMain=function(V){return V instanceof j||(V=new j(V,this.loose)),H(this.major,V.major)||H(this.minor,V.minor)||H(this.patch,V.patch)},j.prototype.comparePre=function(V){if(V instanceof j||(V=new j(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],oe=V.prerelease[G];if(S("prerelease compare",G,K,oe),K===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(K===void 0)return-1;if(K!==oe)return H(K,oe)}while(++G)},j.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,G,K,oe){typeof K=="string"&&(oe=K,K=void 0);try{return new j(V,K).inc(G,oe).version}catch(ae){return null}},t.diff=function(V,G){if(ce(V,G))return null;var K=x(V),oe=x(G);if(K.prerelease.length||oe.prerelease.length){for(var ae in K)if((ae==="major"||ae==="minor"||ae==="patch")&&K[ae]!==oe[ae])return"pre"+ae;return"prerelease"}for(var ae in K)if((ae==="major"||ae==="minor"||ae==="patch")&&K[ae]!==oe[ae])return ae},t.compareIdentifiers=H;var $=/^[0-9]+$/;function H(V,G){var K=$.test(V),oe=$.test(G);return K&&oe&&(V=+V,G=+G),K&&!oe?-1:oe&&!K?1:V<G?-1:V>G?1:0}function ee(V,G,K){return new j(V,K).compare(new j(G,K))}function ne(V,G,K){return ee(V,G,K)>0}function re(V,G,K){return ee(V,G,K)<0}function ce(V,G,K){return ee(V,G,K)===0}function me(V,G,K){return ee(V,G,K)!==0}function be(V,G,K){return ee(V,G,K)>=0}function ke(V,G,K){return ee(V,G,K)<=0}function Te(V,G,K,oe){var ae;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),ae=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),ae=V!==K;break;case"":case"=":case"==":ae=ce(V,K,oe);break;case"!=":ae=me(V,K,oe);break;case">":ae=ne(V,K,oe);break;case">=":ae=be(V,K,oe);break;case"<":ae=re(V,K,oe);break;case"<=":ae=ke(V,K,oe);break;default:throw new TypeError("Invalid operator: "+G)}return ae}function we(V,G){if(V instanceof we){if(V.loose===G)return V;V=V.value}if(!(this instanceof we))return new we(V,G);S("comparator",V,G),this.loose=G,this.parse(V),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}t.rcompareIdentifiers=function(V,G){return H(G,V)},t.major=function(V,G){return new j(V,G).major},t.minor=function(V,G){return new j(V,G).minor},t.patch=function(V,G){return new j(V,G).patch},t.compare=ee,t.compareLoose=function(V,G){return ee(V,G,!0)},t.rcompare=function(V,G,K){return ee(G,V,K)},t.sort=function(V,G){return V.sort(function(K,oe){return t.compare(K,oe,G)})},t.rsort=function(V,G){return V.sort(function(K,oe){return t.rcompare(K,oe,G)})},t.gt=ne,t.lt=re,t.eq=ce,t.neq=me,t.gte=be,t.lte=ke,t.cmp=Te,t.Comparator=we;var Fe={};function ve(V,G){if(V instanceof ve)return V.loose===G?V:new ve(V.raw,G);if(V instanceof we)return new ve(V.value,G);if(!(this instanceof ve))return new ve(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Re(V){return!V||V.toLowerCase()==="x"||V==="*"}function je(V,G,K,oe,ae,Se,de,Le,ye,De,Ae,Ee,Ie){return((G=Re(K)?"":Re(oe)?">="+K+".0.0":Re(ae)?">="+K+"."+oe+".0":">="+G)+" "+(Le=Re(ye)?"":Re(De)?"<"+(+ye+1)+".0.0":Re(Ae)?"<"+ye+"."+(+De+1)+".0":Ee?"<="+ye+"."+De+"."+Ae+"-"+Ee:"<="+Le)).trim()}function Be(V,G){for(var K=0;K<V.length;K++)if(!V[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<V.length;K++)if(S(V[K].semver),V[K].semver!==Fe&&V[K].semver.prerelease.length>0){var oe=V[K].semver;if(oe.major===G.major&&oe.minor===G.minor&&oe.patch===G.patch)return!0}return!1}return!0}function xe(V,G,K){try{G=new ve(G,K)}catch(oe){return!1}return G.test(V)}function ze(V,G,K,oe){var ae,Se,de,Le,ye;switch(V=new j(V,oe),G=new ve(G,oe),K){case">":ae=ne,Se=ke,de=re,Le=">",ye=">=";break;case"<":ae=re,Se=be,de=ne,Le="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(V,G,oe))return!1;for(var De=0;De<G.set.length;++De){var Ae=G.set[De],Ee=null,Ie=null;if(Ae.forEach(function(Ce){Ce.semver===Fe&&(Ce=new we(">=0.0.0")),Ee=Ee||Ce,Ie=Ie||Ce,ae(Ce.semver,Ee.semver,oe)?Ee=Ce:de(Ce.semver,Ie.semver,oe)&&(Ie=Ce)}),Ee.operator===Le||Ee.operator===ye||(!Ie.operator||Ie.operator===Le)&&Se(V,Ie.semver)||Ie.operator===ye&&de(V,Ie.semver))return!1}return!0}we.prototype.parse=function(V){var G=this.loose?C[W]:C[U],K=V.match(G);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new j(K[2],this.loose):this.semver=Fe},we.prototype.toString=function(){return this.value},we.prototype.test=function(V){return S("Comparator.test",V,this.loose),this.semver===Fe||(typeof V=="string"&&(V=new j(V,this.loose)),Te(V,this.operator,this.semver,this.loose))},we.prototype.intersects=function(V,G){if(!(V instanceof we))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ve(V.value,G),xe(this.value,K,G);if(V.operator==="")return K=new ve(this.value,G),xe(V.semver,K,G);var oe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Se=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=Te(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ye=Te(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return oe||ae||Se&&de||Le||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),S("range",V,G);var K=G?C[y]:C[N];V=V.replace(K,je),S("hyphen replace",V),V=V.replace(C[E],"$1$2$3"),S("comparator trim",V,C[E]),V=(V=(V=V.replace(C[J],"$1~")).replace(C[X],"$1^")).split(/\s+/).join(" ");var oe=G?C[W]:C[U],ae=V.split(" ").map(function(Se){return function(de,Le){return S("comp",de),de=function(ye,De){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,Ie){S("caret",Ee,Ie);var Ce=Ie?C[B]:C[Q];return Ee.replace(Ce,function(Oe,le,he,ge,pe){var Pe;return S("caret",Ee,Oe,le,he,ge,pe),Re(le)?Pe="":Re(he)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Pe=le==="0"?">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":">="+le+"."+he+".0 <"+(+le+1)+".0.0":pe?(S("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=le==="0"?he==="0"?">="+le+"."+he+"."+ge+pe+" <"+le+"."+he+"."+(+ge+1):">="+le+"."+he+"."+ge+pe+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+ge+pe+" <"+(+le+1)+".0.0"):(S("no pr"),Pe=le==="0"?he==="0"?">="+le+"."+he+"."+ge+" <"+le+"."+he+"."+(+ge+1):">="+le+"."+he+"."+ge+" <"+le+"."+(+he+1)+".0":">="+le+"."+he+"."+ge+" <"+(+le+1)+".0.0"),S("caret return",Pe),Pe})}(Ae,De)}).join(" ")}(de,Le),S("caret",de),de=function(ye,De){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,Ie){var Ce=Ie?C[se]:C[ie];return Ee.replace(Ce,function(Oe,le,he,ge,pe){var Pe;return S("tilde",Ee,Oe,le,he,ge,pe),Re(le)?Pe="":Re(he)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Pe=">="+le+"."+he+".0 <"+le+"."+(+he+1)+".0":pe?(S("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=">="+le+"."+he+"."+ge+pe+" <"+le+"."+(+he+1)+".0"):Pe=">="+le+"."+he+"."+ge+" <"+le+"."+(+he+1)+".0",S("tilde return",Pe),Pe})}(Ae,De)}).join(" ")}(de,Le),S("tildes",de),de=function(ye,De){return S("replaceXRanges",ye,De),ye.split(/\s+/).map(function(Ae){return function(Ee,Ie){Ee=Ee.trim();var Ce=Ie?C[k]:C[I];return Ee.replace(Ce,function(Oe,le,he,ge,pe,Pe){S("xRange",Ee,Oe,le,he,ge,pe,Pe);var Ve=Re(he),Me=Ve||Re(ge),Ue=Me||Re(pe);return le==="="&&Ue&&(le=""),Ve?Oe=le===">"||le==="<"?"<0.0.0":"*":le&&Ue?(Me&&(ge=0),Ue&&(pe=0),le===">"?(le=">=",Me?(he=+he+1,ge=0,pe=0):Ue&&(ge=+ge+1,pe=0)):le==="<="&&(le="<",Me?he=+he+1:ge=+ge+1),Oe=le+he+"."+ge+"."+pe):Me?Oe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Oe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),S("xRange return",Oe),Oe})}(Ae,De)}).join(" ")}(de,Le),S("xrange",de),de=function(ye,De){return S("replaceStars",ye,De),ye.trim().replace(C[F],"")}(de,Le),S("stars",de),de}(Se,G)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(Se){return!!Se.match(oe)})),ae=ae.map(function(Se){return new we(Se,G)})},ve.prototype.intersects=function(V,G){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(oe){return V.set.some(function(ae){return ae.every(function(Se){return oe.intersects(Se,G)})})})})},t.toComparators=function(V,G){return new ve(V,G).set.map(function(K){return K.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new j(V,this.loose));for(var G=0;G<this.set.length;G++)if(Be(this.set[G],V))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(V,G,K){var oe=null,ae=null;try{var Se=new ve(G,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(oe&&ae.compare(de)!==-1||(ae=new j(oe=de,K)))}),oe},t.minSatisfying=function(V,G,K){var oe=null,ae=null;try{var Se=new ve(G,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(oe&&ae.compare(de)!==1||(ae=new j(oe=de,K)))}),oe},t.validRange=function(V,G){try{return new ve(V,G).range||"*"}catch(K){return null}},t.ltr=function(V,G,K){return ze(V,G,"<",K)},t.gtr=function(V,G,K){return ze(V,G,">",K)},t.outside=ze,t.prerelease=function(V,G){var K=x(V,G);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,G,K){return V=new ve(V,K),G=new ve(G,K),V.intersects(G)},t.coerce=function(V){if(V instanceof j)return V;if(typeof V!="string")return null;var G=V.match(C[z]);return G==null?null:x((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,T(1))},function(_,t){var T,D,S=_.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function C(b){if(T===setTimeout)return setTimeout(b,0);if((T===A||!T)&&setTimeout)return T=setTimeout,setTimeout(b,0);try{return T(b,0)}catch(v){try{return T.call(null,b,0)}catch(w){return T.call(this,b,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:A}catch(b){T=A}try{D=typeof clearTimeout=="function"?clearTimeout:O}catch(b){D=O}})();var u,h=[],g=!1,p=-1;function m(){g&&u&&(g=!1,u.length?h=u.concat(h):p=-1,h.length&&L())}function L(){if(!g){var b=C(m);g=!0;for(var v=h.length;v;){for(u=h,h=[];++p<v;)u&&u[p].run();p=-1,v=h.length}u=null,g=!1,function(w){if(D===clearTimeout)return clearTimeout(w);if((D===O||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(w);try{D(w)}catch(f){try{return D.call(null,w)}catch(s){return D.call(this,w)}}}(b)}}function a(b,v){this.fun=b,this.array=v}function c(){}S.nextTick=function(b){var v=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)v[w-1]=arguments[w];h.push(new a(b,v)),h.length!==1||g||C(L)},a.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=c,S.addListener=c,S.once=c,S.off=c,S.removeListener=c,S.removeAllListeners=c,S.emit=c,S.prependListener=c,S.prependOnceListener=c,S.listeners=function(b){return[]},S.binding=function(b){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(b){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Z[37],te([0,1,8,2]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function S(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=S;function A(f){const s=f;return s?S(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=A;function O(f,s){return new C(f,s)}t.newWriteableStream=O;class C{constructor(s,o){this.reducer=s,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(o=>o(s))}emitError(s){this.listeners.error.length===0?(0,T.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(o=>o(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,o){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(s,o){if(this.state.destroyed)return;let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(o);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(f,s){const o=[];let e;for(;(e=f.read())!==null;)o.push(e);return s(o)}t.consumeReadable=u;function h(f,s,o){const e=[];let i;for(;(i=f.read())!==null&&e.length<o;)e.push(i);return i===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}t.peekReadable=h;function g(f,s){return new Promise((o,e)=>{const i=[];p(f,{onData:n=>{s&&i.push(n)},onError:n=>{s?e(n):o(void 0)},onEnd:()=>{o(s?s(i):void 0)}})})}t.consumeStream=g;function p(f,s){f.on("error",o=>s.onError(o)),f.on("end",()=>s.onEnd()),f.on("data",o=>s.onData(o))}t.listenStream=p;function m(f,s){return new Promise((o,e)=>{const i=new D.DisposableStore,n=[],r=R=>{if(n.push(R),n.length>s)return i.dispose(),f.pause(),o({stream:f,buffer:n,ended:!1})},l=R=>e(R),d=()=>o({stream:f,buffer:n,ended:!0});i.add((0,D.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),i.add((0,D.toDisposable)(()=>f.removeListener("end",d))),f.on("end",d),i.add((0,D.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}t.peekStream=m;function L(f,s){const o=O(s);return o.end(f),o}t.toStream=L;function a(){const f=O(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=a;function c(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}t.toReadable=c;function b(f,s,o){const e=O(o);return p(f,{onData:i=>e.write(s.data(i)),onError:i=>e.error(s.error?s.error(i):i),onEnd:()=>e.end()}),e}t.transform=b;function v(f,s,o){let e=!1;return{read:()=>{const i=s.read();return e?i:(e=!0,i!==null?o([f,i]):f)}}}t.prefixedReadable=v;function w(f,s,o){let e=!1;const i=O(o);return p(s,{onData:n=>e?i.write(n):(e=!0,i.write(o([f,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(f)),i.end()}}),i}t.prefixedStream=w}),define(Z[16],te([0,1,37]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined";let S,A;class O{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return D?new O(Buffer.allocUnsafe(r)):new O(new Uint8Array(r))}static wrap(r){return D&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new O(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&D?new O(Buffer.from(r)):(S||(S=new TextEncoder),new O(S.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let M=0,I=r.length;M<I;M++)l+=r[M].byteLength}const d=O.alloc(l);let R=0;for(let M=0,I=r.length;M<I;M++){const k=r[M];d.set(k,R),R+=k.byteLength}return d}toString(){return D?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,l){return new O(this.buffer.subarray(r,l))}set(r,l){r instanceof O?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return h(this.buffer,r)}writeUInt32BE(r,l){g(this.buffer,r,l)}readUInt32LE(r){return p(this.buffer,r)}writeUInt32LE(r,l){m(this.buffer,r,l)}readUInt8(r){return L(this.buffer,r)}writeUInt8(r,l){a(this.buffer,r,l)}}t.VSBuffer=O;function C(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=C;function u(n,r,l){n[l+0]=r&255,r=r>>>8,n[l+1]=r&255}t.writeUInt16LE=u;function h(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=h;function g(n,r,l){n[l+3]=r,r=r>>>8,n[l+2]=r,r=r>>>8,n[l+1]=r,r=r>>>8,n[l]=r}t.writeUInt32BE=g;function p(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=p;function m(n,r,l){n[l+0]=r&255,r=r>>>8,n[l+1]=r&255,r=r>>>8,n[l+2]=r&255,r=r>>>8,n[l+3]=r&255}t.writeUInt32LE=m;function L(n,r){return n[r]}t.readUInt8=L;function a(n,r,l){n[l]=r}t.writeUInt8=a;function c(n){return T.consumeReadable(n,r=>O.concat(r))}t.readableToBuffer=c;function b(n){return T.toReadable(n)}t.bufferToReadable=b;function v(n){return T.consumeStream(n,r=>O.concat(r))}t.streamToBuffer=v;async function w(n){return n.ended?O.concat(n.buffer):O.concat([...n.buffer,await v(n.stream)])}t.bufferedStreamToBuffer=w;function f(n){return T.toStream(n,r=>O.concat(r))}t.bufferToStream=f;function s(n){return T.transform(n,{data:r=>typeof r=="string"?O.fromString(r):O.wrap(r)},r=>O.concat(r))}t.streamToBufferReadableStream=s;function o(n){return T.newWriteableStream(r=>O.concat(r),n)}t.newWriteableBufferStream=o;function e(n,r){return T.prefixedReadable(n,r,l=>O.concat(l))}t.prefixedBufferReadable=e;function i(n,r){return T.prefixedStream(n,r,l=>O.concat(l))}t.prefixedBufferStream=i}),define(Z[18],te([0,1,13]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const b=Array.isArray(c)?[]:{};return Object.keys(c).forEach(v=>{c[v]&&typeof c[v]=="object"?b[v]=D(c[v]):b[v]=c[v]}),b}t.deepClone=D;function S(c){if(!c||typeof c!="object")return c;const b=[c];for(;b.length>0;){const v=b.shift();Object.freeze(v);for(const w in v)if(A.call(v,w)){const f=v[w];typeof f=="object"&&!Object.isFrozen(f)&&b.push(f)}}return c}t.deepFreeze=S;const A=Object.prototype.hasOwnProperty;function O(c,b){return C(c,b,new Set)}t.cloneAndChange=O;function C(c,b,v){if((0,T.isUndefinedOrNull)(c))return c;const w=b(c);if(typeof w!="undefined")return w;if((0,T.isArray)(c)){const f=[];for(const s of c)f.push(C(s,b,v));return f}if((0,T.isObject)(c)){if(v.has(c))throw new Error("Cannot clone recursive data-structure");v.add(c);const f={};for(let s in c)A.call(c,s)&&(f[s]=C(c[s],b,v));return v.delete(c),f}return c}function u(c,b,v=!0){return(0,T.isObject)(c)?((0,T.isObject)(b)&&Object.keys(b).forEach(w=>{w in c?v&&((0,T.isObject)(c[w])&&(0,T.isObject)(b[w])?u(c[w],b[w],v):c[w]=b[w]):c[w]=b[w]}),c):b}t.mixin=u;function h(c,b){if(c===b)return!0;if(c==null||b===null||b===void 0||typeof c!=typeof b||typeof c!="object"||Array.isArray(c)!==Array.isArray(b))return!1;let v,w;if(Array.isArray(c)){if(c.length!==b.length)return!1;for(v=0;v<c.length;v++)if(!h(c[v],b[v]))return!1}else{const f=[];for(w in c)f.push(w);f.sort();const s=[];for(w in b)s.push(w);if(s.sort(),!h(f,s))return!1;for(v=0;v<f.length;v++)if(!h(c[f[v]],b[f[v]]))return!1}return!0}t.equals=h;function g(c){const b=new Set;return JSON.stringify(c,(v,w)=>{if((0,T.isObject)(w)||Array.isArray(w)){if(b.has(w))return"[Circular]";b.add(w)}return w})}t.safeStringify=g;function p(c,b,v){const w=b(c);return typeof w=="undefined"?v:w}t.getOrDefault=p;function m(c,b){const v=Object.create(null);return!c||!b||Object.keys(b).forEach(f=>{const s=c[f],o=b[f];h(s,o)||(v[f]=o)}),v}t.distinct=m;function L(c,b){const v=b.toLowerCase(),w=Object.keys(c).find(f=>f.toLowerCase()===v);return w?c[w]:c[b]}t.getCaseInsensitive=L;function a(c,b){const v=Object.create(null);for(const w of Object.keys(c))b(w,c[w])&&(v[w]=c[w]);return v}t.filter=a}),define(Z[59],te([0,1,7]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function D(h){const g=h;return g&&typeof g.type=="string"&&typeof g.severity=="string"}t.isRemoteConsoleLog=D;function S(h){const g=[];let p;try{const m=JSON.parse(h.arguments),L=m[m.length-1];L&&L.__$stack&&(m.pop(),p=L.__$stack),g.push(...m)}catch(m){g.push("Unable to log remote console arguments",h.arguments)}return{args:g,stack:p}}t.parse=S;function A(h){if(typeof h!="string")return A(S(h).stack);const g=h;if(g){const p=O(g),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(m&&m.length===4)return{uri:T.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}t.getFirstFrame=A;function O(h){if(!h)return h;const g=h.indexOf(`
`);return g===-1?h:h.substring(0,g)}function C(h,g){const{args:p,stack:m}=S(h),L=typeof p[0]=="string"&&p.length===1;let a=O(m);a&&(a=`(${a.trim()})`);let c=[];if(typeof p[0]=="string"?a&&L?c=[`%c[${g}] %c${p[0]} %c${a}`,u("blue"),u(""),u("grey")]:c=[`%c[${g}] %c${p[0]}`,u("blue"),u(""),...p.slice(1)]:c=[`%c[${g}]%`,u("blue"),...p],a&&!L&&c.push(a),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,c)}t.log=C;function u(h){return`color: ${h}`}}),define(Z[60],te([0,1,16,21,7]),function(_,t,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function A(g){return JSON.stringify(g,u)}t.stringify=A;function O(g){let p=JSON.parse(g);return p=h(p),p}t.parse=O;var C;(function(g){g[g.Uri=1]="Uri",g[g.Regexp=2]="Regexp",g[g.ScmResource=3]="ScmResource",g[g.ScmResourceGroup=4]="ScmResourceGroup",g[g.ScmProvider=5]="ScmProvider",g[g.CommentController=6]="CommentController",g[g.CommentThread=7]="CommentThread",g[g.CommentThreadReply=8]="CommentThreadReply",g[g.CommentNode=9]="CommentNode",g[g.CommentThreadNode=10]="CommentThreadNode",g[g.TimelineActionContext=11]="TimelineActionContext",g[g.NotebookCellActionContext=12]="NotebookCellActionContext",g[g.TestItemContext=13]="TestItemContext"})(C=t.MarshalledId||(t.MarshalledId={}));function u(g,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,D.regExpFlags)(p)}:p}function h(g,p=0){if(!g||p>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return S.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof T.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let m=0;m<g.length;++m)g[m]=h(g[m],p+1);else for(const m in g)Object.hasOwnProperty.call(g,m)&&(g[m]=h(g[m],p+1))}return g}t.revive=h}),define(Z[61],te([0,1,3,31,45,4,21]),function(_,t,T,D,S,A,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function C(){return Object.create(null)}t.getEmptyExpression=C;const u="**",h="/",g="[/\\\\]",p="[^/\\\\]",m=/\//g;function L(E){switch(E){case 0:return"";case 1:return`${p}*?`;default:return`(?:${g}|${p}+${g}|${g}${p}+)*?`}}function a(E,N){if(!E)return[];const y=[];let F=!1,P=!1,x="";for(const j of E){switch(j){case N:if(!F&&!P){y.push(x),x="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":P=!0;break;case"]":P=!1;break}x+=j}return x&&y.push(x),y}t.splitGlobAware=a;function c(E){if(!E)return"";let N="";const y=a(E,h);if(y.every(F=>F===u))N=".*";else{let F=!1;y.forEach((P,x)=>{if(P===u){F||(N+=L(2),F=!0);return}let j=!1,$="",H=!1,ee="";for(const ne of P){if(ne!=="}"&&j){$+=ne;continue}if(H&&(ne!=="]"||!ee)){let re;ne==="-"?re=ne:(ne==="^"||ne==="!")&&!ee?re="^":ne===h?re="":re=O.escapeRegExpCharacters(ne),ee+=re;continue}switch(ne){case"{":j=!0;continue;case"[":H=!0;continue;case"}":N+=`(?:${a($,",").map(me=>c(me)).join("|")})`,j=!1,$="";break;case"]":N+="["+ee+"]",H=!1,ee="";break;case"?":N+=p;continue;case"*":N+=L(1);continue;default:N+=O.escapeRegExpCharacters(ne)}}x<y.length-1&&(y[x+1]!==u||x+2<y.length)&&(N+=g),F=!1})}return N}const b=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),i=function(){return!1},n=function(){return null};function r(E,N){if(!E)return n;let y;typeof E!="string"?y=E.pattern:y=E,y=y.trim();const F=`${y}_${!!N.trimForExclusions}`;let P=e.get(F);if(P)return l(P,E);let x;if(b.test(y)){const j=y.substr(4);P=function($,H){return typeof $=="string"&&$.endsWith(j)?y:null}}else(x=v.exec(d(y,N)))?P=R(x[1],y):(N.trimForExclusions?f:w).test(y)?P=M(y,N):(x=s.exec(d(y,N)))?P=I(x[1].substr(1),y,!0):(x=o.exec(d(y,N)))?P=I(x[1],y,!1):P=k(y);return e.set(F,P),l(P,E)}function l(E,N){return typeof N=="string"?E:function(y,F){return D.isEqualOrParent(y,N.base)?E(A.relative(N.base,y),F):null}}function d(E,N){return N.trimForExclusions&&E.endsWith("/**")?E.substr(0,E.length-2):E}function R(E,N){const y=`/${E}`,F=`\\${E}`,P=function(j,$){return typeof j!="string"?null:$?$===E?N:null:j===E||j.endsWith(y)||j.endsWith(F)?N:null},x=[E];return P.basenames=x,P.patterns=[N],P.allBasenames=x,P}function M(E,N){const y=U(E.slice(1,-1).split(",").map($=>r($,N)).filter($=>$!==n),E),F=y.length;if(!F)return n;if(F===1)return y[0];const P=function($,H){for(let ee=0,ne=y.length;ee<ne;ee++)if(y[ee]($,H))return E;return null},x=y.find($=>!!$.allBasenames);x&&(P.allBasenames=x.allBasenames);const j=y.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return j.length&&(P.allPaths=j),P}function I(E,N,y){const F=A.sep===A.posix.sep,P=F?E:E.replace(m,A.sep),x=A.sep+P,j=A.posix.sep+E,$=y?function(H,ee){return typeof H=="string"&&(H===P||H.endsWith(x)||!F&&(H===E||H.endsWith(j)))?N:null}:function(H,ee){return typeof H=="string"&&(H===P||!F&&H===E)?N:null};return $.allPaths=[(y?"*/":"./")+E],$}function k(E){try{const N=new RegExp(`^${c(E)}$`);return function(y){return N.lastIndex=0,typeof y=="string"&&N.test(y)?E:null}}catch(N){return n}}function z(E,N,y){return!E||typeof N!="string"?!1:q(E)(N,void 0,y)}t.match=z;function q(E,N={}){if(!E)return i;if(typeof E=="string"||Y(E)){const y=r(E,N);if(y===n)return i;const F=function(P,x){return!!y(P,x)};return y.allBasenames&&(F.allBasenames=y.allBasenames),y.allPaths&&(F.allPaths=y.allPaths),F}return B(E,N)}t.parse=q;function J(E){if(!E)return;let N;return y=>(N||(N=(E()||Promise.resolve([])).then(F=>F?se(F):{})),N.then(F=>!!F[y]))}t.hasSiblingPromiseFn=J;function ie(E){if(!E)return;let N;return y=>{if(!N){const F=E();N=F?se(F):{}}return!!N[y]}}t.hasSiblingFn=ie;function se(E){const N={};for(const y of E)N[y]=!0;return N}function Y(E){const N=E;return N&&typeof N.base=="string"&&typeof N.pattern=="string"}t.isRelativePattern=Y;function X(E){return E.allBasenames||[]}t.getBasenameTerms=X;function Q(E){return E.allPaths||[]}t.getPathTerms=Q;function B(E,N){const y=U(Object.getOwnPropertyNames(E).map($=>W($,E[$],N)).filter($=>$!==n)),F=y.length;if(!F)return n;if(!y.some($=>!!$.requiresSiblings)){if(F===1)return y[0];const $=function(ne,re){for(let ce=0,me=y.length;ce<me;ce++){const be=y[ce](ne,re);if(be)return be}return null},H=y.find(ne=>!!ne.allBasenames);H&&($.allBasenames=H.allBasenames);const ee=y.reduce((ne,re)=>re.allPaths?ne.concat(re.allPaths):ne,[]);return ee.length&&($.allPaths=ee),$}const P=function($,H,ee){let ne;for(let re=0,ce=y.length;re<ce;re++){const me=y[re];me.requiresSiblings&&ee&&(H||(H=A.basename($)),ne||(ne=H.substr(0,H.length-A.extname($).length)));const be=me($,H,ne,ee);if(be)return be}return null},x=y.find($=>!!$.allBasenames);x&&(P.allBasenames=x.allBasenames);const j=y.reduce(($,H)=>H.allPaths?$.concat(H.allPaths):$,[]);return j.length&&(P.allPaths=j),P}function W(E,N,y){if(N===!1)return n;const F=r(E,y);if(F===n)return n;if(typeof N=="boolean")return F;if(N){const P=N.when;if(typeof P=="string"){const x=(j,$,H,ee)=>{if(!ee||!F(j,$))return null;const ne=P.replace("$(basename)",H),re=ee(ne);return(0,T.isThenable)(re)?re.then(ce=>ce?E:null):re?E:null};return x.requiresSiblings=!0,x}}return F}function U(E,N){const y=E.filter($=>!!$.basenames);if(y.length<2)return E;const F=y.reduce(($,H)=>{const ee=H.basenames;return ee?$.concat(ee):$},[]);let P;if(N){P=[];for(let $=0,H=F.length;$<H;$++)P.push(N)}else P=y.reduce(($,H)=>{const ee=H.patterns;return ee?$.concat(ee):$},[]);const x=function($,H){if(typeof $!="string")return null;if(!H){let ne;for(ne=$.length;ne>0;ne--){const re=$.charCodeAt(ne-1);if(re===47||re===92)break}H=$.substr(ne)}const ee=F.indexOf(H);return ee!==-1?P[ee]:null};x.basenames=F,x.patterns=P,x.allBasenames=F;const j=E.filter($=>!$.basenames);return j.push(x),j}}),define(Z[62],te([0,1,31,9,4,10,19,21,7]),function(_,t,T,D,S,A,O,C,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function h(r,l,d){if(typeof r=="string"&&(r=u.URI.file(r)),d){const M=d.getWorkspaceFolder(r);if(M){const I=d.getWorkspace().folders.length>1;let k;if((0,O.isEqual)(M.uri,r)?k="":k=(0,O.relativePath)(M.uri,r),I){const z=M.name?M.name:(0,O.basename)(M.uri);k=k?z+" \u2022 "+k:z}return k}}if(r.scheme!==D.Schemas.file&&r.scheme!==D.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(r.fsPath))return(0,S.normalize)(p(r.fsPath));let R=(0,S.normalize)(r.fsPath);return!A.isWindows&&l?.userHome&&(R=L(R,l.userHome.fsPath)),R}t.getPathLabel=h;function g(r){if(!r)return;typeof r=="string"&&(r=u.URI.file(r));const l=(0,O.basename)(r)||(r.scheme===D.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,T.isRootOrDriveLetter)(l)?p(l):l}t.getBaseLabel=g;function p(r){return(0,T.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=p;let m=Object.create(null);function L(r,l){if(A.isWindows||!r||!l)return r;let d=m.original===l?m.normalized:void 0;return d||(d=`${(0,C.rtrim)(l,S.posix.sep)}${S.posix.sep}`,m={original:l,normalized:d}),(A.isLinux?r.startsWith(d):(0,C.startsWithIgnoreCase)(r,d))&&(r=`~/${r.substr(d.length)}`),r}t.tildify=L;function a(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=a;const c="\u2026",b="\\\\",v="~";function w(r,l=S.sep){const d=new Array(r.length);let R=!1;for(let M=0;M<r.length;M++){let I=r[M];if(I===""){d[M]=`.${l}`;continue}if(!I){d[M]=I;continue}R=!0;let k="";I.indexOf(b)===0?(k=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length)):I.indexOf(l)===0?(k=I.substr(0,I.indexOf(l)+l.length),I=I.substr(I.indexOf(l)+l.length)):I.indexOf(v)===0&&(k=I.substr(0,I.indexOf(v)+v.length),I=I.substr(I.indexOf(v)+v.length));const z=I.split(l);for(let q=1;R&&q<=z.length;q++)for(let J=z.length-q;R&&J>=0;J--){R=!1;let ie=z.slice(J,J+q).join(l);for(let se=0;!R&&se<r.length;se++)if(se!==M&&r[se]&&r[se].indexOf(ie)>-1){const Y=J+q===z.length,X=J>0&&r[se].indexOf(l)>-1?l+ie:ie,Q=r[se].endsWith(X);R=!Y||Q}if(!R){let se="";(z[0].endsWith(":")||k!=="")&&(J===1&&(J=0,q++,ie=z[0]+l+ie),J>0&&(se=z[0]+l),se=k+se),J>0&&(se=se+c+l),se=se+ie,J+q<z.length&&(se=se+l+c),d[M]=se}}R&&(d[M]=I)}return d}t.shorten=w;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function s(r,l=Object.create(null)){const d=[];let R=!1,M="";for(const I of r)if(I==="$"||R&&I==="{")M&&d.push({value:M,type:f.TEXT}),M="",R=!0;else if(I==="}"&&R){const k=l[M];if(typeof k=="string")k.length&&d.push({value:k,type:f.VARIABLE});else if(k){const z=d[d.length-1];(!z||z.type!==f.SEPARATOR)&&d.push({value:k.label,type:f.SEPARATOR})}M="",R=!1}else M+=I;return M&&!R&&d.push({value:M,type:f.TEXT}),d.filter((I,k)=>{if(I.type===f.SEPARATOR){const z=d[k-1],q=d[k+1];return[z,q].every(J=>J&&(J.type===f.VARIABLE||J.type===f.TEXT)&&J.value.length>0)}return!0}).map(I=>I.value).join("")}t.template=s;function o(r,l){return A.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,d=>d==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(r,l){return A.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,d=>d==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const l=r.indexOf("/")!==-1?S.posix:S.win32,d=l.basename(r),R=l.dirname(r);return d.length?{name:d,parentPath:R}:{name:R,parentPath:""}}t.splitName=n}),define(Z[46],te([0,1,126]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class D{constructor(A="utf8"){this.stringDecoder=new T.StringDecoder(A),this.remaining=null}write(A){const O=[],C=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(C.length<1)return O;let u=0,h,g=u;for(;g<C.length;)if(h=C.charCodeAt(g),h===13||h===10){if(O.push(C.substring(u,g)),g++,g<C.length){const p=h;h=C.charCodeAt(g),(p===13&&h===10||p===10&&h===13)&&g++}u=g}else g++;return this.remaining=u<C.length?C.substr(u):null,O}end(){return this.remaining}}t.LineDecoder=D}),define(Z[63],te([0,1,38,4,21,11]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function O(g){const p=(0,D.dirname)(g);if(g===p)return g;const m=((0,D.basename)(g)||g).toLowerCase();try{const a=(0,A.readdirSync)(p).filter(c=>c.toLowerCase()===m);if(a.length===1){const c=O(p);if(c)return(0,D.join)(c,a[0])}else if(a.length>1){const c=a.indexOf(m);if(c>=0){const b=O(p);if(b)return(0,D.join)(b,a[c])}}}catch(L){}return null}t.realcaseSync=O;async function C(g){try{return await A.Promises.realpath(g)}catch(p){const m=h(g);return await A.Promises.access(m,T.constants.R_OK),m}}t.realpath=C;function u(g){try{return T.realpathSync(g)}catch(p){const m=h(g);return T.accessSync(m,T.constants.R_OK),m}}t.realpathSync=u;function h(g){return(0,S.rtrim)((0,D.normalize)(g),D.sep)}}),define(Z[64],te([0,1,32,4,11]),function(_,t,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var u;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(u||(u={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class p{constructor(o,e,i){this.exePath=o,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:s=!1}={}){return s?h===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function L({useAlternateBitness:s=!1,findPreview:o=!1}={}){const e=m({useAlternateBitness:s});if(!e)return null;const i=D.join(e,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const R of await S.Promises.readdir(i)){let M=-1;if(o){const k=R.indexOf("-");if(k<0)continue;const z=R.substring(0,k);if(!A.test(z)||R.substring(k+1)!=="preview")continue;M=parseInt(z,10)}else{if(!A.test(R))continue;M=parseInt(R,10)}if(M<=n)continue;const I=D.join(i,R,"pwsh.exe");!await S.SymlinkSupport.existsFile(I)||(r=I,n=M)}if(!r)return null;const l=e.includes("x86")?" (x86)":"",d=o?" Preview":"";return new p(r,`PowerShell${d}${l}`,!0)}async function a({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const o=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=s?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const n of await S.Promises.readdir(o))if(e.test(n)){const r=D.join(o,n,"pwsh.exe");return new p(r,i)}return null}function c(){const s=D.join(T.homedir(),".dotnet","tools","pwsh.exe");return new p(s,".NET Core PowerShell Global Tool")}function b(){const s=D.join(process.env.windir,h===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(s,"Windows PowerShell",!0)}async function*v(){let s=await L();s&&(yield s),s=await L({useAlternateBitness:!0}),s&&(yield s),s=await a(),s&&(yield s),s=c(),s&&(yield s),s=await L({findPreview:!0}),s&&(yield s),s=await a({findPreview:!0}),s&&(yield s),s=await L({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=b(),s&&(yield s)}async function*w(){for await(const s of v())await s.exists()&&(yield s)}t.enumeratePowerShellInstallations=w;async function f(){for await(const s of w())return s;return null}t.getFirstAvailablePowerShellInstallation=f}),define(Z[65],te([0,1,38,31,2,127,4,10,11]),function(_,t,T,D,S,A,O,C,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function h(m,L,a){return p({path:m,isDirectory:!1},L,a)}t.watchFile=h;function g(m,L,a){return p({path:m,isDirectory:!0},L,a)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function p(m,L,a){if(C.isMacintosh&&(0,D.isEqualOrParent)(m.path,"/Volumes/"))return a(`Refusing to watch ${m.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const c=(0,O.basename)(m.path),b=new Map;let v=!1,w=[(0,S.toDisposable)(()=>{b.forEach(f=>(0,S.dispose)(f)),b.clear()})];try{const f=(0,T.watch)(m.path);w.push((0,S.toDisposable)(()=>{f.removeAllListeners(),f.close()}));const s=new Set;m.isDirectory&&u.Promises.readdir(m.path).then(o=>o.forEach(e=>s.add(e))),f.on("error",(o,e)=>{v||a(`Failed to watch ${m.path} for changes using fs.watch() (${o}, ${e})`)}),f.on("change",(o,e)=>{if(v)return;let i="";if(e&&(i=e.toString(),C.isMacintosh&&(i=(0,A.normalizeNFC)(i))),!i||o!=="change"&&o!=="rename")return;const n=m.isDirectory?(0,O.join)(m.path,i):m.path;if(m.isDirectory)if(o==="rename"){const r=b.get(n);r&&(0,S.dispose)(r);const l=setTimeout(async()=>{b.delete(n);const d=await u.Promises.exists(n);if(v)return;let R;d?s.has(i)?R="changed":(R="added",s.add(i)):(s.delete(i),R="deleted"),L(R,n)},t.CHANGE_BUFFER_DELAY);b.set(n,(0,S.toDisposable)(()=>clearTimeout(l)))}else{let r;s.has(i)?r="changed":(r="added",s.add(i)),L(r,n)}else if(o==="rename"||i!==c){const r=setTimeout(async()=>{const l=await u.Promises.exists(n);v||(l?(L("changed",n),w=[p(m,L,a)]):L("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,S.dispose)(w),w=[(0,S.toDisposable)(()=>clearTimeout(r))]}else L("changed",n)})}catch(f){u.Promises.exists(m.path).then(s=>{s&&!v&&a(`Failed to watch ${m.path} for changes using fs.watch() (${f.toString()})`)})}return(0,S.toDisposable)(()=>{v=!0,w=(0,S.dispose)(w)})}});var ue=this&&this.__decorate||function(_,t,T,D){var S=arguments.length,A=S<3?t:D===null?D=Object.getOwnPropertyDescriptor(t,T):D,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(_,t,T,D);else for(var C=_.length-1;C>=0;C--)(O=_[C])&&(A=(S<3?O(A):S>3?O(t,T,A):O(t,T))||A);return S>3&&A&&Object.defineProperty(t,T,A),A};define(Z[39],te([0,1,24,3,16,26,44,8,14,2,60,21,13]),function(_,t,T,D,S,A,O,C,u,h,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var L;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(L=t.RequestType||(t.RequestType={}));function a(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function b(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(v||(v={}));class w{constructor(E){this.buffer=E,this.pos=0}read(E){const N=this.buffer.slice(this.pos,this.pos+E);return this.pos+=N.byteLength,N}}class f{constructor(){this.buffers=[]}get buffer(){return S.VSBuffer.concat(this.buffers)}write(E){this.buffers.push(E)}}var s;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(s||(s={}));function o(U){const E=S.VSBuffer.alloc(4);return E.writeUInt32BE(U,0),E}function e(U){return U.read(4).readUInt32BE(0)}function i(U){const E=S.VSBuffer.alloc(1);return E.writeUInt8(U,0),E}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object)},r=typeof Buffer!="undefined";function l(U,E){if(typeof E=="undefined")U.write(n.Undefined);else if(typeof E=="string"){const N=S.VSBuffer.fromString(E);U.write(n.String),U.write(o(N.byteLength)),U.write(N)}else if(r&&Buffer.isBuffer(E)){const N=S.VSBuffer.wrap(E);U.write(n.Buffer),U.write(o(N.byteLength)),U.write(N)}else if(E instanceof S.VSBuffer)U.write(n.VSBuffer),U.write(o(E.byteLength)),U.write(E);else if(Array.isArray(E)){U.write(n.Array),U.write(o(E.length));for(const N of E)l(U,N)}else{const N=S.VSBuffer.fromString(JSON.stringify(E));U.write(n.Object),U.write(o(N.byteLength)),U.write(N)}}function d(U){switch(U.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return U.read(e(U)).toString();case s.Buffer:return U.read(e(U)).buffer;case s.VSBuffer:return U.read(e(U));case s.Array:{const N=e(U),y=[];for(let F=0;F<N;F++)y.push(d(U));return y}case s.Object:return JSON.parse(U.read(e(U)).toString())}}class R{constructor(E,N,y=null,F=1e3){this.protocol=E,this.ctx=N,this.logger=y,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(P=>this.onRawMessage(P)),this.sendResponse({type:200})}registerChannel(E,N){this.channels.set(E,N),setTimeout(()=>this.flushPendingRequests(E),0)}sendResponse(E){switch(E.type){case 200:{const N=this.send([E.type]);this.logger&&this.logger.logOutgoing(N,0,1,b(E.type));return}case 201:case 202:case 204:case 203:{const N=this.send([E.type,E.id],E.data);this.logger&&this.logger.logOutgoing(N,E.id,1,b(E.type),E.data);return}}}send(E,N=void 0){const y=new f;return l(y,E),l(y,N),this.sendBuffer(y.buffer)}sendBuffer(E){try{return this.protocol.send(E),E.byteLength}catch(N){return 0}}onRawMessage(E){const N=new w(E),y=d(N),F=d(N),P=y[0];switch(P){case 100:return this.logger&&this.logger.logIncoming(E.byteLength,y[1],1,`${a(P)}: ${y[2]}.${y[3]}`,F),this.onPromise({type:P,id:y[1],channelName:y[2],name:y[3],arg:F});case 102:return this.logger&&this.logger.logIncoming(E.byteLength,y[1],1,`${a(P)}: ${y[2]}.${y[3]}`,F),this.onEventListen({type:P,id:y[1],channelName:y[2],name:y[3],arg:F});case 101:return this.logger&&this.logger.logIncoming(E.byteLength,y[1],1,`${a(P)}`),this.disposeActiveRequest({type:P,id:y[1]});case 103:return this.logger&&this.logger.logIncoming(E.byteLength,y[1],1,`${a(P)}`),this.disposeActiveRequest({type:P,id:y[1]})}}onPromise(E){const N=this.channels.get(E.channelName);if(!N){this.collectPendingRequest(E);return}const y=new A.CancellationTokenSource;let F;try{F=N.call(this.ctx,E.name,E.arg,y.token)}catch(j){F=Promise.reject(j)}const P=E.id;F.then(j=>{this.sendResponse({id:P,data:j,type:201}),this.activeRequests.delete(E.id)},j=>{j instanceof Error?this.sendResponse({id:P,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:P,data:j,type:203}),this.activeRequests.delete(E.id)});const x=(0,h.toDisposable)(()=>y.cancel());this.activeRequests.set(E.id,x)}onEventListen(E){const N=this.channels.get(E.channelName);if(!N){this.collectPendingRequest(E);return}const y=E.id,P=N.listen(this.ctx,E.name,E.arg)(x=>this.sendResponse({id:y,data:x,type:204}));this.activeRequests.set(E.id,P)}disposeActiveRequest(E){const N=this.activeRequests.get(E.id);N&&(N.dispose(),this.activeRequests.delete(E.id))}collectPendingRequest(E){let N=this.pendingRequests.get(E.channelName);N||(N=[],this.pendingRequests.set(E.channelName,N));const y=setTimeout(()=>{console.error(`Unknown channel: ${E.channelName}`),E.type===100&&this.sendResponse({id:E.id,data:{name:"Unknown channel",message:`Channel name '${E.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);N.push({request:E,timeoutTimer:y})}flushPendingRequests(E){const N=this.pendingRequests.get(E);if(N){for(const y of N)switch(clearTimeout(y.timeoutTimer),y.request.type){case 100:this.onPromise(y.request);break;case 102:this.onEventListen(y.request);break}this.pendingRequests.delete(E)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(E=>E.dispose()),this.activeRequests.clear()}}t.ChannelServer=R;var M;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(M=t.RequestInitiator||(t.RequestInitiator={}));class I{constructor(E,N=null){this.protocol=E,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(y=>this.onBuffer(y)),this.logger=N}getChannel(E){const N=this;return{call(y,F,P){return N.isDisposed?Promise.reject(C.canceled()):N.requestPromise(E,y,F,P)},listen(y,F){return N.isDisposed?Promise.reject(C.canceled()):N.requestEvent(E,y,F)}}}requestPromise(E,N,y,F=A.CancellationToken.None){const P=this.lastRequestId++,j={id:P,type:100,channelName:E,name:N,arg:y};if(F.isCancellationRequested)return Promise.reject(C.canceled());let $;return new Promise((ee,ne)=>{if(F.isCancellationRequested)return ne(C.canceled());const re=()=>{const ke=Te=>{switch(Te.type){case 201:this.handlers.delete(P),ee(Te.data);break;case 202:this.handlers.delete(P);const we=new Error(Te.data.message);we.stack=Te.data.stack,we.name=Te.data.name,ne(we);break;case 203:this.handlers.delete(P),ne(Te.data);break}};this.handlers.set(P,ke),this.sendRequest(j)};let ce=null;this.state===v.Idle?re():(ce=(0,D.createCancelablePromise)(ke=>this.whenInitialized()),ce.then(()=>{ce=null,re()}));const me=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:P,type:101}),ne(C.canceled())},be=F.onCancellationRequested(me);$=(0,h.combinedDisposable)((0,h.toDisposable)(me),be),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(E,N,y){const F=this.lastRequestId++,x={id:F,type:102,channelName:E,name:N,arg:y};let j=null;const $=new u.Emitter({onFirstListenerAdd:()=>{j=(0,D.createCancelablePromise)(ee=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add($),this.sendRequest(x)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete($),this.sendRequest({id:F,type:103}))}}),H=ee=>$.fire(ee.data);return this.handlers.set(F,H),$.event}sendRequest(E){switch(E.type){case 100:case 102:{const N=this.send([E.type,E.id,E.channelName,E.name],E.arg);this.logger&&this.logger.logOutgoing(N,E.id,0,`${a(E.type)}: ${E.channelName}.${E.name}`,E.arg);return}case 101:case 103:{const N=this.send([E.type,E.id]);this.logger&&this.logger.logOutgoing(N,E.id,0,a(E.type));return}}}send(E,N=void 0){const y=new f;return l(y,E),l(y,N),this.sendBuffer(y.buffer)}sendBuffer(E){try{return this.protocol.send(E),E.byteLength}catch(N){return 0}}onBuffer(E){const N=new w(E),y=d(N),F=d(N),P=y[0];switch(P){case 200:return this.logger&&this.logger.logIncoming(E.byteLength,0,0,b(P)),this.onResponse({type:y[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(E.byteLength,y[1],0,b(P),F),this.onResponse({type:y[0],id:y[1],data:F})}}onResponse(E){if(E.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const N=this.handlers.get(E.id);N&&N(E)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(E=>E.dispose()),this.activeRequests.clear()}}ue([O.memoize],I.prototype,"onDidInitializePromise",null),t.ChannelClient=I;class k{constructor(E){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,E(({protocol:N,onDidClientDisconnect:y})=>{u.Event.once(N.onMessage)(P=>{const x=new w(P),j=d(x),$=new R(N,j),H=new I(N);this.channels.forEach((ne,re)=>$.registerChannel(re,ne));const ee={channelServer:$,channelClient:H,ctx:j};this._connections.add(ee),this._onDidAddConnection.fire(ee),y(()=>{$.dispose(),H.dispose(),this._connections.delete(ee),this._onDidRemoveConnection.fire(ee)})})})}get connections(){const E=[];return this._connections.forEach(N=>E.push(N)),E}getChannel(E,N){const y=this;return{call(F,P,x){let j;if((0,m.isFunction)(N)){let H=(0,T.getRandomElement)(y.connections.filter(N));j=H?Promise.resolve(H):u.Event.toPromise(u.Event.filter(y.onDidAddConnection,N))}else j=N.routeCall(y,F,P);const $=j.then(H=>H.channelClient.getChannel(E));return q($).call(F,P,x)},listen(F,P){if((0,m.isFunction)(N))return y.getMulticastEvent(E,N,F,P);const x=N.routeEvent(y,F,P).then(j=>j.channelClient.getChannel(E));return q(x).listen(F,P)}}}getMulticastEvent(E,N,y,F){const P=this;let x=new h.DisposableStore;const j=new u.Emitter({onFirstListenerAdd:()=>{x=new h.DisposableStore;const $=new u.EventMultiplexer,H=new Map,ee=re=>{const me=re.channelClient.getChannel(E).listen(y,F),be=$.add(me);H.set(re,be)},ne=re=>{const ce=H.get(re);!ce||(ce.dispose(),H.delete(re))};P.connections.filter(N).forEach(ee),u.Event.filter(P.onDidAddConnection,N)(ee,void 0,x),P.onDidRemoveConnection(ne,void 0,x),$.event(j.fire,j,x),x.add($)},onLastListenerRemove:()=>{x.dispose()}});return j.event}registerChannel(E,N){this.channels.set(E,N),this._connections.forEach(y=>{y.channelServer.registerChannel(E,N)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=k;class z{constructor(E,N,y=null){const F=new f;l(F,N),E.send(F.buffer),this.channelClient=new I(E,y),this.channelServer=new R(E,N,y)}getChannel(E){return this.channelClient.getChannel(E)}registerChannel(E,N){this.channelServer.registerChannel(E,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=z;function q(U){return{call(E,N,y){return U.then(F=>F.call(E,N,y))},listen(E,N){const y=new u.Relay;return U.then(F=>y.input=F.listen(E,N)),y.event}}}t.getDelayedChannel=q;function J(U){let E=!1;return{call(N,y,F){return E?U.call(N,y,F):(0,D.timeout)(0).then(()=>E=!0).then(()=>U.call(N,y,F))},listen(N,y){if(E)return U.listen(N,y);const F=new u.Relay;return(0,D.timeout)(0).then(()=>E=!0).then(()=>F.input=U.listen(N,y)),F.event}}}t.getNextTickChannel=J;class ie{constructor(E){this.fn=E}routeCall(E){return this.route(E)}routeEvent(E){return this.route(E)}async route(E){for(const N of E.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await u.Event.toPromise(E.onDidAddConnection),await this.route(E)}}t.StaticRouter=ie;var se;(function(U){function E(F,P){const x=F,j=P&&P.disableMarshalling,$=new Map;for(const H in x)y(H)&&$.set(H,u.Event.buffer(x[H],!0));return new class{listen(H,ee){const ne=$.get(ee);if(ne)return ne;throw new Error(`Event not found: ${ee}`)}call(H,ee,ne){const re=x[ee];if(typeof re=="function"){if(!j&&Array.isArray(ne))for(let ce=0;ce<ne.length;ce++)ne[ce]=(0,g.revive)(ne[ce]);return re.apply(x,ne)}throw new Error(`Method not found: ${ee}`)}}}U.fromService=E;function N(F,P){const x=P&&P.disableMarshalling;return new Proxy({},{get(j,$){if(typeof $=="string")return P?.properties?.has($)?P.properties.get($):y($)?F.listen($):async function(...H){let ee;P&&!(0,m.isUndefinedOrNull)(P.context)?ee=[P.context,...H]:ee=H;const ne=await F.call($,ee);return x?ne:(0,g.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}U.toService=N;function y(F){return F[0]==="o"&&F[1]==="n"&&p.isUpperAsciiLetter(F.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let E=U.toString();if(E!=="[object Object]")return E}return U}function Q(U){return Array.isArray(U)?U.map(X):X(U)}function B(U,E,N,y,F,P,x){x=Q(x);const j=Y[F],$=j[y%j.length];let H=[`%c[${U}]%c[${String(E).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(y).padStart(5," ")} - ${P}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(P)?(H=H.concat(x),H.push(")")):H.push(x),console.log.apply(console,H)}t.logWithColors=B;class W{constructor(E,N){this._outgoingPrefix=E,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(E,N,y,F,P){this._totalOutgoing+=E,B(this._outgoingPrefix,this._totalOutgoing,E,N,y,F,P)}logIncoming(E,N,y,F,P){this._totalIncoming+=E,B(this._incomingPrefix,this._totalIncoming,E,N,y,F,P)}}t.IPCLogger=W}),define(Z[66],te([0,1,3,14,2,13]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var O;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=t.StorageHint||(t.StorageHint={}));var C;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(C||(C={}));class u extends S.Disposable{constructor(p,m=Object.create(null)){super();this.database=p,this.options=m,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((m,L)=>this.accept(L,m)),p.deleted?.forEach(m=>this.accept(m,void 0))}accept(p,m){if(this.state===C.Closed)return;let L=!1;(0,A.isUndefinedOrNull)(m)?L=this.cache.delete(p):this.cache.get(p)!==m&&(this.cache.set(p,m),L=!0),L&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,m){const L=this.cache.get(p);return(0,A.isUndefinedOrNull)(L)?m:L}getBoolean(p,m){const L=this.get(p);return(0,A.isUndefinedOrNull)(L)?m:L==="true"}getNumber(p,m){const L=this.get(p);return(0,A.isUndefinedOrNull)(L)?m:parseInt(L,10)}async set(p,m){if(this.state===C.Closed)return;if((0,A.isUndefinedOrNull)(m))return this.delete(p);const L=String(m);if(this.cache.get(p)!==L)return this.cache.set(p,L),this.pendingInserts.set(p,L),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async delete(p){if(!(this.state===C.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(p){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class h{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((m,L)=>this.items.set(L,m)),p.delete&&p.delete.forEach(m=>this.items.delete(m))}async close(){}}t.InMemoryStorageDatabase=h}),define(Z[67],te([5,6]),function(_,t){return _.create("vs/base/common/date",t)}),define(Z[68],te([0,1,67]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const D=60,S=D*60,A=S*24,O=A*7,C=A*30,u=A*365;function h(p,m){typeof p!="number"&&(p=p.getTime());const L=Math.round((new Date().getTime()-p)/1e3);if(L<-30)return(0,T.localize)(0,null,h(new Date().getTime()+L*1e3,!1));if(L<30)return(0,T.localize)(1,null);let a;return L<D?(a=L,m?a===1?(0,T.localize)(2,null,a):(0,T.localize)(3,null,a):a===1?(0,T.localize)(4,null,a):(0,T.localize)(5,null,a)):L<S?(a=Math.floor(L/D),m?a===1?(0,T.localize)(6,null,a):(0,T.localize)(7,null,a):a===1?(0,T.localize)(8,null,a):(0,T.localize)(9,null,a)):L<A?(a=Math.floor(L/S),m?a===1?(0,T.localize)(10,null,a):(0,T.localize)(11,null,a):a===1?(0,T.localize)(12,null,a):(0,T.localize)(13,null,a)):L<O?(a=Math.floor(L/A),m?a===1?(0,T.localize)(14,null,a):(0,T.localize)(15,null,a):a===1?(0,T.localize)(16,null,a):(0,T.localize)(17,null,a)):L<C?(a=Math.floor(L/O),m?a===1?(0,T.localize)(18,null,a):(0,T.localize)(19,null,a):a===1?(0,T.localize)(20,null,a):(0,T.localize)(21,null,a)):L<u?(a=Math.floor(L/C),m?a===1?(0,T.localize)(22,null,a):(0,T.localize)(23,null,a):a===1?(0,T.localize)(24,null,a):(0,T.localize)(25,null,a)):(a=Math.floor(L/u),m?a===1?(0,T.localize)(26,null,a):(0,T.localize)(27,null,a):a===1?(0,T.localize)(28,null,a):(0,T.localize)(29,null,a))}t.fromNow=h;function g(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=g}),define(Z[69],te([5,6]),function(_,t){return _.create("vs/base/common/errorMessage",t)}),define(Z[28],te([0,1,24,13,69]),function(_,t,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function A(h,g){return g&&(h.stack||h.stacktrace)?S.localize(0,null,C(h),O(h.stack)||O(h.stacktrace)):C(h)}function O(h){return Array.isArray(h)?h.join(`
`):h}function C(h){return typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?S.localize(1,null,h.message):h.message||S.localize(2,null)}function u(h=null,g=!1){if(!h)return S.localize(3,null);if(Array.isArray(h)){const p=T.coalesce(h),m=u(p[0],g);return p.length>1?S.localize(4,null,m,p.length):m}if(D.isString(h))return h;if(h.detail){const p=h.detail;if(p.error)return A(p.error,g);if(p.exception)return A(p.exception,g)}return h.stack?A(h,g):h.message?h.message:S.localize(5,null)}t.toErrorMessage=u}),define(Z[70],te([5,6]),function(_,t){return _.create("vs/base/node/processes",t)}),define(Z[47],te([0,1,33,31,9,18,4,10,34,13,46,11,70]),function(_,t,T,D,S,A,O,C,u,h,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function L(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(s,o){if(C.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const i=T.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],e);return new Promise(n=>{i.once("error",r=>{n({success:!1,error:r})}),i.once("exit",(r,l)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?L(e.status):1})}else if(C.isLinux||C.isMacintosh)try{const e=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(i=>{T.execFile(e,[s.pid.toString()],{encoding:"utf8",shell:!0},(n,r,l)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function c(s=u.env){return s.comspec||"cmd.exe"}t.getWindowsShell=c;class b{constructor(o,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=o,this.args=e,this.shell=i,this.options=n;else{const r=o;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(u.env).forEach(l=>{r[l]=u.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(O.sep);return e!==-1&&(o=o.substring(e+1)),b.WellKnowCommands[o]?o:"other"}start(o){return C.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(u.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(e=>{let i,n;const r=new Promise((l,d)=>{i=l,n=d});if(e){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=T.exec(l,this.options,(d,R,M)=>{this.childProcess=null;const I=d;I&&I.killed?n({killed:this.terminateRequested,stdout:R.toString(),stderr:M.toString()}):this.handleExec(i,o,d,R,M)})}else{let l=null;const d=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,i,o,n);const M={terminated:this.terminateRequested};h.isNumber(R)&&(M.cmdCode=R),i(M)};if(this.shell&&C.isWindows){const R=A.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let M=!1,I=!1;const k=[];let z=this.ensureQuotes(this.cmd);k.push(z.value),M=z.quoted,this.args&&this.args.forEach(J=>{z=this.ensureQuotes(J),k.push(z.value),I=I&&z.quoted});const q=["/s","/c"];M?I?q.push('"'+k.join(" ")+'"'):k.length>1?q.push('"'+k[0]+'" '+k.slice(1).join(" ")):q.push('"'+k[0]+'"'):q.push(k.join(" ")),l=T.spawn(c(),q,R)}else this.cmd&&(l=T.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(h.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",R=>{this.childProcess=null,n({terminated:this.terminateRequested,error:R})}),l.pid&&(this.childProcess.on("close",d),this.handleSpawn(l,i,o,n,!0)))}return r})}handleClose(o,e,i,n){}ensureQuotes(o){return b.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,a(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!C.isWindows)return o(!1);const e=T.spawn(c(),["/s","/c"]);e.on("error",i=>o(!0)),e.on("exit",i=>o(!1))})}}t.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class v extends b{constructor(o,e,i,n){super(o,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,i,n,r){[n,r].forEach((l,d)=>{const R=new g.LineDecoder;R.write(l).forEach(k=>{e({line:k,source:d===0?0:1})});const I=R.end();I&&e({line:I,source:d===0?0:1})}),o({terminated:this.terminateRequested,error:i})}handleSpawn(o,e,i,n,r){const l=new g.LineDecoder,d=new g.LineDecoder;o.stdout.on("data",R=>{l.write(R).forEach(I=>i({line:I,source:0}))}),o.stderr.on("data",R=>{d.write(R).forEach(I=>i({line:I,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=d}handleClose(o,e,i,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}t.LineProcess=v;function w(s){let o=[],e=!1;const i=function(n){if(e){o.push(n);return}(!s.send(n,l=>{if(l&&console.error(l),e=!1,o.length>0){const d=o.slice(0);o=[],d.forEach(R=>i(R))}})||C.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=w;var f;(function(s){async function o(e,i,n){if(O.isAbsolute(e))return e;if(i===void 0&&(i=u.cwd()),O.dirname(e)!=="."||(n===void 0&&h.isString(u.env.PATH)&&(n=u.env.PATH.split(O.delimiter)),n===void 0||n.length===0))return O.join(i,e);async function l(d){return await p.Promises.exists(d)?!(await p.Promises.stat(d)).isDirectory():!1}for(let d of n){let R;if(O.isAbsolute(d)?R=O.join(d,e):R=O.join(i,d,e),await l(R))return R;let M=R+".com";if(await l(M)||(M=R+".exe",await l(M)))return M}return O.join(i,e)}s.findExecutable=o})(f=t.win32||(t.win32={}))}),define(Z[71],te([0,1,32,10,64,47]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function O(L,a){return L===1?D.isWindows?p():A.getWindowsShell(a):h(L,a)}t.getSystemShell=O;function C(L,a){return L===1?D.isWindows?m(a):A.getWindowsShell(a):h(L,a)}t.getSystemShellSync=C;let u=null;function h(L,a){if(D.isLinux&&L===2||D.isMacintosh&&L===3)return"/bin/bash";if(!u){let c;if(D.isWindows)c="/bin/bash";else{if(c=a.SHELL,!c)try{c=(0,T.userInfo)().shell}catch(b){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}u=c}return u}let g=null;async function p(){return g||(g=(await(0,S.getFirstAvailablePowerShellInstallation)()).exePath),g}function m(L){if(g)return g;const a=D.isWindows&&parseFloat((0,T.release)())>=10,c=L.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${L.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?b:A.getWindowsShell(L)}}),define(Z[48],te([0,1,33,3,16,26,59,8,14,2,18,10,47,39]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class a extends L.ChannelServer{constructor(v){super({send:w=>{try{process.send&&process.send(w.buffer.toString("base64"))}catch(f){}},onMessage:u.Event.fromNodeEventEmitter(process,"message",w=>S.VSBuffer.wrap(Buffer.from(w,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=a;class c{constructor(v,w){this.modulePath=v,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new D.Delayer(f),this.child=null,this._client=null}getChannel(v){const w=this;return{call(f,s,o){return w.requestPromise(v,f,s,o)},listen(f,s){return w.requestEvent(v,f,s)}}}requestPromise(v,w,f,s=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(v),e=(0,D.createCancelablePromise)(r=>o.call(w,f,r)),i=s.onCancellationRequested(()=>e.cancel()),n=(0,h.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(v,w,f){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let s;const o=new u.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(v).listen(w,f)(o.fire,o),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env={...(0,g.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(w.env={...w.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),p.isMacintosh&&w.env&&delete w.env.DYLD_LIBRARY_PATH,this.child=(0,T.fork)(this.modulePath,v,w);const f=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,O.isRemoteConsoleLog)(l)){(0,O.log)(l,`IPC Library: ${this.options.serverName}`);return}f.fire(S.VSBuffer.wrap(Buffer.from(l,"base64")))});const o=this.options.useQueue?(0,m.createQueuedSender)(this.child):this.child,e=l=>this.child&&this.child.connected&&o.send(l.buffer.toString("base64")),i=f.event,n={send:e,onMessage:i};this._client=new L.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,d)=>{process.removeListener("exit",r),this.activeRequests.forEach(R=>(0,h.dispose)(R)),this.activeRequests.clear(),l!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+d),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:d})})}return this._client}getCachedChannel(v){let w=this.channels.get(v);return w||(w=this.client.getChannel(v),this.channels.set(v,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=c}),define(Z[72],te([5,6]),function(_,t){return _.create("vs/base/node/zip",t)}),define(Z[73],te([5,6]),function(_,t){return _.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[74],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[75],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[76],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[77],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[78],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[79],te([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Z[80],te([5,6]),function(_,t){return _.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[81],te([5,6]),function(_,t){return _.create("vs/platform/files/common/fileService",t)}),define(Z[82],te([5,6]),function(_,t){return _.create("vs/platform/files/common/io",t)}),define(Z[83],te([5,6]),function(_,t){return _.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[84],te([5,6]),function(_,t){return _.create("vs/platform/request/common/request",t)}),define(Z[85],te([5,6]),function(_,t){return _.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[86],te([0,1,68,44,9,4,34,19,7]),function(_,t,T,D,S,A,O,C,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class h{constructor(a,c,b){this._args=a,this.paths=c,this.productService=b}get appRoot(){return(0,A.dirname)(S.FileAccess.asFileUri("",_).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(u.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return u.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return u.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=O.env.VSCODE_PORTABLE;return a?u.URI.file((0,A.join)(a,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,A.resolve)(a):(0,A.normalize)((0,A.join)(S.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,A.resolve)(a):(0,A.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,A.resolve)(a);const c=O.env.VSCODE_EXTENSIONS;if(c)return c;const b=O.env.VSCODE_PORTABLE;return b?(0,A.join)(b,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(c=>/^[^:/?#]+?:\/\//.test(c)?u.URI.parse(c):u.URI.file((0,A.normalize)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?u.URI.parse(a):u.URI.file((0,A.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return u.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([D.memoize],h.prototype,"appRoot",null),ue([D.memoize],h.prototype,"userHome",null),ue([D.memoize],h.prototype,"userDataPath",null),ue([D.memoize],h.prototype,"appSettingsHome",null),ue([D.memoize],h.prototype,"tmpDir",null),ue([D.memoize],h.prototype,"userRoamingDataHome",null),ue([D.memoize],h.prototype,"settingsResource",null),ue([D.memoize],h.prototype,"userDataSyncHome",null),ue([D.memoize],h.prototype,"userDataSyncLogResource",null),ue([D.memoize],h.prototype,"sync",null),ue([D.memoize],h.prototype,"machineSettingsResource",null),ue([D.memoize],h.prototype,"globalStorageHome",null),ue([D.memoize],h.prototype,"workspaceStorageHome",null),ue([D.memoize],h.prototype,"keybindingsResource",null),ue([D.memoize],h.prototype,"keyboardLayoutResource",null),ue([D.memoize],h.prototype,"argvResource",null),ue([D.memoize],h.prototype,"snippetsHome",null),ue([D.memoize],h.prototype,"isExtensionDevelopment",null),ue([D.memoize],h.prototype,"untitledWorkspacesHome",null),ue([D.memoize],h.prototype,"installSourcePath",null),ue([D.memoize],h.prototype,"builtinExtensionsPath",null),ue([D.memoize],h.prototype,"extensionsPath",null),ue([D.memoize],h.prototype,"extensionDevelopmentLocationURI",null),ue([D.memoize],h.prototype,"extensionDevelopmentKind",null),ue([D.memoize],h.prototype,"extensionTestsLocationURI",null),ue([D.memoize],h.prototype,"debugExtensionHost",null),ue([D.memoize],h.prototype,"serviceMachineIdResource",null),ue([D.memoize],h.prototype,"telemetryLogResource",null),ue([D.memoize],h.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=h;function g(L,a){return m(L["inspect-extensions"],L["inspect-brk-extensions"],5870,a,L.debugId)}t.parseExtensionHostPort=g;function p(L,a){return m(L["inspect-search"],L["inspect-brk-search"],5876,a)}t.parseSearchPort=p;function m(L,a,c,b,v){const f=Number(a||L)||(b?null:c),s=f?Boolean(!!a):!1;return{port:f,break:s,debugId:v}}}),function(){"use strict";function _(t,T,D,S){function A(C){const u=O(C),h=[u];return t.isAbsolute(u)||h.unshift(S),t.resolve(...h)}function O(C){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return t.join(h,D);const g=C["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=t.join(p,"AppData","Roaming")}break;case"darwin":h=t.join(T.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||t.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(h,D)}return{getUserDataPath:A}}if(typeof define=="function")define(Z[87],te([0,88,32,9,19,34]),function(t,T,D,S,A,O){const C=A.dirname(S.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(A.joinPath(C,"package.json").fsPath);return _(T,D,u.name,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),T=require("path"),D=require("os");module.exports=_(T,D,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[89],te([0,1,32,86,87]),function(_,t,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class A extends D.AbstractNativeEnvironmentService{constructor(C,u){super(C,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,S.getUserDataPath)(C)},u)}}t.NativeEnvironmentService=A}),define(Z[90],te([0,1,18]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function S(A,O){const C=u=>{if(typeof u!="string")return;const h=D.exec(u);if(!h)return;const g=O[h[1]]??u;return typeof g=="string"?g:typeof g.message=="string"?g.message:u};return(0,T.cloneAndChange)(A,C)}t.localizeManifest=S}),define(Z[49],te([0,1,80]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function A(m){return m=m.trim(),m==="*"||D.test(m)}t.isValidVersionStr=A;function O(m){if(!A(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let L=m.match(D);return L?{hasCaret:L[1]==="^",hasGreaterEquals:L[1]===">=",majorBase:L[2]==="x"?0:parseInt(L[2],10),majorMustEqual:L[2]!=="x",minorBase:L[4]==="x"?0:parseInt(L[4],10),minorMustEqual:L[4]!=="x",patchBase:L[6]==="x"?0:parseInt(L[6],10),patchMustEqual:L[6]!=="x",preRelease:L[8]||null}:null}t.parseVersion=O;function C(m){if(!m)return null;let L=m.majorBase,a=m.majorMustEqual,c=m.minorBase,b=m.minorMustEqual,v=m.patchBase,w=m.patchMustEqual;m.hasCaret&&(L===0||(b=!1),w=!1);let f=0;if(m.preRelease){const s=S.exec(m.preRelease);if(s){const[,o,e,i]=s;f=Date.UTC(Number(o),Number(e)-1,Number(i))}}return{majorBase:L,majorMustEqual:a,minorBase:c,minorMustEqual:b,patchBase:v,patchMustEqual:w,isMinimum:m.hasGreaterEquals,notBefore:f}}t.normalizeVersion=C;function u(m,L,a){let c;typeof m=="string"?c=C(O(m)):c=m;let b;L instanceof Date?b=L.getTime():typeof L=="string"&&(b=new Date(L).getTime());let v;if(typeof a=="string"?v=C(O(a)):v=a,!c||!v)return!1;let w=c.majorBase,f=c.minorBase,s=c.patchBase,o=v.majorBase,e=v.minorBase,i=v.patchBase,n=v.notBefore,r=v.majorMustEqual,l=v.minorMustEqual,d=v.patchMustEqual;return v.isMinimum?w>o?!0:w<o?!1:f>e?!0:f<e||b&&b<n?!1:s>=i:(w===1&&o===0&&(!r||!l||!d)&&(o=1,e=0,i=0,r=!0,l=!1,d=!1),w<o?!1:w>o?!r:f<e?!1:f>e?!l:s<i?!1:s>i?!d:!(b&&b<n))}t.isValidVersion=u;function h(m,L,a,c){return a.isBuiltin||typeof a.main=="undefined"?!0:p(m,L,a.engines.vscode,c)}t.isValidExtensionVersion=h;function g(m,L,a){return m==="*"||p(L,a,m)}t.isEngineValid=g;function p(m,L,a,c=[]){let b=C(O(a));if(!b)return c.push(T.localize(0,null,a)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return c.push(T.localize(1,null,a)),!1}else if(!b.majorMustEqual)return c.push(T.localize(2,null,a)),!1;return u(m,L,b)?!0:(c.push(T.localize(3,null,m,a)),!1)}}),define(Z[91],te([0,1,2,9,39,48]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class O extends T.Disposable{constructor(u,h,g,p){super();this.folders=u,this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new A.Client(D.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=O,O.MAX_RESTARTS=5}),define(Z[92],te([0,1,2,9,39,48]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class O extends T.Disposable{constructor(u,h,g,p,m={}){super();this.folders=u,this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=p,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new A.Client(D.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(u.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=O,O.MAX_RESTARTS=5}),define(Z[93],te([0,1,33,61,9,46]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class O{constructor(u,h,g,p,m){this.watchedFolder=u,this.eventCallback=g,this.logCallback=p,this.verboseLogging=m,this.restartCounter=0,Array.isArray(h)?this.ignored=h.map(L=>(0,D.parse)(L)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${h.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=(0,T.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",_).fsPath,u);const h=new A.LineDecoder;this.handle.stdout.on("data",g=>{const p=[];for(const m of h.write(g)){const L=m.split("|");if(L.length===2){const a=Number(L[0]),c=L[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(b=>b(c))){this.verboseLogging&&this.log(c);continue}p.push({type:O.changeTypeMap[a],path:c})}else this.log(L[1])}}p.length>0&&this.eventCallback(p)}),this.handle.on("error",g=>this.onError(g)),this.handle.stderr.on("data",g=>this.onError(g)),this.handle.on("exit",(g,p)=>this.onExit(g,p))}onError(u){this.error("process error: "+u.toString())}onExit(u,h){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${h})`),this.restartCounter<=O.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=O,O.MAX_RESTARTS=5,O.changeTypeMap=[0,1,2]}),define(Z[94],te([0,1,4,21,93]),function(_,t,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class A{constructor(C,u,h,g){this.onDidFilesChange=u,this.onLogMessage=h,this.verboseLogging=g,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=A}),define(Z[50],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class T{constructor(S,A=[],O=!1){this.ctor=S,this.staticArguments=A,this.supportsDelayedInstantiation=O}}t.SyncDescriptor=T}),define(Z[95],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class T{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}t.Node=T;class D{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let O of this._nodes.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const C=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(O);C.outgoing.set(this._hashFn(O),u),u.incoming.set(this._hashFn(A),C)}removeNode(A){const O=this._hashFn(A);this._nodes.delete(O);for(let C of this._nodes.values())C.outgoing.delete(O),C.incoming.delete(O)}lookupOrInsertNode(A){const O=this._hashFn(A);let C=this._nodes.get(O);return C||(C=new T(A),this._nodes.set(O,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[O,C]of this._nodes)A.push(`${O}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,O]of this._nodes){const C=new Set([A]),u=this._findCycle(O,C);if(u)return u}}_findCycle(A,O){for(let[C,u]of A.outgoing){if(O.has(C))return[...O,C].join(" -> ");O.add(C);const h=this._findCycle(u,O);if(h)return h;O.delete(C)}}}t.Graph=D}),define(Z[96],te([0,1,12]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Z[20],te([0,1,12]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,T.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,T.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[22],te([0,1,9,75,12]),function(_,t,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function A(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}t.isIExtensionIdentifier=A;var O;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(O=t.SortBy||(t.SortBy={}));var C;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(C=t.SortOrder||(t.SortOrder={}));var u;(function(p){p.Install="install",p.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var h;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(h=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class g extends Error{constructor(m,L){super(m);this.code=L,this.name=L}}t.ExtensionManagementError=g,t.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",_).toString(!0),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(Z[40],te([0,1,21,12]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=S;function A(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=A,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(O=t.ExtensionType||(t.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,m){if(typeof p=="undefined"||p===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof p=="string"||typeof m=="string"){let L=typeof p=="string"?p:p.value,a=typeof m=="string"?m:m.value;return T.equalsIgnoreCase(L,a)}return p._lower===m._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}t.ExtensionIdentifier=C;function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function h(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=h,t.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[23],te([0,1,21,40]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function S(a,c){return a.uuid&&c.uuid?a.uuid===c.uuid:a.id===c.id?!0:(0,T.compareIgnoreCase)(a.id,c.id)===0}t.areSameExtensions=S;class A{constructor(c,b){this.version=b,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof A?S(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=A;function O(a,c){return`${a}.${c}`}t.getExtensionId=O;function C(a){return a.toLocaleLowerCase()}t.adoptToGalleryExtensionId=C;function u(a,c){return C(O(a,c))}t.getGalleryExtensionId=u;function h(a,c){const b=[],v=w=>{for(const f of b)if(f.some(s=>S(c(s),c(w))))return f;return null};for(const w of a){const f=v(w);f?f.push(w):b.push([w])}return b}t.groupByExtension=h;function g(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=g;function p(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}t.getGalleryExtensionTelemetryData=p,t.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function m(a){const c=new Set;for(const b of a)b.malicious&&c.add(b.id.id);return c}t.getMaliciousExtensionsSet=m;function L(a,c){const b=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const w=v.shift();if(w&&b.every(f=>!S(f.identifier,{id:w}))){const f=a.filter(s=>S(s.identifier,{id:w}));f.length===1&&(b.push(f[0]),v.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}t.getExtensionDependencies=L});var fe=this&&this.__param||function(_,t){return function(T,D){t(T,D,_)}};define(Z[97],te([0,1,26,8,62,9,41,7,76,22,23,40]),function(_,t,T,D,S,A,O,C,u,h,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const m=w=>(0,u.localize)(0,null,w),L=(0,u.localize)(1,null,"ms-dotnettools.csharp");function a(w,f){return f?`${w.publisher}.${w.name}@${w.version}`:`${w.publisher}.${w.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(w){const f=c.exec(w);return f&&f[1]?[(0,g.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,g.adoptToGalleryExtensionId)(w),void 0]}t.getIdAndVersion=b;let v=class{constructor(f,s){this.extensionManagementService=f,this.extensionGalleryService=s}get location(){}async listExtensions(f,s,o=console){let e=await this.extensionManagementService.getInstalled(1);const i=p.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(s&&s!==""){if(i.indexOf(s.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(d=>d.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){o.log("Possible Categories: "),i.forEach(r=>{o.log(r)});return}this.location&&o.log((0,u.localize)(2,null,this.location)),e=e.sort((r,l)=>r.identifier.id.localeCompare(l.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,o.log(a(r.manifest,f)))}async installExtensions(f,s,o,e,i=console){const n=[],r=[];f.length&&i.log(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const l=await this.extensionManagementService.getInstalled(1),d=(I,k)=>{const z=l.find(q=>(0,g.areSameExtensions)(q.identifier,{id:I}));if(z){if(!k&&!e)return i.log((0,u.localize)(5,null,I,z.manifest.version,I)),!1;if(k&&z.manifest.version===k)return i.log((0,u.localize)(6,null,`${I}@${k}`)),!1}return!0},R=[],M=[];for(const I of f)if(I instanceof C.URI)R.push(I);else{const[k,z]=b(I);d(k,z)&&M.push({id:k,version:z,installOptions:{isBuiltin:!1,isMachineScoped:o}})}for(const I of s){const[k,z]=b(I);d(k,z)&&M.push({id:k,version:z,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(R.length&&await Promise.all(R.map(async I=>{try{const k=await this.installVSIX(I,{isBuiltin:!1,isMachineScoped:o},e,i);k&&r.push(k)}catch(k){i.error(k.message||k.stack||k),n.push(I.toString())}})),M.length){const I=await this.getGalleryExtensions(M);await Promise.all(M.map(async k=>{const z=I.get(k.id.toLowerCase());if(z)try{const q=await this.installFromGallery(k,z,l,e,i);q&&r.push(q)}catch(q){i.error(q.message||q.stack||q),n.push(k.id)}else i.error(`${m(k.version?`${k.id}@${k.version}`:k.id)}
${L}`),n.push(k.id)}))}if(n.length)throw new Error((0,u.localize)(7,null,n.join(", ")))}async installVSIX(f,s,o,e){const i=await this.extensionManagementService.getManifest(f);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,o,e))try{return await this.extensionManagementService.install(f,s),e.log((0,u.localize)(8,null,(0,S.getBaseLabel)(f))),i}catch(r){if((0,D.isPromiseCanceledError)(r))return e.log((0,u.localize)(9,null,(0,S.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const s=f.filter(({version:i})=>i===void 0).map(({id:i})=>i),o=f.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(s,T.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(o.map(async({id:i,version:n})=>{const r=await this.extensionGalleryService.getCompatibleExtension({id:i},n);r&&e.set(r.identifier.id.toLowerCase(),r)}))]),e}async installFromGallery({id:f,version:s,installOptions:o},e,i,n,r){const l=await this.extensionGalleryService.getManifest(e,T.CancellationToken.None);if(l&&!this.validateExtensionKind(l,r))return null;const d=i.find(R=>(0,g.areSameExtensions)(R.identifier,e.identifier));if(d){if(e.version===d.manifest.version)return r.log((0,u.localize)(10,null,s?`${f}@${s}`:f)),null;r.log((0,u.localize)(11,null,f,e.version))}try{return o.isBuiltin?r.log(s?(0,u.localize)(12,null,f,s):(0,u.localize)(13,null,f)):r.log(s?(0,u.localize)(14,null,f,s):(0,u.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,o),r.log((0,u.localize)(16,null,f,e.version)),l}catch(R){if((0,D.isPromiseCanceledError)(R))return r.log((0,u.localize)(17,null,f)),null;throw R}}validateExtensionKind(f,s){return!0}async validateVSIX(f,s,o){const e={id:(0,g.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,g.areSameExtensions)(e,r.identifier)&&(0,O.gt)(r.manifest.version,f.version));return n&&!s?(o.log((0,u.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,o)}async uninstallExtensions(f,s,o=console){const e=async n=>{if(n instanceof C.URI){const r=await this.extensionManagementService.getManifest(n);return a(r)}return n},i=[];for(const n of f){const r=await e(n),d=(await this.extensionManagementService.getInstalled()).filter(R=>(0,g.areSameExtensions)(R.identifier,{id:r}));if(!d.length)throw new Error(`${this.notInstalled(r)}
${L}`);if(d.some(R=>R.type===0)){o.log((0,u.localize)(19,null,r));return}if(!s&&d.some(R=>R.isBuiltin)){o.log((0,u.localize)(20,null,r));return}o.log((0,u.localize)(21,null,r));for(const R of d)await this.extensionManagementService.uninstall(R),i.push(R);this.location?o.log((0,u.localize)(22,null,r,this.location)):o.log((0,u.localize)(23,null,r))}}async locateExtension(f,s=console){const o=await this.extensionManagementService.getInstalled();f.forEach(e=>{o.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===A.Schemas.file){s.log(i.location.fsPath);return}})})}notInstalled(f){return this.location?(0,u.localize)(24,null,f,this.location):(0,u.localize)(25,null,f)}};v=ue([fe(0,h.IExtensionManagementService),fe(1,h.IExtensionGalleryService)],v),t.ExtensionManagementCLIService=v}),define(Z[98],te([0,1,2,4,11,40]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class O extends T.Disposable{constructor(u,h){super();this.environmentService=u,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(h.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(u){u.some(h=>!!h.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){S.Promises.rm(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=O}),define(Z[99],te([0,1,33,88,26,28,8,10,29,71,128]),function(_,t,T,D,S,A,O,C,u,h,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function p(a,c,b){return c["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,g.isLaunchedFromCli)(b)&&!c["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,g.isLaunchedFromCli)(b)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=new Promise(async v=>{const w=new S.CancellationTokenSource,f=setTimeout(()=>{a.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),w.dispose(!0),v({})},1e4);try{const s=await L(a,w.token);v(s)}catch(s){(0,O.isPromiseCanceledError)(s)||a.error(`[resolve shell env] Unable to resolve shell environment (${s}). Proceeding without shell environment...`),v({})}finally{clearTimeout(f),w.dispose()}})),m)}t.resolveShellEnv=p;let m;async function L(a,c){const b=new Promise(async(v,w)=>{const f=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",f);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",s);const o=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",i);const n=await(0,h.getSystemShell)(C.OS,i);if(a.trace("getUnixShellEnvironment#shell",n),c.isCancellationRequested)return w(O.canceled);const r=D.basename(n);let l,d;/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,d=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,d=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),l);const R=(0,T.spawn)(n,[...d,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});c.onCancellationRequested(()=>(R.kill(),w(O.canceled))),R.on("error",k=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(k)),v({})});const M=[];R.stdout.on("data",k=>M.push(k));const I=[];R.stderr.on("data",k=>I.push(k)),R.on("close",(k,z)=>{const q=Buffer.concat(M).toString("utf8");a.trace("getUnixShellEnvironment#raw",q);const J=Buffer.concat(I).toString("utf8");if(J.trim()&&a.trace("getUnixShellEnvironment#stderr",J),k||z)return w(new Error(`Failed to get environment (code ${k}, signal ${z})`));const ie=e.exec(q),se=ie?ie[1]:"{}";try{const Y=JSON.parse(se);f?Y.ELECTRON_RUN_AS_NODE=f:delete Y.ELECTRON_RUN_AS_NODE,s?Y.ELECTRON_NO_ATTACH_CONSOLE=s:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",Y),v(Y)}catch(Y){a.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(Y)),w(Y)}})});try{return await b}catch(v){return a.error("getUnixShellEnvironment#error",(0,A.toErrorMessage)(v)),{}}}}),define(Z[51],te([0,1,10,7,17]),function(_,t,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function A(u){return u.map(h=>({type:h.type,resource:D.URI.file(h.path)}))}t.toFileChanges=A;function O(u){const h=new C;for(const g of u)h.processEvent(g);return h.normalize()}t.normalizeFileChanges=O;class C{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(h){const g=this.mapPathToChange.get(h.path);if(g){const p=g.type,m=h.type;p===1&&m===2?(this.mapPathToChange.delete(h.path),this.normalized.splice(this.normalized.indexOf(g),1)):p===2&&m===1?g.type=0:p===1&&m===0||(g.type=m)}else this.normalized.push(h),this.mapPathToChange.set(h.path,h)}normalize(){const h=[],g=[];return this.normalized.filter(p=>p.type!==2?(h.push(p),!1):!0).sort((p,m)=>p.path.length-m.path.length).filter(p=>g.some(m=>(0,S.isParent)(p.path,m,!T.isLinux))?!1:(g.push(p.path),!0)).concat(h)}}}),define(Z[100],te([0,1,3,2,4,63,11,65,51]),function(_,t,T,D,S,A,O,C,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class h extends D.Disposable{constructor(p,m,L,a){super();this.path=p,this.onDidFilesChange=m,this.onLogMessage=L,this.verboseLogging=a,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(p){this.verboseLogging=p}async startWatching(){try{const{stat:p,symbolicLink:m}=await O.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let L=this.path;if(m)try{L=await(0,A.realpath)(L)}catch(a){if(this.onError(a),m.dangling)return}p.isDirectory()?this._register((0,C.watchFolder)(L,(a,c)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(c))})},a=>this.onError(a))):this._register((0,C.watchFile)(L,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(p){p.code!=="ENOENT"&&this.onError(p)}}onFileChange(p){this.fileChangesBuffer.push(p),this.verboseLogging&&this.onVerbose(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const L=(0,u.normalizeFileChanges)(m);if(this.verboseLogging)for(const a of L)this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);L.length>0&&this.onDidFilesChange(L)})}onError(p){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${p}`})}onVerbose(p){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=h}),define(Z[52],te([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class T{constructor(...S){this._entries=new Map;for(let[A,O]of S)this.set(A,O)}set(S,A){const O=this._entries.get(S);return this._entries.set(S,A),O}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}t.ServiceCollection=T}),define(Z[101],te([0,1,3,8,50,95,12,52]),function(_,t,T,D,S,A,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class h extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class g{constructor(a=new C.ServiceCollection,c=!1,b){this._activeInstantiations=new Set,this._services=a,this._strict=c,this._parent=b,this._services.set(O.IInstantiationService,this)}createChild(a){return new g(a,this._strict,this)}invokeFunction(a,...c){let b=m.traceInvocation(a),v=!1;try{return a({get:(f,s)=>{if(v)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(f,b);if(!o&&s!==O.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return o}},...c)}finally{v=!0,b.stop()}}createInstance(a,...c){let b,v;return a instanceof S.SyncDescriptor?(b=m.traceCreation(a.ctor),v=this._createInstance(a.ctor,a.staticArguments.concat(c),b)):(b=m.traceCreation(a),v=this._createInstance(a,c,b)),b.stop(),v}_createInstance(a,c=[],b){let v=O._util.getServiceDependencies(a).sort((s,o)=>s.index-o.index),w=[];for(const s of v){let o=this._getOrCreateServiceInstance(s.id,b);if(!o&&this._strict&&!s.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${s.id}.`);w.push(o)}let f=v.length>0?v[0].index:c.length;if(c.length!==f){console.warn(`[createInstance] First service dependency of ${a.name} at position ${f+1} conflicts with ${c.length} static arguments`);let s=f-c.length;s>0?c=c.concat(new Array(s)):c=c.slice(0,f)}return new a(...[...c,...w])}_setServiceInstance(a,c){if(this._services.get(a)instanceof S.SyncDescriptor)this._services.set(a,c);else if(this._parent)this._parent._setServiceInstance(a,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let c=this._services.get(a);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):c}_getOrCreateServiceInstance(a,c){let b=this._getServiceInstanceOrDescriptor(a);return b instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,b,c.branch(a,!0)):(c.branch(a,!1),b)}_safeCreateAndCacheServiceInstance(a,c,b){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,c,b)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,c,b){const v=new A.Graph(s=>s.id.toString());let w=0;const f=[{id:a,desc:c,_trace:b}];for(;f.length;){const s=f.pop();if(v.lookupOrInsertNode(s),w++>1e3)throw new h(v);for(let o of O._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(!e&&!o.optional&&console.warn(`[createInstance] ${a} depends on ${o.id} which is NOT registered.`),e instanceof S.SyncDescriptor){const i={id:o.id,desc:e,_trace:s._trace.branch(o.id,!0)};v.insertEdge(s,i),f.push(i)}}}for(;;){const s=v.roots();if(s.length===0){if(!v.isEmpty())throw new h(v);break}for(const{data:o}of s){if(this._getServiceInstanceOrDescriptor(o.id)instanceof S.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}v.removeNode(o)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,c,b=[],v,w){if(this._services.get(a)instanceof S.SyncDescriptor)return this._createServiceInstance(c,b,v,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,c,b,v,w);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(a,c=[],b,v){if(b){const w=new T.IdleValue(()=>this._createInstance(a,c,v));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let o=w.value,e=o[s];return typeof e!="function"||(e=e.bind(o),f[s]=e),e},set(f,s,o){return w.value[s]=o,!0}})}else return this._createInstance(a,c,v)}}t.InstantiationService=g;var p;(function(L){L[L.Creation=0]="Creation",L[L.Invocation=1]="Invocation",L[L.Branch=2]="Branch"})(p||(p={}));class m{constructor(a,c){this.type=a,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return u?new m(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(a){return u?new m(0,a.name):m._None}branch(a,c){let b=new m(2,a.toString());return this._dep.push([a,c,b]),b}stop(){let a=Date.now()-this._start;m._totals+=a;let c=!1;function b(w,f){let s=[],o=new Array(w+1).join("	");for(const[e,i,n]of f._dep)if(i&&n){c=!0,s.push(`${o}CREATES -> ${e}`);let r=b(w+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${e}`);return s.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(a>2||c)&&console.log(v.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[53],te([0,1,12]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,T.createDecorator)("localizationsService");function D(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const A of S.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}t.isValidLocalization=D}),define(Z[15],te([0,1,28,14,2,10,12]),function(_,t,T,D,S,A,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,O.createDecorator)("logService"),t.ILoggerService=(0,O.createDecorator)("loggerService");function C(){return new Date().toISOString()}var u;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class h extends S.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=h;class g extends h{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(u.Error,this.format(n))}else this.log(u.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=g;class p extends h{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!A.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,e,...i):console.warn(`[main ${C()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=p;class m extends h{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=m;class L extends h{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=L;class a extends h{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=a;class c extends S.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=c;class b extends S.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=b;class v{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=v;function w(o){if(o.verbose)return u.Trace;if(typeof o.logLevel=="string"){const e=f(o.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=w;function f(o){switch(o){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=f;function s(o){switch(o){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=s}),define(Z[102],te([0,1,3,8,2,10,19,41,7,29,11,20,22,23,17,15]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends S.Disposable{constructor(f,s,o,e){super();this.fileService=s,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=u.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const o=this.getName(f),e=(0,O.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const i=(0,O.joinPath)(this.extensionsDownloadDir,`.${(0,h.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,s);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(f){}async rename(f,s,o){try{await g.Promises.rename(f.fsPath,s.fsPath)}catch(e){if(A.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],o=[];for(const n of f.children){const r=this.parse(n.name);r&&o.push([r,n])}const e=(0,L.groupByExtension)(o,([n])=>n),i=[];for(const n of e)n.sort((r,l)=>C.rcompare(r[0].version,l[0].version)),s.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await T.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new L.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,h.generateUuid)()}parse(f){const s=b.exec(f);return s&&s[1]&&s[2]?new L.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};v=ue([fe(0,p.INativeEnvironmentService),fe(1,a.IFileService),fe(2,m.IExtensionGalleryService),fe(3,c.ILogService)],v),t.ExtensionsDownloader=v}),define(Z[103],te([0,1,33,3,28,14,2,9,4,11,20,15]),function(_,t,T,D,S,A,O,C,u,h,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let m=class extends O.Disposable{constructor(a,c){super();this.environmentService=a,this.logService=c,this.processesLimiter=new D.Limiter(5)}async postUninstall(a){const c=this.parseScript(a,"uninstall");return c&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${b}`)))),h.Promises.rm(this.getExtensionStoragePath(a)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(a,c){const b=`vscode:${c}`;if(a.location.scheme===C.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[b]=="string"){const v=a.manifest.scripts[b].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${b} should be a node script`),null):{script:(0,u.join)(a.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(a,c,b,v,w){return new Promise((f,s)=>{const o=this.start(a,c,b,w);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?s(n):f(void 0)};o.on("error",n=>{i((0,S.toErrorMessage)(n)||"Unknown")}),o.on("exit",(n,r)=>{i(n?`post-${c} process exited with code ${n}`:void 0)}),v&&(e=setTimeout(()=>{e=null,o.kill(),s("timed out")},5e3))})}start(a,c,b,v){const w={silent:!0,execArgv:void 0},f=(0,T.fork)(a,[`--type=extension-post-${c}`,...b],w);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=A.Event.fromNodeEventEmitter(f.stdout,"data"),o=A.Event.fromNodeEventEmitter(f.stderr,"data");s(n=>this.logService.info(v.identifier.id,v.manifest.version,`post-${c}`,n)),o(n=>this.logService.error(v.identifier.id,v.manifest.version,`post-${c}`,n));const e=A.Event.any(A.Event.map(s,n=>({data:`%c${n}`,format:[""]})),A.Event.map(o,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(v.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(a){return(0,u.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};m=ue([fe(0,g.IEnvironmentService),fe(1,p.ILogService)],m),t.ExtensionsLifecycle=m}),define(Z[104],te([0,1,14,2,19,7,20,23,17,15]),function(_,t,T,D,S,A,O,C,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let g=class extends D.Disposable{constructor(m,L,a,c){super();this.extensionsManagementService=m,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(w=>this.onInstallExtension(w))),this._register(m.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(m.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const b=A.URI.file(a.extensionsPath),v=new S.ExtUri(w=>!L.hasCapability(w,1024));this._register(L.watch(b)),this._register(T.Event.filter(L.onDidChangeFilesRaw,w=>w.changes.some(f=>this.doesChangeAffects(f,b,v)))(()=>this.onDidChange()))}doesChangeAffects(m,L,a){return a.isEqual(a.dirname(m.resource),L)?a.isEqual(m.resource,a.joinPath(L,".obsolete"))?!0:!(m.type!==1&&m.type!==2||a.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const L of m)this.removeInstallingExtension(L.identifier),L.local&&this.addInstalledExtension(L.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(L=>!(0,C.areSameExtensions)(L,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(L=>!(0,C.areSameExtensions)(L,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),L=m.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(b=>(0,C.areSameExtensions)(b,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),a=this.installedExtensions.filter(c=>this.installingExtensions.some(b=>(0,C.areSameExtensions)(b,c))?!1:m.every(b=>!(0,C.areSameExtensions)(b.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=m.map(c=>c.identifier),(L.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:L,removed:a})}}};g=ue([fe(1,u.IFileService),fe(2,O.INativeEnvironmentService),fe(3,h.ILogService)],g),t.ExtensionsWatcher=g}),define(Z[105],te([0,1,129,24,3,2,9,4,11,20,22,23,53,15]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let a=class extends A.Disposable{constructor(v,w,f){super();this.extensionManagementService=v,this.logService=f,this.cache=this._register(new c(w,f)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),w=["en",...Object.keys(v)];return(0,D.distinct)(w)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const w=await this.cache.getLanguagePacks();Object.keys(w).some(f=>w[f]&&w[f].extensions.some(s=>(0,p.areSameExtensions)(s.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(w);return!(0,D.equals)(Object.keys(v),Object.keys(f))}};a=ue([fe(0,g.IExtensionManagementService),fe(1,h.INativeEnvironmentService),fe(2,L.ILogService)],a),t.LocalizationsService=a;let c=class extends A.Disposable{constructor(v,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(w=>{Object.keys(w).forEach(f=>delete w[f]),this.createLanguagePacksFromExtensions(w,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...w){for(const f of w)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,f);Object.keys(v).forEach(f=>this.updateHash(v[f]))}createLanguagePacksFromExtension(v,w){const f=w.identifier,s=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const o of s)if(w.location.scheme===O.Schemas.file&&(0,m.isValidLocalization)(o)){let e=v[o.languageId];e||(e={hash:"",extensions:[],translations:{}},v[o.languageId]=e);let i=e.extensions.filter(n=>(0,p.areSameExtensions)(n.extensionIdentifier,f))[0];i?i.version=w.manifest.version:e.extensions.push({extensionIdentifier:f,version:w.manifest.version});for(const n of o.translations)e.translations[n.id]=(0,C.join)(w.location.fsPath,n.path)}}updateHash(v){if(v){const w=(0,T.createHash)("md5");for(const f of v.extensions)w.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);v.hash=w.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(s){return{}}}).then(f=>(w=v(f),f)).then(f=>{for(const o of Object.keys(f))f[o]||delete f[o];this.languagePacks=f,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),u.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>w,f=>this.logService.error(f))})}};c=ue([fe(0,h.INativeEnvironmentService),fe(1,L.ILogService)],c)}),define(Z[106],te([0,1,17,15]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function S(u,h,g,p){try{const m=await new Promise((L,a)=>{_(["spdlog"],L,a)});return m.setFlushOn(D.LogLevel.Trace),m.createAsyncRotatingLogger(u,h,g,p)}catch(m){console.error(m)}return null}function A(u,h,g,p){const m=_.__$__nodeRequire("spdlog");return m.setFlushOn(D.LogLevel.Trace),m.createRotatingLogger(u,h,g,p)}t.createRotatingLogger=A;function O(u,h,g){switch(h){case D.LogLevel.Trace:u.trace(g);break;case D.LogLevel.Debug:u.debug(g);break;case D.LogLevel.Info:u.info(g);break;case D.LogLevel.Warning:u.warn(g);break;case D.LogLevel.Error:u.error(g);break;case D.LogLevel.Critical:u.critical(g);break;default:throw new Error("Invalid log level")}}class C extends D.AbstractMessageLogger{constructor(h,g,p,m){super();this.name=h,this.filepath=g,this.rotating=p,this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(L=>{this._logger&&this._logger.setLevel(L)}))}_createSpdLogLogger(){const h=this.rotating?6:1,g=30/h*T.ByteSize.MB;return S(this.name,this.filepath,g,h).then(p=>{if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:m,message:L}of this.buffer)O(this._logger,m,L);this.buffer=[]}})}log(h,g){this._logger?O(this._logger,h,g):this.getLevel()<=h&&this.buffer.push({level:h,message:g})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=C}),define(Z[54],te([0,1,16,8,82,17,35]),function(_,t,T,D,S,A,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function C(p,m,L,a,c,b){let v;try{await u(p,m,L,a,c,b)}catch(w){v=w}finally{v&&c.errorTransformer&&(v=c.errorTransformer(v)),typeof v!="undefined"&&L.error(v),L.end()}}t.readFileIntoStream=C;async function u(p,m,L,a,c,b){h(b);const v=await p.open(m,{create:!1});try{h(b);let w=0,f=0,s=c&&typeof c.length=="number"?c.length:void 0,o=T.VSBuffer.alloc(Math.min(c.bufferSize,typeof s=="number"?s:c.bufferSize)),e=c&&typeof c.position=="number"?c.position:0,i=0;do f=await p.read(v,e,o.buffer,i,o.byteLength-i),e+=f,i+=f,w+=f,typeof s=="number"&&(s-=f),i===o.byteLength&&(await L.write(a(o)),o=T.VSBuffer.alloc(Math.min(c.bufferSize,typeof s=="number"?s:c.bufferSize)),i=0);while(f>0&&(typeof s!="number"||s>0)&&h(b)&&g(w,c));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),L.write(a(o.slice(0,n)))}}catch(w){throw(0,A.ensureFileSystemProviderError)(w)}finally{await p.close(v)}}function h(p){if(p.isCancellationRequested)throw(0,D.canceled)();return!0}function g(p,m){if(m?.limits){if(typeof m.limits.memory=="number"&&p>m.limits.memory)throw(0,A.createFileSystemProviderError)((0,S.localize)(0,null,O.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&p>m.limits.size)throw(0,A.createFileSystemProviderError)((0,S.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[107],te([0,1,24,3,16,26,14,130,2,45,9,131,19,37,81,17,54,15]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L,a,c,b,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let w=class Ne extends u.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new O.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new O.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new c.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new c.FileChangesEvent(o,!0)))),this.watchedResources=h.TernarySearchTree.forUris(o=>{const e=this.getProvider(o.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(s,o){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:o});const e=new u.DisposableStore;return e.add(o.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(o)))),e.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:s}))),typeof o.onDidErrorOccur=="function"&&e.add(o.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:o}),this.provider.delete(s),(0,u.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){o.push(e)}}),!this.provider.has(s)&&await D.Promises.settled(o)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,o){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&o)}listCapabilities(){return C.Iterable.map(this.provider,([s,o])=>({scheme:s,capabilities:o.capabilities}))}async withProvider(s){if(!(0,m.isAbsolutePath)(s))throw new c.FileOperationError((0,a.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const o=this.provider.get(s.scheme);if(!o){const e=new Error;throw e.name="ENOPRO",e.message=(0,a.localize)(1,null,s.toString()),e}return o}async withReadProvider(s){const o=await this.withProvider(s);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o)||(0,c.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const o=await this.withProvider(s);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,o){try{return await this.doResolveFile(s,o)}catch(e){throw(0,c.toFileSystemProviderErrorCode)(e)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,a.localize)(2,null,this.resourceForError(s)),1):(0,c.ensureFileSystemProviderError)(e)}}async doResolveFile(s,o){const e=await this.withProvider(s),i=this.isPathCaseSensitive(e),n=o?.resolveTo,r=o?.resolveSingleChildDescendants,l=o?.resolveMetadata,d=await e.stat(s);let R;return this.toFileStat(e,s,d,void 0,!!l,(M,I)=>(R||(R=h.TernarySearchTree.forUris(()=>!i),R.set(s,!0),(0,T.isNonEmptyArray)(n)&&n.forEach(k=>R.set(k,!0))),Boolean(R.findSuperstr(M.resource)||R.get(M.resource))?!0:M.isDirectory&&r?I===1:!1))}async toFileStat(s,o,e,i,n,r){const{providerExtUri:l}=this.getExtUri(s),d={resource:o,name:l.basename(o),isFile:(e.type&c.FileType.File)!=0,isDirectory:(e.type&c.FileType.Directory)!=0,isSymbolicLink:(e.type&c.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&c.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,c.etag)({mtime:e.mtime,size:e.size})};if(d.isDirectory&&r(d,i)){try{const R=await s.readdir(o),M=await D.Promises.settled(R.map(async([I,k])=>{try{const z=l.joinPath(o,I),q=n?await s.stat(z):{type:k};return await this.toFileStat(s,z,q,R.length,n,r)}catch(z){return this.logService.trace(z),null}}));d.children=(0,T.coalesce)(M)}catch(R){this.logService.trace(R),d.children=[]}return d}return d}async resolveAll(s){return D.Promises.settled(s.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const o=await this.withProvider(s);try{return!!await o.stat(s)}catch(e){return!1}}async canCreateFile(s,o){try{await this.doValidateCreateFile(s,o)}catch(e){return e}return!0}async doValidateCreateFile(s,o){if(!o?.overwrite&&await this.exists(s))throw new c.FileOperationError((0,a.localize)(3,null,this.resourceForError(s)),3,o)}async createFile(s,o=S.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const i=await this.writeFile(s,o);return this._onDidRunOperation.fire(new c.FileOperationEvent(s,0,i)),i}async writeFile(s,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,e)||await this.mkdirp(i,n.dirname(s));let l;if((0,c.hasReadWriteCapability)(i)&&!(o instanceof S.VSBuffer))if((0,L.isReadableStream)(o)){const d=await(0,L.peekStream)(o,3);d.ended?l=S.VSBuffer.concat(d.buffer):l=d}else l=(0,L.peekReadable)(o,d=>S.VSBuffer.concat(d),3);else l=o;!(0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasReadWriteCapability)(i)&&l instanceof S.VSBuffer?await this.doWriteUnbuffered(i,s,e,l):await this.doWriteBuffered(i,s,e,l instanceof S.VSBuffer?(0,S.bufferToReadable)(l):l)}catch(r){throw new c.FileOperationError((0,a.localize)(4,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,o,e){if(!!e?.unlock&&!(s.capabilities&8192))throw new Error((0,a.localize)(5,null,this.resourceForError(o)));let n;try{n=await s.stat(o)}catch(r){return}if((n.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,a.localize)(6,null,this.resourceForError(o)),0,e);if(this.throwIfFileIsReadonly(o,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==c.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,c.etag)({mtime:e.mtime,size:n.size}))throw new c.FileOperationError((0,a.localize)(7,null),3,e);return n}async readFile(s,o){const e=await this.withReadProvider(s);return o?.atomic?this.doReadFileAtomic(e,s,o):this.doReadFile(e,s,o)}async doReadFileAtomic(s,o,e){return new Promise((i,n)=>{this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(s,o,e);i(r)}catch(r){n(r)}})})}async doReadFile(s,o,e){const i=await this.doReadFileStream(s,o,{...e,preferUnbuffered:!0});return{...i,value:await(0,S.streamToBuffer)(i.value)}}async readFileStream(s,o){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,o)}async doReadFileStream(s,o,e){const i=new A.CancellationTokenSource,n=this.validateReadFile(o,e).then(l=>l,l=>{throw i.cancel(),l});let r;try{return typeof e?.etag=="string"&&e.etag!==c.ETAG_DISABLED&&await n,!((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasFileReadStreamCapability)(s))||(0,c.hasReadWriteCapability)(s)&&e?.preferUnbuffered?r=this.readFileUnbuffered(s,o,e):(0,c.hasFileReadStreamCapability)(s)?r=this.readFileStreamed(s,o,i.token,e):r=this.readFileBuffered(s,o,i.token,e),{...await n,value:r}}catch(l){r&&await(0,L.consumeStream)(r);const d=(0,a.localize)(8,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(l).toString());throw l instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(d,l.stat,e):new c.FileOperationError(d,(0,c.toFileOperationResult)(l),e)}}readFileStreamed(s,o,e,i=Object.create(null)){const n=s.readFileStream(o,i,e);return(0,L.transform)(n,{data:r=>r instanceof S.VSBuffer?r:S.VSBuffer.wrap(r),error:r=>new c.FileOperationError((0,a.localize)(9,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},r=>S.VSBuffer.concat(r))}readFileBuffered(s,o,e,i=Object.create(null)){const n=(0,S.newWriteableBufferStream)();return(0,b.readFileIntoStream)(s,o,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new c.FileOperationError((0,a.localize)(10,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(s,o,e){const i=(0,L.newWriteableStream)(n=>S.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(o);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(o,n.byteLength,e),i.end(S.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,o){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new c.FileOperationError((0,a.localize)(11,null,this.resourceForError(s)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.ETAG_DISABLED&&o.etag===e.etag)throw new c.NotModifiedSinceFileOperationError((0,a.localize)(12,null),e,o);return this.validateReadFileLimits(s,e.size,o),e}validateReadFileLimits(s,o,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&o>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&o>e.limits.size&&(i=7),typeof i=="number")throw new c.FileOperationError((0,a.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,o,e){return this.doCanMoveCopy(s,o,"move",e)}async canCopy(s,o,e){return this.doCanMoveCopy(s,o,"copy",e)}async doCanMoveCopy(s,o,e,i){if(s.toString()!==o.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,s,r,o,e,i)}catch(n){return n}return!0}async move(s,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(i,s,n,o,"move",!!e),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(s,r==="move"?2:3,l)),l}async copy(s,o,e){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(i,s,n,o,"copy",!!e),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(s,r==="copy"?3:2,l)),l}async doMoveCopy(s,o,e,i,n,r){if(o.toString()===i.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(s,o,e,i,n,r);if(l&&!d&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(s===e&&(0,c.hasFileFolderCopyCapability)(s))await s.copy(o,i,{overwrite:r});else{const R=await this.resolve(o);R.isDirectory?await this.doCopyFolder(s,R,e,i):await this.doCopyFile(s,o,e,i)}return n}else return s===e?(await s.rename(o,i,{overwrite:r}),n):(await this.doMoveCopy(s,o,e,i,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(s,o,e,i){if((0,c.hasOpenReadWriteCloseCapability)(s)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,o,e,i);if((0,c.hasOpenReadWriteCloseCapability)(s)&&(0,c.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,o,e,i);if((0,c.hasReadWriteCapability)(s)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,o,e,i);if((0,c.hasReadWriteCapability)(s)&&(0,c.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,o,e,i)}async doCopyFolder(s,o,e,i){await e.mkdir(i),Array.isArray(o.children)&&await D.Promises.settled(o.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),e,r):this.doCopyFile(s,n.resource,e,r)}))}async doValidateMoveCopy(s,o,e,i,n,r){let l=!1;if(s===e){const{providerExtUri:R,isPathCaseSensitive:M}=this.getExtUri(s);if(M||(l=R.isEqual(o,i)),l&&n==="copy")throw new Error((0,a.localize)(14,null,this.resourceForError(o),this.resourceForError(i)));if(!l&&R.isEqualOrParent(i,o))throw new Error((0,a.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}const d=await this.exists(i);if(d&&!l){if(!r)throw new c.FileOperationError((0,a.localize)(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(s===e){const{providerExtUri:R}=this.getExtUri(s);if(R.isEqualOrParent(o,i))throw new Error((0,a.localize)(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:d,isSameResourceWithDifferentPathCase:l}}getExtUri(s){const o=this.isPathCaseSensitive(s);return{providerExtUri:o?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(o,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(s,0,e)),e}async mkdirp(s,o){const e=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(o,i.dirname(o));)try{if(((await s.stat(o)).type&c.FileType.Directory)==0)throw new Error((0,a.localize)(18,null,this.resourceForError(o)));break}catch(n){if((0,c.toFileSystemProviderErrorCode)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(o)),o=i.dirname(o)}for(let n=e.length-1;n>=0;n--){o=i.joinPath(o,e[n]);try{await s.mkdir(o)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(s,o){try{await this.doValidateDelete(s,o)}catch(e){return e}return!0}async doValidateDelete(s,o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!o?.useTrash&&!(e.capabilities&4096))throw new Error((0,a.localize)(19,null,this.resourceForError(s)));let n;try{n=await e.stat(s)}catch(l){}if(n)this.throwIfFileIsReadonly(s,n);else throw new c.FileOperationError((0,a.localize)(20,null,this.resourceForError(s)),1);if(!!!o?.recursive){const l=await this.resolve(s);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,a.localize)(21,null,this.resourceForError(s)))}return e}async del(s,o){const e=await this.doValidateDelete(s,o),i=!!o?.useTrash,n=!!o?.recursive;await e.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new c.FileOperationEvent(s,1))}onDidChangeFile(s,o){this._onDidChangeFilesRaw.fire({changes:s});let e,i;{for(const n of s)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new c.FileChangesEvent(e,!o))}if(i){const n=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,o={recursive:!1,excludes:[]}){const e=new u.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,u.toDisposable)(()=>n())),this.doWatch(s,o).then(r=>{i?(0,u.dispose)(r):n=()=>(0,u.dispose)(r)},r=>this.logService.error(r))}return o.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),e.add((0,u.toDisposable)(()=>{const i=this.watchedResources.get(s);typeof i=="number"&&(i<=1?this.watchedResources.delete(s):this.watchedResources.set(s,i-1))}))),e}async doWatch(s,o){const e=await this.withProvider(s),i=this.toWatchKey(e,s,o),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(s,o)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,u.toDisposable)(()=>{n.count--,n.count===0&&((0,u.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,o,e){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(o),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,u.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(o,{create:!0,unlock:e?.unlock??!1});try{(0,L.isReadableStream)(i)||(0,L.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,n,i):await this.doWriteReadableBufferedQueued(s,n,i)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,o,e){let i=0,n;if((0,L.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=S.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,o,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(r,l)=>{(0,L.listenStream)(n,{onData:async d=>{n.pause();try{await this.doWriteBuffer(s,o,d,d.byteLength,i,0)}catch(R){return l(R)}i+=d.byteLength,setTimeout(()=>n.resume())},onError:d=>l(d),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(s,o,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(s,o,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,o,e,i,n,r){let l=0;for(;l<i;)l+=await s.write(o,n+l,e.buffer,r+l,i-l)}async doWriteUnbuffered(s,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,o,e,i))}async doWriteUnbufferedQueued(s,o,e,i){let n;i instanceof S.VSBuffer?n=i:(0,L.isReadableStream)(i)?n=await(0,S.streamToBuffer)(i):(0,L.isReadableBufferedStream)(i)?n=await(0,S.bufferedStreamToBuffer)(i):n=(0,S.readableToBuffer)(i),await s.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(s,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,o,e,i))}async doPipeBufferedQueued(s,o,e,i){let n,r;try{n=await s.open(o,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const l=S.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,R=0,M=0;do M=await s.read(n,d,l.buffer,R,l.byteLength-R),await this.doWriteBuffer(e,r,l,M,d,R),d+=M,R+=M,R===l.byteLength&&(R=0);while(M>0)}catch(l){throw(0,c.ensureFileSystemProviderError)(l)}finally{await D.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(s,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,o,e,i))}async doPipeUnbufferedQueued(s,o,e,i){return e.writeFile(i,await s.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,o,e,i))}async doPipeUnbufferedToBufferedQueued(s,o,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await s.readFile(o);await this.doWriteBuffer(e,n,S.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(s,o,e,i){const n=await(0,S.streamToBuffer)(this.readFileBuffered(s,o,A.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(s,o){if(s.capabilities&2048)throw new c.FileOperationError((0,a.localize)(22,null,this.resourceForError(o)),6);return s}throwIfFileIsReadonly(s,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,a.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===g.Schemas.file?s.fsPath:s.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=ue([fe(0,v.ILogService)],w),t.FileService=w}),define(Z[108],te([0,1,24,3,16,14,31,2,4,10,19,37,11,83,17,54,100,91,92,51,94,15]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L,a,c,b,v,w,f,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends C.Disposable{constructor(n,r){super();this.logService=n,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,h.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:l}=await m.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,l),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await m.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(r.map(async d=>{try{let R;d.isSymbolicLink()?R=(await this.stat((0,g.joinPath)(n,d.name))).type:R=this.toType(d),l.push([d.name,R])}catch(R){this.logService.trace(R)}})),l}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let l;return r?.dangling?l=a.FileType.Unknown:n.isFile()?l=a.FileType.File:n.isDirectory()?l=a.FileType.Directory:l=a.FileType.Unknown,r&&(l|=a.FileType.SymbolicLink),l}async readFile(n){try{const r=this.toFilePath(n);return await m.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(n,r,l){const d=(0,p.newWriteableStream)(R=>S.VSBuffer.concat(R.map(M=>S.VSBuffer.wrap(M))).buffer);return(0,c.readFileIntoStream)(this,n,d,R=>R.buffer,{...r,bufferSize:this.BUFFER_SIZE},l),d}async writeFile(n,r,l){let d;try{const R=this.toFilePath(n);if(!l.create||!l.overwrite){if(await m.Promises.exists(R)){if(!l.overwrite)throw(0,a.createFileSystemProviderError)((0,L.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,a.createFileSystemProviderError)((0,L.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(d,0,r,0,r.byteLength)}catch(R){throw await this.toFileSystemProviderWriteError(n,R)}finally{typeof d=="number"&&await this.close(d)}}async open(n,r){try{const l=this.toFilePath(n);if((0,a.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:M}=await m.SymlinkSupport.stat(l);M.mode&128||await m.Promises.chmod(l,M.mode|128)}catch(M){this.logService.trace(M)}let d;if((0,a.isFileOpenForWriteOptions)(r)){if(h.isWindows)try{await m.Promises.truncate(l,0),d="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}d||(d="w")}else d="r";const R=await m.Promises.open(l,d);return this.mapHandleToPos.set(R,0),(0,a.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(R,n),R}catch(l){throw(0,a.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await m.Promises.fdatasync(n)}catch(r){this.canFlush=!1,this.logService.error(r)}return await m.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}}async read(n,r,l,d,R){const M=this.normalizePos(n,r);let I=null;try{const k=await m.Promises.read(n,l,d,R,M);return typeof k=="number"?I=k:I=k.bytesRead,I}catch(k){throw this.toFileSystemProviderError(k)}finally{this.updatePos(n,M,I)}}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,l){const d=this.mapHandleToPos.get(n);typeof d=="number"&&(typeof r=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,d+l):this.mapHandleToPos.delete(n)))}async write(n,r,l,d,R){return(0,D.retry)(()=>this.doWrite(n,r,l,d,R),100,3)}async doWrite(n,r,l,d,R){const M=this.normalizePos(n,r);let I=null;try{const k=await m.Promises.write(n,l,d,R,M);return typeof k=="number"?I=k:I=k.bytesWritten,I}catch(k){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),k)}finally{this.updatePos(n,M,I)}}async mkdir(n){try{await m.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const l=this.toFilePath(n);await this.doDelete(l,r)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,r){r.recursive?await m.Promises.rm(n,m.RimRafMode.MOVE):await m.Promises.unlink(n)}async rename(n,r,l){const d=this.toFilePath(n),R=this.toFilePath(r);if(d!==R)try{await this.validateTargetDeleted(n,r,"move",l.overwrite),await m.Promises.move(d,R)}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,L.localize)(2,null,(0,u.basename)(d),(0,u.basename)((0,u.dirname)(R)),M.toString()))),this.toFileSystemProviderError(M)}}async copy(n,r,l){const d=this.toFilePath(n),R=this.toFilePath(r);if(d!==R)try{await this.validateTargetDeleted(n,r,"copy",l.overwrite),await m.Promises.copy(d,R,{preserveSymlinks:!0})}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,L.localize)(3,null,(0,u.basename)(d),(0,u.basename)((0,u.dirname)(R)),M.toString()))),this.toFileSystemProviderError(M)}}async validateTargetDeleted(n,r,l,d){const R=this.toFilePath(n),M=this.toFilePath(r);let I=!1;if(!!(this.capabilities&1024)||(I=(0,O.isEqual)(R,M,!0)),I&&l==="copy")throw(0,a.createFileSystemProviderError)((0,L.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!I&&await m.Promises.exists(M)){if(!d)throw(0,a.createFileSystemProviderError)((0,L.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(n,r){return r.recursive?this.watchRecursive(n,r.excludes):this.watchNonRecursive(n)}watchRecursive(n,r){const l={path:this.toFilePath(n),excludes:r},d=(0,T.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,r;this.options?.watcher?.usePolling?(n=w.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?h.isWindows?n=s.FileWatcher:n=w.FileWatcher:n=v.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,f.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===o.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)}))}}watchNonRecursive(n){const r=new b.FileWatcher(this.toFilePath(n),d=>this._onDidChangeFile.fire((0,f.toFileChanges)(d)),d=>{d.type==="error"&&this._onDidWatchErrorOccur.fire(d.message),this.logService[d.type](d.message)},this.logService.getLevel()===o.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)});return(0,C.combinedDisposable)(r,l)}toFilePath(n){return(0,u.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof a.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let l=this.toFileSystemProviderError(r);if(n&&l.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await m.SymlinkSupport.stat(this.toFilePath(n));d.mode&128||(l=(0,a.createFileSystemProviderError)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return l}dispose(){super.dispose(),(0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,C.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Z[42],te([0,1,12]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,T.createDecorator)("productService")}),define(Z[25],te([0,1,57,13]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class S{constructor(){this.data=new Map}add(O,C){T.ok(D.isString(O)),T.ok(D.isObject(C)),T.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,C)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}t.Registry=new S}),define(Z[109],te([0,1,14,25]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function S(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,h){this.schemasById[S(u)]=h,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new A;D.Registry.add(t.Extensions.JSONContribution,O)}),define(Z[30],te([0,1,14,13,73,109,25]),function(_,t,T,D,S,A,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var C;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(C=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var u;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(u=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=O.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,f=!0){this.registerConfigurations([w],f)}registerConfigurations(w,f=!0){const s=[];w.forEach(o=>{s.push(...this.validateAndRegisterProperties(o,f,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(w){const f=[],s=o=>{if(o.properties)for(const e in o.properties)f.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,o.properties[e]);o.allOf&&o.allOf.forEach(e=>s(e))};for(const o of w){s(o);const e=this.configurationContributors.indexOf(o);e!==-1&&this.configurationContributors.splice(e,1)}h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(w){const f=[],s=[];for(const o of w)for(const e in o)if(f.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...o[e]};const i={type:"object",default:this.defaultValues[e],description:S.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};s.push(m(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=o[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(w){const f=[];for(const s of w)for(const o in s)if(f.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const e=this.configurationProperties[o];e&&(this.updatePropertyDefaultValue(o,e),this.updateSchema(o,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const f of w)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,f=!0,s,o=3){o=D.isUndefinedOrNull(w.scope)?o:w.scope;let e=[],i=w.properties;if(i)for(let r in i){if(f&&c(r)){delete i[r];continue}const l=i[r];if(this.updatePropertyDefaultValue(r,l),t.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?o:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!s?.restrictedConfigurations?.includes(r):l.restricted),i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),e.push(r)}let n=w.allOf;if(n)for(let r of n)e.push(...this.validateAndRegisterProperties(r,f,s,o));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const f=s=>{let o=s.properties;if(o)for(const i in o)this.updateSchema(i,o[i]);let e=s.allOf;e&&e.forEach(f)};f(w)}updateSchema(w,f){switch(t.allSettings.properties[w]=f,f.scope){case 1:t.applicationSettings.properties[w]=f;break;case 2:t.machineSettings.properties[w]=f;break;case 6:t.machineOverridableSettings.properties[w]=f;break;case 3:t.windowSettings.properties[w]=f;break;case 4:t.resourceSettings.properties[w]=f;break;case 5:t.resourceSettings.properties[w]=f,this.resourceLanguageSettingsSchema.properties[w]=f;break}}removeFromSchema(w,f){switch(delete t.allSettings.properties[w],f.scope){case 1:delete t.applicationSettings.properties[w];break;case 2:delete t.machineSettings.properties[w];break;case 6:delete t.machineOverridableSettings.properties[w];break;case 3:delete t.windowSettings.properties[w];break;case 4:case 5:delete t.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const f=`[${w}]`,s={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,s),t.allSettings.properties[f]=s,t.applicationSettings.properties[f]=s,t.machineSettings.properties[f]=s,t.machineOverridableSettings.properties[f]=s,t.windowSettings.properties[f]=s,t.resourceSettings.properties[f]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,f){let s=this.defaultValues[w];D.isUndefined(s)&&(s=f.default),D.isUndefined(s)&&(s=L(f.type)),f.default=s}}const p="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(p);function m(v){return v.substring(1,v.length-1)}t.overrideIdentifierFromKey=m;function L(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=L;const a=new g;O.Registry.add(t.Extensions.Configuration,a);function c(v){return v.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(v)?S.localize(5,null,v):a.getConfigurationProperties()[v]!==void 0?S.localize(6,null,v):null:S.localize(4,null)}t.validateProperty=c;function b(){const v=[],w=a.getConfigurationProperties();for(const f of Object.keys(w))v.push([f,w[f].scope]);return v.push(["launch",4]),v.push(["task",4]),v}t.getScopes=b}),define(Z[27],te([0,1,18,13,7,30,12,25]),function(_,t,T,D,S,A,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,O.createDecorator)("configurationService");function u(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof S.URI)}t.isConfigurationOverrides=u;var h;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(h=t.ConfigurationTarget||(t.ConfigurationTarget={}));function g(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=g;function p(i,n){const r=n?i?n.keys.filter(z=>i.keys.indexOf(z)===-1):[...n.keys]:[],l=i?n?i.keys.filter(z=>n.keys.indexOf(z)===-1):[...i.keys]:[],d=[];if(n&&i){for(const z of i.keys)if(n.keys.indexOf(z)!==-1){const q=v(i.contents,z),J=v(n.contents,z);T.equals(q,J)||d.push(z)}}const R=[],M=z=>{const q={};for(const J of z)for(const ie of J.identifiers)q[o(ie)]=J;return q},I=n?M(n.overrides):{},k=i?M(i.overrides):{};if(Object.keys(I).length)for(const z of r){const q=I[z];q&&R.push([(0,A.overrideIdentifierFromKey)(z),q.keys])}if(Object.keys(k).length)for(const z of l){const q=k[z];q&&R.push([(0,A.overrideIdentifierFromKey)(z),q.keys])}if(Object.keys(I).length&&Object.keys(k).length)for(const z of d){const q=k[z],J=I[z];if(q&&J){const ie=p({contents:q.contents,keys:q.keys,overrides:[]},{contents:J.contents,keys:J.keys,overrides:[]});R.push([(0,A.overrideIdentifierFromKey)(z),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:l,updated:d,overrides:R}}t.compare=p;function m(i,n){const r=[];for(const l of Object.keys(i))if(A.OVERRIDE_PROPERTY_PATTERN.test(l)){const d={};for(const R in i[l])d[R]=i[l][R];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(d),contents:L(d,n)})}return r}t.toOverrides=m;function L(i,n){const r=Object.create(null);for(let l in i)a(r,l,i[l],n);return r}t.toValuesTree=L;function a(i,n,r,l){const d=n.split("."),R=d.pop();let M=i;for(let I=0;I<d.length;I++){let k=d[I],z=M[k];switch(typeof z){case"undefined":z=M[k]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${d.slice(0,I+1).join(".")} is ${JSON.stringify(z)}`);return}M=z}if(typeof M=="object"&&M!==null)try{M[R]=r}catch(I){l(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(M)}`)}else l(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(M)}`)}t.addToValueTree=a;function c(i,n){const r=n.split(".");b(i,r)}t.removeFromValueTree=c;function b(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const l=i[r];typeof l=="object"&&!Array.isArray(l)&&(b(l,n),Object.keys(l).length===0&&delete i[r])}}function v(i,n,r){function l(M,I){let k=M;for(const z of I){if(typeof k!="object"||k===null)return;k=k[z]}return k}const d=n.split("."),R=l(i,d);return typeof R=="undefined"?r:R}t.getConfigurationValue=v;function w(i,n,r){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in i?D.isObject(i[l])&&D.isObject(n[l])?w(i[l],n[l],r):r&&(i[l]=n[l]):i[l]=n[l])})}t.merge=w;function f(){const i=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=f;function s(){const i=Object.create(null),n=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in n){let l=n[r].default;a(i,r,l,d=>console.error(`Conflict in default settings: ${d}`))}return i}t.getDefaultValues=s;function o(i){return`[${i}]`}t.keyFromOverrideIdentifier=o;function e(i,n,r){const l=i.inspect(n),d=i.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:l.defaultValue}t.getMigratedSettingValue=e}),define(Z[110],te([0,1,24,14,58,2,45,18,13,7,27,30,25]),function(_,t,T,D,S,A,O,C,u,h,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class L{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,g.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,g.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r],d=i[r];d&&(typeof l=="object"&&typeof d=="object"?(l=C.deepClone(l),this.mergeContents(l,d)):l=d),n[r]=l}return new L(n,this.keys,this.overrides)}merge(...e){const i=C.deepClone(this.contents),n=C.deepClone(this.overrides),r=[...this.keys];for(const l of e){this.mergeContents(i,l.contents);for(const d of l.overrides){const[R]=n.filter(M=>T.equals(M.identifiers,d.identifiers));R?this.mergeContents(R.contents,d.contents):n.push(C.deepClone(d))}for(const d of l.keys)r.indexOf(d)===-1&&r.push(d)}return new L(i,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&u.isObject(e[n])&&u.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=C.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?C.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,g.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,g.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=L;class a extends L{constructor(){const e=(0,g.getDefaultValues)(),i=(0,g.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))p.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,p.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,g.toValuesTree)(e[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,i,n)}}t.DefaultConfigurationModel=a;class c{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new L}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!u.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:l,restricted:d}=this.doParseRaw(e,i);this._configurationModel=new L(n,r,l),this._restrictedConfigurations=d||[]}doParseContent(e){let i={},n=null,r=[],l=[],d=[];function R(I){Array.isArray(r)?r.push(I):n!==null&&(r[n]=I)}let M={onObjectBegin:()=>{let I={};R(I),l.push(r),r=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let I=[];R(I),l.push(r),r=I,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:R,onError:(I,k,z)=>{d.push({error:I,offset:k,length:z})}};if(e)try{S.visit(e,M),i=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this._name}: ${I}`),this._parseErrors=[I]}return i}doParseRaw(e,i){const n=m.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const l=(0,g.toValuesTree)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),d=Object.keys(e),R=(0,g.toOverrides)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:l,keys:d,overrides:R,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const l={},d=[];for(let R in e)if(p.OVERRIDE_PROPERTY_PATTERN.test(R)&&n){const M=this.filter(e[R],i,!1,r);l[R]=M.raw,d.push(...M.restricted)}else{const M=i[R],I=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&d.push(R),(I===void 0||r.scopes===void 0||r.scopes.includes(I))&&(r.skipRestricted&&M?.restricted||(l[R]=e[R]))}return{raw:l,restricted:d}}}t.ConfigurationModelParser=c;class b extends A.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new L}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=b;class v{constructor(e,i,n=new L,r=new L,l=new O.ResourceMap,d=new L,R=new O.ResourceMap,M=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=d,this._memoryConfigurationByResource=R,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new L,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),l=this.getFolderConfigurationModelForResource(i.resource,n),d=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,R=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),M=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),I=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),z=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,q=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,J=i.overrideIdentifier?d.override(i.overrideIdentifier).getValue(e):d.getValue(e),ie=r.getValue(e),se=T.distinct(T.flatten(r.overrides.map(Y=>Y.identifiers))).filter(Y=>r.getOverrideValue(e,Y)!==void 0);return{defaultValue:R,userValue:M,userLocalValue:I,userRemoteValue:k,workspaceValue:z,workspaceFolderValue:q,memoryValue:J,value:ie,default:R!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:I!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:z!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:l?.freeze().getValue(e),override:i.overrideIdentifier?l?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:J!==void 0?{value:d.getValue(e),override:i.overrideIdentifier?d.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>p.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,p.overrideIdentifierFromKey)(r),d=this._defaultConfiguration.getKeysForOverrideIdentifier(l),R=e.getKeysForOverrideIdentifier(l),M=[...R.filter(I=>d.indexOf(I)===-1),...d.filter(I=>R.indexOf(I)===-1),...d.filter(I=>!C.equals(this._defaultConfiguration.override(l).getValue(I),e.override(l).getValue(I)))];return[l,M]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:l}=(0,g.compare)(this.localUserConfiguration,e),d=[...i,...n,...r];return d.length&&this.updateLocalUserConfiguration(e),{keys:d,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:l}=(0,g.compare)(this.remoteUserConfiguration,e);let d=[...i,...n,...r];return d.length&&this.updateRemoteUserConfiguration(e),{keys:d,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:l}=(0,g.compare)(this.workspaceConfiguration,e);let d=[...i,...n,...r];return d.length&&this.updateWorkspaceConfiguration(e),{keys:d,overrides:l}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:l,removed:d,overrides:R}=(0,g.compare)(n,i);let M=[...r,...l,...d];return(M.length||!n)&&this.updateFolderConfiguration(e,i),{keys:M,overrides:R}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:l,overrides:d}=(0,g.compare)(i,void 0);return{keys:[...n,...r,...l],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const l=this._memoryConfigurationByResource.get(e);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:l}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((d,R)=>(d.set(h.URI.revive(R[0]),this.parseConfigurationModel(R[1])),d),new O.ResourceMap);return new v(i,n,new L,r,l,new L,new O.ResourceMap,!1)}static parseConfigurationModel(e){return new L(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>e.add(l)),r.overrides.forEach(([l,d])=>{const R=(0,O.getOrSet)(i,l,new Set);d.forEach(M=>R.add(M))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=w;class f{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(R=>l.add(R)),e.overrides.forEach(([,R])=>R.forEach(M=>l.add(M))),this.affectedKeys=[...l.values()];const d=new L;this.affectedKeys.forEach(R=>d.setValue(R,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!C.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,g.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=f;class s extends f{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=s}),define(Z[111],te([0,1,3,14,2,19,27,110,30,25]),function(_,t,T,D,S,A,O,C,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class g extends S.Disposable{constructor(m,L){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,L)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(h.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,L){const a=typeof m=="string"?m:void 0,c=(0,O.isConfigurationOverrides)(m)?m:(0,O.isConfigurationOverrides)(L)?L:{};return this.configuration.getValue(a,c,void 0)}updateValue(m,L,a,c){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const L=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(a,L,1)}onDidDefaultConfigurationChange(m){const L=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,m);this.trigger(a,L,6)}trigger(m,L,a){const c=new C.ConfigurationChangeEvent(m,{data:L},this.configuration);c.source=a,c.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=g}),define(Z[55],te([0,1,16,84,30,12,25]),function(_,t,T,D,S,A,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,A.createDecorator)("requestService");function C(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}t.isSuccess=C;function u(a){return a.res.statusCode===204}async function h(a){if(!C(a))throw new Error("Server returned "+a.res.statusCode);return u(a)?null:(await(0,T.streamToBuffer)(a.stream)).toString()}t.asText=h;async function g(a){if(!C(a))throw new Error("Server returned "+a.res.statusCode);if(u(a))return null;const b=(await(0,T.streamToBuffer)(a.stream)).toString();try{return JSON.parse(b)}catch(v){throw v.message+=`:
`+b,v}}t.asJson=g;function p(a){L(a)}t.updateProxyConfigurationsScope=p;let m;function L(a){const c=O.Registry.as(S.Extensions.Configuration);m&&c.deregisterConfigurations([m]),m={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},c.registerConfiguration(m)}L(2)}),define(Z[112],te([0,1,113,13]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function S(O,C){return O.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:O.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function A(O,C,u={}){const h=(0,T.parse)(O),g=u.proxyUrl||S(h,C);if(!g)return null;const p=(0,T.parse)(g);if(!/^https?:$/.test(p.protocol||""))return null;const m={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((L,a)=>{_(["http-proxy-agent"],L,a)}))(m):new(await new Promise((L,a)=>{_(["https-proxy-agent"],L,a)}))(m)}t.getProxyAgent=A}),define(Z[114],te([0,1,16,29]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function S(A,O,C){let u=C&&C.get("storage.serviceMachineId",0)||null;if(u)return u;try{const g=(await O.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.isUUID)(g)?g:null}catch(h){u=null}if(!u){u=(0,D.generateUuid)();try{await O.writeFile(A.serviceMachineIdResource,T.VSBuffer.fromString(u))}catch(h){}}return C&&C.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=S}),define(Z[115],te([0,1,3,14,2,13,66,12]),function(_,t,T,D,S,A,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=(0,C.createDecorator)("storageService");var h;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(h=t.WillSaveStateReason||(t.WillSaveStateReason={}));var g;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(g=t.StorageScope||(t.StorageScope={}));var p;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(p=t.StorageTarget||(t.StorageTarget={}));class m extends S.Disposable{constructor(b={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new S.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,S.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,v){v===u?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:v,target:this.getKeyTargets(b)[v]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,v,w){return this.getStorage(v)?.get(b,w)}getBoolean(b,v,w){return this.getStorage(v)?.getBoolean(b,w)}getNumber(b,v,w){return this.getStorage(v)?.getNumber(b,w)}store(b,v,w,f){if((0,A.isUndefinedOrNull)(v)){this.remove(b,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,w,f),this.getStorage(w)?.set(b,v)})}remove(b,v){this.withPausedEmitters(()=>{this.updateKeyTarget(b,v,void 0),this.getStorage(v)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,v){const w=[],f=this.getKeyTargets(b);for(const s of Object.keys(f))f[s]===v&&w.push(s);return w}updateKeyTarget(b,v,w){const f=this.getKeyTargets(v);typeof w=="number"?f[b]!==w&&(f[b]=w,this.getStorage(v)?.set(u,JSON.stringify(f))):typeof f[b]=="number"&&(delete f[b],this.getStorage(v)?.set(u,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const v=this.get(u,b);if(v)try{return JSON.parse(v)}catch(w){}return Object.create(null)}isNew(b){return this.getBoolean(t.IS_NEW_KEY,b)===!0}async flush(b=h.NONE){this._onWillSaveState.fire({reason:b}),await T.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return a(b,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class L extends m{constructor(){super();this.globalStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}t.InMemoryStorageService=L;async function a(c,b,v,w){const f=l=>{try{return JSON.parse(l)}catch(d){return l}},s=new Map,o=new Map;c.forEach((l,d)=>{s.set(d,l),o.set(d,f(l))});const e=new Map,i=new Map;b.forEach((l,d)=>{e.set(d,l),i.set(d,f(l))}),console.group(`Storage: Global (path: ${v})`);let n=[];s.forEach((l,d)=>{n.push({key:d,value:l})}),console.table(n),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${w})`);let r=[];e.forEach((l,d)=>{r.push({key:d,value:l})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=a}),define(Z[116],te([0,1,10,34,7,29]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function O(h){if(T.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function C(h,g,p,m,L,a,c,b,v,w){const f=Object.create(null);f["common.machineId"]=c,f.sessionID=(0,A.generateUuid)()+Date.now(),f.commitHash=L,f.version=a,f["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=D.platform,f["common.nodeArch"]=m,f["common.product"]=w||"desktop";const s=u(b||[]);s&&(f["common.msftInternal"]=s);let o=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const i=O(p);i&&(f["common.platformDetail"]=i);try{const n=await h.readFile(S.URI.file(v));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}t.resolveCommonProperties=C;function u(h){const g=D.env.USERDNSDOMAIN;if(!g)return!1;const p=g.toLowerCase();return h.some(m=>p===m)}t.verifyMicrosoftInternalDomain=u}),define(Z[36],te([0,1,12]),function(_,t,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,T.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Z[117],te([0,1,3,26,8,14,2,10,7,74,22,23,15,35,36]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let c=class extends O.Disposable{constructor(s,o,e){super();this.galleryService=s,this.telemetryService=o,this.logService=e,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,O.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(s,o={}){if(!this.galleryService.isEnabled())throw new Error(h.localize(0,null));try{s=await this.checkAndGetCompatibleVersion(s)}catch(i){throw this.logService.error((0,S.getErrorMessage)(i)),v(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(!await this.canInstall(s)){const i=new g.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",s.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(s),void 0,i),i}const e=await this.galleryService.getManifest(s,D.CancellationToken.None);if(e===null){const i=new g.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(s),void 0,i),i}return this.installExtension(e,s,o)}async uninstall(s,o={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,o)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(h.localize(1,null));const o=await this.findGalleryExtension(s);if(!o)throw new Error(h.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,o,e){if(!u.URI.isUri(o)){let d=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(o.identifier,o.version).key());if(d)return this.logService.info("Extensions is already requested to install",o.identifier.id),d.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],n=[],r=this.createInstallExtensionTask(s,o,e);u.URI.isUri(o)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(r.identifier,s.version).key(),r),this._onInstallExtension.fire({identifier:r.identifier,source:o}),this.logService.info("Installing extension:",r.identifier.id),i.push({task:r,manifest:s});let l=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",r.identifier.id);else try{const R=await this.getAllDepsAndPackExtensionsToInstall(r.identifier,s,!!e.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:M,manifest:I}of R)if(l=l||!!I.extensionDependencies?.some(k=>(0,p.areSameExtensions)({id:k},r.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(M.identifier,M.version).key()))this.logService.info("Extension is already requested to install",M.identifier.id);else{const k=this.createInstallExtensionTask(I,M,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(k.identifier,I.version).key(),k),this._onInstallExtension.fire({identifier:k.identifier,source:M}),this.logService.info("Installing extension:",k.identifier.id),i.push({task:k,manifest:I})}}catch(R){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",r.identifier.id),this.logService.error(R),R}const d=i.reduce((R,{task:M,manifest:I})=>(R.set(M.identifier.id.toLowerCase(),{task:M,manifest:I}),R),new Map);for(;d.size;){let R;const M=[...d.values()].filter(({manifest:I})=>!I.extensionDependencies?.some(k=>d.has(k.toLowerCase())));M.length?R=d.size===1?M:M.filter(({task:I})=>!(I===r&&!l)):(this.logService.info("Found extensions with circular dependencies",M.map(({task:I})=>I.identifier.id)),R=[...d.values()]),await this.joinAllSettled(R.map(async({task:I})=>{const k=new Date().getTime();try{const z=await I.run();if(await this.joinAllSettled(this.participants.map(q=>q.postInstall(z,I.source,e,D.CancellationToken.None))),!u.URI.isUri(I.source)&&(v(this.telemetryService,I.operation===2?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(I.source),new Date().getTime()-k,void 0),C.isWeb&&I.operation===1))try{await this.galleryService.reportStatistic(z.manifest.publisher,z.manifest.name,z.manifest.version,"install")}catch(q){}n.push({local:z,identifier:I.identifier,operation:I.operation,source:I.source})}catch(z){throw u.URI.isUri(I.source)||v(this.telemetryService,I.operation===2?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(I.source),new Date().getTime()-k,z),this.logService.error("Error while installing the extension:",I.identifier.id),this.logService.error(z),z}finally{d.delete(I.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:R})=>this.logService.info("Extension installed successfully:",R.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:R})=>(0,p.areSameExtensions)(R,r.identifier))[0].local}catch(d){if(i.forEach(({task:R})=>R.cancel()),n.length)try{const R=await Promise.allSettled(n.map(({local:M})=>this.createUninstallExtensionTask(M,{versionOnly:!0}).run()));for(let M=0;M<R.length;M++){const I=R[M],{identifier:k}=n[M];I.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",k.id):this.logService.warn("Rollback: Error while uninstalling extension",k.id,(0,S.getErrorMessage)(I.reason))}}catch(R){this.logService.warn("Error while rolling back extensions",(0,S.getErrorMessage)(R),n.map(({identifier:M})=>M.id))}throw this.logService.error("Failed to install extension:",r.identifier.id,(0,S.getErrorMessage)(d)),this._onDidInstallExtensions.fire(i.map(({task:R})=>({identifier:R.identifier,operation:1,source:R.source}))),d instanceof Error&&(d.name=d&&d.code?d.code:t.ERROR_UNKNOWN),d}finally{for(const{task:d,manifest:R}of i)if(!u.URI.isUri(d.source)){const M=new p.ExtensionIdentifierWithVersion(d.identifier,R.version).key();this.installingExtensions.delete(M)||this.logService.warn("Installation task is not found in the cache",M)}}}async joinAllSettled(s){const o=[],e=[],i=await Promise.allSettled(s);for(const n of i)n.status==="fulfilled"?o.push(n.value):e.push(n.reason);if(e.length)throw b(e);return o}async getAllDepsAndPackExtensionsToInstall(s,o,e){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const n=[s,...i.map(d=>d.identifier)],r=[],l=async(d,R)=>{const M=R.extensionDependencies||[];if(R.extensionPack){const I=e?i.find(k=>(0,p.areSameExtensions)(k.identifier,d)):void 0;for(const k of R.extensionPack)I&&I.manifest.extensionPack&&I.manifest.extensionPack.some(z=>(0,p.areSameExtensions)({id:z},{id:k}))||M.every(z=>!(0,p.areSameExtensions)({id:z},{id:k}))&&M.push(k)}if(M.length){const I=[...n,...r.map(z=>z.gallery.identifier)],k=M.filter(z=>I.every(q=>!(0,p.areSameExtensions)(q,{id:z})));if(k.length){const z=await this.galleryService.query({names:k,pageSize:M.length},D.CancellationToken.None);for(const q of z.firstPage){if(I.find(se=>(0,p.areSameExtensions)(se,q.identifier)))continue;const J=await this.checkAndGetCompatibleVersion(q);if(!await this.canInstall(J)){this.logService.info("Skipping the extension as it cannot be installed",J.identifier.id);continue}const ie=await this.galleryService.getManifest(J,D.CancellationToken.None);if(ie===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${J.identifier.id}`,t.INSTALL_ERROR_VALIDATING);r.push({gallery:J,manifest:ie}),await l(J.identifier,ie)}}}};return await l(s,o),i=await this.getInstalled(),r.filter(d=>!i.some(R=>(0,p.areSameExtensions)(R.identifier,d.gallery.identifier)))}async checkAndGetCompatibleVersion(s){if(await this.isMalicious(s))throw new g.ExtensionManagementError(h.localize(3,null,s.identifier.id),g.INSTALL_ERROR_MALICIOUS);const o=await this.galleryService.getCompatibleExtension(s);if(!o)throw new g.ExtensionManagementError(h.localize(4,null,s.identifier.id,L.default.version),g.INSTALL_ERROR_INCOMPATIBLE);return o}async isMalicious(s){const o=await this.getExtensionsReport();return(0,p.getMaliciousExtensionsSet)(o).has(s.identifier.id)}async unininstallExtension(s,o){const e=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),e.waitUntilTaskIsFinished();const i=(d,R)=>{const M=this.createUninstallExtensionTask(d,R);return this.uninstallingExtensions.set(M.extension.identifier.id.toLowerCase(),M),this.logService.info("Uninstalling extension:",d.identifier.id),this._onUninstallExtension.fire(d.identifier),M},n=(d,R)=>{R?this.logService.error("Failed to uninstall extension:",d.identifier.id,R.message):this.logService.info("Successfully uninstalled extension:",d.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(d),void 0,R),this._onDidUninstallExtension.fire({identifier:d.identifier,error:R?.code})},r=[],l=[];try{r.push(i(s,{}));const d=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const R=this.getAllPackExtensionsToUninstall(s,d);for(const M of R)this.uninstallingExtensions.has(M.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",M.identifier.id):r.push(i(M,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(r.map(R=>R.extension),d,s),await this.joinAllSettled(r.map(async R=>{try{if(await R.run(),await this.joinAllSettled(this.participants.map(M=>M.postUninstall(R.extension,o,D.CancellationToken.None))),R.extension.identifier.uuid)try{await this.galleryService.reportStatistic(R.extension.manifest.publisher,R.extension.manifest.name,R.extension.manifest.version,"uninstall")}catch(M){}n(R.extension)}catch(M){const I=M instanceof g.ExtensionManagementError?M:new g.ExtensionManagementError((0,S.getErrorMessage)(M),t.ERROR_UNKNOWN);throw n(R.extension,I),I}finally{l.push(R)}}))}catch(d){const R=d instanceof g.ExtensionManagementError?d:new g.ExtensionManagementError((0,S.getErrorMessage)(d),t.ERROR_UNKNOWN);for(const M of r){try{M.cancel()}catch(I){}l.includes(M)||n(M.extension,R)}throw R}finally{for(const d of r)this.uninstallingExtensions.delete(d.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",d.extension.identifier.id)}}checkForDependents(s,o,e){for(const i of s){const n=this.getDependents(i,o);if(n.length){const r=n.filter(l=>s.indexOf(l)===-1);if(r.length)throw new Error(this.getDependentsErrorMessage(i,r,e))}}}getDependentsErrorMessage(s,o,e){return e===s?o.length===1?h.localize(5,null,e.manifest.displayName||e.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?h.localize(6,null,e.manifest.displayName||e.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):h.localize(7,null,e.manifest.displayName||e.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?h.localize(8,null,e.manifest.displayName||e.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?h.localize(9,null,e.manifest.displayName||e.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):h.localize(10,null,e.manifest.displayName||e.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(s,o,e=[]){if(e.indexOf(s)!==-1)return[];e.push(s);const i=s.manifest.extensionPack?s.manifest.extensionPack:[];if(i.length){const n=o.filter(l=>!l.isBuiltin&&i.some(d=>(0,p.areSameExtensions)({id:d},l.identifier))),r=[];for(const l of n)r.push(...this.getAllPackExtensionsToUninstall(l,o,e));return[...n,...r]}return[]}getDependents(s,o){return o.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(i=>(0,p.areSameExtensions)({id:i},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const o=await this.findGalleryExtensionById(s.identifier.uuid);return o||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};c=ue([fe(0,g.IExtensionGalleryService),fe(1,a.ITelemetryService),fe(2,m.ILogService)],c),t.AbstractExtensionManagementService=c;function b(f){const s=Array.isArray(f)?f:[f];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,e)=>new Error(`${o.message}${o.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}t.joinErrors=b;function v(f,s,o,e,i){const n=i?i instanceof g.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;f.publicLogError(s,{...o,success:!i,duration:e,errorcode:n})}t.reportTelemetry=v;class w{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(s=>new Promise((o,e)=>{const i=s.onCancellationRequested(()=>{i.dispose(),e((0,S.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=w}),define(Z[118],te([0,1,26,8,18,10,7,20,22,23,49,17,12,15,42,55,114,115,36]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L,a,c,b,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var f;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished"})(f||(f={}));function s(...B){return String(B.reduce((W,U)=>W|U,0))}var o;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},r={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:f.None,criteria:[],assetTypes:[]};class l{constructor(W=r){this.state=W}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(W,U=this.state.pageSize){return new l({...this.state,pageNumber:W,pageSize:U})}withFilter(W,...U){const E=[...this.state.criteria,...U.length?U.map(N=>({filterType:W,value:N})):[{filterType:W}]];return new l({...this.state,criteria:E})}withSortBy(W){return new l({...this.state,sortBy:W})}withSortOrder(W){return new l({...this.state,sortOrder:W})}withFlags(...W){return new l({...this.state,flags:W.reduce((U,E)=>U|E,0)})}withAssetTypes(...W){return new l({...this.state,assetTypes:W})}get raw(){const{criteria:W,pageNumber:U,pageSize:E,sortBy:N,sortOrder:y,flags:F,assetTypes:P}=this.state;return{filters:[{criteria:W,pageNumber:U,pageSize:E,sortBy:N,sortOrder:y}],assetTypes:P,flags:F}}get searchText(){const W=this.state.criteria.filter(U=>U.filterType===o.SearchText)[0];return W&&W.value?W.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(W=>String(W.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function d(B,W){const U=(B||[]).filter(E=>E.statisticName===W)[0];return U?U.value:0}function R(B){const W="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(E=>E.assetType.indexOf(W)===0).reduce((E,N)=>{const y=z(B,N.assetType);return y&&E.push([N.assetType.substring(W.length),y]),E},[])}function M(B){if(B.properties){const W=B.properties.filter(N=>N.key===e.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),E=W.filter(N=>U.test(N.value))[0];return E?{uri:E.value,fallbackUri:E.value}:null}return z(B,e.Repository)}function I(B){return{uri:`${B.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${B.fallbackAssetUri}/${e.VSIX}`}}function k(B){const W=z(B,e.Icon);if(W)return W;const U=u.DefaultIconPath;return{uri:U,fallbackUri:U}}function z(B,W){return B.files.filter(E=>E.assetType===W)[0]?{uri:`${B.assetUri}/${W}`,fallbackUri:`${B.fallbackAssetUri}/${W}`}:null}function q(B,W){const U=B.properties?B.properties.filter(N=>N.key===W):[],E=U.length>0&&U[0].value;return E?E.split(",").map(N=>(0,h.adoptToGalleryExtensionId)(N)):[]}function J(B){const W=B.properties?B.properties.filter(U=>U.key===i.Engine):[];return W.length>0&&W[0].value||""}function ie(B){const W=B.properties?B.properties.filter(E=>E.key===i.LocalizedLanguages):[],U=W.length>0&&W[0].value||"";return U?U.split(","):[]}function se(B){return B.indexOf("preview")!==-1}function Y(B,W,U,E,N){const y={manifest:z(W,e.Manifest),readme:z(W,e.Details),changelog:z(W,e.Changelog),license:z(W,e.License),repository:M(W),download:I(W),icon:k(W),coreTranslations:R(W)};return{identifier:{id:(0,h.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:W.version,date:W.lastUpdated,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,description:B.shortDescription||"",installCount:d(B.statistics,"install"),rating:d(B.statistics,"averagerating"),ratingCount:d(B.statistics,"ratingcount"),assetUri:O.URI.parse(W.assetUri),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),webExtension:!!B.tags?.includes(u.WEB_EXTENSION_TAG),assetTypes:W.files.map(({assetType:F})=>F),assets:y,properties:{dependencies:q(W,i.Dependency),extensionPack:q(W,i.ExtensionPack),engine:J(W),localizedLanguages:ie(W)},telemetryData:{index:(E.pageNumber-1)*E.pageSize+U,querySource:N},preview:se(B.flags)}}let X=class{constructor(W,U,E,N,y,F,P){this.requestService=W,this.logService=U,this.environmentService=E,this.telemetryService=N,this.fileService=y,this.productService=F;const x=F.extensionsGallery;this.extensionsGalleryUrl=x&&x.serviceUrl,this.extensionsControlUrl=x&&x.controlUrl,this.commonHeadersPromise=Q(F.version,this.environmentService,this.fileService,P)}api(W=""){return`${this.extensionsGalleryUrl}${W}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(W,U){const E=[];let{total:N,firstPage:y,getPage:F}=await this.query({names:W,pageSize:W.length},U);E.push(...y);for(let P=1;E.length<N&&(y=await F(P,U),y.length);P++)E.push(...y);return E}async getCompatibleExtension(W,U){return this.getCompatibleExtensionByEngine(W,U)}async getCompatibleExtensionByEngine(W,U){const E=(0,u.isIExtensionIdentifier)(W)?null:W;if(E&&E.properties.engine&&(0,g.isEngineValid)(E.properties.engine,this.productService.version,this.productService.date))return E;const{id:N,uuid:y}=E?E.identifier:W;let F=new l().withFlags(f.IncludeAssetUri,f.IncludeStatistics,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");y?F=F.withFilter(o.ExtensionId,y):F=F.withFilter(o.ExtensionName,N);const{galleryExtensions:P}=await this.queryGallery(F,T.CancellationToken.None),[x]=P;if(!x||!x.versions.length)return null;if(U){const $=x.versions.filter(H=>H.version===U)[0];if($){const H=Y(x,$,0,F);if(H.properties.engine&&(0,g.isEngineValid)(H.properties.engine,this.productService.version,this.productService.date))return H}return null}const j=await this.getLastValidExtensionVersion(x,x.versions);return j?Y(x,j,0,F):null}async query(W,U){const E=T.CancellationToken.isCancellationToken(W)?{}:W,N=T.CancellationToken.isCancellationToken(W)?W:U;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let y=E.text||"";const F=(0,S.getOrDefault)(E,ee=>ee.pageSize,50);let P=new l().withFlags(f.IncludeLatestVersionOnly,f.IncludeAssetUri,f.IncludeStatistics,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,F).withFilter(o.Target,"Microsoft.VisualStudio.Code");y?(y=y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,ne,re)=>(P=P.withFilter(o.Category,re||ne),"")),y=y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,ne,re)=>(P=P.withFilter(o.Tag,re||ne),"")),y=y.replace(/\bfeatured(\s+|\b|$)/g,()=>(P=P.withFilter(o.Featured),"")),y=y.trim(),y&&(y=y.length<200?y:y.substring(0,200),P=P.withFilter(o.SearchText,y)),P=P.withSortBy(0)):E.ids?P=P.withFilter(o.ExtensionId,...E.ids):E.names?P=P.withFilter(o.ExtensionName,...E.names):P=P.withSortBy(4),typeof E.sortBy=="number"&&(P=P.withSortBy(E.sortBy)),typeof E.sortOrder=="number"&&(P=P.withSortOrder(E.sortOrder));const{galleryExtensions:x,total:j}=await this.queryGallery(P,N),$=x.map((ee,ne)=>Y(ee,ee.versions[0],ne,P,E.source)),H=async(ee,ne)=>{if(ne.isCancellationRequested)throw(0,D.canceled)();const re=P.withPage(ee+1),{galleryExtensions:ce}=await this.queryGallery(re,ne);return ce.map((me,be)=>Y(me,me.versions[0],be,re,E.source))};return{firstPage:$,total:j,pageSize:P.pageSize,getPage:H}}async queryGallery(W,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");W=W.withFlags(W.flags,f.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,s(f.Unpublished));const E=await this.commonHeadersPromise,N=JSON.stringify(W.raw),y={...E,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)},F=new Date().getTime();let P,x,j=0;try{if(P=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:y},U),P.res.statusCode&&P.res.statusCode>=400&&P.res.statusCode<500)return{galleryExtensions:[],total:j};const $=await(0,c.asJson)(P);if($){const H=$.results[0],ee=H.extensions,ne=H.resultMetadata&&H.resultMetadata.filter(re=>re.metadataType==="ResultCount")[0];return j=ne&&ne.metadataItems.filter(re=>re.name==="TotalCount")[0].count||0,{galleryExtensions:ee,total:j}}return{galleryExtensions:[],total:j}}catch($){throw x=$,$}finally{this.telemetryService.publicLog2("galleryService:query",{...W.telemetryData,requestBodySize:String(N.length),duration:new Date().getTime()-F,success:!!P&&(0,c.isSuccess)(P),responseBodySize:P?.res.headers["Content-Length"],statusCode:P?String(P.res.statusCode):void 0,errorCode:x?(0,D.isPromiseCanceledError)(x)?"canceled":(0,D.getErrorMessage)(x).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(W,U,E,N){if(!this.isEnabled())return;const y=A.isWeb?this.api(`/itemName/${W}.${U}/version/${E}/statType/${N==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${W}/extensions/${U}/${E}/stats?statType=${N}`),F=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",x={...await this.commonHeadersPromise,Accept:F};try{await this.requestService.request({type:"POST",url:y,headers:x},T.CancellationToken.None)}catch(j){}}async download(W,U,E){this.logService.trace("ExtensionGalleryService#download",W.identifier.id);const N=(0,h.getGalleryExtensionTelemetryData)(W),y=new Date().getTime(),F=$=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...N,duration:$}),P=E===1?"install":E===2?"update":"",x=P?{uri:`${W.assets.download.uri}&${P}=true`,fallbackUri:`${W.assets.download.fallbackUri}?${P}=true`}:W.assets.download,j=await this.getAsset(x);await this.fileService.writeFile(U,j.stream),F(new Date().getTime()-y)}async getReadme(W,U){if(W.assets.readme){const E=await this.getAsset(W.assets.readme,{},U);return await(0,c.asText)(E)||""}return""}async getManifest(W,U){if(W.assets.manifest){const E=await this.getAsset(W.assets.manifest,{},U),N=await(0,c.asText)(E);return N?JSON.parse(N):null}return null}async getCoreTranslation(W,U){const E=W.assets.coreTranslations.filter(N=>N[0]===U.toUpperCase())[0];if(E){const N=await this.getAsset(E[1]),y=await(0,c.asText)(N);return y?JSON.parse(y):null}return null}async getChangelog(W,U){if(W.assets.changelog){const E=await this.getAsset(W.assets.changelog,{},U);return await(0,c.asText)(E)||""}return""}async getAllVersions(W,U){let E=new l().withFlags(f.IncludeVersions,f.IncludeCategoryAndTags,f.IncludeFiles,f.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");W.identifier.uuid?E=E.withFilter(o.ExtensionId,W.identifier.uuid):E=E.withFilter(o.ExtensionName,W.identifier.id);const N=[],{galleryExtensions:y}=await this.queryGallery(E,T.CancellationToken.None);return y.length&&(U?await Promise.all(y[0].versions.map(async F=>{let P;try{P=await this.getEngine(F)}catch(x){}P&&(0,g.isEngineValid)(P,this.productService.version,this.productService.date)&&N.push({version:F.version,date:F.lastUpdated})})):N.push(...y[0].versions.map(F=>({version:F.version,date:F.lastUpdated})))),N}async getAsset(W,U={},E=T.CancellationToken.None){const N=await this.commonHeadersPromise,y={type:"GET"},F={...N,...U.headers||{}};U={...U,...y,headers:F};const P=W.uri,x=W.fallbackUri,j={...U,url:P};try{const $=await this.requestService.request(j,E);if($.res.statusCode===200)return $;const H=await(0,c.asText)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${H}`)}catch($){if((0,D.isPromiseCanceledError)($))throw $;const H=(0,D.getErrorMessage)($);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:P,message:H});const ee={...U,url:x};return this.requestService.request(ee,E)}}async getLastValidExtensionVersion(W,U){const E=this.getLastValidExtensionVersionFromProperties(W,U);return E||this.getLastValidExtensionVersionRecursively(W,U)}getLastValidExtensionVersionFromProperties(W,U){for(const E of U){const N=J(E);if(!N)return null;if((0,g.isEngineValid)(N,this.productService.version,this.productService.date))return E}return null}async getEngine(W){const U=J(W);if(U)return U;const E=z(W,e.Manifest);if(!E)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},y=await this.getAsset(E,{headers:N}),F=await(0,c.asJson)(y);if(F)return F.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(W,U){if(!U.length)return null;const E=U[0],N=await this.getEngine(E);return(0,g.isEngineValid)(N,this.productService.version,this.productService.date)?{...E,properties:[...E.properties||[],{key:i.Engine,value:N}]}:this.getLastValidExtensionVersionRecursively(W,U.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const W=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(W.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,c.asJson)(W),E=new Map;if(U)for(const N of U.malicious){const y=E.get(N)||{id:{id:N},malicious:!0,slow:!1};y.malicious=!0,E.set(N,y)}return[...E.values()]}};X=ue([fe(0,c.IRequestService),fe(1,L.ILogService),fe(2,C.IEnvironmentService),fe(3,w.ITelemetryService),fe(4,p.IFileService),fe(5,a.IProductService),fe(6,(0,m.optional)(v.IStorageService))],X),t.ExtensionGalleryService=X;async function Q(B,W,U,E){const N={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B}`},y=await(0,b.getServiceMachineId)(W,U,E);return N["X-Market-User-Id"]=y,N}t.resolveMarketplaceHeaders=Q}),define(Z[119],te([0,1,2,18,21,85,27,30,12,35,25]),function(_,t,T,D,S,A,O,C,u,h,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let p=class{constructor(a,c){this._configurationService=c,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,S.escapeRegExpCharacters)(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const v=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})}))}setExperimentProperty(a,c){this._experimentProperties[a]=c}setEnabled(a){this._enabled=a}_updateUserOptIn(){const a=this._configurationService?.getValue(m);this._userOptIn=a?a.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let c=a.sessionID,b=a["common.instanceId"],v=a["common.machineId"],w=a["common.firstSessionDate"],f=a["common.msftInternal"];return{sessionId:c,instanceId:b,machineId:v,firstSessionDate:w,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(a,c,b){return this.isOptedIn?this._commonProperties.then(v=>{c=(0,D.mixin)(c,v),c=(0,D.mixin)(c,this._experimentProperties),c=(0,D.cloneAndChange)(c,w=>{if(typeof w=="string")return this._cleanupInfo(w,b)}),this._appender.log(a,c)},v=>{console.error(v)}):Promise.resolve(void 0)}publicLog2(a,c,b){return this.publicLog(a,c,b)}publicLogError(a,c){return this.sendErrorTelemetry?this.publicLog(a,c,!0):Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}_cleanupInfo(a,c){let b=a;if(c){const v=[];for(let o of this._cleanupPatterns)for(;;){const e=o.exec(a);if(!e)break;v.push([e.index,o.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(b="";;){const o=f.exec(a);if(!o)break;!w.test(o[0])&&v.every(([e,i])=>o.index<e||o.index>=i)&&(b+=a.substring(s,o.index)+"<REDACTED: user-file-path>",s=f.lastIndex)}s<a.length&&(b+=a.substr(s))}for(let v of this._cleanupPatterns)b=b.replace(v,"");return b}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([fe(1,(0,u.optional)(O.IConfigurationService))],p),t.TelemetryService=p;const m="telemetry";g.Registry.as(C.Extensions.Configuration).registerConfiguration({id:m,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,A.localize)(2,null,h.default.nameLong,h.default.privacyStatementUrl):(0,A.localize)(1,null,h.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[56],te([0,1,3,18,13,27]),function(_,t,T,D,S,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,c){return Promise.resolve(void 0)}publicLog2(a,c){return this.publicLog(a,c)}publicLogError(a,c){return Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class O{async publicLog(c,b,v){}async publicLogError(c,b,v){}}t.NullEndpointTelemetryService=O;function C(...a){return{log:(c,b)=>a.forEach(v=>v.log(c,b)),flush:()=>T.Promises.settled(a.map(c=>c.flush()))}}t.combinedAppender=C,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(a,c){return c.onDidChangeConfiguration(b=>{b.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(b.source),configurationKeys:m(b.sourceConfig)})})}t.configurationTelemetry=u;function h(a){const c=Object.create(null),b=Object.create(null),v=Object.create(null);p(a,v);for(let w in v){w=w.length>150?w.substr(w.length-149):w;const f=v[w];typeof f=="number"?b[w]=f:typeof f=="boolean"?b[w]=f?1:0:typeof f=="string"?c[w]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(c[w]=f)}return{properties:c,measurements:b}}t.validateTelemetryData=h;function g(a){if(!a)return"none";let c="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{a.indexOf(`${v}+`)===0&&(c=v)}),c}t.cleanRemoteAuthority=g;function p(a,c,b=0,v){if(!!a)for(let w of Object.getOwnPropertyNames(a)){const f=a[w],s=v?v+w:w;Array.isArray(f)?c[s]=(0,D.safeStringify)(f):f instanceof Date?c[s]=f.toISOString():(0,S.isObject)(f)?b<2?p(f,c,b+1,s+"."):c[s]=(0,D.safeStringify)(f):c[s]=f}}function m(a){if(!a)return[];const c=[];return L(c,"",a),c}function L(a,c,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(v=>L(a,c?`${c}.${v}`:v,b[v])):a.push(c)}}),define(Z[120],te([0,1,8,18,56]),function(_,t,T,D,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function A(C){const u=await new Promise((g,p)=>{_(["applicationinsights"],g,p)});let h;return u.defaultClient?(h=new u.TelemetryClient(C),h.channel.setUseDiskRetryCaching(!0)):(u.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),h=u.defaultClient),C.indexOf("AIF-")===0&&(h.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),h}class O{constructor(u,h,g){this._eventPrefix=u,this._defaultData=h,this._defaultData||(this._defaultData=Object.create(null)),typeof g=="function"?this._aiClient=g():this._aiClient=g,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient)),this._asyncAIClient.then(h=>{u(h)},h=>{(0,T.onUnexpectedError)(h),console.error(h)})}}log(u,h){!this._aiClient||(h=(0,D.mixin)(h,this._defaultData),h=(0,S.validateTelemetryData)(h),this._withAIClient(g=>g.trackEvent({name:this._eventPrefix+"/"+u,properties:h.properties,measurements:h.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(h=>{h.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=O}),define(Z[121],te([0,1,4,11]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function S(A,O){const C=Object.create(null),u=(g,p)=>{const m=JSON.parse(g);C[p]=m};if(O){const g=[],p=await D.Promises.readdir(O);for(const L of p)try{(await D.Promises.stat((0,T.join)(O,L))).isDirectory()&&g.push(L)}catch{}const m=[];for(const L of g)(await D.Promises.readdir((0,T.join)(O,L))).filter(c=>c==="telemetry.json").length===1&&m.push(L);for(const L of m){const a=(await D.Promises.readFile((0,T.join)(O,L,"telemetry.json"))).toString();u(a,L)}}let h=(await D.Promises.readFile((0,T.join)(A,"telemetry-core.json"))).toString();return u(h,"vscode-core"),h=(await D.Promises.readFile((0,T.join)(A,"telemetry-extensions.json"))).toString(),u(h,"vscode-extensions"),JSON.stringify(C,null,4)}t.buildTelemetryMessage=S}),define(Z[43],te([0,1,38,3,4,13,11,72,132,133]),function(_,t,T,D,S,A,O,C,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class g extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=g;function p(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function m(o){if(o instanceof g)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new g(e,o)}function L(o,e,i,n,r,l){const d=S.dirname(e),R=S.join(n,d);if(!R.startsWith(n))return Promise.reject(new Error(C.localize(0,null,e)));const M=S.join(n,e);let I;return l.onCancellationRequested(()=>{I&&I.destroy()}),Promise.resolve(O.Promises.mkdir(R,{recursive:!0})).then(()=>new Promise((k,z)=>{if(!l.isCancellationRequested)try{I=(0,T.createWriteStream)(M,{mode:i}),I.once("close",()=>k()),I.once("error",z),o.once("error",z),o.pipe(I)}catch(q){z(q)}}))}function a(o,e,i,n){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{r.cancel(),o.close()}),new Promise((d,R)=>{const M=new D.Sequencer,I=k=>{k.isCancellationRequested||(l++,o.readEntry())};o.once("error",R),o.once("close",()=>r.then(()=>{n.isCancellationRequested||o.entryCount===l?d():R(new g("Incomplete",new Error(C.localize(1,null,l,o.entryCount))))},R)),o.readEntry(),o.on("entry",k=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(k.fileName)){I(n);return}const z=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(z)){const ie=S.join(e,z);r=(0,D.createCancelablePromise)(se=>O.Promises.mkdir(ie,{recursive:!0}).then(()=>I(se)).then(void 0,R));return}const q=b(o,k),J=p(k);r=(0,D.createCancelablePromise)(ie=>M.queue(()=>q.then(se=>L(se,z,J,e,i,ie).then(()=>I(ie)))).then(null,R))})})}function c(o,e=!1){return new Promise((i,n)=>{(0,u.open)(o,e?{lazyEntries:!0}:void 0,(r,l)=>{r?n(m(r)):i((0,A.assertIsDefined)(l))})})}function b(o,e){return new Promise((i,n)=>{o.openReadStream(e,(r,l)=>{r?n(m(r)):i((0,A.assertIsDefined)(l))})})}function v(o,e){return new Promise((i,n)=>{const r=new h.ZipFile;e.forEach(d=>{d.contents?r.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&r.addFile(d.localPath,d.path)}),r.end();const l=(0,T.createWriteStream)(o);r.outputStream.pipe(l),r.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>i(o))})}t.zip=v;function w(o,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let l=c(o,!0);return i.overwrite&&(l=l.then(d=>O.Promises.rm(e).then(()=>d))),l.then(d=>a(d,e,{sourcePathRegex:r},n))}t.extract=w;function f(o,e){return c(o).then(i=>new Promise((n,r)=>{i.on("entry",l=>{l.fileName===e&&b(i,l).then(d=>n(d),d=>r(d))}),i.once("close",()=>r(new Error(C.localize(2,null,e))))}))}function s(o,e){return f(o,e).then(i=>new Promise((n,r)=>{const l=[];i.once("error",r),i.on("data",d=>l.push(d)),i.on("end",()=>n(Buffer.concat(l)))}))}t.buffer=s}),define(Z[122],te([0,1,43,78]),function(_,t,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function S(A){return(0,T.buffer)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch(C){throw new Error((0,D.localize)(0,null))}})}t.getManifest=S}),define(Z[123],te([0,1,24,3,8,2,9,4,10,19,41,7,29,11,43,79,20,22,23,90,17,15,42]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L,a,c,b,v,w,f,s,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",l="deleting",d="renaming";let R=class extends A.Disposable{constructor(I,k,z,q,J){super();this.beforeRemovingExtension=I,this.fileService=k,this.logService=z,this.environmentService=q,this.productService=J,this._devSystemExtensionsPath=null,this.systemExtensionsPath=q.builtinExtensionsPath,this.extensionsPath=q.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(I){const k=[];(I===null||I===0)&&k.push(this.scanSystemExtensions().then(null,z=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(z).message,i)))),(I===null||I===1)&&k.push(this.scanUserExtensions(!0).then(null,z=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(z).message,n))));try{const z=await Promise.all(k);return(0,T.flatten)(z)}catch(z){throw this.joinErrors(z)}}async scanUserExtensions(I){this.logService.trace("Started scanning user extensions");let[k,z]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return z=z.filter(q=>!k[new w.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).key()]),I&&(z=(0,w.groupByExtension)(z,J=>J.identifier).map(J=>J.sort((ie,se)=>g.rcompare(ie.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",z.length),z}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(I,k,z){const q=I.key(),J=C.join(this.extensionsPath,`.${(0,m.generateUuid)()}`),ie=C.join(this.extensionsPath,q);try{await L.Promises.rm(ie)}catch(Y){try{await L.Promises.rm(ie)}catch(X){}throw new v.ExtensionManagementError((0,c.localize)(0,null,ie,I.id),l)}await this.extractAtLocation(I,k,J,z);let se=await this.scanExtension(p.URI.file(J),1);if(!se)throw new Error((0,c.localize)(1,null,J));await this.storeMetadata(se,{installedTimestamp:Date.now()});try{await this.rename(I,J,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(Y){try{await L.Promises.rm(J)}catch(X){}if(Y.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",I.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(Y)}. Deleted from extracted location`,J),Y}try{se=await this.scanExtension(p.URI.file(ie),1)}catch(Y){}if(se)return se;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(I,k){return this.setMetadata(I,k),await this.storeMetadata(I,{...k,installedTimestamp:I.installedTimestamp}),I}async storeMetadata(I,k){k.isMachineScoped=k.isMachineScoped||void 0,k.isBuiltin=k.isBuiltin||void 0,k.installedTimestamp=k.installedTimestamp||void 0;const z=C.join(I.location.fsPath,"package.json"),q=await L.Promises.readFile(z,"utf8"),{manifest:J}=await this.parseManifest(q);return J.__metadata=k,await L.Promises.writeFile(z,JSON.stringify(J,null,"	")),I}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...I){const k=I.map(z=>new w.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version));await this.withUninstalledExtensions(z=>{k.forEach(q=>z[q.key()]=!0)})}async setInstalled(I){await this.withUninstalledExtensions(q=>delete q[I.key()]);const z=(await this.scanExtensions(1)).find(q=>new w.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version).equals(I))||null;return z?(await this.storeMetadata(z,{installedTimestamp:Date.now()}),this.scanExtension(z.location,1)):null}async withUninstalledExtensions(I){return this.uninstalledFileLimiter.queue(async()=>{let k;try{k=await L.Promises.readFile(this.uninstalledPath,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let z={};if(k)try{z=JSON.parse(k)}catch(q){}return I&&(I(z),Object.keys(z).length?await L.Promises.writeFile(this.uninstalledPath,JSON.stringify(z)):await L.Promises.rm(this.uninstalledPath)),z})}async removeExtension(I,k){this.logService.trace(`Deleting ${k} extension from disk`,I.identifier.id,I.location.fsPath),await L.Promises.rm(I.location.fsPath),this.logService.info("Deleted from disk",I.identifier.id,I.location.fsPath)}async removeUninstalledExtension(I){await this.removeExtension(I,"uninstalled"),await this.withUninstalledExtensions(k=>delete k[new w.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()])}async extractAtLocation(I,k,z,q){this.logService.trace(`Started extracting the extension from ${k} to ${z}`);try{await L.Promises.rm(z)}catch(J){throw new v.ExtensionManagementError(this.joinErrors(J).message,l)}try{await(0,a.extract)(k,z,{sourcePath:"extension",overwrite:!0},q),this.logService.info(`Extracted extension to ${z}:`,I.id)}catch(J){try{await L.Promises.rm(z)}catch(ie){}throw new v.ExtensionManagementError(J.message,J instanceof a.ExtractError&&J.type?J.type:r)}}async rename(I,k,z,q){try{await L.Promises.rename(k,z)}catch(J){if(u.isWindows&&J&&J.code==="EPERM"&&Date.now()<q)return this.logService.info(`Failed renaming ${k} to ${z} with 'EPERM' error. Trying again...`,I.id),this.rename(I,k,z,q);throw new v.ExtensionManagementError(J.message||(0,c.localize)(3,null,k,z),J.code||d)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const I=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return I;const k=this.scanDevSystemExtensions(),[z,q]=await Promise.all([I,k]);return[...z,...q]}async scanExtensionsInDir(I,k){const z=new D.Limiter(10),q=await this.fileService.resolve(p.URI.file(I));return q.children?(await Promise.all(q.children.filter(ie=>ie.isDirectory).map(ie=>z.queue(async()=>k===1&&(0,h.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,k))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(I,k){try{const z=await this.fileService.resolve(I);if(z.children){const{manifest:q,metadata:J}=await this.readManifest(I.fsPath),ie=z.children.find(({name:Q})=>/^readme(\.txt|\.md|)$/i.test(Q))?.resource,se=z.children.find(({name:Q})=>/^changelog(\.txt|\.md|)$/i.test(Q))?.resource,Y={id:(0,w.getGalleryExtensionId)(q.publisher,q.name)},X={type:k,identifier:Y,manifest:q,location:I,readmeUrl:ie,changelogUrl:se,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:k===0};return J&&(this.setMetadata(X,J),X.installedTimestamp=J.installedTimestamp),X}}catch(z){k!==0&&this.logService.trace(z)}return null}async scanDefaultSystemExtensions(){const I=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",I.length),I}async scanDevSystemExtensions(){const I=this.getDevSystemExtensionsList();if(I.length){const k=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",k.length),k.filter(z=>I.some(q=>(0,w.areSameExtensions)(z.identifier,{id:q})))}else return[]}setMetadata(I,k){I.publisherDisplayName=k.publisherDisplayName||null,I.publisherId=k.publisherId||null,I.identifier.uuid=k.id,I.isMachineScoped=!!k.isMachineScoped,I.isBuiltin=I.type===0||!!k.isBuiltin}async removeUninstalledExtensions(){const I=await this.getUninstalledExtensions(),k=await this.scanAllUserExtensions(),z=new Set;for(const ie of k)I[new w.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||z.add(ie.identifier.id.toLowerCase());const q=(0,w.groupByExtension)(k,ie=>ie.identifier);await D.Promises.settled(q.map(async ie=>{const se=ie.sort((Y,X)=>g.rcompare(Y.manifest.version,X.manifest.version))[0];z.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const J=k.filter(ie=>I[new w.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await D.Promises.settled(J.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const I=await this.scanAllUserExtensions(),k=[],z=(0,w.groupByExtension)(I,q=>q.identifier);k.push(...(0,T.flatten)(z.map(q=>q.sort((J,ie)=>g.rcompare(J.manifest.version,ie.manifest.version)).slice(1)))),await D.Promises.settled(k.map(q=>this.removeExtension(q,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(I=>I.name)}joinErrors(I){const k=Array.isArray(I)?I:[I];return k.length===1?k[0]instanceof Error?k[0]:new Error(k[0]):k.reduce((z,q)=>new Error(`${z.message}${z.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(O.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(I){const k=[L.Promises.readFile(C.join(I,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),L.Promises.readFile(C.join(I,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:z,metadata:q},J]=await Promise.all(k);return{manifest:(0,f.localizeManifest)(z,J),metadata:q}}parseManifest(I){return new Promise((k,z)=>{try{const q=JSON.parse(I),J=q.__metadata||null;k({manifest:q,metadata:J})}catch(q){z(new Error((0,c.localize)(4,null)))}})}};R=ue([fe(1,s.IFileService),fe(2,o.ILogService),fe(3,b.INativeEnvironmentService),fe(4,e.IProductService)],R),t.ExtensionsScanner=R}),define(Z[124],te([0,1,28,9,4,10,19,41,7,29,11,43,77,96,20,117,22,23,102,103,122,98,123,104,49,17,12,15,35,36]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L,a,c,b,v,w,f,s,o,e,i,n,r,l,d,R,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const I="unsetUninstalled",k="downloading";let z=class extends c.AbstractExtensionManagementService{constructor(X,Q,B,W,U,E,N){super(X,Q,B);this.environmentService=W,this.downloadService=U;const y=this._register(E.createInstance(f.ExtensionsLifecycle));this.extensionsScanner=this._register(E.createInstance(e.ExtensionsScanner,P=>y.postUninstall(P))),this.manifestCache=this._register(new o.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(E.createInstance(w.ExtensionsDownloader));const F=this._register(new i.ExtensionsWatcher(this,N,W,B));this._register(F.onDidChangeExtensionsByAnotherSource(({added:P,removed:x})=>{P.length&&this._onDidInstallExtensions.fire(P.map(j=>({identifier:j.identifier,operation:0,local:j}))),x.forEach(j=>this._onDidUninstallExtension.fire({identifier:j}))}))}async zip(X){this.logService.trace("ExtensionManagementService#zip",X.identifier.id);const Q=await this.collectFiles(X),B=await(0,p.zip)((0,O.joinPath)(this.environmentService.tmpDir,(0,h.generateUuid)()).fsPath,Q);return u.URI.file(B)}async unzip(X){return this.logService.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const Q=await this.downloadVsix(X),B=S.resolve(Q.fsPath);return(0,s.getManifest)(B)}getInstalled(X=null){return this.extensionsScanner.scanExtensions(X)}async canInstall(X){return!0}async install(X,Q={}){this.logService.trace("ExtensionManagementService#install",X.toString());const B=await this.downloadVsix(X),W=await(0,s.getManifest)(S.resolve(B.fsPath));if(W.engines&&W.engines.vscode&&!(0,n.isEngineValid)(W.engines.vscode,R.default.version,R.default.date))throw new Error(m.localize(0,null,(0,v.getGalleryExtensionId)(W.publisher,W.name),R.default.version));return this.installExtension(W,B,Q)}async updateMetadata(X,Q){return this.logService.trace("ExtensionManagementService#updateMetadata",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},...Q}),this.manifestCache.invalidate(),X}async updateExtensionScope(X,Q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},isMachineScoped:Q}),this.manifestCache.invalidate(),X}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(X){if(X.scheme===D.Schemas.file)return X;if(!this.downloadService)throw new Error("Download service is not available");const Q=(0,O.joinPath)(this.environmentService.tmpDir,(0,h.generateUuid)());return await this.downloadService.download(X,Q),Q}createInstallExtensionTask(X,Q,B){return u.URI.isUri(Q)?new ie(X,Q,B,this.galleryService,this.extensionsScanner,this.logService):new J(Q,B,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(X,Q){return new se(X,Q,this.extensionsScanner)}async collectFiles(X){const Q=async W=>{let U=await g.Promises.readdir(W);U=U.map(y=>S.join(W,y));const E=await Promise.all(U.map(y=>g.Promises.stat(y)));let N=Promise.resolve([]);return E.forEach((y,F)=>{const P=U[F];y.isFile()&&(N=N.then(x=>[...x,P])),y.isDirectory()&&(N=N.then(x=>Q(P).then(j=>[...x,...j])))}),N};return(await Q(X.location.fsPath)).map(W=>({path:`extension/${S.relative(X.location.fsPath,W)}`,localPath:W}))}};z=ue([fe(0,b.IExtensionGalleryService),fe(1,M.ITelemetryService),fe(2,d.ILogService),fe(3,a.INativeEnvironmentService),fe(4,(0,l.optional)(L.IDownloadService)),fe(5,l.IInstantiationService),fe(6,r.IFileService)],z),t.ExtensionManagementService=z;class q extends c.AbstractExtensionTask{constructor(X,Q,B,W){super();this.identifier=X,this.source=Q,this.extensionsScanner=B,this.logService=W,this._operation=1}get operation(){return this._operation}async installExtension(X,Q){try{const B=await this.unsetUninstalledAndGetLocal(X.identifierWithVersion);if(B)return X.metadata?this.extensionsScanner.saveMetadataForLocalExtension(B,X.metadata):B}catch(B){throw A.isMacintosh?new b.ExtensionManagementError(m.localize(1,null),I):new b.ExtensionManagementError(m.localize(2,null),I)}return this.extract(X,Q)}async unsetUninstalledAndGetLocal(X){if(!await this.isUninstalled(X))return null;this.logService.trace("Removing the extension from uninstalled list:",X.id);const B=await this.extensionsScanner.setInstalled(X);return this.logService.info("Removed the extension from uninstalled list:",X.id),B}async isUninstalled(X){return!!(await this.extensionsScanner.getUninstalledExtensions())[X.key()]}async extract({zipPath:X,identifierWithVersion:Q,metadata:B},W){let U=await this.extensionsScanner.extractUserExtension(Q,X,W);return this.logService.info("Extracting completed.",Q.id),B&&(U=await this.extensionsScanner.saveMetadataForLocalExtension(U,B)),U}}class J extends q{constructor(X,Q,B,W,U){super(X.identifier,X,W,U);this.gallery=X,this.options=Q,this.extensionsDownloader=B}async doRun(X){const B=(await this.extensionsScanner.scanExtensions(null)).find(E=>(0,v.areSameExtensions)(E.identifier,this.gallery.identifier));B&&(this._operation=2);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||B?.isBuiltin;const U=await this.installExtension(W,X);B&&C.neq(B.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(B);try{await this.extensionsDownloader.delete(u.URI.file(W.zipPath))}catch(E){}return U}async downloadInstallableExtension(X,Q){const B={id:X.identifier.uuid,publisherId:X.publisherId,publisherDisplayName:X.publisherDisplayName};let W;try{this.logService.trace("Started downloading extension:",X.identifier.id),W=(await this.extensionsDownloader.downloadExtension(X,Q)).fsPath,this.logService.info("Downloaded extension:",X.identifier.id,W)}catch(U){throw new b.ExtensionManagementError((0,c.joinErrors)(U).message,k)}try{const U=await(0,s.getManifest)(W);return{zipPath:W,identifierWithVersion:new v.ExtensionIdentifierWithVersion(X.identifier,U.version),metadata:B}}catch(U){throw new b.ExtensionManagementError((0,c.joinErrors)(U).message,c.INSTALL_ERROR_VALIDATING)}}}class ie extends q{constructor(X,Q,B,W,U,E){super({id:(0,v.getGalleryExtensionId)(X.publisher,X.name)},Q,U,E);this.manifest=X,this.location=Q,this.options=B,this.galleryService=W}async doRun(X){const Q=new v.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(E=>(0,v.areSameExtensions)(this.identifier,E.identifier)),U=await this.getMetadata(this.identifier.id,X);if(W)if(U.isMachineScoped=this.options.isMachineScoped||W.isMachineScoped,U.isBuiltin=this.options.isBuiltin||W.isBuiltin,this._operation=2,Q.equals(new v.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch(E){throw new Error(m.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const E=await this.unsetUninstalledAndGetLocal(Q);if(E)try{await this.extensionsScanner.removeExtension(E,"existing")}catch(N){throw new Error(m.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:S.resolve(this.location.fsPath),identifierWithVersion:Q,metadata:U},X)}async getMetadata(X,Q){try{const B=(await this.galleryService.query({names:[X],pageSize:1},Q)).firstPage[0];if(B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId}}catch(B){}return{}}}class se extends c.AbstractExtensionTask{constructor(X,Q,B){super();this.extension=X,this.options=Q,this.extensionsScanner=B}async doRun(X){const Q=[],B=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=new v.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);Q.push(...B.filter(U=>W.equals(new v.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version))))}else Q.push(...B.filter(W=>(0,v.areSameExtensions)(W.identifier,this.extension.identifier)));if(!Q.length)throw new Error(m.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...Q),this.options.remove)for(const W of Q)try{X.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch(U){throw new Error(m.localize(6,null,(0,T.toErrorMessage)(U)))}}}}),define(Z[125],te([0,1,113,16,8,2,13,27,20,99,15,112,134]),function(_,t,T,D,S,A,O,C,u,h,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let L=class extends A.Disposable{constructor(c,b,v){super();this.environmentService=b,this.logService=v,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,b){this.logService.trace("RequestService#request",c.url);const{proxyUrl:v,strictSSL:w}=this,f={...process.env,...await(0,h.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},s=c.agent?c.agent:await(0,p.getProxyAgent)(c.url||"",f,{proxyUrl:v,strictSSL:w});return c.agent=s,c.strictSSL=w,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,b)}async getNodeRequest(c){return((0,T.parse)(c.url).protocol==="https:"?await new Promise((w,f)=>{_(["https"],w,f)}):await new Promise((w,f)=>{_(["http"],w,f)})).request}_request(c,b){return new Promise(async(v,w)=>{let f;const s=(0,T.parse)(c.url),o=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),e={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,O.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(e.auth=c.user+":"+c.password),f=o(e,i=>{const n=(0,O.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...c,url:i.headers.location,followRedirects:n-1},b).then(v,w);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,m.createGunzip)())),v({res:i,stream:(0,D.streamToBufferReadableStream)(r)})}}),f.on("error",w),c.timeout&&f.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&f.write(c.data),f.end(),b.onCancellationRequested(()=>{f.abort(),w((0,S.canceled)())})})}async resolveProxy(c){}};L=ue([fe(0,C.IConfigurationService),fe(1,u.INativeEnvironmentService),fe(2,g.ILogService)],L),t.RequestService=L}),define(Z[135],te([0,1,38,136,32,3,16,28,8,2,9,4,34,7,11,27,111,20,89,118,22,97,124,17,107,108,50,101,52,53,105,15,106,35,42,55,125,116,36,119,56,120,121]),function(_,t,T,D,S,A,O,C,u,h,g,p,m,L,a,c,b,v,w,f,s,o,e,i,n,r,l,d,R,M,I,k,z,q,J,ie,se,Y,X,Q,B,W,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class E extends h.Disposable{constructor(F){super();this.argv=F,(0,D.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[F,P]=await this.initServices();return F.invokeFunction(async x=>{const j=x.get(k.ILogService),$=x.get(i.IFileService),H=x.get(v.INativeEnvironmentService),ee=x.get(s.IExtensionManagementCLIService);return j.info("CLI main",this.argv),this.registerErrorHandler(j),await this.doRun(H,ee,$),(0,A.raceTimeout)((0,B.combinedAppender)(...P).flush(),1e3)})}async initServices(){const F=new R.ServiceCollection,P={_serviceBrand:void 0,...q.default};F.set(J.IProductService,P);const x=new w.NativeEnvironmentService(this.argv,P);F.set(v.INativeEnvironmentService,x),await Promise.all([x.appSettingsHome.fsPath,x.extensionsPath].map(me=>me?a.Promises.mkdir(me,{recursive:!0}):void 0));const j=(0,k.getLogLevel)(x),$=[];$.push(new z.SpdLogLogger("cli",(0,p.join)(x.logsPath,"cli.log"),!0,j)),j===k.LogLevel.Trace&&$.push(new k.ConsoleLogger(j));const H=this._register(new k.MultiplexLogService($));F.set(k.ILogService,H);const ee=this._register(new n.FileService(H));F.set(i.IFileService,ee);const ne=this._register(new r.DiskFileSystemProvider(H));ee.registerProvider(g.Schemas.file,ne);const re=this._register(new b.ConfigurationService(x.settingsResource,ee));F.set(c.IConfigurationService,re),await re.initialize(),F.set(ie.IRequestService,new l.SyncDescriptor(se.RequestService)),F.set(s.IExtensionManagementService,new l.SyncDescriptor(e.ExtensionManagementService)),F.set(s.IExtensionGalleryService,new l.SyncDescriptor(f.ExtensionGalleryService)),F.set(s.IExtensionManagementCLIService,new l.SyncDescriptor(o.ExtensionManagementCLIService)),F.set(M.ILocalizationsService,new l.SyncDescriptor(I.LocalizationsService));const ce=[];if(x.isBuilt&&!x.isExtensionDevelopment&&!x.disableTelemetry&&P.enableTelemetry){P.aiConfig&&P.aiConfig.asimovKey&&ce.push(new W.AppInsightsAppender("monacoworkbench",null,P.aiConfig.asimovKey));const{appRoot:me,extensionsPath:be,installSourcePath:ke}=x,Te={appender:(0,B.combinedAppender)(...ce),sendErrorTelemetry:!1,commonProperties:(async()=>{let we;try{const Fe=await a.Promises.readFile((0,p.join)(x.userDataPath,"storage.json"));we=JSON.parse(Fe.toString())[X.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&H.error(Fe)}return(0,Y.resolveCommonProperties)(ee,(0,S.release)(),(0,S.hostname)(),process.arch,P.commit,P.version,we,P.msftInternalDomains,ke)})(),piiPaths:[me,be]};F.set(X.ITelemetryService,new l.SyncDescriptor(Q.TelemetryService,[Te]))}else F.set(X.ITelemetryService,B.NullTelemetryService);return[new d.InstantiationService(F),ce]}registerErrorHandler(F){(0,u.setUnexpectedErrorHandler)(P=>{const x=(0,C.toErrorMessage)(P,!0);!x||F.error(`[uncaught exception in CLI]: ${x}`)}),process.on("uncaughtException",P=>(0,u.onUnexpectedError)(P)),process.on("unhandledRejection",P=>(0,u.onUnexpectedError)(P))}async doRun(F,P,x){if(this.argv["install-source"])return this.setInstallSource(F,x,this.argv["install-source"]);if(this.argv["list-extensions"])return P.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return P.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return P.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return P.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(F.appRoot,F.extensionsPath))}asExtensionIdOrVSIX(F){return F.map(P=>/\.vsix$/i.test(P)?L.URI.file((0,p.isAbsolute)(P)?P:(0,p.join)((0,m.cwd)(),P)):P)}async setInstallSource(F,P,x){await P.writeFile(L.URI.file(F.installSourcePath),O.VSBuffer.fromString(x.slice(0,30)))}}async function N(y){const F=new E(y);try{await F.run()}finally{F.dispose()}}t.main=N})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58454f7bec838f79fe2422ab5914419147d82e40/core/vs/code/node/cliProcessMain.js.map
