/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/map","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],we=function(J){for(var e=[],g=0,L=J.length;g<L;g++)e[g]=ve[J[g]];return e};define(ve[54],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,C){if(!L)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=g}),define(ve[55],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let u in i)g.call(i,u)&&I.push(i[u]);return I}e.values=L;function C(i,I){for(let u in i)if(g.call(i,u)&&I({key:u,value:i[u]},function(){delete i[u]})===!1)return}e.forEach=C;function k(i,I){const u=Object.create(null);for(const m of i){const c=I(m);let v=u[c];v||(v=u[c]=[]),v.push(m)}return u}e.groupBy=k;function T(i){const I=Object.create(null);return i&&i.forEach((u,m)=>{I[m]=u}),I}e.fromMap=T;function y(i,I){const u=[],m=[];for(let c of i)I.has(c)||u.push(c);for(let c of I)i.has(c)||m.push(c);return{removed:u,added:m}}e.diffSets=y;function S(i,I){const u=[],m=[];for(let[c,v]of i)I.has(c)||u.push(v);for(let[c,v]of I)i.has(c)||m.push(v);return{removed:u,added:m}}e.diffMaps=S;class A{constructor(){this.map=new Map}add(I,u){let m=this.map.get(I);m||(m=new Set,this.map.set(I,m)),m.add(u)}delete(I,u){const m=this.map.get(I);!m||(m.delete(u),m.size===0&&this.map.delete(I))}forEach(I,u){const m=this.map.get(I);!m||m.forEach(u)}}e.SetMap=A}),define(ve[56],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(T){return(y,S,A)=>{let i=null,I=null;if(typeof A.value=="function"?(i="value",I=A.value):typeof A.get=="function"&&(i="get",I=A.get),!I)throw new Error("not supported");A[i]=T(I,S)}}e.createDecorator=g;function L(T,y,S){let A=null,i=null;if(typeof S.value=="function"?(A="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(A="get",i=S.get),!i)throw new Error("not supported");const I=`$memoize$${y}`;S[A]=function(...u){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,u)}),this[I]}}e.memoize=L;function C(T,y,S){return g((A,i)=>{const I=`$debounce$${i}`,u=`$debounce$result$${i}`;return function(...m){this[u]||(this[u]=S?S():void 0),clearTimeout(this[I]),y&&(this[u]=y(this[u],...m),m=[this[u]]),this[I]=setTimeout(()=>{A.apply(this,m),this[u]=S?S():void 0},T)}})}e.debounce=C;function k(T,y,S){return g((A,i)=>{const I=`$throttle$timer$${i}`,u=`$throttle$result$${i}`,m=`$throttle$lastRun$${i}`,c=`$throttle$pending$${i}`;return function(...v){if(this[u]||(this[u]=S?S():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),y&&(this[u]=y(this[u],...v)),this[c])return;const _=this[m]+T;_<=Date.now()?(this[m]=Date.now(),A.apply(this,[this[u]]),this[u]=S?S():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[m]=Date.now(),A.apply(this,[this[u]]),this[u]=S?S():void 0},_-Date.now()))}})}e.throttle=k}),define(ve[16],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function C(p){S(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=C;function k(p){S(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=k;function T(p){if(p instanceof Error){let{name:t,message:s}=p;const o=p.stacktrace||p.stack;return{$isError:!0,name:t,message:s,stack:o}}return p}e.transformErrorForSerialization=T;const y="Canceled";function S(p){return p instanceof Error&&p.name===y&&p.message===y}e.isPromiseCanceledError=S;class A extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=A;function i(){const p=new Error(y);return p.name=p.message,p}e.canceled=i;function I(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=I;function u(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=u;function m(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function c(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function v(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=v;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function l(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function f(p,t=Object.create(null)){const s=new Error(p);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=f}),define(ve[20],we([0,1,16]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(B,K=0){return B[B.length-(1+K)]}e.tail=L;function C(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=C;function k(B,K,ne=(me,Se)=>me===Se){if(B===K)return!0;if(!B||!K||B.length!==K.length)return!1;for(let me=0,Se=B.length;me<Se;me++)if(!ne(B[me],K[me]))return!1;return!0}e.equals=k;function T(B,K,ne){let me=0,Se=B.length-1;for(;me<=Se;){const Ce=(me+Se)/2|0,Te=ne(B[Ce],K);if(Te<0)me=Ce+1;else if(Te>0)Se=Ce-1;else return Ce}return-(me+1)}e.binarySearch=T;function y(B,K){let ne=0,me=B.length;if(me===0)return 0;for(;ne<me;){const Se=Math.floor((ne+me)/2);K(B[Se])?me=Se:ne=Se+1}return ne}e.findFirstInSorted=y;function S(B,K,ne){if(B=B|0,B>=K.length)throw new TypeError("invalid index");let me=K[Math.floor(K.length*Math.random())],Se=[],Ce=[],Te=[];for(let je of K){const Be=ne(je,me);Be<0?Se.push(je):Be>0?Ce.push(je):Te.push(je)}return B<Se.length?S(B,Se,ne):B<Se.length+Te.length?Te[0]:S(B-(Se.length+Te.length),Ce,ne)}e.quickSelect=S;function A(B,K){const ne=[];let me;for(const Se of B.slice(0).sort(K))!me||K(me[0],Se)!==0?(me=[Se],ne.push(me)):me.push(Se);return ne}e.groupBy=A;function i(B,K,ne){const me=[];function Se(je,Be,Ve){if(Be===0&&Ve.length===0)return;const W=me[me.length-1];W&&W.start+W.deleteCount===je?(W.deleteCount+=Be,W.toInsert.push(...Ve)):me.push({start:je,deleteCount:Be,toInsert:Ve})}let Ce=0,Te=0;for(;;){if(Ce===B.length){Se(Ce,0,K.slice(Te));break}if(Te===K.length){Se(Ce,B.length-Ce,[]);break}const je=B[Ce],Be=K[Te],Ve=ne(je,Be);Ve===0?(Ce+=1,Te+=1):Ve<0?(Se(Ce,1,[]),Ce+=1):Ve>0&&(Se(Ce,0,[Be]),Te+=1)}return me}e.sortedDiff=i;function I(B,K,ne){const me=i(B,K,ne),Se=[],Ce=[];for(const Te of me)Se.push(...B.slice(Te.start,Te.start+Te.deleteCount)),Ce.push(...Te.toInsert);return{removed:Se,added:Ce}}e.delta=I;function u(B,K,ne){if(ne===0)return[];const me=B.slice(0,ne).sort(K);return c(B,K,me,ne,B.length),me}e.top=u;function m(B,K,ne,me,Se){return ne===0?Promise.resolve([]):new Promise((Ce,Te)=>{(async()=>{const je=B.length,Be=B.slice(0,ne).sort(K);for(let Ve=ne,W=Math.min(ne+me,je);Ve<je;Ve=W,W=Math.min(W+me,je)){if(Ve>ne&&await new Promise(Z=>setTimeout(Z)),Se&&Se.isCancellationRequested)throw(0,g.canceled)();c(B,K,Be,Ve,W)}return Be})().then(Ce,Te)})}e.topAsync=m;function c(B,K,ne,me,Se){for(const Ce=ne.length;me<Se;me++){const Te=B[me];if(K(Te,ne[Ce-1])<0){ne.pop();const je=y(ne,Be=>K(Te,Be)<0);ne.splice(je,0,Te)}}}function v(B){return B.filter(K=>!!K)}e.coalesce=v;function _(B){let K=0;for(let ne=0;ne<B.length;ne++)B[ne]&&(B[K]=B[ne],K+=1);B.length=K}e.coalesceInPlace=_;function b(B,K,ne){B.splice(ne,0,B.splice(K,1)[0])}e.move=b;function P(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=P;function l(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=l;function f(B,K){if(!K)return B.filter((me,Se)=>B.indexOf(me)===Se);const ne=Object.create(null);return B.filter(me=>{const Se=K(me);return ne[Se]?!1:(ne[Se]=!0,!0)})}e.distinct=f;function p(B){const K=new Set;return B.filter(ne=>K.has(ne)?!1:(K.add(ne),!0))}e.distinctES6=p;function t(B){const K=Object.create(null);return ne=>{const me=B(ne);return K[me]?!1:(K[me]=!0,!0)}}e.uniqueFilter=t;function s(B,K){for(let ne=B.length-1;ne>=0;ne--){const me=B[ne];if(K(me))return ne}return-1}e.lastIndex=s;function o(B,K){return B.length>0?B[0]:K}e.firstOrDefault=o;function n(B,K,ne=(me,Se)=>me===Se){let me=0;for(let Se=0,Ce=Math.min(B.length,K.length);Se<Ce&&ne(B[Se],K[Se]);Se++)me++;return me}e.commonPrefixLength=n;function a(B){return[].concat(...B)}e.flatten=a;function h(B,K){let ne=typeof K=="number"?B:0;typeof K=="number"?ne=B:(ne=0,K=B);const me=[];if(ne<=K)for(let Se=ne;Se<K;Se++)me.push(Se);else for(let Se=ne;Se>K;Se--)me.push(Se);return me}e.range=h;function d(B,K,ne){return B.reduce((me,Se)=>(me[K(Se)]=ne?ne(Se):Se,me),Object.create(null))}e.index=d;function w(B,K){return B.push(K),()=>E(B,K)}e.insert=w;function E(B,K){const ne=B.indexOf(K);if(ne>-1)return B.splice(ne,1),K}e.remove=E;function r(B,K,ne){const me=B.slice(0,K),Se=B.slice(K);return me.concat(ne,Se)}e.arrayInsert=r;function D(B,K){let ne;if(typeof K=="number"){let me=K;ne=()=>{const Se=Math.sin(me++)*179426549;return Se-Math.floor(Se)}}else ne=Math.random;for(let me=B.length-1;me>0;me-=1){const Se=Math.floor(ne()*(me+1)),Ce=B[me];B[me]=B[Se],B[Se]=Ce}}e.shuffle=D;function R(B,K){const ne=B.indexOf(K);ne>-1&&(B.splice(ne,1),B.unshift(K))}e.pushToStart=R;function x(B,K){const ne=B.indexOf(K);ne>-1&&(B.splice(ne,1),B.push(K))}e.pushToEnd=x;function j(B,K){return Array.isArray(B)?B.map(K):K(B)}e.mapArrayOrNot=j;function te(B){return Array.isArray(B)?B:[B]}e.asArray=te;function Q(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=Q;function N(B,K){for(const ne of B){const me=K(ne);if(me!==void 0)return me}}e.mapFind=N;function U(B,K,ne){const me=V(B,K),Se=B.length,Ce=ne.length;B.length=Se+Ce;for(let Te=Se-1;Te>=me;Te--)B[Te+Ce]=B[Te];for(let Te=0;Te<Ce;Te++)B[Te+me]=ne[Te]}e.insertInto=U;function F(B,K,ne,me){const Se=V(B,K),Ce=B.splice(Se,ne);return U(B,Se,me),Ce}e.splice=F;function V(B,K){return K<0?Math.max(K+B.length,0):Math.min(K,B.length)}function M(B,K){let ne=Number.MAX_SAFE_INTEGER,me=0;return B.forEach((Se,Ce)=>{const Te=K(Se);Te<ne&&(ne=Te,me=Ce)}),me}e.minIndex=M;function O(B,K){let ne=Number.MIN_SAFE_INTEGER,me=0;return B.forEach((Se,Ce)=>{const Te=K(Se);Te>ne&&(ne=Te,me=Ce)}),me}e.maxIndex=O;class q{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let ne=this.firstIdx;for(;ne<this.items.length&&K(this.items[ne]);)ne++;const me=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,me}takeFromEndWhile(K){let ne=this.lastIdx;for(;ne>=0&&K(this.items[ne]);)ne--;const me=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,me}}e.ArrayQueue=q}),define(ve[73],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const C=this;let k=!1,T;return function(){return k||(k=!0,T=L.apply(C,arguments)),T}}e.once=g}),define(ve[74],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(ve[75],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function C(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=C;const k=Object.freeze([]);function T(){return k}L.empty=T;function*y(p){yield p}L.single=y;function S(p){return p||k}L.from=S;function A(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=A;function i(p){return p[Symbol.iterator]().next().value}L.first=i;function I(p,t){for(const s of p)if(t(s))return!0;return!1}L.some=I;function u(p,t){for(const s of p)if(t(s))return s}L.find=u;function*m(p,t){for(const s of p)t(s)&&(yield s)}L.filter=m;function*c(p,t){let s=0;for(const o of p)yield t(o,s++)}L.map=c;function*v(...p){for(const t of p)for(const s of t)yield s}L.concat=v;function*_(p){for(const t of p)for(const s of t)yield s}L.concatNested=_;function b(p,t,s){let o=s;for(const n of p)o=t(o,n);return o}L.reduce=b;function*P(p,t,s=p.length){for(t<0&&(t+=p.length),s<0?s+=p.length:s>p.length&&(s=p.length);t<s;t++)yield p[t]}L.slice=P;function l(p,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,p];const o=p[Symbol.iterator]();for(let n=0;n<t;n++){const a=o.next();if(a.done)return[s,L.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return o}}]}L.consume=l;function f(p,t,s=(o,n)=>o===n){const o=p[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const a=o.next(),h=n.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!s(a.value,h.value))return!1}}L.equals=f})(g=e.Iterable||(e.Iterable={}))}),define(ve[57],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function T(t,s=!1){let o=0,n=t.length,a="",h=0,d=16,w=0;function E(Q){let N=0,U=0;for(;N<Q;){const F=t.charCodeAt(o);if(F>=48&&F<=57)U=U*16+F-48;else if(F>=65&&F<=70)U=U*16+F-65+10;else if(F>=97&&F<=102)U=U*16+F-97+10;else break;o++,N++}return N<Q&&(U=-1),U}function r(Q){o=Q,a="",h=0,d=16,w=0}function D(){const Q=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&A(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&A(t.charCodeAt(o)))for(o++;o<t.length&&A(t.charCodeAt(o));)o++;else return w=3,t.substring(Q,o);let N=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&A(t.charCodeAt(o))){for(o++;o<t.length&&A(t.charCodeAt(o));)o++;N=o}else w=3;return t.substring(Q,N)}function R(){let Q="",N=o;for(;;){if(o>=n){Q+=t.substring(N,o),w=2;break}const U=t.charCodeAt(o);if(U===34){Q+=t.substring(N,o),o++;break}if(U===92){if(Q+=t.substring(N,o),o++,o>=n){w=2;break}switch(t.charCodeAt(o++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const V=E(4);V>=0?Q+=String.fromCharCode(V):w=4;break;default:w=5}N=o;continue}if(U>=0&&U<=31)if(S(U)){Q+=t.substring(N,o),w=2;break}else w=6;o++}return Q}function x(){if(a="",w=0,h=o,o>=n)return h=n,d=17;let Q=t.charCodeAt(o);if(y(Q)){do o++,a+=String.fromCharCode(Q),Q=t.charCodeAt(o);while(y(Q));return d=15}if(S(Q))return o++,a+=String.fromCharCode(Q),Q===13&&t.charCodeAt(o)===10&&(o++,a+=`
`),d=14;switch(Q){case 123:return o++,d=1;case 125:return o++,d=2;case 91:return o++,d=3;case 93:return o++,d=4;case 58:return o++,d=6;case 44:return o++,d=5;case 34:return o++,a=R(),d=10;case 47:const N=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<n&&!S(t.charCodeAt(o));)o++;return a=t.substring(N,o),d=12}if(t.charCodeAt(o+1)===42){o+=2;const U=n-1;let F=!1;for(;o<U;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,F=!0;break}o++}return F||(o++,w=1),a=t.substring(N,o),d=13}return a+=String.fromCharCode(Q),o++,d=16;case 45:if(a+=String.fromCharCode(Q),o++,o===n||!A(t.charCodeAt(o)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=D(),d=11;default:for(;o<n&&j(Q);)o++,Q=t.charCodeAt(o);if(h!==o){switch(a=t.substring(h,o),a){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return a+=String.fromCharCode(Q),o++,d=16}}function j(Q){if(y(Q)||S(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let Q;do Q=x();while(Q>=12&&Q<=15);return Q}return{setPosition:r,getPosition:()=>o,scan:s?te:x,getToken:()=>d,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>o-h,getTokenError:()=>w}}e.createScanner=T;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function A(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,s){const o=[],n=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function w(E,r,D,R){h.value=E,h.offset=r,h.length=D,h.type=R,h.colonOffset=void 0,a=h}try{l(t,{onObjectBegin:(E,r)=>{if(s<=E)throw n;a=void 0,d=s>E,o.push("")},onObjectProperty:(E,r,D)=>{if(s<r||(w(E,r,D,"property"),o[o.length-1]=E,s<=r+D))throw n},onObjectEnd:(E,r)=>{if(s<=E)throw n;a=void 0,o.pop()},onArrayBegin:(E,r)=>{if(s<=E)throw n;a=void 0,o.push(0)},onArrayEnd:(E,r)=>{if(s<=E)throw n;a=void 0,o.pop()},onLiteralValue:(E,r,D)=>{if(s<r||(w(E,r,D,p(E)),s<=r+D))throw n},onSeparator:(E,r,D)=>{if(s<=r)throw n;if(E===":"&&a&&a.type==="property")a.colonOffset=r,d=!1,a=void 0;else if(E===","){const R=o[o.length-1];typeof R=="number"?o[o.length-1]=R+1:(d=!0,o[o.length-1]=""),a=void 0}}})}catch(E){if(E!==n)throw E}return{path:o,previousNode:a,isAtPropertyKey:d,matches:E=>{let r=0;for(let D=0;r<E.length&&D<o.length;D++)if(E[r]===o[D]||E[r]==="*")r++;else if(E[r]!=="**")return!1;return r===E.length}}}e.getLocation=I;function u(t,s=[],o=k.DEFAULT){let n=null,a=[];const h=[];function d(E){Array.isArray(a)?a.push(E):n!==null&&(a[n]=E)}return l(t,{onObjectBegin:()=>{const E={};d(E),h.push(a),a=E,n=null},onObjectProperty:E=>{n=E},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const E=[];d(E),h.push(a),a=E,n=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:d,onError:(E,r,D)=>{s.push({error:E,offset:r,length:D})}},o),a[0]}e.parse=u;function m(t,s=[],o=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){n.type==="property"&&(n.length=E-n.offset,n=n.parent)}function h(E){return n.children.push(E),E}l(t,{onObjectBegin:E=>{n=h({type:"object",offset:E,length:-1,parent:n,children:[]})},onObjectProperty:(E,r,D)=>{n=h({type:"property",offset:r,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:E,offset:r,length:D,parent:n})},onObjectEnd:(E,r)=>{n.length=E+r-n.offset,n=n.parent,a(E+r)},onArrayBegin:(E,r)=>{n=h({type:"array",offset:E,length:-1,parent:n,children:[]})},onArrayEnd:(E,r)=>{n.length=E+r-n.offset,n=n.parent,a(E+r)},onLiteralValue:(E,r,D)=>{h({type:p(E),offset:r,length:D,parent:n,value:E}),a(r+D)},onSeparator:(E,r,D)=>{n.type==="property"&&(E===":"?n.colonOffset=r:E===","&&a(r))},onError:(E,r,D)=>{s.push({error:E,offset:r,length:D})}},o);const w=n.children[0];return w&&delete w.parent,w}e.parseTree=m;function c(t,s){if(!t)return;let o=t;for(let n of s)if(typeof n=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const h of o.children)if(Array.isArray(h.children)&&h.children[0].value===n){o=h.children[1],a=!0;break}if(!a)return}else{const a=n;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.findNodeAtLocation=c;function v(t){if(!t.parent||!t.parent.children)return[];const s=v(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;s.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&s.push(o)}return s}e.getNodePath=v;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const s=Object.create(null);for(let o of t.children){const n=o.children[1];n&&(s[o.children[0].value]=_(n))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function b(t,s,o=!1){return s>=t.offset&&s<t.offset+t.length||o&&s===t.offset+t.length}e.contains=b;function P(t,s,o=!1){if(b(t,s,o)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=s;a++){const h=P(n[a],s,o);if(h)return h}return t}}e.findNodeAtOffset=P;function l(t,s,o=k.DEFAULT){const n=T(t,!1);function a(ne){return ne?()=>ne(n.getTokenOffset(),n.getTokenLength()):()=>!0}function h(ne){return ne?me=>ne(me,n.getTokenOffset(),n.getTokenLength()):()=>!0}const d=a(s.onObjectBegin),w=h(s.onObjectProperty),E=a(s.onObjectEnd),r=a(s.onArrayBegin),D=a(s.onArrayEnd),R=h(s.onLiteralValue),x=h(s.onSeparator),j=a(s.onComment),te=h(s.onError),Q=o&&o.disallowComments,N=o&&o.allowTrailingComma;function U(){for(;;){const ne=n.scan();switch(n.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:Q||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(ne){case 12:case 13:Q?F(10):j();break;case 16:F(1);break;case 15:case 14:break;default:return ne}}}function F(ne,me=[],Se=[]){if(te(ne),me.length+Se.length>0){let Ce=n.getToken();for(;Ce!==17;){if(me.indexOf(Ce)!==-1){U();break}else if(Se.indexOf(Ce)!==-1)break;Ce=U()}}}function V(ne){const me=n.getTokenValue();return ne?R(me):w(me),U(),!0}function M(){switch(n.getToken()){case 11:let ne=0;try{ne=JSON.parse(n.getTokenValue()),typeof ne!="number"&&(F(2),ne=0)}catch(me){F(2)}R(ne);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return U(),!0}function O(){return n.getToken()!==10?(F(3,[],[2,5]),!1):(V(!1),n.getToken()===6?(x(":"),U(),K()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function q(){d(),U();let ne=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ne||F(4,[],[]),x(","),U(),n.getToken()===2&&N)break}else ne&&F(6,[],[]);O()||F(4,[],[2,5]),ne=!0}return E(),n.getToken()!==2?F(7,[2],[]):U(),!0}function B(){r(),U();let ne=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ne||F(4,[],[]),x(","),U(),n.getToken()===4&&N)break}else ne&&F(6,[],[]);K()||F(4,[],[4,5]),ne=!0}return D(),n.getToken()!==4?F(8,[4],[]):U(),!0}function K(){switch(n.getToken()){case 3:return B();case 1:return q();case 10:return V(!0);default:return M()}}return U(),n.getToken()===17?o.allowEmptyContent?!0:(F(4,[],[]),!1):K()?(n.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=l;function f(t,s){let o=T(t),n=[],a,h=0,d;do switch(d=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:h!==d&&n.push(t.substring(h,d)),s!==void 0&&n.push(o.getTokenValue().replace(/[^\r\n]/g,s)),h=o.getPosition();break}while(a!==17);return n.join("")}e.stripComments=f;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ve[137],we([0,1,57]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,A,i){let I,u,m,c,v;if(A){for(c=A.offset,v=c+A.length,m=c;m>0&&!y(S,m-1);)m--;let h=v;for(;h<S.length&&!y(S,h);)h++;u=S.substring(m,h),I=k(u,i)}else u=S,I=0,m=0,c=0,v=S.length;const _=T(i,S);let b=!1,P=0,l;i.insertSpaces?l=C(" ",i.tabSize||4):l="	";const f=(0,g.createScanner)(u,!1);let p=!1;function t(){return _+C(l,I+P)}function s(){let h=f.scan();for(b=!1;h===15||h===14;)b=b||h===14,h=f.scan();return p=h===16||f.getTokenError()!==0,h}const o=[];function n(h,d,w){!p&&d<v&&w>c&&S.substring(d,w)!==h&&o.push({offset:d,length:w-d,content:h})}let a=s();if(a!==17){const h=f.getTokenOffset()+m,d=C(l,I);n(d,m,h)}for(;a!==17;){let h=f.getTokenOffset()+f.getTokenLength()+m,d=s(),w="";for(;!b&&(d===12||d===13);){const r=f.getTokenOffset()+m;n(" ",h,r),h=f.getTokenOffset()+f.getTokenLength()+m,w=d===12?t():"",d=s()}if(d===2)a!==1&&(P--,w=t());else if(d===4)a!==3&&(P--,w=t());else{switch(a){case 3:case 1:P++,w=t();break;case 5:case 12:w=t();break;case 13:b?w=t():w=" ";break;case 6:w=" ";break;case 10:if(d===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?w=" ":d!==5&&d!==17&&(p=!0);break;case 16:p=!0;break}b&&(d===12||d===13)&&(w=t())}const E=f.getTokenOffset()+m;n(w,h,E),a=d}return o}e.format=L;function C(S,A){let i="";for(let I=0;I<A;I++)i+=S;return i}function k(S,A){let i=0,I=0;const u=A.tabSize||4;for(;i<S.length;){const m=S.charAt(i);if(m===" ")I++;else if(m==="	")I+=u;else break;i++}return Math.floor(I/u)}function T(S,A){for(let i=0;i<A.length;i++){const I=A.charAt(i);if(I==="\r")return i+1<A.length&&A.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=T;function y(S,A){return`\r
`.indexOf(S.charAt(A))!==-1}e.isEOL=y}),define(ve[138],we([0,1,57,137]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(A,i,I){return k(A,i,void 0,I)}e.removeProperty=C;function k(A,i,I,u,m){const c=i.slice(),v=[],_=(0,g.parseTree)(A,v);let b,P;for(;c.length>0&&(P=c.pop(),b=(0,g.findNodeAtLocation)(_,c),b===void 0&&I!==void 0);)typeof P=="string"?I={[P]:I}:I=[I];if(b)if(b.type==="object"&&typeof P=="string"&&Array.isArray(b.children)){const l=(0,g.findNodeAtLocation)(b,[P]);if(l!==void 0)if(I===void 0){if(!l.parent)throw new Error("Malformed AST");const f=b.children.indexOf(l.parent);let p,t=l.parent.offset+l.parent.length;if(f>0){const s=b.children[f-1];p=s.offset+s.length}else p=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return T(A,{offset:p,length:t-p,content:""},u)}else return T(A,{offset:l.offset,length:l.length,content:JSON.stringify(I)},u);else{if(I===void 0)return[];const f=`${JSON.stringify(P)}: ${JSON.stringify(I)}`,p=m?m(b.children.map(s=>s.children[0].value)):b.children.length;let t;if(p>0){const s=b.children[p-1];t={offset:s.offset+s.length,length:0,content:","+f}}else b.children.length===0?t={offset:b.offset+1,length:0,content:f}:t={offset:b.offset+1,length:0,content:f+","};return T(A,t,u)}}else if(b.type==="array"&&typeof P=="number"&&Array.isArray(b.children))if(I!==void 0){const l=`${JSON.stringify(I)}`;let f;if(b.children.length===0||P===0)f={offset:b.offset+1,length:0,content:b.children.length===0?l:l+","};else{const p=P===-1||P>b.children.length?b.children.length:P,t=b.children[p-1];f={offset:t.offset+t.length,length:0,content:","+l}}return T(A,f,u)}else{const l=P,f=b.children[l];let p;if(b.children.length===1)p={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===l){const t=b.children[l-1],s=t.offset+t.length,o=b.offset+b.length;p={offset:s,length:o-2-s,content:""}}else p={offset:f.offset,length:b.children[l+1].offset-f.offset,content:""};return T(A,p,u)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${b.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return T(A,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},u)}}e.setProperty=k;function T(A,i,I){let u=y(A,i),m=i.offset,c=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;m>0&&!(0,L.isEOL)(u,m-1);)m--;for(;c<u.length&&!(0,L.isEOL)(u,c);)c++}const v=(0,L.format)(u,{offset:m,length:c-m},I);for(let b=v.length-1;b>=0;b--){const P=v[b];u=y(u,P),m=Math.min(m,P.offset),c=Math.max(c,P.offset+P.length),c+=P.content.length-P.length}const _=A.length-(u.length-c)-m;return[{offset:m,length:_,content:u.substring(m,c)}]}e.withFormatting=T;function y(A,i){return A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)}e.applyEdit=y;function S(A,i){let I=i.slice(0).sort((m,c)=>{const v=m.offset-c.offset;return v===0?m.length-c.length:v}),u=A.length;for(let m=I.length-1;m>=0;m--){let c=I[m];if(c.offset+c.length<=u)A=y(A,c);else throw new Error("Overlapping edit");u=c.offset}return A}e.applyEdits=S}),define(ve[139],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new g(()=>C(this.getValue()))}}e.Lazy=g}),define(ve[6],we([0,1,73,75]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let k=null;function T(o){k=o}if(e.setDisposableTracker=T,C){const o="__is_disposable_tracked__";T(new class{trackDisposable(n){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[o]||console.log(a)},3e3)}setParent(n,a){if(n&&n!==P.None)try{n[o]=!0}catch{}}markAsDisposed(n){if(n&&n!==P.None)try{n[o]=!0}catch{}}markAsSingleton(n){}})}function y(o){return k?.trackDisposable(o),o}function S(o){k?.markAsDisposed(o)}function A(o,n){k?.setParent(o,n)}function i(o,n){if(!!k)for(const a of o)k.setParent(a,n)}function I(o){return k?.markAsSingleton(o),o}e.markAsSingleton=I;class u extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=u;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function c(o){if(L.Iterable.is(o)){let n=[];for(const a of o)if(a)try{a.dispose()}catch(h){n.push(h)}if(n.length===1)throw n[0];if(n.length>1)throw new u(n);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=c;function v(...o){const n=_(()=>c(o));return i(o,n),n}e.combinedDisposable=v;function _(o){const n=y({dispose:(0,g.once)(()=>{S(n),o()})});return n}e.toDisposable=_;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return A(n,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new b,y(this),A(this._store,this)}dispose(){S(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&A(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&A(n,null),n}}e.MutableDisposable=l;class f{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class p{constructor(){this.references=new Map}acquire(n,...a){let h=this.references.get(n);h||(h={counter:0,object:this.createReferencedObject(n,...a)},this.references.set(n,h));const{object:d}=h,w=(0,g.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(n,h.object),this.references.delete(n))});return h.counter++,{object:d,dispose:w}}}e.ReferenceCollection=p;class t{constructor(n){this.referenceCollection=n}async acquire(n,...a){const h=this.referenceCollection.acquire(n,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(d){throw h.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s}),define(ve[94],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(k){this.element=k,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let k=this._first;for(;k!==g.Undefined;){const T=k.next;k.prev=g.Undefined,k.next=g.Undefined,k=T}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,T){const y=new g(k);if(this._first===g.Undefined)this._first=y,this._last=y;else if(T){const A=this._last;this._last=y,y.prev=A,A.next=y}else{const A=this._first;this._first=y,y.next=A,A.prev=y}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(y))}}shift(){if(this._first!==g.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==g.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==g.Undefined&&k.next!==g.Undefined){const T=k.prev;T.next=k.next,k.next.prev=T}else k.prev===g.Undefined&&k.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):k.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):k.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==g.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(ke,ye){for(var Ie=0;Ie<ye.length;Ie++){var ce=ye[Ie];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(ke,ce.key,ce)}}function e(ke,ye,Ie){return ye&&J(ke.prototype,ye),Ie&&J(ke,Ie),ke}function g(ke,ye){if(!!ke){if(typeof ke=="string")return L(ke,ye);var Ie=Object.prototype.toString.call(ke).slice(8,-1);if(Ie==="Object"&&ke.constructor&&(Ie=ke.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(ke);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return L(ke,ye)}}function L(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var Ie=0,ce=new Array(ye);Ie<ye;Ie++)ce[Ie]=ke[Ie];return ce}function C(ke,ye){var Ie;if(typeof Symbol=="undefined"||ke[Symbol.iterator]==null){if(Array.isArray(ke)||(Ie=g(ke))||ye&&ke&&typeof ke.length=="number"){Ie&&(ke=Ie);var ce=0;return function(){return ce>=ke.length?{done:!0}:{done:!1,value:ke[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ie=ke[Symbol.iterator](),Ie.next.bind(Ie)}function k(ke){var ye={exports:{}};return ke(ye,ye.exports),ye.exports}var T=k(function(ke){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ie(ce){ke.exports.defaults=ce}ke.exports={defaults:ye(),getDefaults:ye,changeDefaults:Ie}}),y=/[&<>"']/,S=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(ye){return I[ye]};function m(ke,ye){if(ye){if(y.test(ke))return ke.replace(S,u)}else if(A.test(ke))return ke.replace(i,u);return ke}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(ke){return ke.replace(c,function(ye,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var _=/(^|[^\[])\^/g;function b(ke,ye){ke=ke.source||ke,ye=ye||"";var Ie={replace:function(de,H){return H=H.source||H,H=H.replace(_,"$1"),ke=ke.replace(de,H),Ie},getRegex:function(){return new RegExp(ke,ye)}};return Ie}var P=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(ke,ye,Ie){if(ke){var ce;try{ce=decodeURIComponent(v(Ie)).replace(P,"").toLowerCase()}catch(de){return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}ye&&!l.test(Ie)&&(Ie=n(ye,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch(de){return null}return Ie}var p={},t=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(ke,ye){p[" "+ke]||(t.test(ke)?p[" "+ke]=ke+"/":p[" "+ke]=w(ke,"/",!0)),ke=p[" "+ke];var Ie=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ie?ye:ke.replace(s,"$1")+ye:ye.charAt(0)==="/"?Ie?ye:ke.replace(o,"$1")+ye:ke+ye}var a={exec:function(){}};function h(ke){for(var ye=1,Ie,ce;ye<arguments.length;ye++){Ie=arguments[ye];for(ce in Ie)Object.prototype.hasOwnProperty.call(Ie,ce)&&(ke[ce]=Ie[ce])}return ke}function d(ke,ye){var Ie=ke.replace(/\|/g,function(H,ee,ue){for(var Le=!1,Re=ee;--Re>=0&&ue[Re]==="\\";)Le=!Le;return Le?"|":" |"}),ce=Ie.split(/ \|/),de=0;if(ce.length>ye)ce.splice(ye);else for(;ce.length<ye;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function w(ke,ye,Ie){var ce=ke.length;if(ce===0)return"";for(var de=0;de<ce;){var H=ke.charAt(ce-de-1);if(H===ye&&!Ie)de++;else if(H!==ye&&Ie)de++;else break}return ke.substr(0,ce-de)}function E(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var Ie=ke.length,ce=0,de=0;de<Ie;de++)if(ke[de]==="\\")de++;else if(ke[de]===ye[0])ce++;else if(ke[de]===ye[1]&&(ce--,ce<0))return de;return-1}function r(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(ke,ye){if(ye<1)return"";for(var Ie="";ye>1;)ye&1&&(Ie+=ke),ye>>=1,ke+=ke;return Ie+ke}var R={escape:m,unescape:v,edit:b,cleanUrl:f,resolveUrl:n,noopTest:a,merge:h,splitCells:d,rtrim:w,findClosingBracket:E,checkSanitizeDeprecation:r,repeatString:D},x=T.defaults,j=R.rtrim,te=R.splitCells,Q=R.escape,N=R.findClosingBracket;function U(ke,ye,Ie){var ce=ye.href,de=ye.title?Q(ye.title):null,H=ke[1].replace(/\\([\[\]])/g,"$1");return ke[0].charAt(0)!=="!"?{type:"link",raw:Ie,href:ce,title:de,text:H}:{type:"image",raw:Ie,href:ce,title:de,text:Q(H)}}function F(ke,ye){var Ie=ke.match(/^(\s+)(?:```)/);if(Ie===null)return ye;var ce=Ie[1];return ye.split(`
`).map(function(de){var H=de.match(/^\s+/);if(H===null)return de;var ee=H[0];return ee.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var V=function(){function ke(Ie){this.options=Ie||x}var ye=ke.prototype;return ye.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},ye.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var H=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?H:j(H,`
`)}}},ye.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var H=de[0],ee=F(H,de[3]||"");return{type:"code",raw:H,lang:de[2]?de[2].trim():de[2],text:ee}}},ye.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var H=de[2].trim();if(/#$/.test(H)){var ee=j(H,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(H=ee.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:H}}},ye.nptable=function(ce){var de=this.rules.block.nptable.exec(ce);if(de){var H={type:"table",header:te(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[],raw:de[0]};if(H.header.length===H.align.length){var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=te(H.cells[ue],H.header.length);return H}}},ye.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},ye.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var H=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],text:H}}},ye.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var H=de[0],ee=de[2],ue=ee.length>1,Le={type:"list",raw:H,ordered:ue,start:ue?+ee.slice(0,-1):"",loose:!1,items:[]},Re=de[0].match(this.rules.block.item),ze=!1,Ge,et,it,Ye,Xe,mt,vt,Et,ot=Re.length;it=this.rules.block.listItemStart.exec(Re[0]);for(var at=0;at<ot;at++){if(Ge=Re[at],H=Ge,at!==ot-1){if(Ye=this.rules.block.listItemStart.exec(Re[at+1]),this.options.pedantic?Ye[1].length>it[1].length:Ye[1].length>it[0].length||Ye[1].length>3){Re.splice(at,2,Re[at]+`
`+Re[at+1]),at--,ot--;continue}else(!this.options.pedantic||this.options.smartLists?Ye[2][Ye[2].length-1]!==ee[ee.length-1]:ue===(Ye[2].length===1))&&(Xe=Re.slice(at+1).join(`
`),Le.raw=Le.raw.substring(0,Le.raw.length-Xe.length),at=ot-1);it=Ye}et=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(et-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+et+"}","gm"),"")),mt=ze||/\n\n(?!\s*$)/.test(Ge),at!==ot-1&&(ze=Ge.charAt(Ge.length-1)===`
`,mt||(mt=ze)),mt&&(Le.loose=!0),this.options.gfm&&(vt=/^\[[ xX]\] /.test(Ge),Et=void 0,vt&&(Et=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),Le.items.push({type:"list_item",raw:H,task:vt,checked:Et,loose:mt,text:Ge})}return Le}},ye.html=function(ce){var de=this.rules.block.html.exec(ce);if(de)return{type:this.options.sanitize?"paragraph":"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):Q(de[0]):de[0]}},ye.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var H=de[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:de[0],href:de[2],title:de[3]}}},ye.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var H={type:"table",header:te(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=de[0];var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=te(H.cells[ue].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},ye.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1]}},ye.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de)return{type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1]}},ye.text=function(ce){var de=this.rules.block.text.exec(ce);if(de)return{type:"text",raw:de[0],text:de[0]}},ye.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:Q(de[1])}},ye.tag=function(ce,de,H){var ee=this.rules.inline.tag.exec(ce);if(ee)return!de&&/^<a /i.test(ee[0])?de=!0:de&&/^<\/a>/i.test(ee[0])&&(de=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:de,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):Q(ee[0]):ee[0]}},ye.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var H=de[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var ee=j(H.slice(0,-1),"\\");if((H.length-ee.length)%2==0)return}else{var ue=N(de[2],"()");if(ue>-1){var Le=de[0].indexOf("!")===0?5:4,Re=Le+de[1].length+ue;de[2]=de[2].substring(0,ue),de[0]=de[0].substring(0,Re).trim(),de[3]=""}}var ze=de[2],Ge="";if(this.options.pedantic){var et=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ze);et&&(ze=et[1],Ge=et[3])}else Ge=de[3]?de[3].slice(1,-1):"";return ze=ze.trim(),/^</.test(ze)&&(this.options.pedantic&&!/>$/.test(H)?ze=ze.slice(1):ze=ze.slice(1,-1)),U(de,{href:ze&&ze.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},de[0])}},ye.reflink=function(ce,de){var H;if((H=this.rules.inline.reflink.exec(ce))||(H=this.rules.inline.nolink.exec(ce))){var ee=(H[2]||H[1]).replace(/\s+/g," ");if(ee=de[ee.toLowerCase()],!ee||!ee.href){var ue=H[0].charAt(0);return{type:"text",raw:ue,text:ue}}return U(H,ee,H[0])}},ye.emStrong=function(ce,de,H){H===void 0&&(H="");var ee=this.rules.inline.emStrong.lDelim.exec(ce);if(!!ee&&!(ee[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=ee[1]||ee[2]||"";if(!ue||ue&&(H===""||this.rules.inline.punctuation.exec(H))){var Le=ee[0].length-1,Re,ze,Ge=Le,et=0,it=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(it.lastIndex=0,de=de.slice(-1*ce.length+Le);(ee=it.exec(de))!=null;)if(Re=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!Re){if(ze=Re.length,ee[3]||ee[4]){Ge+=ze;continue}else if((ee[5]||ee[6])&&Le%3&&!((Le+ze)%3)){et+=ze;continue}if(Ge-=ze,!(Ge>0)){if(Ge+et-ze<=0&&!de.slice(it.lastIndex).match(it)&&(ze=Math.min(ze,ze+Ge+et)),Math.min(Le,ze)%2)return{type:"em",raw:ce.slice(0,Le+ee.index+ze+1),text:ce.slice(1,Le+ee.index+ze)};if(Math.min(Le,ze)%2==0)return{type:"strong",raw:ce.slice(0,Le+ee.index+ze+1),text:ce.slice(2,Le+ee.index+ze-1)}}}}}},ye.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var H=de[2].replace(/\n/g," "),ee=/[^ ]/.test(H),ue=/^ /.test(H)&&/ $/.test(H);return ee&&ue&&(H=H.substring(1,H.length-1)),H=Q(H,!0),{type:"codespan",raw:de[0],text:H}}},ye.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},ye.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2]}},ye.autolink=function(ce,de){var H=this.rules.inline.autolink.exec(ce);if(H){var ee,ue;return H[2]==="@"?(ee=Q(this.options.mangle?de(H[1]):H[1]),ue="mailto:"+ee):(ee=Q(H[1]),ue=ee),{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},ye.url=function(ce,de){var H;if(H=this.rules.inline.url.exec(ce)){var ee,ue;if(H[2]==="@")ee=Q(this.options.mangle?de(H[0]):H[0]),ue="mailto:"+ee;else{var Le;do Le=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Le!==H[0]);ee=Q(H[0]),H[1]==="www."?ue="http://"+ee:ue=ee}return{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},ye.inlineText=function(ce,de,H){var ee=this.rules.inline.text.exec(ce);if(ee){var ue;return de?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):Q(ee[0]):ee[0]:ue=Q(this.options.smartypants?H(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ue}}},ke}(),M=R.noopTest,O=R.edit,q=R.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=O(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=O(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=O(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=O(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=O(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=O(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=O(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=q({},B),B.gfm=q({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=O(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=O(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=q({},B.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:O(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=O(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=O(B._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=O(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=O(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=O(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=O(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=O(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=O(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=O(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=O(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=q({},K),K.pedantic=q({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=q({},K.normal,{escape:O(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),K.gfm.url=O(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=q({},K.gfm,{br:O(K.br).replace("{2,}","*").getRegex(),text:O(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ne={block:B,inline:K},me=T.defaults,Se=ne.block,Ce=ne.inline,Te=R.repeatString;function je(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Be(ke){var ye="",Ie,ce,de=ke.length;for(Ie=0;Ie<de;Ie++)ce=ke.charCodeAt(Ie),Math.random()>.5&&(ce="x"+ce.toString(16)),ye+="&#"+ce+";";return ye}var Ve=function(){function ke(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||me,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ce={block:Se.normal,inline:Ce.normal};this.options.pedantic?(ce.block=Se.pedantic,ce.inline=Ce.pedantic):this.options.gfm&&(ce.block=Se.gfm,this.options.breaks?ce.inline=Ce.breaks:ce.inline=Ce.gfm),this.tokenizer.rules=ce}ke.lex=function(ce,de){var H=new ke(de);return H.lex(ce)},ke.lexInline=function(ce,de){var H=new ke(de);return H.inlineTokens(ce)};var ye=ke.prototype;return ye.lex=function(ce){return ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(ce,de,H){de===void 0&&(de=[]),H===void 0&&(H=!0),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var ee,ue,Le,Re;ce;){if(ee=this.tokenizer.space(ce)){ce=ce.substring(ee.raw.length),ee.type&&de.push(ee);continue}if(ee=this.tokenizer.code(ce)){ce=ce.substring(ee.raw.length),Re=de[de.length-1],Re&&Re.type==="paragraph"?(Re.raw+=`
`+ee.raw,Re.text+=`
`+ee.text):de.push(ee);continue}if(ee=this.tokenizer.fences(ce)){ce=ce.substring(ee.raw.length),de.push(ee);continue}if(ee=this.tokenizer.heading(ce)){ce=ce.substring(ee.raw.length),de.push(ee);continue}if(ee=this.tokenizer.nptable(ce)){ce=ce.substring(ee.raw.length),de.push(ee);continue}if(ee=this.tokenizer.hr(ce)){ce=ce.substring(ee.raw.length),de.push(ee);continue}if(ee=this.tokenizer.blockquote(ce)){ce=ce.substring(ee.raw.length),ee.tokens=this.blockTokens(ee.text,[],H),de.push(ee);continue}if(ee=this.tokenizer.list(ce)){for(ce=ce.substring(ee.raw.length),Le=ee.items.length,ue=0;ue<Le;ue++)ee.items[ue].tokens=this.blockTokens(ee.items[ue].text,[],!1);de.push(ee);continue}if(ee=this.tokenizer.html(ce)){ce=ce.substring(ee.raw.length),de.push(ee);continue}if(H&&(ee=this.tokenizer.def(ce))){ce=ce.substring(ee.raw.length),this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ce)){ce=ce.substring(ee.raw.length),de.push(ee);continue}if(ee=this.tokenizer.lheading(ce)){ce=ce.substring(ee.raw.length),de.push(ee);continue}if(H&&(ee=this.tokenizer.paragraph(ce))){ce=ce.substring(ee.raw.length),de.push(ee);continue}if(ee=this.tokenizer.text(ce)){ce=ce.substring(ee.raw.length),Re=de[de.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+ee.raw,Re.text+=`
`+ee.text):de.push(ee);continue}if(ce){var ze="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return de},ye.inline=function(ce){var de,H,ee,ue,Le,Re,ze=ce.length;for(de=0;de<ze;de++)switch(Re=ce[de],Re.type){case"paragraph":case"text":case"heading":{Re.tokens=[],this.inlineTokens(Re.text,Re.tokens);break}case"table":{for(Re.tokens={header:[],cells:[]},ue=Re.header.length,H=0;H<ue;H++)Re.tokens.header[H]=[],this.inlineTokens(Re.header[H],Re.tokens.header[H]);for(ue=Re.cells.length,H=0;H<ue;H++)for(Le=Re.cells[H],Re.tokens.cells[H]=[],ee=0;ee<Le.length;ee++)Re.tokens.cells[H][ee]=[],this.inlineTokens(Le[ee],Re.tokens.cells[H][ee]);break}case"blockquote":{this.inline(Re.tokens);break}case"list":{for(ue=Re.items.length,H=0;H<ue;H++)this.inline(Re.items[H].tokens);break}}return ce},ye.inlineTokens=function(ce,de,H,ee){de===void 0&&(de=[]),H===void 0&&(H=!1),ee===void 0&&(ee=!1);var ue,Le,Re=ce,ze,Ge,et;if(this.tokens.links){var it=Object.keys(this.tokens.links);if(it.length>0)for(;(ze=this.tokenizer.rules.inline.reflinkSearch.exec(Re))!=null;)it.includes(ze[0].slice(ze[0].lastIndexOf("[")+1,-1))&&(Re=Re.slice(0,ze.index)+"["+Te("a",ze[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ze=this.tokenizer.rules.inline.blockSkip.exec(Re))!=null;)Re=Re.slice(0,ze.index)+"["+Te("a",ze[0].length-2)+"]"+Re.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ze=this.tokenizer.rules.inline.escapedEmSt.exec(Re))!=null;)Re=Re.slice(0,ze.index)+"++"+Re.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;){if(Ge||(et=""),Ge=!1,ue=this.tokenizer.escape(ce)){ce=ce.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.tag(ce,H,ee)){ce=ce.substring(ue.raw.length),H=ue.inLink,ee=ue.inRawBlock;var Ye=de[de.length-1];Ye&&ue.type==="text"&&Ye.type==="text"?(Ye.raw+=ue.raw,Ye.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.link(ce)){ce=ce.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,ee)),de.push(ue);continue}if(ue=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(ue.raw.length);var Xe=de[de.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,ee),de.push(ue)):Xe&&ue.type==="text"&&Xe.type==="text"?(Xe.raw+=ue.raw,Xe.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.emStrong(ce,Re,et)){ce=ce.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),de.push(ue);continue}if(ue=this.tokenizer.codespan(ce)){ce=ce.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.br(ce)){ce=ce.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.del(ce)){ce=ce.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),de.push(ue);continue}if(ue=this.tokenizer.autolink(ce,Be)){ce=ce.substring(ue.raw.length),de.push(ue);continue}if(!H&&(ue=this.tokenizer.url(ce,Be))){ce=ce.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.inlineText(ce,ee,je)){ce=ce.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(et=ue.raw.slice(-1)),Ge=!0,Le=de[de.length-1],Le&&Le.type==="text"?(Le.raw+=ue.raw,Le.text+=ue.text):de.push(ue);continue}if(ce){var mt="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return de},e(ke,null,[{key:"rules",get:function(){return{block:Se,inline:Ce}}}]),ke}(),W=T.defaults,Z=R.cleanUrl,ie=R.escape,le=function(){function ke(Ie){this.options=Ie||W}var ye=ke.prototype;return ye.code=function(ce,de,H){var ee=(de||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(ce,ee);ue!=null&&ue!==ce&&(H=!0,ce=ue)}return ce=ce.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+ie(ee,!0)+'">'+(H?ce:ie(ce,!0))+`</code></pre>
`:"<pre><code>"+(H?ce:ie(ce,!0))+`</code></pre>
`},ye.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},ye.html=function(ce){return ce},ye.heading=function(ce,de,H,ee){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+ee.slug(H)+'">'+ce+"</h"+de+`>
`:"<h"+de+">"+ce+"</h"+de+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ce,de,H){var ee=de?"ol":"ul",ue=de&&H!==1?' start="'+H+'"':"";return"<"+ee+ue+`>
`+ce+"</"+ee+`>
`},ye.listitem=function(ce){return"<li>"+ce+`</li>
`},ye.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ce){return"<p>"+ce+`</p>
`},ye.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},ye.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},ye.tablecell=function(ce,de){var H=de.header?"th":"td",ee=de.align?"<"+H+' align="'+de.align+'">':"<"+H+">";return ee+ce+"</"+H+`>
`},ye.strong=function(ce){return"<strong>"+ce+"</strong>"},ye.em=function(ce){return"<em>"+ce+"</em>"},ye.codespan=function(ce){return"<code>"+ce+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ce){return"<del>"+ce+"</del>"},ye.link=function(ce,de,H){if(ce=Z(this.options.sanitize,this.options.baseUrl,ce),ce===null)return H;var ee='<a href="'+ie(ce)+'"';return de&&(ee+=' title="'+de+'"'),ee+=">"+H+"</a>",ee},ye.image=function(ce,de,H){if(ce=Z(this.options.sanitize,this.options.baseUrl,ce),ce===null)return H;var ee='<img src="'+ce+'" alt="'+H+'"';return de&&(ee+=' title="'+de+'"'),ee+=this.options.xhtml?"/>":">",ee},ye.text=function(ce){return ce},ke}(),Y=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(ce){return ce},ye.em=function(ce){return ce},ye.codespan=function(ce){return ce},ye.del=function(ce){return ce},ye.html=function(ce){return ce},ye.text=function(ce){return ce},ye.link=function(ce,de,H){return""+H},ye.image=function(ce,de,H){return""+H},ye.br=function(){return""},ke}(),ae=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ce,de){var H=ce,ee=0;if(this.seen.hasOwnProperty(H)){ee=this.seen[ce];do ee++,H=ce+"-"+ee;while(this.seen.hasOwnProperty(H))}return de||(this.seen[ce]=ee,this.seen[H]=0),H},ye.slug=function(ce,de){de===void 0&&(de={});var H=this.serialize(ce);return this.getNextSafeSlug(H,de.dryrun)},ke}(),be=T.defaults,Fe=R.unescape,He=function(){function ke(Ie){this.options=Ie||be,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ae}ke.parse=function(ce,de){var H=new ke(de);return H.parse(ce)},ke.parseInline=function(ce,de){var H=new ke(de);return H.parseInline(ce)};var ye=ke.prototype;return ye.parse=function(ce,de){de===void 0&&(de=!0);var H="",ee,ue,Le,Re,ze,Ge,et,it,Ye,Xe,mt,vt,Et,ot,at,Dt,_e,ge,he=ce.length;for(ee=0;ee<he;ee++)switch(Xe=ce[ee],Xe.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(Xe.tokens),Xe.depth,Fe(this.parseInline(Xe.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(Xe.text,Xe.lang,Xe.escaped);continue}case"table":{for(it="",et="",Re=Xe.header.length,ue=0;ue<Re;ue++)et+=this.renderer.tablecell(this.parseInline(Xe.tokens.header[ue]),{header:!0,align:Xe.align[ue]});for(it+=this.renderer.tablerow(et),Ye="",Re=Xe.cells.length,ue=0;ue<Re;ue++){for(Ge=Xe.tokens.cells[ue],et="",ze=Ge.length,Le=0;Le<ze;Le++)et+=this.renderer.tablecell(this.parseInline(Ge[Le]),{header:!1,align:Xe.align[Le]});Ye+=this.renderer.tablerow(et)}H+=this.renderer.table(it,Ye);continue}case"blockquote":{Ye=this.parse(Xe.tokens),H+=this.renderer.blockquote(Ye);continue}case"list":{for(mt=Xe.ordered,vt=Xe.start,Et=Xe.loose,Re=Xe.items.length,Ye="",ue=0;ue<Re;ue++)at=Xe.items[ue],Dt=at.checked,_e=at.task,ot="",at.task&&(ge=this.renderer.checkbox(Dt),Et?at.tokens.length>0&&at.tokens[0].type==="text"?(at.tokens[0].text=ge+" "+at.tokens[0].text,at.tokens[0].tokens&&at.tokens[0].tokens.length>0&&at.tokens[0].tokens[0].type==="text"&&(at.tokens[0].tokens[0].text=ge+" "+at.tokens[0].tokens[0].text)):at.tokens.unshift({type:"text",text:ge}):ot+=ge),ot+=this.parse(at.tokens,Et),Ye+=this.renderer.listitem(ot,_e,Dt);H+=this.renderer.list(Ye,mt,vt);continue}case"html":{H+=this.renderer.html(Xe.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(Xe.tokens));continue}case"text":{for(Ye=Xe.tokens?this.parseInline(Xe.tokens):Xe.text;ee+1<he&&ce[ee+1].type==="text";)Xe=ce[++ee],Ye+=`
`+(Xe.tokens?this.parseInline(Xe.tokens):Xe.text);H+=de?this.renderer.paragraph(Ye):Ye;continue}default:{var G='Token with "'+Xe.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}return H},ye.parseInline=function(ce,de){de=de||this.renderer;var H="",ee,ue,Le=ce.length;for(ee=0;ee<Le;ee++)switch(ue=ce[ee],ue.type){case"escape":{H+=de.text(ue.text);break}case"html":{H+=de.html(ue.text);break}case"link":{H+=de.link(ue.href,ue.title,this.parseInline(ue.tokens,de));break}case"image":{H+=de.image(ue.href,ue.title,ue.text);break}case"strong":{H+=de.strong(this.parseInline(ue.tokens,de));break}case"em":{H+=de.em(this.parseInline(ue.tokens,de));break}case"codespan":{H+=de.codespan(ue.text);break}case"br":{H+=de.br();break}case"del":{H+=de.del(this.parseInline(ue.tokens,de));break}case"text":{H+=de.text(ue.text);break}default:{var Re='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}return H},ke}(),Ee=R.merge,Qe=R.checkSanitizeDeprecation,X=R.escape,se=T.getDefaults,pe=T.changeDefaults,Ue=T.defaults;function Ne(ke,ye,Ie){if(typeof ke=="undefined"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(Ie=ye,ye=null),ye=Ee({},Ne.defaults,ye||{}),Qe(ye),Ie){var ce=ye.highlight,de;try{de=Ve.lex(ke,ye)}catch(Le){return Ie(Le)}var H=function(Re){var ze;if(!Re)try{ze=He.parse(de,ye)}catch(Ge){Re=Ge}return ye.highlight=ce,Re?Ie(Re):Ie(null,ze)};if(!ce||ce.length<3||(delete ye.highlight,!de.length))return H();var ee=0;Ne.walkTokens(de,function(Le){Le.type==="code"&&(ee++,setTimeout(function(){ce(Le.text,Le.lang,function(Re,ze){if(Re)return H(Re);ze!=null&&ze!==Le.text&&(Le.text=ze,Le.escaped=!0),ee--,ee===0&&H()})},0))}),ee===0&&H();return}try{var ue=Ve.lex(ke,ye);return ye.walkTokens&&Ne.walkTokens(ue,ye.walkTokens),He.parse(ue,ye)}catch(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+X(Le.message+"",!0)+"</pre>";throw Le}}Ne.options=Ne.setOptions=function(ke){return Ee(Ne.defaults,ke),pe(Ne.defaults),Ne},Ne.getDefaults=se,Ne.defaults=Ue,Ne.use=function(ke){var ye=Ee({},ke);if(ke.renderer&&function(){var ce=Ne.defaults.renderer||new le,de=function(ue){var Le=ce[ue];ce[ue]=function(){for(var Re=arguments.length,ze=new Array(Re),Ge=0;Ge<Re;Ge++)ze[Ge]=arguments[Ge];var et=ke.renderer[ue].apply(ce,ze);return et===!1&&(et=Le.apply(ce,ze)),et}};for(var H in ke.renderer)de(H);ye.renderer=ce}(),ke.tokenizer&&function(){var ce=Ne.defaults.tokenizer||new V,de=function(ue){var Le=ce[ue];ce[ue]=function(){for(var Re=arguments.length,ze=new Array(Re),Ge=0;Ge<Re;Ge++)ze[Ge]=arguments[Ge];var et=ke.tokenizer[ue].apply(ce,ze);return et===!1&&(et=Le.apply(ce,ze)),et}};for(var H in ke.tokenizer)de(H);ye.tokenizer=ce}(),ke.walkTokens){var Ie=Ne.defaults.walkTokens;ye.walkTokens=function(ce){ke.walkTokens(ce),Ie&&Ie(ce)}}Ne.setOptions(ye)},Ne.walkTokens=function(ke,ye){for(var Ie=C(ke),ce;!(ce=Ie()).done;){var de=ce.value;switch(ye(de),de.type){case"table":{for(var H=C(de.tokens.header),ee;!(ee=H()).done;){var ue=ee.value;Ne.walkTokens(ue,ye)}for(var Le=C(de.tokens.cells),Re;!(Re=Le()).done;)for(var ze=Re.value,Ge=C(ze),et;!(et=Ge()).done;){var it=et.value;Ne.walkTokens(it,ye)}break}case"list":{Ne.walkTokens(de.items,ye);break}default:de.tokens&&Ne.walkTokens(de.tokens,ye)}}},Ne.parseInline=function(ke,ye){if(typeof ke=="undefined"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=Ee({},Ne.defaults,ye||{}),Qe(ye);try{var Ie=Ve.lexInline(ke,ye);return ye.walkTokens&&Ne.walkTokens(Ie,ye.walkTokens),He.parseInline(Ie,ye)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+X(ce.message+"",!0)+"</pre>";throw ce}},Ne.Parser=He,Ne.parser=He.parse,Ne.Renderer=le,Ne.TextRenderer=Y,Ne.Lexer=Ve,Ne.lexer=Ve.lex,Ne.Tokenizer=V,Ne.Slugger=ae,Ne.parse=Ne;var Je=Ne;return Je}),define(ve[76],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(T,y,S){return Math.min(Math.max(T,y),S)}e.clamp=g;function L(T,y){return(y+T%y)%y}e.rot=L;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class k{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=k}),function(){function J(C){const k=[];typeof C=="number"&&k.push("code/timeOrigin",C);function T(S){k.push(S,Date.now())}function y(){const S=[];for(let A=0;A<k.length;A+=2)S.push({name:k[A],startTime:k[A+1]});return S}return{mark:T,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(C+T.startTime)});return k}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function g(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(ve[11],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,C=!1,k=!1,T=!1,y=!1,S=!1,A=!1,i,I=g,u,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const v=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=v&&c?.sandboxed,typeof navigator=="object"&&!v)m=navigator.userAgent,L=m.indexOf("Windows")>=0,C=m.indexOf("Macintosh")>=0,A=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=m.indexOf("Linux")>=0,S=!0,i=navigator.language,I=i;else if(typeof c=="object"){L=c.platform==="win32",C=c.platform==="darwin",k=c.platform==="linux",T=k&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,i=g,I=g;const o=c.env.VSCODE_NLS_CONFIG;if(o)try{const n=JSON.parse(o),a=n.availableLanguages["*"];i=n.locale,I=a||g,u=n._translationsConfigFile}catch(n){}y=!0}else console.error("Unable to resolve platform.");var _;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function b(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let P=0;C?P=1:L?P=3:k&&(P=2),e.isWindows=L,e.isMacintosh=C,e.isLinux=k,e.isLinuxSnap=T,e.isNative=y,e.isWeb=S,e.isIOS=A,e.platform=P,e.userAgent=m,e.language=I;var l;(function(o){function n(){return e.language}o.value=n;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=a;function h(){return e.language==="en"}o.isDefault=h})(l=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=u,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let w=0,E=a.length;w<E;w++){const r=a[w];if(r.id===d.data.vscodeSetImmediateId){a.splice(w,1),r.callback();return}}});let h=0;return d=>{const w=++h;a.push({id:w,callback:d}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof c?.nextTick=="function")return c.nextTick.bind(c);const n=Promise.resolve();return a=>n.then(a)}();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||A?2:L?1:3;let p=!0,t=!1;function s(){if(!t){t=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,p=new Uint16Array(o.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=s}),define(ve[38],we([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const C=g.globals.vscode.process;L={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(k){return(0,g.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(C){return(0,g.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(ve[8],we([0,1,38]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,C=97,k=90,T=122,y=46,S=47,A=92,i=58,I=63;class u extends Error{constructor(f,p,t){let s;typeof p=="string"&&p.indexOf("not ")===0?(s="must not be",p=p.replace(/^not /,"")):s="must be";const o=f.indexOf(".")!==-1?"property":"argument";let n=`The "${f}" ${o} ${s} of type ${p}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function m(l,f){if(typeof l!="string")throw new u(f,"string",l)}function c(l){return l===S||l===A}function v(l){return l===S}function _(l){return l>=L&&l<=k||l>=C&&l<=T}function b(l,f,p,t){let s="",o=0,n=-1,a=0,h=0;for(let d=0;d<=l.length;++d){if(d<l.length)h=l.charCodeAt(d);else{if(t(h))break;h=S}if(t(h)){if(!(n===d-1||a===1))if(a===2){if(s.length<2||o!==2||s.charCodeAt(s.length-1)!==y||s.charCodeAt(s.length-2)!==y){if(s.length>2){const w=s.lastIndexOf(p);w===-1?(s="",o=0):(s=s.slice(0,w),o=s.length-1-s.lastIndexOf(p)),n=d,a=0;continue}else if(s.length!==0){s="",o=0,n=d,a=0;continue}}f&&(s+=s.length>0?`${p}..`:"..",o=2)}else s.length>0?s+=`${p}${l.slice(n+1,d)}`:s=l.slice(n+1,d),o=d-n-1;n=d,a=0}else h===y&&a!==-1?++a:a=-1}return s}function P(l,f){if(f===null||typeof f!="object")throw new u("pathObject","Object",f);const p=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return p?p===f.root?`${p}${t}`:`${p}${l}${t}`:t}e.win32={resolve(...l){let f="",p="",t=!1;for(let s=l.length-1;s>=-1;s--){let o;if(s>=0){if(o=l[s],m(o,"path"),o.length===0)continue}else f.length===0?o=g.cwd():(o=g.env[`=${f}`]||g.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==f.toLowerCase()&&o.charCodeAt(2)===A)&&(o=`${f}\\`));const n=o.length;let a=0,h="",d=!1;const w=o.charCodeAt(0);if(n===1)c(w)&&(a=1,d=!0);else if(c(w))if(d=!0,c(o.charCodeAt(1))){let E=2,r=E;for(;E<n&&!c(o.charCodeAt(E));)E++;if(E<n&&E!==r){const D=o.slice(r,E);for(r=E;E<n&&c(o.charCodeAt(E));)E++;if(E<n&&E!==r){for(r=E;E<n&&!c(o.charCodeAt(E));)E++;(E===n||E!==r)&&(h=`\\\\${D}\\${o.slice(r,E)}`,a=E)}}}else a=1;else _(w)&&o.charCodeAt(1)===i&&(h=o.slice(0,2),a=2,n>2&&c(o.charCodeAt(2))&&(d=!0,a=3));if(h.length>0)if(f.length>0){if(h.toLowerCase()!==f.toLowerCase())continue}else f=h;if(t){if(f.length>0)break}else if(p=`${o.slice(a)}\\${p}`,t=d,d&&f.length>0)break}return p=b(p,!t,"\\",c),t?`${f}\\${p}`:`${f}${p}`||"."},normalize(l){m(l,"path");const f=l.length;if(f===0)return".";let p=0,t,s=!1;const o=l.charCodeAt(0);if(f===1)return v(o)?"\\":l;if(c(o))if(s=!0,c(l.charCodeAt(1))){let a=2,h=a;for(;a<f&&!c(l.charCodeAt(a));)a++;if(a<f&&a!==h){const d=l.slice(h,a);for(h=a;a<f&&c(l.charCodeAt(a));)a++;if(a<f&&a!==h){for(h=a;a<f&&!c(l.charCodeAt(a));)a++;if(a===f)return`\\\\${d}\\${l.slice(h)}\\`;a!==h&&(t=`\\\\${d}\\${l.slice(h,a)}`,p=a)}}}else p=1;else _(o)&&l.charCodeAt(1)===i&&(t=l.slice(0,2),p=2,f>2&&c(l.charCodeAt(2))&&(s=!0,p=3));let n=p<f?b(l.slice(p),!s,"\\",c):"";return n.length===0&&!s&&(n="."),n.length>0&&c(l.charCodeAt(f-1))&&(n+="\\"),t===void 0?s?`\\${n}`:n:s?`${t}\\${n}`:`${t}${n}`},isAbsolute(l){m(l,"path");const f=l.length;if(f===0)return!1;const p=l.charCodeAt(0);return c(p)||f>2&&_(p)&&l.charCodeAt(1)===i&&c(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let f,p;for(let o=0;o<l.length;++o){const n=l[o];m(n,"path"),n.length>0&&(f===void 0?f=p=n:f+=`\\${n}`)}if(f===void 0)return".";let t=!0,s=0;if(typeof p=="string"&&c(p.charCodeAt(0))){++s;const o=p.length;o>1&&c(p.charCodeAt(1))&&(++s,o>2&&(c(p.charCodeAt(2))?++s:t=!1))}if(t){for(;s<f.length&&c(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(l,f){if(m(l,"from"),m(f,"to"),l===f)return"";const p=e.win32.resolve(l),t=e.win32.resolve(f);if(p===t||(l=p.toLowerCase(),f=t.toLowerCase(),l===f))return"";let s=0;for(;s<l.length&&l.charCodeAt(s)===A;)s++;let o=l.length;for(;o-1>s&&l.charCodeAt(o-1)===A;)o--;const n=o-s;let a=0;for(;a<f.length&&f.charCodeAt(a)===A;)a++;let h=f.length;for(;h-1>a&&f.charCodeAt(h-1)===A;)h--;const d=h-a,w=n<d?n:d;let E=-1,r=0;for(;r<w;r++){const R=l.charCodeAt(s+r);if(R!==f.charCodeAt(a+r))break;R===A&&(E=r)}if(r!==w){if(E===-1)return t}else{if(d>w){if(f.charCodeAt(a+r)===A)return t.slice(a+r+1);if(r===2)return t.slice(a+r)}n>w&&(l.charCodeAt(s+r)===A?E=r:r===2&&(E=3)),E===-1&&(E=0)}let D="";for(r=s+E+1;r<=o;++r)(r===o||l.charCodeAt(r)===A)&&(D+=D.length===0?"..":"\\..");return a+=E,D.length>0?`${D}${t.slice(a,h)}`:(t.charCodeAt(a)===A&&++a,t.slice(a,h))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const f=e.win32.resolve(l);if(f.length<=2)return l;if(f.charCodeAt(0)===A){if(f.charCodeAt(1)===A){const p=f.charCodeAt(2);if(p!==I&&p!==y)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(_(f.charCodeAt(0))&&f.charCodeAt(1)===i&&f.charCodeAt(2)===A)return`\\\\?\\${f}`;return l},dirname(l){m(l,"path");const f=l.length;if(f===0)return".";let p=-1,t=0;const s=l.charCodeAt(0);if(f===1)return c(s)?l:".";if(c(s)){if(p=t=1,c(l.charCodeAt(1))){let a=2,h=a;for(;a<f&&!c(l.charCodeAt(a));)a++;if(a<f&&a!==h){for(h=a;a<f&&c(l.charCodeAt(a));)a++;if(a<f&&a!==h){for(h=a;a<f&&!c(l.charCodeAt(a));)a++;if(a===f)return l;a!==h&&(p=t=a+1)}}}}else _(s)&&l.charCodeAt(1)===i&&(p=f>2&&c(l.charCodeAt(2))?3:2,t=p);let o=-1,n=!0;for(let a=f-1;a>=t;--a)if(c(l.charCodeAt(a))){if(!n){o=a;break}}else n=!1;if(o===-1){if(p===-1)return".";o=p}return l.slice(0,o)},basename(l,f){f!==void 0&&m(f,"ext"),m(l,"path");let p=0,t=-1,s=!0,o;if(l.length>=2&&_(l.charCodeAt(0))&&l.charCodeAt(1)===i&&(p=2),f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let n=f.length-1,a=-1;for(o=l.length-1;o>=p;--o){const h=l.charCodeAt(o);if(c(h)){if(!s){p=o+1;break}}else a===-1&&(s=!1,a=o+1),n>=0&&(h===f.charCodeAt(n)?--n==-1&&(t=o):(n=-1,t=a))}return p===t?t=a:t===-1&&(t=l.length),l.slice(p,t)}for(o=l.length-1;o>=p;--o)if(c(l.charCodeAt(o))){if(!s){p=o+1;break}}else t===-1&&(s=!1,t=o+1);return t===-1?"":l.slice(p,t)},extname(l){m(l,"path");let f=0,p=-1,t=0,s=-1,o=!0,n=0;l.length>=2&&l.charCodeAt(1)===i&&_(l.charCodeAt(0))&&(f=t=2);for(let a=l.length-1;a>=f;--a){const h=l.charCodeAt(a);if(c(h)){if(!o){t=a+1;break}continue}s===-1&&(o=!1,s=a+1),h===y?p===-1?p=a:n!==1&&(n=1):p!==-1&&(n=-1)}return p===-1||s===-1||n===0||n===1&&p===s-1&&p===t+1?"":l.slice(p,s)},format:P.bind(null,"\\"),parse(l){m(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const p=l.length;let t=0,s=l.charCodeAt(0);if(p===1)return c(s)?(f.root=f.dir=l,f):(f.base=f.name=l,f);if(c(s)){if(t=1,c(l.charCodeAt(1))){let E=2,r=E;for(;E<p&&!c(l.charCodeAt(E));)E++;if(E<p&&E!==r){for(r=E;E<p&&c(l.charCodeAt(E));)E++;if(E<p&&E!==r){for(r=E;E<p&&!c(l.charCodeAt(E));)E++;E===p?t=E:E!==r&&(t=E+1)}}}}else if(_(s)&&l.charCodeAt(1)===i){if(p<=2)return f.root=f.dir=l,f;if(t=2,c(l.charCodeAt(2))){if(p===3)return f.root=f.dir=l,f;t=3}}t>0&&(f.root=l.slice(0,t));let o=-1,n=t,a=-1,h=!0,d=l.length-1,w=0;for(;d>=t;--d){if(s=l.charCodeAt(d),c(s)){if(!h){n=d+1;break}continue}a===-1&&(h=!1,a=d+1),s===y?o===-1?o=d:w!==1&&(w=1):o!==-1&&(w=-1)}return a!==-1&&(o===-1||w===0||w===1&&o===a-1&&o===n+1?f.base=f.name=l.slice(n,a):(f.name=l.slice(n,o),f.base=l.slice(n,a),f.ext=l.slice(o,a))),n>0&&n!==t?f.dir=l.slice(0,n-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let f="",p=!1;for(let t=l.length-1;t>=-1&&!p;t--){const s=t>=0?l[t]:g.cwd();m(s,"path"),s.length!==0&&(f=`${s}/${f}`,p=s.charCodeAt(0)===S)}return f=b(f,!p,"/",v),p?`/${f}`:f.length>0?f:"."},normalize(l){if(m(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===S,p=l.charCodeAt(l.length-1)===S;return l=b(l,!f,"/",v),l.length===0?f?"/":p?"./":".":(p&&(l+="/"),f?`/${l}`:l)},isAbsolute(l){return m(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let f;for(let p=0;p<l.length;++p){const t=l[p];m(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(l,f){if(m(l,"from"),m(f,"to"),l===f||(l=e.posix.resolve(l),f=e.posix.resolve(f),l===f))return"";const p=1,t=l.length,s=t-p,o=1,n=f.length-o,a=s<n?s:n;let h=-1,d=0;for(;d<a;d++){const E=l.charCodeAt(p+d);if(E!==f.charCodeAt(o+d))break;E===S&&(h=d)}if(d===a)if(n>a){if(f.charCodeAt(o+d)===S)return f.slice(o+d+1);if(d===0)return f.slice(o+d)}else s>a&&(l.charCodeAt(p+d)===S?h=d:d===0&&(h=0));let w="";for(d=p+h+1;d<=t;++d)(d===t||l.charCodeAt(d)===S)&&(w+=w.length===0?"..":"/..");return`${w}${f.slice(o+h)}`},toNamespacedPath(l){return l},dirname(l){if(m(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===S;let p=-1,t=!0;for(let s=l.length-1;s>=1;--s)if(l.charCodeAt(s)===S){if(!t){p=s;break}}else t=!1;return p===-1?f?"/":".":f&&p===1?"//":l.slice(0,p)},basename(l,f){f!==void 0&&m(f,"ext"),m(l,"path");let p=0,t=-1,s=!0,o;if(f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let n=f.length-1,a=-1;for(o=l.length-1;o>=0;--o){const h=l.charCodeAt(o);if(h===S){if(!s){p=o+1;break}}else a===-1&&(s=!1,a=o+1),n>=0&&(h===f.charCodeAt(n)?--n==-1&&(t=o):(n=-1,t=a))}return p===t?t=a:t===-1&&(t=l.length),l.slice(p,t)}for(o=l.length-1;o>=0;--o)if(l.charCodeAt(o)===S){if(!s){p=o+1;break}}else t===-1&&(s=!1,t=o+1);return t===-1?"":l.slice(p,t)},extname(l){m(l,"path");let f=-1,p=0,t=-1,s=!0,o=0;for(let n=l.length-1;n>=0;--n){const a=l.charCodeAt(n);if(a===S){if(!s){p=n+1;break}continue}t===-1&&(s=!1,t=n+1),a===y?f===-1?f=n:o!==1&&(o=1):f!==-1&&(o=-1)}return f===-1||t===-1||o===0||o===1&&f===t-1&&f===p+1?"":l.slice(f,t)},format:P.bind(null,"/"),parse(l){m(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const p=l.charCodeAt(0)===S;let t;p?(f.root="/",t=1):t=0;let s=-1,o=0,n=-1,a=!0,h=l.length-1,d=0;for(;h>=t;--h){const w=l.charCodeAt(h);if(w===S){if(!a){o=h+1;break}continue}n===-1&&(a=!1,n=h+1),w===y?s===-1?s=h:d!==1&&(d=1):s!==-1&&(d=-1)}if(n!==-1){const w=o===0&&p?1:o;s===-1||d===0||d===1&&s===n-1&&s===o+1?f.base=f.name=l.slice(w,n):(f.name=l.slice(w,s),f.base=l.slice(w,n),f.ext=l.slice(s,n))}return o>0?f.dir=l.slice(0,o-1):p&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[140],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(k,...T){const y=T.reduce((i,I)=>(i[I]=!0,i),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(i=>!y[i]).forEach(i=>{for(let I=0;I<S.length;I++)if(i.search(S[I])!==-1){delete k[i];break}})}e.sanitizeProcessEnvironment=C}),define(ve[46],we([0,1,11]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class C{constructor(T){this._highResolution=L&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new C(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ve[3],we([0,1,16,73,6,94,46]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(l){l.None=()=>C.Disposable.None;function f(Q){return(N,U=null,F)=>{let V=!1,M;return M=Q(O=>{if(!V)return M?M.dispose():V=!0,N.call(U,O)},null,F),V&&M.dispose(),M}}l.once=f;function p(Q,N){return h((U,F=null,V)=>Q(M=>U.call(F,N(M)),null,V))}l.map=p;function t(Q,N){return h((U,F=null,V)=>Q(M=>{N(M),U.call(F,M)},null,V))}l.forEach=t;function s(Q,N){return h((U,F=null,V)=>Q(M=>N(M)&&U.call(F,M),null,V))}l.filter=s;function o(Q){return Q}l.signal=o;function n(...Q){return(N,U=null,F)=>(0,C.combinedDisposable)(...Q.map(V=>V(M=>N.call(U,M),null,F)))}l.any=n;function a(Q,N,U){let F=U;return p(Q,V=>(F=N(F,V),F))}l.reduce=a;function h(Q){let N;const U=new u({onFirstListenerAdd(){N=Q(U.fire,U)},onLastListenerRemove(){N.dispose()}});return U.event}function d(Q,N,U=100,F=!1,V){let M,O,q,B=0;const K=new u({leakWarningThreshold:V,onFirstListenerAdd(){M=Q(ne=>{B++,O=N(O,ne),F&&!q&&(K.fire(O),O=void 0),clearTimeout(q),q=setTimeout(()=>{const me=O;O=void 0,q=void 0,(!F||B>1)&&K.fire(me),B=0},U)})},onLastListenerRemove(){M.dispose()}});return K.event}l.debounce=d;function w(Q,N=(U,F)=>U===F){let U=!0,F;return s(Q,V=>{const M=U||!N(V,F);return U=!1,F=V,M})}l.latch=w;function E(Q,N){return[l.filter(Q,N),l.filter(Q,U=>!N(U))]}l.split=E;function r(Q,N=!1,U=[]){let F=U.slice(),V=Q(q=>{F?F.push(q):O.fire(q)});const M=()=>{F&&F.forEach(q=>O.fire(q)),F=null},O=new u({onFirstListenerAdd(){V||(V=Q(q=>O.fire(q)))},onFirstListenerDidAdd(){F&&(N?setTimeout(M):M())},onLastListenerRemove(){V&&V.dispose(),V=null}});return O.event}l.buffer=r;class D{constructor(N){this.event=N}map(N){return new D(p(this.event,N))}forEach(N){return new D(t(this.event,N))}filter(N){return new D(s(this.event,N))}reduce(N,U){return new D(a(this.event,N,U))}latch(){return new D(w(this.event))}debounce(N,U=100,F=!1,V){return new D(d(this.event,N,U,F,V))}on(N,U,F){return this.event(N,U,F)}once(N,U,F){return f(this.event)(N,U,F)}}function R(Q){return new D(Q)}l.chain=R;function x(Q,N,U=F=>F){const F=(...q)=>O.fire(U(...q)),V=()=>Q.on(N,F),M=()=>Q.removeListener(N,F),O=new u({onFirstListenerAdd:V,onLastListenerRemove:M});return O.event}l.fromNodeEventEmitter=x;function j(Q,N,U=F=>F){const F=(...q)=>O.fire(U(...q)),V=()=>Q.addEventListener(N,F),M=()=>Q.removeEventListener(N,F),O=new u({onFirstListenerAdd:V,onLastListenerRemove:M});return O.event}l.fromDOMEventEmitter=j;function te(Q){return new Promise(N=>f(Q)(N))}l.toPromise=te})(y=e.Event||(e.Event={}));class S{constructor(f){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${f}_${S._idPool++}`}start(f){this._stopWatch=new T.StopWatch(!0),this._listenerCount=f}stop(){if(this._stopWatch){const f=this._stopWatch.elapsed();this._elapsedOverall+=f,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${f.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let A=-1;function i(l){const f=A;return A=l,{dispose(){A=f}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(f,p=Math.random().toString(18).slice(2,5)){this.customThreshold=f,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(f){let p=A;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||f<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let o,n=0;for(const[a,h]of this._stacks)(!o||n<h)&&(o=a,n=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${n}):`),console.warn(o)}return()=>{const o=this._stacks.get(t)||0;this._stacks.set(t,o-1)}}}class u{constructor(f){this._disposed=!1,this._options=f,this._leakageMon=A>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(f,p,t)=>{this._listeners||(this._listeners=new k.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(p?[f,p]:f);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,f,p);const n=this._leakageMon?.check(this._listeners.size),a=(0,C.toDisposable)(()=>{n&&n(),this._disposed||(o(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof C.DisposableStore?t.add(a):Array.isArray(t)&&t.push(a),a}),this._event}fire(f){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,f]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(s){(0,g.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class m extends u{async fireAsync(f,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,f]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[s,o]=this._asyncDeliveryQueue.shift(),n=[],a={...o,waitUntil:h=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");t&&(h=t(h,typeof s=="function"?s:s[0])),n.push(h)}};try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(h){(0,g.onUnexpectedError)(h);continue}Object.freeze(n),await Promise.allSettled(n).then(h=>{for(const d of h)d.status==="rejected"&&(0,g.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=m;class c extends u{constructor(f){super(f);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=f?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const f=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(f))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(f){this._listeners&&(this._isPaused!==0?this._eventQueue.push(f):super.fire(f))}}e.PauseableEmitter=c;class v extends c{constructor(f){super(f);this._delay=f.delay??100}fire(f){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(f)}}e.DebounceEmitter=v;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(f){const p={event:f,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const s=this.events.indexOf(p);this.events.splice(s,1)};return(0,C.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(f=>this.hook(f))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(f=>this.unhook(f))}hook(f){f.listener=f.event(p=>this.emitter.fire(p))}unhook(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=_;class b{constructor(){this.buffers=[]}wrapEvent(f){return(p,t,s)=>f(o=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>p.call(t,o)):p.call(t,o)},void 0,s)}bufferEvents(f){const p=[];this.buffers.push(p);const t=f();return this.buffers.pop(),p.forEach(s=>s()),t}}e.EventBufferer=b;class P{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=C.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(f){this.inputEvent=f,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=f(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(ve[21],we([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(y,S){const A=setTimeout(y.bind(S),0);return{dispose(){clearTimeout(A)}}});var C;(function(y){function S(A){return A===y.None||A===y.Cancelled||A instanceof k?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}y.isCancellationToken=S,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(C=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=C.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=T}),define(ve[47],we([0,1,3]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const u=this._icons.get(I.id);u?I.description?u.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new L;e.iconRegistry=C;function k(i,I){return new y(i,I)}e.registerCodicon=k;function T(i){return i?i.replace(/\$\((.*?)\)/g,(I,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=T;class y{constructor(I,u,m){this.id=I,this.definition=u,this.description=m,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function S(i,I){const u=["codicon","codicon-"+i];return I&&u.push("codicon-modifier-"+I),u}e.getClassNamesArray=S;var A;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function u(v){if(v instanceof y)return["codicon","codicon-"+v.id];const _=I.exec(v.id);if(!_)return u(y.error);let[,b,P]=_;const l=["codicon","codicon-"+b];return P&&l.push("codicon-modifier-"+P.substr(1)),l}i.asClassNameArray=u;function m(v){return u(v).join(" ")}i.asClassName=m;function c(v){return"."+u(v).join(".")}i.asCSSSelector=c})(A=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(ve[95],we([0,1,16,6]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=C;function k(l){const f=l;return f?C(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=k;function T(l,f){return new y(l,f)}e.newWriteableStream=T;class y{constructor(f,p){this.reducer=f,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(p=>p(f))}emitError(f){this.listeners.error.length===0?(0,g.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(p=>p(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,p){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(f,p){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(p);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,f){const p=[];let t;for(;(t=l.read())!==null;)p.push(t);return f(p)}e.consumeReadable=S;function A(l,f,p){const t=[];let s;for(;(s=l.read())!==null&&t.length<p;)t.push(s);return s===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const o=s;return s=void 0,o}return l.read()}}}e.peekReadable=A;function i(l,f){return new Promise((p,t)=>{const s=[];I(l,{onData:o=>{f&&s.push(o)},onError:o=>{f?t(o):p(void 0)},onEnd:()=>{p(f?f(s):void 0)}})})}e.consumeStream=i;function I(l,f){l.on("error",p=>f.onError(p)),l.on("end",()=>f.onEnd()),l.on("data",p=>f.onData(p))}e.listenStream=I;function u(l,f){return new Promise((p,t)=>{const s=new L.DisposableStore,o=[],n=d=>{if(o.push(d),o.length>f)return s.dispose(),l.pause(),p({stream:l,buffer:o,ended:!1})},a=d=>t(d),h=()=>p({stream:l,buffer:o,ended:!0});s.add((0,L.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),s.add((0,L.toDisposable)(()=>l.removeListener("end",h))),l.on("end",h),s.add((0,L.toDisposable)(()=>l.removeListener("data",n))),l.on("data",n)})}e.peekStream=u;function m(l,f){const p=T(f);return p.end(l),p}e.toStream=m;function c(){const l=T(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=c;function v(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=v;function _(l,f,p){const t=T(p);return I(l,{onData:s=>t.write(f.data(s)),onError:s=>t.error(f.error?f.error(s):s),onEnd:()=>t.end()}),t}e.transform=_;function b(l,f,p){let t=!1;return{read:()=>{const s=f.read();return t?s:(t=!0,s!==null?p([l,s]):l)}}}e.prefixedReadable=b;function P(l,f,p){let t=!1;const s=T(p);return I(f,{onData:o=>t?s.write(o):(t=!0,s.write(p([l,o]))),onError:o=>s.error(o),onEnd:()=>{t||(t=!0,s.write(l)),s.end()}}),s}e.prefixedStream=P}),define(ve[24],we([0,1,95]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let C,k;class T{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return L?new T(Buffer.allocUnsafe(n)):new T(new Uint8Array(n))}static wrap(n){return L&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new T(n)}static fromString(n,a){return!(a?.dontUseNodeBuffer||!1)&&L?new T(Buffer.from(n)):(C||(C=new TextEncoder),new T(C.encode(n)))}static concat(n,a){if(typeof a=="undefined"){a=0;for(let w=0,E=n.length;w<E;w++)a+=n[w].byteLength}const h=T.alloc(a);let d=0;for(let w=0,E=n.length;w<E;w++){const r=n[w];h.set(r,d),d+=r.byteLength}return h}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(n,a){return new T(this.buffer.subarray(n,a))}set(n,a){n instanceof T?this.buffer.set(n.buffer,a):this.buffer.set(n,a)}readUInt32BE(n){return A(this.buffer,n)}writeUInt32BE(n,a){i(this.buffer,n,a)}readUInt32LE(n){return I(this.buffer,n)}writeUInt32LE(n,a){u(this.buffer,n,a)}readUInt8(n){return m(this.buffer,n)}writeUInt8(n,a){c(this.buffer,n,a)}}e.VSBuffer=T;function y(o,n){return o[n+0]<<0>>>0|o[n+1]<<8>>>0}e.readUInt16LE=y;function S(o,n,a){o[a+0]=n&255,n=n>>>8,o[a+1]=n&255}e.writeUInt16LE=S;function A(o,n){return o[n]*2**24+o[n+1]*2**16+o[n+2]*2**8+o[n+3]}e.readUInt32BE=A;function i(o,n,a){o[a+3]=n,n=n>>>8,o[a+2]=n,n=n>>>8,o[a+1]=n,n=n>>>8,o[a]=n}e.writeUInt32BE=i;function I(o,n){return o[n+0]<<0>>>0|o[n+1]<<8>>>0|o[n+2]<<16>>>0|o[n+3]<<24>>>0}e.readUInt32LE=I;function u(o,n,a){o[a+0]=n&255,n=n>>>8,o[a+1]=n&255,n=n>>>8,o[a+2]=n&255,n=n>>>8,o[a+3]=n&255}e.writeUInt32LE=u;function m(o,n){return o[n]}e.readUInt8=m;function c(o,n,a){o[a]=n}e.writeUInt8=c;function v(o){return g.consumeReadable(o,n=>T.concat(n))}e.readableToBuffer=v;function _(o){return g.toReadable(o)}e.bufferToReadable=_;function b(o){return g.consumeStream(o,n=>T.concat(n))}e.streamToBuffer=b;async function P(o){return o.ended?T.concat(o.buffer):T.concat([...o.buffer,await b(o.stream)])}e.bufferedStreamToBuffer=P;function l(o){return g.toStream(o,n=>T.concat(n))}e.bufferToStream=l;function f(o){return g.transform(o,{data:n=>typeof n=="string"?T.fromString(n):T.wrap(n)},n=>T.concat(n))}e.streamToBufferReadableStream=f;function p(o){return g.newWriteableStream(n=>T.concat(n),o)}e.newWriteableBufferStream=p;function t(o,n){return g.prefixedReadable(o,n,a=>T.concat(a))}e.prefixedBufferReadable=t;function s(o,n){return g.prefixedStream(o,n,a=>T.concat(a))}e.prefixedBufferStream=s}),define(ve[9],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function C(H,...ee){return ee.length===0?H:H.replace(L,function(ue,Le){const Re=parseInt(Le,10);return isNaN(Re)||Re<0||Re>=ee.length?ue:ee[Re]})}e.format=C;const k=/{([^}]+)}/g;function T(H,ee){return H.replace(k,(ue,Le)=>ee[Le]??ue)}e.format2=T;function y(H){return H.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=y;function S(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function A(H,ee){let ue=0;const Le=ee.charCodeAt(0);for(let Re=H.length-1;Re>=0;Re--)H.charCodeAt(Re)===Le&&ue++;return ue}e.count=A;function i(H,ee,ue="\u2026"){return H.length<=ee?H:`${H.substr(0,ee)}${ue}`}e.truncate=i;function I(H,ee=" "){const ue=u(H,ee);return m(ue,ee)}e.trim=I;function u(H,ee){if(!H||!ee)return H;const ue=ee.length;if(ue===0||H.length===0)return H;let Le=0;for(;H.indexOf(ee,Le)===Le;)Le=Le+ue;return H.substring(Le)}e.ltrim=u;function m(H,ee){if(!H||!ee)return H;const ue=ee.length,Le=H.length;if(ue===0||Le===0)return H;let Re=Le,ze=-1;for(;ze=H.lastIndexOf(ee,Re-1),!(ze===-1||ze+ue!==Re);){if(ze===0)return"";Re=ze}return H.substring(0,Re)}e.rtrim=m;function c(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function v(H){return H.replace(/\*/g,"")}e.stripWildcards=v;function _(H,ee,ue={}){if(!H)throw new Error("Cannot create regex from empty string");ee||(H=S(H)),ue.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Le="";return ue.global&&(Le+="g"),ue.matchCase||(Le+="i"),ue.multiline&&(Le+="m"),ue.unicode&&(Le+="u"),new RegExp(H,Le)}e.createRegExp=_;function b(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function P(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function l(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=l;function f(H){return H.split(/\r\n|\r|\n/)}e.splitLines=f;function p(H){for(let ee=0,ue=H.length;ee<ue;ee++){const Le=H.charCodeAt(ee);if(Le!==32&&Le!==9)return ee}return-1}e.firstNonWhitespaceIndex=p;function t(H,ee=0,ue=H.length){for(let Le=ee;Le<ue;Le++){const Re=H.charCodeAt(Le);if(Re!==32&&Re!==9)return H.substring(ee,Le)}return H.substring(ee,ue)}e.getLeadingWhitespace=t;function s(H,ee=H.length-1){for(let ue=ee;ue>=0;ue--){const Le=H.charCodeAt(ue);if(Le!==32&&Le!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function o(H,ee){return H<ee?-1:H>ee?1:0}e.compare=o;function n(H,ee,ue=0,Le=H.length,Re=0,ze=ee.length){for(;ue<Le&&Re<ze;ue++,Re++){let it=H.charCodeAt(ue),Ye=ee.charCodeAt(Re);if(it<Ye)return-1;if(it>Ye)return 1}const Ge=Le-ue,et=ze-Re;return Ge<et?-1:Ge>et?1:0}e.compareSubstring=n;function a(H,ee){return h(H,ee,0,H.length,0,ee.length)}e.compareIgnoreCase=a;function h(H,ee,ue=0,Le=H.length,Re=0,ze=ee.length){for(;ue<Le&&Re<ze;ue++,Re++){let it=H.charCodeAt(ue),Ye=ee.charCodeAt(Re);if(it===Ye)continue;const Xe=it-Ye;if(!(Xe===32&&w(Ye))&&!(Xe===-32&&w(it)))return d(it)&&d(Ye)?Xe:n(H.toLowerCase(),ee.toLowerCase(),ue,Le,Re,ze)}const Ge=Le-ue,et=ze-Re;return Ge<et?-1:Ge>et?1:0}e.compareSubstringIgnoreCase=h;function d(H){return H>=97&&H<=122}e.isLowerAsciiLetter=d;function w(H){return H>=65&&H<=90}e.isUpperAsciiLetter=w;function E(H){return d(H)||w(H)}function r(H,ee){return H.length===ee.length&&D(H,ee)}e.equalsIgnoreCase=r;function D(H,ee,ue=H.length){for(let Le=0;Le<ue;Le++){const Re=H.charCodeAt(Le),ze=ee.charCodeAt(Le);if(Re!==ze){if(E(Re)&&E(ze)){const Ge=Math.abs(Re-ze);if(Ge!==0&&Ge!==32)return!1}else if(String.fromCharCode(Re).toLowerCase()!==String.fromCharCode(ze).toLowerCase())return!1}}return!0}function R(H,ee){const ue=ee.length;return ee.length>H.length?!1:D(H,ee,ue)}e.startsWithIgnoreCase=R;function x(H,ee){let ue,Le=Math.min(H.length,ee.length);for(ue=0;ue<Le;ue++)if(H.charCodeAt(ue)!==ee.charCodeAt(ue))return ue;return Le}e.commonPrefixLength=x;function j(H,ee){let ue,Le=Math.min(H.length,ee.length);const Re=H.length-1,ze=ee.length-1;for(ue=0;ue<Le;ue++)if(H.charCodeAt(Re-ue)!==ee.charCodeAt(ze-ue))return ue;return Le}e.commonSuffixLength=j;function te(H){return 55296<=H&&H<=56319}e.isHighSurrogate=te;function Q(H){return 56320<=H&&H<=57343}e.isLowSurrogate=Q;function N(H,ee){return(H-55296<<10)+(ee-56320)+65536}e.computeCodePoint=N;function U(H,ee,ue){const Le=H.charCodeAt(ue);if(te(Le)&&ue+1<ee){const Re=H.charCodeAt(ue+1);if(Q(Re))return N(Le,Re)}return Le}e.getNextCodePoint=U;function F(H,ee){const ue=H.charCodeAt(ee-1);if(Q(ue)&&ee>1){const Le=H.charCodeAt(ee-2);if(te(Le))return N(Le,ue)}return ue}function V(H,ee){const ue=Ne.getInstance(),Le=ee,Re=H.length,ze=U(H,Re,ee);ee+=ze>=65536?2:1;let Ge=ue.getGraphemeBreakType(ze);for(;ee<Re;){const et=U(H,Re,ee),it=ue.getGraphemeBreakType(et);if(pe(Ge,it))break;ee+=et>=65536?2:1,Ge=it}return ee-Le}e.nextCharLength=V;function M(H,ee){const ue=Ne.getInstance(),Le=ee,Re=F(H,ee);ee-=Re>=65536?2:1;let ze=ue.getGraphemeBreakType(Re);for(;ee>0;){const Ge=F(H,ee),et=ue.getGraphemeBreakType(Ge);if(pe(et,ze))break;ee-=Ge>=65536?2:1,ze=et}return Le-ee}e.prevCharLength=M;function O(H,ee){const ue=Ne.getInstance(),Le=H.length,Re=ee,ze=U(H,Le,ee),Ge=ue.getGraphemeBreakType(ze);ee+=ze>=65536?2:1;let et=Ge;for(;ee<Le;){const Ye=U(H,Le,ee),Xe=ue.getGraphemeBreakType(Ye);if(pe(et,Xe))break;ee+=Ye>=65536?2:1,et=Xe}const it=ee;for(ee=Re,et=Ge;ee>0;){const Ye=F(H,ee),Xe=ue.getGraphemeBreakType(Ye);if(pe(Xe,et))break;ee-=Ye>=65536?2:1,et=Xe}return[ee,it]}function q(H,ee){return ee>0&&Q(H.charCodeAt(ee))?O(H,ee-1):O(H,ee)}e.getCharContainingOffset=q;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(H){return B.test(H)}e.containsRTL=K;const ne=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function me(H){return ne.test(H)}e.containsEmoji=me;const Se=/^[\t\n\r\x20-\x7E]*$/;function Ce(H){return Se.test(H)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Te(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Te;function je(H){for(let ee=0,ue=H.length;ee<ue;ee++)if(Be(H.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=je;function Be(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=Be;function Ve(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=Ve;function W(H,ee){if(H.length<ee)return H;const ue=/\b/g;let Le=0;for(;ue.test(H)&&!(H.length-ue.lastIndex<ee);)Le=ue.lastIndex,ue.lastIndex+=1;return H.substring(Le).replace(/^\s/,"")}e.lcut=W;const Z=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function Y(H){return H&&(H=H.replace(Z,""),H=H.replace(ie,""),H=H.replace(le,"")),H}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ae;function be(H){return ae(H)?H.substr(1):H}e.stripUTF8BOM=be;function Fe(H,ee){if(!H||!ee||H.length<ee.length)return!1;const ue=ee.length,Le=H.toLowerCase();let Re=0,ze=-1;for(;Re<ue;){const Ge=Le.indexOf(ee[Re],ze+1);if(Ge<0)return!1;ze=Ge,Re++}return!0}e.fuzzyContains=Fe;function He(H,ee=!1){return H?(ee&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=He;function Ee(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Ee;function Qe(H,ee=1){if(ee===0)return"";let ue=-1;do ue=H.indexOf(`
`,ue+1),ee--;while(ee>0&&ue>=0);return ue===-1?H:(H[ue-1]==="\r"&&ue--,H.substr(0,ue))}e.getNLines=Qe;function X(H){const ee=90-65+1;return H=H%(2*ee),H<ee?String.fromCharCode(97+H):String.fromCharCode(65+H-ee)}e.singleLetterHash=X;function se(H){return Ne.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=se;function pe(H,ee){return H===0?ee!==5&&ee!==7:H===2&&ee===3?!1:H===4||H===2||H===3||ee===4||ee===2||ee===3?!0:!(H===8&&(ee===8||ee===9||ee===11||ee===12)||(H===11||H===9)&&(ee===9||ee===10)||(H===12||H===10)&&ee===10||ee===5||ee===13||ee===7||H===1||H===13&&ee===14||H===6&&ee===6)}e.breakBetweenGraphemeBreakType=pe;var Ue;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(Ue=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Je()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const ue=this._data,Le=ue.length/3;let Re=1;for(;Re<=Le;)if(ee<ue[3*Re])Re=2*Re;else if(ee>ue[3*Re+1])Re=2*Re+1;else return ue[3*Re+2];return 0}}Ne._INSTANCE=null;function Je(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ke(H,ee){if(H===0)return 0;const ue=ye(H,ee);if(ue!==void 0)return ue;const Le=F(ee,H);return H-=Ie(Le),H}e.getLeftDeleteOffset=ke;function ye(H,ee){let ue=F(ee,H);for(H-=Ie(ue);ce(ue)||ue===65039||ue===8419;){if(H===0)return;ue=F(ee,H),H-=Ie(ue)}if(!!Ve(ue)){if(H>=0){const Le=F(ee,H);Le===8205&&(H-=Ie(Le))}return H}}function Ie(H){return H>=65536?2:1}function ce(H){return 127995<=H&&H<=127999}var de;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(de||(de={}))}),define(ve[58],we([0,1,9]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(b){return C(b,0)}e.hash=L;function C(b,P){switch(typeof b){case"object":return b===null?k(349,P):Array.isArray(b)?S(b,P):A(b,P);case"string":return y(b,P);case"boolean":return T(b,P);case"number":return k(b,P);case"undefined":return k(937,P);default:return k(617,P)}}e.doHash=C;function k(b,P){return(P<<5)-P+b|0}function T(b,P){return k(b?433:863,P)}function y(b,P){P=k(149417,P);for(let l=0,f=b.length;l<f;l++)P=k(b.charCodeAt(l),P);return P}e.stringHash=y;function S(b,P){return P=k(104579,P),b.reduce((l,f)=>C(f,l),P)}function A(b,P){return P=k(181387,P),Object.keys(b).sort().reduce((l,f)=>(l=y(f,l),C(b[f],l)),P)}class i{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=C(P,this._value),this._value}}e.Hasher=i;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function u(b,P,l=32){const f=l-P,p=~((1<<f)-1);return(b<<P|(p&b)>>>f)>>>0}function m(b,P=0,l=b.byteLength,f=0){for(let p=0;p<l;p++)b[P+p]=f}function c(b,P,l="0"){for(;b.length<P;)b=l+b;return b}function v(b,P=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(l=>l.toString(16).padStart(2,"0")).join(""):c((b>>>0).toString(16),P/4)}e.toHexString=v;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const l=P.length;if(l===0)return;const f=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,s,o;for(t!==0?(s=t,o=-1,t=0):(s=P.charCodeAt(0),o=0);;){let n=s;if(g.isHighSurrogate(s))if(o+1<l){const a=P.charCodeAt(o+1);g.isLowSurrogate(a)?(o++,n=g.computeCodePoint(s,a)):n=65533}else{t=s;break}else g.isLowSurrogate(s)&&(n=65533);if(p=this._push(f,p,n),o++,o<l)s=P.charCodeAt(o);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(P,l,f){return f<128?P[l++]=f:f<2048?(P[l++]=192|(f&1984)>>>6,P[l++]=128|(f&63)>>>0):f<65536?(P[l++]=224|(f&61440)>>>12,P[l++]=128|(f&4032)>>>6,P[l++]=128|(f&63)>>>0):(P[l++]=240|(f&1835008)>>>18,P[l++]=128|(f&258048)>>>12,P[l++]=128|(f&4032)>>>6,P[l++]=128|(f&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=_._bigBlock32,l=this._buffDV;for(let d=0;d<64;d+=4)P.setUint32(d,l.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)P.setUint32(d,u(P.getUint32(d-12,!1)^P.getUint32(d-32,!1)^P.getUint32(d-56,!1)^P.getUint32(d-64,!1),1),!1);let f=this._h0,p=this._h1,t=this._h2,s=this._h3,o=this._h4,n,a,h;for(let d=0;d<80;d++)d<20?(n=p&t|~p&s,a=1518500249):d<40?(n=p^t^s,a=1859775393):d<60?(n=p&t|p&s|t&s,a=2400959708):(n=p^t^s,a=3395469782),h=u(f,5)+n+o+a+P.getUint32(d*4,!1)&4294967295,o=s,s=t,t=u(p,30),p=f,f=h;this._h0=this._h0+f&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[48],we([0,1,9]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(L||(L={})),function(C){const k="error",T="warning",y="warn",S="info",A="ignore";function i(u){return u?g.equalsIgnoreCase(k,u)?C.Error:g.equalsIgnoreCase(T,u)||g.equalsIgnoreCase(y,u)?C.Warning:g.equalsIgnoreCase(S,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function I(u){switch(u){case C.Error:return k;case C.Warning:return T;case C.Info:return S;default:return A}}C.toString=I}(L||(L={})),e.default=L}),define(ve[14],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(d){return Array.isArray(d)}e.isArray=g;function L(d){return typeof d=="string"}e.isString=L;function C(d){return Array.isArray(d)&&d.every(w=>L(w))}e.isStringArray=C;function k(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=k;function T(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=T;function y(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=y;function S(d){return d===!0||d===!1}e.isBoolean=S;function A(d){return typeof d=="undefined"}e.isUndefined=A;function i(d){return!I(d)}e.isDefined=i;function I(d){return A(d)||d===null}e.isUndefinedOrNull=I;function u(d,w){if(!d)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=u;function m(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=m;function c(...d){const w=[];for(let E=0;E<d.length;E++){const r=d[E];if(I(r))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);w.push(r)}return w}e.assertAllDefined=c;const v=Object.prototype.hasOwnProperty;function _(d){if(!k(d))return!1;for(let w in d)if(v.call(d,w))return!1;return!0}e.isEmptyObject=_;function b(d){return typeof d=="function"}e.isFunction=b;function P(...d){return d.length>0&&d.every(b)}e.areFunctions=P;function l(d,w){const E=Math.min(d.length,w.length);for(let r=0;r<E;r++)f(d[r],w[r])}e.validateConstraints=l;function f(d,w){if(L(w)){if(typeof d!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(b(w)){try{if(d instanceof w)return}catch{}if(!I(d)&&d.constructor===w||w.length===1&&w.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function p(d){let w=[],E=Object.getPrototypeOf(d);for(;Object.prototype!==E;)w=w.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return w}e.getAllPropertyNames=p;function t(d){const w=[];for(const E of p(d))typeof d[E]=="function"&&w.push(E);return w}e.getAllMethodNames=t;function s(d,w){const E=D=>function(){const R=Array.prototype.slice.call(arguments,0);return w(D,R)};let r={};for(const D of d)r[D]=E(D);return r}e.createProxyObject=s;function o(d){return d===null?void 0:d}e.withNullAsUndefined=o;function n(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=n;function a(d){return class{constructor(){return new Proxy({},{get(w,E){if(w[E])return w[E];throw new Error(`Not Implemented: ${d}->${String(E)}`)}})}}}e.NotImplementedProxy=a;function h(d,w="Unreachable"){throw new Error(w)}e.assertNever=h}),define(ve[29],we([0,1,8,11,9,14]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function y(o){return o.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=y;function S(o){return o.indexOf("/")===-1&&(o=y(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=S;function A(o,n=g.posix.sep){if(!o)return"";const a=o.length,h=o.charCodeAt(0);if(T(h)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let w=3;const E=w;for(;w<a&&!T(o.charCodeAt(w));w++);if(E!==w&&!T(o.charCodeAt(w+1))){for(w+=1;w<a;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1).replace(/[\\/]/g,n)}}return n}else if(b(h)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+n:o.slice(0,2);let d=o.indexOf("://");if(d!==-1){for(d+=3;d<a;d++)if(T(o.charCodeAt(d)))return o.slice(0,d+1)}return""}e.getRoot=A;function i(o){if(!L.isWindows||!o||o.length<5)return!1;let n=o.charCodeAt(0);if(n!==92||(n=o.charCodeAt(1),n!==92))return!1;let a=2;const h=a;for(;a<o.length&&(n=o.charCodeAt(a),n!==92);a++);return!(h===a||(n=o.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(o,n=L.isWindows){const a=n?I:u;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||n&&m.test(o)||o==="."||o===".."||n&&o[o.length-1]==="."||n&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=c;function v(o,n,a){const h=o===n;return!a||h?h:!o||!n?!1:(0,C.equalsIgnoreCase)(o,n)}e.isEqual=v;function _(o,n,a,h=g.sep){if(o===n)return!0;if(!o||!n||n.length>o.length)return!1;if(a){if(!(0,C.startsWithIgnoreCase)(o,n))return!1;if(n.length===o.length)return!0;let w=n.length;return n.charAt(n.length-1)===h&&w--,o.charAt(w)===h}return n.charAt(n.length-1)!==h&&(n+=h),o.indexOf(n)===0}e.isEqualOrParent=_;function b(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=b;function P(o,n){return L.isWindows&&o.endsWith(":")&&(o+=g.sep),(0,g.isAbsolute)(o)||(o=(0,g.join)(n,o)),o=(0,g.normalize)(o),L.isWindows?(o=(0,C.rtrim)(o,g.sep),o.endsWith(":")&&(o+=g.sep)):(o=(0,C.rtrim)(o,g.sep),o||(o=g.sep)),o}e.sanitizeFilePath=P;function l(o){const n=(0,g.normalize)(o);return L.isWindows?o.length>3?!1:f(n)&&(o.length===2||n.charCodeAt(2)===92):n===g.posix.sep}e.isRootOrDriveLetter=l;function f(o){return L.isWindows?b(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function p(o){return f(o)?o[0]:void 0}e.getDriveLetter=p;function t(o,n,a){return n.length>o.length?-1:o===n?0:(a&&(o=o.toLowerCase(),n=n.toLowerCase()),o.indexOf(n))}e.indexOfPath=t;function s(o){const n=o.split(":");let a,h,d;if(n.forEach(w=>{const E=Number(w);(0,k.isNumber)(E)?h===void 0?h=E:d===void 0&&(d=E):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:d!==void 0?d:h!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(ve[25],we([0,1,14]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const _=Array.isArray(v)?[]:{};return Object.keys(v).forEach(b=>{v[b]&&typeof v[b]=="object"?_[b]=L(v[b]):_[b]=v[b]}),_}e.deepClone=L;function C(v){if(!v||typeof v!="object")return v;const _=[v];for(;_.length>0;){const b=_.shift();Object.freeze(b);for(const P in b)if(k.call(b,P)){const l=b[P];typeof l=="object"&&!Object.isFrozen(l)&&_.push(l)}}return v}e.deepFreeze=C;const k=Object.prototype.hasOwnProperty;function T(v,_){return y(v,_,new Set)}e.cloneAndChange=T;function y(v,_,b){if((0,g.isUndefinedOrNull)(v))return v;const P=_(v);if(typeof P!="undefined")return P;if((0,g.isArray)(v)){const l=[];for(const f of v)l.push(y(f,_,b));return l}if((0,g.isObject)(v)){if(b.has(v))throw new Error("Cannot clone recursive data-structure");b.add(v);const l={};for(let f in v)k.call(v,f)&&(l[f]=y(v[f],_,b));return b.delete(v),l}return v}function S(v,_,b=!0){return(0,g.isObject)(v)?((0,g.isObject)(_)&&Object.keys(_).forEach(P=>{P in v?b&&((0,g.isObject)(v[P])&&(0,g.isObject)(_[P])?S(v[P],_[P],b):v[P]=_[P]):v[P]=_[P]}),v):_}e.mixin=S;function A(v,_){if(v===_)return!0;if(v==null||_===null||_===void 0||typeof v!=typeof _||typeof v!="object"||Array.isArray(v)!==Array.isArray(_))return!1;let b,P;if(Array.isArray(v)){if(v.length!==_.length)return!1;for(b=0;b<v.length;b++)if(!A(v[b],_[b]))return!1}else{const l=[];for(P in v)l.push(P);l.sort();const f=[];for(P in _)f.push(P);if(f.sort(),!A(l,f))return!1;for(b=0;b<l.length;b++)if(!A(v[l[b]],_[l[b]]))return!1}return!0}e.equals=A;function i(v){const _=new Set;return JSON.stringify(v,(b,P)=>{if((0,g.isObject)(P)||Array.isArray(P)){if(_.has(P))return"[Circular]";_.add(P)}return P})}e.safeStringify=i;function I(v,_,b){const P=_(v);return typeof P=="undefined"?b:P}e.getOrDefault=I;function u(v,_){const b=Object.create(null);return!v||!_||Object.keys(_).forEach(l=>{const f=v[l],p=_[l];A(f,p)||(b[l]=p)}),b}e.distinct=u;function m(v,_){const b=_.toLowerCase(),P=Object.keys(v).find(l=>l.toLowerCase()===b);return P?v[P]:v[_]}e.getCaseInsensitive=m;function c(v,_){const b=Object.create(null);for(const P of Object.keys(v))_(P,v[P])&&(b[P]=v[P]);return b}e.filter=c}),define(ve[96],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(k){return k<0?0:k>255?255:k|0}e.toUint8=L;function C(k){return k<0?0:k>4294967295?4294967295:k|0}e.toUint32=C}),define(ve[2],we([0,1,8,11]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,k=/^\//,T=/^\/\//;function y(o,n){if(!o.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!C.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!k.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,n){return!o&&!n?"file":o}function A(o,n){switch(o){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const i="",I="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(n,a,h,d,w,E=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=S(n,E),this.authority=a||i,this.path=A(this.scheme,h||i),this.query=d||i,this.fragment=w||i,y(this,E))}static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return l(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:h,path:d,query:w,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=i),h===void 0?h=this.authority:h===null&&(h=i),d===void 0?d=this.path:d===null&&(d=i),w===void 0?w=this.query:w===null&&(w=i),E===void 0?E=this.fragment:E===null&&(E=i),a===this.scheme&&h===this.authority&&d===this.path&&w===this.query&&E===this.fragment?this:new v(a,h,d,w,E)}static parse(n,a=!1){const h=u.exec(n);return h?new v(h[2]||i,s(h[4]||i),s(h[5]||i),s(h[7]||i),s(h[9]||i),a):new v(i,i,i,i,i)}static file(n){let a=i;if(L.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const h=n.indexOf(I,2);h===-1?(a=n.substring(2),n=I):(a=n.substring(2,h),n=n.substring(h)||I)}return new v("file",a,n,i,i)}static from(n){const a=new v(n.scheme,n.authority,n.path,n.query,n.fragment);return y(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return L.isWindows&&n.scheme==="file"?h=m.file(g.win32.join(l(n,!0),...a)).path:h=g.posix.join(n.path,...a),n.with({path:h})}toString(n=!1){return f(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const a=new v(n);return a._formatted=n.external,a._fsPath=n._sep===c?n.fsPath:null,a}}else return n}}e.URI=m;const c=L.isWindows?1:void 0;class v extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(n=!1){return n?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(o,n){let a,h=-1;for(let d=0;d<o.length;d++){const w=o.charCodeAt(d);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||n&&w===47)h!==-1&&(a+=encodeURIComponent(o.substring(h,d)),h=-1),a!==void 0&&(a+=o.charAt(d));else{a===void 0&&(a=o.substr(0,d));const E=_[w];E!==void 0?(h!==-1&&(a+=encodeURIComponent(o.substring(h,d)),h=-1),a+=E):h===-1&&(h=d)}}return h!==-1&&(a+=encodeURIComponent(o.substring(h))),a!==void 0?a:o}function P(o){let n;for(let a=0;a<o.length;a++){const h=o.charCodeAt(a);h===35||h===63?(n===void 0&&(n=o.substr(0,a)),n+=_[h]):n!==void 0&&(n+=o[a])}return n!==void 0?n:o}function l(o,n){let a;return o.authority&&o.path.length>1&&o.scheme==="file"?a=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?n?a=o.path.substr(1):a=o.path[1].toLowerCase()+o.path.substr(2):a=o.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=l;function f(o,n){const a=n?P:b;let h="",{scheme:d,authority:w,path:E,query:r,fragment:D}=o;if(d&&(h+=d,h+=":"),(w||d==="file")&&(h+=I,h+=I),w){let R=w.indexOf("@");if(R!==-1){const x=w.substr(0,R);w=w.substr(R+1),R=x.indexOf(":"),R===-1?h+=a(x,!1):(h+=a(x.substr(0,R),!1),h+=":",h+=a(x.substr(R+1),!1)),h+="@"}w=w.toLowerCase(),R=w.indexOf(":"),R===-1?h+=a(w,!1):(h+=a(w.substr(0,R),!1),h+=w.substr(R))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const R=E.charCodeAt(1);R>=65&&R<=90&&(E=`/${String.fromCharCode(R+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const R=E.charCodeAt(0);R>=65&&R<=90&&(E=`${String.fromCharCode(R+32)}:${E.substr(2)}`)}h+=a(E,!0)}return r&&(h+="?",h+=a(r,!1)),D&&(h+="#",h+=n?D:b(D,!1)),h}function p(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+p(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(o){return o.match(t)?o.replace(t,n=>p(n)):o}});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[22],we([0,1,9,2]),function(J,e,g,L){"use strict";var C,k,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,s,o){let n=t.get(s);return n===void 0&&(n=o,t.set(s,n)),n}e.getOrSet=y;function S(t){const s=[];return t.forEach((o,n)=>{s.push(`${n} => ${o}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=S;function A(t){const s=[];return t.forEach(o=>{s.push(o)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=A;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const o=s.charCodeAt(0),n=this._value.charCodeAt(this._pos);return o-n}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,g.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class u{constructor(s=!0,o=!0){this._splitOnBackslash=s,this._caseSensitive=o}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,g.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,g.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class c{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,g.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,g.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,g.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,g.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(s){this._iter=s}static forUris(s=()=>!1){return new _(new c(s))}static forPaths(){return new _(new u)}static forStrings(){return new _(new i)}static forConfigKeys(){return new _(new I)}clear(){this._root=void 0}set(s,o){const n=this._iter.reset(s);let a;for(this._root||(this._root=new v,this._root.segment=n.value()),a=this._root;;){const d=n.cmp(a.segment);if(d>0)a.left||(a.left=new v,a.left.segment=n.value()),a=a.left;else if(d<0)a.right||(a.right=new v,a.right.segment=n.value()),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new v,a.mid.segment=n.value()),a=a.mid;else break}const h=a.value;return a.value=o,a.key=s,h}get(s){return this._getNode(s)?.value}_getNode(s){const o=this._iter.reset(s);let n=this._root;for(;n;){const a=o.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else break}return n}has(s){const o=this._getNode(s);return!(o?.value===void 0&&o?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,o){const n=this._iter.reset(s),a=[];let h=this._root;for(;h;){const d=n.cmp(h.segment);if(d>0)a.push([1,h]),h=h.left;else if(d<0)a.push([-1,h]),h=h.right;else if(n.hasNext())n.next(),a.push([0,h]),h=h.mid;else{for(o?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;a.length>0&&h.isEmpty();){let[w,E]=a.pop();switch(w){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}h=E}break}}}findSubstr(s){const o=this._iter.reset(s);let n=this._root,a;for(;n;){const h=o.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(o.hasNext())o.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(s){const o=this._iter.reset(s);let n=this._root;for(;n;){const a=o.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(s){for(const[o,n]of this)s(n,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const o=[s];for(;o.length>0;){const n=o.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&o.push(n.left),n.mid&&o.push(n.mid),n.right&&o.push(n.right))}}}e.TernarySearchTree=_;class b{constructor(s,o){this[C]="ResourceMap",s instanceof b?(this.map=new Map(s.map),this.toKey=o??b.defaultToKey):(this.map=new Map,this.toKey=s??b.defaultToKey)}set(s,o){return this.map.set(this.toKey(s),o),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,o){typeof o!="undefined"&&(s=s.bind(o));for(let[n,a]of this.map)s(a,L.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield L.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[L.URI.parse(s[0]),s[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[L.URI.parse(s[0]),s[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var P;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class l{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,o=0){const n=this._map.get(s);if(!!n)return o!==0&&this.touch(n,o),n.value}set(s,o,n=0){let a=this._map.get(s);if(a)a.value=o,n!==0&&this.touch(a,n);else{switch(a={key:s,value:o,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(s,a),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this._map.get(s);if(!!o)return this._map.delete(s),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,o){const n=this._state;let a=this._head;for(;a;){if(o?s.bind(o)(a.value,a.key,this):s(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const s=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:n.key,done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return a}values(){const s=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:n.value,done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return a}entries(){const s=this,o=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(n){const h={value:[n.key,n.value],done:!1};return n=n.next,h}else return{value:void 0,done:!0}}};return a}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this._head,n=this.size;for(;o&&n>s;)this._map.delete(o.key),o=o.next,n--;this._head=o,this._size=n,o&&(o.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const o=s.next,n=s.previous;if(!o||!n)throw new Error("Invalid list");o.previous=n,n.next=o}s.next=void 0,s.previous=void 0,this._state++}touch(s,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this._head)return;const n=s.next,a=s.previous;s===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(o===2){if(s===this._tail)return;const n=s.next,a=s.previous;s===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((o,n)=>{s.push([n,o])}),s}fromJSON(s){this.clear();for(const[o,n]of s)this.set(o,n)}}e.LinkedMap=l;class f extends l{constructor(s,o=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class p{constructor(s){T.set(this,void 0),nt(this,T,s,"f")}get size(){return $e(this,T,"f").size}forEach(s,o){$e(this,T,"f").forEach(s,o)}get(s){return $e(this,T,"f").get(s)}has(s){return $e(this,T,"f").has(s)}entries(){return $e(this,T,"f").entries()}keys(){return $e(this,T,"f").keys()}values(){return $e(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return $e(this,T,"f").entries()}}e.ReadonlyMapView=p}),define(ve[97],we([0,1,22,9]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Y){return function(ae,be){for(let Fe=0,He=Y.length;Fe<He;Fe++){const Ee=Y[Fe](ae,be);if(Ee)return Ee}return null}}e.or=C,e.matchesStrictPrefix=k.bind(void 0,!1),e.matchesPrefix=k.bind(void 0,!0);function k(Y,ae,be){if(!be||be.length<ae.length)return null;let Fe;return Y?Fe=L.startsWithIgnoreCase(be,ae):Fe=be.indexOf(ae)===0,Fe?ae.length>0?[{start:0,end:ae.length}]:[]:null}function T(Y,ae){const be=ae.toLowerCase().indexOf(Y.toLowerCase());return be===-1?null:[{start:be,end:be+Y.length}]}e.matchesContiguousSubString=T;function y(Y,ae){return S(Y.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=y;function S(Y,ae,be,Fe){if(be===Y.length)return[];if(Fe===ae.length)return null;if(Y[be]===ae[Fe]){let He=null;return(He=S(Y,ae,be+1,Fe+1))?b({start:Fe,end:Fe+1},He):null}return S(Y,ae,be,Fe+1)}function A(Y){return 97<=Y&&Y<=122}function i(Y){return 65<=Y&&Y<=90}e.isUpper=i;function I(Y){return 48<=Y&&Y<=57}function u(Y){return Y===32||Y===9||Y===10||Y===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>m.add(Y.charCodeAt(0)));function c(Y){return u(Y)||m.has(Y)}function v(Y,ae){return Y===ae||c(Y)&&c(ae)}function _(Y){return A(Y)||i(Y)||I(Y)}function b(Y,ae){return ae.length===0?ae=[Y]:Y.end===ae[0].start?ae[0].start=Y.start:ae.unshift(Y),ae}function P(Y,ae){for(let be=ae;be<Y.length;be++){const Fe=Y.charCodeAt(be);if(i(Fe)||I(Fe)||be>0&&!_(Y.charCodeAt(be-1)))return be}return Y.length}function l(Y,ae,be,Fe){if(be===Y.length)return[];if(Fe===ae.length)return null;if(Y[be]!==ae[Fe].toLowerCase())return null;{let He=null,Ee=Fe+1;for(He=l(Y,ae,be+1,Fe+1);!He&&(Ee=P(ae,Ee))<ae.length;)He=l(Y,ae,be+1,Ee),Ee++;return He===null?null:b({start:Fe,end:Fe+1},He)}}function f(Y){let ae=0,be=0,Fe=0,He=0,Ee=0;for(let Ue=0;Ue<Y.length;Ue++)Ee=Y.charCodeAt(Ue),i(Ee)&&ae++,A(Ee)&&be++,_(Ee)&&Fe++,I(Ee)&&He++;const Qe=ae/Y.length,X=be/Y.length,se=Fe/Y.length,pe=He/Y.length;return{upperPercent:Qe,lowerPercent:X,alphaPercent:se,numericPercent:pe}}function p(Y){const{upperPercent:ae,lowerPercent:be}=Y;return be===0&&ae>.6}function t(Y){const{upperPercent:ae,lowerPercent:be,alphaPercent:Fe,numericPercent:He}=Y;return be>.2&&ae<.8&&Fe>.6&&He<.2}function s(Y){let ae=0,be=0,Fe=0,He=0;for(let Ee=0;Ee<Y.length;Ee++)Fe=Y.charCodeAt(Ee),i(Fe)&&ae++,A(Fe)&&be++,u(Fe)&&He++;return(ae===0||be===0)&&He===0?Y.length<=30:ae<=5}function o(Y,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(Y)||ae.length>60)return null;const be=f(ae);if(!t(be)){if(!p(be))return null;ae=ae.toLowerCase()}let Fe=null,He=0;for(Y=Y.toLowerCase();He<ae.length&&(Fe=l(Y,ae,0,He))===null;)He=P(ae,He+1);return Fe}e.matchesCamelCase=o;function n(Y,ae,be=!1){if(!ae||ae.length===0)return null;let Fe=null,He=0;for(Y=Y.toLowerCase(),ae=ae.toLowerCase();He<ae.length&&(Fe=a(Y,ae,0,He,be))===null;)He=h(ae,He+1);return Fe}e.matchesWords=n;function a(Y,ae,be,Fe,He){if(be===Y.length)return[];if(Fe===ae.length)return null;if(v(Y.charCodeAt(be),ae.charCodeAt(Fe))){let Ee=null,Qe=Fe+1;if(Ee=a(Y,ae,be+1,Fe+1,He),!He)for(;!Ee&&(Qe=h(ae,Qe))<ae.length;)Ee=a(Y,ae,be+1,Qe,He),Qe++;return Ee===null?null:b({start:Fe,end:Fe+1},Ee)}else return null}function h(Y,ae){for(let be=ae;be<Y.length;be++)if(c(Y.charCodeAt(be))||be>0&&c(Y.charCodeAt(be-1)))return be;return Y.length}const d=C(e.matchesPrefix,o,T),w=C(e.matchesPrefix,o,y),E=new g.LRUCache(1e4);function r(Y,ae,be=!1){if(typeof Y!="string"||typeof ae!="string")return null;let Fe=E.get(Y);Fe||(Fe=new RegExp(L.convertSimple2RegExpPattern(Y),"i"),E.set(Y,Fe));const He=Fe.exec(ae);return He?[{start:He.index,end:He.index+He[0].length}]:be?w(Y,ae):d(Y,ae)}e.matchesFuzzy=r;function D(Y,ae){const be=je(Y,Y.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return be?x(be):null}e.matchesFuzzy2=D;function R(Y,ae,be,Fe,He,Ee){const Qe=Math.min(13,Y.length);for(;be<Qe;be++){const X=je(Y,ae,be,Fe,He,Ee,!1);if(X)return X}return[0,Ee]}e.anyScore=R;function x(Y){if(typeof Y=="undefined")return[];const ae=[],be=Y[1];for(let Fe=Y.length-1;Fe>1;Fe--){const He=Y[Fe]+be,Ee=ae[ae.length-1];Ee&&Ee.end===He?Ee.end=He+1:ae.push({start:He,end:He+1})}return ae}e.createMatches=x;const j=128;function te(){const Y=[],ae=[];for(let be=0;be<=j;be++)ae[be]=0;for(let be=0;be<=j;be++)Y.push(ae.slice(0));return Y}function Q(Y){const ae=[];for(let be=0;be<=Y;be++)ae[be]=0;return ae}const N=Q(2*j),U=Q(2*j),F=te(),V=te(),M=te(),O=!1;function q(Y,ae,be,Fe,He){function Ee(X,se,pe=" "){for(;X.length<se;)X=pe+X;return X}let Qe=` |   |${Fe.split("").map(X=>Ee(X,3)).join("|")}
`;for(let X=0;X<=be;X++)X===0?Qe+=" |":Qe+=`${ae[X-1]}|`,Qe+=Y[X].slice(0,He+1).map(se=>Ee(se.toString(),3)).join("|")+`
`;return Qe}function B(Y,ae,be,Fe){Y=Y.substr(ae),be=be.substr(Fe),console.log(q(V,Y,Y.length,be,be.length)),console.log(q(M,Y,Y.length,be,be.length)),console.log(q(F,Y,Y.length,be,be.length))}function K(Y,ae){if(ae<0||ae>=Y.length)return!1;const be=Y.codePointAt(ae);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(be)}}function ne(Y,ae){if(ae<0||ae>=Y.length)return!1;switch(Y.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function me(Y,ae,be){return ae[Y]!==be[Y]}function Se(Y,ae,be,Fe,He,Ee,Qe=!1){for(;ae<be&&He<Ee;)Y[ae]===Fe[He]&&(Qe&&(N[ae]=He),ae+=1),He+=1;return ae===be}e.isPatternInWord=Se;var Ce;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Te;(function(Y){Y.Default=[-100,0];function ae(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}Y.isDefault=ae})(Te=e.FuzzyScore||(e.FuzzyScore={}));function je(Y,ae,be,Fe,He,Ee,Qe){const X=Y.length>j?j:Y.length,se=Fe.length>j?j:Fe.length;if(be>=X||Ee>=se||X-be>se-Ee||!Se(ae,be,X,He,Ee,se,!0))return;Be(X,se,be,Ee,ae,He);let pe=1,Ue=1,Ne=be,Je=Ee;const ke=[!1];for(pe=1,Ne=be;Ne<X;pe++,Ne++){const H=N[Ne],ee=U[Ne],ue=Ne+1<X?U[Ne+1]:se;for(Ue=H-Ee+1,Je=H;Je<ue;Ue++,Je++){let Le=Number.MIN_SAFE_INTEGER,Re=!1;Je<=ee&&(Le=Ve(Y,ae,Ne,be,Fe,He,Je,se,Ee,F[pe-1][Ue-1]===0,ke));let ze=0;Le!==Number.MAX_SAFE_INTEGER&&(Re=!0,ze=Le+V[pe-1][Ue-1]);const Ge=Je>H,et=Ge?V[pe][Ue-1]+(F[pe][Ue-1]>0?-5:0):0,it=Je>H+1&&F[pe][Ue-1]>0,Ye=it?V[pe][Ue-2]+(F[pe][Ue-2]>0?-5:0):0;if(it&&(!Ge||Ye>=et)&&(!Re||Ye>=ze))V[pe][Ue]=Ye,M[pe][Ue]=3,F[pe][Ue]=0;else if(Ge&&(!Re||et>=ze))V[pe][Ue]=et,M[pe][Ue]=2,F[pe][Ue]=0;else if(Re)V[pe][Ue]=ze,M[pe][Ue]=1,F[pe][Ue]=F[pe-1][Ue-1]+1;else throw new Error("not possible")}}if(O&&B(Y,be,Fe,Ee),!ke[0]&&!Qe)return;pe--,Ue--;const ye=[V[pe][Ue],Ee];let Ie=0,ce=0;for(;pe>=1;){let H=Ue;do{const ee=M[pe][H];if(ee===3)H=H-2;else if(ee===2)H=H-1;else break}while(H>=1);Ie>1&&ae[be+pe-1]===He[Ee+Ue-1]&&!me(H+Ee-1,Fe,He)&&Ie+1>F[pe][H]&&(H=Ue),H===Ue?Ie++:Ie=1,ce||(ce=H),pe--,Ue=H-1,ye.push(Ue)}se===X&&(ye[0]+=2);const de=ce-X;return ye[0]-=de,ye}e.fuzzyScore=je;function Be(Y,ae,be,Fe,He,Ee){let Qe=Y-1,X=ae-1;for(;Qe>=be&&X>=Fe;)He[Qe]===Ee[X]&&(U[Qe]=X,Qe--),X--}function Ve(Y,ae,be,Fe,He,Ee,Qe,X,se,pe,Ue){if(ae[be]!==Ee[Qe])return Number.MIN_SAFE_INTEGER;let Ne=1,Je=!1;return Qe===be-Fe?Ne=Y[be]===He[Qe]?7:5:me(Qe,He,Ee)&&(Qe===0||!me(Qe-1,He,Ee))?(Ne=Y[be]===He[Qe]?7:5,Je=!0):K(Ee,Qe)&&(Qe===0||!K(Ee,Qe-1))?Ne=5:(K(Ee,Qe-1)||ne(Ee,Qe-1))&&(Ne=5,Je=!0),Ne>1&&be===Fe&&(Ue[0]=!0),Je||(Je=me(Qe,He,Ee)||K(Ee,Qe-1)||ne(Ee,Qe-1)),be===Fe?Qe>se&&(Ne-=Je?3:5):pe?Ne+=Je?2:0:Ne+=Je?0:1,Qe+1===X&&(Ne-=Je?3:5),Ne}function W(Y,ae,be,Fe,He,Ee,Qe){return ie(Y,ae,be,Fe,He,Ee,!0,Qe)}e.fuzzyScoreGracefulAggressive=W;function Z(Y,ae,be,Fe,He,Ee,Qe){return ie(Y,ae,be,Fe,He,Ee,!1,Qe)}e.fuzzyScoreGraceful=Z;function ie(Y,ae,be,Fe,He,Ee,Qe,X){let se=je(Y,ae,be,Fe,He,Ee,X);if(se&&!Qe)return se;if(Y.length>=3){const pe=Math.min(7,Y.length-1);for(let Ue=be+1;Ue<pe;Ue++){const Ne=le(Y,Ue);if(Ne){const Je=je(Ne,Ne.toLowerCase(),be,Fe,He,Ee,X);Je&&(Je[0]-=3,(!se||Je[0]>se[0])&&(se=Je))}}}return se}function le(Y,ae){if(ae+1>=Y.length)return;const be=Y[ae],Fe=Y[ae+1];if(be!==Fe)return Y.slice(0,ae)+Fe+be+Y.slice(ae+2)}}),define(ve[141],we([0,1,47,97,9]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const k=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${k.source}`,"g");function y(v){return v.replace(T,(_,b)=>b?_:`\\${_}`)}e.escapeIcons=y;const S=new RegExp(`\\\\${k.source}`,"g");function A(v){return v.replace(S,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=A;const i=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function I(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(i,(_,b,P,l)=>P?_:b||l||"")}e.stripIcons=I;function u(v){const _=v.indexOf(e.iconStartMarker);return _===-1?{text:v}:m(v,_)}e.parseLabelWithIcons=u;function m(v,_){const b=[];let P="";function l(h){if(h){P+=h;for(const d of h)b.push(t)}}let f=-1,p="",t=0,s,o,n=_;const a=v.length;for(l(v.substr(0,_));n<a;)s=v[n],o=v[n+1],s===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(f=n,l(p),p=e.iconStartMarker,n++):s===")"&&f!==-1?(t+=n-f+1,f=-1,p=""):f!==-1?/^[a-z0-9\-]$/i.test(s)?p+=s:(l(p),f=-1,p=""):l(s),n++;return l(p),{text:P,iconOffsets:b}}function c(v,_,b=!1){const{text:P,iconOffsets:l}=_;if(!l||l.length===0)return(0,L.matchesFuzzy)(v,P,b);const f=(0,C.ltrim)(P," "),p=P.length-f.length,t=(0,L.matchesFuzzy)(v,f,b);if(t)for(const s of t){const o=l[s.start+p]+p;s.start+=o,s.end+=o}return t}e.matchesFuzzyIconAware=c}),define(ve[98],we([0,1,16,141]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(m="",c=!1){if(this.value=m,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1)}appendText(m,c=0){return this.value+=A(this.supportThemeIcons?(0,L.escapeIcons)(m):m).replace(/([ \t]+)/g,(v,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,c){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=k;function T(u){return y(u)?!u.value:Array.isArray(u)?u.every(T):!0}e.isEmptyMarkdownString=T;function y(u){return u instanceof k?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function S(u,m){return u===m?!0:!u||!m?!1:u.value===m.value&&u.isTrusted===m.isTrusted&&u.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=S;function A(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function i(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(u){const m=[],c=u.split("|").map(_=>_.trim());u=c[0];const v=c[1];if(v){const _=/height=(\d+)/.exec(v),b=/width=(\d+)/.exec(v),P=_?_[1]:"",l=b?b[1]:"",f=isFinite(parseInt(l)),p=isFinite(parseInt(P));f&&m.push(`width="${l}"`),p&&m.push(`height="${P}"`)}return{href:u,dimensions:m}}e.parseHrefAndDimensions=I}),define(ve[59],we([0,1,24,9,2]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(i){return JSON.stringify(i,S)}e.stringify=k;function T(i){let I=JSON.parse(i);return I=A(I),I}e.parse=T;var y;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(y=e.MarshalledId||(e.MarshalledId={}));function S(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function A(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return C.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let u=0;u<i.length;++u)i[u]=A(i[u],I+1);else for(const u in i)Object.hasOwnProperty.call(i,u)&&(i[u]=A(i[u],I+1))}return i}e.revive=A}),define(ve[10],we([0,1,11,2]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,A,i){this._hosts[S]=A,this._ports[S]=i}setConnectionToken(S,A){this._connectionTokens[S]=A}rewrite(S){if(this._delegate)return this._delegate(S);const A=S.authority;let i=this._hosts[A];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[A],u=this._connectionTokens[A];let m=`path=${encodeURIComponent(S.path)}`;return typeof u=="string"&&(m+=`&tkn=${encodeURIComponent(u)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new k;class T{asBrowserUri(S,A){const i=this.toUri(S,A);return i.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===C.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${C.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?i.with({scheme:C.vscodeFileResource,authority:i.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(S,A){const i=this.toUri(S,A);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==T.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,A){return L.URI.isUri(S)?S:L.URI.parse(A.toUrl(S))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ve[77],we([0,1,22]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function C(A){return S(A,"NFC",L)}e.normalizeNFC=C;const k=new g.LRUCache(1e4);function T(A){return S(A,"NFD",k)}e.normalizeNFD=T;const y=/[^\u0000-\u0080]/;function S(A,i,I){if(!A)return A;const u=I.get(A);if(u)return u;let m;return y.test(A)?m=A.normalize(i):m=A,I.set(A,m),m}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(i){return T(i).replace(A,"")}}()}),define(ve[23],we([0,1,29,10,8,11,9,2]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(m){return(0,y.uriToFsPath)(m,!0)}e.originalFSPath=S;class A{constructor(c){this._ignorePathCasing=c}compare(c,v,_=!1){return c===v?0:(0,T.compare)(this.getComparisonKey(c,_),this.getComparisonKey(v,_))}isEqual(c,v,_=!1){return c===v?!0:!c||!v?!1:this.getComparisonKey(c,_)===this.getComparisonKey(v,_)}getComparisonKey(c,v=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,v,_=!1){if(c.scheme===v.scheme){if(c.scheme===L.Schemas.file)return g.isEqualOrParent(S(c),S(v),this._ignorePathCasing(c))&&c.query===v.query&&(_||c.fragment===v.fragment);if((0,e.isEqualAuthority)(c.authority,v.authority))return g.isEqualOrParent(c.path,v.path,this._ignorePathCasing(c),"/")&&c.query===v.query&&(_||c.fragment===v.fragment)}return!1}joinPath(c,...v){return y.URI.joinPath(c,...v)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return C.posix.basename(c.path)}extname(c){const v=C.posix.extname(c.path),_=v.indexOf("?");return _!==-1?v.substr(0,_):v}dirname(c){if(c.path.length===0)return c;let v;return c.scheme===L.Schemas.file?v=y.URI.file(C.dirname(S(c))).path:(v=C.posix.dirname(c.path),c.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),v="/")),c.with({path:v})}normalizePath(c){if(!c.path.length)return c;let v;return c.scheme===L.Schemas.file?v=y.URI.file(C.normalize(S(c))).path:v=C.posix.normalize(c.path),c.with({path:v})}relativePath(c,v){if(c.scheme!==v.scheme||!(0,e.isEqualAuthority)(c.authority,v.authority))return;if(c.scheme===L.Schemas.file){const P=C.relative(S(c),S(v));return k.isWindows?g.toSlashes(P):P}let _=c.path||"/",b=v.path||"/";if(this._ignorePathCasing(c)){let P=0;for(const l=Math.min(_.length,b.length);P<l&&!(_.charCodeAt(P)!==b.charCodeAt(P)&&_.charAt(P).toLowerCase()!==b.charAt(P).toLowerCase());P++);_=b.substr(0,P)+_.substr(P)}return C.posix.relative(_,b)}resolvePath(c,v){if(c.scheme===L.Schemas.file){const _=y.URI.file(C.resolve(S(c),v));return c.with({authority:_.authority,path:_.path})}return v=g.toPosixPath(v),c.with({path:C.posix.resolve(c.path,v)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,v){return c===v||(0,T.equalsIgnoreCase)(c,v)}hasTrailingPathSeparator(c,v=C.sep){if(c.scheme===L.Schemas.file){const _=S(c);return _.length>g.getRoot(_).length&&_[_.length-1]===v}else{const _=c.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,v=C.sep){return(0,e.hasTrailingPathSeparator)(c,v)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,v=C.sep){let _=!1;if(c.scheme===L.Schemas.file){const b=S(c);_=b!==void 0&&b.length===g.getRoot(b).length&&b[b.length-1]===v}else{v="/";const b=c.path;_=b.length===1&&b.charCodeAt(b.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(c,v)?c.with({path:c.path+"/"}):c}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(m=>m.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new A(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(m,c){const v=[];for(let _=0;_<m.length;_++){const b=c(m[_]);m.some((P,l)=>l===_?!1:(0,e.isEqualOrParent)(b,c(P)))||v.push(m[_])}return v}e.distinctParents=i;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function c(v){const _=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[f,p]=l.split(":");f&&p&&_.set(f,p)});const P=v.path.substring(0,v.path.indexOf(";"));return P&&_.set(m.META_DATA_MIME,P),_}m.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function u(m,c,v){if(c){let _=m.path;return _&&_[0]!==C.posix.sep&&(_=C.posix.sep+_),m.with({scheme:v,authority:c,path:_})}return m.with({scheme:v})}e.toLocalResource=u}),define(ve[17],we([0,1,21,16,3,6,23]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(U){return!!U&&typeof U.then=="function"}e.isThenable=y;function S(U){const F=new g.CancellationTokenSource,V=U(F.token),M=new Promise((O,q)=>{const B=F.token.onCancellationRequested(()=>{B.dispose(),F.dispose(),q((0,L.canceled)())});Promise.resolve(V).then(K=>{B.dispose(),F.dispose(),O(K)},K=>{B.dispose(),F.dispose(),q(K)})});return new class{cancel(){F.cancel()}then(O,q){return M.then(O,q)}catch(O){return this.then(void 0,O)}finally(O){return M.finally(O)}}}e.createCancelablePromise=S;function A(U,F,V){return Promise.race([U,new Promise(M=>F.onCancellationRequested(()=>M(V)))])}e.raceCancellation=A;async function i(U){let F=-1;const V=U.map((O,q)=>O.then(B=>(F=q,B))),M=await Promise.race(V);return U.forEach((O,q)=>{q!==F&&O.cancel()}),M}e.raceCancellablePromises=i;function I(U,F,V){let M;const O=setTimeout(()=>{M?.(void 0),V?.()},F);return Promise.race([U.finally(()=>clearTimeout(O)),new Promise(q=>M=q)])}e.raceTimeout=I;function u(U){return new Promise((F,V)=>{const M=U();y(M)?M.then(F,V):F(M)})}e.asPromise=u;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(V,V).then(M)})}return new Promise((V,M)=>{this.queuedPromise.then(V,M)})}return this.activePromise=F(),new Promise((V,M)=>{this.activePromise.then(O=>{this.activePromise=null,V(O)},O=>{this.activePromise=null,M(O)})})}}e.Throttler=m;class c{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=c;class v{constructor(){this.promiseMap=new Map}queue(F,V){const O=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(F)===O&&this.promiseMap.delete(F)});return this.promiseMap.set(F,O),O}}e.SequencerByKey=v;class _{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,V=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,O)=>{this.doResolve=M,this.doReject=O}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class b{constructor(F){this.delayer=new _(F),this.throttler=new m}trigger(F,V){return this.delayer.trigger(()=>this.throttler.queue(F),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class P{constructor(){this._isOpen=!1,this._promise=new Promise((F,V)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class l extends P{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function f(U,F){return F?new Promise((V,M)=>{const O=setTimeout(()=>{q.dispose(),V()},U),q=F.onCancellationRequested(()=>{clearTimeout(O),q.dispose(),M((0,L.canceled)())})}):S(V=>f(U,V))}e.timeout=f;function p(U,F=0){const V=setTimeout(U,F);return(0,k.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=p;function t(U){const F=[];let V=0;const M=U.length;function O(){return V<M?U[V++]():null}function q(B){B!=null&&F.push(B);const K=O();return K?K.then(q):Promise.resolve(F)}return Promise.resolve(null).then(q)}e.sequence=t;function s(U,F=M=>!!M,V=null){let M=0;const O=U.length,q=()=>{if(M>=O)return Promise.resolve(V);const B=U[M++];return Promise.resolve(B()).then(ne=>F(ne)?Promise.resolve(ne):q())};return q()}e.first=s;function o(U,F=M=>!!M,V=null){if(U.length===0)return Promise.resolve(V);let M=U.length;const O=()=>{M=-1;for(const q of U)q.cancel?.()};return new Promise((q,B)=>{for(const K of U)K.then(ne=>{--M>=0&&F(ne)?(O(),q(ne)):M===0&&q(V)}).catch(ne=>{--M>=0&&(O(),B(ne))})})}e.firstParallel=o;class n{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((V,M)=>{this.outstandingPromises.push({factory:F,c:V,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const V=F.factory();V.then(F.c,F.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class a extends n{constructor(){super(1)}}e.Queue=a;class h{constructor(){this.queues=new Map}queueFor(F,V=T.extUri){const M=V.getComparisonKey(F);let O=this.queues.get(M);return O||(O=new a,C.Event.once(O.onFinished)(()=>{O?.dispose(),this.queues.delete(M)}),this.queues.set(M,O)),O}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=h;class d{constructor(F,V){this._token=-1,typeof F=="function"&&typeof V=="number"&&this.setIfNotSet(F,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},V)}setIfNotSet(F,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},V))}}e.TimeoutTimer=d;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,V){this.cancel(),this._token=setInterval(()=>{F()},V)}}e.IntervalTimer=w;class E{constructor(F,V){this.timeoutToken=-1,this.runner=F,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class r extends E{constructor(F,V){super(F,V);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=r;class D extends k.Disposable{constructor(F,V,M,O){super();this.maxWorkChunkSize=F,this.maxPendingWork=V,this.throttleDelay=M,this.handler=O,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=D,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const V=setTimeout(()=>F(U));let M=!1;return{dispose(){M||(M=!0,clearTimeout(V))}}}}else e.runWhenIdle=(U,F)=>{const V=requestIdleCallback(U,typeof F=="number"?{timeout:F}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(V))}}}}();class R{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function x(U,F,V){let M;for(let O=0;O<V;O++)try{return await U()}catch(q){M=q,await f(F)}throw M}e.retry=x;class j{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,V,M){return this._pending={taskId:F,cancel:()=>M?.(),promise:V},V.then(()=>this.donePending(F),()=>this.donePending(F)),V}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let V,M;const O=new Promise((q,B)=>{V=q,M=B});this._next={run:F,promise:O,promiseResolve:V,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=j;class te{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,V)=>{this.completeCallback=F,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(V=>{this.completeCallback(F),this.resolved=!0,V()})}error(F){return new Promise(V=>{this.errorCallback(F),this.rejected=!0,V()})}cancel(){new Promise(F=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=Q;var N;(function(U){async function F(V){let M;const O=await Promise.all(V.map(q=>q.then(B=>B,B=>{M||(M=B)})));if(typeof M!="undefined")throw M;return O}U.settled=F})(N=e.Promises||(e.Promises={}))}),define(ve[99],we([0,1,17,8]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new g.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),k=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(E,r,D=!1){const R=E||"",x=r||"",j=C.value.collator.compare(R,x);return C.value.collatorIsNumeric&&j===0&&R!==x?R<x?-1:1:j}e.compareFileNames=y;function S(E,r){const D=k.value.collator;return E=E||"",r=r||"",p(D,E,r)}e.compareFileNamesDefault=S;function A(E,r){const D=k.value.collator;return E=E||"",r=r||"",n(E,r)||p(D,E,r)}e.compareFileNamesUpper=A;function i(E,r){const D=k.value.collator;return E=E||"",r=r||"",o(E,r)||p(D,E,r)}e.compareFileNamesLower=i;function I(E,r){return E=E||"",r=r||"",E===r?0:E<r?-1:1}e.compareFileNamesUnicode=I;function u(E,r,D=!1){D||(E=E&&E.toLowerCase(),r=r&&r.toLowerCase());const[R,x]=l(E),[j,te]=l(r);return R!==j?R<j?-1:1:x===te?0:x<te?-1:1}e.noIntlCompareFileNames=u;function m(E,r){const[D,R]=l(E),[x,j]=l(r);let te=C.value.collator.compare(R,j);if(te===0){if(C.value.collatorIsNumeric&&R!==j)return R<j?-1:1;if(te=C.value.collator.compare(D,x),C.value.collatorIsNumeric&&te===0&&D!==x)return D<x?-1:1}return te}e.compareFileExtensions=m;function c(E,r){E=E||"",r=r||"";const D=f(E),R=f(r),x=k.value.collator,j=T.value.collator;return p(j,D,R)||p(x,E,r)}e.compareFileExtensionsDefault=c;function v(E,r){E=E||"",r=r||"";const D=f(E),R=f(r),x=k.value.collator,j=T.value.collator;return p(j,D,R)||n(E,r)||p(x,E,r)}e.compareFileExtensionsUpper=v;function _(E,r){E=E||"",r=r||"";const D=f(E),R=f(r),x=k.value.collator,j=T.value.collator;return p(j,D,R)||o(E,r)||p(x,E,r)}e.compareFileExtensionsLower=_;function b(E,r){E=E||"",r=r||"";const D=f(E).toLowerCase(),R=f(r).toLowerCase();return D!==R?D<R?-1:1:E!==r?E<r?-1:1:0}e.compareFileExtensionsUnicode=b;const P=/^(.*?)(\.([^.]*))?$/;function l(E,r=!1){const D=E?P.exec(E):[];let R=[D&&D[1]||"",D&&D[3]||""];return r&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function f(E){const r=E?P.exec(E):[];return r&&r[1]&&r[1].charAt(0)!=="."&&r[3]||""}function p(E,r,D){let R=E.compare(r,D);return R!==0?R:r.length!==D.length?r.length<D.length?-1:1:0}function t(E){const r=E.charAt(0);return r.toLocaleUpperCase()!==r}function s(E){const r=E.charAt(0);return r.toLocaleLowerCase()!==r}function o(E,r){return t(E)&&s(r)?-1:s(E)&&t(r)?1:0}function n(E,r){return s(E)&&t(r)?-1:t(E)&&s(r)?1:0}function a(E,r,D=!1){return D||(E=E&&E.toLowerCase(),r=r&&r.toLowerCase()),E===r?0:E<r?-1:1}function h(E,r,D=!1){const R=E.split(L.sep),x=r.split(L.sep),j=R.length-1,te=x.length-1;let Q,N;for(let U=0;;U++){if(Q=j===U,N=te===U,Q&&N)return y(R[U],x[U],D);if(Q)return-1;if(N)return 1;const F=a(R[U],x[U],D);if(F!==0)return F}}e.comparePaths=h;function d(E,r,D){const R=E.toLowerCase(),x=r.toLowerCase(),j=w(E,r,D);if(j)return j;const te=R.endsWith(D),Q=x.endsWith(D);if(te!==Q)return te?-1:1;const N=y(R,x);return N!==0?N:R.localeCompare(x)}e.compareAnything=d;function w(E,r,D){const R=E.toLowerCase(),x=r.toLowerCase(),j=R.startsWith(D),te=x.startsWith(D);if(j!==te)return j?-1:1;if(j&&te){if(R.length<x.length)return-1;if(R.length>x.length)return 1}return 0}e.compareByPrefix=w}),define(ve[100],we([0,1,99,97,8,11,9]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,S=[y,[]];function A(Q,N,U,F){if(!Q||!N)return S;const V=Q.length,M=N.length;if(V<M)return S;const O=Q.toLowerCase();return!F&&!O.includes(U)?S:i(N,U,M,Q,O,V)}e.scoreFuzzy=A;function i(Q,N,U,F,V,M){const O=[],q=[];for(let me=0;me<U;me++){const Se=me*M,Ce=Se-M,Te=me>0,je=Q[me],Be=N[me];for(let Ve=0;Ve<M;Ve++){const W=Ve>0,Z=Se+Ve,ie=Z-1,le=Ce+Ve-1,Y=W?O[ie]:0,ae=Te&&W?O[le]:0,be=Te&&W?q[le]:0;let Fe;!ae&&Te?Fe=0:Fe=I(je,Be,F,V,Ve,be),Fe&&ae+Fe>=Y?(q[Z]=be+1,O[Z]=ae+Fe):(q[Z]=y,O[Z]=Y)}}const B=[];let K=U-1,ne=M-1;for(;K>=0&&ne>=0;){const me=K*M+ne;q[me]===y||(B.push(ne),K--),ne--}return[O[U*M-1],B.reverse()]}function I(Q,N,U,F,V,M){let O=0;if(!u(N,F[V]))return O;if(O+=1,M>0&&(O+=M*5),Q===U[V]&&(O+=1),V===0)O+=8;else{const q=m(U.charCodeAt(V-1));q?O+=q:(0,L.isUpper)(U.charCodeAt(V))&&(O+=2)}return O}function u(Q,N){return Q===N?!0:Q==="/"||Q==="\\"?N==="/"||N==="\\":!1}function m(Q){switch(Q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function v(Q,N,U=0,F=0){const V=N;return V.values&&V.values.length>1?_(Q,V.values,U,F):b(Q,N,U,F)}e.scoreFuzzy2=v;function _(Q,N,U,F){let V=0;const M=[];for(const O of N){const[q,B]=b(Q,O,U,F);if(typeof q!="number")return c;V+=q,M.push(...B)}return[V,h(M)]}function b(Q,N,U,F){const V=(0,L.fuzzyScore)(N.original,N.originalLowercase,U,Q,Q.toLowerCase(),F,!0);return V?[V[0],(0,L.createMatches)(V)]:c}const P=Object.freeze({score:0}),l=1<<18,f=1<<17,p=1<<16;function t(Q,N,U,F,V){if(!Q||!N.normalized)return P;const M=F.getItemLabel(Q);if(!M)return P;const O=F.getItemDescription(Q);let q;O?q=`${M}${O}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${U}`:q=`${M}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${U}`;const B=V[q];if(B)return B;const K=s(M,O,F.getItemPath(Q),N,U);return V[q]=K,K}e.scoreItemFuzzy=t;function s(Q,N,U,F,V){const M=!U||!F.containsPathSeparator;return U&&(k.isLinux?F.pathNormalized===U:(0,T.equalsIgnoreCase)(F.pathNormalized,U))?{score:l,labelMatch:[{start:0,end:Q.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:F.values&&F.values.length>1?o(Q,N,U,F.values,M,V):n(Q,N,U,F,M,V)}function o(Q,N,U,F,V,M){let O=0;const q=[],B=[];for(const K of F){const{score:ne,labelMatch:me,descriptionMatch:Se}=n(Q,N,U,K,V,M);if(ne===y)return P;O+=ne,me&&q.push(...me),Se&&B.push(...Se)}return{score:O,labelMatch:h(q),descriptionMatch:h(B)}}function n(Q,N,U,F,V,M){if(V||!N){const[O,q]=A(Q,F.normalized,F.normalizedLowercase,M);if(O){const B=(0,L.matchesPrefix)(F.normalized,Q);let K;return B?(K=f,K+=Math.round(F.normalized.length/Q.length*100)):K=p,{score:K+O,labelMatch:B||a(q)}}}if(N){let O=N;U&&(O=`${N}${C.sep}`);const q=O.length,B=`${O}${Q}`,[K,ne]=A(B,F.normalized,F.normalizedLowercase,M);if(K){const me=a(ne),Se=[],Ce=[];return me.forEach(Te=>{Te.start<q&&Te.end>q?(Se.push({start:0,end:Te.end-q}),Ce.push({start:Te.start,end:q})):Te.start>=q?Se.push({start:Te.start-q,end:Te.end-q}):Ce.push(Te)}),{score:K,labelMatch:Se,descriptionMatch:Ce}}}return P}function a(Q){const N=[];if(!Q)return N;let U;for(const F of Q)U&&U.end===F?U.end+=1:(U={start:F,end:F+1},N.push(U));return N}function h(Q){const N=Q.sort((V,M)=>V.start-M.start),U=[];let F;for(const V of N)!F||!d(F,V)?(F=V,U.push(V)):(F.start=Math.min(F.start,V.start),F.end=Math.max(F.end,V.end));return U}function d(Q,N){return!(Q.end<N.start||N.end<Q.start)}function w(Q,N,U,F,V,M){const O=t(Q,U,F,V,M),q=t(N,U,F,V,M),B=O.score,K=q.score;if((B===l||K===l)&&B!==K)return B===l?-1:1;if(B>p||K>p){if(B!==K)return B>K?-1:1;if(B<f&&K<f){const Be=r(O.labelMatch,q.labelMatch);if(Be!==0)return Be}const Te=V.getItemLabel(Q)||"",je=V.getItemLabel(N)||"";if(Te.length!==je.length)return Te.length-je.length}if(B!==K)return B>K?-1:1;const ne=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,me=Array.isArray(q.labelMatch)&&q.labelMatch.length>0;if(ne&&!me)return-1;if(me&&!ne)return 1;const Se=E(Q,O,V),Ce=E(N,q,V);return Se&&Ce&&Se!==Ce?Ce>Se?-1:1:D(Q,N,U,V)}e.compareItemsByFuzzyScore=w;function E(Q,N,U){let F=-1,V=-1;if(N.descriptionMatch&&N.descriptionMatch.length?F=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(F=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(V=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const M=U.getItemDescription(Q);M&&(V+=M.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(V=N.descriptionMatch[N.descriptionMatch.length-1].end);return V-F}function r(Q,N){if(!Q&&!N||(!Q||!Q.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!Q||!Q.length)return 1;const U=Q[0].start,V=Q[Q.length-1].end-U,M=N[0].start,q=N[N.length-1].end-M;return V===q?0:q<V?1:-1}function D(Q,N,U,F){const V=F.getItemLabel(Q)||"",M=F.getItemLabel(N)||"",O=F.getItemDescription(Q),q=F.getItemDescription(N),B=V.length+(O?O.length:0),K=M.length+(q?q.length:0);if(B!==K)return B-K;const ne=F.getItemPath(Q),me=F.getItemPath(N);return ne&&me&&ne.length!==me.length?ne.length-me.length:V!==M?(0,g.compareAnything)(V,M,U.normalized):O&&q&&O!==q?(0,g.compareAnything)(O,q,U.normalized):ne&&me&&ne!==me?(0,g.compareAnything)(ne,me,U.normalized):0}const R=" ";function x(Q){typeof Q!="string"&&(Q="");const N=Q.toLowerCase(),{pathNormalized:U,normalized:F,normalizedLowercase:V}=j(Q),M=U.indexOf(C.sep)>=0;let O;const q=Q.split(R);if(q.length>1)for(const B of q){const{pathNormalized:K,normalized:ne,normalizedLowercase:me}=j(B);ne&&(O||(O=[]),O.push({original:B,originalLowercase:B.toLowerCase(),pathNormalized:K,normalized:ne,normalizedLowercase:me}))}return{original:Q,originalLowercase:N,pathNormalized:U,normalized:F,normalizedLowercase:V,values:O,containsPathSeparator:M}}e.prepareQuery=x;function j(Q){let N;k.isWindows?N=Q.replace(/\//g,C.sep):N=Q.replace(/\\/g,C.sep);const U=(0,T.stripWildcards)(N).replace(/\s/g,"");return{pathNormalized:N,normalized:U,normalizedLowercase:U.toLowerCase()}}function te(Q){return Array.isArray(Q)?x(Q.map(N=>N.original).join(R)):x(Q.original)}e.pieceToQuery=te}),define(ve[30],we([0,1,17,29,22,8,9]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const S="**",A="/",i="[/\\\\]",I="[^/\\\\]",u=/\//g;function m(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function c(O,q){if(!O)return[];const B=[];let K=!1,ne=!1,me="";for(const Se of O){switch(Se){case q:if(!K&&!ne){B.push(me),me="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}me+=Se}return me&&B.push(me),B}e.splitGlobAware=c;function v(O){if(!O)return"";let q="";const B=c(O,A);if(B.every(K=>K===S))q=".*";else{let K=!1;B.forEach((ne,me)=>{if(ne===S){K||(q+=m(2),K=!0);return}let Se=!1,Ce="",Te=!1,je="";for(const Be of ne){if(Be!=="}"&&Se){Ce+=Be;continue}if(Te&&(Be!=="]"||!je)){let Ve;Be==="-"?Ve=Be:(Be==="^"||Be==="!")&&!je?Ve="^":Be===A?Ve="":Ve=T.escapeRegExpCharacters(Be),je+=Ve;continue}switch(Be){case"{":Se=!0;continue;case"[":Te=!0;continue;case"}":q+=`(?:${c(Ce,",").map(Z=>v(Z)).join("|")})`,Se=!1,Ce="";break;case"]":q+="["+je+"]",Te=!1,je="";break;case"?":q+=I;continue;case"*":q+=m(1);continue;default:q+=T.escapeRegExpCharacters(Be)}}me<B.length-1&&(B[me+1]!==S||me+2<B.length)&&(q+=i),K=!1})}return q}const _=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),s=function(){return!1},o=function(){return null};function n(O,q){if(!O)return o;let B;typeof O!="string"?B=O.pattern:B=O,B=B.trim();const K=`${B}_${!!q.trimForExclusions}`;let ne=t.get(K);if(ne)return a(ne,O);let me;if(_.test(B)){const Se=B.substr(4);ne=function(Ce,Te){return typeof Ce=="string"&&Ce.endsWith(Se)?B:null}}else(me=b.exec(h(B,q)))?ne=d(me[1],B):(q.trimForExclusions?l:P).test(B)?ne=w(B,q):(me=f.exec(h(B,q)))?ne=E(me[1].substr(1),B,!0):(me=p.exec(h(B,q)))?ne=E(me[1],B,!1):ne=r(B);return t.set(K,ne),a(ne,O)}function a(O,q){return typeof q=="string"?O:function(B,K){return L.isEqualOrParent(B,q.base)?O(k.relative(q.base,B),K):null}}function h(O,q){return q.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function d(O,q){const B=`/${O}`,K=`\\${O}`,ne=function(Se,Ce){return typeof Se!="string"?null:Ce?Ce===O?q:null:Se===O||Se.endsWith(B)||Se.endsWith(K)?q:null},me=[O];return ne.basenames=me,ne.patterns=[q],ne.allBasenames=me,ne}function w(O,q){const B=M(O.slice(1,-1).split(",").map(Ce=>n(Ce,q)).filter(Ce=>Ce!==o),O),K=B.length;if(!K)return o;if(K===1)return B[0];const ne=function(Ce,Te){for(let je=0,Be=B.length;je<Be;je++)if(B[je](Ce,Te))return O;return null},me=B.find(Ce=>!!Ce.allBasenames);me&&(ne.allBasenames=me.allBasenames);const Se=B.reduce((Ce,Te)=>Te.allPaths?Ce.concat(Te.allPaths):Ce,[]);return Se.length&&(ne.allPaths=Se),ne}function E(O,q,B){const K=k.sep===k.posix.sep,ne=K?O:O.replace(u,k.sep),me=k.sep+ne,Se=k.posix.sep+O,Ce=B?function(Te,je){return typeof Te=="string"&&(Te===ne||Te.endsWith(me)||!K&&(Te===O||Te.endsWith(Se)))?q:null}:function(Te,je){return typeof Te=="string"&&(Te===ne||!K&&Te===O)?q:null};return Ce.allPaths=[(B?"*/":"./")+O],Ce}function r(O){try{const q=new RegExp(`^${v(O)}$`);return function(B){return q.lastIndex=0,typeof B=="string"&&q.test(B)?O:null}}catch(q){return o}}function D(O,q,B){return!O||typeof q!="string"?!1:R(O)(q,void 0,B)}e.match=D;function R(O,q={}){if(!O)return s;if(typeof O=="string"||Q(O)){const B=n(O,q);if(B===o)return s;const K=function(ne,me){return!!B(ne,me)};return B.allBasenames&&(K.allBasenames=B.allBasenames),B.allPaths&&(K.allPaths=B.allPaths),K}return F(O,q)}e.parse=R;function x(O){if(!O)return;let q;return B=>(q||(q=(O()||Promise.resolve([])).then(K=>K?te(K):{})),q.then(K=>!!K[B]))}e.hasSiblingPromiseFn=x;function j(O){if(!O)return;let q;return B=>{if(!q){const K=O();q=K?te(K):{}}return!!q[B]}}e.hasSiblingFn=j;function te(O){const q={};for(const B of O)q[B]=!0;return q}function Q(O){const q=O;return q&&typeof q.base=="string"&&typeof q.pattern=="string"}e.isRelativePattern=Q;function N(O){return O.allBasenames||[]}e.getBasenameTerms=N;function U(O){return O.allPaths||[]}e.getPathTerms=U;function F(O,q){const B=M(Object.getOwnPropertyNames(O).map(Ce=>V(Ce,O[Ce],q)).filter(Ce=>Ce!==o)),K=B.length;if(!K)return o;if(!B.some(Ce=>!!Ce.requiresSiblings)){if(K===1)return B[0];const Ce=function(Be,Ve){for(let W=0,Z=B.length;W<Z;W++){const ie=B[W](Be,Ve);if(ie)return ie}return null},Te=B.find(Be=>!!Be.allBasenames);Te&&(Ce.allBasenames=Te.allBasenames);const je=B.reduce((Be,Ve)=>Ve.allPaths?Be.concat(Ve.allPaths):Be,[]);return je.length&&(Ce.allPaths=je),Ce}const ne=function(Ce,Te,je){let Be;for(let Ve=0,W=B.length;Ve<W;Ve++){const Z=B[Ve];Z.requiresSiblings&&je&&(Te||(Te=k.basename(Ce)),Be||(Be=Te.substr(0,Te.length-k.extname(Ce).length)));const ie=Z(Ce,Te,Be,je);if(ie)return ie}return null},me=B.find(Ce=>!!Ce.allBasenames);me&&(ne.allBasenames=me.allBasenames);const Se=B.reduce((Ce,Te)=>Te.allPaths?Ce.concat(Te.allPaths):Ce,[]);return Se.length&&(ne.allPaths=Se),ne}function V(O,q,B){if(q===!1)return o;const K=n(O,B);if(K===o)return o;if(typeof q=="boolean")return K;if(q){const ne=q.when;if(typeof ne=="string"){const me=(Se,Ce,Te,je)=>{if(!je||!K(Se,Ce))return null;const Be=ne.replace("$(basename)",Te),Ve=je(Be);return(0,g.isThenable)(Ve)?Ve.then(W=>W?O:null):Ve?O:null};return me.requiresSiblings=!0,me}}return K}function M(O,q){const B=O.filter(Ce=>!!Ce.basenames);if(B.length<2)return O;const K=B.reduce((Ce,Te)=>{const je=Te.basenames;return je?Ce.concat(je):Ce},[]);let ne;if(q){ne=[];for(let Ce=0,Te=K.length;Ce<Te;Ce++)ne.push(q)}else ne=B.reduce((Ce,Te)=>{const je=Te.patterns;return je?Ce.concat(je):Ce},[]);const me=function(Ce,Te){if(typeof Ce!="string")return null;if(!Te){let Be;for(Be=Ce.length;Be>0;Be--){const Ve=Ce.charCodeAt(Be-1);if(Ve===47||Ve===92)break}Te=Ce.substr(Be)}const je=K.indexOf(Te);return je!==-1?ne[je]:null};me.basenames=K,me.patterns=ne,me.allBasenames=K;const Se=O.filter(Ce=>!Ce.basenames);return Se.push(me),Se}}),define(ve[78],we([0,1,29,10,8,11,23,9,2]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(n,a,h){if(typeof n=="string"&&(n=S.URI.file(n)),h){const w=h.getWorkspaceFolder(n);if(w){const E=h.getWorkspace().folders.length>1;let r;if((0,T.isEqual)(w.uri,n)?r="":r=(0,T.relativePath)(w.uri,n),E){const D=w.name?w.name:(0,T.basename)(w.uri);r=r?D+" \u2022 "+r:D}return r}}if(n.scheme!==L.Schemas.file&&n.scheme!==L.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(n.fsPath))return(0,C.normalize)(I(n.fsPath));let d=(0,C.normalize)(n.fsPath);return!k.isWindows&&a?.userHome&&(d=m(d,a.userHome.fsPath)),d}e.getPathLabel=A;function i(n){if(!n)return;typeof n=="string"&&(n=S.URI.file(n));const a=(0,T.basename)(n)||(n.scheme===L.Schemas.file?n.fsPath:n.path);return k.isWindows&&(0,g.isRootOrDriveLetter)(a)?I(a):a}e.getBaseLabel=i;function I(n){return(0,g.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=I;let u=Object.create(null);function m(n,a){if(k.isWindows||!n||!a)return n;let h=u.original===a?u.normalized:void 0;return h||(h=`${(0,y.rtrim)(a,C.posix.sep)}${C.posix.sep}`,u={original:a,normalized:h}),(k.isLinux?n.startsWith(h):(0,y.startsWithIgnoreCase)(n,h))&&(n=`~/${n.substr(h.length)}`),n}e.tildify=m;function c(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=c;const v="\u2026",_="\\\\",b="~";function P(n,a=C.sep){const h=new Array(n.length);let d=!1;for(let w=0;w<n.length;w++){let E=n[w];if(E===""){h[w]=`.${a}`;continue}if(!E){h[w]=E;continue}d=!0;let r="";E.indexOf(_)===0?(r=E.substr(0,E.indexOf(_)+_.length),E=E.substr(E.indexOf(_)+_.length)):E.indexOf(a)===0?(r=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(b)===0&&(r=E.substr(0,E.indexOf(b)+b.length),E=E.substr(E.indexOf(b)+b.length));const D=E.split(a);for(let R=1;d&&R<=D.length;R++)for(let x=D.length-R;d&&x>=0;x--){d=!1;let j=D.slice(x,x+R).join(a);for(let te=0;!d&&te<n.length;te++)if(te!==w&&n[te]&&n[te].indexOf(j)>-1){const Q=x+R===D.length,N=x>0&&n[te].indexOf(a)>-1?a+j:j,U=n[te].endsWith(N);d=!Q||U}if(!d){let te="";(D[0].endsWith(":")||r!=="")&&(x===1&&(x=0,R++,j=D[0]+a+j),x>0&&(te=D[0]+a),te=r+te),x>0&&(te=te+v+a),te=te+j,x+R<D.length&&(te=te+a+v),h[w]=te}}d&&(h[w]=E)}return h}e.shorten=P;var l;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function f(n,a=Object.create(null)){const h=[];let d=!1,w="";for(const E of n)if(E==="$"||d&&E==="{")w&&h.push({value:w,type:l.TEXT}),w="",d=!0;else if(E==="}"&&d){const r=a[w];if(typeof r=="string")r.length&&h.push({value:r,type:l.VARIABLE});else if(r){const D=h[h.length-1];(!D||D.type!==l.SEPARATOR)&&h.push({value:r.label,type:l.SEPARATOR})}w="",d=!1}else w+=E;return w&&!d&&h.push({value:w,type:l.TEXT}),h.filter((E,r)=>{if(E.type===l.SEPARATOR){const D=h[r-1],R=h[r+1];return[D,R].every(x=>x&&(x.type===l.VARIABLE||x.type===l.TEXT)&&x.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=f;function p(n,a){return k.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(n,a){return k.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):k.isWindows?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function o(n){const a=n.indexOf("/")!==-1?C.posix:C.win32,h=a.basename(n),d=a.dirname(n);return h.length?{name:h,parentPath:d}:{name:d,parentPath:""}}e.splitName=o}),define(ve[101],we([0,1,30,10,8,23,9]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var y;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown"})(y=e.Mimes||(e.Mimes={}));let S=[],A=[],i=[];function I(n,a=!1){const h=u(n);S.push(h),h.userConfigured?i.push(h):A.push(h),a&&!h.userConfigured&&S.forEach(d=>{d.mime===h.mime||d.userConfigured||(h.extension&&d.extension===h.extension&&console.warn(`Overwriting extension <<${h.extension}>> to now point to mime <<${h.mime}>>`),h.filename&&d.filename===h.filename&&console.warn(`Overwriting filename <<${h.filename}>> to now point to mime <<${h.mime}>>`),h.filepattern&&d.filepattern===h.filepattern&&console.warn(`Overwriting filepattern <<${h.filepattern}>> to now point to mime <<${h.mime}>>`),h.firstline&&d.firstline===h.firstline&&console.warn(`Overwriting firstline <<${h.firstline}>> to now point to mime <<${h.mime}>>`))})}e.registerTextMime=I;function u(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?n.filepattern.toLowerCase():void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(C.posix.sep)>=0:!1}}function m(n){n?(S=S.filter(a=>!a.userConfigured),i=[]):(S=[],A=[],i=[])}e.clearTextMimes=m;function c(n,a){let h;if(n)switch(n.scheme){case L.Schemas.file:h=n.fsPath;break;case L.Schemas.data:h=k.DataUri.parseMetaData(n).get(k.DataUri.META_DATA_LABEL);break;default:h=n.path}if(!h)return[y.unknown];h=h.toLowerCase();const d=(0,C.basename)(h),w=v(h,d,i);if(w)return[w,y.text];const E=v(h,d,A);if(E)return[E,y.text];if(a){const r=_(a);if(r)return[r,y.text]}return[y.unknown]}e.guessMimeTypes=c;function v(n,a,h){let d=null,w=null,E=null;for(let r=h.length-1;r>=0;r--){const D=h[r];if(a===D.filenameLowercase){d=D;break}if(D.filepattern&&(!w||D.filepattern.length>w.filepattern.length)){const R=D.filepatternOnPath?n:a;(0,g.match)(D.filepatternLowercase,R)&&(w=D)}D.extension&&(!E||D.extension.length>E.extension.length)&&a.endsWith(D.extensionLowercase)&&(E=D)}return d?d.mime:w?w.mime:E?E.mime:null}function _(n){if((0,T.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let a=S.length-1;a>=0;a--){const h=S[a];if(!h.firstline)continue;const d=n.match(h.firstline);if(d&&d.length>0)return h.mime}return null}function b(n){return n?typeof n=="string"?n===y.binary||n===y.text||n===y.unknown:n.length===1&&b(n[0]):!0}e.isUnspecific=b;const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(n){const a=(0,C.extname)(n),h=P[a.toLowerCase()];return h!==void 0?h:p(n)}e.getMediaOrTextMime=f;function p(n){const a=(0,C.extname)(n);return l[a.toLowerCase()]}e.getMediaMime=p;function t(n){for(const a in l)if(l[a]===n)return a}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function o(n,a){const h=s.exec(n);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:a?void 0:n}e.normalizeMimeType=o}),define(ve[102],we([0,1,2]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class C{constructor(I){this._uriTransformer=I}transformIncoming(I){const u=this._uriTransformer.transformIncoming(I);return u===I?I:L(g.URI.from(u))}transformOutgoing(I){const u=this._uriTransformer.transformOutgoing(I);return u===I?I:L(g.URI.from(u))}transformOutgoingURI(I){const u=this._uriTransformer.transformOutgoing(I);return u===I?I:g.URI.from(u)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function k(i,I,u){if(!i||u>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let m in i)if(Object.hasOwnProperty.call(i,m)){const c=k(i[m],I,u+1);c!==null&&(i[m]=c)}}return null}function T(i,I){const u=k(i,I,0);return u===null?i:u}e.transformOutgoingURIs=T;function y(i,I,u,m){if(!i||m>200)return null;if(typeof i=="object"){if(i.$mid===1)return u?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let c in i)if(Object.hasOwnProperty.call(i,c)){const v=y(i[c],I,u,m+1);v!==null&&(i[c]=v)}}return null}function S(i,I){const u=y(i,I,!1,0);return u===null?i:u}e.transformIncomingURIs=S;function A(i,I){const u=y(i,I,!0,0);return u===null?i:u}e.transformAndReviveIncomingURIs=A}),define(ve[32],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return g.test(S)}e.isUUID=L;const C=new Uint8Array(16),k=[];for(let S=0;S<256;S++)k.push(S.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(S){for(let A=0;A<S.length;A++)S[A]=Math.floor(Math.random()*256);return S};function y(){T(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let S=0,A="";return A+=k[C[S++]],A+=k[C[S++]],A+=k[C[S++]],A+=k[C[S++]],A+="-",A+=k[C[S++]],A+=k[C[S++]],A+="-",A+=k[C[S++]],A+=k[C[S++]],A+="-",A+=k[C[S++]],A+=k[C[S++]],A+="-",A+=k[C[S++]],A+=k[C[S++]],A+=k[C[S++]],A+=k[C[S++]],A+=k[C[S++]],A+=k[C[S++]],A}e.generateUuid=y}),define(ve[142],we([0,1,103]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new g.StringDecoder(k),this.remaining=null}write(k){const T=[],y=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(y.length<1)return T;let S=0,A,i=S;for(;i<y.length;)if(A=y.charCodeAt(i),A===13||A===10){if(T.push(y.substring(S,i)),i++,i<y.length){const I=A;A=y.charCodeAt(i),(I===13&&A===10||I===10&&A===13)&&i++}S=i}else i++;return this.remaining=S<y.length?y.substr(S):null,T}end(){return this.remaining}}e.LineDecoder=L}),define(ve[28],we([0,1,49,79,290,17,29,77,8,11,23,2,32]),function(J,e,g,L,C,k,T,y,S,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function c(N,U=m.UNLINK){if((0,T.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return U===m.UNLINK?_(N):v(N)}async function v(N){try{const U=(0,S.join)((0,L.tmpdir)(),(0,u.generateUuid)());try{await e.Promises.rename(N,U)}catch(F){return _(N)}_(U).catch(F=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function _(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function b(N){if((0,T.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(N,{recursive:!0})}e.rimrafSync=b;async function P(N,U){return p(await(U?l(N):(0,C.promisify)(g.readdir)(N)))}async function l(N){try{return await(0,C.promisify)(g.readdir)(N,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const U=[],F=await P(N);for(const V of F){let M=!1,O=!1,q=!1;try{const B=await e.Promises.lstat((0,S.join)(N,V));M=B.isFile(),O=B.isDirectory(),q=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}U.push({name:V,isFile:()=>M,isDirectory:()=>O,isSymbolicLink:()=>q})}return U}function f(N){return p(g.readdirSync(N))}e.readdirSync=f;function p(N){return N.map(U=>typeof U=="string"?A.isMacintosh?(0,y.normalizeNFC)(U):U:(U.name=A.isMacintosh?(0,y.normalizeNFC)(U.name):U.name,U))}async function t(N){const U=await P(N),F=[];for(const V of U)await o.existsDirectory((0,S.join)(N,V))&&F.push(V);return F}function s(N,U=1e3){return new Promise(F=>{let V=!1;const M=setInterval(()=>{V||(V=!0,g.access(N,O=>{V=!1,O&&(clearInterval(M),F(void 0))}))},U)})}e.whenDeleted=s;var o;(function(N){async function U(M){let O;try{if(O=await e.Promises.lstat(M),!O.isSymbolicLink())return{stat:O}}catch(q){}try{return{stat:await e.Promises.stat(M),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(A.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw B}throw q}}N.stat=U;async function F(M){try{const{stat:O,symbolicLink:q}=await N.stat(M);return O.isFile()&&q?.dangling!==!0}catch(O){}return!1}N.existsFile=F;async function V(M){try{const{stat:O,symbolicLink:q}=await N.stat(M);return O.isDirectory()&&q?.dangling!==!0}catch(O){}return!1}N.existsDirectory=V})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new k.ResourceQueue;function a(N,U,F){return n.queueFor(I.URI.file(N),i.extUriBiasedIgnorePathCase).queue(()=>{const V=E(F);return new Promise((M,O)=>d(N,U,V,q=>q?O(q):M()))})}let h=!0;function d(N,U,F,V){if(!h)return g.writeFile(N,U,{mode:F.mode,flag:F.flag},V);g.open(N,F.flag,F.mode,(M,O)=>{if(M)return V(M);g.writeFile(O,U,q=>{if(q)return g.close(O,()=>V(q));g.fdatasync(O,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),h=!1),g.close(O,K=>V(K))))})})}function w(N,U,F){const V=E(F);if(!h)return g.writeFileSync(N,U,{mode:V.mode,flag:V.flag});const M=g.openSync(N,V.flag,V.mode);try{g.writeFileSync(M,U);try{g.fdatasyncSync(M)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),h=!1}}finally{g.closeSync(M)}}e.writeFileSync=w;function E(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function r(N,U){if(N===U)return;async function F(V){try{const M=await e.Promises.lstat(V);if(M.isDirectory()||M.isSymbolicLink())return;await e.Promises.utimes(V,M.atime,new Date)}catch(M){}}try{await e.Promises.rename(N,U),await F(U)}catch(V){if(N.toLowerCase()!==U.toLowerCase()&&V.code==="EXDEV"||N.endsWith("."))await D(N,U,{preserveSymlinks:!1}),await c(N,m.MOVE),await F(U);else throw V}}async function D(N,U,F){return x(N,U,{root:{source:N,target:U},options:F,handledSourcePaths:new Set})}const R=511;async function x(N,U,F){if(F.handledSourcePaths.has(N))return;F.handledSourcePaths.add(N);const{stat:V,symbolicLink:M}=await o.stat(N);if(M){if(F.options.preserveSymlinks)try{return await Q(N,U,F)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(M.dangling)return}return V.isDirectory()?j(N,U,V.mode&R,F):te(N,U,V.mode&R)}async function j(N,U,F,V){await e.Promises.mkdir(U,{recursive:!0,mode:F});const M=await P(N);for(const O of M)await x((0,S.join)(N,O),(0,S.join)(U,O),V)}async function te(N,U,F){await e.Promises.copyFile(N,U),await e.Promises.chmod(U,F)}async function Q(N,U,F){let V=await e.Promises.readlink(N);(0,T.isEqualOrParent)(V,F.root.source,!A.isLinux)&&(V=(0,S.join)(F.root.target,V.substr(F.root.source.length+1))),await e.Promises.symlink(V,U)}e.Promises=new class{get access(){return(0,C.promisify)(g.access)}get stat(){return(0,C.promisify)(g.stat)}get lstat(){return(0,C.promisify)(g.lstat)}get utimes(){return(0,C.promisify)(g.utimes)}get read(){return(0,C.promisify)(g.read)}get readFile(){return(0,C.promisify)(g.readFile)}get write(){return(0,C.promisify)(g.write)}get appendFile(){return(0,C.promisify)(g.appendFile)}get fdatasync(){return(0,C.promisify)(g.fdatasync)}get truncate(){return(0,C.promisify)(g.truncate)}get rename(){return(0,C.promisify)(g.rename)}get copyFile(){return(0,C.promisify)(g.copyFile)}get open(){return(0,C.promisify)(g.open)}get close(){return(0,C.promisify)(g.close)}get symlink(){return(0,C.promisify)(g.symlink)}get readlink(){return(0,C.promisify)(g.readlink)}get chmod(){return(0,C.promisify)(g.chmod)}get mkdir(){return(0,C.promisify)(g.mkdir)}get unlink(){return(0,C.promisify)(g.unlink)}get rmdir(){return(0,C.promisify)(g.rmdir)}get realpath(){return(0,C.promisify)(g.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return c}get move(){return r}get copy(){return D}}}),define(ve[104],we([0,1,49,8,9,28]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const I=(0,L.dirname)(i);if(i===I)return i;const u=((0,L.basename)(i)||i).toLowerCase();try{const c=(0,k.readdirSync)(I).filter(v=>v.toLowerCase()===u);if(c.length===1){const v=T(I);if(v)return(0,L.join)(v,c[0])}else if(c.length>1){const v=c.indexOf(u);if(v>=0){const _=T(I);if(_)return(0,L.join)(_,c[v])}}}catch(m){}return null}e.realcaseSync=T;async function y(i){try{return await k.Promises.realpath(i)}catch(I){const u=A(i);return await k.Promises.access(u,g.constants.R_OK),u}}e.realpath=y;function S(i){try{return g.realpathSync(i)}catch(I){const u=A(i);return g.accessSync(u,g.constants.R_OK),u}}e.realpathSync=S;function A(i){return(0,C.rtrim)((0,L.normalize)(i),L.sep)}});var We=this&&this.__decorate||function(J,e,g,L){var C=arguments.length,k=C<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(J,e,g,L);else for(var y=J.length-1;y>=0;y--)(T=J[y])&&(k=(C<3?T(k):C>3?T(e,g,k):T(e,g))||k);return C>3&&k&&Object.defineProperty(e,g,k),k};define(ve[105],we([0,1,20,17,24,21,56,16,3,6,59,9,14]),function(J,e,g,L,C,k,T,y,S,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function c(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function _(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(b||(b={}));class P{constructor(O){this.buffer=O,this.pos=0}read(O){const q=this.buffer.slice(this.pos,this.pos+O);return this.pos+=q.byteLength,q}}class l{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var f;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(f||(f={}));function p(M){const O=C.VSBuffer.alloc(4);return O.writeUInt32BE(M,0),O}function t(M){return M.read(4).readUInt32BE(0)}function s(M){const O=C.VSBuffer.alloc(1);return O.writeUInt8(M,0),O}const o={Undefined:s(f.Undefined),String:s(f.String),Buffer:s(f.Buffer),VSBuffer:s(f.VSBuffer),Array:s(f.Array),Object:s(f.Object)},n=typeof Buffer!="undefined";function a(M,O){if(typeof O=="undefined")M.write(o.Undefined);else if(typeof O=="string"){const q=C.VSBuffer.fromString(O);M.write(o.String),M.write(p(q.byteLength)),M.write(q)}else if(n&&Buffer.isBuffer(O)){const q=C.VSBuffer.wrap(O);M.write(o.Buffer),M.write(p(q.byteLength)),M.write(q)}else if(O instanceof C.VSBuffer)M.write(o.VSBuffer),M.write(p(O.byteLength)),M.write(O);else if(Array.isArray(O)){M.write(o.Array),M.write(p(O.length));for(const q of O)a(M,q)}else{const q=C.VSBuffer.fromString(JSON.stringify(O));M.write(o.Object),M.write(p(q.byteLength)),M.write(q)}}function h(M){switch(M.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return M.read(t(M)).toString();case f.Buffer:return M.read(t(M)).buffer;case f.VSBuffer:return M.read(t(M));case f.Array:{const q=t(M),B=[];for(let K=0;K<q;K++)B.push(h(M));return B}case f.Object:return JSON.parse(M.read(t(M)).toString())}}class d{constructor(O,q,B=null,K=1e3){this.protocol=O,this.ctx=q,this.logger=B,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ne=>this.onRawMessage(ne)),this.sendResponse({type:200})}registerChannel(O,q){this.channels.set(O,q),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const q=this.send([O.type]);this.logger&&this.logger.logOutgoing(q,0,1,_(O.type));return}case 201:case 202:case 204:case 203:{const q=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(q,O.id,1,_(O.type),O.data);return}}}send(O,q=void 0){const B=new l;return a(B,O),a(B,q),this.sendBuffer(B.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(q){return 0}}onRawMessage(O){const q=new P(O),B=h(q),K=h(q),ne=B[0];switch(ne){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${c(ne)}: ${B[2]}.${B[3]}`,K),this.onPromise({type:ne,id:B[1],channelName:B[2],name:B[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${c(ne)}: ${B[2]}.${B[3]}`,K),this.onEventListen({type:ne,id:B[1],channelName:B[2],name:B[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${c(ne)}`),this.disposeActiveRequest({type:ne,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],1,`${c(ne)}`),this.disposeActiveRequest({type:ne,id:B[1]})}}onPromise(O){const q=this.channels.get(O.channelName);if(!q){this.collectPendingRequest(O);return}const B=new k.CancellationTokenSource;let K;try{K=q.call(this.ctx,O.name,O.arg,B.token)}catch(Se){K=Promise.reject(Se)}const ne=O.id;K.then(Se=>{this.sendResponse({id:ne,data:Se,type:201}),this.activeRequests.delete(O.id)},Se=>{Se instanceof Error?this.sendResponse({id:ne,data:{message:Se.message,name:Se.name,stack:Se.stack?Se.stack.split?Se.stack.split(`
`):Se.stack:void 0},type:202}):this.sendResponse({id:ne,data:Se,type:203}),this.activeRequests.delete(O.id)});const me=(0,A.toDisposable)(()=>B.cancel());this.activeRequests.set(O.id,me)}onEventListen(O){const q=this.channels.get(O.channelName);if(!q){this.collectPendingRequest(O);return}const B=O.id,ne=q.listen(this.ctx,O.name,O.arg)(me=>this.sendResponse({id:B,data:me,type:204}));this.activeRequests.set(O.id,ne)}disposeActiveRequest(O){const q=this.activeRequests.get(O.id);q&&(q.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let q=this.pendingRequests.get(O.channelName);q||(q=[],this.pendingRequests.set(O.channelName,q));const B=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:O,timeoutTimer:B})}flushPendingRequests(O){const q=this.pendingRequests.get(O);if(q){for(const B of q)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var w;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(O,q=null){this.protocol=O,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=q}getChannel(O){const q=this;return{call(B,K,ne){return q.isDisposed?Promise.reject(y.canceled()):q.requestPromise(O,B,K,ne)},listen(B,K){return q.isDisposed?Promise.reject(y.canceled()):q.requestEvent(O,B,K)}}}requestPromise(O,q,B,K=k.CancellationToken.None){const ne=this.lastRequestId++,Se={id:ne,type:100,channelName:O,name:q,arg:B};if(K.isCancellationRequested)return Promise.reject(y.canceled());let Ce;return new Promise((je,Be)=>{if(K.isCancellationRequested)return Be(y.canceled());const Ve=()=>{const le=Y=>{switch(Y.type){case 201:this.handlers.delete(ne),je(Y.data);break;case 202:this.handlers.delete(ne);const ae=new Error(Y.data.message);ae.stack=Y.data.stack,ae.name=Y.data.name,Be(ae);break;case 203:this.handlers.delete(ne),Be(Y.data);break}};this.handlers.set(ne,le),this.sendRequest(Se)};let W=null;this.state===b.Idle?Ve():(W=(0,L.createCancelablePromise)(le=>this.whenInitialized()),W.then(()=>{W=null,Ve()}));const Z=()=>{W?(W.cancel(),W=null):this.sendRequest({id:ne,type:101}),Be(y.canceled())},ie=K.onCancellationRequested(Z);Ce=(0,A.combinedDisposable)((0,A.toDisposable)(Z),ie),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(O,q,B){const K=this.lastRequestId++,me={id:K,type:102,channelName:O,name:q,arg:B};let Se=null;const Ce=new S.Emitter({onFirstListenerAdd:()=>{Se=(0,L.createCancelablePromise)(je=>this.whenInitialized()),Se.then(()=>{Se=null,this.activeRequests.add(Ce),this.sendRequest(me)})},onLastListenerRemove:()=>{Se?(Se.cancel(),Se=null):(this.activeRequests.delete(Ce),this.sendRequest({id:K,type:103}))}}),Te=je=>Ce.fire(je.data);return this.handlers.set(K,Te),Ce.event}sendRequest(O){switch(O.type){case 100:case 102:{const q=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(q,O.id,0,`${c(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const q=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(q,O.id,0,c(O.type));return}}}send(O,q=void 0){const B=new l;return a(B,O),a(B,q),this.sendBuffer(B.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(q){return 0}}onBuffer(O){const q=new P(O),B=h(q),K=h(q),ne=B[0];switch(ne){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,_(ne)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,B[1],0,_(ne),K),this.onResponse({type:B[0],id:B[1],data:K})}}onResponse(O){if(O.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(O.id);q&&q(O)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}We([T.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class r{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:q,onDidClientDisconnect:B})=>{S.Event.once(q.onMessage)(ne=>{const me=new P(ne),Se=h(me),Ce=new d(q,Se),Te=new E(q);this.channels.forEach((Be,Ve)=>Ce.registerChannel(Ve,Be));const je={channelServer:Ce,channelClient:Te,ctx:Se};this._connections.add(je),this._onDidAddConnection.fire(je),B(()=>{Ce.dispose(),Te.dispose(),this._connections.delete(je),this._onDidRemoveConnection.fire(je)})})})}get connections(){const O=[];return this._connections.forEach(q=>O.push(q)),O}getChannel(O,q){const B=this;return{call(K,ne,me){let Se;if((0,u.isFunction)(q)){let Te=(0,g.getRandomElement)(B.connections.filter(q));Se=Te?Promise.resolve(Te):S.Event.toPromise(S.Event.filter(B.onDidAddConnection,q))}else Se=q.routeCall(B,K,ne);const Ce=Se.then(Te=>Te.channelClient.getChannel(O));return R(Ce).call(K,ne,me)},listen(K,ne){if((0,u.isFunction)(q))return B.getMulticastEvent(O,q,K,ne);const me=q.routeEvent(B,K,ne).then(Se=>Se.channelClient.getChannel(O));return R(me).listen(K,ne)}}}getMulticastEvent(O,q,B,K){const ne=this;let me=new A.DisposableStore;const Se=new S.Emitter({onFirstListenerAdd:()=>{me=new A.DisposableStore;const Ce=new S.EventMultiplexer,Te=new Map,je=Ve=>{const Z=Ve.channelClient.getChannel(O).listen(B,K),ie=Ce.add(Z);Te.set(Ve,ie)},Be=Ve=>{const W=Te.get(Ve);!W||(W.dispose(),Te.delete(Ve))};ne.connections.filter(q).forEach(je),S.Event.filter(ne.onDidAddConnection,q)(je,void 0,me),ne.onDidRemoveConnection(Be,void 0,me),Ce.event(Se.fire,Se,me),me.add(Ce)},onLastListenerRemove:()=>{me.dispose()}});return Se.event}registerChannel(O,q){this.channels.set(O,q),this._connections.forEach(B=>{B.channelServer.registerChannel(O,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=r;class D{constructor(O,q,B=null){const K=new l;a(K,q),O.send(K.buffer),this.channelClient=new E(O,B),this.channelServer=new d(O,q,B)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,q){this.channelServer.registerChannel(O,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function R(M){return{call(O,q,B){return M.then(K=>K.call(O,q,B))},listen(O,q){const B=new S.Relay;return M.then(K=>B.input=K.listen(O,q)),B.event}}}e.getDelayedChannel=R;function x(M){let O=!1;return{call(q,B,K){return O?M.call(q,B,K):(0,L.timeout)(0).then(()=>O=!0).then(()=>M.call(q,B,K))},listen(q,B){if(O)return M.listen(q,B);const K=new S.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>K.input=M.listen(q,B)),K.event}}}e.getNextTickChannel=x;class j{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const q of O.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await S.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=j;var te;(function(M){function O(K,ne){const me=K,Se=ne&&ne.disableMarshalling,Ce=new Map;for(const Te in me)B(Te)&&Ce.set(Te,S.Event.buffer(me[Te],!0));return new class{listen(Te,je){const Be=Ce.get(je);if(Be)return Be;throw new Error(`Event not found: ${je}`)}call(Te,je,Be){const Ve=me[je];if(typeof Ve=="function"){if(!Se&&Array.isArray(Be))for(let W=0;W<Be.length;W++)Be[W]=(0,i.revive)(Be[W]);return Ve.apply(me,Be)}throw new Error(`Method not found: ${je}`)}}}M.fromService=O;function q(K,ne){const me=ne&&ne.disableMarshalling;return new Proxy({},{get(Se,Ce){if(typeof Ce=="string")return ne?.properties?.has(Ce)?ne.properties.get(Ce):B(Ce)?K.listen(Ce):async function(...Te){let je;ne&&!(0,u.isUndefinedOrNull)(ne.context)?je=[ne.context,...Te]:je=Te;const Be=await K.call(Ce,je);return me?Be:(0,i.revive)(Be)};throw new Error(`Property not found: ${String(Ce)}`)}})}M.toService=q;function B(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}})(te=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let O=M.toString();if(O!=="[object Object]")return O}return M}function U(M){return Array.isArray(M)?M.map(N):N(M)}function F(M,O,q,B,K,ne,me){me=U(me);const Se=Q[K],Ce=Se[B%Se.length];let Te=[`%c[${M}]%c[${String(O).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(ne)?(Te=Te.concat(me),Te.push(")")):Te.push(me),console.log.apply(console,Te)}e.logWithColors=F;class V{constructor(O,q){this._outgoingPrefix=O,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,q,B,K,ne){this._totalOutgoing+=O,F(this._outgoingPrefix,this._totalOutgoing,O,q,B,K,ne)}logIncoming(O,q,B,K,ne){this._totalIncoming+=O,F(this._incomingPrefix,this._totalIncoming,O,q,B,K,ne)}}e.IPCLogger=V}),define(ve[106],we([0,1,24,3,6,11,38,105]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function i(){return A||(A=g.VSBuffer.alloc(0)),A}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,a){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const E=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=n),E}if(this._chunks[0].byteLength>n){const E=this._chunks[0].slice(0,n);return a&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),E}let h=g.VSBuffer.alloc(n),d=0,w=0;for(;n>0;){const E=this._chunks[w];if(E.byteLength>n){const r=E.slice(0,n);h.set(r,d),d+=n,a&&(this._chunks[w]=E.slice(n),this._totalLength-=n),n-=n}else h.set(E,d),d+=E.byteLength,a?(this._chunks.shift(),this._totalLength-=E.byteLength):w++,n-=E.byteLength}return h}}e.ChunkStream=I;var u;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.KeepAlive=4]="KeepAlive",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest"})(u||(u={}));var m;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",o[o.KeepAliveTime=5e3]="KeepAliveTime",o[o.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(n,a,h,d){this.type=n,this.id=a,this.ack=h,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends C.Disposable{constructor(n){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const h=this._state.messageType,d=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new c(h,d,w,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=g.VSBuffer.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this._writeSoon(a,n.data)}_bufferAdd(n,a){const h=this._totalLength===0;return this._data.push(n,a),this._totalLength+=n.byteLength+a.byteLength,h}_bufferTake(){const n=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,a){this._bufferAdd(n,a)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends C.Disposable{constructor(n){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new c(1,0,0,n))}}e.Protocol=b;class P extends y.IPCClient{constructor(n,a,h=null){super(n,a,h);this.protocol=n}static fromSocket(n,a){return new P(new b(n),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=P;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,T.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class f{constructor(n){this.data=n,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],a=0,h=this._first;for(;h;)n[a++]=h.data,h=h.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const a=new f(n);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=n-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let h=0;for(let d=0;d<t._HISTORY_LENGTH;d++)n-this.lastRuns[d]<=a&&h++;return 1-h/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(n,a=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new c(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const a=new c(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,a){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let a=0,h=n.length;a<h;a++)this._socketWriter.write(n[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new c(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const a=this._outgoingUnackMsg.toArray();for(let h=0,d=a.length;h<d;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new c(1,a,this._incomingAckId,n);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(n){const a=new c(2,0,0,n);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),a=Date.now()-n.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new c(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(ve[107],we([0,1,96]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(y){let S=(0,g.toUint8)(y);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(y){let S=new Uint8Array(256);for(let A=0;A<256;A++)S[A]=y;return S}set(y,S){let A=(0,g.toUint8)(S);y>=0&&y<256?this._asciiMap[y]=A:this._map.set(y,A)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=L;var C;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(C||(C={}));class k{constructor(){this._actual=new L(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=k}),define(ve[143],we([0,1,107]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends g.CharacterClassifier{constructor(y){super(0);for(let S=0,A=y.length;S<A;S++)this.set(y.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function k(T){let y={};return S=>(y.hasOwnProperty(S)||(y[S]=T(S)),y[S])}e.getMapForWordSeparators=k(T=>new C(T))}),define(ve[50],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(C,k){this.lineNumber=C,this.column=k}with(C=this.lineNumber,k=this.column){return C===this.lineNumber&&k===this.column?this:new g(C,k)}delta(C=0,k=0){return this.with(this.lineNumber+C,this.column+k)}equals(C){return g.equals(this,C)}static equals(C,k){return!C&&!k?!0:!!C&&!!k&&C.lineNumber===k.lineNumber&&C.column===k.column}isBefore(C){return g.isBefore(this,C)}static isBefore(C,k){return C.lineNumber<k.lineNumber?!0:k.lineNumber<C.lineNumber?!1:C.column<k.column}isBeforeOrEqual(C){return g.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,k){return C.lineNumber<k.lineNumber?!0:k.lineNumber<C.lineNumber?!1:C.column<=k.column}static compare(C,k){let T=C.lineNumber|0,y=k.lineNumber|0;if(T===y){let S=C.column|0,A=k.column|0;return S-A}return T-y}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new g(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=g}),define(ve[41],we([0,1,50]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(k,T,y,S){k>y||k===y&&T>S?(this.startLineNumber=y,this.startColumn=S,this.endLineNumber=k,this.endColumn=T):(this.startLineNumber=k,this.startColumn=T,this.endLineNumber=y,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return L.containsPosition(this,k)}static containsPosition(k,T){return!(T.lineNumber<k.startLineNumber||T.lineNumber>k.endLineNumber||T.lineNumber===k.startLineNumber&&T.column<k.startColumn||T.lineNumber===k.endLineNumber&&T.column>k.endColumn)}containsRange(k){return L.containsRange(this,k)}static containsRange(k,T){return!(T.startLineNumber<k.startLineNumber||T.endLineNumber<k.startLineNumber||T.startLineNumber>k.endLineNumber||T.endLineNumber>k.endLineNumber||T.startLineNumber===k.startLineNumber&&T.startColumn<k.startColumn||T.endLineNumber===k.endLineNumber&&T.endColumn>k.endColumn)}strictContainsRange(k){return L.strictContainsRange(this,k)}static strictContainsRange(k,T){return!(T.startLineNumber<k.startLineNumber||T.endLineNumber<k.startLineNumber||T.startLineNumber>k.endLineNumber||T.endLineNumber>k.endLineNumber||T.startLineNumber===k.startLineNumber&&T.startColumn<=k.startColumn||T.endLineNumber===k.endLineNumber&&T.endColumn>=k.endColumn)}plusRange(k){return L.plusRange(this,k)}static plusRange(k,T){let y,S,A,i;return T.startLineNumber<k.startLineNumber?(y=T.startLineNumber,S=T.startColumn):T.startLineNumber===k.startLineNumber?(y=T.startLineNumber,S=Math.min(T.startColumn,k.startColumn)):(y=k.startLineNumber,S=k.startColumn),T.endLineNumber>k.endLineNumber?(A=T.endLineNumber,i=T.endColumn):T.endLineNumber===k.endLineNumber?(A=T.endLineNumber,i=Math.max(T.endColumn,k.endColumn)):(A=k.endLineNumber,i=k.endColumn),new L(y,S,A,i)}intersectRanges(k){return L.intersectRanges(this,k)}static intersectRanges(k,T){let y=k.startLineNumber,S=k.startColumn,A=k.endLineNumber,i=k.endColumn,I=T.startLineNumber,u=T.startColumn,m=T.endLineNumber,c=T.endColumn;return y<I?(y=I,S=u):y===I&&(S=Math.max(S,u)),A>m?(A=m,i=c):A===m&&(i=Math.min(i,c)),y>A||y===A&&S>i?null:new L(y,S,A,i)}equalsRange(k){return L.equalsRange(this,k)}static equalsRange(k,T){return!!k&&!!T&&k.startLineNumber===T.startLineNumber&&k.startColumn===T.startColumn&&k.endLineNumber===T.endLineNumber&&k.endColumn===T.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(k){return new g.Position(k.endLineNumber,k.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(k){return new g.Position(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,T){return new L(this.startLineNumber,this.startColumn,k,T)}setStartPosition(k,T){return new L(k,T,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(k){return new L(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}static fromPositions(k,T=k){return new L(k.lineNumber,k.column,T.lineNumber,T.column)}static lift(k){return k?new L(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,T){return!(k.endLineNumber<T.startLineNumber||k.endLineNumber===T.startLineNumber&&k.endColumn<T.startColumn||T.endLineNumber<k.startLineNumber||T.endLineNumber===k.startLineNumber&&T.endColumn<k.startColumn)}static areIntersecting(k,T){return!(k.endLineNumber<T.startLineNumber||k.endLineNumber===T.startLineNumber&&k.endColumn<=T.startColumn||T.endLineNumber<k.startLineNumber||T.endLineNumber===k.startLineNumber&&T.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,T){if(k&&T){const A=k.startLineNumber|0,i=T.startLineNumber|0;if(A===i){const I=k.startColumn|0,u=T.startColumn|0;if(I===u){const m=k.endLineNumber|0,c=T.endLineNumber|0;if(m===c){const v=k.endColumn|0,_=T.endColumn|0;return v-_}return m-c}return I-u}return A-i}return(k?1:0)-(T?1:0)}static compareRangesUsingEnds(k,T){return k.endLineNumber===T.endLineNumber?k.endColumn===T.endColumn?k.startLineNumber===T.startLineNumber?k.startColumn-T.startColumn:k.startLineNumber-T.startLineNumber:k.endColumn-T.endColumn:k.endLineNumber-T.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}}e.Range=L}),define(ve[144],we([0,1,50,41]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class k extends L.Range{constructor(y,S,A,i){super(y,S,A,i);this.selectionStartLineNumber=y,this.selectionStartColumn=S,this.positionLineNumber=A,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return k.selectionsEqual(this,y)}static selectionsEqual(y,S){return y.selectionStartLineNumber===S.selectionStartLineNumber&&y.selectionStartColumn===S.selectionStartColumn&&y.positionLineNumber===S.positionLineNumber&&y.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,S){return this.getDirection()===0?new k(this.startLineNumber,this.startColumn,y,S):new k(y,S,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,S){return this.getDirection()===0?new k(y,S,this.endLineNumber,this.endColumn):new k(this.endLineNumber,this.endColumn,y,S)}static fromPositions(y,S=y){return new k(y.lineNumber,y.column,S.lineNumber,S.column)}static liftSelection(y){return new k(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,S){if(y&&!S||!y&&S)return!1;if(!y&&!S)return!0;if(y.length!==S.length)return!1;for(let A=0,i=y.length;A<i;A++)if(!this.selectionsEqual(y[A],S[A]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,S,A,i,I){return I===0?new k(y,S,A,i):new k(A,i,y,S)}}e.Selection=k}),define(ve[108],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var L;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(L=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace)}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class S{constructor(v,_){this._findMatchBrand=void 0,this.range=v,this.matches=_}}e.FindMatch=S;var A;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(A=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None"})(i=e.PositionAffinity||(e.PositionAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class u{constructor(v,_,b,P,l,f){this.identifier=v,this.range=_,this.text=b,this.forceMoveMarkers=P,this.isAutoWhitespaceEdit=l,this._isTracked=f}}e.ValidAnnotatedEditOperation=u;class m{constructor(v,_,b){this.reverseEdits=v,this.changes=_,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=m}),define(ve[145],we([0,1,9,143,50,41,108]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class S{constructor(l,f,p,t){this.searchString=l,this.isRegex=f,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=A(this.searchString):l=this.searchString.indexOf(`
`)>=0;let f=null;try{f=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let p=!this.isRegex&&!l;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new i(f,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=S;function A(P){if(!P||P.length===0)return!1;for(let l=0,f=P.length;l<f;l++)if(P.charCodeAt(l)===92){if(l++,l>=f)break;const t=P.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=A;class i{constructor(l,f,p){this.regex=l,this.wordSeparators=f,this.simpleSearch=p}}e.SearchData=i;function I(P,l,f){if(!f)return new T.FindMatch(P,null);let p=[];for(let t=0,s=l.length;t<s;t++)p[t]=l[t];return new T.FindMatch(P,p)}e.createFindMatch=I;class u{constructor(l){let f=[],p=0;for(let t=0,s=l.length;t<s;t++)l.charCodeAt(t)===10&&(f[p++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(l){const f=this._lineFeedsOffsets;let p=0,t=f.length-1;if(t===-1||l<=f[0])return 0;for(;p<t;){const s=p+((t-p)/2>>0);f[s]>=l?t=s-1:f[s+1]>=l?(p=s,t=s):p=s+1}return p+1}}class m{static findMatches(l,f,p,t,s){const o=f.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(l,p,new b(o.wordSeparators,o.regex),t,s):this._doFindMatchesLineByLine(l,p,o,t,s):[]}static _getMultilineMatchRange(l,f,p,t,s,o){let n,a=0;t?(a=t.findLineFeedCountBeforeOffset(s),n=f+s+a):n=f+s;let h;if(t){let r=t.findLineFeedCountBeforeOffset(s+o.length)-a;h=n+o.length+r}else h=n+o.length;const d=l.getPositionAt(n),w=l.getPositionAt(h);return new k.Range(d.lineNumber,d.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(l,f,p,t,s){const o=l.getOffsetAt(f.getStartPosition()),n=l.getValueInRange(f,1),a=l.getEOL()===`\r
`?new u(n):null,h=[];let d=0,w;for(p.reset(0);w=p.next(n);)if(h[d++]=I(this._getMultilineMatchRange(l,o,n,a,w.index,w[0]),w,t),d>=s)return h;return h}static _doFindMatchesLineByLine(l,f,p,t,s){const o=[];let n=0;if(f.startLineNumber===f.endLineNumber){const h=l.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return n=this._findMatchesInLine(p,h,f.startLineNumber,f.startColumn-1,n,o,t,s),o}const a=l.getLineContent(f.startLineNumber).substring(f.startColumn-1);n=this._findMatchesInLine(p,a,f.startLineNumber,f.startColumn-1,n,o,t,s);for(let h=f.startLineNumber+1;h<f.endLineNumber&&n<s;h++)n=this._findMatchesInLine(p,l.getLineContent(h),h,0,n,o,t,s);if(n<s){const h=l.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);n=this._findMatchesInLine(p,h,f.endLineNumber,0,n,o,t,s)}return o}static _findMatchesInLine(l,f,p,t,s,o,n,a){const h=l.wordSeparators;if(!n&&l.simpleSearch){const E=l.simpleSearch,r=E.length,D=f.length;let R=-r;for(;(R=f.indexOf(E,R+r))!==-1;)if((!h||_(h,f,D,R,r))&&(o[s++]=new T.FindMatch(new k.Range(p,R+1+t,p,R+1+r+t),null),s>=a))return s;return s}const d=new b(l.wordSeparators,l.regex);let w;d.reset(0);do if(w=d.next(f),w&&(o[s++]=I(new k.Range(p,w.index+1+t,p,w.index+1+w[0].length+t),w,n),s>=a))return s;while(w);return s}static findNextMatch(l,f,p,t){const s=f.parseSearchRequest();if(!s)return null;const o=new b(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(l,p,o,t):this._doFindNextMatchLineByLine(l,p,o,t)}static _doFindNextMatchMultiline(l,f,p,t){const s=new C.Position(f.lineNumber,1),o=l.getOffsetAt(s),n=l.getLineCount(),a=l.getValueInRange(new k.Range(s.lineNumber,s.column,n,l.getLineMaxColumn(n)),1),h=l.getEOL()===`\r
`?new u(a):null;p.reset(f.column-1);let d=p.next(a);return d?I(this._getMultilineMatchRange(l,o,a,h,d.index,d[0]),d,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(l,new C.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(l,f,p,t){const s=l.getLineCount(),o=f.lineNumber,n=l.getLineContent(o),a=this._findFirstMatchInLine(p,n,o,f.column,t);if(a)return a;for(let h=1;h<=s;h++){const d=(o+h-1)%s,w=l.getLineContent(d+1),E=this._findFirstMatchInLine(p,w,d+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(l,f,p,t,s){l.reset(t-1);const o=l.next(f);return o?I(new k.Range(p,o.index+1,p,o.index+1+o[0].length),o,s):null}static findPreviousMatch(l,f,p,t){const s=f.parseSearchRequest();if(!s)return null;const o=new b(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(l,p,o,t):this._doFindPreviousMatchLineByLine(l,p,o,t)}static _doFindPreviousMatchMultiline(l,f,p,t){const s=this._doFindMatchesMultiline(l,new k.Range(1,1,f.lineNumber,f.column),p,t,10*y);if(s.length>0)return s[s.length-1];const o=l.getLineCount();return f.lineNumber!==o||f.column!==l.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(l,new C.Position(o,l.getLineMaxColumn(o)),p,t):null}static _doFindPreviousMatchLineByLine(l,f,p,t){const s=l.getLineCount(),o=f.lineNumber,n=l.getLineContent(o).substring(0,f.column-1),a=this._findLastMatchInLine(p,n,o,t);if(a)return a;for(let h=1;h<=s;h++){const d=(s+o-h-1)%s,w=l.getLineContent(d+1),E=this._findLastMatchInLine(p,w,d+1,t);if(E)return E}return null}static _findLastMatchInLine(l,f,p,t){let s=null,o;for(l.reset(0);o=l.next(f);)s=I(new k.Range(p,o.index+1,p,o.index+1+o[0].length),o,t);return s}}e.TextModelSearch=m;function c(P,l,f,p,t){if(p===0)return!0;const s=l.charCodeAt(p-1);if(P.get(s)!==0||s===13||s===10)return!0;if(t>0){const o=l.charCodeAt(p);if(P.get(o)!==0)return!0}return!1}function v(P,l,f,p,t){if(p+t===f)return!0;const s=l.charCodeAt(p+t);if(P.get(s)!==0||s===13||s===10)return!0;if(t>0){const o=l.charCodeAt(p+t-1);if(P.get(o)!==0)return!0}return!1}function _(P,l,f,p,t){return c(P,l,f,p,t)&&v(P,l,f,p,t)}e.isValidMatch=_;class b{constructor(l,f){this._wordSeparators=l,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const f=l.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(p=this._searchRegex.exec(l),!p))return null;const t=p.index,s=p[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){g.getNextCodePoint(l,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||_(this._wordSeparators,l,f,t,s))return p}while(p);return null}}e.Searcher=b}),define(ve[109],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(y=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)y.indexOf(A)>=0||(S+="\\"+A);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=g();function L(y){let S=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)S=y;else{let A="g";y.ignoreCase&&(A+="i"),y.multiline&&(A+="m"),y.unicode&&(A+="u"),S=new RegExp(y.source,A)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const C={maxLen:1e3,windowSize:15,timeBudget:150};function k(y,S,A,i,I=C){if(A.length>I.maxLen){let _=y-I.maxLen/2;return _<0?_=0:i+=_,A=A.substring(_,y+I.maxLen/2),k(y,S,A,i,I)}const u=Date.now(),m=y-1-i;let c=-1,v=null;for(let _=1;!(Date.now()-u>=I.timeBudget);_++){const b=m-I.windowSize*_;S.lastIndex=Math.max(0,b);const P=T(S,A,m,c);if(!P&&v||(v=P,b<=0))break;c=b}if(v){let _={word:v[0],startColumn:i+1+v.index,endColumn:i+1+v.index+v[0].length};return S.lastIndex=0,_}return null}e.getWordAtText=k;function T(y,S,A,i){let I;for(;I=y.exec(S);){const u=I.index||0;if(u<=A&&y.lastIndex>=A)return I;if(i>0&&u>i)return null}return null}}),define(ve[146],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(y){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let S=0,A=y.notIn.length;S<A;S++)switch(y.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=L;class C{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of y)k(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),k(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),k(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),k(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&k(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=C;function k(T,y,S){T.has(y)?T.get(y).push(S):T.set(y,[S])}}),define(ve[80],we([0,1,30,8]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(k,T,y,S){if(Array.isArray(k)){let A=0;for(const i of k){const I=C(i,T,y,S);if(I===10)return I;I>A&&(A=I)}return A}else{if(typeof k=="string")return S?k==="*"?5:k===y?10:0:0;if(k){const{language:A,pattern:i,scheme:I,hasAccessToAllModels:u}=k;if(!S&&!u)return 0;let m=0;if(I)if(I===T.scheme)m=10;else if(I==="*")m=5;else return 0;if(A)if(A===y)m=10;else if(A==="*")m=Math.max(m,5);else return 0;if(i){let c;if(typeof i=="string"?c=i:c={...i,base:(0,L.normalize)(i.base)},c===T.fsPath||(0,g.match)(c,T.fsPath))m=10;else return 0}return m}else return 0}}e.score=C}),define(ve[147],we([0,1,107]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class C{constructor(c,v,_){const b=new Uint8Array(c*v);for(let P=0,l=c*v;P<l;P++)b[P]=_;this._data=b,this.rows=c,this.cols=v}get(c,v){return this._data[c*this.cols+v]}set(c,v,_){this._data[c*this.cols+v]=_}}e.Uint8Matrix=C;class k{constructor(c){let v=0,_=0;for(let P=0,l=c.length;P<l;P++){let[f,p,t]=c[P];p>v&&(v=p),f>_&&(_=f),t>_&&(_=t)}v++,_++;let b=new C(_,v,0);for(let P=0,l=c.length;P<l;P++){let[f,p,t]=c[P];b.set(f,p,t)}this._states=b,this._maxCharCode=v}nextState(c,v){return v<0||v>=this._maxCharCode?0:this._states.get(c,v)}}e.StateMachine=k;let T=null;function y(){return T===null&&(T=new k([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var S;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let A=null;function i(){if(A===null){A=new g.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)A.set(m.charCodeAt(v),1);const c=".,;";for(let v=0;v<c.length;v++)A.set(c.charCodeAt(v),2)}return A}class I{static _createLink(c,v,_,b,P){let l=P-1;do{const f=v.charCodeAt(l);if(c.get(f)!==2)break;l--}while(l>b);if(b>0){const f=v.charCodeAt(b-1),p=v.charCodeAt(l);(f===40&&p===41||f===91&&p===93||f===123&&p===125)&&l--}return{range:{startLineNumber:_,startColumn:b+1,endLineNumber:_,endColumn:l+2},url:v.substring(b,l+1)}}static computeLinks(c,v=y()){const _=i();let b=[];for(let P=1,l=c.getLineCount();P<=l;P++){const f=c.getLineContent(P),p=f.length;let t=0,s=0,o=0,n=1,a=!1,h=!1,d=!1,w=!1;for(;t<p;){let E=!1;const r=f.charCodeAt(t);if(n===13){let D;switch(r){case 40:a=!0,D=0;break;case 41:D=a?0:1;break;case 91:d=!0,h=!0,D=0;break;case 93:d=!1,D=h?0:1;break;case 123:w=!0,D=0;break;case 125:D=w?0:1;break;case 39:D=o===34||o===96?0:1;break;case 34:D=o===39||o===96?0:1;break;case 96:D=o===39||o===34?0:1;break;case 42:D=o===42?1:0;break;case 124:D=o===124?1:0;break;case 32:D=d?0:1;break;default:D=_.get(r)}D===1&&(b.push(I._createLink(_,f,P,s,t)),E=!0)}else if(n===12){let D;r===91?(h=!0,D=0):D=_.get(r),D===1?E=!0:n=13}else n=v.nextState(n,r),n===0&&(E=!0);E&&(n=1,a=!1,h=!1,w=!1,s=t+1,o=r),t++}n===13&&b.push(I._createLink(_,f,P,s,p))}return b}}e.LinkComputer=I;function u(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:I.computeLinks(m)}e.computeLinks=u}),define(ve[148],we([0,1,3,6]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,y){return this._map.set(T,y),this.fire([T]),(0,L.toDisposable)(()=>{this._map.get(T)===y&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,y){let S=null,A=!1;return this._promises.set(T,y.then(i=>{this._promises.delete(T),!(A||!i)&&(S=this.register(T,i))})),(0,L.toDisposable)(()=>{A=!0,S&&S.dispose()})}getPromise(T){const y=this.get(T);if(y)return Promise.resolve(y);const S=this._promises.get(T);return S?S.then(A=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(ve[110],we([0,1,24,11]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(C||(C={}));function k(I){for(let u=0,m=I.length;u<m;u+=4){const c=I[u+0],v=I[u+1],_=I[u+2],b=I[u+3];I[u+0]=b,I[u+1]=_,I[u+2]=v,I[u+3]=c}}function T(I){const u=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||k(u),g.VSBuffer.wrap(u)}function y(I){const u=I.buffer;if(L.isLittleEndian()||k(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const m=new Uint8Array(u.byteLength);return m.set(u),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function S(I){const u=new Uint32Array(A(I));let m=0;if(u[m++]=I.id,I.type==="full")u[m++]=1,u[m++]=I.data.length,u.set(I.data,m),m+=I.data.length;else{u[m++]=2,u[m++]=I.deltas.length;for(const c of I.deltas)u[m++]=c.start,u[m++]=c.deleteCount,c.data?(u[m++]=c.data.length,u.set(c.data,m),m+=c.data.length):u[m++]=0}return T(u)}e.encodeSemanticTokensDto=S;function A(I){let u=0;if(u+=1+1,I.type==="full")u+=1+I.data.length;else{u+=1,u+=(1+1+1)*I.deltas.length;for(const m of I.deltas)m.data&&(u+=m.data.length)}return u}function i(I){const u=y(I);let m=0;const c=u[m++];if(u[m++]===1){const P=u[m++],l=u.subarray(m,m+P);return m+=P,{id:c,type:"full",data:l}}const _=u[m++];let b=[];for(let P=0;P<_;P++){const l=u[m++],f=u[m++],p=u[m++];let t;p>0&&(t=u.subarray(m,m+p),m+=p),b[P]={start:l,deleteCount:f,data:t}}return{id:c,type:"delta",deltas:b}}e.decodeSemanticTokensDto=i}),define(ve[111],we([0,1,96]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(T,y){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=y}}e.PrefixSumIndexOfResult=L;class C{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,y){T=(0,g.toUint32)(T);const S=this.values,A=this.prefixSum,i=y.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,T),0),this.values.set(S.subarray(T),T+i),this.values.set(y,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,y){return T=(0,g.toUint32)(T),y=(0,g.toUint32)(y),this.values[T]===y?!1:(this.values[T]=y,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,y){T=(0,g.toUint32)(T),y=(0,g.toUint32)(y);const S=this.values,A=this.prefixSum;if(T>=S.length)return!1;let i=S.length-T;return y>=i&&(y=i),y===0?!1:(this.values=new Uint32Array(S.length-y),this.values.set(S.subarray(0,T),0),this.values.set(S.subarray(T+y),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,g.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),T>=this.values.length&&(T=this.values.length-1);for(let S=y;S<=T;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let y=0,S=this.values.length-1,A=0,i=0,I=0;for(;y<=S;)if(A=y+(S-y)/2|0,i=this.prefixSum[A],I=i-this.values[A],T<I)S=A-1;else if(T>=i)y=A+1;else break;return new L(A,T-I)}}e.PrefixSumComputer=C}),define(ve[149],we([0,1,9,50,111]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class k{constructor(y,S,A,i){this._uri=y,this._lines=S,this._eol=A,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const S=y.changes;for(const A of S)this._acceptDeleteRange(A.range),this._acceptInsertText(new L.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,S=this._lines.length,A=new Uint32Array(S);for(let i=0;i<S;i++)A[i]=this._lines[i].length+y;this._lineStarts=new C.PrefixSumComputer(A)}}_setLineText(y,S){this._lines[y]=S,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,S){if(S.length===0)return;let A=(0,g.splitLines)(S);if(A.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+A[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}A[A.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+A[0]);let i=new Uint32Array(A.length-1);for(let I=1;I<A.length;I++)this._lines.splice(y.lineNumber+I-1,0,A[I]),i[I-1]=A[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,i)}}e.MirrorTextModel=k}),define(ve[150],we([18,19]),function(J,e){return J.create("vs/base/common/date",e)}),define(ve[151],we([0,1,150]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,C=L*60,k=C*24,T=k*7,y=k*30,S=k*365;function A(I,u){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,g.localize)(0,null,A(new Date().getTime()+m*1e3,!1));if(m<30)return(0,g.localize)(1,null);let c;return m<L?(c=m,u?c===1?(0,g.localize)(2,null,c):(0,g.localize)(3,null,c):c===1?(0,g.localize)(4,null,c):(0,g.localize)(5,null,c)):m<C?(c=Math.floor(m/L),u?c===1?(0,g.localize)(6,null,c):(0,g.localize)(7,null,c):c===1?(0,g.localize)(8,null,c):(0,g.localize)(9,null,c)):m<k?(c=Math.floor(m/C),u?c===1?(0,g.localize)(10,null,c):(0,g.localize)(11,null,c):c===1?(0,g.localize)(12,null,c):(0,g.localize)(13,null,c)):m<T?(c=Math.floor(m/k),u?c===1?(0,g.localize)(14,null,c):(0,g.localize)(15,null,c):c===1?(0,g.localize)(16,null,c):(0,g.localize)(17,null,c)):m<y?(c=Math.floor(m/T),u?c===1?(0,g.localize)(18,null,c):(0,g.localize)(19,null,c):c===1?(0,g.localize)(20,null,c):(0,g.localize)(21,null,c)):m<S?(c=Math.floor(m/y),u?c===1?(0,g.localize)(22,null,c):(0,g.localize)(23,null,c):c===1?(0,g.localize)(24,null,c):(0,g.localize)(25,null,c)):(c=Math.floor(m/S),u?c===1?(0,g.localize)(26,null,c):(0,g.localize)(27,null,c):c===1?(0,g.localize)(28,null,c):(0,g.localize)(29,null,c))}e.fromNow=A;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(ve[152],we([18,19]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[60],we([0,1,20,14,152]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(A,i){return i&&(A.stack||A.stacktrace)?C.localize(0,null,y(A),T(A.stack)||T(A.stacktrace)):y(A)}function T(A){return Array.isArray(A)?A.join(`
`):A}function y(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?C.localize(1,null,A.message):A.message||C.localize(2,null)}function S(A=null,i=!1){if(!A)return C.localize(3,null);if(Array.isArray(A)){const I=g.coalesce(A),u=S(I[0],i);return I.length>1?C.localize(4,null,u,I.length):u}if(L.isString(A))return A;if(A.detail){const I=A.detail;if(I.error)return k(I.error,i);if(I.exception)return k(I.exception,i)}return A.stack?k(A,i):A.message?A.message:C.localize(5,null)}e.toErrorMessage=S}),define(ve[153],we([18,19]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ve[112],we([0,1,39,29,10,25,8,11,38,14,142,28,153]),function(J,e,g,L,C,k,T,y,S,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(f){switch(f){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(f,p){if(y.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const s=g.execFile("taskkill",["/T","/F","/PID",f.pid.toString()],t);return new Promise(o=>{s.once("error",n=>{o({success:!1,error:n})}),s.once("exit",(n,a)=>{o(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(y.isLinux||y.isMacintosh)try{const t=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(s=>{g.execFile(t,[f.pid.toString()],{encoding:"utf8",shell:!0},(o,n,a)=>{s(o?{success:!1,error:o}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else f.kill("SIGKILL");return Promise.resolve({success:!0})}function v(f=S.env){return f.comspec||"cmd.exe"}e.getWindowsShell=v;class _{constructor(p,t,s,o){if(t!==void 0&&s!==void 0&&o!==void 0)this.cmd=p,this.args=t,this.shell=s,this.options=o;else{const n=p;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(S.env).forEach(a=>{n[a]=S.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(T.sep);return t!==-1&&(p=p.substring(t+1)),_.WellKnowCommands[p]?p:"other"}start(p){return y.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(u.localize(0,null))):this.useExec().then(t=>{let s,o;const n=new Promise((a,h)=>{s=a,o=h});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=g.exec(a,this.options,(h,d,w)=>{this.childProcess=null;const E=h;E&&E.killed?o({killed:this.terminateRequested,stdout:d.toString(),stderr:w.toString()}):this.handleExec(s,p,h,d,w)})}else{let a=null;const h=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,s,p,o);const w={terminated:this.terminateRequested};A.isNumber(d)&&(w.cmdCode=d),s(w)};if(this.shell&&y.isWindows){const d=k.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let w=!1,E=!1;const r=[];let D=this.ensureQuotes(this.cmd);r.push(D.value),w=D.quoted,this.args&&this.args.forEach(x=>{D=this.ensureQuotes(x),r.push(D.value),E=E&&D.quoted});const R=["/s","/c"];w?E?R.push('"'+r.join(" ")+'"'):r.length>1?R.push('"'+r[0]+'" '+r.slice(1).join(" ")):R.push('"'+r[0]+'"'):R.push(r.join(" ")),a=g.spawn(v(),R,d)}else this.cmd&&(a=g.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(A.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",d=>{this.childProcess=null,o({terminated:this.terminateRequested,error:d})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,s,p,o,!0)))}return n})}handleClose(p,t,s,o){}ensureQuotes(p){return _.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,c(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!y.isWindows)return p(!1);const t=g.spawn(v(),["/s","/c"]);t.on("error",s=>p(!0)),t.on("exit",s=>p(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class b extends _{constructor(p,t,s,o){super(p,t,s,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,s,o,n){[o,n].forEach((a,h)=>{const d=new i.LineDecoder;d.write(a).forEach(r=>{t({line:r,source:h===0?0:1})});const E=d.end();E&&t({line:E,source:h===0?0:1})}),p({terminated:this.terminateRequested,error:s})}handleSpawn(p,t,s,o,n){const a=new i.LineDecoder,h=new i.LineDecoder;p.stdout.on("data",d=>{a.write(d).forEach(E=>s({line:E,source:0}))}),p.stderr.on("data",d=>{h.write(d).forEach(E=>s({line:E,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(p,t,s,o){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&s({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&s({line:a,source:1})}}e.LineProcess=b;function P(f){let p=[],t=!1;const s=function(o){if(t){p.push(o);return}(!f.send(o,a=>{if(a&&console.error(a),t=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(d=>s(d))}})||y.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=P;var l;(function(f){async function p(t,s,o){if(T.isAbsolute(t))return t;if(s===void 0&&(s=S.cwd()),T.dirname(t)!=="."||(o===void 0&&A.isString(S.env.PATH)&&(o=S.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(s,t);async function a(h){return await I.Promises.exists(h)?!(await I.Promises.stat(h)).isDirectory():!1}for(let h of o){let d;if(T.isAbsolute(h)?d=T.join(h,t):d=T.join(s,h,t),await a(d))return d;let w=d+".com";if(await a(w)||(w=d+".exe",await a(w)))return w}return T.join(s,t)}f.findExecutable=p})(l=e.win32||(e.win32={}))}),define(ve[154],we([18,19]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(ve[113],we([0,1,154,11,109]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(k=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=T;class y{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,pe){this._values[se]=pe}}e.ValidatedEditorOptions=y;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class A{constructor(se,pe,Ue,Ne){this.id=se,this.name=pe,this.defaultValue=Ue,this.schema=Ne}compute(se,pe,Ue){return Ue}}class i{constructor(se,pe=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(se){return this.defaultValue}}class I{constructor(se,pe,Ue,Ne){this.id=se,this.name=pe,this.defaultValue=Ue,this.schema=Ne}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,pe,Ue){return Ue}}function u(X,se){return typeof X=="undefined"?se:X==="false"?!1:Boolean(X)}e.boolean=u;class m extends I{constructor(se,pe,Ue,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Ue),super(se,pe,Ue,Ne)}validate(se){return u(se,this.defaultValue)}}class c extends I{constructor(se,pe,Ue,Ne,Je,ke=void 0){typeof ke!="undefined"&&(ke.type="integer",ke.default=Ue,ke.minimum=Ne,ke.maximum=Je),super(se,pe,Ue,ke),this.minimum=Ne,this.maximum=Je}static clampedInt(se,pe,Ue,Ne){if(typeof se=="undefined")return pe;let Je=parseInt(se,10);return isNaN(Je)?pe:(Je=Math.max(Ue,Je),Je=Math.min(Ne,Je),Je|0)}validate(se){return c.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class v extends I{constructor(se,pe,Ue,Ne,Je){typeof Je!="undefined"&&(Je.type="number",Je.default=Ue),super(se,pe,Ue,Je),this.validationFn=Ne}static clamp(se,pe,Ue){return se<pe?pe:se>Ue?Ue:se}static float(se,pe){if(typeof se=="number")return se;if(typeof se=="undefined")return pe;const Ue=parseFloat(se);return isNaN(Ue)?pe:Ue}validate(se){return this.validationFn(v.float(se,this.defaultValue))}}class _ extends I{static string(se,pe){return typeof se!="string"?pe:se}constructor(se,pe,Ue,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Ue),super(se,pe,Ue,Ne)}validate(se){return _.string(se,this.defaultValue)}}function b(X,se,pe){return typeof X!="string"||pe.indexOf(X)===-1?se:X}e.stringSet=b;class P extends I{constructor(se,pe,Ue,Ne,Je=void 0){typeof Je!="undefined"&&(Je.type="string",Je.enum=Ne,Je.default=Ue),super(se,pe,Ue,Je),this._allowedValues=Ne}validate(se){return b(se,this.defaultValue,this._allowedValues)}}class l extends A{constructor(se,pe,Ue,Ne,Je,ke,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=Je,ye.default=Ne),super(se,pe,Ue,ye),this._allowedValues=Je,this._convert=ke}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function f(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,pe,Ue){return Ue===0?se.accessibilitySupport:Ue}}class t extends A{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:g.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{insertSpace:u(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(X){switch(X){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function h(X){switch(X){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class d extends i{constructor(){super(126,[64,31])}compute(se,pe,Ue){const Ne=["monaco-editor"];return pe.get(31)&&Ne.push(pe.get(31)),se.extraEditorClassName&&Ne.push(se.extraEditorClassName),pe.get(64)==="default"?Ne.push("mouse-default"):pe.get(64)==="copy"&&Ne.push("mouse-copy"),pe.get(99)&&Ne.push("showUnused"),pe.get(124)&&Ne.push("showDeprecated"),Ne.join(" ")}}class w extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(se,pe,Ue){return Ue&&se.emptySelectionClipboard}}class E extends A{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:g.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{cursorMoveOnType:u(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":b(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":b(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(pe.loop,this.defaultValue.loop)}}}class r extends A{constructor(){super(42,"fontLigatures",r.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?r.OFF:se==="true"?r.ON:se:Boolean(se)?r.ON:r.OFF}}e.EditorFontLigatures=r,r.OFF='"liga" off, "calt" off',r.ON='"liga" on, "calt" on';class D extends i{constructor(){super(41)}compute(se,pe,Ue){return se.fontInfo}}class R extends I{constructor(){super(43,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(se){let pe=v.float(se,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(pe,6,100)}compute(se,pe,Ue){return se.fontInfo.fontSize}}class x extends A{constructor(){super(44,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(c.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class j extends A{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(48,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ue,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ue,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ue,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ue,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ue,description:g.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{multiple:b(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??b(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??b(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??b(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??b(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??b(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class te extends A{constructor(){const se={enabled:!0,delay:300,sticky:!0};super(51,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:g.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{enabled:u(pe.enabled,this.defaultValue.enabled),delay:c.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:u(pe.sticky,this.defaultValue.sticky)}}}var Q;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Q=e.RenderMinimap||(e.RenderMinimap={}));class N extends i{constructor(){super(129,[47,56,35,63,91,58,59,93,116,119,120,121,2])}compute(se,pe,Ue){return N.computeLayout(pe,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const pe=se.height/se.lineHeight,Ue=se.scrollBeyondLastLine?pe-1:0,Ne=(se.viewLineCount+Ue)/(se.pixelRatio*se.height),Je=Math.floor(se.viewLineCount/Ne);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ue,desiredRatio:Ne,minimapLineCount:Je}}static _computeMinimapLayout(se,pe){const Ue=se.outerWidth,Ne=se.outerHeight,Je=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Je*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const ke=pe.stableMinimapLayoutInput,ye=ke&&se.outerHeight===ke.outerHeight&&se.lineHeight===ke.lineHeight&&se.typicalHalfwidthCharacterWidth===ke.typicalHalfwidthCharacterWidth&&se.pixelRatio===ke.pixelRatio&&se.scrollBeyondLastLine===ke.scrollBeyondLastLine&&se.minimap.enabled===ke.minimap.enabled&&se.minimap.side===ke.minimap.side&&se.minimap.size===ke.minimap.size&&se.minimap.showSlider===ke.minimap.showSlider&&se.minimap.renderCharacters===ke.minimap.renderCharacters&&se.minimap.maxColumn===ke.minimap.maxColumn&&se.minimap.scale===ke.minimap.scale&&se.verticalScrollbarWidth===ke.verticalScrollbarWidth&&se.isViewportWrapping===ke.isViewportWrapping,Ie=se.lineHeight,ce=se.typicalHalfwidthCharacterWidth,de=se.scrollBeyondLastLine,H=se.minimap.renderCharacters;let ee=Je>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const ue=se.minimap.maxColumn,Le=se.minimap.size,Re=se.minimap.side,ze=se.verticalScrollbarWidth,Ge=se.viewLineCount,et=se.remainingWidth,it=se.isViewportWrapping,Ye=H?2:3;let Xe=Math.floor(Je*Ne);const mt=Xe/Je;let vt=!1,Et=!1,ot=Ye*ee,at=ee/Je,Dt=1;if(Le==="fill"||Le==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:qe,desiredRatio:ft,minimapLineCount:bt}=N.computeContainedMinimapLineCount({viewLineCount:Ge,scrollBeyondLastLine:de,height:Ne,lineHeight:Ie,pixelRatio:Je});if(Ge/bt>1)vt=!0,Et=!0,ee=1,ot=1,at=ee/Je;else{let dt=!1,ct=ee+1;if(Le==="fit"){const ht=Math.ceil((Ge+qe)*ot);it&&ye&&et<=pe.stableFitRemainingWidth?(dt=!0,ct=pe.stableFitMaxMinimapScale):dt=ht>Xe}if(Le==="fill"||dt){vt=!0;const ht=ee;ot=Math.min(Ie*Je,Math.max(1,Math.floor(1/ft))),it&&ye&&et<=pe.stableFitRemainingWidth&&(ct=pe.stableFitMaxMinimapScale),ee=Math.min(ct,Math.max(1,Math.floor(ot/Ye))),ee>ht&&(Dt=Math.min(2,ee/ht)),at=ee/Je/Dt,Xe=Math.ceil(Math.max(Ze,Ge+qe)*ot),it?(pe.stableMinimapLayoutInput=se,pe.stableFitRemainingWidth=et,pe.stableFitMaxMinimapScale=ee):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const _e=Math.floor(ue*at),ge=Math.min(_e,Math.max(0,Math.floor((et-ze-2)*at/(ce+at)))+e.MINIMAP_GUTTER_WIDTH);let he=Math.floor(Je*ge);const G=he/Je;he=Math.floor(he*Dt);const Pe=H?1:2,Oe=Re==="left"?0:Ue-ge-ze;return{renderMinimap:Pe,minimapLeft:Oe,minimapWidth:ge,minimapHeightIsEditorHeight:vt,minimapIsSampling:Et,minimapScale:ee,minimapLineHeight:ot,minimapCanvasInnerWidth:he,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:G,minimapCanvasOuterHeight:mt}}static computeLayout(se,pe){const Ue=pe.outerWidth|0,Ne=pe.outerHeight|0,Je=pe.lineHeight|0,ke=pe.lineNumbersDigitCount|0,ye=pe.typicalHalfwidthCharacterWidth,Ie=pe.maxDigitWidth,ce=pe.pixelRatio,de=pe.viewLineCount,H=se.get(121),ee=H==="inherit"?se.get(120):H,ue=ee==="inherit"?se.get(116):ee,Le=se.get(119),Re=se.get(2),ze=pe.isDominatedByLongLines,Ge=se.get(47),et=se.get(58).renderType!==0,it=se.get(59),Ye=se.get(93),Xe=se.get(63),mt=se.get(91),vt=mt.verticalScrollbarSize,Et=mt.verticalHasArrows,ot=mt.arrowSize,at=mt.horizontalScrollbarSize,Dt=se.get(56),_e=se.get(35);let ge;if(typeof Dt=="string"&&/^\d+(\.\d+)?ch$/.test(Dt)){const It=parseFloat(Dt.substr(0,Dt.length-2));ge=c.clampedInt(It*ye,0,0,1e3)}else ge=c.clampedInt(Dt,0,0,1e3);_e&&(ge+=16);let he=0;if(et){const It=Math.max(ke,it);he=Math.round(It*Ie)}let G=0;Ge&&(G=Je);let Pe=0,Oe=Pe+G,Ze=Oe+he,qe=Ze+ge;const ft=Ue-G-he-ge;let bt=!1,kt=!1,dt=-1;Re!==2&&(ee==="inherit"&&ze?(bt=!0,kt=!0):ue==="on"||ue==="bounded"?kt=!0:ue==="wordWrapColumn"&&(dt=Le));const ct=N._computeMinimapLayout({outerWidth:Ue,outerHeight:Ne,lineHeight:Je,typicalHalfwidthCharacterWidth:ye,pixelRatio:ce,scrollBeyondLastLine:Ye,minimap:Xe,verticalScrollbarWidth:vt,viewLineCount:de,remainingWidth:ft,isViewportWrapping:kt},pe.memory||new S);ct.renderMinimap!==0&&ct.minimapLeft===0&&(Pe+=ct.minimapWidth,Oe+=ct.minimapWidth,Ze+=ct.minimapWidth,qe+=ct.minimapWidth);const ht=ft-ct.minimapWidth,_t=Math.max(1,Math.floor((ht-vt-2)/ye)),Tt=Et?ot:0;return kt&&(dt=Math.max(1,_t),ue==="bounded"&&(dt=Math.min(dt,Le))),{width:Ue,height:Ne,glyphMarginLeft:Pe,glyphMarginWidth:G,lineNumbersLeft:Oe,lineNumbersWidth:he,decorationsLeft:Ze,decorationsWidth:ge,contentLeft:qe,contentWidth:ht,minimap:ct,viewportColumn:_t,isWordWrapMinified:bt,isViewportWrapping:kt,wrappingColumn:dt,verticalScrollbarWidth:vt,horizontalScrollbarHeight:at,overviewRuler:{top:Tt,width:vt,height:Ne-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=N;class U extends A{constructor(){const se={enabled:!0};super(55,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:g.localize(42,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:u(se.enabled,this.defaultValue.enabled)}}}class F extends A{constructor(){const se={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:g.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,description:g.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{enabled:u(pe.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class V extends v{constructor(){super(57,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>v.clamp(se,0,150),{markdownDescription:g.localize(46,null)})}compute(se,pe,Ue){return se.fontInfo.lineHeight}}class M extends A{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(63,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:g.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(48,null),g.localize(49,null),g.localize(50,null)],default:se.size,description:g.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:g.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:g.localize(53,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:g.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:g.localize(56,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{enabled:u(pe.enabled,this.defaultValue.enabled),size:b(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(pe.side,this.defaultValue.side,["right","left"]),showSlider:b(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(pe.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(pe.scale,1,1,3),maxColumn:c.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(X){return X==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends A{constructor(){super(73,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{top:c.clampedInt(pe.top,0,0,1e3),bottom:c.clampedInt(pe.bottom,0,0,1e3)}}}class B extends A{constructor(){const se={enabled:!0,cycle:!1};super(74,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:g.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:g.localize(60,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{enabled:u(pe.enabled,this.defaultValue.enabled),cycle:u(pe.cycle,this.defaultValue.cycle)}}}class K extends i{constructor(){super(127)}compute(se,pe,Ue){return se.pixelRatio}}class ne extends A{constructor(){const se={other:!0,comments:!1,strings:!1};super(77,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:g.localize(61,null)},comments:{type:"boolean",default:se.comments,description:g.localize(62,null)},other:{type:"boolean",default:se.other,description:g.localize(63,null)}}}],default:se,description:g.localize(64,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const pe=se,Ue={other:u(pe.other,this.defaultValue.other),comments:u(pe.comments,this.defaultValue.comments),strings:u(pe.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var me;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(me=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends A{constructor(){super(58,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(65,null),g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:"on",description:g.localize(69,null)})}validate(se){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(pe=4,Ue=se):se==="interval"?pe=3:se==="relative"?pe=2:se==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function Ce(X){const se=X.get(86);return se==="editable"?X.get(79):se!=="on"}e.filterValidationDecorations=Ce;class Te extends A{constructor(){const se=[],pe={type:"number",description:g.localize(70,null)};super(90,"rulers",se,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:g.localize(71,null),format:"color-hex"}}}]},default:se,description:g.localize(72,null)})}validate(se){if(Array.isArray(se)){let pe=[];for(let Ue of se)if(typeof Ue=="number")pe.push({column:c.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ne=Ue;pe.push({column:c.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return pe.sort((Ue,Ne)=>Ue.column-Ne.column),pe}return this.defaultValue}}function je(X,se){if(typeof X!="string")return se;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Be extends A{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(73,null),g.localize(74,null),g.localize(75,null)],default:"auto",description:g.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(77,null),g.localize(78,null),g.localize(79,null)],default:"auto",description:g.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:g.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:g.localize(83,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se,Ue=c.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=c.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(pe.vertical,this.defaultValue.vertical),horizontal:je(pe.horizontal,this.defaultValue.horizontal),useShadows:u(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:c.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:c.clampedInt(pe.verticalSliderSize,Ne,0,1e3),scrollByPage:u(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class Ve extends A{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(53,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:g.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(85,null),g.localize(86,null),g.localize(87,null)],default:se.mode,description:g.localize(88,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{enabled:u(pe.enabled,this.defaultValue.enabled),mode:b(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class W extends A{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(89,null),g.localize(90,null)],default:se.insertMode,description:g.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:g.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:g.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:g.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:g.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:g.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:g.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:g.localize(98,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(99,null),g.localize(100,null),g.localize(101,null)],default:se.previewMode,description:g.localize(102,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:g.localize(103,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(104,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(105,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const pe=se;return{insertMode:b(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(pe.showIcons,this.defaultValue.showIcons),showStatusBar:u(pe.showStatusBar,this.defaultValue.showStatusBar),preview:u(pe.preview,this.defaultValue.preview),previewMode:b(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(pe.showMethods,this.defaultValue.showMethods),showFunctions:u(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:u(pe.showFields,this.defaultValue.showFields),showVariables:u(pe.showVariables,this.defaultValue.showVariables),showClasses:u(pe.showClasses,this.defaultValue.showClasses),showStructs:u(pe.showStructs,this.defaultValue.showStructs),showInterfaces:u(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(pe.showModules,this.defaultValue.showModules),showProperties:u(pe.showProperties,this.defaultValue.showProperties),showEvents:u(pe.showEvents,this.defaultValue.showEvents),showOperators:u(pe.showOperators,this.defaultValue.showOperators),showUnits:u(pe.showUnits,this.defaultValue.showUnits),showValues:u(pe.showValues,this.defaultValue.showValues),showConstants:u(pe.showConstants,this.defaultValue.showConstants),showEnums:u(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(pe.showKeywords,this.defaultValue.showKeywords),showWords:u(pe.showWords,this.defaultValue.showWords),showColors:u(pe.showColors,this.defaultValue.showColors),showFiles:u(pe.showFiles,this.defaultValue.showFiles),showReferences:u(pe.showReferences,this.defaultValue.showReferences),showFolders:u(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(pe.showSnippets,this.defaultValue.showSnippets),showUsers:u(pe.showUsers,this.defaultValue.showUsers),showIssues:u(pe.showIssues,this.defaultValue.showIssues)}}}class Z extends A{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(135,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ie extends i{constructor(){super(128,[79])}compute(se,pe,Ue){return pe.get(79)?!0:se.tabFocusMode}}var le;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(le=e.WrappingIndent||(e.WrappingIndent={}));function Y(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ae extends i{constructor(){super(130,[129])}compute(se,pe,Ue){const Ne=pe.get(129);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const be="Consolas, 'Courier New', monospace",Fe="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Fe:L.isLinux?He:be,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(X){return e.editorOptionsRegistry[X.id]=X,X}var Qe;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.foldingImportsByDefault=38]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=39]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=40]="fontFamily",X[X.fontInfo=41]="fontInfo",X[X.fontLigatures=42]="fontLigatures",X[X.fontSize=43]="fontSize",X[X.fontWeight=44]="fontWeight",X[X.formatOnPaste=45]="formatOnPaste",X[X.formatOnType=46]="formatOnType",X[X.glyphMargin=47]="glyphMargin",X[X.gotoLocation=48]="gotoLocation",X[X.hideCursorInOverviewRuler=49]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=50]="highlightActiveIndentGuide",X[X.hover=51]="hover",X[X.inDiffEditor=52]="inDiffEditor",X[X.inlineSuggest=53]="inlineSuggest",X[X.letterSpacing=54]="letterSpacing",X[X.lightbulb=55]="lightbulb",X[X.lineDecorationsWidth=56]="lineDecorationsWidth",X[X.lineHeight=57]="lineHeight",X[X.lineNumbers=58]="lineNumbers",X[X.lineNumbersMinChars=59]="lineNumbersMinChars",X[X.linkedEditing=60]="linkedEditing",X[X.links=61]="links",X[X.matchBrackets=62]="matchBrackets",X[X.minimap=63]="minimap",X[X.mouseStyle=64]="mouseStyle",X[X.mouseWheelScrollSensitivity=65]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=66]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=67]="multiCursorMergeOverlapping",X[X.multiCursorModifier=68]="multiCursorModifier",X[X.multiCursorPaste=69]="multiCursorPaste",X[X.occurrencesHighlight=70]="occurrencesHighlight",X[X.overviewRulerBorder=71]="overviewRulerBorder",X[X.overviewRulerLanes=72]="overviewRulerLanes",X[X.padding=73]="padding",X[X.parameterHints=74]="parameterHints",X[X.peekWidgetDefaultFocus=75]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=76]="definitionLinkOpensInPeek",X[X.quickSuggestions=77]="quickSuggestions",X[X.quickSuggestionsDelay=78]="quickSuggestionsDelay",X[X.readOnly=79]="readOnly",X[X.renameOnType=80]="renameOnType",X[X.renderControlCharacters=81]="renderControlCharacters",X[X.renderIndentGuides=82]="renderIndentGuides",X[X.renderFinalNewline=83]="renderFinalNewline",X[X.renderLineHighlight=84]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=86]="renderValidationDecorations",X[X.renderWhitespace=87]="renderWhitespace",X[X.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",X[X.roundedSelection=89]="roundedSelection",X[X.rulers=90]="rulers",X[X.scrollbar=91]="scrollbar",X[X.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=93]="scrollBeyondLastLine",X[X.scrollPredominantAxis=94]="scrollPredominantAxis",X[X.selectionClipboard=95]="selectionClipboard",X[X.selectionHighlight=96]="selectionHighlight",X[X.selectOnLineNumbers=97]="selectOnLineNumbers",X[X.showFoldingControls=98]="showFoldingControls",X[X.showUnused=99]="showUnused",X[X.snippetSuggestions=100]="snippetSuggestions",X[X.smartSelect=101]="smartSelect",X[X.smoothScrolling=102]="smoothScrolling",X[X.stickyTabStops=103]="stickyTabStops",X[X.stopRenderingLineAfter=104]="stopRenderingLineAfter",X[X.suggest=105]="suggest",X[X.suggestFontSize=106]="suggestFontSize",X[X.suggestLineHeight=107]="suggestLineHeight",X[X.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",X[X.suggestSelection=109]="suggestSelection",X[X.tabCompletion=110]="tabCompletion",X[X.tabIndex=111]="tabIndex",X[X.unusualLineTerminators=112]="unusualLineTerminators",X[X.useShadowDOM=113]="useShadowDOM",X[X.useTabStops=114]="useTabStops",X[X.wordSeparators=115]="wordSeparators",X[X.wordWrap=116]="wordWrap",X[X.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=119]="wordWrapColumn",X[X.wordWrapOverride1=120]="wordWrapOverride1",X[X.wordWrapOverride2=121]="wordWrapOverride2",X[X.wrappingIndent=122]="wrappingIndent",X[X.wrappingStrategy=123]="wrappingStrategy",X[X.showDeprecated=124]="showDeprecated",X[X.inlayHints=125]="inlayHints",X[X.editorClassName=126]="editorClassName",X[X.pixelRatio=127]="pixelRatio",X[X.tabFocusMode=128]="tabFocusMode",X[X.layoutInfo=129]="layoutInfo",X[X.wrappingInfo=130]="wrappingInfo"})(Qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(136,null)})),acceptSuggestionOnEnter:Ee(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(137,null),""],markdownDescription:g.localize(138,null)})),accessibilitySupport:Ee(new p),accessibilityPageSize:Ee(new c(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(139,null)})),ariaLabel:Ee(new _(4,"ariaLabel",g.localize(140,null))),autoClosingBrackets:Ee(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(141,null),g.localize(142,null),""],description:g.localize(143,null)})),autoClosingDelete:Ee(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(144,null),""],description:g.localize(145,null)})),autoClosingOvertype:Ee(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(146,null),""],description:g.localize(147,null)})),autoClosingQuotes:Ee(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(148,null),g.localize(149,null),""],description:g.localize(150,null)})),autoIndent:Ee(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[g.localize(151,null),g.localize(152,null),g.localize(153,null),g.localize(154,null),g.localize(155,null)],description:g.localize(156,null)})),automaticLayout:Ee(new m(10,"automaticLayout",!1)),autoSurround:Ee(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(157,null),g.localize(158,null),g.localize(159,null),""],description:g.localize(160,null)})),stickyTabStops:Ee(new m(103,"stickyTabStops",!1,{description:g.localize(161,null)})),codeLens:Ee(new m(12,"codeLens",!0,{description:g.localize(162,null)})),codeLensFontFamily:Ee(new _(13,"codeLensFontFamily","",{description:g.localize(163,null)})),codeLensFontSize:Ee(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(164,null)})),colorDecorators:Ee(new m(15,"colorDecorators",!0,{description:g.localize(165,null)})),columnSelection:Ee(new m(16,"columnSelection",!1,{description:g.localize(166,null)})),comments:Ee(new t),contextmenu:Ee(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new m(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(167,null)})),cursorBlinking:Ee(new l(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:g.localize(168,null)})),cursorSmoothCaretAnimation:Ee(new m(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(169,null)})),cursorStyle:Ee(new l(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:g.localize(170,null)})),cursorSurroundingLines:Ee(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(171,null)})),cursorSurroundingLinesStyle:Ee(new P(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(172,null),g.localize(173,null)],description:g.localize(174,null)})),cursorWidth:Ee(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(175,null)})),disableLayerHinting:Ee(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new m(28,"domReadOnly",!1)),dragAndDrop:Ee(new m(29,"dragAndDrop",!0,{description:g.localize(176,null)})),emptySelectionClipboard:Ee(new w),extraEditorClassName:Ee(new _(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new v(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:g.localize(177,null)})),find:Ee(new E),fixedOverflowWidgets:Ee(new m(34,"fixedOverflowWidgets",!1)),folding:Ee(new m(35,"folding",!0,{description:g.localize(178,null)})),foldingStrategy:Ee(new P(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(179,null),g.localize(180,null)],description:g.localize(181,null)})),foldingHighlight:Ee(new m(37,"foldingHighlight",!0,{description:g.localize(182,null)})),foldingImportsByDefault:Ee(new m(38,"foldingImportsByDefault",!1,{description:g.localize(183,null)})),unfoldOnClickAfterEndOfLine:Ee(new m(39,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(184,null)})),fontFamily:Ee(new _(40,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(185,null)})),fontInfo:Ee(new D),fontLigatures2:Ee(new r),fontSize:Ee(new R),fontWeight:Ee(new x),formatOnPaste:Ee(new m(45,"formatOnPaste",!1,{description:g.localize(186,null)})),formatOnType:Ee(new m(46,"formatOnType",!1,{description:g.localize(187,null)})),glyphMargin:Ee(new m(47,"glyphMargin",!0,{description:g.localize(188,null)})),gotoLocation:Ee(new j),hideCursorInOverviewRuler:Ee(new m(49,"hideCursorInOverviewRuler",!1,{description:g.localize(189,null)})),highlightActiveIndentGuide:Ee(new m(50,"highlightActiveIndentGuide",!0,{description:g.localize(190,null)})),hover:Ee(new te),inDiffEditor:Ee(new m(52,"inDiffEditor",!1)),letterSpacing:Ee(new v(54,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>v.clamp(X,-5,20),{description:g.localize(191,null)})),lightbulb:Ee(new U),lineDecorationsWidth:Ee(new I(56,"lineDecorationsWidth",10)),lineHeight:Ee(new V),lineNumbers:Ee(new Se),lineNumbersMinChars:Ee(new c(59,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new m(60,"linkedEditing",!1,{description:g.localize(192,null)})),links:Ee(new m(61,"links",!0,{description:g.localize(193,null)})),matchBrackets:Ee(new P(62,"matchBrackets","always",["always","near","never"],{description:g.localize(194,null)})),minimap:Ee(new M),mouseStyle:Ee(new P(64,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new v(65,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:g.localize(195,null)})),mouseWheelZoom:Ee(new m(66,"mouseWheelZoom",!1,{markdownDescription:g.localize(196,null)})),multiCursorMergeOverlapping:Ee(new m(67,"multiCursorMergeOverlapping",!0,{description:g.localize(197,null)})),multiCursorModifier:Ee(new l(68,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[g.localize(198,null),g.localize(199,null)],markdownDescription:g.localize(200,null)})),multiCursorPaste:Ee(new P(69,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(201,null),g.localize(202,null)],markdownDescription:g.localize(203,null)})),occurrencesHighlight:Ee(new m(70,"occurrencesHighlight",!0,{description:g.localize(204,null)})),overviewRulerBorder:Ee(new m(71,"overviewRulerBorder",!0,{description:g.localize(205,null)})),overviewRulerLanes:Ee(new c(72,"overviewRulerLanes",3,0,3)),padding:Ee(new q),parameterHints:Ee(new B),peekWidgetDefaultFocus:Ee(new P(75,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(206,null),g.localize(207,null)],description:g.localize(208,null)})),definitionLinkOpensInPeek:Ee(new m(76,"definitionLinkOpensInPeek",!1,{description:g.localize(209,null)})),quickSuggestions:Ee(new ne),quickSuggestionsDelay:Ee(new c(78,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(210,null)})),readOnly:Ee(new m(79,"readOnly",!1)),renameOnType:Ee(new m(80,"renameOnType",!1,{description:g.localize(211,null),markdownDeprecationMessage:g.localize(212,null)})),renderControlCharacters:Ee(new m(81,"renderControlCharacters",!1,{description:g.localize(213,null)})),renderIndentGuides:Ee(new m(82,"renderIndentGuides",!0,{description:g.localize(214,null)})),renderFinalNewline:Ee(new m(83,"renderFinalNewline",!0,{description:g.localize(215,null)})),renderLineHighlight:Ee(new P(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(216,null)],description:g.localize(217,null)})),renderLineHighlightOnlyWhenFocus:Ee(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(218,null)})),renderValidationDecorations:Ee(new P(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new P(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(219,null),g.localize(220,null),g.localize(221,null),""],description:g.localize(222,null)})),revealHorizontalRightPadding:Ee(new c(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new m(89,"roundedSelection",!0,{description:g.localize(223,null)})),rulers:Ee(new Te),scrollbar:Ee(new Be),scrollBeyondLastColumn:Ee(new c(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(224,null)})),scrollBeyondLastLine:Ee(new m(93,"scrollBeyondLastLine",!0,{description:g.localize(225,null)})),scrollPredominantAxis:Ee(new m(94,"scrollPredominantAxis",!0,{description:g.localize(226,null)})),selectionClipboard:Ee(new m(95,"selectionClipboard",!0,{description:g.localize(227,null),included:L.isLinux})),selectionHighlight:Ee(new m(96,"selectionHighlight",!0,{description:g.localize(228,null)})),selectOnLineNumbers:Ee(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new P(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(229,null),g.localize(230,null)],description:g.localize(231,null)})),showUnused:Ee(new m(99,"showUnused",!0,{description:g.localize(232,null)})),showDeprecated:Ee(new m(124,"showDeprecated",!0,{description:g.localize(233,null)})),inlayHints:Ee(new F),snippetSuggestions:Ee(new P(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),g.localize(237,null)],description:g.localize(238,null)})),smartSelect:Ee(new Z),smoothScrolling:Ee(new m(102,"smoothScrolling",!1,{description:g.localize(239,null)})),stopRenderingLineAfter:Ee(new c(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new W),inlineSuggest:Ee(new Ve),suggestFontSize:Ee(new c(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(240,null)})),suggestLineHeight:Ee(new c(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(241,null)})),suggestOnTriggerCharacters:Ee(new m(108,"suggestOnTriggerCharacters",!0,{description:g.localize(242,null)})),suggestSelection:Ee(new P(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),tabCompletion:Ee(new P(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(247,null),g.localize(248,null),g.localize(249,null)],description:g.localize(250,null)})),tabIndex:Ee(new c(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new P(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(251,null),g.localize(252,null),g.localize(253,null)],description:g.localize(254,null)})),useShadowDOM:Ee(new m(113,"useShadowDOM",!0)),useTabStops:Ee(new m(114,"useTabStops",!0,{description:g.localize(255,null)})),wordSeparators:Ee(new _(115,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:g.localize(256,null)})),wordWrap:Ee(new P(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(257,null),g.localize(258,null),g.localize(259,null),g.localize(260,null)],description:g.localize(261,null)})),wordWrapBreakAfterCharacters:Ee(new _(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new _(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new c(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(262,null)})),wordWrapOverride1:Ee(new P(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new P(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new l(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[g.localize(263,null),g.localize(264,null),g.localize(265,null),g.localize(266,null)],description:g.localize(267,null)})),wrappingStrategy:Ee(new P(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),editorClassName:Ee(new d),pixelRatio:Ee(new K),tabFocusMode:Ee(new ie),layoutInfo:Ee(new N),wrappingInfo:Ee(new ae)}}),define(ve[155],we([18,19]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[156],we([18,19]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[157],we([18,19]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[158],we([18,19]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[159],we([18,19]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[160],we([18,19]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[161],we([18,19]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[162],we([18,19]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[163],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[164],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[165],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[166],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[167],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[168],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[169],we([18,19]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[170],we([18,19]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[171],we([18,19]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(ve[172],we([18,19]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(ve[173],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[174],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[175],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[176],we([18,19]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[177],we([18,19]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[178],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var C;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var k;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(k=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[179],we([0,1,157]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function k(u){return u=u.trim(),u==="*"||L.test(u)}e.isValidVersionStr=k;function T(u){if(!k(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=u.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=T;function y(u){if(!u)return null;let m=u.majorBase,c=u.majorMustEqual,v=u.minorBase,_=u.minorMustEqual,b=u.patchBase,P=u.patchMustEqual;u.hasCaret&&(m===0||(_=!1),P=!1);let l=0;if(u.preRelease){const f=C.exec(u.preRelease);if(f){const[,p,t,s]=f;l=Date.UTC(Number(p),Number(t)-1,Number(s))}}return{majorBase:m,majorMustEqual:c,minorBase:v,minorMustEqual:_,patchBase:b,patchMustEqual:P,isMinimum:u.hasGreaterEquals,notBefore:l}}e.normalizeVersion=y;function S(u,m,c){let v;typeof u=="string"?v=y(T(u)):v=u;let _;m instanceof Date?_=m.getTime():typeof m=="string"&&(_=new Date(m).getTime());let b;if(typeof c=="string"?b=y(T(c)):b=c,!v||!b)return!1;let P=v.majorBase,l=v.minorBase,f=v.patchBase,p=b.majorBase,t=b.minorBase,s=b.patchBase,o=b.notBefore,n=b.majorMustEqual,a=b.minorMustEqual,h=b.patchMustEqual;return b.isMinimum?P>p?!0:P<p?!1:l>t?!0:l<t||_&&_<o?!1:f>=s:(P===1&&p===0&&(!n||!a||!h)&&(p=1,t=0,s=0,n=!0,a=!1,h=!1),P<p?!1:P>p?!n:l<t?!1:l>t?!a:f<s?!1:f>s?!h:!(_&&_<o))}e.isValidVersion=S;function A(u,m,c,v){return c.isBuiltin||typeof c.main=="undefined"?!0:I(u,m,c.engines.vscode,v)}e.isValidExtensionVersion=A;function i(u,m,c){return u==="*"||I(m,c,u)}e.isEngineValid=i;function I(u,m,c,v=[]){let _=y(T(c));if(!_)return v.push(g.localize(0,null,c)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return v.push(g.localize(1,null,c)),!1}else if(!_.majorMustEqual)return v.push(g.localize(2,null,c)),!1;return S(u,m,_)?!0:(v.push(g.localize(3,null,u,c)),!1)}}),define(ve[114],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(C,k=[],T=!1){this.ctor=C,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=g}),define(ve[81],we([0,1,114]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function C(T,y,S){y instanceof g.SyncDescriptor||(y=new g.SyncDescriptor(y,[],S)),L.push([T,y])}e.registerSingleton=C;function k(){return L}e.getSingletonServiceDescriptors=k}),define(ve[180],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=g;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let T of this._nodes.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const y=this.lookupOrInsertNode(k),S=this.lookupOrInsertNode(T);y.outgoing.set(this._hashFn(T),S),S.incoming.set(this._hashFn(k),y)}removeNode(k){const T=this._hashFn(k);this._nodes.delete(T);for(let y of this._nodes.values())y.outgoing.delete(T),y.incoming.delete(T)}lookupOrInsertNode(k){const T=this._hashFn(k);let y=this._nodes.get(T);return y||(y=new g(k),this._nodes.set(T,y)),y}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[T,y]of this._nodes)k.push(`${T}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,T]of this._nodes){const y=new Set([k]),S=this._findCycle(T,y);if(S)return S}}_findCycle(k,T){for(let[y,S]of k.outgoing){if(T.has(y))return[...T,y].join(" -> ");T.add(y);const A=this._findCycle(S,T);if(A)return A;T.delete(y)}}}e.Graph=L}),define(ve[4],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function S(A){return A[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=S})(g=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function L(y,S,A,i){S[g.DI_TARGET]===S?S[g.DI_DEPENDENCIES].push({id:y,index:A,optional:i}):(S[g.DI_DEPENDENCIES]=[{id:y,index:A,optional:i}],S[g.DI_TARGET]=S)}function C(y){if(g.serviceIds.has(y))return g.serviceIds.get(y);const S=function(A,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,A,I,!1)};return S.toString=()=>y,g.serviceIds.set(y,S),S}e.createDecorator=C;function k(y){return y}e.refineServiceDecorator=k;function T(y){return function(S,A,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(y,S,i,!0)}}e.optional=T}),define(ve[181],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(ve[182],we([0,1,3,58,6,22,76,80,181]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(A):!!u.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(m,c){let v={selector:m,provider:c,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(v){let _=this._entries.indexOf(v);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const c=[];for(let v of this._entries)v._score>0&&c.push(v.provider);return c}ordered(m){const c=[];return this._orderedForEach(m,v=>c.push(v.provider)),c}orderedGroups(m){const c=[];let v,_;return this._orderedForEach(m,b=>{v&&_===b._score?v.push(b.provider):(_=b._score,v=[b.provider],c.push(v))}),c}_orderedForEach(m,c){if(!!m){this._updateScores(m);for(const v of this._entries)v._score>0&&c(v)}}_updateScores(m){let c={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let v of this._entries)if(v._score=(0,y.score)(v.selector,m.uri,m.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(m)),A(v.selector)&&v._score>0){for(let _ of this._entries)_._score=0;v._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(m,c){return m._score<c._score?1:m._score>c._score?-1:m._time<c._time?1:m._time>c._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(m,c,v=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=c,this.max=v,this._cache=new k.LRUCache(50,.7)}_key(m){return m.id+(0,L.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const c=this._key(m),v=this._cache.get(c);return this._clamp(v?.value)}update(m,c){const v=this._key(m);let _=this._cache.get(v);return _||(_=new T.MovingAverage,this._cache.set(v,_)),_.update(c),this.get(m)}}e.LanguageFeatureRequestDelays=I}),define(ve[82],we([0,1,2,41,182,148,47]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(r){r[r.Null=0]="Null",r[r.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class S{constructor(D,R){this.language=D,this.id=R}}e.LanguageIdentifier=S;var A;(function(r){r[r.NotSet=-1]="NotSet",r[r.None=0]="None",r[r.Italic=1]="Italic",r[r.Bold=2]="Bold",r[r.Underline=4]="Underline"})(A=e.FontStyle||(e.FontStyle={}));var i;(function(r){r[r.None=0]="None",r[r.DefaultForeground=1]="DefaultForeground",r[r.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(r){r[r.Other=0]="Other",r[r.Comment=1]="Comment",r[r.String=2]="String",r[r.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var u;(function(r){r[r.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",r[r.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",r[r.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",r[r.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",r[r.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",r[r.ITALIC_MASK=2048]="ITALIC_MASK",r[r.BOLD_MASK=4096]="BOLD_MASK",r[r.UNDERLINE_MASK=8192]="UNDERLINE_MASK",r[r.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",r[r.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",r[r.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",r[r.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",r[r.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",r[r.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",r[r.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",r[r.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",r[r.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",r[r.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(u=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let R=this.getForeground(D),x="mtk"+R,j=this.getFontStyle(D);return j&1&&(x+=" mtki"),j&2&&(x+=" mtkb"),j&4&&(x+=" mtku"),x}static getInlineStyleFromMetadata(D,R){const x=this.getForeground(D),j=this.getFontStyle(D);let te=`color: ${R[x]};`;return j&1&&(te+="font-style: italic;"),j&2&&(te+="font-weight: bold;"),j&4&&(te+="text-decoration: underline;"),te}}e.TokenMetadata=m;var c;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let r=Object.create(null);return r[0]="symbol-method",r[1]="symbol-function",r[2]="symbol-constructor",r[3]="symbol-field",r[4]="symbol-variable",r[5]="symbol-class",r[6]="symbol-struct",r[7]="symbol-interface",r[8]="symbol-module",r[9]="symbol-property",r[10]="symbol-event",r[11]="symbol-operator",r[12]="symbol-unit",r[13]="symbol-value",r[14]="symbol-constant",r[15]="symbol-enum",r[16]="symbol-enum-member",r[17]="symbol-keyword",r[27]="symbol-snippet",r[18]="symbol-text",r[19]="symbol-color",r[20]="symbol-file",r[21]="symbol-reference",r[22]="symbol-customcolor",r[23]="symbol-folder",r[24]="symbol-type-parameter",r[25]="account",r[26]="issues",function(D){const R=r[D];let x=R&&T.iconRegistry.get(R);return x||(console.info("No codicon found for CompletionItemKind "+D),x=T.Codicon.symbolProperty),x.classNames}}(),e.completionKindFromString=function(){let r=Object.create(null);return r.method=0,r.function=1,r.constructor=2,r.field=3,r.variable=4,r.class=5,r.struct=6,r.interface=7,r.module=8,r.property=9,r.event=10,r.operator=11,r.unit=12,r.value=13,r.constant=14,r.enum=15,r["enum-member"]=16,r.enumMember=16,r.keyword=17,r.snippet=27,r.text=18,r.color=19,r.file=20,r.reference=21,r.customcolor=22,r.folder=23,r["type-parameter"]=24,r.typeParameter=24,r.account=25,r.issue=26,function(D,R){let x=r[D];return typeof x=="undefined"&&!R&&(x=9),x}}();var v;(function(r){r[r.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(r){return r&&g.URI.isUri(r.uri)&&L.Range.isIRange(r.range)&&(L.Range.isIRange(r.originSelectionRange)||L.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=t;var s;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var o;(function(r){r[r.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var n;(function(r){const D=new Map;D.set("file",0),D.set("module",1),D.set("namespace",2),D.set("package",3),D.set("class",4),D.set("method",5),D.set("property",6),D.set("field",7),D.set("constructor",8),D.set("enum",9),D.set("interface",10),D.set("function",11),D.set("variable",12),D.set("constant",13),D.set("string",14),D.set("number",15),D.set("boolean",16),D.set("array",17),D.set("object",18),D.set("key",19),D.set("null",20),D.set("enum-member",21),D.set("struct",22),D.set("event",23),D.set("operator",24),D.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function x(Q){return D.get(Q)}r.fromString=x;function j(Q){return R.get(Q)}r.toString=j;function te(Q,N){const U=R.get(Q);let F=U&&T.iconRegistry.get("symbol-"+U);return F||(console.info("No codicon found for SymbolKind "+Q),F=T.Codicon.symbolProperty),`${N?"inline":"block"} ${F.classNames}`}r.toCssClassName=te})(n=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(D){this.value=D}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var h;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var w;(function(r){r[r.Other=0]="Other",r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new k.TokenizationRegistryImpl;var E;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[61],we([0,1,11,9,4]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=g.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",g.isMacintosh),T.set("isLinux",g.isLinux),T.set("isWindows",g.isWindows),T.set("isWeb",g.isWeb),T.set("isMacNative",g.isMacintosh&&!g.isWeb),T.set("isEdge",k.indexOf("Edg/")>=0),T.set("isFirefox",k.indexOf("Firefox")>=0),T.set("isChrome",k.indexOf("Chrome")>=0),T.set("isSafari",k.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return I.INSTANCE}static true(){return u.INSTANCE}static has(r){return m.create(r)}static equals(r,D){return c.create(r,D)}static notEquals(r,D){return b.create(r,D)}static regex(r,D){return s.create(r,D)}static in(r,D){return v.create(r,D)}static not(r){return P.create(r)}static and(...r){return n.create(r)}static or(...r){return a.create(r)}static greater(r,D){return l.create(r,D)}static less(r,D){return p.create(r,D)}static deserialize(r,D=!1){if(!!r)return this._deserializeOrExpression(r,D)}static _deserializeOrExpression(r,D){let R=r.split("||");return a.create(R.map(x=>this._deserializeAndExpression(x,D)))}static _deserializeAndExpression(r,D){let R=r.split("&&");return n.create(R.map(x=>this._deserializeOne(x,D)))}static _deserializeOne(r,D){if(r=r.trim(),r.indexOf("!=")>=0){let R=r.split("!=");return b.create(R[0].trim(),this._deserializeValue(R[1],D))}if(r.indexOf("==")>=0){let R=r.split("==");return c.create(R[0].trim(),this._deserializeValue(R[1],D))}if(r.indexOf("=~")>=0){let R=r.split("=~");return s.create(R[0].trim(),this._deserializeRegexValue(R[1],D))}if(r.indexOf(" in ")>=0){let R=r.split(" in ");return v.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(r)){const R=r.split(">=");return f.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(r)){const R=r.split(">");return l.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(r)){const R=r.split("<=");return t.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(r)){const R=r.split("<");return p.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(r)?P.create(r.substr(1).trim()):m.create(r)}static _deserializeValue(r,D){if(r=r.trim(),r==="true")return!0;if(r==="false")return!1;let R=/^'([^']*)'$/.exec(r);return R?R[1].trim():r}static _deserializeRegexValue(r,D){if((0,L.isFalsyOrWhitespace)(r)){if(D)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let R=r.indexOf("/"),x=r.lastIndexOf("/");if(R===x||R<0){if(D)throw new Error(`bad regexp-value '${r}', missing /-enclosure`);return console.warn(`bad regexp-value '${r}', missing /-enclosure`),null}let j=r.slice(R+1,x),te=r[x+1]==="i"?"i":"";try{return new RegExp(j,te)}catch(Q){if(D)throw new Error(`bad regexp-value '${r}', parse error: ${Q}`);return console.warn(`bad regexp-value '${r}', parse error: ${Q}`),null}}}e.ContextKeyExpr=A;function i(E,r){return E.cmp(r)}class I{constructor(){this.type=0}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}evaluate(r){return!1}serialize(){return"false"}keys(){return[]}map(r){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class u{constructor(){this.type=1}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}evaluate(r){return!0}serialize(){return"true"}keys(){return[]}map(r){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class m{constructor(r){this.key=r,this.type=2}static create(r){const D=T.get(r);return typeof D=="boolean"?D?u.INSTANCE:I.INSTANCE:new m(r)}cmp(r){return r.type!==this.type?this.type-r.type:d(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}evaluate(r){return!!r.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(r){return r.mapDefined(this.key)}negate(){return P.create(this.key)}}e.ContextKeyDefinedExpr=m;class c{constructor(r,D){this.key=r,this.value=D,this.type=4}static create(r,D){if(typeof D=="boolean")return D?m.create(r):P.create(r);const R=T.get(r);return typeof R=="boolean"?D===(R?"true":"false")?u.INSTANCE:I.INSTANCE:new c(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return r.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(r){return r.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class v{constructor(r,D){this.key=r,this.valueKey=D,this.type=10}static create(r,D){return new v(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.valueKey,r.key,r.valueKey)}equals(r){return r.type===this.type?this.key===r.key&&this.valueKey===r.valueKey:!1}evaluate(r){const D=r.getValue(this.valueKey),R=r.getValue(this.key);return Array.isArray(D)?D.indexOf(R)>=0:typeof R=="string"&&typeof D=="object"&&D!==null?y.call(D,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(r){return r.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=v;class _{constructor(r){this._actual=r,this.type=11}static create(r){return new _(r)}cmp(r){return r.type!==this.type?this.type-r.type:this._actual.cmp(r._actual)}equals(r){return r.type===this.type?this._actual.equals(r._actual):!1}evaluate(r){return!this._actual.evaluate(r)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(r){return new _(this._actual.map(r))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class b{constructor(r,D){this.key=r,this.value=D,this.type=5}static create(r,D){if(typeof D=="boolean")return D?P.create(r):m.create(r);const R=T.get(r);return typeof R=="boolean"?D===(R?"true":"false")?I.INSTANCE:u.INSTANCE:new b(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return r.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(r){return r.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class P{constructor(r){this.key=r,this.type=3}static create(r){const D=T.get(r);return typeof D=="boolean"?D?I.INSTANCE:u.INSTANCE:new P(r)}cmp(r){return r.type!==this.type?this.type-r.type:d(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}evaluate(r){return!r.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(r){return r.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=P;class l{constructor(r,D){this.key=r,this.value=D,this.type=12}static create(r,D){return new l(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(r){return r.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class f{constructor(r,D){this.key=r,this.value=D,this.type=13}static create(r,D){return new f(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(r){return r.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class p{constructor(r,D){this.key=r,this.value=D,this.type=14}static create(r,D){return new p(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(r){return r.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(r,D){this.key=r,this.value=D,this.type=15}static create(r,D){return new t(r,D)}cmp(r){return r.type!==this.type?this.type-r.type:w(this.key,this.value,r.key,r.value)}equals(r){return r.type===this.type?this.key===r.key&&this.value===r.value:!1}evaluate(r){return parseFloat(r.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(r){return r.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(r,D){this.key=r,this.regexp=D,this.type=7}static create(r,D){return new s(r,D)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.key<r.key)return-1;if(this.key>r.key)return 1;const D=this.regexp?this.regexp.source:"",R=r.regexp?r.regexp.source:"";return D<R?-1:D>R?1:0}equals(r){if(r.type===this.type){const D=this.regexp?this.regexp.source:"",R=r.regexp?r.regexp.source:"";return this.key===r.key&&D===R}return!1}evaluate(r){let D=r.getValue(this.key);return this.regexp?this.regexp.test(D):!1}serialize(){const r=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${r}`}keys(){return[this.key]}map(r){return r.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=s;class o{constructor(r){this._actual=r,this.type=8}static create(r){return new o(r)}cmp(r){return r.type!==this.type?this.type-r.type:this._actual.cmp(r._actual)}equals(r){return r.type===this.type?this._actual.equals(r._actual):!1}evaluate(r){return!this._actual.evaluate(r)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(r){return new o(this._actual.map(r))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class n{constructor(r){this.expr=r,this.type=6}static create(r){return n._normalizeArr(r)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let D=0,R=this.expr.length;D<R;D++){const x=i(this.expr[D],r.expr[D]);if(x!==0)return x}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].equals(r.expr[D]))return!1;return!0}return!1}evaluate(r){for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].evaluate(r))return!1;return!0}static _normalizeArr(r){const D=[];let R=!1;for(const x of r)if(!!x){if(x.type===1){R=!0;continue}if(x.type===0)return I.INSTANCE;if(x.type===6){D.push(...x.expr);continue}D.push(x)}if(D.length===0&&R)return u.INSTANCE;if(D.length!==0){if(D.length===1)return D[0];for(D.sort(i);D.length>1;){const x=D[D.length-1];if(x.type!==9)break;D.pop();const j=D.pop(),te=a.create(x.expr.map(Q=>n.create([Q,j])));te&&(D.push(te),D.sort(i))}return D.length===1?D[0]:new n(D)}}serialize(){return this.expr.map(r=>r.serialize()).join(" && ")}keys(){const r=[];for(let D of this.expr)r.push(...D.keys());return r}map(r){return new n(this.expr.map(D=>D.map(r)))}negate(){let r=[];for(let D of this.expr)r.push(D.negate());return a.create(r)}}e.ContextKeyAndExpr=n;class a{constructor(r){this.expr=r,this.type=9}static create(r){const D=a._normalizeArr(r);if(D.length!==0)return D.length===1?D[0]:new a(D)}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let D=0,R=this.expr.length;D<R;D++){const x=i(this.expr[D],r.expr[D]);if(x!==0)return x}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let D=0,R=this.expr.length;D<R;D++)if(!this.expr[D].equals(r.expr[D]))return!1;return!0}return!1}evaluate(r){for(let D=0,R=this.expr.length;D<R;D++)if(this.expr[D].evaluate(r))return!0;return!1}static _normalizeArr(r){let D=[],R=!1;if(r){for(let x=0,j=r.length;x<j;x++){const te=r[x];if(!!te){if(te.type===0){R=!0;continue}if(te.type===1)return[u.INSTANCE];if(te.type===9){D=D.concat(te.expr);continue}D.push(te)}}if(D.length===0&&R)return[I.INSTANCE];D.sort(i)}return D}serialize(){return this.expr.map(r=>r.serialize()).join(" || ")}keys(){const r=[];for(let D of this.expr)r.push(...D.keys());return r}map(r){return new a(this.expr.map(D=>D.map(r)))}negate(){let r=[];for(let R of this.expr)r.push(R.negate());const D=R=>R.type===9?R.expr:[R];for(;r.length>1;){const R=r.shift(),x=r.shift(),j=[];for(const te of D(R))for(const Q of D(x))j.push(A.and(te,Q));r.unshift(A.or(...j))}return r[0]}}e.ContextKeyOrExpr=a;class h extends m{constructor(r,D,R){super(r);this._defaultValue=D,typeof R=="object"?h._info.push({...R,key:r}):R!==!0&&h._info.push({key:r,description:R,type:D!=null?typeof D:void 0})}static all(){return h._info.values()}bindTo(r){return r.createKey(this.key,this._defaultValue)}getValue(r){return r.getContextKeyValue(this.key)}toNegated(){return A.not(this.key)}isEqualTo(r){return A.equals(this.key,r)}notEqualsTo(r){return A.notEquals(this.key,r)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(E,r){return E<r?-1:E>r?1:0}function w(E,r,D,R){return E<D?-1:E>D?1:r<R?-1:r>R?1:0}}),define(ve[183],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[184],we([0,1,10,156,4]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=k;var T;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var y;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var S;(function(I){I.Install="install",I.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var A;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(A=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(u,m){super(u);this.code=m,this.name=m}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(ve[26],we([0,1,9,4]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=C;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,u){if(typeof I=="undefined"||I===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof I=="string"||typeof u=="string"){let m=typeof I=="string"?I:I.value,c=typeof u=="string"?u:u.value;return g.equalsIgnoreCase(m,c)}return I._lower===u._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=y;function S(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function A(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=A,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[185],we([0,1,9,26]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(c,v){return c.uuid&&v.uuid?c.uuid===v.uuid:c.id===v.id?!0:(0,g.compareIgnoreCase)(c.id,v.id)===0}e.areSameExtensions=C;class k{constructor(v,_){this.version=_,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof k?C(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=k;function T(c,v){return`${c}.${v}`}e.getExtensionId=T;function y(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function S(c,v){return y(T(c,v))}e.getGalleryExtensionId=S;function A(c,v){const _=[],b=P=>{for(const l of _)if(l.some(f=>C(v(f),v(P))))return l;return null};for(const P of c){const l=b(P);l?l.push(P):_.push([P])}return _}e.groupByExtension=A;function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function u(c){const v=new Set;for(const _ of c)_.malicious&&v.add(_.id.id);return v}e.getMaliciousExtensionsSet=u;function m(c,v){const _=[],b=v.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const P=b.shift();if(P&&_.every(l=>!C(l.identifier,{id:P}))){const l=c.filter(f=>C(f.identifier,{id:P}));l.length===1&&(_.push(l[0]),b.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=m}),define(ve[186],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(ve[187],we([0,1,39,10,8,11,140,28,112,158,186]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=A.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends u{openTerminal(f,p){return this.spawnTerminal(g,f,S.getWindowsShell(),p)}spawnTerminal(f,p,t,s){const o=p.windowsExec||m.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=C.basename(o).toLowerCase();if(n==="cmder"||n==="cmder.exe")return f.spawn(o,s?[s]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return o.indexOf(" ")>=0&&a.push('""'),a.push(o),(n==="wt"||n==="wt.exe")&&a.push("-d ."),new Promise((h,d)=>{const w=_(process),E=f.spawn(t,a,{cwd:s,env:w});E.on("error",d),E.on("exit",()=>h())})}runInTerminal(f,p,t,s,o){const n="windowsExec"in o&&o.windowsExec?o.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,h)=>{const d=`"${p} - ${I}"`,w=`""${t.join('" "')}" & pause"`,E=["/c","start",d,"/wait",n,"/c",w],r=Object.assign({},_(process),s);Object.keys(r).filter(x=>r[x]===null).forEach(x=>delete r[x]);const D={cwd:p,env:r,windowsVerbatimArguments:!0};g.spawn(m.CMD,E,D).on("error",x=>{h(b(x))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class c extends u{openTerminal(f,p){return this.spawnTerminal(g,f,p)}runInTerminal(f,p,t,s,o){const n=o.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((a,h)=>{if(n===i.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const d=n===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,J).fsPath,"-t",f||I,"-w",p];for(let R of t)E.push("-a"),E.push(R);if(s){const R=Object.assign({},_(process),s);for(let x in R){const j=R[x];j===null?(E.push("-u"),E.push(x)):(E.push("-e"),E.push(`${x}=${j}`))}}let r="";const D=g.spawn(c.OSASCRIPT,E);D.on("error",R=>{h(b(R))}),D.stderr.on("data",R=>{r+=R.toString()}),D.on("exit",R=>{if(R===0)a(void 0);else if(r){const x=r.split(`
`,1);h(new Error(x[0]))}else h(new Error(A.localize(1,null,d,R)))})}else h(new Error(A.localize(2,null,n)))})}spawnTerminal(f,p,t){const s=p.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((o,n)=>{const a=["-a",s];t&&a.push(t);const h=_(process),d=f.spawn("/usr/bin/open",a,{cwd:t,env:h});d.on("error",n),d.on("exit",()=>o())})}}e.MacExternalTerminalService=c,c.OSASCRIPT="/usr/bin/osascript";class v extends u{openTerminal(f,p){return this.spawnTerminal(g,f,p)}runInTerminal(f,p,t,s,o){const n=o.linuxExec?Promise.resolve(o.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((a,h)=>{let d=[];n.then(w=>{w.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const E=`${P(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;d.push(`''${E}''`);const r=Object.assign({},_(process),s);Object.keys(r).filter(j=>r[j]===null).forEach(j=>delete r[j]);const D={cwd:p,env:r};let R="";const x=g.spawn(w,d,D);x.on("error",j=>{h(b(j))}),x.stderr.on("data",j=>{R+=j.toString()}),x.on("exit",j=>{if(j===0)a(void 0);else if(R){const te=R.split(`
`,1);h(new Error(te[0]))}else h(new Error(A.localize(4,null,w,j)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async f=>{k.isLinux?await y.Promises.exists("/etc/debian_version")?f("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?f("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?f("konsole"):process.env.COLORTERM?f(process.env.COLORTERM):process.env.TERM?f(process.env.TERM):f("xterm"):f("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(f,p,t){const s=p.linuxExec?Promise.resolve(p.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,n)=>{s.then(a=>{const h=_(process),d=f.spawn(a,[],{cwd:t,env:h});d.on("error",n),d.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=A.localize(3,null);function _(l){const f={...l.env};return(0,T.sanitizeProcessEnvironment)(f),f}function b(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(A.localize(5,null,l.path)):l}function P(l){let f="";for(let p of l)p.indexOf(" ")>=0?f+='"'+p+'"':f+=p,f+=" ";return f}}),define(ve[42],we([0,1,22,8,9,14,2,159,4]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function A(N){return N.create===!0}e.isFileOpenForWriteOptions=A;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(N){N[N.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var u;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function c(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=c;function v(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function _(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=_;var b;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(U,F){super(U);this.code=F}}e.FileSystemProviderError=P;function l(N,U){const F=new P(N.toString(),U);return p(F,U),F}e.createFileSystemProviderError=l;function f(N){return N||l((0,y.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=f;function p(N,U){return N.name=U?`${U} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=p;function t(N){if(!N)return b.Unknown;if(N instanceof P)return N.code;const U=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!U)return b.Unknown;switch(U[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function s(N){if(N instanceof w)return N.fileOperationResult;switch(t(N)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var o;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(o=e.FileOperation||(e.FileOperation={}));class n{constructor(U,F,V){this.resource=U,this.operation=F,this.target=V}isOperation(U){return this.operation===U}}e.FileOperationEvent=n;var a;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(U,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const V of U)switch(V.type){case 1:this.added||(this.added=g.TernarySearchTree.forUris(()=>F)),this.added.set(V.resource,V);break;case 0:this.updated||(this.updated=g.TernarySearchTree.forUris(()=>F)),this.updated.set(V.resource,V);break;case 2:this.deleted||(this.deleted=g.TernarySearchTree.forUris(()=>F)),this.deleted.set(V.resource,V);break}}contains(U,...F){return this.doContains(U,{includeChildren:!1},...F)}affects(U,...F){return this.doContains(U,{includeChildren:!0},...F)}doContains(U,F,...V){if(!U)return!1;const M=V.length>0;return!!((!M||V.includes(1))&&(this.added?.get(U)||F.includeChildren&&this.added?.findSuperstr(U))||(!M||V.includes(0))&&(this.updated?.get(U)||F.includeChildren&&this.updated?.findSuperstr(U))||(!M||V.includes(2))&&(this.deleted?.findSubstr(U)||F.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function d(N,U,F){return!N||!U||N===U||U.length>N.length?!1:(U.charAt(U.length-1)!==L.sep&&(U+=L.sep),F?(0,C.startsWithIgnoreCase)(N,U):N.indexOf(U)===0)}e.isParent=d;class w extends Error{constructor(U,F,V){super(U);this.fileOperationResult=F,this.options=V}}e.FileOperationError=w;class E extends w{constructor(U,F,V){super(U,2,V);this.stat=F}}e.NotModifiedSinceFileOperationError=E;var r;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(r=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=R;async function x(N,U){if(!U.canHandleResource(T.URI.from({scheme:N.scheme})))return new Promise(F=>{const V=U.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===N.scheme&&M.added&&(V.dispose(),F())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(U){return(0,k.isNumber)(U)||(U=0),U<j.KB?(0,y.localize)(1,null,U.toFixed(0)):U<j.MB?(0,y.localize)(2,null,(U/j.KB).toFixed(2)):U<j.GB?(0,y.localize)(3,null,(U/j.MB).toFixed(2)):U<j.TB?(0,y.localize)(4,null,(U/j.GB).toFixed(2)):(0,y.localize)(5,null,(U/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var te;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(te=e.Arch||(e.Arch={}));function Q(N){return{maxFileSize:N===0?300*j.MB:16*j.GB,maxHeapSize:N===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=Q}),define(ve[83],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...C){this._entries=new Map;for(let[k,T]of C)this.set(k,T)}set(C,k){const T=this._entries.get(C);return this._entries.set(C,k),T}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=g}),define(ve[188],we([0,1,17,16,114,180,4,83]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class A extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class i{constructor(c=new y.ServiceCollection,v=!1,_){this._activeInstantiations=new Set,this._services=c,this._strict=v,this._parent=_,this._services.set(T.IInstantiationService,this)}createChild(c){return new i(c,this._strict,this)}invokeFunction(c,...v){let _=u.traceInvocation(c),b=!1;try{return c({get:(l,f)=>{if(b)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(l,_);if(!p&&f!==T.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return p}},...v)}finally{b=!0,_.stop()}}createInstance(c,...v){let _,b;return c instanceof C.SyncDescriptor?(_=u.traceCreation(c.ctor),b=this._createInstance(c.ctor,c.staticArguments.concat(v),_)):(_=u.traceCreation(c),b=this._createInstance(c,v,_)),_.stop(),b}_createInstance(c,v=[],_){let b=T._util.getServiceDependencies(c).sort((f,p)=>f.index-p.index),P=[];for(const f of b){let p=this._getOrCreateServiceInstance(f.id,_);if(!p&&this._strict&&!f.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${f.id}.`);P.push(p)}let l=b.length>0?b[0].index:v.length;if(v.length!==l){console.warn(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${v.length} static arguments`);let f=l-v.length;f>0?v=v.concat(new Array(f)):v=v.slice(0,l)}return new c(...[...v,...P])}_setServiceInstance(c,v){if(this._services.get(c)instanceof C.SyncDescriptor)this._services.set(c,v);else if(this._parent)this._parent._setServiceInstance(c,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let v=this._services.get(c);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):v}_getOrCreateServiceInstance(c,v){let _=this._getServiceInstanceOrDescriptor(c);return _ instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,_,v.branch(c,!0)):(v.branch(c,!1),_)}_safeCreateAndCacheServiceInstance(c,v,_){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,v,_)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,v,_){const b=new k.Graph(f=>f.id.toString());let P=0;const l=[{id:c,desc:v,_trace:_}];for(;l.length;){const f=l.pop();if(b.lookupOrInsertNode(f),P++>1e3)throw new A(b);for(let p of T._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${c} depends on ${p.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const s={id:p.id,desc:t,_trace:f._trace.branch(p.id,!0)};b.insertEdge(f,s),l.push(s)}}}for(;;){const f=b.roots();if(f.length===0){if(!b.isEmpty())throw new A(b);break}for(const{data:p}of f){if(this._getServiceInstanceOrDescriptor(p.id)instanceof C.SyncDescriptor){const s=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,s)}b.removeNode(p)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,v,_=[],b,P){if(this._services.get(c)instanceof C.SyncDescriptor)return this._createServiceInstance(v,_,b,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,v,_,b,P);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(c,v=[],_,b){if(_){const P=new g.IdleValue(()=>this._createInstance(c,v,b));return new Proxy(Object.create(null),{get(l,f){if(f in l)return l[f];let p=P.value,t=p[f];return typeof t!="function"||(t=t.bind(p),l[f]=t),t},set(l,f,p){return P.value[f]=p,!0}})}else return this._createInstance(c,v,b)}}e.InstantiationService=i;var I;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(I||(I={}));class u{constructor(c,v){this.type=c,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return S?new u(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(c){return S?new u(0,c.name):u._None}branch(c,v){let _=new u(2,c.toString());return this._dep.push([c,v,_]),_}stop(){let c=Date.now()-this._start;u._totals+=c;let v=!1;function _(P,l){let f=[],p=new Array(P+1).join("	");for(const[t,s,o]of l._dep)if(s&&o){v=!0,f.push(`${p}CREATES -> ${t}`);let n=_(P+1,o);n&&f.push(n)}else f.push(`${p}uses -> ${t}`);return f.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(c>2||v)&&console.log(b.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(ve[12],we([0,1,60,3,6,11,4]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function y(){return new Date().toISOString()}var S;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class A extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class i extends A{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(S.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(S.Error,this.format(o))}else this.log(S.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let o=0;o<t.length;o++){let n=t[o];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}s+=(o>0?" ":"")+n}return s}}e.AbstractMessageLogger=i;class I extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...s):console.log(`[main ${y()}]`,t,...s))}debug(t,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...s):console.log(`[main ${y()}]`,t,...s))}info(t,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...s):console.log(`[main ${y()}]`,t,...s))}warn(t,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...s):console.warn(`[main ${y()}]`,t,...s))}error(t,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...s):console.error(`[main ${y()}]`,t,...s))}critical(t,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...s):console.error(`[main ${y()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class u extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=u;class m extends A{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,g.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class c extends A{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const o of this.logServices)o.trace(t,...s)}debug(t,...s){for(const o of this.logServices)o.debug(t,...s)}info(t,...s){for(const o of this.logServices)o.info(t,...s)}warn(t,...s){for(const o of this.logServices)o.warn(t,...s)}error(t,...s){for(const o of this.logServices)o.error(t,...s)}critical(t,...s){for(const o of this.logServices)o.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class v extends C.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=v;class _ extends C.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,s?.always?S.Trace:this.logLevel,s),this.loggers.set(t.toString(),o),s?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class b{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=b;function P(p){if(p.verbose)return S.Trace;if(typeof p.logLevel=="string"){const t=l(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=P;function l(p){switch(p){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function f(p){switch(p){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=f}),define(ve[115],we([0,1,42,12]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(S,A,i,I){try{const u=await new Promise((m,c)=>{J(["spdlog"],m,c)});return u.setFlushOn(L.LogLevel.Trace),u.createAsyncRotatingLogger(S,A,i,I)}catch(u){console.error(u)}return null}function k(S,A,i,I){const u=J.__$__nodeRequire("spdlog");return u.setFlushOn(L.LogLevel.Trace),u.createRotatingLogger(S,A,i,I)}e.createRotatingLogger=k;function T(S,A,i){switch(A){case L.LogLevel.Trace:S.trace(i);break;case L.LogLevel.Debug:S.debug(i);break;case L.LogLevel.Info:S.info(i);break;case L.LogLevel.Warning:S.warn(i);break;case L.LogLevel.Error:S.error(i);break;case L.LogLevel.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}class y extends L.AbstractMessageLogger{constructor(A,i,I,u){super();this.name=A,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const A=this.rotating?6:1,i=30/A*g.ByteSize.MB;return C(this.name,this.filepath,i,A).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:u,message:m}of this.buffer)T(this._logger,u,m);this.buffer=[]}})}log(A,i){this._logger?T(this._logger,A,i):this.getLevel()<=A&&this.buffer.push({level:A,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=y}),define(ve[116],we([0,1,48,160,4]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(k=e.MarkerTag||(e.MarkerTag={}));var T;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function A(c,v){return v-c}S.compare=A;const i=Object.create(null);i[S.Error]=(0,L.localize)(0,null),i[S.Warning]=(0,L.localize)(1,null),i[S.Info]=(0,L.localize)(2,null);function I(c){return i[c]||""}S.toString=I;function u(c){switch(c){case g.default.Error:return S.Error;case g.default.Warning:return S.Warning;case g.default.Info:return S.Info;case g.default.Ignore:return S.Hint}}S.fromSeverity=u;function m(c){switch(c){case S.Error:return g.default.Error;case S.Warning:return g.default.Warning;case S.Info:return g.default.Info;case S.Hint:return g.default.Ignore}}S.toSeverity=m}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(S){const A="";function i(u){return I(u,!0)}S.makeKey=i;function I(u,m){let c=[A];return u.source?c.push(u.source.replace("\xA6","\\\xA6")):c.push(A),u.code?typeof u.code=="string"?c.push(u.code.replace("\xA6","\\\xA6")):c.push(u.code.value.replace("\xA6","\\\xA6")):c.push(A),u.severity!==void 0&&u.severity!==null?c.push(T.toString(u.severity)):c.push(A),u.message&&m?c.push(u.message.replace("\xA6","\\\xA6")):c.push(A),u.startLineNumber!==void 0&&u.startLineNumber!==null?c.push(u.startLineNumber.toString()):c.push(A),u.startColumn!==void 0&&u.startColumn!==null?c.push(u.startColumn.toString()):c.push(A),u.endLineNumber!==void 0&&u.endLineNumber!==null?c.push(u.endLineNumber.toString()):c.push(A),u.endColumn!==void 0&&u.endColumn!==null?c.push(u.endColumn.toString()):c.push(A),c.push(A),c.join("\xA6")}S.makeKeyOptionalMessage=I})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(ve[189],we([0,1,3,48,4]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,C.createDecorator)("notificationService");var k;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(k=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new S,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=y;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S}),define(ve[190],we([0,1,6,9,2,4]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function T(y,S){return C.URI.isUri(y)?(0,L.equalsIgnoreCase)(y.scheme,S):(0,L.startsWithIgnoreCase)(y,S+":")}e.matchesScheme=T}),define(ve[191],we([0,1,10,11,38,23]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const y=L.globals.vscode.context.configuration();if(y)T=y.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const y=(0,k.dirname)(g.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,k.joinPath)(y,"product.json").fsPath);const S=J.__$__nodeRequire((0,k.joinPath)(y,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:S.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.60.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var xe=this&&this.__param||function(J,e){return function(g,L){e(g,L,J)}};define(ve[117],we([0,1,17,21,6,4]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,k.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let S=class extends C.Disposable{constructor(I,u){super();this.deferred=new g.DeferredPromise,u.withProgress(I,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=We([xe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class A extends C.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(I){this.stop();const u=++this.currentOperationId,m=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:m.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,k.createDecorator)("editorProgressService")}),define(ve[34],we([0,1,54,14]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(T,y){g.ok(L.isString(T)),g.ok(L.isObject(y)),g.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,y)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new C}),define(ve[118],we([0,1,3,34]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class k{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,A){this.schemasById[C(S)]=A,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new k;L.Registry.add(e.Extensions.JSONContribution,T)}),define(ve[84],we([0,1,3,14,155,118,34]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=T.Registry.as(k.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new g.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new g.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,l=!0){this.registerConfigurations([P],l)}registerConfigurations(P,l=!0){const f=[];P.forEach(p=>{f.push(...this.validateAndRegisterProperties(p,l,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(P){const l=[],f=p=>{if(p.properties)for(const t in p.properties)l.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>f(t))};for(const p of P){f(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(P){const l=[],f=[];for(const p of P)for(const t in p)if(l.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const s={type:"object",default:this.defaultValues[t],description:C.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};f.push(u(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=p[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(P){const l=[];for(const f of P)for(const p in f)if(l.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const l of P)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,l=!0,f,p=3){p=L.isUndefinedOrNull(P.scope)?p:P.scope;let t=[],s=P.properties;if(s)for(let n in s){if(l&&v(n)){delete s[n];continue}const a=s[n];if(this.updatePropertyDefaultValue(n,a),e.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=L.isUndefinedOrNull(a.scope)?p:a.scope,a.restricted=L.isUndefinedOrNull(a.restricted)?!!f?.restrictedConfigurations?.includes(n):a.restricted),s[n].hasOwnProperty("included")&&!s[n].included){this.excludedConfigurationProperties[n]=s[n],delete s[n];continue}else this.configurationProperties[n]=s[n];!s[n].deprecationMessage&&s[n].markdownDeprecationMessage&&(s[n].deprecationMessage=s[n].markdownDeprecationMessage),t.push(n)}let o=P.allOf;if(o)for(let n of o)t.push(...this.validateAndRegisterProperties(n,l,f,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const l=f=>{let p=f.properties;if(p)for(const s in p)this.updateSchema(s,p[s]);let t=f.allOf;t&&t.forEach(l)};l(P)}updateSchema(P,l){switch(e.allSettings.properties[P]=l,l.scope){case 1:e.applicationSettings.properties[P]=l;break;case 2:e.machineSettings.properties[P]=l;break;case 6:e.machineOverridableSettings.properties[P]=l;break;case 3:e.windowSettings.properties[P]=l;break;case 4:e.resourceSettings.properties[P]=l;break;case 5:e.resourceSettings.properties[P]=l,this.resourceLanguageSettingsSchema.properties[P]=l;break}}removeFromSchema(P,l){switch(delete e.allSettings.properties[P],l.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const l=`[${P}]`,f={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,f),e.allSettings.properties[l]=f,e.applicationSettings.properties[l]=f,e.machineSettings.properties[l]=f,e.machineOverridableSettings.properties[l]=f,e.windowSettings.properties[l]=f,e.resourceSettings.properties[l]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,l){let f=this.defaultValues[P];L.isUndefined(f)&&(f=l.default),L.isUndefined(f)&&(f=m(l.type)),l.default=f}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function u(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=u;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const c=new i;T.Registry.add(e.Extensions.Configuration,c);function v(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?C.localize(5,null,b):c.getConfigurationProperties()[b]!==void 0?C.localize(6,null,b):null:C.localize(4,null)}e.validateProperty=v;function _(){const b=[],P=c.getConfigurationProperties();for(const l of Object.keys(P))b.push([l,P[l].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=_}),define(ve[119],we([0,1,25,14,2,84,4,34]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof C.URI)}e.isConfigurationOverrides=S;var A;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(s,o){const n=o?s?o.keys.filter(D=>s.keys.indexOf(D)===-1):[...o.keys]:[],a=s?o?s.keys.filter(D=>o.keys.indexOf(D)===-1):[...s.keys]:[],h=[];if(o&&s){for(const D of s.keys)if(o.keys.indexOf(D)!==-1){const R=b(s.contents,D),x=b(o.contents,D);g.equals(R,x)||h.push(D)}}const d=[],w=D=>{const R={};for(const x of D)for(const j of x.identifiers)R[p(j)]=x;return R},E=o?w(o.overrides):{},r=s?w(s.overrides):{};if(Object.keys(E).length)for(const D of n){const R=E[D];R&&d.push([(0,k.overrideIdentifierFromKey)(D),R.keys])}if(Object.keys(r).length)for(const D of a){const R=r[D];R&&d.push([(0,k.overrideIdentifierFromKey)(D),R.keys])}if(Object.keys(E).length&&Object.keys(r).length)for(const D of h){const R=r[D],x=E[D];if(R&&x){const j=I({contents:R.contents,keys:R.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});d.push([(0,k.overrideIdentifierFromKey)(D),[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:a,updated:h,overrides:d}}e.compare=I;function u(s,o){const n=[];for(const a of Object.keys(s))if(k.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const d in s[a])h[d]=s[a][d];n.push({identifiers:[(0,k.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:m(h,o)})}return n}e.toOverrides=u;function m(s,o){const n=Object.create(null);for(let a in s)c(n,a,s[a],o);return n}e.toValuesTree=m;function c(s,o,n,a){const h=o.split("."),d=h.pop();let w=s;for(let E=0;E<h.length;E++){let r=h[E],D=w[r];switch(typeof D){case"undefined":D=w[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${o} as ${h.slice(0,E+1).join(".")} is ${JSON.stringify(D)}`);return}w=D}if(typeof w=="object"&&w!==null)try{w[d]=n}catch(E){a(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(w)}`)}else a(`Ignoring ${o} as ${h.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=c;function v(s,o){const n=o.split(".");_(s,n)}e.removeFromValueTree=v;function _(s,o){const n=o.shift();if(o.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const a=s[n];typeof a=="object"&&!Array.isArray(a)&&(_(a,o),Object.keys(a).length===0&&delete s[n])}}function b(s,o,n){function a(w,E){let r=w;for(const D of E){if(typeof r!="object"||r===null)return;r=r[D]}return r}const h=o.split("."),d=a(s,h);return typeof d=="undefined"?n:d}e.getConfigurationValue=b;function P(s,o,n){Object.keys(o).forEach(a=>{a!=="__proto__"&&(a in s?L.isObject(s[a])&&L.isObject(o[a])?P(s[a],o[a],n):n&&(s[a]=o[a]):s[a]=o[a])})}e.merge=P;function l(){const s=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=l;function f(){const s=Object.create(null),o=y.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let n in o){let a=o[n].default;c(s,n,a,h=>console.error(`Conflict in default settings: ${h}`))}return s}e.getDefaultValues=f;function p(s){return`[${s}]`}e.keyFromOverrideIdentifier=p;function t(s,o,n){const a=s.inspect(o),h=s.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}e.getMigratedSettingValue=t}),define(ve[192],we([0,1,20,3,57,6,22,25,14,2,119,84,34]),function(J,e,g,L,C,k,T,y,S,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},s=[],o=[]){this._contents=t,this._keys=s,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const o=this.getContentsForOverrideIdentifer(s);return o?t?(0,i.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let o={};for(const n of g.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[n],h=s[n];h&&(typeof a=="object"&&typeof h=="object"?(a=y.deepClone(a),this.mergeContents(a,h)):a=h),o[n]=a}return new m(o,this.keys,this.overrides)}merge(...t){const s=y.deepClone(this.contents),o=y.deepClone(this.overrides),n=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const h of a.overrides){const[d]=o.filter(w=>g.equals(w.identifiers,h.identifiers));d?this.mergeContents(d.contents,h.contents):o.push(y.deepClone(h))}for(const h of a.keys)n.indexOf(h)===-1&&n.push(h)}return new m(s,n,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const o of Object.keys(s)){if(o in t&&S.isObject(t[o])&&S.isObject(s[o])){this.mergeContents(t[o],s[o]);continue}t[o]=y.deepClone(s[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,i.addToValueTree)(this.contents,t,s,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let o=0;o<s;o++)t.indexOf(this.keys[o])===0&&(s=o);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=m;class c extends m{constructor(){const t=(0,i.getDefaultValues)(),s=(0,i.getConfigurationKeys)(),o=[];for(const n of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(n)&&o.push({identifiers:[(0,I.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,i.toValuesTree)(t[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,o)}}e.DefaultConfigurationModel=c;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:o,keys:n,overrides:a,restricted:h}=this.doParseRaw(t,s);this._configurationModel=new m(o,n,a),this._restrictedConfigurations=h||[]}doParseContent(t){let s={},o=null,n=[],a=[],h=[];function d(E){Array.isArray(n)?n.push(E):o!==null&&(n[o]=E)}let w={onObjectBegin:()=>{let E={};d(E),a.push(n),n=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let E=[];d(E),a.push(n),n=E,o=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:d,onError:(E,r,D)=>{h.push({error:E,offset:r,length:D})}};if(t)try{C.visit(t,w),s=n[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return s}doParseRaw(t,s){const o=u.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,o,!0,s);t=n.raw;const a=(0,i.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),h=Object.keys(t),d=(0,i.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:h,overrides:d,restricted:n.restricted}}filter(t,s,o,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const a={},h=[];for(let d in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(d)&&o){const w=this.filter(t[d],s,!1,n);a[d]=w.raw,h.push(...w.restricted)}else{const w=s[d],E=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&h.push(d),(E===void 0||n.scopes===void 0||n.scopes.includes(E))&&(n.skipRestricted&&w?.restricted||(a[d]=t[d]))}return{raw:a,restricted:h}}}e.ConfigurationModelParser=v;class _ extends k.Disposable{constructor(t,s,o,n){super();this.userSettingsResource=t,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class b{constructor(t,s,o=new m,n=new m,a=new T.ResourceMap,h=new m,d=new T.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=o,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=d,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,s,o){return this.getConsolidateConfigurationModel(s,o).getValue(t)}updateValue(t,s,o={}){let n;o.resource?(n=this._memoryConfigurationByResource.get(o.resource),n||(n=new m,this._memoryConfigurationByResource.set(o.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(t):n.setValue(t,s),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,o){const n=this.getConsolidateConfigurationModel(s,o),a=this.getFolderConfigurationModelForResource(s.resource,o),h=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,d=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),r=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),D=o?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,R=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,x=s.overrideIdentifier?h.override(s.overrideIdentifier).getValue(t):h.getValue(t),j=n.getValue(t),te=g.distinct(g.flatten(n.overrides.map(Q=>Q.identifiers))).filter(Q=>n.getOverrideValue(t,Q)!==void 0);return{defaultValue:d,userValue:w,userLocalValue:E,userRemoteValue:r,workspaceValue:D,workspaceFolderValue:R,memoryValue:x,value:j,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:r!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:D!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:h.getValue(t),override:s.overrideIdentifier?h.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:te.length?te:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=s.filter(n=>I.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,I.overrideIdentifierFromKey)(n),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),d=t.getKeysForOverrideIdentifier(a),w=[...d.filter(E=>h.indexOf(E)===-1),...h.filter(E=>d.indexOf(E)===-1),...h.filter(E=>!y.equals(this._defaultConfiguration.override(a).getValue(E),t.override(a).getValue(E)))];return[a,w]});return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:n,overrides:a}=(0,i.compare)(this.localUserConfiguration,t),h=[...s,...o,...n];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:n,overrides:a}=(0,i.compare)(this.remoteUserConfiguration,t);let h=[...s,...o,...n];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:n,overrides:a}=(0,i.compare)(this.workspaceConfiguration,t);let h=[...s,...o,...n];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const o=this.folderConfigurations.get(t),{added:n,updated:a,removed:h,overrides:d}=(0,i.compare)(o,s);let w=[...n,...a,...h];return(w.length||!o)&&this.updateFolderConfiguration(t,s),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:n,removed:a,overrides:h}=(0,i.compare)(s,void 0);return{keys:[...o,...n,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let o=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},s){let o=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const n=s.getFolder(t);n&&(o=this.getFolderConsolidatedConfiguration(n.uri)||o);const a=this._memoryConfigurationByResource.get(t);a&&(o=o.merge(a))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const o=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(s=o.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=o}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:o,overrides:n,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:o,overrides:n,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((h,d)=>(h.set(A.URI.revive(d[0]),this.parseConfigurationModel(d[1])),h),new T.ResourceMap);return new b(s,o,new m,n,a,new m,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function P(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,s=new Map;for(const n of p)n.keys.forEach(a=>t.add(a)),n.overrides.forEach(([a,h])=>{const d=(0,T.getOrSet)(s,a,new Set);h.forEach(w=>d.add(w))});const o=[];return s.forEach((n,a)=>o.push([a,[...n.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=P;class l{constructor(t,s,o,n){this.change=t,this.previous=s,this.currentConfiguraiton=o,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(d=>a.add(d)),t.overrides.forEach(([,d])=>d.forEach(w=>a.add(w))),this.affectedKeys=[...a.values()];const h=new m;this.affectedKeys.forEach(d=>h.setValue(d,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!y.equals(o,n)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let o=(0,i.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof o=="object"&&(n=Object.keys(o)[0]);){if(t=t[n],!t)return!1;o=o[n]}return!0}}e.ConfigurationChangeEvent=l;class f extends l{constructor(t,s,o,n){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=o,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=f}),define(ve[120],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(T,y=L.Unknown,S){super(T);this._message=T,this._code=y,this._detail=S,this.isHandled=y===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(T){return T instanceof C&&T._code===L.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof C&&T._code===L.NoResolverFound}static isHandled(T){return T instanceof C&&T.isHandled}}e.RemoteAuthorityResolverError=C}),define(ve[85],we([0,1,10]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(A){return A.scheme===g.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=L;function C(A){if(!A)return;const i=A.indexOf("+");return i<0?A:A.substr(0,i)}e.getRemoteName=C;function k(A){return A.scheme!==g.Schemas.file&&A.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=k;function T(A){if(A.folders.length)return A.folders.every(i=>k(i.uri))?A.folders[0].uri:void 0;if(A.configuration&&k(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=T;function y(A){return T(A)?.scheme}e.getVirtualWorkspaceScheme=y;function S(A){return T(A)!==void 0}e.isVirtualWorkspace=S}),define(ve[193],we([0,1,3,11,4,12]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService");var T;(function(m){m.Http="http",m.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var y;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=i;function I(m,c){return c?c!==1&&m<1024:!L.isWindows&&m<1024}e.isPortPrivileged=I;let u=class{constructor(c){this.logService=c,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,v){return this._tunnelProvider=c,c?(this._canElevate=v.elevation,this._canMakePublic=v.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async c=>{const v=[],_=Array.from(this._tunnels.values());for(let b of _){const P=Array.from(b.values());for(let l of P){const f=await l.value;f&&v.push(f)}}c(v)})}async dispose(){for(const c of this._tunnels.values()){for(const{value:v}of c.values())await v.then(_=>_?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,v,_,b,P=!1,l=!1,f){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${_} on local port ${b}.`),!c)return;v||(v="localhost");const p=this.retainOrCreateTunnel(c,v,_,b,P,l,f);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==v||t.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,public:c.public,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const v=this._tunnels.get(c.tunnelRemoteHost);if(v){const _=v.get(c.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,_))}}}}async tryDisposeTunnel(c,v,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${v}.`);const b=_.value.then(async P=>{P&&(await P.dispose(!0),this._onTunnelClosed.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(v),b}}async closeTunnel(c,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${v} `);const _=this._tunnels.get(c);if(_&&_.has(v)){const b=_.get(v);b.refcount=0,await this.tryDisposeTunnel(c,v,b)}}addTunnelToMap(c,v,_){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(v,{refcount:1,value:_})}async removeEmptyTunnelFromMap(c,v){const _=this._tunnels.get(c);_&&(await _.get(v)||_.delete(v),_.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,v){let _=[c];A(c)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):i(c)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const b=_.map(P=>this._tunnels.get(P));for(const P of b){const l=P?.get(v);if(l)return l}}canTunnel(c){return!!S(c)}createWithProvider(c,v,_,b,P,l,f){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${_} on local port ${b}.`);const t={elevationRequired:P?I(b===void 0?_:b):!1},s={remoteAddress:{host:v,port:_},localAddressPort:b,public:l,protocol:f},o=c.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),o&&this.addTunnelToMap(v,_,o),o}};u=We([xe(0,k.ILogService)],u),e.AbstractTunnelService=u}),define(ve[194],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((C,k)=>J(["vsda"],C,k))}async sign(C){try{const k=await this.vsda(),T=new k.signer;if(T)return T.sign(C)}catch(k){}return C}}e.SignService=g}),define(ve[195],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,k,T=5){let y;return y=k(S=>{const A=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(A);return}const I=setTimeout(()=>this.flushBuffer(C),T);i={data:[A],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(C),y.dispose()}},this._terminalBufferMap.set(C,i)}),y}stopBuffering(C){const k=this._terminalBufferMap.get(C);k&&k.dispose()}flushBuffer(C){const k=this._terminalBufferMap.get(C);k&&(this._terminalBufferMap.delete(C),this._callback(C,k.data.join("")))}}e.TerminalDataBufferer=g}),define(ve[196],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(ve[62],we([0,1,47,3,6,4,34,196]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var S;(function(_){function b(P){return P&&typeof P=="object"&&typeof P.id=="string"}_.isThemeColor=b})(S=e.ThemeColor||(e.ThemeColor={}));function A(_){return{id:_}}e.themeColorFromId=A;var i;(function(_){function b(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}_.isThemeIcon=b;const P=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function l(s){const o=P.exec(s);if(!o)return;let[,n]=o;return{id:n}}_.fromString=l;function f(s,o){let n=s.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),o&&(n=`${n}~${o}`),{id:n}}_.modify=f;function p(s,o){return s.id===o.id&&s.color?.id===o.color?.id}_.isEqual=p;function t(s,o){return{id:s.id,color:o?A(o):void 0}}_.asThemeIcon=t,_.asClassNameArray=g.CSSIcon.asClassNameArray,_.asClassName=g.CSSIcon.asClassName,_.asCSSSelector=g.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(_){switch(_){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,C.toDisposable)(()=>{const P=this.themingParticipants.indexOf(b);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new u;T.Registry.add(e.Extensions.ThemingContribution,m);function c(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=c;class v extends C.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,P){let l=this.theme.getColor(b);return l&&P&&(l=P(l,this.theme)),l?l.toString():null}}e.Themable=v}),define(ve[197],we([0,1,17,47,3,161,118,34,62]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class A{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,P,l,f){const p=this.iconsById[b];if(p){if(l&&!p.description){p.description=l,this.iconSchema.properties[b].markdownDescription=`${l} $(${b})`;const o=this.iconReferenceSchema.enum.indexOf(b);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=l),this._onDidChange.fire()}return p}let t={id:b,description:l,defaults:P,deprecationMessage:f};this.iconsById[b]=t;let s={$ref:"#/definitions/icons"};return f&&(s.deprecationMessage=f),l&&(s.markdownDescription=`${l}: $(${b})`),this.iconSchema.properties[b]=s,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const P=this.iconReferenceSchema.enum.indexOf(b);P!==-1&&(this.iconReferenceSchema.enum.splice(P,1),this.iconReferenceSchema.enumDescriptions.splice(P,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,P){const l=this.iconFontsById[b];if(l)return l;let f={id:b,definition:P};return this.iconFontsById[b]=f,this._onDidChange.fire(),f}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFonts(){return Object.keys(this.iconFontsById).map(b=>this.iconFontsById[b])}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(p,t)=>p.id.localeCompare(t.id),P=p=>{for(;S.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of f.filter(t=>!!t.description).sort(b))l.push(`|<i class="${P(p)}"></i>|${p.id}|${S.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const p of f.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(b))l.push(`|<i class="${P(p)}"></i>|${p.id}|`);return l.join(`
`)}}const i=new A;y.Registry.add(e.Extensions.IconContribution,i);function I(_,b,P,l){return i.registerIcon(_,b,P,l)}e.registerIcon=I;function u(){return i}e.getIconRegistry=u;function m(){for(const _ of L.iconRegistry.all)i.registerIcon(_.id,_.definition,_.description);L.iconRegistry.onDidRegister(_=>i.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let c=y.Registry.as(T.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,i.getIconSchema());const v=new g.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,k.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,k.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,k.localize)(4,null)),e.syncing=S.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(ve[43],we([0,1,22,23,2,4]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var T;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function y(u){const m=u;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=y;function S(u){const m=u;return!!(m&&typeof m=="object"&&C.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=S;class A{constructor(m,c,v,_){this._id=m,this._configuration=v,this._ignorePathCasing=_,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=A;class i{constructor(m,c){this.raw=c,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(u){return new i({uri:u,index:0,name:(0,L.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=I}),define(ve[198],we([0,1,29,57,138,78,10,8,11,23,2,162,4,85,43]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(N){return(typeof N=="string"?(0,y.extname)(N):(0,A.extname)(N))===v}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,u.createDecorator)("workspacesService");function b(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function P(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=P;function l(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=l;function f(N){const U=N;return typeof U?.id=="string"&&i.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=f;function p(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(N){const U=N;return typeof U?.id=="string"&&i.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function s(N){const U=N;if(U?.uri)return{id:U.id,uri:i.URI.revive(U.uri)};const F=N;if(F?.configPath)return{id:F.id,configPath:i.URI.revive(F.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=s;function o(N,U){return A.extUriBiasedIgnorePathCase.isEqualOrParent(N,U.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function n(N){return a(N)||h(N)}e.isStoredWorkspaceFolder=n;function a(N){const U=N;return typeof U?.path=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=a;function h(N){const U=N;return typeof U?.uri=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=h;function d(N,U,F,V,M=!S.isWindows,O){if(N.scheme!==V.scheme)return{name:F,uri:N.toString(!0)};let q=U?void 0:O.relativePath(V,N);if(q!==void 0)q.length===0?q=".":S.isWindows&&N.scheme===T.Schemas.file&&!M&&(q=q.replace(/\//g,"\\"));else if(N.scheme===T.Schemas.file)q=N.fsPath,S.isWindows&&(q=(0,k.normalizeDriveLetter)(q),M&&(q=(0,g.toSlashes)(q)));else{if(!O.isEqualAuthority(N.authority,V.authority))return{name:F,uri:N.toString(!0)};q=N.path}return{name:F,path:q}}e.getStoredWorkspaceFolder=d;function w(N,U,F){let V=[],M=new Set;const O=F.dirname(U);for(let q of N){let B;if(a(q))q.path&&(B=F.resolvePath(O,q.path));else if(h(q))try{B=i.URI.parse(q.uri),B.path[0]!=="/"&&(B=B.with({path:"/"+B.path}))}catch(K){console.warn(K)}if(B){let K=F.getComparisonKey(B);if(!M.has(K)){M.add(K);const ne=q.name||F.basenameOrAuthority(B);V.push(new c.WorkspaceFolder({uri:B,name:ne,index:V.length},q))}}}return V}e.toWorkspaceFolders=w;function E(N,U,F,V,M){let O=r(U,N);const q=M.dirname(U),B=M.dirname(V),K=[],ne=D(O.folders);for(const Te of O.folders){const je=a(Te)?M.resolvePath(q,Te.path):i.URI.parse(Te.uri);let Be;F?Be=!1:Be=!a(Te)||(0,y.isAbsolute)(Te.path),K.push(d(je,Be,Te.name,B,ne,M))}const me={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Se=C.setProperty(N,["folders"],K,me);let Ce=C.applyEdits(N,Se);return O.remoteAuthority===(0,m.getRemoteAuthority)(V)&&(Ce=C.applyEdits(Ce,C.removeProperty(Ce,["remoteAuthority"],me))),Ce}e.rewriteWorkspaceFileForNewLocation=E;function r(N,U){let F=L.parse(U);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(V=>n(V));else throw new Error(`${N} looks like an invalid workspace file.`);return F}function D(N){return S.isWindows?N.some(U=>a(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=D;function R(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function x(N){return typeof N.folderUri=="string"}function j(N){return typeof N.fileUri=="string"}function te(N,U){const F={workspaces:[],files:[]};if(N){const V=function(O,q){for(let B=0;B<O.length;B++)try{q(O[B],B)}catch(K){U.warn(`Error restoring recent entry ${JSON.stringify(O[B])}: ${K.toString()}. Skip entry.`)}},M=N;if(Array.isArray(M.entries))V(M.entries,O=>{const q=O.label,B=O.remoteAuthority;R(O)?F.workspaces.push({label:q,remoteAuthority:B,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):x(O)?F.workspaces.push({label:q,remoteAuthority:B,folderUri:i.URI.parse(O.folderUri)}):j(O)&&F.files.push({label:q,remoteAuthority:B,fileUri:i.URI.parse(O.fileUri)})});else{const O=N;Array.isArray(O.workspaces3)&&V(O.workspaces3,(q,B)=>{const K=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[B]||void 0;typeof q=="object"&&typeof q.id=="string"&&typeof q.configURIPath=="string"?F.workspaces.push({label:K,workspace:{id:q.id,configPath:i.URI.parse(q.configURIPath)}}):typeof q=="string"&&F.workspaces.push({label:K,folderUri:i.URI.parse(q)})}),Array.isArray(O.files2)&&V(O.files2,(q,B)=>{const K=Array.isArray(O.fileLabels)&&O.fileLabels[B]||void 0;typeof q=="string"&&F.files.push({label:K,fileUri:i.URI.parse(q)})})}}return F}e.restoreRecentlyOpened=te;function Q(N){const U={entries:[]};for(const F of N.workspaces)P(F)?U.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):U.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of N.files)U.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return U}e.toStoreData=Q}),define(ve[86],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const k=this._idPool++;return this._data.set(k,C),this.logDebugInfo(),k}get(C,k){return this._data.has(C)?this._data.get(C)[k]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(ve[51],we([0,1,2,3,4]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class k{constructor(){this._onDidChangeTabs=new L.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(S=>({name:S.name,group:S.group,resource:g.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=k}),define(ve[63],we([0,1,10,4]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,y){y===null?this._providerInfo.delete(T):this._providerInfo.set(T,y)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,L.createDecorator)("IExtHostFileSystemInfo")}),define(ve[27],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(ve[199],we([0,1,17]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(T,y,S){this._deferredPromises=new Map,this._id=T,this._shared=y,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of A.values())i.complete()}catch(i){for(const I of A.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,y){let S=this._value[T];return typeof S=="undefined"&&(S=y),S}update(T,y){this._value[T]=y;let S=this._deferredPromises.get(T);if(S!==void 0)return S.p;const A=new g.DeferredPromise;return this._deferredPromises.set(T,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class C extends L{constructor(T,y){super(T.identifier.value,!0,y);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=C}),define(ve[200],we([0,1,3,2,12]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let k=class{constructor(y,S){this._logService=y,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(y,S,A){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(y)).acceptModelChanged(S,A)}$acceptDirtyStateChanged(y,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(y)).acceptDirty(S)}$acceptModelSaved(y){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(y));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(y,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",y.path,S);const A=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(y));A.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};k=We([xe(0,C.ILogService)],k),e.ExtHostNotebookDocuments=k}),define(ve[13],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[201],we([0,1,26,3]),function(J,e,g,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class k{constructor(y,S){C.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(y.identifier),nt(this,C,S,"f"),$e(this,C,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(y){return $e(this,C,"f").get(this._id,y)}store(y,S){return $e(this,C,"f").store(this._id,y,S)}delete(y){return $e(this,C,"f").delete(this._id,y)}}e.ExtensionSecrets=k,C=new WeakMap}),define(ve[121],we([0,1,4,3]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(ve[87],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(P){P[P.Upsert=0]="Upsert",P[P.RemoveChild=1]="RemoveChild",P[P.Invalidated=2]="Invalidated",P[P.SetProp=3]="SetProp",P[P.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,C=(P,l)=>{const f={controllerId:l};return L.set(P,f),f};e.createPrivateApiFor=C;const k=P=>L.get(P);e.getPrivateApiFor=k;const T=(P,l,f,p)=>{let t=f;return{enumerable:!0,configurable:!1,get(){return t},set(s){p(t,s)||(t=s,P.listener?.({op:3,key:l,value:s}))}}},y=(P,l)=>P===l,S={range:(P,l)=>P===l?!0:!P||!l?!1:P.isEqual(l),label:y,description:y,busy:y,error:y,canResolveChildren:y,tags:(P,l)=>!(P.length!==l.length||P.some(f=>!l.find(p=>f.id===p.id)))},A=Object.keys(S),i=(P,l)=>({range:T(P,"range",void 0,S.range),label:T(P,"label",l,S.label),description:T(P,"description",void 0,S.description),canResolveChildren:T(P,"canResolveChildren",!1,S.canResolveChildren),busy:T(P,"busy",!1,S.busy),error:T(P,"error",void 0,S.error),tags:T(P,"tags",[],S.tags)}),I=(P,l)=>{const f=new Map;for(const p of A)S[p](P[p],l[p])||f.set(p,l[p]);return f};e.diffTestItems=I;class u extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=u;class m extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class c extends Error{constructor(l,f,p){super(`TestItem with ID "${l}" is from controller "${f}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=c;const v=P=>{const l=(0,e.getPrivateApiFor)(P);let f=new Map;return{get size(){return f.size},forEach(p,t){for(const s of f.values())p.call(t,s,this)},replace(p){const t=new Map,s=new Set(f.keys()),o={op:4,ops:[]};for(const n of p){if(!(n instanceof _))throw new m(n.id);const a=(0,e.getPrivateApiFor)(n).controllerId;if(a!==l.controllerId)throw new c(n.id,a,l.controllerId);if(t.has(n.id))throw new u(n.id);t.set(n.id,n),s.delete(n.id),o.ops.push({op:0,item:n})}for(const n of s.keys())o.ops.push({op:1,id:n});l.listener?.(o),f=t},add(p){if(!(p instanceof _))throw new m(p.id);f.set(p.id,p),l.listener?.({op:0,item:p})},delete(p){f.delete(p)&&l.listener?.({op:1,id:p})},get(p){return f.get(p)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class _{constructor(l,f,p,t){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const s=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof b?void 0:s.parent}},children:{value:v(this),enumerable:!0,writable:!1},...i(s,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class b extends _{constructor(l,f){super(l,l,f,void 0)}}e.TestItemRootImpl=b}),define(ve[52],we([0,1,4,3,13]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(y){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}y.fromApiTunnel=S;function A(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}y.fromServiceTunnel=A})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let T=class{constructor(S){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,A){return{dispose:()=>{}}}async $providePortAttributes(S,A,i,I,u){return[]}async $forwardPort(S,A){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=We([xe(0,C.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[7],we([0,1,20,16,98,22,101,14,2,32,42,120]),function(J,e,g,L,C,k,T,y,S,A,i,I){"use strict";var u,m,c,v,_,b,P,l,f,p,t,s,o,n,a,h,d,w,E,r;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function D(z){function $(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf($,z),Object.setPrototypeOf($.prototype,z.prototype),$}let R=_=class{constructor($){u.set(this,void 0),nt(this,u,$,"f")}static from(...$){let oe=$;return new _(function(){if(oe){for(const De of oe)De&&typeof De.dispose=="function"&&De.dispose();oe=void 0}})}dispose(){typeof $e(this,u,"f")=="function"&&($e(this,u,"f").call(this),nt(this,u,void 0,"f"))}};u=new WeakMap,R=_=We([D],R),e.Disposable=R;let x=b=class{constructor($,oe){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=oe}static Min(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let De=1;De<$.length;De++){const Ke=$[De];Ke.isBefore(oe)&&(oe=Ke)}return oe}static Max(...$){if($.length===0)throw new TypeError;let oe=$[0];for(let De=1;De<$.length;De++){const Ke=$[De];Ke.isAfter(oe)&&(oe=Ke)}return oe}static isPosition($){if(!$)return!1;if($ instanceof b)return!0;let{line:oe,character:De}=$;return typeof oe=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,oe=0){if($===null||oe===null)throw(0,L.illegalArgument)();let De;return typeof $=="undefined"?De=0:typeof $=="number"?De=$:(De=typeof $.lineDelta=="number"?$.lineDelta:0,oe=typeof $.characterDelta=="number"?$.characterDelta:0),De===0&&oe===0?this:new b(this.line+De,this.character+oe)}with($,oe=this.character){if($===null||oe===null)throw(0,L.illegalArgument)();let De;return typeof $=="undefined"?De=this.line:typeof $=="number"?De=$:(De=typeof $.line=="number"?$.line:this.line,oe=typeof $.character=="number"?$.character:this.character),De===this.line&&oe===this.character?this:new b(De,oe)}toJSON(){return{line:this.line,character:this.character}}};x=b=We([D],x),e.Position=x;let j=P=class{constructor($,oe,De,Ke){let tt,rt;if(typeof $=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ke=="number"?(tt=new x($,oe),rt=new x(De,Ke)):$ instanceof x&&oe instanceof x&&(tt=$,rt=oe),!tt||!rt)throw new Error("Invalid arguments");tt.isBefore(rt)?(this._start=tt,this._end=rt):(this._start=rt,this._end=tt)}static isRange($){return $ instanceof P?!0:$?x.isPosition($.start)&&x.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof P?this.contains($._start)&&this.contains($._end):$ instanceof x?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const oe=x.Max($.start,this._start),De=x.Min($.end,this._end);if(!oe.isAfter(De))return new P(oe,De)}union($){if(this.contains($))return this;if($.contains(this))return $;const oe=x.Min($.start,this._start),De=x.Max($.end,this.end);return new P(oe,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,oe=this.end){if($===null||oe===null)throw(0,L.illegalArgument)();let De;return $?x.isPosition($)?De=$:(De=$.start||this.start,oe=$.end||this.end):De=this.start,De.isEqual(this._start)&&oe.isEqual(this.end)?this:new P(De,oe)}toJSON(){return[this.start,this.end]}};j=P=We([D],j),e.Range=j;let te=l=class extends j{constructor($,oe,De,Ke){let tt,rt;if(typeof $=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ke=="number"?(tt=new x($,oe),rt=new x(De,Ke)):$ instanceof x&&oe instanceof x&&(tt=$,rt=oe),!tt||!rt)throw new Error("Invalid arguments");super(tt,rt);this._anchor=tt,this._active=rt}static isSelection($){return $ instanceof l?!0:$?j.isRange($)&&x.isPosition($.anchor)&&x.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};te=l=We([D],te),e.Selection=te;class Q{constructor($,oe,De){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(oe),this.connectionToken=De}}e.ResolvedAuthority=Q;class N extends Error{constructor($,oe=I.RemoteAuthorityResolverErrorCode.Unknown,De){super($);this._message=$,this._code=oe,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable($,oe){return new N($,I.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable($){return new N($,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var U;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(U=e.EndOfLine||(e.EndOfLine={}));var F;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(F=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=f=class{constructor($,oe){this._range=$,this._newText=oe}static isTextEdit($){return $ instanceof f?!0:$?j.isRange($)&&typeof $.newText=="string":!1}static replace($,oe){return new f($,oe)}static insert($,oe){return f.replace(new j($,$),oe)}static delete($){return f.replace($,"")}static setEndOfLine($){const oe=new f(new j(new x(0,0),new x(0,0)),"");return oe.newEol=$,oe}get range(){return this._range}set range($){if($&&!j.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=f=We([D],V),e.TextEdit=V;var M;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace"})(M=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,oe,De,Ke){this._edits.push({_type:1,from:$,to:oe,options:De,metadata:Ke})}createFile($,oe,De){this._edits.push({_type:1,from:void 0,to:$,options:oe,metadata:De})}deleteFile($,oe,De){this._edits.push({_type:1,from:$,to:void 0,options:oe,metadata:De})}replaceNotebookMetadata($,oe,De){this._edits.push({_type:3,metadata:De,uri:$,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells($,oe,De,Ke,tt){let rt,lt,yt=[],At;if(Bt.isNotebookRange(oe)&&Lt.isNotebookCellDataArray(De)&&!Lt.isNotebookCellDataArray(Ke)?(rt=oe.start,lt=oe.end,yt=De,At=Ke):typeof oe=="number"&&typeof De=="number"&&Lt.isNotebookCellDataArray(Ke)&&(rt=oe,lt=De,yt=Ke,At=tt),rt===void 0||lt===void 0)throw new Error("Invalid arguments");(rt!==lt||yt.length>0)&&this._edits.push({_type:5,uri:$,index:rt,count:lt-rt,cells:yt,metadata:At})}replaceNotebookCellMetadata($,oe,De,Ke){this._edits.push({_type:3,metadata:Ke,uri:$,edit:{editType:8,index:oe,metadata:De}})}replace($,oe,De,Ke){this._edits.push({_type:2,uri:$,edit:new V(oe,De),metadata:Ke})}insert($,oe,De,Ke){this.replace($,new j(oe,oe),De,Ke)}delete($,oe,De){this.replace($,oe,"",De)}has($){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===$.toString())}set($,oe){if(oe)for(const De of oe)De&&this._edits.push({_type:2,uri:$,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ke=this._edits[De];Ke._type===2&&Ke.uri.toString()===$.toString()&&(this._edits[De]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get($){const oe=[];for(let De of this._edits)De._type===2&&De.uri.toString()===$.toString()&&oe.push(De.edit);return oe}entries(){const $=new k.ResourceMap;for(let oe of this._edits)if(oe._type===2){let De=$.get(oe.uri);De||(De=[oe.uri,[]],$.set(oe.uri,De)),De[1].push(oe.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=We([D],O),e.WorkspaceEdit=O;let q=p=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof p?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=p._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,oe=this._tabstop++){if(typeof $=="function"){const De=new p;De._tabstop=this._tabstop,$(De),this._tabstop=De._tabstop,$=De.value}else $=p._escape($);return this.value+="${",this.value+=oe,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,oe=this._tabstop++){const De=$.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable($,oe){if(typeof oe=="function"){const De=new p;De._tabstop=this._tabstop,oe(De),this._tabstop=De._tabstop,oe=De.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};q=p=We([D],q),e.SnippetString=q;var B;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(B=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ne=t=class{constructor($,oe){if(this.uri=$,oe)if(oe instanceof j)this.range=oe;else if(oe instanceof x)this.range=new j(oe,oe);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof t?!0:$?j.isRange($.range)&&S.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ne=t=We([D],ne),e.Location=ne;let me=class{constructor($,oe){this.location=$,this.message=oe}static is($){return $?typeof $.message=="string"&&$.location&&j.isRange($.location.range)&&S.URI.isUri($.location.uri):!1}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.location.range.isEqual(oe.location.range)&&$.location.uri.toString()===oe.location.uri.toString()}};me=We([D],me),e.DiagnosticRelatedInformation=me;let Se=class{constructor($,oe,De=K.Error){if(!j.isRange($))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=$,this.message=oe,this.severity=De}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,oe){return $===oe?!0:!$||!oe?!1:$.message===oe.message&&$.severity===oe.severity&&$.code===oe.code&&$.severity===oe.severity&&$.source===oe.source&&$.range.isEqual(oe.range)&&(0,g.equals)($.tags,oe.tags)&&(0,g.equals)($.relatedInformation,oe.relatedInformation,me.isEqual)}};Se=We([D],Se),e.Diagnostic=Se;let Ce=class{constructor($,oe){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=oe}};Ce=We([D],Ce),e.Hover=Ce;var Te;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(Te=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor($,oe=Te.Text){this.range=$,this.kind=oe}toJSON(){return{range:this.range,kind:Te[this.kind]}}};je=We([D],je),e.DocumentHighlight=je;var Be;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(Be=e.SymbolKind||(e.SymbolKind={}));var Ve;(function(z){z[z.Deprecated=1]="Deprecated"})(Ve=e.SymbolTag||(e.SymbolTag={}));let W=s=class{constructor($,oe,De,Ke,tt){this.name=$,this.kind=oe,this.containerName=tt,typeof De=="string"&&(this.containerName=De),Ke instanceof ne?this.location=Ke:De instanceof j&&(this.location=new ne(Ke,De)),s.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Be[this.kind],location:this.location,containerName:this.containerName}}};W=s=We([D],W),e.SymbolInformation=W;let Z=o=class{constructor($,oe,De,Ke,tt){this.name=$,this.detail=oe,this.kind=De,this.range=Ke,this.selectionRange=tt,this.children=[],o.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(o.validate)}};Z=o=We([D],Z),e.DocumentSymbol=Z;var ie;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ie=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor($,oe){this.title=$,this.kind=oe}};le=We([D],le),e.CodeAction=le;let Y=n=class{constructor($){this.value=$}append($){return new n(this.value?this.value+n.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+n.sep)}};Y.sep=".",Y=n=We([D],Y),e.CodeActionKind=Y,Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll");let ae=class{constructor($,oe){if(this.range=$,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=We([D],ae),e.SelectionRange=ae;class be{constructor($,oe,De,Ke,tt,rt){this.kind=$,this.name=oe,this.detail=De,this.uri=Ke,this.range=tt,this.selectionRange=rt}}e.CallHierarchyItem=be;class Fe{constructor($,oe){this.fromRanges=oe,this.from=$}}e.CallHierarchyIncomingCall=Fe;class He{constructor($,oe){this.fromRanges=oe,this.to=$}}e.CallHierarchyOutgoingCall=He;var Ee;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Ee=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor($,oe){this.range=$,this.command=oe}get isResolved(){return!!this.command}};Qe=We([D],Qe),e.CodeLens=Qe;let X=a=class{constructor($,oe=!1){m.set(this,void 0),nt(this,m,new C.MarkdownString($,{supportThemeIcons:oe}),"f")}static isMarkdownString($){return $ instanceof a?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return $e(this,m,"f").value}set value($){$e(this,m,"f").value=$}get isTrusted(){return $e(this,m,"f").isTrusted}set isTrusted($){$e(this,m,"f").isTrusted=$}get supportThemeIcons(){return $e(this,m,"f").supportThemeIcons}set supportThemeIcons($){$e(this,m,"f").supportThemeIcons=$}appendText($){return $e(this,m,"f").appendText($),this}appendMarkdown($){return $e(this,m,"f").appendMarkdown($),this}appendCodeblock($,oe){return $e(this,m,"f").appendCodeblock(oe??"",$),this}};m=new WeakMap,X=a=We([D],X),e.MarkdownString=X;let se=class{constructor($,oe){this.label=$,this.documentation=oe}};se=We([D],se),e.ParameterInformation=se;let pe=class{constructor($,oe){this.label=$,this.documentation=oe,this.parameters=[]}};pe=We([D],pe),e.SignatureInformation=pe;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=We([D],Ue),e.SignatureHelp=Ue;var Ne;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Je;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Je=e.InlayHintKind||(e.InlayHintKind={}));let ke=class{constructor($,oe,De){this.text=$,this.position=oe,this.kind=De}};ke=We([D],ke),e.InlayHint=ke;var ye;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ie;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ie=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(z){z[z.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let de=class{constructor($,oe){this.label=$,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Ie[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};de=We([D],de),e.CompletionItem=de;let H=class{constructor($=[],oe=!1){this.items=$,this.isIncomplete=oe}};H=We([D],H),e.CompletionList=H;let ee=class{constructor($,oe,De){this.text=$,this.range=oe,this.command=De}};ee=We([D],ee),e.InlineSuggestion=ee;let ue=class{constructor($){this.items=$}};ue=We([D],ue),e.InlineSuggestions=ue;var Le;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Le=e.ViewColumn||(e.ViewColumn={}));var Re;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ze;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(et=e.TextEditorRevealType||(e.TextEditorRevealType={}));var it;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(it=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ye;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Ye=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Xe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Xe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function $(oe){switch(oe){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=$}(it=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let mt=class{constructor($,oe){if(oe&&!S.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!j.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=oe}};mt=We([D],mt),e.DocumentLink=mt;let vt=class{constructor($,oe,De,Ke){this.red=$,this.green=oe,this.blue=De,this.alpha=Ke}};vt=We([D],vt),e.Color=vt;let Et=class{constructor($,oe){if(oe&&!(oe instanceof vt))throw(0,L.illegalArgument)("color");if(!j.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=oe}};Et=We([D],Et),e.ColorInformation=Et;let ot=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};ot=We([D],ot),e.ColorPresentation=ot;var at;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(at=e.ColorFormat||(e.ColorFormat={}));var Dt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Dt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class _e{constructor($,oe,De){if(this.startIndex=$,this.length=oe,this.tooltip=De,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=_e;class ge{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=ge;var he;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var G;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(G=e.TaskPanelKind||(e.TaskPanelKind={}));let Pe=h=class{constructor($,oe){if(typeof $!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};Pe.Clean=new h("clean","Clean"),Pe.Build=new h("build","Build"),Pe.Rebuild=new h("rebuild","Rebuild"),Pe.Test=new h("test","Test"),Pe=h=We([D],Pe),e.TaskGroup=Pe;function Oe(z){let $="";for(let oe=0;oe<z.length;oe++)$+=z[oe].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,oe,De){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=De):this._options=oe)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)$.push(oe);return Oe($)}};Ze=We([D],Ze),e.ProcessExecution=Ze;let qe=class{constructor($,oe,De){if(this._args=[],Array.isArray(oe)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=oe,this._options=De}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=oe}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)$.push(typeof oe=="string"?oe:oe.value);return Oe($)}};qe=We([D],qe),e.ShellExecution=qe;var ft;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(ft=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class kt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=kt;let dt=d=class{constructor($,oe,De,Ke,tt,rt){this.__deprecated=!1,this._definition=this.definition=$;let lt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=De,this.execution=Ke,lt=tt,this.__deprecated=!0):oe===bt.Global||oe===bt.Workspace?(this.target=oe,this._name=this.name=De,this._source=this.source=Ke,this.execution=tt,lt=rt):(this.target=oe,this._name=this.name=De,this._source=this.source=Ke,this.execution=tt,lt=rt),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:d.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:d.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:d.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:d.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const oe=this._definition.type;(d.EmptyType===oe||d.ProcessType===oe||d.ShellType===oe||d.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=d=We([D],dt),e.Task=dt;var ct;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let ht=class{constructor($,oe=_t.None){this.collapsibleState=oe,S.URI.isUri($)?this.resourceUri=$:this.label=$}};ht=We([D],ht),e.TreeItem=ht;var _t;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Tt=class{constructor($,oe){this.id=$,this.color=oe}};Tt=We([D],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let It=class{constructor($){this.id=$}};It=We([D],It),e.ThemeColor=It;var En;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(En=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor($,oe){if(typeof $!="string"&&(!$||!S.URI.isUri($)&&!S.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=S.URI.file($),this.base=$):S.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=oe}};Vt=We([D],Vt),e.RelativePattern=Vt;let St=class{constructor($,oe,De,Ke){this.enabled=typeof $=="boolean"?$:!0,typeof oe=="string"&&(this.condition=oe),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};St=We([D],St),e.Breakpoint=St;let Xt=class extends St{constructor($,oe,De,Ke,tt){super(oe,De,Ke,tt);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};Xt=We([D],Xt),e.SourceBreakpoint=Xt;let Yt=class extends St{constructor($,oe,De,Ke,tt){super(oe,De,Ke,tt);this.functionName=$}};Yt=We([D],Yt),e.FunctionBreakpoint=Yt;let gt=class extends St{constructor($,oe,De,Ke,tt,rt,lt){super(Ke,tt,rt,lt);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=oe,this.canPersist=De}};gt=We([D],gt),e.DataBreakpoint=gt;let jt=class{constructor($,oe,De){this.command=$,this.args=oe||[],this.options=De}};jt=We([D],jt),e.DebugAdapterExecutable=jt;let Wt=class{constructor($,oe){this.port=$,this.host=oe}};Wt=We([D],Wt),e.DebugAdapterServer=Wt;let Jt=class{constructor($){this.path=$}};Jt=We([D],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor($){this.implementation=$}};Zt=We([D],Zt),e.DebugAdapterInlineImplementation=Zt;let Pt=class{constructor($,oe){this.range=$,this.expression=oe}};Pt=We([D],Pt),e.EvaluatableExpression=Pt;var hn;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor($,oe){this.range=$,this.text=oe}};en=We([D],en),e.InlineValueText=en;let xt=class{constructor($,oe,De=!0){this.range=$,this.variableName=oe,this.caseSensitiveLookup=De}};xt=We([D],xt),e.InlineValueVariableLookup=xt;let ut=class{constructor($,oe){this.range=$,this.expression=oe}};ut=We([D],ut),e.InlineValueEvaluatableExpression=ut;let tn=class{constructor($,oe){this.frameId=$,this.stoppedLocation=oe}};tn=We([D],tn),e.InlineValueContext=tn;var Mt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Ot=w=class extends Error{constructor($,oe=i.FileSystemProviderErrorCode.Unknown,De){super(S.URI.isUri($)?$.toString(!0):$);this.code=De?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists($){return new w($,i.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound($){return new w($,i.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory($){return new w($,i.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory($){return new w($,i.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions($){return new w($,i.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable($){return new w($,i.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Ot=w=We([D],Ot),e.FileSystemError=Ot;let qt=class{constructor($,oe,De){this.start=$,this.end=oe,this.kind=De}};qt=We([D],qt),e.FoldingRange=qt;var _n;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(_n=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Sn;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Sn=e.CommentMode||(e.CommentMode={}));class mn{constructor($,oe=[]){this.tokenTypes=$,this.tokenModifiers=oe}}e.SemanticTokensLegend=mn;function nn(z){return typeof z=="undefined"||(0,y.isStringArray)(z)}class rn{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let oe=0,De=$.tokenTypes.length;oe<De;oe++)this._tokenTypeStrToInt.set($.tokenTypes[oe],oe);for(let oe=0,De=$.tokenModifiers.length;oe<De;oe++)this._tokenModifierStrToInt.set($.tokenModifiers[oe],oe)}}push($,oe,De,Ke,tt){if(typeof $=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded($,oe,De,Ke,tt);if(j.isRange($)&&typeof oe=="string"&&nn(De))return this._push($,oe,De);throw(0,L.illegalArgument)()}_push($,oe,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ke=$.start.line,tt=$.start.character,rt=$.end.character-$.start.character,lt=this._tokenTypeStrToInt.get(oe);let yt=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);yt|=1<<Rt>>>0}this._pushEncoded(Ke,tt,rt,lt,yt)}_pushEncoded($,oe,De,Ke,tt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Rt=0;for(let Ft=0;Ft<yt;Ft++){let Nt=this._data[5*Ft],un=this._data[5*Ft+1];Nt===0?(Nt=At,un+=Rt):Nt+=At,this._data[5*Ft]=Nt,this._data[5*Ft+1]=un,At=Nt,Rt=un}}let rt=$,lt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(rt-=this._prevLine,rt===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=rt,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=tt,this._prevLine=$,this._prevChar=oe}static _sortAndDeltaEncode($){let oe=[];const De=$.length/5|0;for(let lt=0;lt<De;lt++)oe[lt]=lt;oe.sort((lt,yt)=>{const At=$[5*lt],Rt=$[5*yt];if(At===Rt){const Ft=$[5*lt+1],Nt=$[5*yt+1];return Ft-Nt}return At-Rt});const Ke=new Uint32Array($.length);let tt=0,rt=0;for(let lt=0;lt<De;lt++){const yt=5*oe[lt],At=$[yt+0],Rt=$[yt+1],Ft=$[yt+2],Nt=$[yt+3],un=$[yt+4],Un=At-tt,qn=Un===0?Rt-rt:Rt,dn=5*lt;Ke[dn+0]=Un,Ke[dn+1]=qn,Ke[dn+2]=Ft,Ke[dn+3]=Nt,Ke[dn+4]=un,tt=At,rt=Rt}return Ke}build($){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),$):new Ht(rn._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=rn;class Ht{constructor($,oe){this.resultId=oe,this.data=$}}e.SemanticTokens=Ht;class sn{constructor($,oe,De){this.start=$,this.deleteCount=oe,this.data=De}}e.SemanticTokensEdit=sn;class yn{constructor($,oe){this.resultId=oe,this.edits=$}}e.SemanticTokensEdits=yn;var Dn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var zt;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(zt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Tt("arrow-left")},Gt=We([D],Gt),e.QuickInputButtons=Gt;var Cn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Cn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor($,oe,De){this.badge=$,this.tooltip=oe,this.color=De}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=kn;let on=class{constructor($){this.kind=$}};on=We([D],on),e.ColorTheme=on;var an;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor($,oe){if($<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");$<=oe?(this._start=$,this._end=oe):(this._start=oe,this._end=$)}static isNotebookRange($){return $ instanceof Bt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let oe=this._start,De=this._end;return $.start!==void 0&&(oe=$.start),$.end!==void 0&&(De=$.end),oe===this._start&&De===this._end?this:new Bt(oe,De)}}e.NotebookRange=Bt;class Lt{constructor($,oe,De,Ke,tt,rt,lt){this.kind=$,this.value=oe,this.languageId=De,this.mime=Ke,this.outputs=tt??[],this.metadata=rt,this.executionSummary=lt,Lt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(oe=>Lt.isNotebookCellData(oe))}static isNotebookCellData($){return!0}}e.NotebookCellData=Lt;class Kt{constructor($){this.cells=$}}e.NotebookData=Kt;class Me{constructor($,oe){this.data=$,this.mime=oe;const De=(0,T.normalizeMimeType)(oe,!0);if(!De)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem($){return $ instanceof Me?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const oe={name:$.name,message:$.message,stack:$.stack};return Me.json(oe,"application/vnd.code.notebook.error")}static stdout($){return Me.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Me.text($,"application/vnd.code.notebook.stderr")}static bytes($,oe="application/octet-stream"){return new Me($,oe)}static text($,oe=T.Mimes.text){const De=$e(Me,c,"f",v).encode(String($));return new Me(De,oe)}static json($,oe="application/json"){const De=JSON.stringify($,void 0,"	");return Me.text(De,oe)}}e.NotebookCellOutputItem=Me,c=Me,v={value:new TextEncoder};class $t{constructor($,oe,De){this.items=$t.ensureUniqueMimeTypes($,!0),typeof oe=="string"?(this.id=oe,this.metadata=De):(this.id=(0,A.generateUuid)(),this.metadata=oe??De)}static isNotebookCellOutput($){return $ instanceof $t?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,y.isArray)($.items)}static ensureUniqueMimeTypes($,oe=!1){const De=new Set,Ke=new Set;for(let tt=0;tt<$.length;tt++){const rt=$[tt],lt=(0,T.normalizeMimeType)(rt.mime);if(!De.has(lt)){De.add(lt);continue}Ke.add(tt),oe&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Ke.size===0?$:$.filter((tt,rt)=>!Ke.has(rt))}}e.NotebookCellOutput=$t;var gn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(gn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor($,oe){this.text=$,this.alignment=oe}}e.NotebookCellStatusBarItem=pn;var vn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(vn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor($,oe=[]){this.uri=$,this.provides=(0,g.asArray)(oe)}}e.NotebookRendererScript=An;let ln=class{constructor($,oe){this.label=$,this.timestamp=oe}};ln=We([D],ln),e.TimelineItem=ln;var Tn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var wn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(wn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor($,oe){this.ranges=$,this.wordPattern=oe}}e.LinkedEditingRanges=Ln;class Fn{constructor($,oe){this._port=$,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let cn=class{constructor($,oe,De){this.include=$,this.exclude=oe,this.profile=De}};cn=We([D],cn),e.TestRunRequest=cn;let re=E=class{constructor($){this.message=$}static diff($,oe,De){const Ke=new E($);return Ke.expectedOutput=oe,Ke.actualOutput=De,Ke}};re=E=We([D],re),e.TestMessage=re;let fe=class{constructor($,oe){this.id=$,this.label=oe}};fe=We([D],fe),e.TestTag=fe;let Ae=class{constructor($,oe){this.covered=$,this.total=oe}};Ae=We([D],Ae),e.CoveredCount=Ae;let st=r=class{constructor($,oe,De,Ke){this.uri=$,this.statementCoverage=oe,this.branchCoverage=De,this.functionCoverage=Ke}static fromDetails($,oe){const De=new Ae(0,0),Ke=new Ae(0,0),tt=new Ae(0,0);for(const lt of oe)if("branches"in lt){De.total+=1,De.covered+=lt.executionCount>0?1:0;for(const yt of lt.branches)Ke.total+=1,Ke.covered+=yt.executionCount>0?1:0}else tt.total+=1,tt.covered+=lt.executionCount>0?1:0;const rt=new r($,De,Ke.total>0?Ke:void 0,tt.total>0?tt:void 0);return rt.detailedCoverage=oe,rt}};st=r=We([D],st),e.FileCoverage=st;let wt=class{constructor($,oe,De=[]){this.executionCount=$,this.location=oe,this.branches=De}};wt=We([D],wt),e.StatementCoverage=wt;let Ct=class{constructor($,oe){this.executionCount=$,this.location=oe}};Ct=We([D],Ct),e.BranchCoverage=Ct;let Nn=class{constructor($,oe){this.executionCount=$,this.location=oe}};Nn=We([D],Nn),e.FunctionCoverage=Nn;var Hn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(zn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class jn{constructor($,oe,De,Ke,tt,rt){this.kind=$,this.name=oe,this.detail=De,this.uri=Ke,this.range=tt,this.selectionRange=rt}}e.TypeHierarchyItem=jn}),define(ve[122],we([0,1,54,10,9,149,109,7,20]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function i(c,v){v?A.set(c,v):A.delete(c)}e.setWordDefinitionFor=i;function I(c){return A.get(c)}e.getWordDefinitionFor=I;class u extends k.MirrorTextModel{constructor(v,_,b,P,l,f,p,t){super(_,b,P,l);this._proxy=v,this._languageId=f,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,S.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===L.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(_){return _?v._getTextInRange(_):v.getText()},get eol(){return v._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(_){return v._lineAt(_)},offsetAt(_){return v._offsetAt(_)},positionAt(_){return v._positionAt(_)},validateRange(_){return v._validateRange(_)},validatePosition(_){return v._validatePosition(_)},getWordRangeAtPosition(_,b){return v._getWordRangeAtPosition(_,b)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,g.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,g.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const _=this._validateRange(v);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const b=this._eol,P=_.start.line,l=_.end.line,f=[];f.push(this._lines[P].substring(_.start.character));for(let p=P+1;p<l;p++)f.push(this._lines[p]);return f.push(this._lines[l].substring(0,_.end.character)),f.join(b)}_lineAt(v){let _;if(v instanceof y.Position?_=v.line:typeof v=="number"&&(_=v),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(v),b=this._lines[_.index].length;return new y.Position(_.index,Math.min(_.remainder,b))}_validateRange(v){if(!(v instanceof y.Range))throw new Error("Invalid argument");const _=this._validatePosition(v.start),b=this._validatePosition(v.end);return _===v.start&&b===v.end?v:new y.Range(_.line,_.character,b.line,b.character)}_validatePosition(v){if(!(v instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:_,character:b}=v,P=!1;if(_<0)_=0,b=0,P=!0;else if(_>=this._lines.length)_=this._lines.length-1,b=this._lines[_].length,P=!0;else{const l=this._lines[_].length;b<0?(b=0,P=!0):b>l&&(b=l,P=!0)}return P?new y.Position(_,b):v}_getWordRangeAtPosition(v,_){const b=this._validatePosition(v);if(!_)_=I(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const P=(0,T.getWordAtText)(b.character+1,(0,T.ensureValidWordDefinition)(_),this._lines[b.line],0);if(P)return new y.Range(b.line,P.startColumn-1,b.line,P.endColumn-1)}}e.ExtHostDocumentData=u;class m{constructor(v,_,b){this._line=v,this._text=_,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(ve[202],we([0,1,7,3,111,6,80,22,2,32]),function(J,e,g,L,C,k,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(u,m,c,v){this._notebook=c,this._selector=v,this._disposables=new k.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(b=>{const P=this._cellUris.get(b.document.uri);P!==void 0&&(this._cellLengths.changeValue(P,this._cells[P].document.getText().length+1),this._cellLines.changeValue(P,this._cells[P].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(b=>_(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const u=[],m=[];for(const c of this._notebook.getCells())c.kind===g.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),u.push(c.document.getText().length+1),m.push(c.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(u){if(!u){let P="";for(const l of this._cells)P+=l.document.getText()+`
`;return P=P.slice(0,-1),P}if(u.isEmpty)return"";const m=this.locationAt(u.start),c=this.locationAt(u.end),v=this._cellUris.get(m.uri),_=this._cellUris.get(c.uri);if(v===void 0||_===void 0)return"";if(v===_)return this._cells[v].document.getText(new g.Range(m.range.start,c.range.end));const b=[this._cells[v].document.getText(new g.Range(m.range.start,new g.Position(this._cells[v].document.lineCount,0)))];for(let P=v+1;P<_;P++)b.push(this._cells[P].document.getText());return b.push(this._cells[_].document.getText(new g.Range(new g.Position(0,0),c.range.end))),b.join(`
`)}offsetAt(u){const m=this._cellLines.getIndexOf(u.line),c=this._cellLengths.getPrefixSum(m.index-1),v=this._cells[m.index].document.offsetAt(u.with(m.remainder));return c+v}positionAt(u){if(typeof u=="number"){const c=this._cellLengths.getIndexOf(u),v=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(v)}const m=this._cellUris.get(u.uri);if(m!==void 0){const c=this._cellLines.getPrefixSum(m-1);return new g.Position(c+u.range.start.line,u.range.start.character)}return new g.Position(0,0)}locationAt(u){g.Range.isRange(u)||(u=new g.Range(u,u));const m=this._cellLines.getIndexOf(u.start.line);let c=m;u.isEmpty||(c=this._cellLines.getIndexOf(u.end.line));const v=new g.Position(m.remainder,u.start.character),_=new g.Position(c.remainder,u.end.character),b=new g.Range(v,_),P=this._cells[m.index];return new g.Location(P.document.uri,P.document.validateRange(b))}contains(u){return this._cellUris.has(u)}validateRange(u){const m=this.validatePosition(u.start),c=this.validatePosition(u.end);return u.with(m,c)}validatePosition(u){const m=this._cellLines.getIndexOf(u.line),c=new g.Position(m.remainder,u.character),v=this._cells[m.index].document.validatePosition(c),_=this._cellLines.getPrefixSum(m.index-1);return new g.Position(_+v.line,v.character)}}e.ExtHostNotebookConcatDocument=i}),define(ve[203],we([0,1,7,13,3]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let k=class{constructor(y){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let S=y==="light"?g.ColorThemeKind.Light:y==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};k=We([xe(0,L.IExtHostRpcService)],k),e.ExtHostTheming=k}),define(ve[64],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(k){k?(this.transformIncoming=k.transformIncoming.bind(k),this.transformOutgoing=k.transformOutgoing.bind(k),this.transformOutgoingURI=k.transformOutgoingURI.bind(k),this.transformOutgoingScheme=k.transformOutgoingScheme.bind(k)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=L}),define(ve[204],we([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let A=this.buffers.indexOf(S);return A<0&&(A=this.buffers.length,this.buffers.push(S)),A}}function C(y,S){if(S.serializeBuffersForPostMessage){const A=new L,i=(m,c)=>{if(c instanceof ArrayBuffer){const v=A.add(c);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(c)){const v=k(c);if(v){const _=A.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:v,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(y,i),u=A.buffers.map(m=>{const c=new Uint8Array(m);return g.VSBuffer.wrap(c)});return{message:I,buffers:u}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=C;function k(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(y,S){const A=S.map(u=>{const m=new ArrayBuffer(u.byteLength);return new Uint8Array(m).set(u.buffer),m}),i=S.length?(u,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const c=m,{index:v}=c,_=A[v];if(c.view)switch(c.view.type){case 1:return new Int8Array(_,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return m}:void 0;return{message:JSON.parse(y,i),arrayBuffers:A}}e.deserializeWebviewMessage=T}),define(ve[205],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function C(T){const y={items:new Map};return T.types.forEach((S,A)=>{y.items.set(S,{asString:async()=>T.items[A].asString})}),y}L.toITreeDataTransfer=C;async function k(T){const y={types:[],items:[]},S=Array.from(T.items.entries());for(const A of S)y.types.push(A[0]),y.items.push({asString:await A[1].asString()});return y}L.toTreeDataTransferDTO=k})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[88],we([0,1,10,2]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(y,S){return y.scheme===g.Schemas.http||y.scheme===g.Schemas.https?y:(S&&S.authority&&S.isRemote&&y.scheme===g.Schemas.file&&(y=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:S.authority,path:y.path})),L.URI.from({scheme:g.Schemas.https,authority:`${y.scheme}+${k(y.authority)}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=C;function k(y){return y.replace(/./g,S=>{const A=S.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?S:"-"+A.toString(16).padStart(4,"0")})}function T(y){return y.replace(/-([0-9a-f]{4})/g,(S,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=T}),define(ve[206],we([0,1,3,6,88]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class k{constructor(y,S,A){this._proxy=y,this._editors=S,this._initData=A,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const i=S.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,S,A,i,I){let u;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===y){u=l;break}if(!u)throw new Error("not a visible editor");const m=this,c=this._handlePool++,v=new g.Emitter,_=new g.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,C.asWebviewUri)(l,m._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(l){this._options=l,m._proxy.$setOptions(c,l)}get options(){return this._options}set html(l){this._html=l,m._proxy.$setHtml(c,l)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(l){return m._proxy.$postMessage(c,l)}},P=new class{constructor(){this.editor=y,this.line=S,this.height=A,this.webview=b,this.onDidDispose=_.event}dispose(){m._insets.has(c)&&(m._insets.delete(c),m._proxy.$disposeEditorInset(c),_.fire(),_.dispose(),v.dispose())}};return this._proxy.$createEditorInset(c,u.id,u.value.document.uri,S+1,A,i||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:y,inset:P,onDidReceiveMessage:v}),P}$onDidDispose(y){const S=this._insets.get(y);S&&S.inset.dispose()}$onDidReceiveMessage(y,S){const A=this._insets.get(y);A&&A.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=k}),define(ve[207],we([0,1,171,14,2,6,4,61,34,20,10]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new y.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new y.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new y.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new y.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new y.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new y.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new y.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new y.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new y.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new y.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new y.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new y.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new y.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new y.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new y.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new y.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new y.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new y.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new y.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function I(r){return typeof r?.getViewState=="function"}e.isTextEditorPane=I;function u(r){if(l(r))return!1;const D=r;return C.URI.isUri(D?.resource)}e.isResourceEditorInput=u;function m(r){if(l(r))return!1;const D=r;return D?.original!==void 0&&D.modified!==void 0}e.isResourceDiffEditorInput=m;function c(r){if(l(r))return!1;const D=r;return D?D.resource===void 0||D.resource.scheme===i.Schemas.untitled||D.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var v;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var _;(function(r){r[r.EXPLICIT=1]="EXPLICIT",r[r.AUTO=2]="AUTO",r[r.FOCUS_CHANGE=3]="FOCUS_CHANGE",r[r.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));var b;(function(r){r[r.None=0]="None",r[r.Readonly=2]="Readonly",r[r.Untitled=4]="Untitled",r[r.Singleton=8]="Singleton",r[r.RequiresTrust=16]="RequiresTrust"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class P extends k.Disposable{}e.AbstractEditorInput=P;function l(r){return r instanceof P}e.isEditorInput=l;function f(r){const D=r;return C.URI.isUri(D?.preferredResource)}function p(r){const D=r;return l(D?.primary)&&l(D?.secondary)}e.isSideBySideEditorInput=p;function t(r){return l(r?.editor)}e.isEditorInputWithOptions=t;function s(r){const D=r;return t(r)&&D?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function o(r){const D=r;return typeof D?.groupId=="number"&&l(D.editor)}e.isEditorIdentifier=o;var n;(function(r){r[r.PRIMARY=1]="PRIMARY",r[r.SECONDARY=2]="SECONDARY",r[r.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(D,R){if(!D)return;const x=p(D)?D.primary:m(D)?D.modified:void 0,j=p(D)?D.secondary:m(D)?D.original:void 0;if(R?.supportSideBySide&&x&&j){if(R?.supportSideBySide===n.BOTH)return{primary:this.getOriginalUri(x,{filterByScheme:R.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:R.filterByScheme})};D=R.supportSideBySide===n.PRIMARY?x:j}if(m(D))return;const te=f(D)?D.preferredResource:D.resource;return!te||!R||!R.filterByScheme?te:this.filterUri(te,R.filterByScheme)}getCanonicalUri(D,R){if(!D)return;const x=p(D)?D.primary:m(D)?D.modified:void 0,j=p(D)?D.secondary:m(D)?D.original:void 0;if(R?.supportSideBySide&&x&&j){if(R?.supportSideBySide===n.BOTH)return{primary:this.getCanonicalUri(x,{filterByScheme:R.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:R.filterByScheme})};D=R.supportSideBySide===n.PRIMARY?x:j}if(m(D))return;const te=D.resource;return!te||!R||!R.filterByScheme?te:this.filterUri(te,R.filterByScheme)}filterUri(D,R){if(Array.isArray(R)){if(R.some(x=>D.scheme===x))return D}else if(R===D.scheme)return D}}e.EditorResourceAccessor=new a;var h;(function(r){r[r.LEFT=0]="LEFT",r[r.RIGHT=1]="RIGHT"})(h=e.CloseDirection||(e.CloseDirection={}));class d{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(D){const R=this.instantiationService=D.get(T.IInstantiationService);for(const[x,j]of this.editorSerializerConstructors)this.createEditorSerializer(x,j,R);this.editorSerializerConstructors.clear()}createEditorSerializer(D,R,x){const j=x.createInstance(R);this.editorSerializerInstances.set(D,j)}registerFileEditorFactory(D){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=D}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(D,R){if(this.editorSerializerConstructors.has(D)||this.editorSerializerInstances.has(D))throw new Error(`A editor serializer with type ID '${D}' was already registered.`);return this.instantiationService?this.createEditorSerializer(D,R,this.instantiationService):this.editorSerializerConstructors.set(D,R),(0,k.toDisposable)(()=>{this.editorSerializerConstructors.delete(D),this.editorSerializerInstances.delete(D)})}getEditorSerializer(D){return this.editorSerializerInstances.get(typeof D=="string"?D:D.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new d);async function w(r,D){if(!r||!r.length)return[];const R=await Promise.all(r.map(async x=>{const j=C.URI.revive(x.fileUri);if(!j||(await D.activateProvider(j.scheme),!D.canHandleResource(j)))return;const te=typeof x.exists=="boolean"?x.exists:await D.exists(j);if(!te&&x.openOnlyIfExists)return;const Q=te&&!(0,L.isUndefined)(x.selection)?{selection:x.selection,pinned:!0,override:x.editorOverrideId}:{pinned:!0,override:x.editorOverrideId};let N;return te?N={resource:j,options:Q,forceFile:!0}:N={resource:j,options:Q,forceUntitled:!0},N}));return(0,A.coalesce)(R)}e.pathsToEditors=w;var E;(function(r){r[r.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",r[r.SEQUENTIAL=1]="SEQUENTIAL"})(E=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[208],we([0,1,3,61,172,4,6,22,34,20,55,25,47,197]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",u.Codicon.window,(0,C.localize)(0,null));var c;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(c=e.Extensions||(e.Extensions={}));var v;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function b(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=b;class P extends T.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,A.flatten)([...this.viewContainers.values()])}registerViewContainer(h,d,w){const E=this.get(h.id);if(E)return E;const r=h;return r.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:r.openCommandActionDescriptor??{id:r.id},(0,y.getOrSet)(this.viewContainers,d,[]).push(r),w?.isDefault&&this.defaultViewContainers.push(r),this._onDidRegister.fire({viewContainer:r,viewContainerLocation:d}),r}deregisterViewContainer(h){for(const d of this.viewContainers.keys()){const w=this.viewContainers.get(d),E=w?.indexOf(h);if(E!==-1){w?.splice(E,1),w.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:d});return}}}get(h){return this.all.filter(d=>d.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(w=>w?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===h)}}S.Registry.add(c.ViewContainersRegistry,new P);var l;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function f(a,h){const d=a.group??l.More,w=h.group??l.More;return d!==w?d.localeCompare(w):(a.order??5)-(h.order??5)}class p extends T.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(h,d){this.registerViews2([{views:h,viewContainer:d}])}registerViews2(h){h.forEach(({views:d,viewContainer:w})=>this.addViews(d,w)),this._onViewsRegistered.fire(h)}deregisterViews(h,d){const w=this.removeViews(h,d);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:d})}moveViews(h,d){for(const w of this._views.keys())if(w!==d){const E=this.removeViews(h,w);E.length&&(this.addViews(E,d),this._onDidChangeContainer.fire({views:E,from:w,to:d}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const d of this._viewContainers){const w=(this._views.get(d)||[]).filter(E=>E.id===h)[0];if(w)return w}return null}getViewContainer(h){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(E=>E.id===h)[0])return d;return null}registerViewWelcomeContent(h,d){return this._viewWelcomeContents.add(h,d),this._onDidChangeViewWelcomeContent.fire(h),(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,d),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,d){const w=new Map;for(const[E,r]of d)this._viewWelcomeContents.add(h,r),w.set(E,(0,T.toDisposable)(()=>{this._viewWelcomeContents.delete(h,r),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),w}getViewWelcomeContent(h){const d=[];return this._viewWelcomeContents.forEach(h,w=>d.push(w)),d.sort(f)}addViews(h,d){let w=this._views.get(d);w||(w=[],this._views.set(d,w),this._viewContainers.push(d));for(const E of h){if(this.getView(E.id)!==null)throw new Error((0,C.localize)(1,null,E.id));w.push(E)}}removeViews(h,d){const w=this._views.get(d);if(!w)return[];const E=[],r=[];for(const D of w)h.includes(D)?E.push(D):r.push(D);return E.length&&(r.length?this._views.set(d,r):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),E}}S.Registry.add(c.ViewsRegistry,new p),e.IViewsService=(0,k.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,k.createDecorator)("viewDescriptorService");var s;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(s=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(h,d){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,h),this._hasResolve=!!d,this.resolve=async w=>{if(d&&!this.resolved){const E=await d(w);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(ve[123],we([0,1,3,17,173]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class k{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,S,A,i){const I={command:y};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof i=="number"){const u=setTimeout(()=>{clearTimeout(u);const m=this.pendingRequests.get(I.seq);if(m){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:y,message:(0,C.localize)(0,null,i,y)};m(c)}},i)}return A&&this.pendingRequests.set(I.seq,A),I.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,S){return y.type!=="event"||S.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await(0,L.timeout)(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const S=y,A=this.pendingRequests.get(S.request_seq);A&&(this.pendingRequests.delete(S.request_seq),A(S));break}}}internalSend(y,S){S.type=y,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((S,A)=>y.set(A,S)),await(0,L.timeout)(500),y.forEach((S,A)=>{S({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=k}),define(ve[209],we([0,1,9,2,8,25,10]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function S(o,n,a){return o.replace(y,function(h,d){return n&&d.length>0&&d[0]!=="_"?h:a&&a.hasOwnProperty(d)?a[d]:h})}e.formatPII=S;function A(o){const n={};for(const a of Object.keys(o))a.startsWith("!")||(n[a]=o[a]);return n}e.filterExceptionsFromTelemetry=A;function i(o){return o.configuration.request==="attach"&&!I(o)&&(!o.parentSession||i(o.parentSession))}e.isSessionAttach=i;function I(o){let n=o.configuration.type;if(!!n)return n==="vslsShare"&&(n=o.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(n,"extensionhost")||(0,g.equalsIgnoreCase)(n,"pwa-extensionhost")?o:o.parentSession?I(o.parentSession):void 0}e.getExtensionHostDebugSession=I;function u(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=u;function m(o,n,a){let h,d=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=w.exec(o);){let r=E.index+1,D=r+E[0].length;if(r<=n&&D>=a){h=E[0],d=r;break}}if(h){let r=/\w+/g,D=null;for(;(D=r.exec(h))&&!(D.index+1+d+D[0].length>=a););D&&(h=h.substring(0,r.lastIndex))}return h?{start:d,end:d+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(o){return!!(o&&o.match(c))}e.isUri=v;function _(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(v(o.path))return L.URI.parse(o.path);if((0,C.isAbsolute)(o.path))return L.URI.file(o.path)}return o.path}function b(o){if(typeof o.path=="object"){const n=L.URI.revive(o.path);if(n)return n.scheme===T.Schemas.file?n.fsPath:n.toString()}return o.path}function P(o,n){const a=n?_:b,h=(0,k.deepClone)(o);return f(h,(d,w)=>{d&&w&&(w.path=a(w))}),h}e.convertToDAPaths=P;function l(o,n){const a=n?_:b,h=(0,k.deepClone)(o);return f(h,(d,w)=>{!d&&w&&(w.path=a(w))}),h}e.convertToVSCPaths=l;function f(o,n){switch(o.type){case"event":const a=o;switch(a.event){case"output":n(!1,a.body.source);break;case"loadedSource":n(!1,a.body.source);break;case"breakpoint":n(!1,a.body.breakpoint.source);break;default:break}break;case"request":const h=o;switch(h.command){case"setBreakpoints":n(!0,h.arguments.source);break;case"breakpointLocations":n(!0,h.arguments.source);break;case"source":n(!0,h.arguments.source);break;case"gotoTargets":n(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(w=>n(!1,w));break;default:break}break;case"response":const d=o;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(w=>n(!1,w.source));break;case"loadedSources":d.body.sources.forEach(w=>n(!1,w));break;case"scopes":d.body.scopes.forEach(w=>n(!1,w.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(w=>n(!1,w.source));break;case"setBreakpoints":d.body.breakpoints.forEach(w=>n(!1,w.source));break;default:break}break}}function p(o){return o.filter(n=>!n.presentation?.hidden).sort((n,a)=>n.presentation?a.presentation?n.presentation.group?a.presentation.group?n.presentation.group!==a.presentation.group?n.presentation.group.localeCompare(a.presentation.group):t(n.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(n.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=p;function t(o,n){return typeof o!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:o-n}async function s(o,n){const a=o.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorMode});if(a!=="none"&&(await n.saveAll(),a==="allEditorsInActiveGroup")){const h=n.activeEditorPane;h&&await n.save({editor:h.input,groupId:h.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(ve[210],we([0,1,28,39,174,124,8,9,25,11,184,123]),function(J,e,g,L,C,k,T,y,S,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(P,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,P.on("data",f=>this.handleData(f))}sendMessage(P){if(this.outputStream){const l=JSON.stringify(P);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${u.TWO_CRLF}${l}`,"utf8")}}handleData(P){for(this.rawData=Buffer.concat([this.rawData,P]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(f){this._onError.fire(new Error((f.message||f)+`
`+l))}continue}}else{const l=this.rawData.indexOf(u.TWO_CRLF);if(l!==-1){const p=this.rawData.toString("utf8",0,l).split(u.HEADER_LINESEPARATOR);for(const t of p){const s=t.split(u.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(l+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class m extends u{startSession(){return new Promise((P,l)=>{let f=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),P(),f=!0}),this.socket.on("close",()=>{f?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",p=>{f?this._onError.fire(p):l(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class c extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return k.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",P)}}e.SocketDebugAdapter=c;class v extends m{constructor(P){super();this.adapterServer=P}createConnection(P){return k.createConnection(this.adapterServer.path,P)}}e.NamedPipeDebugAdapter=v;class _ extends u{constructor(P,l,f){super();this.adapterExecutable=P,this.debugType=l,this.outputService=f}async startSession(){const P=this.adapterExecutable.command,l=this.adapterExecutable.args,f=this.adapterExecutable.options||{};try{if(P)if(T.isAbsolute(P)){if(!await g.Promises.exists(P))throw new Error(C.localize(0,null,P))}else P.indexOf("/")<0&&P.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let p=process.env;if(f.env&&Object.keys(f.env).length>0&&(p=S.mixin(S.deepClone(process.env),f.env)),P==="node")if(Array.isArray(l)&&l.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:p,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(o.cwd=f.cwd);const n=L.fork(l[0],l.slice(1),o);if(!n.pid)throw new Error(C.localize(2,null,l[0]));this.serverProcess=n}else throw new Error(C.localize(3,null));else{const s={env:p};f.cwd&&(s.cwd=f.cwd),this.serverProcess=L.spawn(P,l,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,o)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)});const t=this.outputService;if(t){const s=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(s(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((P,l)=>{const f=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,s){if(p)return l(p)});f.on("exit",P),f.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(P,l){if(!P)return;const f=Object.create(null);P.runtime&&(P.runtime.indexOf("./")===0?f.runtime=T.join(l,P.runtime):f.runtime=P.runtime),P.runtimeArgs&&(f.runtimeArgs=P.runtimeArgs),P.program&&(T.isAbsolute(P.program)?f.program=P.program:f.program=T.join(l,P.program)),P.args&&(f.args=P.args);const p=P;return p.win&&(f.win=_.extract(p.win,l)),p.winx86&&(f.winx86=_.extract(p.winx86,l)),p.windows&&(f.windows=_.extract(p.windows,l)),p.osx&&(f.osx=_.extract(p.osx,l)),p.linux&&(f.linux=_.extract(p.linux,l)),f}static platformAdapterExecutable(P,l){let f=Object.create(null);l=l.toLowerCase();for(const a of P)if(a.contributes){const h=a.contributes.debuggers;h&&h.length>0&&h.filter(d=>typeof d.type=="string"&&y.equalsIgnoreCase(d.type,l)).forEach(d=>{const w=_.extract(d,a.extensionLocation.fsPath);f=S.mixin(f,w,a.isBuiltin)})}let p;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=f.winx86||f.win||f.windows:A.isWindows?p=f.win||f.windows:A.isMacintosh?p=f.osx:A.isLinux&&(p=f.linux),p=p||f;let t=p.program||f.program;const s=p.args||f.args;let o=p.runtime||f.runtime;const n=p.runtimeArgs||f.runtimeArgs;if(o)return{type:"executable",command:o,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.ExecutableDebugAdapter=_}),define(ve[211],we([0,1,39,11,29,187]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(u,m){return new Promise((c,v)=>{let _="";const b=g.spawn(u,m);b.pid&&b.stdout.on("data",P=>{_+=P.toString()}),b.on("error",P=>{v(P)}),b.on("close",P=>{c(_)})})}let y;function S(u,m){if(!y)if(L.isWindows)y=new k.WindowsExternalTerminalService;else if(L.isMacintosh)y=new k.MacExternalTerminalService;else if(L.isLinux)y=new k.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=m.getConfiguration("terminal");return y.runInTerminal(u.title,u.cwd,u.args,u.env||{},c.external||{})}e.runInExternalTerminal=S;function A(u){return u?L.isWindows?new Promise(async m=>{(await new Promise((v,_)=>{J(["windows-process-tree"],v,_)})).getProcessTree(u,v=>{m(v.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(u)]).then(m=>{const c=m.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=A;var i;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(i||(i={}));function I(u,m,c,v){u=u.trim().toLowerCase();let _;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?_=1:u.indexOf("cmd.exe")>=0?_=0:u.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let b,P=" ";switch(_){case 1:if(b=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),c){const f=(0,C.getDriveLetter)(c);f&&(P+=`${f}:; `),P+=`cd ${b(c)}; `}if(v)for(let f in v){const p=v[f];p===null?P+=`Remove-Item env:${f}; `:P+=`\${env:${f}}='${p}'; `}if(m.length>0){const f=b(m.shift());P+=f[0]==="'"?`& ${f} `:`${f} `;for(let p of m)P+=`${b(p)} `}break;case 0:if(b=f=>(f=f.replace(/\"/g,'""'),f.indexOf(" ")>=0||f.indexOf('"')>=0||f.length===0?`"${f}"`:f),c){const f=(0,C.getDriveLetter)(c);f&&(P+=`${f}: && `),P+=`cd ${b(c)} && `}if(v){P+='cmd /C "';for(let f in v){let p=v[f];p===null?P+=`set "${f}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),P+=`set "${f}=${p}" && `)}}for(let f of m)P+=`${b(f)} `;v&&(P+='"');break;case 2:b=f=>(f=f.replace(/(["'\\\$])/g,"\\$1"),f.indexOf(" ")>=0||f.indexOf(";")>=0||f.length===0?`"${f}"`:f);const l=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(c&&(P+=`cd ${b(c)} ; `),v){P+="/usr/bin/env";for(let f in v){const p=v[f];p===null?P+=` -u ${l(f)}`:P+=` ${l(`${f}=${p}`)}`}P+=" "}for(let f of m)P+=`${b(f)} `;break}return P}e.prepareCommand=I}),define(ve[125],we([0,1,30,101,10,8,11,61]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(r){r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeLanguage=5]="ChangeLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var _;(function(r){r.scheme=C.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function R(N,U){return N.with({scheme:r.scheme,fragment:`ch${U.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}r.generate=R;function x(N){if(N.scheme!==r.scheme)return;const U=D.exec(N.fragment);return U?{handle:Number(U[1]),notebook:N.with({scheme:N.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}r.parse=x;function j(N){if(N.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const U=D.exec(N.fragment);return U?{handle:Number(U[1]),notebook:N.with({scheme:N.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}r.parseCellMetadataUri=j;function te(N,U,F){return N.with({scheme:F,fragment:`ch${U.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}r.generateCellUri=te;function Q(N,U){if(N.scheme!==U)return;const F=D.exec(N.fragment);return F?{handle:Number(F[1]),notebook:N.with({scheme:N.fragment.substr(F[0].length)||C.Schemas.file,fragment:null})}:void 0}r.parseCellUri=Q})(_=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function P(r){return b.get(r)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=P;function l(r){return b.get(r)?.supportedByCore??!1}e.mimeTypeSupportedByCore=l;function f(r){return b.get(r)?.mergeable??!1}e.mimeTypeIsMergeable=f;function p(r,D){return T.isWindows&&(r=r.replace(/\//g,"\\"),D=D.replace(/\//g,"\\")),g.match(r,D)}function t(r,D,R){let x=0;for(let j=0;j<D.length;j++){if(p(D[j],r))return x;x++}for(let j=0;j<R.length;j++){if(p(R[j],r))return x;x++}return x}function s(r,D,R){return r.sort((x,j)=>t(x,D,R)-t(j,D,R))}e.sortMimeTypes=s;function o(r,D,R,x=(j,te)=>j===te){const j=[];function te(U,F,V){if(F===0&&V.length===0)return;const M=j[j.length-1];M&&M.start+M.deleteCount===U?(M.deleteCount+=F,M.toInsert.push(...V)):j.push({start:U,deleteCount:F,toInsert:V})}let Q=0,N=0;for(;;){if(Q===r.length){te(Q,0,D.slice(N));break}if(N===D.length){te(Q,r.length-Q,[]);break}const U=r[Q],F=D[N];if(x(U,F)){Q+=1,N+=1;continue}R(F)?(te(Q,1,[]),Q+=1):(te(Q,0,[F]),N+=1)}return j}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(r){r.default="default",r.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(r){const D=r;return!!((typeof D.include=="string"||g.isRelativePattern(D.include))&&(typeof D.exclude=="string"||g.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=a;function h(r,D,R){if(Array.isArray(r.viewType)&&r.viewType.indexOf(D)>=0||r.viewType===D)return!0;if(r.filenamePattern){let x=a(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,j=a(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(g.match(x,(0,k.basename)(R.fsPath).toLowerCase()))return!(j&&g.match(j,(0,k.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class d{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)D[R]=this.textModel.cells[R].getHashValue();return D}}e.CellSequence=d,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(D){return`${E._prefix}${D}`}static parse(D){if(D.startsWith(E._prefix))return D.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(ve[212],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState",C[C.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(ve[213],we([0,1,176,4,61]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[214],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=g;function L(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=L}),define(ve[126],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(C=e.TestMessageType||(e.TestMessageType={}));var k;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(k=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(I,u)=>{u.expand!==void 0&&(I.expand=u.expand),u.item!==void 0&&(I.item=I.item?Object.assign(I.item,u.item):u.item)};e.applyTestItemUpdate=T;var y;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var S;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(u){}update(u){}remove(u,m){}complete(){}}e.IncrementalChangeCollector=A;class i{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(u){const m=this.createChangeCollector();for(const c of u)switch(c[0]){case 0:{const v=c[1];if(v.parent){if(this.items.has(v.parent)){const _=this.items.get(v.parent);_.children.add(v.item.extId);const b=this.createItem(v,_);this.items.set(v.item.extId,b),m.add(b)}}else{const _=this.createItem(v);this.roots.add(_),this.items.set(v.item.extId,_),m.add(_)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=c[1],_=this.items.get(v.extId);if(!_)break;v.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,v),m.update(_);break}case 2:{const v=this.items.get(c[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const _=[[c[1]]];for(;_.length;)for(const b of _.pop()){const P=this.items.get(b);P&&(_.push(P.children),this.items.delete(b),m.remove(P,P!==v),P.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(c[1]);break;case 3:this.updatePendingRoots(c[1]);break}m.complete()}retireTest(u){}updatePendingRoots(u){this.pendingRootCount+=u}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=i}),define(ve[89],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(k){k.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class C{constructor(T,y=T.length){if(this.path=T,this.viewEnd=y,T.length===0||y<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,y,S=T.parent){if(T.id===y)return new C([y]);let A=[T.id];for(let i=S;i&&i.id!==y;i=i.parent)A.push(i.id);return A.push(y),new C(A.reverse())}static isRoot(T){return!T.includes("\0")}static fromString(T){return new C(T.split("\0"))}static join(T,y){return new C([...T.path,y])}static joinToString(T,y){return T.toString()+"\0"+y}static compare(T,y){return T===y?0:y.startsWith(T+"\0")?2:T.startsWith(y+"\0")?3:1}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new C(this.path,T)}compare(T){if(typeof T=="string")return C.compare(this.toString(),T);for(let y=0;y<T.viewEnd&&y<this.viewEnd;y++)if(T.path[y]!==this.path[y])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=C}),define(ve[215],we([0,1,8,38,14,25,11,78,177]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(I,u,m){this._contributedVariables=new Map,this._context=I,this._labelService=u,m&&(this._envVariablesPromise=m.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(T.isWindows){const u=Object.create(null);return Object.keys(I).forEach(m=>{u[m.toLowerCase()]=I[m]}),u}return I}resolveWithEnvironment(I,u,m){return this.recursiveResolve(this.prepareEnv(I),u?u.uri:void 0,m)}async resolveAsync(I,u){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,u)}async resolveAnyBase(I,u,m,c){const v=k.deepClone(u);return T.isWindows&&v.windows?Object.keys(v.windows).forEach(_=>v[_]=v.windows[_]):T.isMacintosh&&v.osx?Object.keys(v.osx).forEach(_=>v[_]=v.osx[_]):T.isLinux&&v.linux&&Object.keys(v.linux).forEach(_=>v[_]=v.linux[_]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,v,m,c)}async resolveAnyAsync(I,u,m){return this.resolveAnyBase(I,u,m)}async resolveAnyMap(I,u,m){const c=new Map;return{newConfig:await this.resolveAnyBase(I,u,m,c),resolvedVariables:c}}resolveWithInteractionReplace(I,u,m,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,u,m,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,u){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,u)}recursiveResolve(I,u,m,c,v){if(C.isString(m))return this.resolveString(I,u,m,c,v);if(C.isArray(m))return m.map(_=>this.recursiveResolve(I,u,_,c,v));if(C.isObject(m)){let _=Object.create(null);return Object.keys(m).forEach(b=>{const P=this.resolveString(I,u,b,c,v);_[P]=this.recursiveResolve(I,u,m[b],c,v)}),_}return m}resolveString(I,u,m,c,v){return m.replace(A.VARIABLE_REGEXP,(b,P)=>{if(P.includes(A.VARIABLE_LHS))return b;let l=this.evaluateSingleVariable(I,b,P,u,c);return v&&v.set(P,l),l!==b&&C.isString(l)&&l.match(A.VARIABLE_REGEXP)&&(l=this.resolveString(I,u,l,c,v)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,u,m,c,v){let _;const b=m.split(":");b.length>1&&(m=b[0],_=b[1]);const P=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,S.localize)(0,null,u))},l=()=>{const p=P();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,u,g.basename(p)))},f=()=>{if(_){const p=this._context.getFolderUri(_);if(p)return p;throw new Error((0,S.localize)(2,null,u,_))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,u)):new Error((0,S.localize)(4,null,u))};switch(m){case"env":if(_){if(I){const p=I[T.isWindows?_.toLowerCase():_];if(C.isString(p))return p}return""}throw new Error((0,S.localize)(5,null,u));case"config":if(_){const p=this._context.getConfigurationValue(c,_);if(C.isUndefinedOrNull(p))throw new Error((0,S.localize)(6,null,u,_));if(C.isObject(p))throw new Error((0,S.localize)(7,null,u,_));return p}throw new Error((0,S.localize)(8,null,u));case"command":return this.resolveFromMap(u,_,v,"command");case"input":return this.resolveFromMap(u,_,v,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,y.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return c||_?(0,y.normalizeDriveLetter)(this.fsPath(f())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(f()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,S.localize)(9,null,u));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,u));case"file":return P();case"fileWorkspaceFolder":return l();case"relativeFile":return c||_?g.relative(this.fsPath(f()),P()):P();case"relativeFileDirname":const s=g.dirname(P());if(c||_){const h=g.relative(this.fsPath(f()),s);return h.length===0?".":h}return s;case"fileDirname":return g.dirname(P());case"fileExtname":return g.extname(P());case"fileBasename":return g.basename(P());case"fileBasenameNoExtension":const o=g.basename(P());return o.slice(0,o.length-g.extname(o).length);case"fileDirnameBasename":return g.basename(g.dirname(P()));case"execPath":const n=this._context.getExecPath();return n||u;case"execInstallFolder":const a=this._context.getAppRoot();return a||u;case"pathSeparator":return g.sep;default:try{const h=_?`${m}:${_}`:m;return this.resolveFromMap(u,h,v,void 0)}catch(h){return u}}}}resolveFromMap(I,u,m,c){if(u&&m){const v=c===void 0?m[u]:m[c+":"+u];if(typeof v=="string")return v;throw new Error((0,S.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[127],we([0,1,4,207]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var C;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var k;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function A(v){const _=v;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=A;var i;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.EDITOR_OPEN=2]="EDITOR_OPEN",v[v.EDITOR_CLOSE=3]="EDITOR_CLOSE",v[v.EDITOR_MOVE=4]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=6]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=8]="EDITOR_PIN",v[v.EDITOR_STICKY=9]="EDITOR_STICKY",v[v.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function m(v){const _=v;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=m;function c(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=c}),define(ve[216],we([0,1,4,127]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(k){const T=k;return typeof k=="number"||(0,L.isEditorGroup)(T)}e.isPreferredGroup=C}),define(ve[15],we([0,1,20,98,291,59,25,14,2,41,82,178,116,87,125,89,216,7]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var P;(function(_e){function ge(G){const{selectionStartLineNumber:Pe,selectionStartColumn:Oe,positionLineNumber:Ze,positionColumn:qe}=G,ft=new b.Position(Pe-1,Oe-1),bt=new b.Position(Ze-1,qe-1);return new b.Selection(ft,bt)}_e.to=ge;function he(G){const{anchor:Pe,active:Oe}=G;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}_e.from=he})(P=e.Selection||(e.Selection={}));var l;(function(_e){function ge(G){if(!G)return;const{start:Pe,end:Oe}=G;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}_e.from=ge;function he(G){if(!G)return;const{startLineNumber:Pe,startColumn:Oe,endLineNumber:Ze,endColumn:qe}=G;return new b.Range(Pe-1,Oe-1,Ze-1,qe-1)}_e.to=he})(l=e.Range||(e.Range={}));var f;(function(_e){function ge(he){switch(he){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}_e.to=ge})(f=e.TokenType||(e.TokenType={}));var p;(function(_e){function ge(G){return new b.Position(G.lineNumber-1,G.column-1)}_e.to=ge;function he(G){return{lineNumber:G.line+1,column:G.character+1}}_e.from=he})(p=e.Position||(e.Position={}));var t;(function(_e){function ge(G){switch(G){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}_e.from=ge;function he(G){switch(G){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}_e.to=he})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(_e){function ge(G){let Pe;return G.code&&((0,y.isString)(G.code)||(0,y.isNumber)(G.code)?Pe=String(G.code):Pe={value:String(G.code.value),target:G.code.target}),{...l.from(G.range),message:G.message,source:G.source,code:Pe,severity:n.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(o.from),tags:Array.isArray(G.tags)?(0,g.coalesce)(G.tags.map(t.from)):void 0}}_e.from=ge;function he(G){const Pe=new b.Diagnostic(l.to(G),G.message,n.to(G.severity));return Pe.source=G.source,Pe.code=(0,y.isString)(G.code)?G.code:G.code?.value,Pe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(o.to),Pe.tags=G.tags&&(0,g.coalesce)(G.tags.map(t.to)),Pe}_e.to=he})(s=e.Diagnostic||(e.Diagnostic={}));var o;(function(_e){function ge(G){return{...l.from(G.location.range),message:G.message,resource:G.location.uri}}_e.from=ge;function he(G){return new b.DiagnosticRelatedInformation(new b.Location(G.resource,l.to(G)),G.message)}_e.to=he})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(_e){function ge(G){switch(G){case b.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}_e.from=ge;function he(G){switch(G){case u.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}_e.to=he})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(_e){function ge(G){return typeof G=="number"&&G>=b.ViewColumn.One?G-1:G===b.ViewColumn.Beside?_.SIDE_GROUP:_.ACTIVE_GROUP}_e.from=ge;function he(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=he})(a=e.ViewColumn||(e.ViewColumn={}));function h(_e){return typeof _e.range!="undefined"}function d(_e){return _e.length===0?!0:!!h(_e[0])}e.isDecorationOptionsArr=d;var w;(function(_e){function ge(qe){return qe.map(_e.from)}_e.fromMany=ge;function he(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function G(qe){let ft;if(he(qe)){const{language:ct,value:ht}=qe;ft={value:"```"+ct+`
`+ht+"\n```\n"}}else b.MarkdownString.isMarkdownString(qe)?ft={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons}:typeof qe=="string"?ft={value:qe}:ft={value:""};const bt=Object.create(null);ft.uris=bt;const kt=ct=>{try{let ht=S.URI.parse(ct,!0);ht=ht.with({query:Pe(ht.query,bt)}),bt[ct]=ht}catch(ht){}return""},dt=new C.Renderer;return dt.link=kt,dt.image=ct=>kt(L.parseHrefAndDimensions(ct).href),C(ft.value,{renderer:dt}),ft}_e.from=G;function Pe(qe,ft){if(!qe)return qe;let bt;try{bt=(0,k.parse)(qe)}catch(dt){}if(!bt)return qe;let kt=!1;return bt=(0,T.cloneAndChange)(bt,dt=>{if(S.URI.isUri(dt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[ct]=dt,kt=!0,ct}else return}),kt?JSON.stringify(bt):qe}function Oe(qe){const ft=new b.MarkdownString(qe.value,qe.supportThemeIcons);return ft.isTrusted=qe.isTrusted,ft}_e.to=Oe;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:_e.from(qe)}_e.fromStrict=Ze})(w=e.MarkdownString||(e.MarkdownString={}));function E(_e){return d(_e)?_e.map(ge=>({range:l.from(ge.range),hoverMessage:Array.isArray(ge.hoverMessage)?w.fromMany(ge.hoverMessage):ge.hoverMessage?w.from(ge.hoverMessage):void 0,renderOptions:ge.renderOptions})):_e.map(ge=>({range:l.from(ge)}))}e.fromRangeOrRangeWithMessage=E;function r(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?S.URI.file(_e):_e}e.pathOrURIToURI=r;var D;(function(_e){function ge(he){return typeof he=="undefined"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?r(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}_e.from=ge})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(_e){function ge(he){return typeof he=="undefined"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?r(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?D.from(he.before):void 0,after:he.after?D.from(he.after):void 0}}_e.from=ge})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(_e){function ge(he){if(typeof he=="undefined")return he;switch(he){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ge})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var j;(function(_e){function ge(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?x.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?R.from(he.light):void 0,dark:he.dark?R.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?r(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?D.from(he.before):void 0,after:he.after?D.from(he.after):void 0}}_e.from=ge})(j=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var te;(function(_e){function ge(G){return{text:G.newText,eol:G.newEol&&pe.from(G.newEol),range:l.from(G.range)}}_e.from=ge;function he(G){const Pe=new b.TextEdit(l.to(G.range),G.text);return Pe.newEol=typeof G.eol=="undefined"?void 0:pe.to(G.eol),Pe}_e.to=he})(te=e.TextEdit||(e.TextEdit={}));var Q;(function(_e){function ge(G,Pe,Oe){const Ze={edits:[]};if(G instanceof b.WorkspaceEdit)for(let qe of G._allEntries())if(qe._type===1)Ze.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const ft=Pe?.getDocument(qe.uri);Ze.edits.push({_type:2,resource:qe.uri,edit:te.from(qe.edit),modelVersionId:ft?.version,metadata:qe.metadata})}else qe._type===3?Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Oe?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ue.from)}});return Ze}_e.from=ge;function he(G){const Pe=new b.WorkspaceEdit;for(const Oe of G.edits)Oe.edit?Pe.replace(S.URI.revive(Oe.resource),l.to(Oe.edit.range),Oe.edit.text):Pe.renameFile(S.URI.revive(Oe.oldUri),S.URI.revive(Oe.newUri),Oe.options);return Pe}_e.to=he})(Q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(_e){const ge=Object.create(null);ge[b.SymbolKind.File]=0,ge[b.SymbolKind.Module]=1,ge[b.SymbolKind.Namespace]=2,ge[b.SymbolKind.Package]=3,ge[b.SymbolKind.Class]=4,ge[b.SymbolKind.Method]=5,ge[b.SymbolKind.Property]=6,ge[b.SymbolKind.Field]=7,ge[b.SymbolKind.Constructor]=8,ge[b.SymbolKind.Enum]=9,ge[b.SymbolKind.Interface]=10,ge[b.SymbolKind.Function]=11,ge[b.SymbolKind.Variable]=12,ge[b.SymbolKind.Constant]=13,ge[b.SymbolKind.String]=14,ge[b.SymbolKind.Number]=15,ge[b.SymbolKind.Boolean]=16,ge[b.SymbolKind.Array]=17,ge[b.SymbolKind.Object]=18,ge[b.SymbolKind.Key]=19,ge[b.SymbolKind.Null]=20,ge[b.SymbolKind.EnumMember]=21,ge[b.SymbolKind.Struct]=22,ge[b.SymbolKind.Event]=23,ge[b.SymbolKind.Operator]=24,ge[b.SymbolKind.TypeParameter]=25;function he(Pe){return typeof ge[Pe]=="number"?ge[Pe]:6}_e.from=he;function G(Pe){for(const Oe in ge)if(ge[Oe]===Pe)return Number(Oe);return b.SymbolKind.Property}_e.to=G})(N=e.SymbolKind||(e.SymbolKind={}));var U;(function(_e){function ge(G){switch(G){case b.SymbolTag.Deprecated:return 1}}_e.from=ge;function he(G){switch(G){case 1:return b.SymbolTag.Deprecated}}_e.to=he})(U=e.SymbolTag||(e.SymbolTag={}));var F;(function(_e){function ge(G){return{name:G.name,kind:N.from(G.kind),tags:G.tags&&G.tags.map(U.from),containerName:G.containerName,location:B.from(G.location)}}_e.from=ge;function he(G){const Pe=new b.SymbolInformation(G.name,N.to(G.kind),G.containerName,B.to(G.location));return Pe.tags=G.tags&&G.tags.map(U.to),Pe}_e.to=he})(F=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(_e){function ge(G){const Pe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:l.from(G.range),selectionRange:l.from(G.selectionRange),kind:N.from(G.kind),tags:G.tags?.map(U.from)??[]};return G.children&&(Pe.children=G.children.map(ge)),Pe}_e.from=ge;function he(G){const Pe=new b.DocumentSymbol(G.name,G.detail,N.to(G.kind),l.to(G.range),l.to(G.selectionRange));return(0,g.isNonEmptyArray)(G.tags)&&(Pe.tags=G.tags.map(U.to)),G.children&&(Pe.children=G.children.map(he)),Pe}_e.to=he})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(_e){function ge(G){const Pe=new b.CallHierarchyItem(N.to(G.kind),G.name,G.detail||"",S.URI.revive(G.uri),l.to(G.range),l.to(G.selectionRange));return Pe._sessionId=G._sessionId,Pe._itemId=G._itemId,Pe}_e.to=ge;function he(G,Pe,Oe){if(Pe=Pe??G._sessionId,Oe=Oe??G._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,name:G.name,detail:G.detail,kind:N.from(G.kind),uri:G.uri,range:l.from(G.range),selectionRange:l.from(G.selectionRange),tags:G.tags?.map(U.from)}}_e.from=he})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var O;(function(_e){function ge(he){return new b.CallHierarchyIncomingCall(M.to(he.from),he.fromRanges.map(G=>l.to(G)))}_e.to=ge})(O=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(_e){function ge(he){return new b.CallHierarchyOutgoingCall(M.to(he.to),he.fromRanges.map(G=>l.to(G)))}_e.to=ge})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var B;(function(_e){function ge(G){return{range:G.range&&l.from(G.range),uri:G.uri}}_e.from=ge;function he(G){return new b.Location(S.URI.revive(G.uri),l.to(G.range))}_e.to=he})(B=e.location||(e.location={}));var K;(function(_e){function ge(G){const Pe=G,Oe=G;return{originSelectionRange:Pe.originSelectionRange?l.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Oe.uri,range:l.from(Pe.targetRange?Pe.targetRange:Oe.range),targetSelectionRange:Pe.targetSelectionRange?l.from(Pe.targetSelectionRange):void 0}}_e.from=ge;function he(G){return{targetUri:S.URI.revive(G.uri),targetRange:l.to(G.range),targetSelectionRange:G.targetSelectionRange?l.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?l.to(G.originSelectionRange):void 0}}_e.to=he})(K=e.DefinitionLink||(e.DefinitionLink={}));var ne;(function(_e){function ge(G){return{range:l.from(G.range),contents:w.fromMany(G.contents)}}_e.from=ge;function he(G){return new b.Hover(G.contents.map(w.to),l.to(G.range))}_e.to=he})(ne=e.Hover||(e.Hover={}));var me;(function(_e){function ge(G){return{range:l.from(G.range),expression:G.expression}}_e.from=ge;function he(G){return new b.EvaluatableExpression(l.to(G.range),G.expression)}_e.to=he})(me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(_e){function ge(G){if(G instanceof b.InlineValueText)return{type:"text",range:l.from(G.range),text:G.text};if(G instanceof b.InlineValueVariableLookup)return{type:"variable",range:l.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ge;function he(G){switch(G.type){case"text":return{range:l.to(G.range),text:G.text};case"variable":return{range:l.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:l.to(G.range),expression:G.expression}}}_e.to=he})(Se=e.InlineValue||(e.InlineValue={}));var Ce;(function(_e){function ge(G){return{frameId:G.frameId,stoppedLocation:l.from(G.stoppedLocation)}}_e.from=ge;function he(G){return new b.InlineValueContext(G.frameId,l.to(G.stoppedLocation))}_e.to=he})(Ce=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(_e){function ge(G){return{range:l.from(G.range),kind:G.kind}}_e.from=ge;function he(G){return new b.DocumentHighlight(l.to(G.range),G.kind)}_e.to=he})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var je;(function(_e){function ge(he){switch(he){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}_e.to=ge})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(_e){function ge(he){return{triggerKind:je.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}_e.to=ge})(Be=e.CompletionContext||(e.CompletionContext={}));var Ve;(function(_e){function ge(G){switch(G){case b.CompletionItemTag.Deprecated:return 1}}_e.from=ge;function he(G){switch(G){case 1:return b.CompletionItemTag.Deprecated}}_e.to=he})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(_e){const ge=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function he(Oe){return ge.get(Oe)??9}_e.from=he;const G=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Pe(Oe){return G.get(Oe)??b.CompletionItemKind.Property}_e.to=Pe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(_e){function ge(he,G){const Pe=new b.CompletionItem(he.label);return Pe.insertText=he.insertText,Pe.kind=W.to(he.kind),Pe.tags=he.tags?.map(Ve.to),Pe.detail=he.detail,Pe.documentation=L.isMarkdownString(he.documentation)?w.to(he.documentation):he.documentation,Pe.sortText=he.sortText,Pe.filterText=he.filterText,Pe.preselect=he.preselect,Pe.commitCharacters=he.commitCharacters,A.Range.isIRange(he.range)?Pe.range=l.to(he.range):typeof he.range=="object"&&(Pe.range={inserting:l.to(he.range.insert),replacing:l.to(he.range.replace)}),Pe.keepWhitespace=typeof he.insertTextRules=="undefined"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules!="undefined"&&he.insertTextRules&4?Pe.insertText=new b.SnippetString(he.insertText):(Pe.insertText=he.insertText,Pe.textEdit=Pe.range instanceof b.Range?new b.TextEdit(Pe.range,Pe.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Pe.additionalTextEdits=he.additionalTextEdits.map(Oe=>te.to(Oe))),Pe.command=G&&he.command?G.fromInternal(he.command):void 0,Pe}_e.to=ge})(Z=e.CompletionItem||(e.CompletionItem={}));var ie;(function(_e){function ge(G){return{label:G.label,documentation:G.documentation?w.fromStrict(G.documentation):void 0}}_e.from=ge;function he(G){return{label:G.label,documentation:L.isMarkdownString(G.documentation)?w.to(G.documentation):G.documentation}}_e.to=he})(ie=e.ParameterInformation||(e.ParameterInformation={}));var le;(function(_e){function ge(G){return{label:G.label,documentation:G.documentation?w.fromStrict(G.documentation):void 0,parameters:Array.isArray(G.parameters)?G.parameters.map(ie.from):[],activeParameter:G.activeParameter}}_e.from=ge;function he(G){return{label:G.label,documentation:L.isMarkdownString(G.documentation)?w.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(ie.to):[],activeParameter:G.activeParameter}}_e.to=he})(le=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(_e){function ge(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(le.from):[]}}_e.from=ge;function he(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(le.to):[]}}_e.to=he})(Y=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(_e){function ge(G){return{text:G.text,position:p.from(G.position),kind:be.from(G.kind??b.InlayHintKind.Other),whitespaceBefore:G.whitespaceBefore,whitespaceAfter:G.whitespaceAfter}}_e.from=ge;function he(G){const Pe=new b.InlayHint(G.text,p.to(G.position),be.to(G.kind));return Pe.whitespaceAfter=G.whitespaceAfter,Pe.whitespaceBefore=G.whitespaceBefore,Pe}_e.to=he})(ae=e.InlayHint||(e.InlayHint={}));var be;(function(_e){function ge(G){return G}_e.from=ge;function he(G){return G}_e.to=he})(be=e.InlayHintKind||(e.InlayHintKind={}));var Fe;(function(_e){function ge(G){return{range:l.from(G.range),url:G.target,tooltip:G.tooltip}}_e.from=ge;function he(G){let Pe;if(G.url)try{Pe=typeof G.url=="string"?S.URI.parse(G.url,!0):S.URI.revive(G.url)}catch(Oe){}return new b.DocumentLink(l.to(G.range),Pe)}_e.to=he})(Fe=e.DocumentLink||(e.DocumentLink={}));var He;(function(_e){function ge(G){const Pe=new b.ColorPresentation(G.label);return G.textEdit&&(Pe.textEdit=te.to(G.textEdit)),G.additionalTextEdits&&(Pe.additionalTextEdits=G.additionalTextEdits.map(Oe=>te.to(Oe))),Pe}_e.to=ge;function he(G){return{label:G.label,textEdit:G.textEdit?te.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Pe=>te.from(Pe)):void 0}}_e.from=he})(He=e.ColorPresentation||(e.ColorPresentation={}));var Ee;(function(_e){function ge(G){return new b.Color(G[0],G[1],G[2],G[3])}_e.to=ge;function he(G){return[G.red,G.green,G.blue,G.alpha]}_e.from=he})(Ee=e.Color||(e.Color={}));var Qe;(function(_e){function ge(G){return{range:l.from(G.range)}}_e.from=ge;function he(G){return new b.SelectionRange(l.to(G.range))}_e.to=he})(Qe=e.SelectionRange||(e.SelectionRange={}));var X;(function(_e){function ge(he){switch(he){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}_e.to=ge})(X=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var se;(function(_e){function ge(G){switch(G){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ge;function he(G){switch(G){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}_e.to=he})(se=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pe;(function(_e){function ge(G){if(G===b.EndOfLine.CRLF)return 1;if(G===b.EndOfLine.LF)return 0}_e.from=ge;function he(G){if(G===1)return b.EndOfLine.CRLF;if(G===0)return b.EndOfLine.LF}_e.to=he})(pe=e.EndOfLine||(e.EndOfLine={}));var Ue;(function(_e){function ge(he){if(typeof he=="object")return he.viewId;switch(he){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ge})(Ue=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(_e){function ge(he){const G={start:he.start+1,end:he.end+1};return he.kind&&(G.kind=Je.from(he.kind)),G}_e.from=ge})(Ne=e.FoldingRange||(e.FoldingRange={}));var Je;(function(_e){function ge(he){if(he)switch(he){case b.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}_e.from=ge})(Je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ke;(function(_e){function ge(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?l.from(he.selection):void 0,override:typeof he.override=="boolean"?I.EditorResolution.DISABLED:void 0}}_e.from=ge})(ke=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ye;(function(_e){function ge(G){return G instanceof b.RelativePattern||typeof G=="string"?G:he(G)?new b.RelativePattern(G.base,G.pattern):G}_e.from=ge;function he(G){const Pe=G;return Pe&&typeof Pe.base=="string"&&typeof Pe.pattern=="string"}})(ye=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(_e){function ge(he){if(he){if(Array.isArray(he))return he.map(ge);if(typeof he=="string")return he;{const G=he;return{language:G.language,scheme:G.scheme,pattern:typeof G.pattern=="undefined"?void 0:ye.from(G.pattern),exclusive:G.exclusive}}}else return}_e.from=ge})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(_e){function ge(G){return{start:G.start,end:G.end}}_e.from=ge;function he(G){return new b.NotebookRange(G.start,G.end)}_e.to=he})(ce=e.NotebookRange||(e.NotebookRange={}));var de;(function(_e){function ge(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}_e.to=ge;function he(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}_e.from=he})(de=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var H;(function(_e){function ge(G){switch(G){case b.NotebookCellKind.Markup:return c.CellKind.Markup;case b.NotebookCellKind.Code:default:return c.CellKind.Code}}_e.from=ge;function he(G){switch(G){case c.CellKind.Markup:return b.NotebookCellKind.Markup;case c.CellKind.Code:default:return b.NotebookCellKind.Code}}_e.to=he})(H=e.NotebookCellKind||(e.NotebookCellKind={}));var ee;(function(_e){function ge(G){const Pe={metadata:G.metadata??Object.create(null),cells:[]};for(let Oe of G.cells)b.NotebookCellData.validate(Oe),Pe.cells.push(ue.from(Oe));return Pe}_e.from=ge;function he(G){const Pe=new b.NotebookData(G.cells.map(ue.to));return(0,y.isEmptyObject)(G.metadata)||(Pe.metadata=G.metadata),Pe}_e.to=he})(ee=e.NotebookData||(e.NotebookData={}));var ue;(function(_e){function ge(G){return{cellKind:H.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:de.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Re.from):[]}}_e.from=ge;function he(G){return new b.NotebookCellData(H.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Re.to):void 0,G.metadata,G.internalMetadata?de.to(G.internalMetadata):void 0)}_e.to=he})(ue=e.NotebookCellData||(e.NotebookCellData={}));var Le;(function(_e){function ge(G){return{mime:G.mime,valueBytes:Array.from(G.data)}}_e.from=ge;function he(G){return new b.NotebookCellOutputItem(new Uint8Array(G.valueBytes),G.mime)}_e.to=he})(Le=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(_e){function ge(G){return{outputId:G.id,items:G.items.map(Le.from),metadata:G.metadata}}_e.from=ge;function he(G){const Pe=G.items.map(Le.to);return new b.NotebookCellOutput(Pe,G.outputId,G.metadata)}_e.to=he})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ze;(function(_e){function ge(Oe){if(Oe!=null){if(Oe instanceof b.RelativePattern||typeof Oe=="string")return Oe;if(Pe(Oe))return new b.RelativePattern(Oe.base,Oe.pattern);if(G(Oe))return{include:ye.from(Oe.include)||void 0,exclude:ye.from(Oe.exclude)||void 0}}}_e.from=ge;function he(Oe){return typeof Oe=="string"?Oe:Pe(Oe)?{base:Oe.base,pattern:Oe.pattern}:{include:Oe.include,exclude:Oe.exclude}}_e.to=he;function G(Oe){const Ze=Oe,qe=ye.from(Ze.include);if(!(qe&&qe instanceof b.RelativePattern||typeof qe=="string"))return!1;const ft=ye.from(Ze.exclude);return!!(ft&&ft instanceof b.RelativePattern||typeof ft=="string")}function Pe(Oe){const Ze=Oe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(ze=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ge;(function(_e){function ge(he){return{backgroundColor:he.backgroundColor,borderColor:he.borderColor,top:he.top?D.from(he.top):void 0}}_e.from=ge})(Ge=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var et;(function(_e){function ge(he,G,Pe){const Oe=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Oe,Pe),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}_e.from=ge})(et=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var it;(function(_e){function ge(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{}}}_e.from=ge})(it=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ye;(function(_e){function ge(G){return{uri:G.uri,provides:G.provides}}_e.from=ge;function he(G){return new b.NotebookRendererScript(S.URI.revive(G.uri),G.provides)}_e.to=he})(Ye=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Xe;(function(_e){function ge(G){return{message:w.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location?B.from(G.location):void 0}}_e.from=ge;function he(G){const Pe=new b.TestMessage(typeof G.message=="string"?G.message:w.to(G.message));return Pe.actualOutput=G.actual,Pe.expectedOutput=G.expected,Pe}_e.to=he})(Xe=e.TestMessage||(e.TestMessage={}));var mt;(function(_e){let ge;(function(G){G.Delimiter="\0"})(ge||(ge={})),_e.namespace=(G,Pe)=>G+"\0"+Pe;function he(G,Pe){return{displayId:Pe.id,id:_e.namespace(G,Pe.id),label:Pe.label}}_e.display=he,_e.denamespace=G=>{const Pe=G.indexOf("\0");return{ctrlId:G.slice(0,Pe),tagId:G.slice(Pe+1)}}})(mt=e.TestTag||(e.TestTag={}));var vt;(function(_e){function ge(Oe){const Ze=(0,m.getPrivateApiFor)(Oe).controllerId;return{extId:v.TestId.fromExtHostTestItem(Oe,Ze).toString(),label:Oe.label,uri:Oe.uri,tags:Oe.tags.map(qe=>mt.namespace(Ze,qe.id)),range:l.from(Oe.range)||null,description:Oe.description||null,error:Oe.error&&w.fromStrict(Oe.error)||null}}_e.from=ge;function he(Oe){return{id:v.TestId.fromString(Oe.extId).localId,label:Oe.label,uri:S.URI.revive(Oe.uri),tags:(Oe.tags||[]).map(Ze=>{const{tagId:qe}=mt.denamespace(Ze);return new b.TestTag(qe,qe)}),range:l.to(Oe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Oe.description||void 0}}_e.toPlain=he;function G(Oe){const Ze=v.TestId.fromString(Oe.extId),qe=new m.TestItemImpl(Ze.controllerId,Ze.localId,Oe.label,S.URI.revive(Oe.uri));return qe.range=l.to(Oe.range||void 0),qe.description=Oe.description||void 0,qe}function Pe(Oe){let Ze;for(const qe of Oe.tests){const ft=G(qe.item);(0,m.getPrivateApiFor)(ft).parent=Ze,Ze=ft}return Ze}_e.toItemFromContext=Pe})(vt=e.TestItem||(e.TestItem={})),function(_e){function ge(G){return{id:G.id,label:G.label}}_e.from=ge;function he(G){return new b.TestTag(G.id,G.label)}_e.to=he}(mt=e.TestTag||(e.TestTag={}));var Et;(function(_e){const ge=(G,Pe)=>{const Oe={...vt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(qe=>qe.type===0).map(Xe.to)})),children:G.children.map(Ze=>Pe.get(Ze)).filter(y.isDefined).map(Ze=>ge(Ze,Pe))};for(const Ze of Oe.children)Ze.parent=Oe;return Oe};function he(G){const Pe=[],Oe=new Map;for(const Ze of G.items)Oe.set(Ze.item.extId,Ze),G.request.targets.some(qe=>qe.controllerId===Ze.controllerId&&qe.testIds.includes(Ze.item.extId))&&Pe.push(Ze);return{completedAt:G.completedAt,results:Pe.map(Ze=>ge(Ze,Oe))}}_e.to=he})(Et=e.TestResults||(e.TestResults={}));var ot;(function(_e){function ge(Oe){return{covered:Oe.covered,total:Oe.covered}}function he(Oe){return"line"in Oe?p.from(Oe):l.from(Oe)}function G(Oe){return"branches"in Oe?{count:Oe.executionCount,location:he(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&he(Ze.location)})):void 0}:{type:0,count:Oe.executionCount,location:he(Oe.location)}}_e.fromDetailed=G;function Pe(Oe){return{uri:Oe.uri,statement:ge(Oe.statementCoverage),branch:Oe.branchCoverage&&ge(Oe.branchCoverage),function:Oe.functionCoverage&&ge(Oe.functionCoverage),details:Oe.detailedCoverage?.map(G)}}_e.fromFile=Pe})(ot=e.TestCoverage||(e.TestCoverage={}));var at;(function(_e){function ge(he){switch(he){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}_e.to=ge})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Dt;(function(_e){function ge(G){const Pe=new b.TypeHierarchyItem(N.to(G.kind),G.name,G.detail||"",S.URI.revive(G.uri),l.to(G.range),l.to(G.selectionRange));return Pe._sessionId=G._sessionId,Pe._itemId=G._itemId,Pe}_e.to=ge;function he(G,Pe,Oe){if(Pe=Pe??G._sessionId,Oe=Oe??G._itemId,Pe===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Oe,kind:N.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:l.from(G.range),selectionRange:l.from(G.selectionRange),tags:G.tags?.map(U.from)}}_e.from=he})(Dt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[217],we([0,1,2,16,7,15,94]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(A,i,I,u={timeout:1500,errors:3}){this._logService=A,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=u,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(i,I,u)=>{const c={dispose:this._callbacks.push([i,I,A])};return Array.isArray(u)&&u.push(c),c}}async $participateInSave(A,i){const I=g.URI.revive(A);let u=!1;const m=setTimeout(()=>u=!0,this._thresholds.timeout),c=[];try{for(let v of[...this._callbacks]){if(u)break;const _=this._documents.getDocument(I),b=await this._deliverEventAsyncAndBlameBadListeners(v,{document:_,reason:k.TextDocumentSaveReason.to(i)});c.push(b)}}finally{clearTimeout(m)}return c}_deliverEventAsyncAndBlameBadListeners([A,i,I],u){const m=this._badListeners.get(A);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,A,i,u).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const v=this._badListeners.get(A);this._badListeners.set(A,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,i,I,u){const m=[],c=Date.now(),{document:v,reason:_}=u,{version:b}=v,P=Object.freeze({document:v,reason:_,waitUntil(l){if(Object.isFrozen(m))throw(0,L.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(l))}});try{i.apply(I,[P])}catch(l){return Promise.reject(l)}return Object.freeze(m),new Promise((l,f)=>{const p=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(p),l(t)}).catch(t=>{clearTimeout(p),f(t)})}).then(l=>{const f={edits:[]};for(const p of l)if(Array.isArray(p)&&p.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:s,range:o}of p)f.edits.push({_type:2,resource:v.uri,edit:{range:o&&k.Range.from(o),text:t,eol:s&&k.EndOfLine.from(s)}});if(f.edits.length!==0)return b===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(ve[218],we([0,1,3,30,2,15,7]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(i,I,u,m,c){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,u&&(this._config+=1),m&&(this._config+=2),c&&(this._config+=4);const v=(0,L.parse)(I),_=i(b=>{if(!u)for(let P of b.created){const l=C.URI.revive(P);v(l.fsPath)&&this._onDidCreate.fire(l)}if(!m)for(let P of b.changed){const l=C.URI.revive(P);v(l.fsPath)&&this._onDidChange.fire(l)}if(!c)for(let P of b.deleted){const l=C.URI.revive(P);v(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(i,I,u){this._logService=I,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,u,m){return new y(this._onFileSystemEvent.event,i,I,u,m)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(u=>({oldUri:C.URI.revive(u.source),newUri:C.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(u=>C.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(u=>C.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(u,m,c)=>{const v=function(b){u.call(m,b)};return v.extension=i,I.event(v,void 0,c)}}async $onWillRunFileOperation(i,I,u,m){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(c=>({oldUri:C.URI.revive(c.source),newUri:C.URI.revive(c.target)}))},u,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(c=>C.URI.revive(c.target))},u,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(c=>C.URI.revive(c.target))},u,m)}}async _fireWillEvent(i,I,u,m){const c=new Set,v=[];if(await i.fireAsync(I,m,async(b,P)=>{const l=Date.now(),f=await Promise.resolve(b);f instanceof T.WorkspaceEdit&&(v.push(f),c.add(P.extension.displayName??P.extension.identifier.value)),Date.now()-l>u&&this._logService.warn("SLOW file-participant",P.extension.identifier)}),m.isCancellationRequested||v.length===0)return;const _={edits:[]};for(let b of v){let{edits:P}=k.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(P)}return{edit:_,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=S}),define(ve[219],we([0,1,10,25,2,15,7,125]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(u,m,c,v){this.start=u,this.deletedCount=m,this.deletedItems=c,this.items=v}static asApiEvents(u){return u.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(c=>c.apiCell)}))}}class A{constructor(u,m,c){this.notebook=u,this._extHostDocument=m,this._cellData=c,this.handle=c.handle,this.uri=C.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(k.NotebookCellOutput.to),this._internalMetadata=c.internalMetadata??{},this._metadata=Object.freeze(c.metadata??{}),this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(c.internalMetadata??{}))}static asModelAddData(u,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:k.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return u._mime},set mime(c){u._mime=c},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(k.NotebookCellOutput.to)}setOutputItems(u,m,c){const v=c.map(k.NotebookCellOutputItem.to),_=this._outputs.find(b=>b.id===u);_&&(m||(_.items.length=0),_.items.push(...v))}setMetadata(u){this._metadata=Object.freeze(u)}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=Object.freeze(k.NotebookCellExecutionSummary.to(u))}setMime(u){}}e.ExtHostCell=A;class i{constructor(u,m,c,v,_,b){this._proxy=u,this._textDocumentsAndEditors=m,this._textDocuments=c,this._emitter=v,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=Object.freeze(b.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===g.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(m){return m=u._validateIndex(m),u._cells[m].apiCell},getCells(m){return(m?u._getCells(m):u._cells).map(v=>v.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata=Object.freeze({...this._metadata,...u.metadata}))}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,m){this._versionId=u.versionId,this._isDirty=m;for(const c of u.rawEvents)c.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===y.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let m=u.start|0,c=u.end|0;return m<0&&(m=0),c>this._cells.length&&(c=this._cells.length),u.with({start:m,end:c})}_getCells(u){u=this._validateRange(u);const m=[];for(let c=u.start;c<u.end;c++)m.push(this._cells[c]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,m){if(this._disposed)return;const c=[],v=[],_=[];u.reverse().forEach(b=>{const l=b[2].map(t=>{const s=new A(this,this._textDocumentsAndEditors,t);return m||v.push(A.asModelAddData(this.apiNotebook,t)),s}),f=new S(b[0],b[1],[],l),p=this._cells.splice(b[0],b[1],...l);for(const t of p)_.push(t.uri),f.deletedItems.push(t.apiCell);c.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:_}),m||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(c)}))}_moveCell(u,m){const c=this._cells.splice(u,1);this._cells.splice(m,0,...c);const v=[new S(u,1,c.map(_=>_.apiCell),[]),new S(m,0,[],c)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(v)}))}_setCellOutputs(u,m){const c=this._cells[u];c.setOutputs(m),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(u,m,c,v){const _=this._cells[u];_.setOutputItems(m,c,v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(u,m){const c=this._cells[u];c.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(c.uri,m)}_changeCellMime(u,m){const c=this._cells[u];c.apiCell.mime=m}_changeCellMetadata(u,m){const c=this._cells[u],v=c.apiCell.metadata;c.setMetadata(m);const _=c.apiCell.metadata;(0,L.equals)(v,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(u,m){const c=this._cells[u],v=c.internalMetadata;if(c.setInternalMetadata(m),v.runState!==m.runState){const _=m.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:c.apiCell,state:_}))}}getCellFromApiCell(u){return this._cells.find(m=>m.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(m=>m.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(ve[128],we([0,1,7,15,16]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:A})}replaceCells(S,A,i){this._throwIfFinalized(),!(S===A&&i.length===0)&&this._collectedEdits.push({editType:1,index:S,count:A-S,cells:i.map(L.NotebookCellData.from)})}}class T{constructor(S,A,i,I,u,m){this.id=S,this._proxy=A,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=I,this._viewColumn=m}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(A){if(!Array.isArray(A)||!A.every(g.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");S._selections=A,S._trySetSelections(A)},get visibleRanges(){return S._visibleRanges},revealRange(A,i){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(A),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(A){const i=new k(this.document.version);return A(i),S._applyEdit(i.finalize())},setDecorations(A,i){return S.setDecorations(A,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const A=[];let i=-1;for(let I=0;I<S.cellEdits.length;I++){if(i<0){A.push(S.cellEdits[I]),i++;continue}const m=A[i],c=S.cellEdits[I];if(m.editType===1&&c.editType===1&&m.index===c.index){m.cells.push(...S.cellEdits[I].cells),m.count+=S.cellEdits[I].count;continue}A.push(S.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,A)}setDecorations(S,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return A.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(A),S.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(ve[220],we([0,1,15,117,165,21,56]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,u,m){const c=this._handles++,{title:v,location:_,cancellable:b}=u,P={label:(0,C.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:g.ProgressLocation.from(_),title:v,source:P,cancellable:b},I),this._withProgress(c,m,!!b)}_withProgress(I,u,m){let c;m&&(c=new k.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),c&&c.dispose()};let _;try{_=u(new A(this._proxy,I),m&&c?c.token:k.CancellationToken.None)}catch(b){throw v(I),b}return _.then(b=>v(I),b=>v(I)),_}$acceptProgressCanceled(I){const u=this._mapHandleToCancellationSource.get(I);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=y;function S(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class A extends L.Progress{constructor(I,u){super(m=>this.throttledReport(m));this._proxy=I,this._handle=u}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}We([(0,T.throttle)(100,(i,I)=>S(i,I),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(ve[129],we([0,1,54,16,74,15,7]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(u,m,c){const v=y._Keys.nextId();u.$registerTextEditorDecorationType(m.identifier,v,k.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:v,dispose(){u.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=y,y._Keys=new C.IdGenerator("TextEditorDecorationType");class S{constructor(u,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,m){this._throwIfFinalized();let c=null;if(u instanceof T.Position)c=new T.Range(u,u);else if(u instanceof T.Range)c=u;else throw new Error("Unrecognized location");this._pushEdit(c,m,!1)}insert(u,m){this._throwIfFinalized(),this._pushEdit(new T.Range(u,u),m,!0)}delete(u){this._throwIfFinalized();let m=null;if(u instanceof T.Range)m=u;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(u,m,c){const v=this._document.validateRange(u);this._collectedEdits.push({range:v,text:m,forceMoveMarkers:c})}setEndOfLine(u){if(this._throwIfFinalized(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=S;class A{constructor(u,m,c,v){this._proxy=u,this._id=m,this._accept(c),this._logService=v;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(b){_._setTabSize(b)},get insertSpaces(){return _._insertSpaces},set insertSpaces(b){_._setInsertSpaces(b)},get cursorStyle(){return _._cursorStyle},set cursorStyle(b){_._setCursorStyle(b)},get lineNumbers(){return _._lineNumbers},set lineNumbers(b){_._setLineNumbers(b)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=k.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const m=Math.floor(u);return m>0?m:null}if(typeof u=="string"){const m=parseInt(u,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(u){const m=this._validateTabSize(u);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const m=this._validateInsertSpaces(u);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:k.TextEditorLineNumbersStyle.from(u)})))}assign(u){const m={};let c=!1;if(typeof u.tabSize!="undefined"){const v=this._validateTabSize(u.tabSize);v==="auto"?(c=!0,m.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,c=!0,m.tabSize=v)}if(typeof u.insertSpaces!="undefined"){const v=this._validateInsertSpaces(u.insertSpaces);v==="auto"?(c=!0,m.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,c=!0,m.insertSpaces=v)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,c=!0,m.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,c=!0,m.lineNumbers=k.TextEditorLineNumbersStyle.from(u.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(u){u.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=A;class i{constructor(u,m,c,v,_,b,P,l){this.id=u,this._proxy=m,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new A(this._proxy,this.id,b,c),this._visibleRanges=P,this._viewColumn=l;const f=this;this.value=Object.freeze({get document(){return v.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(p){if(!(p instanceof T.Selection))throw(0,L.illegalArgument)("selection");f._selections=[p],f._trySetSelection()},get selections(){return f._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof T.Selection)))throw(0,L.illegalArgument)("selections");f._selections=p,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return f._options.value},set options(p){f._disposed||f._options.assign(p)},get viewColumn(){return f._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(v.getValue(),t);return p(s),f._applyEdit(s)},insertSnippet(p,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=f._selections.map(n=>k.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:a}=k.Position.from(t);o=[{startLineNumber:n,startColumn:a,endLineNumber:n,endColumn:a}]}else if(t instanceof T.Range)o=[k.Range.from(t)];else{o=[];for(const n of t)if(n instanceof T.Range)o.push(k.Range.from(n));else{const{lineNumber:a,column:h}=k.Position.from(n);o.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return m.$tryInsertSnippet(u,p.value,o,s)},setDecorations(p,t){const s=t.length===0;s&&!f._hasDecorationsForKey.has(p.key)||(s?f._hasDecorationsForKey.delete(p.key):f._hasDecorationsForKey.add(p.key),f._runOnProxy(()=>{if(k.isDecorationOptionsArr(t))return m.$trySetDecorations(u,p.key,k.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let n=0,a=t.length;n<a;n++){const h=t[n];o[4*n]=h.start.line+1,o[4*n+1]=h.start.character+1,o[4*n+2]=h.end.line+1,o[4*n+3]=h.end.character+1}return m.$trySetDecorationsFast(u,p.key,o)}}))},revealRange(p,t){f._runOnProxy(()=>m.$tryRevealRange(u,k.Range.from(p),t||T.TextEditorRevealType.Default))},show(p){m.$tryShowEditor(u,k.ViewColumn.from(p))},hide(){m.$tryHideEditor(u)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,g.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,g.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,g.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,g.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(k.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const m=u.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const c=m.edits.map(_=>_.range);c.sort((_,b)=>_.end.line===b.end.line?_.end.character===b.end.character?_.start.line===b.start.line?_.start.character-b.start.character:_.start.line-b.start.line:_.end.character-b.end.character:_.end.line-b.end.line);for(let _=0,b=c.length-1;_<b;_++){const P=c[_].end;if(c[_+1].start.isBefore(P))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=m.edits.map(_=>({range:k.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,v,{setEndOfLine:typeof m.setEndOfLine=="number"?k.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=i}),define(ve[221],we([0,1,168,23,2,3,6,208,17,7,14,20,15,21,205]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(P,l){if((0,i.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let f;return Array.isArray(P.highlights)&&(f=P.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),f=f.length?f:void 0),{label:P.label,highlights:f}}}class _{constructor(l,f,p){this._proxy=l,this.commands=f,this.logService=p,this.treeViews=new Map;function t(s){return s&&s.$treeViewId&&s.$treeItemHandle}f.registerArgumentProcessor({processArgument:s=>t(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(o=>t(o)?this.convertArgument(o):o):s})}registerTreeDataProvider(l,f,p){const t=this.createTreeView(l,{treeDataProvider:f},p);return{dispose:()=>t.dispose()}}createTreeView(l,f,p){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=f.dragAndDropController!==void 0,s=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:t}),o=this.createExtHostTreeView(l,f,p);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(n){o.message=n},get title(){return o.title},set title(n){o.title=n},get description(){return o.description},set description(n){o.description=n},reveal:(n,a)=>o.reveal(n,a),dispose:async()=>{await s,this.treeViews.delete(l),o.dispose()}}}$getChildren(l,f){const p=this.treeViews.get(l);return p?p.getChildren(f):Promise.reject(new Error((0,g.localize)(0,null,l)))}async $onDrop(l,f,p){const t=this.treeViews.get(l);if(!t)return Promise.reject(new Error((0,g.localize)(1,null,l)));const s=c.TreeDataTransferConverter.toITreeDataTransfer(f);if(s.items.has(y.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await s.items.get(y.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(a=>t.getExtensionElement(a)).filter(a=>!!a);n.length>0?s.items.set(y.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):s.items.delete(y.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(s,p)}async $hasResolve(l){const f=this.treeViews.get(l);if(!f)throw new Error((0,g.localize)(2,null,l));return f.hasResolve}$resolve(l,f,p){const t=this.treeViews.get(l);if(!t)throw new Error((0,g.localize)(3,null,l));return t.resolveTreeItem(f,p)}$setExpanded(l,f,p){const t=this.treeViews.get(l);if(!t)throw new Error((0,g.localize)(4,null,l));t.setExpanded(f,p)}$setSelection(l,f){const p=this.treeViews.get(l);if(!p)throw new Error((0,g.localize)(5,null,l));p.setSelection(f)}$setVisible(l,f){const p=this.treeViews.get(l);if(!p)throw new Error((0,g.localize)(6,null,l));p.setVisible(f)}createExtHostTreeView(l,f,p){const t=new b(l,f,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(l,t),t}convertArgument(l){const f=this.treeViews.get(l.$treeViewId);return f?f.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=_;class b extends T.Disposable{constructor(l,f,p,t,s,o){super();if(this.viewId=l,this.proxy=p,this.commands=t,this.logService=s,this.extension=o,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new k.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new k.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new k.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new k.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new k.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,o.contributes&&o.contributes.views)for(const h in o.contributes.views)for(const d of o.contributes.views[h])d.id===l&&(this._title=d.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let n,a;this._register(k.Event.debounce(this._onDidChangeData.event,(h,d)=>(h||(h={message:!1,elements:[]}),d.element!==!1&&(n||(n=new Promise(w=>a=w),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(d.element)?h.elements.push(...d.element):h.elements.push(d.element)),d.message&&(h.message=!0),h),200,!0)(({message:h,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=a;return n=null,this.refresh(d).then(()=>w())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,i.isUndefinedOrNull)(l))}getChildren(l){const f=l?this.getExtensionElement(l):void 0;if(l&&!f)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);const p=this.getChildrenNodes(l);return(p?Promise.resolve(p):this.fetchChildrenNodes(f)).then(t=>t.map(s=>s.item))}getExtensionElement(l){return this.elements.get(l)}reveal(l,f){f=f||{select:!0,focus:!1};const p=(0,i.isUndefinedOrNull)(f.select)?!0:f.select,t=(0,i.isUndefinedOrNull)(f.focus)?!1:f.focus,s=(0,i.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(o=>this.resolveTreeNode(l,o[o.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:o.map(a=>a.item)},{select:p,focus:t,expand:s})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:s})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,f){const p=this.getExtensionElement(l);p&&(f?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(l){(0,I.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(l,f){const p=this.getExtensionElement(f);if(!!p)return(0,S.asPromise)(()=>this.dndController?.onDrop(l,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,f){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(l);if(p){const t=this.nodes.get(p);if(t){const s=await this.dataProvider.resolveTreeItem(t.extensionItem,p,f)??t.extensionItem;return t.item.tooltip=this.getTooltip(s.tooltip),t.item.command=this.getCommand(t.disposableStore,s.command),t.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(f=>f?this.resolveUnknownParentChain(f).then(p=>this.resolveTreeNode(f,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(l){const f=this.nodes.get(l);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,f){const p=this.nodes.get(l);return p?Promise.resolve(p):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(t=>this.createHandle(l,t,f,!0)).then(t=>this.getChildren(f?f.item.handle:void 0).then(()=>{const s=this.getExtensionElement(t);if(s){const o=this.nodes.get(s);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(l){if(l){let f;if(typeof l=="string"){const p=this.getExtensionElement(l);f=p?this.nodes.get(p):void 0}else f=l;return f&&f.children||null}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const f=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=l?this.nodes.get(l):void 0,t=await this.dataProvider.getChildren(l);if(f.token.isCancellationRequested)return[];const s=await Promise.all((0,I.coalesce)(t||[]).map(async o=>{const n=await this.dataProvider.getTreeItem(o);return n&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(o,n,p):null}));return f.token.isCancellationRequested?[]:(0,I.coalesce)(s)}finally{f.dispose()}}refresh(l){if(l.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(l);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const f=new Set,p=l.map(s=>this.nodes.get(s));for(const s of p)if(s&&!f.has(s.item.handle)){let o=s;for(;o&&o.parent&&p.findIndex(n=>o&&o.parent&&n&&n.item.handle===o.parent.item.handle)===-1;){const n=this.elements.get(o.parent.item.handle);o=n?this.nodes.get(n):void 0}o&&!o.parent&&f.add(s.item.handle)}const t=[];return f.forEach(s=>{const o=this.elements.get(s);if(o){const n=this.nodes.get(o);n&&(!n.parent||!f.has(n.parent.item.handle))&&t.push(s)}}),t}refreshHandles(l){const f={};return Promise.all(l.map(p=>this.refreshNode(p).then(t=>{t&&(f[p]=t.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(l){const f=this.getExtensionElement(l);if(f){const p=this.nodes.get(f);if(p)return this.clearChildren(f),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(t=>{if(t){const s=this.createTreeNode(f,t,p.parent);return this.updateNodeCache(f,s,p,p.parent),p.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,f,p){const t=this.createTreeNode(l,f,p);if(f.id&&this.elements.has(t.item.handle))throw new Error((0,g.localize)(7,null,f.id));return this.addNodeToCache(l,t),this.addNodeToParentCache(t,p),t}getTooltip(l){return A.MarkdownString.isMarkdownString(l)?u.MarkdownString.from(l):l}getCommand(l,f){return f?this.commands.toInternal(f,l):void 0}createTreeNode(l,f,p){const t=new T.DisposableStore,s=this.createHandle(l,f,p),o=this.getLightIconPath(f);return{item:{handle:s,parentHandle:p?p.item.handle:void 0,label:v(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(t,f.command),contextValue:f.contextValue,icon:o,iconDark:this.getDarkIconPath(f)||o,themeIcon:this.getThemeIcon(f),collapsibleState:(0,i.isUndefinedOrNull)(f.collapsibleState)?A.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(l){return l.iconPath instanceof A.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:f,label:p,resourceUri:t},s,o){if(f)return`${b.ID_HANDLE_PREFIX}/${f}`;const n=v(p,this.extension),a=s?s.item.handle:b.LABEL_HANDLE_PREFIX;let h=n?n.label:t?(0,L.basename)(t):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const d=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,w=this.getChildrenNodes(s)||[];let E,r=0;do{if(E=`${a}/${r}:${h}`,o||!this.elements.has(E)||d===E)break;r++}while(r<=w.length);return E}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof A.ThemeIcon))return typeof l.iconPath=="string"||C.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof A.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return C.URI.isUri(l)?l:C.URI.file(l)}addNodeToCache(l,f){this.elements.set(f.item.handle,l),this.nodes.set(l,f)}updateNodeCache(l,f,p,t){this.elements.delete(f.item.handle),this.nodes.delete(l),f.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(l,f);const s=this.getChildrenNodes(t)||[],o=s.filter(n=>n.item.handle===p.item.handle)[0];o&&s.splice(s.indexOf(o),1,f)}addNodeToParentCache(l,f){f?(f.children||(f.children=[]),f.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const f=this.nodes.get(l);if(f){if(f.children)for(const p of f.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}f.children=void 0}}else this.clearAll()}clear(l){const f=this.nodes.get(l);if(f){if(f.children)for(const p of f.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(l),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}b.LABEL_HANDLE_PREFIX="0",b.ID_HANDLE_PREFIX="1"}),define(ve[222],we([0,1,17,3,6,14,87,15,126,89]),function(J,e,g,L,C,k,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends C.Disposable{constructor(u){super();this.controllerId=u,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(u){this._resolveHandler=u;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const u=this.diff;return this.diff=[],u}*tags(){const u=new Set;for(const m of this.tree.values())for(const c of m.actual.tags)u.has(c.id)||(u.add(c.id),yield c)}pushDiff(u){const m=this.diff[this.diff.length-1];if(m&&u[0]===1){if(m[0]===1&&m[1].extId===u[1].extId){(0,S.applyTestItemUpdate)(m[1],u[1]);return}if(m[0]===0&&m[1].item.extId===u[1].extId){(0,S.applyTestItemUpdate)(m[1],u[1]);return}}this.diff.push(u),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(u,m){const c=this.tree.get(u);if(!!c){if((c.expandLevels===void 0||m>c.expandLevels)&&(c.expandLevels=m),c.expand===1){const v=this.resolveChildren(c);return v.isOpen()?this.expandChildren(c,m-1):v.wait().then(()=>this.expandChildren(c,m-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,m-1)):this.expandChildren(c,m-1)}}dispose(){for(const u of this.tree.values())(0,T.getPrivateApiFor)(u.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(u,m){switch(m.op){case 2:this.pushDiff([4,u.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(u.fullId,m.id));break;case 0:this.upsertItem(m.item,u);break;case 4:for(const b of m.ops)this.onTestItemEvent(u,b);break;case 3:const{key:c,value:v}=m,_=u.fullId.toString();switch(c){case"canResolveChildren":this.updateExpandability(u);break;case"tags":this.pushDiff([1,{extId:_,item:{tags:v.map(b=>b.id)}}]);break;case"range":this.pushDiff([1,{extId:_,item:{range:y.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:y.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[c]:v??null}}]);break}break;default:(0,k.assertNever)(m)}}upsertItem(u,m){if(!(u instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${u.id} did not`);const c=A.TestId.fromExtHostTestItem(u,this.root.id,m?.actual),v=(0,T.getPrivateApiFor)(u);v.parent&&v.parent!==m?.actual&&v.parent.children.delete(u.id);let _=this.tree.get(c.toString());if(!_){_={fullId:c,actual:u,parent:m?c.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},this.tree.set(_.fullId.toString(),_),this.setItemParent(u,m),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:y.TestItem.from(u)}]),this.connectItemAndChildren(u,_,m);return}if(_.actual===u){this.connectItem(u,_,m);return}const b=_.actual.children,P=_.actual,l=(0,T.diffTestItems)(P,u);(0,T.getPrivateApiFor)(P).listener=void 0,_.actual=u,_.expand=0;for(const[f,p]of l)this.onTestItemEvent(_,{op:3,key:f,value:p});this.connectItemAndChildren(u,_,m);for(const f of b)u.children.get(f.id)||this.removeItem(A.TestId.joinToString(c,f.id))}setItemParent(u,m){(0,T.getPrivateApiFor)(u).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(u,m,c){this.setItemParent(u,c);const v=(0,T.getPrivateApiFor)(u);v.parent=c?.actual,v.listener=_=>this.onTestItemEvent(m,_),this.updateExpandability(m)}connectItemAndChildren(u,m,c){this.connectItem(u,m,c);for(const v of u.children)this.upsertItem(v,m)}updateExpandability(u){let m;this._resolveHandler?u.resolveBarrier?m=u.resolveBarrier.isOpen()?3:2:m=u.actual.canResolveChildren?1:0:m=0,m!==u.expand&&(u.expand=m,this.pushDiff([1,{extId:u.fullId.toString(),expand:m}]),m===1&&u.expandLevels!==void 0&&this.resolveChildren(u))}expandChildren(u,m){if(m<0)return;const c=[];for(const v of u.actual.children){const _=this.expand(A.TestId.joinToString(u.fullId,v.id),m);(0,g.isThenable)(_)&&c.push(_)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this._resolveHandler){const _=new g.Barrier;return _.open(),_}u.expand=2,this.pushExpandStateUpdate(u);const m=u.resolveBarrier=new g.Barrier,c=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),u.actual!==this.root&&(u.actual.error=_.stack||_.message||String(_))};let v;try{v=this._resolveHandler(u.actual===this.root?void 0:u.actual)}catch(_){c(_)}return(0,g.isThenable)(v)?v.catch(c).then(()=>{m.open(),this.updateExpandability(u)}):(m.open(),this.updateExpandability(u)),u.resolveBarrier}pushExpandStateUpdate(u){this.pushDiff([1,{extId:u.fullId.toString(),expand:u.expand}])}removeItem(u){const m=this.tree.get(u);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,u]);const c=[m];for(;c.length;){const v=c.pop();if(!!v){(0,T.getPrivateApiFor)(v.actual).listener=void 0,this.tree.delete(v.fullId.toString());for(const _ of v.actual.children)c.push(this.tree.get(A.TestId.joinToString(v.fullId,_.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.diffOpEmitter.fire(u)}}e.SingleUseTestCollection=i}),define(ve[223],we([0,1,4,183]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(ve[224],we([0,1,26,3,8]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class k{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=k;class T{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(u=>I.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>I.has(g.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const u=T._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(u.map(m=>m.identifier)),I.length>0){const m=new Set;I.forEach(c=>m.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!m.has(g.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new k(u)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,b){this.addNode(_),this.addNode(b),this._arcs.has(_)?this._arcs.get(_).push(b):this._arcs.set(_,[b])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,b){const P=I.getArcs(_);for(let l=0;l<P.length;l++)if(!b.has(P[l]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let _ of i){const b=g.ExtensionIdentifier.toKey(_.identifier);if(u.set(b,_),_.extensionDependencies)for(let P of _.extensionDependencies){const l=g.ExtensionIdentifier.toKey(P);I.addArc(b,l)}}let m=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>m.add(_));let c=I.getNodes().filter(_=>!m.has(_)),v;do{v=!1;for(let _=0;_<c.length;_++){const b=c[_];I.hasOnlyGoodArcs(b,m)&&(c.splice(_,1),_--,m.add(b),v=!0)}}while(v);return c.map(_=>u.get(_))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=T;var y;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(y||(y={}));function S(A,i){const I=A.isBuiltin?0:A.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==u)return I-u;const m=C.posix.basename(A.extensionLocation.path),c=C.posix.basename(i.extensionLocation.path);return m<c?-1:m>c?1:0}}),define(ve[225],we([0,1,24]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function k(y){const S=g.VSBuffer.alloc(1);switch(y){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=k;function T(y,S){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=T}),define(ve[35],we([0,1,3,2,4,26,185]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new k.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class y{constructor(P){this.dependency=P}}e.MissingExtensionDependency=y;var S;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class A{constructor(P,l,f,p){this.codeLoadingTime=P,this.activateCallTime=l,this.activateResolvedTime=f,this.activationReason=p}}e.ActivationTimes=A;class i{constructor(P,l){this.description=P,this.value=l}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function u(b){b.enableProposedApi||m(b)}e.checkProposedApiEnabled=u;function m(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=m;function c(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=c;function v(b,P){return{identifier:new k.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!P,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=v;class _{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,l){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,l,f,p,t){}_onDidActivateExtensionError(P,l){}_onExtensionRuntimeError(P,l){}_onExtensionHostExit(P){}}e.NullExtensionService=_}),define(ve[226],we([0,1,26,35,12]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class T{constructor(c,v,_,b){this.startup=c,this.codeLoadingTime=v,this.activateCallTime=_,this.activateResolvedTime=b}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class y{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,v){return c===-1||v===-1?-1:v-c}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class S{constructor(c,v,_,b,P,l){this.activationFailed=c,this.activationFailedError=v,this.activationTimes=_,this.module=b,this.exports=P,this.subscriptions=l}}e.ActivatedExtension=S;class A extends S{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class i extends S{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends S{constructor(c){super(!0,c,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let u=class{constructor(c,v,_,b,P){this._logService=P,this._registry=c,this._resolvedExtensionsSet=new Set,v.forEach(l=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,_.forEach(l=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(l),l)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const v=g.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(v)}getActivatedExtension(c){const v=g.ExtensionIdentifier.toKey(c),_=this._activatedExtensions.get(v);if(!_)throw new Error("Extension `"+c.value+"` is not known or not activated");return _}activateByEvent(c,v){if(this._alreadyActivatedEvents[c])return k;const _=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(_.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,v){const _=this._registry.getExtensionDescription(c);if(!_)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:_.identifier,reason:v}])}_handleActivateRequest(c,v,_){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(c.id))){v[g.ExtensionIdentifier.toKey(c.id)]=c;return}const b=this._registry.getExtensionDescription(c.id);if(!b){const f=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,f,new L.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(c.id),new I(f));return}const P=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let l=!0;for(let f=0,p=P.length;f<p;f++){const t=P[f];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const h=b.displayName||b.identifier.value,d=this._registry.getExtensionDescription(t),w=d&&d.displayName||t,E=new Error(`Cannot activate the '${h}' extension because its dependency '${w}' failed to activate`);E.detail=s.activationFailedError,this._host.onExtensionActivationError(b.identifier,E,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new I(E));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){l=!1,v[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const o=this._registry.getExtensionDescription(t);if(o){l=!1,v[g.ExtensionIdentifier.toKey(t)]={id:o.identifier,reason:c.reason};continue}const n=b.displayName||b.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,a,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new I(a));return}l?v[g.ExtensionIdentifier.toKey(b.identifier)]=c:_.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(P=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(P.id))),c.length===0))return Promise.resolve(void 0);const v=Object.create(null),_=[];for(let P=0,l=c.length;P<l;P++)this._handleActivateRequest(c[P],v,_);for(let P=0,l=_.length;P<l;P++){const f=g.ExtensionIdentifier.toKey(_[P].id);v[f]&&delete v[f]}const b=Object.keys(v).map(P=>v[P]);return _.length===0?Promise.all(b.map(P=>this._activateExtension(P.id,P.reason))).then(P=>{}):this._activateExtensions(b).then(P=>this._activateExtensions(_))}_activateExtension(c,v){const _=g.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const b=this._activatingExtensions.get(_);if(b)return b;const P=this._host.actualActivateExtension(c,v).then(void 0,l=>{const f=new Error;return l&&l.name&&(f.name=l.name),l&&l.message?f.message=`Activating extension '${c.value}' failed: ${l.message}.`:f.message=`Activating extension '${c.value}' failed: ${l}.`,l&&l.stack&&(f.stack=l.stack),this._host.onExtensionActivationError(c,f,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(l),new I(l)}).then(l=>{this._activatedExtensions.set(_,l),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,P),P}};u=We([xe(4,C.ILogService)],u),e.ExtensionsActivator=u}),define(ve[227],we([0,1,12,35,27,10,115]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends g.LogService{constructor(A){if(A.logFile.scheme!==k.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(L.ExtensionHostLogFileName,A.logFile.fsPath,!0,A.logLevel))}$setLevel(A){this.setLevel(A)}};y=We([xe(0,C.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(ve[228],we([0,1,16]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((k,T)=>{this._actualOk=k,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(k){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=k,this._actual&&this._actualOk(k))}resolveErr(k){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=k,this._actual?this._actualErr(k):(0,g.onUnexpectedError)(k))}then(k,T){return this._ensureActual().then(k,T)}catch(k){return this._ensureActual().then(void 0,k)}finally(k){return this._ensureActual().finally(k)}}e.LazyPromise=L}),define(ve[130],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(S,A){this._proxyIdentifierBrand=void 0,this.isMain=S,this.sid=A,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function C(y){const S=new g(!0,y);return L[S.nid]=S,S}e.createMainContextProxyIdentifier=C;function k(y){const S=new g(!1,y);return L[S.nid]=S,S}e.createExtHostContextProxyIdentifier=k;function T(y){return L[y].sid}e.getStringIdentifierForProxy=T}),define(ve[5],we([0,1,59,2,130]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var k;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var T;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(l){l.name="$ident";function f(t,s){return Object.defineProperty(t,l.name,{value:s,enumerable:!0}),t}l.mixin=f;function p(t){return t[l.name]}l.of=p})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(f){return f._id=m._n++,f}}e.IdObject=m,m._n=0;var c;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(l){if(l&&l.edits)for(const f of l.edits)typeof f.resource=="object"?f.resource=L.URI.revive(f.resource):(f.newUri=L.URI.revive(f.newUri),f.oldUri=L.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,g.revive)(f.metadata));return l}e.reviveWorkspaceEditDto=b;var P;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(P=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,C.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[90],we([0,1,5,3,4]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class k{constructor(y){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,S){return this._proxy.$getPassword(y,S)}store(y,S,A){return this._proxy.$setPassword(y,S,A)}delete(y,S){return this._proxy.$deletePassword(y,S)}}e.ExtHostSecretState=k,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(ve[65],we([0,1,4,12,5,13]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(S,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(C.MainContext.MainThreadTelemetry)}report(S,A,i){const I=this.getUsageKey(S,A);this._reportedUsages.has(I)||(this._reportedUsages.add(I),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:S}))}getUsageKey(S,A){return`${S}-${A.identifier.value}`}};T=We([xe(0,k.IExtHostRpcService),xe(1,L.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(y,S,A){}})}),define(ve[229],we([0,1,3,5,7,26]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,A,i,I={}){const u=k.ExtensionIdentifier.toKey(S.identifier),m=this._inFlightRequests.get(u)||[],c=[...i].sort().join(" ");let v=m.find(_=>_.scopes===c);if(v)return v.result;{const _=this._getSession(S,u,A,i,I);v={scopes:c,result:_},m.push(v),this._inFlightRequests.set(u,m);try{await _}finally{const b=m.findIndex(P=>P.scopes===c);b>-1&&(m.splice(b),this._inFlightRequests.set(u,m))}return _}}async _getSession(S,A,i,I,u={}){await this._proxy.$ensureProvider(i);const m=S.displayName||S.name;return this._proxy.$getSession(i,I,A,m,u)}async removeSession(S,A){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(A):this._proxy.$removeSession(S,A)}registerAuthenticationProvider(S,A,i,I){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:A,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===S)||this._providers.push({id:S,label:A});const u=i.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(S,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,A,I?.supportsMultipleAccounts??!1),new C.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(S);const m=this._providers.findIndex(c=>c.id===S);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,A){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,A){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,A){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,A){return this._onDidChangeSessions.fire({provider:{id:S,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(ve[230],we([0,1,5,13,15]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let k=class{constructor(y,S){this._extHostDocumentsAndEditors=S,this._proxy=y.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const S=C.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};k=We([xe(0,L.IExtHostRpcService)],k),e.ExtHostBulkEdits=k}),define(ve[231],we([0,1,5]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(k){const T=k.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(y){return T.$writeText(y)}})}}e.ExtHostClipboard=L}),define(ve[44],we([0,1,14,7,15,25,5,20,12,59,41,50,2,6,4,13]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=s,this.converter=new b(this,o=>{const n=this._apiCommands.get(o);return n?.result===l.Void?n:void 0},s),this._argumentProcessors=[{processArgument(o){return(0,A.revive)(o)}},{processArgument(o){return(0,k.cloneAndChange)(o,function(n){if(i.Range.isIRange(n))return C.Range.to(n);if(I.Position.isIPosition(n))return C.Position.to(n);if(i.Range.isIRange(n.range)&&u.URI.isUri(n.uri))return C.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...o)=>{const n=t.args.map((h,d)=>{if(!h.validate(o[d]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${o[d]}`);return h.convert(o[d])}),a=await this.executeCommand(t.internalId,...n);return t.result.convert(a,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new L.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,o,n,a){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:o,thisArg:n,description:a}),t&&this._proxy.$registerCommand(s),new L.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,o){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const n=(0,k.cloneAndChange)(s,function(a){if(a instanceof L.Position)return C.Position.from(a);if(a instanceof L.Range)return C.Range.from(a);if(a instanceof L.Location)return C.location.from(a);if(L.NotebookRange.isNotebookRange(a))return C.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,n,o);return(0,A.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw a}}}async _executeContributedCommand(t,s){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:n,thisArg:a,description:h}=o;if(h)for(let d=0;d<h.args.length;d++)try{(0,g.validateConstraint)(s[d],h.args[d].constraint)}catch(w){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[d].name}' - ${h.args[d].description}`)}try{return await n.apply(a,s)}catch(d){if(t===this.converter.delegatingCommandId){const w=this.converter.getActualCommand(...s);w&&(t=w.command)}throw this._logService.error(d,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(o=>this._argumentProcessors.reduce((n,a)=>a.processArgument(n),o)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(o=>o[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,o]of this._commands){let{description:n}=o;n&&(t[s]=n)}return Promise.resolve(t)}};_=We([xe(0,v.IExtHostRpcService),xe(1,S.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class b{constructor(t,s,o){this._commands=t,this._lookupApiCommand=s,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const n=this._lookupApiCommand(t.command);if(n)o.id=n.internalId,o.arguments=n.args.map((a,h)=>a.convert(t.arguments&&t.arguments[h]));else if((0,y.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),s.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),o.$ident=a,o.id=this.delegatingCommandId,o.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return o}fromInternal(t){const s=T.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class P{constructor(t,s,o,n){this.name=t,this.description=s,this.validate=o,this.convert=n}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new P(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",p=>u.URI.isUri(p),p=>p),P.Position=new P("position","A position in a text document",p=>L.Position.isPosition(p),C.Position.from),P.Range=new P("range","A range in a text document",p=>L.Range.isRange(p),C.Range.from),P.Selection=new P("selection","A selection in a text document",p=>L.Selection.isSelection(p),C.Selection.from),P.Number=new P("number","",p=>typeof p=="number",p=>p),P.String=new P("string","",p=>typeof p=="string",p=>p),P.CallHierarchyItem=new P("item","A call hierarchy item",p=>p instanceof L.CallHierarchyItem,C.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",p=>p instanceof L.TypeHierarchyItem,C.TypeHierarchyItem.from);class l{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=l,l.Void=new l("no result",p=>p);class f{constructor(t,s,o,n,a){this.id=t,this.internalId=s,this.description=o,this.args=n,this.result=a}}e.ApiCommand=f}),define(ve[232],we([0,1,15,7,82,44,20,110]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new k.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new k.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,m)=>{if((0,T.isFalsyOrEmpty)(u))return;class c extends L.SymbolInformation{static to(_){const b=new c(_.name,g.SymbolKind.to(_.kind),_.containerName||"",new L.Location(m[0],g.Range.to(_.range)));return b.detail=_.detail,b.range=b.location.range,b.selectionRange=g.Range.to(_.selectionRange),b.children=_.children?_.children.map(c.to):[],b}}return u.map(c.to)})),new k.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new k.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range,new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new k.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,new k.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new k.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new k.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new k.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new k.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new k.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new k.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new k.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new k.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(m=>L.Position.isPosition(m)),u=>u.map(g.Position.from))],new k.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(m=>{let c;for(const v of m.reverse())c=new L.SelectionRange(g.Range.to(v),c);return c}))),new k.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[k.ApiCommandArgument.String.with("query","Search string")],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const m=[];if(Array.isArray(u))for(let c of u)m.push(...c[1].map(g.WorkspaceSymbol.to));return m})),new k.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyItem.to))),new k.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyIncomingCall.to))),new k.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyOutgoingCall.to))),new k.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("newName","The new symbol name")],new k.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return g.WorkspaceEdit.to(u)}})),new k.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new k.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(g.DocumentLink.to))),new k.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,y.decodeSemanticTokensDto)(u);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new L.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,y.decodeSemanticTokensDto)(u);if(m.type==="full")return new L.SemanticTokens(m.data,void 0)})),new k.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new k.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,m,c)=>{if(!u)return new L.CompletionList([]);const v=u.suggestions.map(_=>g.CompletionItem.to(_,c));return new L.CompletionList(v,u.incomplete)})),new k.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new k.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return g.SignatureHelp.to(u)})),new k.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new k.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,m,c)=>i(v=>new L.CodeLens(g.Range.to(v.range),v.command&&c.fromInternal(v.command)))(u))),new k.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>L.Range.isRange(u),u=>L.Selection.isSelection(u)?g.Selection.from(u):g.Range.from(u)),k.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new k.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,m,c)=>i(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(v.command)}else{const _=new L.CodeAction(v.title,v.kind?new L.CodeActionKind(v.kind):void 0);return v.edit&&(_.edit=g.WorkspaceEdit.to(v.edit)),v.command&&(_.command=c.fromInternal(v.command)),_.isPreferred=v.isPreferred,_}})(u))),new k.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new L.ColorInformation(g.Range.to(m.range),g.Color.to(m.color))):[])),new k.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new k.ApiCommandArgument("color","The color to show and insert",u=>u instanceof L.Color,g.Color.from),new k.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:g.Range.from(u.range)}))],new k.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(g.ColorPresentation.to):[])),new k.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(g.InlayHint.to))),new k.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new k.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(m=>g.NotebookExclusiveDocumentPattern.to(m))})))),new k.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(g.InlineValue.to))),new k.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)])).optional(),k.ApiCommandArgument.String.with("label","").optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[k.ApiCommandArgument.Uri.with("resource","Resource to open"),k.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)])).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[k.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),k.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),k.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)]).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A TypeHierarchyItem or undefined",u=>u.map(g.TypeHierarchyItem.to)))];class A{static register(m){S.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=A;function i(u){return m=>{if(Array.isArray(m))return m.map(u)}}function I(u){if(!Array.isArray(u))return;const m=[];for(const c of u)C.isLocationLink(c)?m.push(g.DefinitionLink.to(c)):m.push(g.location.to(c));return m}}),define(ve[233],we([0,1,17,56,3,6,2,82,26,15,7,5]),function(J,e,g,L,C,k,T,y,S,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(m,c,v){const _=m.getProxy(I.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const h=a.getCommentThread(n.commentThreadHandle);return h||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const h=a.getCommentThread(n.thread.commentThreadHandle);return h?{thread:h,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const h=a.getCommentThread(n.thread.commentThreadHandle);if(!h)return n;let d=n.commentUniqueId,w=h.getCommentByUniqueId(d);return w||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const h=a.getCommentThread(n.thread.commentThreadHandle);if(!h)return n;let d=n.text,w=n.commentUniqueId,E=h.getCommentByUniqueId(w);return E?(E.body=d,E):n}return n}})}createCommentController(n,a,h){const d=b.handlePool++,w=new l(n,d,a,h);this._commentControllers.set(w.handle,w);const E=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(n.identifier))||[];return E.push(w),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(n.identifier),E),w.value}$createCommentThreadTemplate(n,a,h){const d=this._commentControllers.get(n);!d||d.$createCommentThreadTemplate(a,h)}async $updateCommentThreadTemplate(n,a,h){const d=this._commentControllers.get(n);!d||d.$updateCommentThreadTemplate(a,h)}$deleteCommentThread(n,a){const h=this._commentControllers.get(n);h&&h.$deleteCommentThread(a)}$provideCommentingRanges(n,a,h){const d=this._commentControllers.get(n);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(T.URI.revive(a));return(0,g.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(w,h)).then(E=>E?E.map(r=>A.Range.from(r)):void 0)}$toggleReaction(n,a,h,d,w){const E=this._commentControllers.get(n);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const r=E.getCommentThread(a);if(r){const D=r.getCommentByUniqueId(d.uniqueIdInThread);if(E!==void 0&&D&&E.reactionHandler)return E.reactionHandler(D,t(w))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class P{constructor(n,a,h,d,w,E,r){this._commentControllerHandle=a,this._id=h,this._uri=d,this._range=w,this._comments=E,this.handle=P._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputDisposables.value=new k.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),_.$createCommentThread(a,this.handle,this._id,this._uri,A.Range.from(this._range),r),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(a,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(R){D.range=R},get comments(){return D.comments},set comments(R){D.comments=R},get collapsibleState(){return D.collapsibleState},set collapsibleState(R){D.collapsibleState=R},get canReply(){return D.canReply},set canReply(R){D.canReply=R},get contextValue(){return D.contextValue},set contextValue(R){D.contextValue=R},get label(){return D.label},set label(R){D.label=R},dispose:()=>{D.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new k.DisposableStore);const n=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),a={};n("range")&&(a.range=A.Range.from(this._range)),n("label")&&(a.label=this.label),n("contextValue")&&(a.contextValue=this.contextValue),n("comments")&&(a.comments=this._comments.map(h=>f(this,h,this._commentsMap))),n("collapsibleState")&&(a.collapseState=s(this._collapseState)),n("canReply")&&(a.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(n){for(let a of this._commentsMap){let h=a[0],d=a[1];if(n===d)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}P._handlePool=0,We([(0,L.debounce)(100)],P.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(n,a,h,d){this._extension=n,this._handle=a,this._id=h,this._label=d,this._threads=new Map,_.$registerCommentController(this.handle,h,d);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,r,D){return w.createCommentThread(E,r,D).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,a,h,d){if(typeof n=="string"){const w=new P(this.id,this.handle,n,a,h,d,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new P(this.id,this.handle,void 0,n,a,h,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(n,a){const h=new P(this.id,this.handle,void 0,T.URI.revive(n),A.Range.to(a),[],this._extension.identifier);return h.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(n,a){let h=this._threads.get(n);h&&(h.range=A.Range.to(a))}$deleteCommentThread(n){let a=this._threads.get(n);a&&a.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function f(o,n,a){let h=a.get(n);h||(h=++o.commentHandle,a.set(n,h));const d=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:h,body:A.MarkdownString.from(n.body),userName:n.author.name,userIconPath:d,label:n.label,commentReactions:n.reactions?n.reactions.map(w=>p(w)):void 0}}function p(o){return{label:o.label,iconPath:o.iconPath?A.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function t(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?T.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function s(o){if(o!==void 0)switch(o){case i.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}return new b}e.createExtHostComments=u}),define(ve[131],we([0,1,2,5,7,4,13,12,20,9,8]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class bn{constructor(m,c){this._logService=c,this._provider=new Map,this._proxy=m.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,c){const v=bn._handlePool++;this._provider.set(v,{provider:m,extensionId:c}),this._proxy.$registerDecorationProvider(v,c.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(v,null);return}let P=(0,S.asArray)(b);if(P.length<=bn._maxEventSize){this._proxy.$onDidChange(v,P);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,P.length);const l=P.map(t=>({uri:t,rank:(0,A.count)(t.path,"/")})),f=(0,S.groupBy)(l,(t,s)=>t.rank-s.rank||(0,A.compare)(t.uri.path,s.uri.path));let p=[];e:for(let t of f){let s;for(let o of t){let n=(0,i.dirname)(o.uri.path);if(s!==n&&(s=n,p.push(o.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(v,p)});return new C.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(m,c,v){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:b,extensionId:P}=this._provider.get(m);return await Promise.all(c.map(async l=>{try{const{uri:f,id:p}=l,t=await Promise.resolve(b.provideFileDecoration(g.URI.revive(f),v));if(!t)return;try{C.FileDecoration.validate(t),_[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${P.value}': ${s}`)}}catch(f){this._logService.error(f)}})),_}};I._handlePool=0,I._maxEventSize=250,I=We([xe(0,T.IExtHostRpcService),xe(1,y.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,k.createDecorator)("IExtHostDecorations")}),define(ve[234],we([0,1,163,116,2,5,7,15,3,12,22]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,v,_,b,P){this._name=c,this._owner=v,this._maxDiagnosticsPerFile=_,this._proxy=b,this._onDidChangeDiagnostics=P,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,v){if(!c){this.clear();return}this._checkDisposed();let _=[];if(C.URI.isUri(c)){if(!v){this.delete(c);return}this._data.set(c,v.slice()),_=[c]}else if(Array.isArray(c)){_=[];let P;c=[...c].sort(I._compareIndexedTuplesByUri);for(const l of c){const[f,p]=l;if((!P||f.toString()!==P.toString())&&(P&&this._data.get(P).length===0&&this._data.delete(P),P=f,_.push(f),this._data.set(f,[])),p){const t=this._data.get(f);t&&t.push(...p)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const b=[];for(let P of _){let l=[];const f=this._data.get(P);if(f)if(f.length>this._maxDiagnosticsPerFile){l=[];const p=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of f)if(s.severity===p[t]&&l.push(y.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;l.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=f.map(p=>y.Diagnostic.from(p));b.push([P,l])}this._proxy.$changeMany(this._owner,b)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,v){this._checkDisposed();for(let _ of this._data.keys())c.apply(v,[_,this.get(_),this])}get(c){this._checkDisposed();const v=this._data.get(c);return Array.isArray(v)?Object.freeze(v.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,v){return c[0].toString()<v[0].toString()?-1:c[0].toString()>v[0].toString()?1:0}}e.DiagnosticCollection=I;let u=class Qt{constructor(c,v){this._logService=v,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=c.getProxy(k.MainContext.MainThreadDiagnostics)}static _mapper(c){const v=new i.ResourceMap;for(const _ of c)v.set(_,_);return{uris:Object.freeze(Array.from(v.values()))}}createDiagnosticCollection(c,v){const{_collections:_,_proxy:b,_onDidChangeDiagnostics:P,_logService:l}=this,f=new class{$changeMany(s,o){b.$changeMany(s,o),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,s,o.length===0?"CLEARING":o)}$clear(s){b.$clear(s),l.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,s)}dispose(){b.dispose()}};let p;if(!v)v="_generated_diagnostic_collection_name_#"+Qt._idPool++,p=v;else if(!_.has(v))p=v;else{this._logService.warn(`DiagnosticCollection with name '${v}' does already exist.`);do p=v+Qt._idPool++;while(_.has(p))}return new class extends I{constructor(){super(v,p,Qt._maxDiagnosticsPerFile,f,P);_.set(p,this)}dispose(){super.dispose(),_.delete(p)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const v=new Map,_=[];for(const b of this._collections.values())b.forEach((P,l)=>{let f=v.get(P.toString());typeof f=="undefined"&&(f=_.length,v.set(P.toString(),f),_.push([P,[]])),_[f][1]=_[f][1].concat(...l)});return _}}_getDiagnostics(c){let v=[];for(let _ of this._collections.values())_.has(c)&&(v=v.concat(_.get(c)));return v}$acceptMarkersChange(c){if(!this._mirrorCollection){const v="_generated_mirror",_=new I(v,v,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(v,_),this._mirrorCollection=_}for(const[v,_]of c)this._mirrorCollection.set(C.URI.revive(v),_.map(y.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=We([xe(1,A.ILogService)],u),e.ExtHostDiagnostics=u}),define(ve[235],we([0,1,2,5]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(T){this._proxy=T.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(y=>y?y.map(S=>g.URI.revive(S)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(y=>y?g.URI.revive(y):void 0)}}e.ExtHostDialogs=C}),define(ve[236],we([0,1,16,2,7,5,10,21,9]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(I,u,m){this._documentsAndEditors=u,this._logService=m,this._documentContentProviders=new Map,this._proxy=I.getProxy(k.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,u){if(Object.keys(T.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const m=A._handlePool++;this._documentContentProviders.set(m,u),this._proxy.$registerTextContentProvider(m,I);let c;return typeof u.onDidChange=="function"&&(c=u.onDidChange(v=>{if(v.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(m,v).then(_=>{if(!_&&typeof _!="string")return;const b=this._documentsAndEditors.getDocument(v);if(!b)return;const P=(0,S.splitLines)(_);if(!b.equalLines(P))return this._proxy.$onVirtualDocumentChange(v,_)},g.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,u){const m=this._documentContentProviders.get(I);return m?Promise.resolve(m.provideTextDocumentContent(L.URI.revive(u),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(ve[237],we([0,1,3,6,2,5,122,15,14,25,7]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(m,c){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(k.MainContext.MainThreadDocuments),this._documentsAndEditors=c,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const _ of v)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const _ of v)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const c=this._documentsAndEditors.getDocument(m);if(c)return c}getDocument(m){const c=this.getDocumentData(m);if(!c?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return c.document}ensureDocumentData(m){const c=this._documentsAndEditors.getDocument(m);if(c)return Promise.resolve(c);let v=this._documentLoader.get(m.toString());return v||(v=this._proxy.$tryOpenDocument(m).then(_=>{this._documentLoader.delete(m.toString());const b=C.URI.revive(_);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(b))},_=>(this._documentLoader.delete(m.toString()),Promise.reject(_))),this._documentLoader.set(m.toString(),v)),v}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(c=>C.URI.revive(c))}$acceptModelModeChanged(m,c){const v=C.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(c),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(m){const c=C.URI.revive(m),v=this._documentsAndEditors.getDocument(c);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(m,c){const v=C.URI.revive(m),_=this._documentsAndEditors.getDocument(v);if(!_)throw new Error("unknown document");_._acceptIsDirty(c),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,c,v){const _=C.URI.revive(m),b=this._documentsAndEditors.getDocument(_);if(!b)throw new Error("unknown document");b._acceptIsDirty(v),b.onEvents(c);let P;c.isUndoing?P=i.TextDocumentChangeReason.Undo:c.isRedoing&&(P=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:b.document,contentChanges:c.changes.map(l=>({range:y.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:P}))}setWordDefinitionFor(m,c){(0,T.setWordDefinitionFor)(m,c)}}e.ExtHostDocuments=I}),define(ve[45],we([0,1,54,3,6,2,4,5,122,13,129,15,12,22,10,75,139]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let P=class{constructor(f,p){this._extHostRpc=f,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const p=[],t=[],s=[];if(f.removedDocuments)for(const o of f.removedDocuments){const n=k.URI.revive(o),a=this._documents.get(n);a?.unref()&&(this._documents.delete(n),p.push(a.value))}if(f.addedDocuments)for(const o of f.addedDocuments){const n=k.URI.revive(o.uri);let a=this._documents.get(n);if(a&&n.scheme!==c.Schemas.vscodeNotebookCell&&n.scheme!==c.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);a||(a=new b(new S.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),n,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(n,a),t.push(a.value)),a.ref()}if(f.removedEditors)for(const o of f.removedEditors){const n=this._editors.get(o);this._editors.delete(o),n&&s.push(n)}if(f.addedEditors)for(const o of f.addedEditors){const n=k.URI.revive(o.documentUri);g.ok(this._documents.has(n),`document '${n}' does not exist`),g.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const a=this._documents.get(n).value,h=new i.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),o.selections.map(I.Selection.to),o.options,o.visibleRanges.map(d=>I.Range.to(d)),typeof o.editorPosition=="number"?I.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,h)}f.newActiveEditor!==void 0&&(g.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,C.dispose)(p),(0,C.dispose)(s),f.removedDocuments&&this._onDidRemoveDocuments.fire(p),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return f?p:p?.value}allEditors(){return[...this._editors.values()]}};P=We([xe(0,A.IExtHostRpcService),xe(1,u.ILogService)],P),e.ExtHostDocumentsAndEditors=P,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[238],we([0,1,2,5,6,7,15,147,9,24]),function(J,e,g,L,C,k,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const c=this._schemes.indexOf(m);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),c=[];let v,_,b=14,P=14;for(const l of m){let f=v?(0,S.commonPrefixLength)(v,l):0;for(f===0?_=1:_=P;f<l.length;f++)f+1===l.length?(b=P,P=9):P+=1,c.push([_,l.toUpperCase().charCodeAt(f),P]),c.push([_,l.toLowerCase().charCodeAt(f),P]),_=P;v=l,P=b}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new y.StateMachine(c)}}provideDocumentLinks(m){this._initStateMachine();const c=[],v=y.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of v){const b=T.DocumentLink.to(_);b.target&&c.push(b)}return c}}class I{constructor(m,c){this._extHostLanguageFeatures=c,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=m.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,c,v,_={},b){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(P,v),this._enableProposedApi.set(P,b??!1);let l=2;_.isCaseSensitive&&(l+=1024),_.isReadonly&&(l+=2048),typeof v.copy=="function"&&(l+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(P,c,l).catch(p=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${c}`),console.error(p)});const f=v.onDidChangeFile(p=>{const t=[];for(const s of p){let{uri:o,type:n}=s;if(o.scheme!==c)continue;let a;switch(n){case k.FileChangeType.Changed:a=0;break;case k.FileChangeType.Created:a=1;break;case k.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:o,type:a})}this._proxy.$onFileSystemChange(P,t)});return(0,C.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(P),this._enableProposedApi.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(m,c){const{type:v,ctime:_,mtime:b,size:P,permissions:l}=m;return c?{type:v,ctime:_,mtime:b,size:P,permissions:l}:{type:v,ctime:_,mtime:b,size:P}}$stat(m,c){return Promise.resolve(this._getFsProvider(m).stat(g.URI.revive(c))).then(v=>I._asIStat(v,this._enableProposedApi.get(m)??!1))}$readdir(m,c){return Promise.resolve(this._getFsProvider(m).readDirectory(g.URI.revive(c)))}$readFile(m,c){return Promise.resolve(this._getFsProvider(m).readFile(g.URI.revive(c))).then(v=>A.VSBuffer.wrap(v))}$writeFile(m,c,v,_){return Promise.resolve(this._getFsProvider(m).writeFile(g.URI.revive(c),v.buffer,_))}$delete(m,c,v){return Promise.resolve(this._getFsProvider(m).delete(g.URI.revive(c),v))}$rename(m,c,v,_){return Promise.resolve(this._getFsProvider(m).rename(g.URI.revive(c),g.URI.revive(v),_))}$copy(m,c,v,_){const b=this._getFsProvider(m);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(g.URI.revive(c),g.URI.revive(v),_))}$mkdir(m,c){return Promise.resolve(this._getFsProvider(m).createDirectory(g.URI.revive(c)))}$watch(m,c,v,_){const b=this._getFsProvider(m).watch(g.URI.revive(v),_);this._watches.set(c,b)}$unwatch(m,c){const v=this._watches.get(c);v&&(v.dispose(),this._watches.delete(c))}$open(m,c,v){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(g.URI.revive(c),v))}$close(m,c){const v=this._getFsProvider(m);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(c))}$read(m,c,v,_){const b=this._getFsProvider(m);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const P=A.VSBuffer.alloc(_);return Promise.resolve(b.read(c,v,P.buffer,0,_)).then(l=>P.slice(0,l))}$write(m,c,v,_){const b=this._getFsProvider(m);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(c,v,_.buffer,0,_.byteLength))}_getFsProvider(m){const c=this._fsProvider.get(m);if(!c){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return c}}e.ExtHostFileSystem=I}),define(ve[91],we([0,1,5,42,7,24,4,13,63]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class Ut{constructor(I,u){const m=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return m.$stat(c).catch(Ut._handleError)},readDirectory(c){return m.$readdir(c).catch(Ut._handleError)},createDirectory(c){return m.$mkdir(c).catch(Ut._handleError)},async readFile(c){return m.$readFile(c).then(v=>v.buffer).catch(Ut._handleError)},writeFile(c,v){return m.$writeFile(c,k.VSBuffer.wrap(v)).catch(Ut._handleError)},delete(c,v){return m.$delete(c,{recursive:!1,useTrash:!1,...v}).catch(Ut._handleError)},rename(c,v,_){return m.$rename(c,v,{overwrite:!1,..._}).catch(Ut._handleError)},copy(c,v,_){return m.$copy(c,v,{overwrite:!1,..._}).catch(Ut._handleError)},isWritableFileSystem(c){const v=u.getCapabilities(c);if(typeof v=="number")return!(v&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new C.FileSystemError(String(I));if(I.name==="ENOPRO")throw C.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(I.message);default:throw new C.FileSystemError(I.message,I.name)}}};A=We([xe(0,y.IExtHostRpcService),xe(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[239],we([0,1,2,44]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(T,y,S,A){this._extHostNotebooks=y,this._textDocumentsAndEditors=S,this._commands=A;const i=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const u=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:u.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(T,y,S,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:y,lines:[""],modeId:S,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,y){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=C}),define(ve[240],we([0,1,6,5]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(T){this._handlePool=0,this._proxy=T.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,T),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=C}),define(ve[241],we([0,1,2,25,15,7,5,9,41,20,14,144,6,110,74,86,46,16,3]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentSymbols(W,Z){const ie=this._documents.getDocument(W),le=await this._provider.provideDocumentSymbols(ie,Z);if(!(0,A.isFalsyOrEmpty)(le))return le[0]instanceof k.DocumentSymbol?le.map(C.DocumentSymbol.from):l._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(W){W=W.slice(0).sort((le,Y)=>{let ae=le.location.range.start.compareTo(Y.location.range.start);return ae===0&&(ae=Y.location.range.end.compareTo(le.location.range.end)),ae});const Z=[],ie=[];for(const le of W){const Y={name:le.name||"!!MISSING: name!!",kind:C.SymbolKind.from(le.kind),tags:le.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:C.Range.from(le.location.range),selectionRange:C.Range.from(le.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Y),Z.push(Y);break}const ae=ie[ie.length-1];if(S.Range.containsRange(ae.range,Y.range)&&!S.Range.equalsRange(ae.range,Y.range)){ae.children&&ae.children.push(Y),ie.push(Y);break}ie.pop()}}return Z}}class f{constructor(W,Z,ie){this._documents=W,this._commands=Z,this._provider=ie,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,Z){const ie=this._documents.getDocument(W),le=await this._provider.provideCodeLenses(ie,Z);if(!le||Z.isCancellationRequested)return;const Y=this._cache.add(le),ae=new u.DisposableStore;this._disposables.set(Y,ae);const be={cacheId:Y,lenses:[]};for(let Fe=0;Fe<le.length;Fe++)be.lenses.push({cacheId:[Y,Fe],range:C.Range.from(le[Fe].range),command:this._commands.toInternal(le[Fe].command,ae)});return be}async resolveCodeLens(W,Z){const ie=W.cacheId&&this._cache.get(...W.cacheId);if(!ie)return;let le;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?le=ie:le=await this._provider.resolveCodeLens(ie,Z),le||(le=ie),Z.isCancellationRequested)return;const Y=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!Y)return W.command=this._commands.toInternal(le.command??f._badCmd,Y),W}releaseCodeLenses(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(Ve){return Array.isArray(Ve)?Ve.map(C.DefinitionLink.from):Ve?[C.DefinitionLink.from(Ve)]:[]}class t{constructor(W,Z){this._documents=W,this._provider=Z}async provideDefinition(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.provideDefinition(le,Y,ie);return p(ae)}}class s{constructor(W,Z){this._documents=W,this._provider=Z}async provideDeclaration(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.provideDeclaration(le,Y,ie);return p(ae)}}class o{constructor(W,Z){this._documents=W,this._provider=Z}async provideImplementation(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.provideImplementation(le,Y,ie);return p(ae)}}class n{constructor(W,Z){this._documents=W,this._provider=Z}async provideTypeDefinition(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.provideTypeDefinition(le,Y,ie);return p(ae)}}class a{constructor(W,Z){this._documents=W,this._provider=Z}async provideHover(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.provideHover(le,Y,ie);if(!(!ae||(0,A.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(Y)),ae.range||(ae.range=new k.Range(Y,Y)),C.Hover.from(ae)}}class h{constructor(W,Z){this._documents=W,this._provider=Z}async provideEvaluatableExpression(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.provideEvaluatableExpression(le,Y,ie);if(ae)return C.EvaluatableExpression.from(ae)}}class d{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlineValues(W,Z,ie,le){const Y=this._documents.getDocument(W),ae=await this._provider.provideInlineValues(Y,C.Range.to(Z),C.InlineValueContext.to(ie),le);if(Array.isArray(ae))return ae.map(be=>C.InlineValue.from(be))}}class w{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentHighlights(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.provideDocumentHighlights(le,Y,ie);if(Array.isArray(ae))return ae.map(C.DocumentHighlight.from)}}class E{constructor(W,Z){this._documents=W,this._provider=Z}async provideLinkedEditingRanges(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.provideLinkedEditingRanges(le,Y,ie);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,A.coalesce)(ae.ranges.map(C.Range.from)),wordPattern:ae.wordPattern}}}class r{constructor(W,Z){this._documents=W,this._provider=Z}async provideReferences(W,Z,ie,le){const Y=this._documents.getDocument(W),ae=C.Position.to(Z),be=await this._provider.provideReferences(Y,ae,ie,le);if(Array.isArray(be))return be.map(C.location.from)}}class D{constructor(W,Z,ie,le,Y,ae,be){this._documents=W,this._commands=Z,this._diagnostics=ie,this._provider=le,this._logService=Y,this._extension=ae,this._apiDeprecation=be,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(W,Z,ie,le){const Y=this._documents.getDocument(W),ae=I.Selection.isISelection(Z)?C.Selection.to(Z):C.Range.to(Z),be=[];for(const se of this._diagnostics.getDiagnostics(W))if(ae.intersection(se.range)&&be.push(se)>D._maxCodeActionsPerFile)break;const Fe={diagnostics:be,only:ie.only?new k.CodeActionKind(ie.only):void 0,triggerKind:C.CodeActionTriggerKind.to(ie.trigger)},He=await this._provider.provideCodeActions(Y,ae,Fe,le);if(!(0,A.isNonEmptyArray)(He)||le.isCancellationRequested)return;const Ee=this._cache.add(He),Qe=new u.DisposableStore;this._disposables.set(Ee,Qe);const X=[];for(let se=0;se<He.length;se++){const pe=He[se];!pe||(D._isCommand(pe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),X.push({_isSynthetic:!0,title:pe.title,command:this._commands.toInternal(pe,Qe)})):(Fe.only&&(pe.kind?Fe.only.contains(pe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action is of kind '${pe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),X.push({cacheId:[Ee,se],title:pe.title,command:pe.command&&this._commands.toInternal(pe.command,Qe),diagnostics:pe.diagnostics&&pe.diagnostics.map(C.Diagnostic.from),edit:pe.edit&&C.WorkspaceEdit.from(pe.edit),kind:pe.kind&&pe.kind.value,isPreferred:pe.isPreferred,disabled:pe.disabled?.reason})))}return{cacheId:Ee,actions:X}}async resolveCodeAction(W,Z){const[ie,le]=W,Y=this._cache.get(ie,le);if(!Y||D._isCommand(Y)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Y,Z)??Y;return ae?.edit?C.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}D._maxCodeActionsPerFile=1e3;class R{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentFormattingEdits(W,Z,ie){const le=this._documents.getDocument(W),Y=await this._provider.provideDocumentFormattingEdits(le,Z,ie);if(Array.isArray(Y))return Y.map(C.TextEdit.from)}}class x{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeFormattingEdits(W,Z,ie,le){const Y=this._documents.getDocument(W),ae=C.Range.to(Z),be=await this._provider.provideDocumentRangeFormattingEdits(Y,ae,ie,le);if(Array.isArray(be))return be.map(C.TextEdit.from)}}class j{constructor(W,Z){this._documents=W,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,Z,ie,le,Y){const ae=this._documents.getDocument(W),be=C.Position.to(Z),Fe=await this._provider.provideOnTypeFormattingEdits(ae,be,ie,le,Y);if(Array.isArray(Fe))return Fe.map(C.TextEdit.from)}}class te{constructor(W,Z){this._provider=W,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(W,Z){const ie=T.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(W,Z);if((0,A.isNonEmptyArray)(le))for(const Y of le){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ae=T.IdObject.mixin(C.WorkspaceSymbol.from(Y));this._symbolCache.set(ae._id,Y),ie.symbols.push(ae)}return ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie}async resolveWorkspaceSymbol(W,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const ie=this._symbolCache.get(W._id);if(ie){const le=await this._provider.resolveWorkspaceSymbol(ie,Z);return le&&(0,L.mixin)(W,C.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(W){const Z=this._resultCache.get(W);if(Z){for(let[ie,le]=Z;ie<=le;ie++)this._symbolCache.delete(ie);this._resultCache.delete(W)}}}class Q{constructor(W,Z,ie){this._documents=W,this._provider=Z,this._logService=ie}static supportsResolving(W){return typeof W.prepareRename=="function"}async provideRenameEdits(W,Z,ie,le){const Y=this._documents.getDocument(W),ae=C.Position.to(Z);try{const be=await this._provider.provideRenameEdits(Y,ae,ie,le);return be?C.WorkspaceEdit.from(be):void 0}catch(be){const Fe=Q._asMessage(be);return Fe?{rejectReason:Fe,edits:void 0}:Promise.reject(be)}}async resolveRenameLocation(W,Z,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(W),Y=C.Position.to(Z);try{const ae=await this._provider.prepareRename(le,Y,ie);let be,Fe;if(k.Range.isRange(ae)?(be=ae,Fe=le.getText(ae)):(0,i.isObject)(ae)&&(be=ae.range,Fe=ae.placeholder),!be||!Fe)return;if(be.start.line>Y.line||be.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(be),text:Fe}}catch(ae){const be=Q._asMessage(ae);return be?{rejectReason:be,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class N{constructor(W,Z){this.resultId=W,this.tokens=Z}}class U{constructor(W,Z){this._documents=W,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(W,Z,ie){const le=this._documents.getDocument(W),Y=Z!==0?this._previousResults.get(Z):null;let ae=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Y.resultId,ie):await this._provider.provideDocumentSemanticTokens(le,ie);return Y&&this._previousResults.delete(Z),ae?(ae=U._fixProvidedSemanticTokens(ae),this._send(U._convertToEdits(Y,ae),ae)):null}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return U._isSemanticTokens(W)?U._isCorrectSemanticTokens(W)?W:new k.SemanticTokens(new Uint32Array(W.data),W.resultId):U._isSemanticTokensEdits(W)?U._isCorrectSemanticTokensEdits(W)?W:new k.SemanticTokensEdits(W.edits.map(Z=>new k.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const Z of W.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,Z){if(!U._isSemanticTokens(Z)||!W||!W.tokens)return Z;const ie=W.tokens,le=ie.length,Y=Z.data,ae=Y.length;let be=0;const Fe=Math.min(le,ae);for(;be<Fe&&ie[be]===Y[be];)be++;if(be===le&&be===ae)return new k.SemanticTokensEdits([],Z.resultId);let He=0;const Ee=Fe-be;for(;He<Ee&&ie[le-He-1]===Y[ae-He-1];)He++;return new k.SemanticTokensEdits([{start:be,deleteCount:le-be-He,data:Y.subarray(be,ae-He)}],Z.resultId)}_send(W,Z){if(U._isSemanticTokens(W)){const ie=this._nextResultId++;return this._previousResults.set(ie,new N(W.resultId,W.data)),(0,m.encodeSemanticTokensDto)({id:ie,type:"full",data:W.data})}if(U._isSemanticTokensEdits(W)){const ie=this._nextResultId++;return U._isSemanticTokens(Z)?this._previousResults.set(ie,new N(Z.resultId,Z.data)):this._previousResults.set(ie,new N(W.resultId)),(0,m.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:(W.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class F{constructor(W,Z){this._documents=W,this._provider=Z}async provideDocumentRangeSemanticTokens(W,Z,ie){const le=this._documents.getDocument(W),Y=await this._provider.provideDocumentRangeSemanticTokens(le,C.Range.to(Z),ie);return Y?this._send(Y):null}_send(W){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=F;class V{constructor(W,Z,ie,le,Y){this._documents=W,this._commands=Z,this._provider=ie,this._apiDeprecation=le,this._extension=Y,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,Z,ie,le){const Y=this._documents.getDocument(W),ae=C.Position.to(Z),be=Y.getWordRangeAtPosition(ae)||new k.Range(ae,ae),Fe=be.with({end:ae}),He=new _.StopWatch(!0),Ee=await this._provider.provideCompletionItems(Y,ae,le,C.CompletionContext.to(ie));if(!Ee||le.isCancellationRequested)return;const Qe=Array.isArray(Ee)?new k.CompletionList(Ee):Ee,X=V.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),se=new u.DisposableStore;this._disposables.set(X,se);const pe=[],Ue={x:X,b:pe,a:{replace:C.Range.from(be),insert:C.Range.from(Fe)},c:Qe.isIncomplete||void 0,d:He.elapsed()};for(let Ne=0;Ne<Qe.items.length;Ne++){const Je=Qe.items[Ne],ke=this._convertCompletionItem(Je,[X,Ne],Fe,be);pe.push(ke)}return Ue}async resolveCompletionItem(W,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...W);if(!ie)return;const le=await this._provider.resolveCompletionItem(ie,Z);if(!!le)return this._convertCompletionItem(le,W)}releaseCompletionItems(W){this._disposables.get(W)?.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,Z,ie,le){const Y=this._disposables.get(Z[0]);if(!Y)throw Error("DisposableStore is missing...");const ae={x:Z,a:W.label,b:W.kind!==void 0?C.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(C.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(W.command,Y)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=W.textEdit.newText):typeof W.insertText=="string"?ae.h=W.insertText:W.insertText instanceof k.SnippetString&&(ae.h=W.insertText.value,ae.i|=4);let be;return W.textEdit?be=W.textEdit.range:W.range&&(be=W.range),k.Range.isRange(be)?ae.j=C.Range.from(be):be&&(!ie?.isEqual(be.inserting)||!le?.isEqual(be.replacing))&&(ae.j={insert:C.Range.from(be.inserting),replace:C.Range.from(be.replacing)}),ae}}class M{constructor(W,Z,ie){this._documents=W,this._provider=Z,this._commands=ie,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(W,Z,ie,le){const Y=this._documents.getDocument(W),ae=C.Position.to(Z),be=await this._provider.provideInlineCompletionItems(Y,ae,ie,le);if(!be||le.isCancellationRequested)return;const Fe=(0,i.isArray)(be)?{items:be}:be,He=this._cache.add(Fe.items);let Ee;return{pid:He,items:Fe.items.map((Qe,X)=>{let se;return Qe.command&&(Ee||(Ee=new u.DisposableStore,this._disposables.set(He,Ee)),se=this._commands.toInternal(Qe.command,Ee)),{text:Qe.text,range:Qe.range?C.Range.from(Qe.range):void 0,command:se,idx:X}})}}disposeCompletions(W){this._cache.delete(W);const Z=this._disposables.get(W);Z&&Z.clear(),this._disposables.delete(W)}handleDidShowCompletionItem(W,Z){const ie=this._cache.get(W,Z);ie&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new P.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(W){let Z=O.map.get(W);return Z||(Z=new O,O.map.set(W,Z)),Z}fireOnDidShowCompletionItem(W){this._onDidShowCompletionItemEmitter.fire(W)}}e.InlineCompletionController=O,O.map=new WeakMap;class q{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(W,Z,ie,le){const Y=this._documents.getDocument(W),ae=C.Position.to(Z),be=this.reviveContext(ie),Fe=await this._provider.provideSignatureHelp(Y,ae,le,be);if(Fe){const He=this._cache.add([Fe]);return{...C.SignatureHelp.from(Fe),id:He}}}reviveContext(W){let Z;if(W.activeSignatureHelp){const ie=C.SignatureHelp.to(W.activeSignatureHelp),le=this._cache.get(W.activeSignatureHelp.id,0);le?(Z=le,Z.activeSignature=ie.activeSignature,Z.activeParameter=ie.activeParameter):Z=ie}return{...W,activeSignatureHelp:Z}}releaseSignatureHelp(W){this._cache.delete(W)}}class B{constructor(W,Z){this._documents=W,this._provider=Z}async provideInlayHints(W,Z,ie){const le=this._documents.getDocument(W),Y=await this._provider.provideInlayHints(le,C.Range.to(Z),ie);return Y?{hints:Y.map(C.InlayHint.from)}:void 0}}class K{constructor(W,Z){this._documents=W,this._provider=Z,this._cache=new v.Cache("DocumentLink")}async provideLinks(W,Z){const ie=this._documents.getDocument(W),le=await this._provider.provideDocumentLinks(ie,Z);if(!(!Array.isArray(le)||le.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(K._validateLink).map(C.DocumentLink.from)};{const Y=this._cache.add(le),ae={links:[],id:Y};for(let be=0;be<le.length;be++){if(!K._validateLink(le[be]))continue;const Fe=C.DocumentLink.from(le[be]);Fe.cacheId=[Y,be],ae.links.push(Fe)}return ae}}}static _validateLink(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...W);if(!ie)return;const le=await this._provider.resolveDocumentLink(ie,Z);if(!(!le||!K._validateLink(le)))return C.DocumentLink.from(le)}releaseLinks(W){this._cache.delete(W)}}class ne{constructor(W,Z){this._documents=W,this._provider=Z}async provideColors(W,Z){const ie=this._documents.getDocument(W),le=await this._provider.provideDocumentColors(ie,Z);return Array.isArray(le)?le.map(ae=>({color:C.Color.from(ae.color),range:C.Range.from(ae.range)})):[]}async provideColorPresentations(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Range.to(Z.range),ae=C.Color.to(Z.color),be=await this._provider.provideColorPresentations(ae,{document:le,range:Y},ie);if(!!Array.isArray(be))return be.map(C.ColorPresentation.from)}}class me{constructor(W,Z){this._documents=W,this._provider=Z}async provideFoldingRanges(W,Z,ie){const le=this._documents.getDocument(W),Y=await this._provider.provideFoldingRanges(le,Z,ie);if(!!Array.isArray(Y))return Y.map(C.FoldingRange.from)}}class Se{constructor(W,Z,ie){this._documents=W,this._provider=Z,this._logService=ie}async provideSelectionRanges(W,Z,ie){const le=this._documents.getDocument(W),Y=Z.map(C.Position.to),ae=await this._provider.provideSelectionRanges(le,Y,ie);if(!(0,A.isNonEmptyArray)(ae))return[];if(ae.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const be=[];for(let Fe=0;Fe<Y.length;Fe++){const He=[];be.push(He);let Ee=Y[Fe],Qe=ae[Fe];for(;;){if(!Qe.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(He.push(C.SelectionRange.from(Qe)),!Qe.parent)break;Ee=Qe.range,Qe=Qe.parent}}return be}}class Ce{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.prepareCallHierarchy(le,Y,ie);if(!ae)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(ae)?ae.map(Fe=>this._cacheAndConvertItem(be,Fe)):[this._cacheAndConvertItem(be,ae)]}async provideCallsTo(W,Z,ie){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(le,ie);if(!!Y)return Y.map(ae=>({from:this._cacheAndConvertItem(W,ae.from),fromRanges:ae.fromRanges.map(be=>C.Range.from(be))}))}async provideCallsFrom(W,Z,ie){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(le,ie);if(!!Y)return Y.map(ae=>({to:this._cacheAndConvertItem(W,ae.to),fromRanges:ae.fromRanges.map(be=>C.Range.from(be))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ie=this._cache.get(W),le=C.CallHierarchyItem.from(Z,W,ie.size.toString(36));return ie.set(le._itemId,Z),le}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class Te{constructor(W,Z){this._documents=W,this._provider=Z,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(W,Z,ie){const le=this._documents.getDocument(W),Y=C.Position.to(Z),ae=await this._provider.prepareTypeHierarchy(le,Y,ie);if(!ae)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(ae)?ae.map(Fe=>this._cacheAndConvertItem(be,Fe)):[this._cacheAndConvertItem(be,ae)]}async provideSupertypes(W,Z,ie){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(le,ie);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(W,ae))}async provideSubtypes(W,Z,ie){const le=this._itemFromCache(W,Z);if(!le)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(le,ie);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(W,ae))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,Z){const ie=this._cache.get(W),le=C.TypeHierarchyItem.from(Z,W,ie.size.toString(36));return ie.set(le._itemId,Z),le}_itemFromCache(W,Z){return this._cache.get(W)?.get(Z)}}class je{constructor(W,Z){this.adapter=W,this.extension=Z}}class Be{constructor(W,Z,ie,le,Y,ae,be){this._adapter=new Map,this._uriTransformer=Z,this._proxy=W.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=le,this._diagnostics=Y,this._logService=ae,this._apiDeprecation=be}_transformDocumentSelector(W){return(0,A.coalesce)((0,A.asArray)(W).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:C.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new k.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Be._handlePool++}_withAdapter(W,Z,ie,le,Y=!1){const ae=this._adapter.get(W);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof Z){let be;ae.extension&&(be=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Fe=ie(ae.adapter,ae.extension),He=ae.extension;return He&&Promise.resolve(Fe).then(()=>this._logService.trace(`[${He.identifier.value}] provider DONE after ${Date.now()-be}ms`),Ee=>{Y&&Ee instanceof b.CancellationError||(this._logService.error(`[${He.identifier.value}] provider FAILED`),this._logService.error(Ee))}),Fe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,Z){const ie=this._nextHandle();return this._adapter.set(ie,new je(W,Z)),ie}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,Z,ie,le){const Y=this._addNewAdapter(new l(this._documents,ie),W),ae=le&&le.label||Be._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(Z),ae),this._createDisposable(Y)}$provideDocumentSymbols(W,Z,ie){return this._withAdapter(W,l,le=>le.provideDocumentSymbols(g.URI.revive(Z),ie),void 0)}registerCodeLensProvider(W,Z,ie){const le=this._nextHandle(),Y=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new je(new f(this._documents,this._commands.converter,ie),W)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(Z),Y);let ae=this._createDisposable(le);if(Y!==void 0){const be=ie.onDidChangeCodeLenses(Fe=>this._proxy.$emitCodeLensEvent(Y));ae=k.Disposable.from(ae,be)}return ae}$provideCodeLenses(W,Z,ie){return this._withAdapter(W,f,le=>le.provideCodeLenses(g.URI.revive(Z),ie),void 0)}$resolveCodeLens(W,Z,ie){return this._withAdapter(W,f,le=>le.resolveCodeLens(Z,ie),void 0)}$releaseCodeLenses(W,Z){this._withAdapter(W,f,ie=>Promise.resolve(ie.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(W,Z,ie){const le=this._addNewAdapter(new t(this._documents,ie),W);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDefinition(W,Z,ie,le){return this._withAdapter(W,t,Y=>Y.provideDefinition(g.URI.revive(Z),ie,le),[])}registerDeclarationProvider(W,Z,ie){const le=this._addNewAdapter(new s(this._documents,ie),W);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDeclaration(W,Z,ie,le){return this._withAdapter(W,s,Y=>Y.provideDeclaration(g.URI.revive(Z),ie,le),[])}registerImplementationProvider(W,Z,ie){const le=this._addNewAdapter(new o(this._documents,ie),W);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideImplementation(W,Z,ie,le){return this._withAdapter(W,o,Y=>Y.provideImplementation(g.URI.revive(Z),ie,le),[])}registerTypeDefinitionProvider(W,Z,ie){const le=this._addNewAdapter(new n(this._documents,ie),W);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideTypeDefinition(W,Z,ie,le){return this._withAdapter(W,n,Y=>Y.provideTypeDefinition(g.URI.revive(Z),ie,le),[])}registerHoverProvider(W,Z,ie,le){const Y=this._addNewAdapter(new a(this._documents,ie),W);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideHover(W,Z,ie,le){return this._withAdapter(W,a,Y=>Y.provideHover(g.URI.revive(Z),ie,le),void 0)}registerEvaluatableExpressionProvider(W,Z,ie,le){const Y=this._addNewAdapter(new h(this._documents,ie),W);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(Z)),this._createDisposable(Y)}$provideEvaluatableExpression(W,Z,ie,le){return this._withAdapter(W,h,Y=>Y.provideEvaluatableExpression(g.URI.revive(Z),ie,le),void 0)}registerInlineValuesProvider(W,Z,ie,le){const Y=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new d(this._documents,ie),W);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(Z),Y);let be=this._createDisposable(ae);if(Y!==void 0){const Fe=ie.onDidChangeInlineValues(He=>this._proxy.$emitInlineValuesEvent(Y));be=k.Disposable.from(be,Fe)}return be}$provideInlineValues(W,Z,ie,le,Y){return this._withAdapter(W,d,ae=>ae.provideInlineValues(g.URI.revive(Z),ie,le,Y),void 0)}registerDocumentHighlightProvider(W,Z,ie){const le=this._addNewAdapter(new w(this._documents,ie),W);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDocumentHighlights(W,Z,ie,le){return this._withAdapter(W,w,Y=>Y.provideDocumentHighlights(g.URI.revive(Z),ie,le),void 0)}registerLinkedEditingRangeProvider(W,Z,ie){const le=this._addNewAdapter(new E(this._documents,ie),W);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideLinkedEditingRanges(W,Z,ie,le){return this._withAdapter(W,E,async Y=>{const ae=await Y.provideLinkedEditingRanges(g.URI.revive(Z),ie,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?Be._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(W,Z,ie){const le=this._addNewAdapter(new r(this._documents,ie),W);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideReferences(W,Z,ie,le,Y){return this._withAdapter(W,r,ae=>ae.provideReferences(g.URI.revive(Z),ie,le,Y),void 0)}registerCodeActionProvider(W,Z,ie,le){const Y=new u.DisposableStore,ae=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(Z),{providedKinds:le?.providedCodeActionKinds?.map(be=>be.value),documentation:le?.documentation?.map(be=>({kind:be.kind.value,command:this._commands.converter.toInternal(be.command,Y)}))},Be._extLabel(W),Boolean(ie.resolveCodeAction)),Y.add(this._createDisposable(ae)),Y}$provideCodeActions(W,Z,ie,le,Y){return this._withAdapter(W,D,ae=>ae.provideCodeActions(g.URI.revive(Z),ie,le,Y),void 0)}$resolveCodeAction(W,Z,ie){return this._withAdapter(W,D,le=>le.resolveCodeAction(Z,ie),void 0)}$releaseCodeActions(W,Z){this._withAdapter(W,D,ie=>Promise.resolve(ie.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(W,Z,ie){const le=this._addNewAdapter(new R(this._documents,ie),W);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(le)}$provideDocumentFormattingEdits(W,Z,ie,le){return this._withAdapter(W,R,Y=>Y.provideDocumentFormattingEdits(g.URI.revive(Z),ie,le),void 0)}registerDocumentRangeFormattingEditProvider(W,Z,ie){const le=this._addNewAdapter(new x(this._documents,ie),W);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(Z),W.identifier,W.displayName||W.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(W,Z,ie,le,Y){return this._withAdapter(W,x,ae=>ae.provideDocumentRangeFormattingEdits(g.URI.revive(Z),ie,le,Y),void 0)}registerOnTypeFormattingEditProvider(W,Z,ie,le){const Y=this._addNewAdapter(new j(this._documents,ie),W);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(Z),le,W.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(W,Z,ie,le,Y,ae){return this._withAdapter(W,j,be=>be.provideOnTypeFormattingEdits(g.URI.revive(Z),ie,le,Y,ae),void 0)}registerWorkspaceSymbolProvider(W,Z){const ie=this._addNewAdapter(new te(Z,this._logService),W);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(W,Z,ie){return this._withAdapter(W,te,le=>le.provideWorkspaceSymbols(Z,ie),{symbols:[]})}$resolveWorkspaceSymbol(W,Z,ie){return this._withAdapter(W,te,le=>le.resolveWorkspaceSymbol(Z,ie),void 0)}$releaseWorkspaceSymbols(W,Z){this._withAdapter(W,te,ie=>ie.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(W,Z,ie){const le=this._addNewAdapter(new Q(this._documents,ie,this._logService),W);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(Z),Q.supportsResolving(ie)),this._createDisposable(le)}$provideRenameEdits(W,Z,ie,le,Y){return this._withAdapter(W,Q,ae=>ae.provideRenameEdits(g.URI.revive(Z),ie,le,Y),void 0)}$resolveRenameLocation(W,Z,ie,le){return this._withAdapter(W,Q,Y=>Y.resolveRenameLocation(g.URI.revive(Z),ie,le),void 0)}registerDocumentSemanticTokensProvider(W,Z,ie,le){const Y=this._nextHandle(),ae=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new je(new U(this._documents,ie),W)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(Z),le,ae);let be=this._createDisposable(Y);if(ae){const Fe=ie.onDidChangeSemanticTokens(He=>this._proxy.$emitDocumentSemanticTokensEvent(ae));be=k.Disposable.from(be,Fe)}return be}$provideDocumentSemanticTokens(W,Z,ie,le){return this._withAdapter(W,U,Y=>Y.provideDocumentSemanticTokens(g.URI.revive(Z),ie,le),null,!0)}$releaseDocumentSemanticTokens(W,Z){this._withAdapter(W,U,ie=>ie.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(W,Z,ie,le){const Y=this._addNewAdapter(new F(this._documents,ie),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(Z),le),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(W,Z,ie,le){return this._withAdapter(W,F,Y=>Y.provideDocumentRangeSemanticTokens(g.URI.revive(Z),ie,le),null,!0)}registerCompletionItemProvider(W,Z,ie,le){const Y=this._addNewAdapter(new V(this._documents,this._commands.converter,ie,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(Z),le,V.supportsResolving(ie),`${W.identifier.value}(${le.join("")})`),this._createDisposable(Y)}$provideCompletionItems(W,Z,ie,le,Y){return this._withAdapter(W,V,ae=>ae.provideCompletionItems(g.URI.revive(Z),ie,le,Y),void 0)}$resolveCompletionItem(W,Z,ie){return this._withAdapter(W,V,le=>le.resolveCompletionItem(Z,ie),void 0)}$releaseCompletionItems(W,Z){this._withAdapter(W,V,ie=>ie.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(W,Z,ie){const le=this._addNewAdapter(new M(this._documents,ie,this._commands.converter),W);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideInlineCompletions(W,Z,ie,le,Y){return this._withAdapter(W,M,ae=>ae.provideInlineCompletions(g.URI.revive(Z),ie,le,Y),void 0)}$handleInlineCompletionDidShow(W,Z,ie){this._withAdapter(W,M,async le=>{le.handleDidShowCompletionItem(Z,ie)},void 0)}$freeInlineCompletionsList(W,Z){this._withAdapter(W,M,async ie=>{ie.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(W,Z,ie,le){const Y=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new q(this._documents,ie),W);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(Z),Y),this._createDisposable(ae)}$provideSignatureHelp(W,Z,ie,le,Y){return this._withAdapter(W,q,ae=>ae.provideSignatureHelp(g.URI.revive(Z),ie,le,Y),void 0)}$releaseSignatureHelp(W,Z){this._withAdapter(W,q,ie=>ie.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(W,Z,ie){const le=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new B(this._documents,ie),W);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(Z),le);let ae=this._createDisposable(Y);if(le!==void 0){const be=ie.onDidChangeInlayHints(Fe=>this._proxy.$emitInlayHintsEvent(le));ae=k.Disposable.from(ae,be)}return ae}$provideInlayHints(W,Z,ie,le){return this._withAdapter(W,B,Y=>Y.provideInlayHints(g.URI.revive(Z),ie,le),void 0)}registerDocumentLinkProvider(W,Z,ie){const le=this._addNewAdapter(new K(this._documents,ie),W);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(Z),typeof ie.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(W,Z,ie){return this._withAdapter(W,K,le=>le.provideLinks(g.URI.revive(Z),ie),void 0)}$resolveDocumentLink(W,Z,ie){return this._withAdapter(W,K,le=>le.resolveLink(Z,ie),void 0)}$releaseDocumentLinks(W,Z){this._withAdapter(W,K,ie=>ie.releaseLinks(Z),void 0)}registerColorProvider(W,Z,ie){const le=this._addNewAdapter(new ne(this._documents,ie),W);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideDocumentColors(W,Z,ie){return this._withAdapter(W,ne,le=>le.provideColors(g.URI.revive(Z),ie),[])}$provideColorPresentations(W,Z,ie,le){return this._withAdapter(W,ne,Y=>Y.provideColorPresentations(g.URI.revive(Z),ie,le),void 0)}registerFoldingRangeProvider(W,Z,ie){const le=this._nextHandle(),Y=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new je(new me(this._documents,ie),W)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(Z),Y);let ae=this._createDisposable(le);if(Y!==void 0){const be=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ae=k.Disposable.from(ae,be)}return ae}$provideFoldingRanges(W,Z,ie,le){return this._withAdapter(W,me,Y=>Y.provideFoldingRanges(g.URI.revive(Z),ie,le),void 0)}registerSelectionRangeProvider(W,Z,ie){const le=this._addNewAdapter(new Se(this._documents,ie,this._logService),W);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$provideSelectionRanges(W,Z,ie,le){return this._withAdapter(W,Se,Y=>Y.provideSelectionRanges(g.URI.revive(Z),ie,le),[])}registerCallHierarchyProvider(W,Z,ie){const le=this._addNewAdapter(new Ce(this._documents,ie),W);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$prepareCallHierarchy(W,Z,ie,le){return this._withAdapter(W,Ce,Y=>Promise.resolve(Y.prepareSession(g.URI.revive(Z),ie,le)),void 0)}$provideCallHierarchyIncomingCalls(W,Z,ie,le){return this._withAdapter(W,Ce,Y=>Y.provideCallsTo(Z,ie,le),void 0)}$provideCallHierarchyOutgoingCalls(W,Z,ie,le){return this._withAdapter(W,Ce,Y=>Y.provideCallsFrom(Z,ie,le),void 0)}$releaseCallHierarchy(W,Z){this._withAdapter(W,Ce,ie=>Promise.resolve(ie.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(W,Z,ie){const le=this._addNewAdapter(new Te(this._documents,ie),W);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(Z)),this._createDisposable(le)}$prepareTypeHierarchy(W,Z,ie,le){return this._withAdapter(W,Te,Y=>Promise.resolve(Y.prepareSession(g.URI.revive(Z),ie,le)),void 0)}$provideTypeHierarchySupertypes(W,Z,ie,le){return this._withAdapter(W,Te,Y=>Y.provideSupertypes(Z,ie,le),void 0)}$provideTypeHierarchySubtypes(W,Z,ie,le){return this._withAdapter(W,Te,Y=>Y.provideSubtypes(Z,ie,le),void 0)}$releaseTypeHierarchy(W,Z){this._withAdapter(W,Te,ie=>Promise.resolve(ie.releaseSession(Z)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,y.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Be._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Be._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Be._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Be._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Be._serializeRegExp(W.beforeText),afterText:W.afterText?Be._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Be._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Be._serializeOnEnterRule)}setLanguageConfiguration(W,Z,ie){let{wordPattern:le}=ie;if(le&&(0,y.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(Z,le):this._documents.setWordDefinitionFor(Z,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const Y=this._nextHandle(),ae={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?Be._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?Be._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?Be._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,Z,ae),this._createDisposable(Y)}$setWordDefinitions(W){for(const Z of W)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=Be,Be._handlePool=0}),define(ve[242],we([0,1,5,15,7,48,17]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(A,i){this._handlePool=0,this._proxy=A.getProxy(g.MainContext.MainThreadLanguages),this._documents=i}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(A,i){await this._proxy.$changeLanguage(A,i);const I=this._documents.getDocumentData(A);if(!I)throw new Error(`document '${A.toString}' NOT found`);return I.document}async tokenAtPosition(A,i){const I=A.version,u=L.Position.from(i),m=await this._proxy.$tokensAtPosition(A.uri,u),c={type:C.StandardTokenType.Other,range:A.getWordRangeAtPosition(i)??new C.Range(i.line,i.character,i.line,i.character)};if(!m)return c;const v={range:L.Range.to(m.range),type:L.TokenType.to(m.type)};return!v.range.contains(i)||I!==A.version?c:v}createLanguageStatusItem(A){const i=this._handlePool++,I=this._proxy,u={selector:A,text:"",detail:"",severity:C.LanguageStatusSeverity.Information};let m;const c=()=>{m?.dispose(),m=(0,T.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(i,{selector:u.selector,text:u.text,message:typeof u.detail=="string"?u.detail:L.MarkdownString.from(u.detail),severity:u.severity===C.LanguageStatusSeverity.Error?k.default.Error:u.severity===C.LanguageStatusSeverity.Warning?k.default.Warning:k.default.Info})},0)},v={get selector(){return u.selector},set selector(_){u.selector=_,c()},get text(){return u.text},set text(_){u.text=_,c()},get detail(){return u.detail},set detail(_){u.detail=_,c()},get severity(){return u.severity},set severity(_){u.severity=_,c()},dispose(){m?.dispose(),I.$removeLanguageStatus(i)}};return c(),v}}e.ExtHostLanguages=y}),define(ve[243],we([0,1,5,12,35]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function k(y){return y&&y.title}let T=class{constructor(S,A){this._logService=A,this._proxy=S.getProxy(g.MainContext.MainThreadMessageService)}showMessage(S,A,i,I,u){const m={extension:S};let c;typeof I=="string"||k(I)?c=[I,...u]:(m.modal=I?.modal,m.useCustom=I?.useCustom,m.detail=I?.detail,c=u),m.useCustom&&(0,C.checkProposedApiEnabled)(S);const v=[];for(let _=0;_<c.length;_++){const b=c[_];if(typeof b=="string")v.push({title:b,handle:_,isCloseAffordance:!1});else if(typeof b=="object"){let{title:P,isCloseAffordance:l}=b;v.push({title:P,isCloseAffordance:!!l,handle:_})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(A,i,m,v).then(_=>{if(typeof _=="number")return c[_]})}};T=We([xe(1,L.ILogService)],T),e.ExtHostMessageService=T}),define(ve[244],we([0,1,24,3,58,6,22,9,14,2,86,5,15,7,219,128]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(P,l,f,p,t){this._textDocumentsAndEditors=f,this._textDocuments=p,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=P.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=P.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=P.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const o=s.notebookEditor?.notebookUri,n=s.cell.handle,h=this._documents.get(o)?.getCell(n);if(h)return h.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(P=>P.apiEditor)}getEditorById(P){const l=this._editors.get(P);if(!l)throw new Error(`unknown text editor: ${P}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(P){for(const[l,f]of this._editors)if(f.apiEditor===P)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(P,l){const f=this._documents.get(P);if(!f&&!l)throw new Error(`NO notebook document for '${P}'`);return f}_getProviderData(P){const l=this._notebookContentProviders.get(P);if(!l)throw new Error(`NO provider for '${P}'`);return l}registerNotebookContentProvider(P,l,f,p,t){if((0,y.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:P,provider:f});let s;return f.onDidChangeNotebookContentOptions&&(s=f.onDidChangeNotebookContentOptions(()=>{const o=u.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(l,o)})),this._notebookProxy.$registerNotebookProvider({id:P.identifier,location:P.extensionLocation},l,u.NotebookDocumentContentOptions.from(p),_._convertNotebookRegistrationData(P,t)),new m.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(P,l){if(!l)return;const f=l.filenamePattern.map(p=>u.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(l.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:P.identifier,providerDisplayName:P.displayName||P.name,displayName:l.displayName,filenamePattern:f,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(P,l,f){const p=_._notebookStatusBarItemProviderHandlePool++,t=typeof f.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(p,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(p,t,l);let s;return t!==void 0&&(s=f.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(t))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(p),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(p,t),s&&s.dispose()})}async createNotebookDocument(P){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:P.viewType,content:P.content&&u.NotebookData.from(P.content)});return A.URI.revive(l)}async openNotebookDocument(P){const l=this._documents.get(P);if(l)return l.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(P),p=this._documents.get(A.URI.revive(f));return(0,S.assertIsDefined)(p?.apiNotebook)}async showNotebookDocument(P,l){A.URI.isUri(P)&&(P=await this.openNotebookDocument(P));let f;typeof l=="object"?f={position:u.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(u.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:f={preserveFocus:!1};const p=await this._notebookEditorsProxy.$tryShowNotebookDocument(P.uri,P.notebookType,f),t=p&&this._editors.get(p)?.apiEditor;if(t)return t;throw p?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(P,l,f,p){const t=this._notebookStatusBarItemProviders.get(P),s=A.URI.revive(l),o=this._documents.get(s);if(!o||!t)return;const n=o.getCellFromIndex(f);if(!n)return;const a=await t.provideCellStatusBarItems(n.apiCell,p);if(!a)return;const h=new k.DisposableStore,d=this._statusBarCache.add([h]),E=(Array.isArray(a)?a:[a]).map(r=>u.NotebookStatusBarItem.from(r,this._commandsConverter,h));return{cacheId:d,items:E}}$releaseNotebookCellStatusBarItems(P){this._statusBarCache.delete(P)}registerNotebookSerializer(P,l,f,p,t){if((0,y.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,f),this._notebookProxy.$registerNotebookSerializer(s,{id:P.identifier,location:P.extensionLocation},l,u.NotebookDocumentContentOptions.from(p),_._convertNotebookRegistrationData(P,t)),(0,k.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(P,l,f){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.deserializeNotebook(l.buffer,f);return u.NotebookData.from(t)}async $notebookToData(P,l,f){const p=this._notebookSerializer.get(P);if(!p)throw new Error("NO serializer found");const t=await p.serializeNotebook(u.NotebookData.to(l),f);return g.VSBuffer.wrap(t)}async $openNotebook(P,l,f,p,t){const{provider:s}=this._getProviderData(P),o=await s.openNotebook(A.URI.revive(l),{backupId:f,untitledDocumentData:p?.buffer},t);return{metadata:o.metadata??Object.create(null),cells:o.cells.map(u.NotebookCellData.from)}}async $saveNotebook(P,l,f){const p=this.getNotebookDocument(A.URI.revive(l)),{provider:t}=this._getProviderData(P);return await t.saveNotebook(p.apiNotebook,f),!0}async $saveNotebookAs(P,l,f,p){const t=this.getNotebookDocument(A.URI.revive(l)),{provider:s}=this._getProviderData(P);return await s.saveNotebookAs(A.URI.revive(f),t.apiNotebook,p),!0}async $backupNotebook(P,l,f){const p=this.getNotebookDocument(A.URI.revive(l)),t=this._getProviderData(P),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),o=String((0,C.hash)([p.uri.toString(),this._backupIdPool++])),n=A.URI.joinPath(s,o),a=await t.provider.backupNotebook(p.apiNotebook,{destination:n},f);return p.updateBackup(a),a.id}_createExtHostEditor(P,l,f){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const p=new v.ExtHostNotebookEditor(l,this._notebookEditorsProxy,P,f.visibleRanges.map(u.NotebookRange.to),f.selections.map(u.NotebookRange.to),typeof f.viewColumn=="number"?u.ViewColumn.to(f.viewColumn):void 0);this._editors.set(l,p)}$acceptDocumentAndEditorsDelta(P){if(P.removedDocuments)for(const f of P.removedDocuments){const p=A.URI.revive(f),t=this._documents.get(p);t&&(t.dispose(),this._documents.delete(p),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===p.toString()&&this._editors.delete(s.id)}if(P.addedDocuments){const f=[];for(const p of P.addedDocuments){const t=A.URI.revive(p.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,o=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){s._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){s._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){s._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){s._onDidChangeCellExecutionState.fire(n)}},t,p);f.push(...p.cells.map(n=>c.ExtHostCell.asModelAddData(o.apiNotebook,n))),this._documents.get(t)?.dispose(),this._documents.set(t,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:f}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(P.addedEditors)for(const f of P.addedEditors){if(this._editors.has(f.id))return;const p=A.URI.revive(f.documentUri),t=this._documents.get(p);t&&this._createExtHostEditor(t,f.id,f)}const l=[];if(P.removedEditors)for(const f of P.removedEditors){const p=this._editors.get(f);p&&(this._editors.delete(f),this._activeNotebookEditor?.id===p.id&&(this._activeNotebookEditor=void 0),l.push(p))}if(P.visibleEditors){this._visibleNotebookEditors=P.visibleEditors.map(p=>this._editors.get(p)).filter(p=>!!p);const f=new Set;this._visibleNotebookEditors.forEach(p=>f.add(p.id));for(const p of this._editors.values()){const t=f.has(p.id);p._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(p=>p).filter(p=>p.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}P.newActiveEditor===null?this._activeNotebookEditor=void 0:P.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(P.newActiveEditor)),P.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(ve[245],we([0,1,3,74,12,5,13,15]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(I,u){const m=S._Keys.nextId();I.$registerNotebookEditorDecorationType(m,y.NotebookDecorationRenderOptions.from(u)),this.value={key:m,dispose(){I.$removeNotebookEditorDecorationType(m)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(I,u,m){this._logService=I,this._extHostRpc=u,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new S(this._extHostRpc.getProxy(k.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,u);const m=this._notebooksAndEditors.getEditorById(I);u.visibleRanges&&m._acceptVisibleRanges(u.visibleRanges.ranges.map(y.NotebookRange.to)),u.selections&&m._acceptSelections(u.selections.selections.map(y.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const u in I)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(y.ViewColumn.to(I[u]))}};A=We([xe(0,C.ILogService),xe(1,T.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(ve[246],we([0,1,20,17,21,3,6,22,2,26,12,5,15,7,88,212,35]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,s,o,n){this._initData=s,this._extHostNotebook=o,this._logService=n,this._activeExecutions=new y.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(I.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,o,n,a,h){for(let M of this._kernelData.values())if(M.controller.id===s&&A.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const d=this._handlePool++,w=this;this._logService.trace(`NotebookController[${d}], CREATED by ${t.identifier.value}, ${s}`);const E=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${t.identifier}'`);let r=!1;const D=new T.DisposableStore,R=new k.Emitter,x=new k.Emitter,j={id:`${t.identifier.value}/${s}`,notebookType:o,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:h?h.map(u.NotebookRendererScript.from):[]};let te=a??E,Q;this._proxy.$addKernel(d,j).catch(M=>{console.log(M),r=!0});let N=0;const U=()=>{if(r)return;const M=++N;Promise.resolve().then(()=>{M===N&&this._proxy.$updateKernel(d,j)})},F=new y.ResourceMap,V={get id(){return s},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return j.label},set label(M){j.label=M??t.displayName??t.name,U()},get detail(){return j.detail??""},set detail(M){j.detail=M,U()},get description(){return j.description??""},set description(M){j.description=M,U()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(M){j.supportedLanguages=M,U()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(M){j.supportsExecutionOrder=M,U()},get rendererScripts(){return j.preloads?j.preloads.map(u.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(M){te=M??E},get interruptHandler(){return Q},set interruptHandler(M){Q=M,j.supportsInterrupt=Boolean(M),U()},createNotebookCellExecution(M){if(r)throw new Error("notebook controller is DISPOSED");if(!F.has(M.notebook.uri))throw w._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(F.keys()).map(O=>O.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return w._createNotebookCellExecution(M)},dispose:()=>{r||(this._logService.trace(`NotebookController[${d}], DISPOSED`),r=!0,this._kernelData.delete(d),D.dispose(),R.dispose(),x.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(M,O){w._proxy.$updateNotebookPriority(d,M.uri,O)},onDidReceiveMessage:x.event,postMessage(M,O){return(0,_.checkProposedApiEnabled)(t),w._proxy.$postMessage(d,O&&w._extHostNotebook.getIdByEditor(O),M)},asWebviewUri(M){return(0,_.checkProposedApiEnabled)(t),(0,c.asWebviewUri)(M,w._initData.remote)}};return this._kernelData.set(d,{extensionId:t.identifier,controller:V,onDidReceiveMessage:x,onDidChangeSelection:R,associatedNotebooks:F}),V}$acceptNotebookAssociation(t,s,o){const n=this._kernelData.get(t);if(n){const a=this._extHostNotebook.getNotebookDocument(S.URI.revive(s));o?n.associatedNotebooks.set(a.uri,!0):n.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),o),n.onDidChangeSelection.fire({selected:o,notebook:a.apiNotebook})}}async $executeCells(t,s,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(S.URI.revive(s)),h=[];for(let d of o){const w=a.getCell(d);w&&h.push(w.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),h.length),await n.controller.executeHandler.call(n.controller,h,a.apiNotebook,n.controller)}catch(d){this._logService.error(`NotebookController[${t}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(t,s,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(S.URI.revive(s));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,a.apiNotebook);else for(let h of o){const d=a.getCell(h);d&&this._activeExecutions.get(d.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,o){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getEditorById(s);n.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:o}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const n=new l(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,n);const a=n.onDidChangeState(()=>{n.state===P.Resolved&&(n.dispose(),a.dispose(),this._activeExecutions.delete(o.uri))});return n.asApiObject()}};b=We([xe(3,i.ILogService)],b),e.ExtHostNotebookKernels=b;var P;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(P||(P={}));class l extends T.Disposable{constructor(t,s,o){super();this._document=t,this._cell=s,this._proxy=o,this._handle=l.HANDLE++,this._onDidChangeState=new k.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=P.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new f(10,n=>this.update(n)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(t){await this._collector.addItem(t)}async update(t){const s=Array.isArray(t)?t:[t];return this._proxy.$updateExecutions(s)}verifyStateForOutput(){if(this._state===P.Init)throw new Error("Must call start before modifying cell output");if(this._state===P.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const o=m.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return o===s.items?u.NotebookCellOutput.from(s):u.NotebookCellOutput.from({items:o,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,o){const n=this.cellIndexToHandle(s),a=this.validateAndConvertOutputs((0,g.asArray)(t));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:n,append:o,outputs:a})}async updateOutputItems(t,s,o){return t=m.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(t),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:t.map(u.NotebookCellOutputItem.from),outputId:s.id,append:o})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(o){t._executionOrder=o,t.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:t._handle,executionOrder:t._executionOrder}])},start(o){if(t._state===P.Resolved||t._state===P.Started)throw new Error("Cannot call start again");t._state=P.Started,t._onDidChangeState.fire(),t.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:t._handle,runStartTime:o})},end(o,n){if(t._state===P.Resolved)throw new Error("Cannot call resolve twice");t._state=P.Resolved,t._onDidChangeState.fire(),t.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:t._handle,runEndTime:n,lastRunSuccess:o}),t._collector.flush(),t._proxy.$removeExecution(t._handle)},clearOutput(o){return t.verifyStateForOutput(),t.updateOutputs([],o,!1)},appendOutput(o,n){return t.verifyStateForOutput(),t.updateOutputs(o,n,!0)},replaceOutput(o,n){return t.verifyStateForOutput(),t.updateOutputs(o,n,!1)},appendOutputItems(o,n){return t.verifyStateForOutput(),t.updateOutputItems(o,n,!0)},replaceOutputItems(o,n){return t.verifyStateForOutput(),t.updateOutputItems(o,n,!1)}})}}l.HANDLE=0;class f{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,L.timeout)(this.delay).then(()=>this.flush())),this.waitPromise}flush(){this.waitPromise=void 0;const t=this.batch;return this.batch=[],this.callback(t)}}}),define(ve[247],we([0,1,3,5,128]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(y,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,S,A){const i=this._extHostNotebook.getEditorById(y);this._rendererMessageEmitters.get(S)?.fire({editor:i.apiEditor,message:A})}createRendererMessaging(y,S){if(!y.contributes?.notebookRenderer?.some(u=>u.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const A=!!y.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(u,m,c)=>{const v=A?u:_=>{const b={};i.set(b,_.editor),u({editor:b,message:_.message})};return this.getOrCreateEmitterFor(S).event(v,m,c)},postMessage:(u,m)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(u)&&([u,m]=[m,u]);const c=A?m:i.get(m),v=c&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(v?.id,S,u)}}}getOrCreateEmitterFor(y){let S=this._rendererMessageEmitters.get(y);return S||(S=new g.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,S),S)}}e.ExtHostNotebookRenderers=k}),define(ve[66],we([0,1,5,3,6,24,4,13]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends C.Disposable{constructor(c,v,_,b,P){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=P,this._id=P.$register(this.name,v,_,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?k.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(v=>this._proxy.$clear(v,c))}show(c,v){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof c=="boolean"?c:v)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class A extends S{constructor(c,v,_){super(c,!1,void 0,v,_)}append(c){super.append(c),this._id.then(v=>this._proxy.$append(v,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=A;class i extends S{constructor(c,v,_){super(c,!0,v,void 0,_)}append(c){throw new Error("Not supported")}}class I{constructor(c,v){this.name=c,this._channel=v}append(c){this._channel.then(v=>v.append(c))}appendLine(c){this._channel.then(v=>v.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,v){this._channel.then(_=>_.show(c,v))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let u=class{constructor(c){this._proxy=c.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c,v){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new A(c,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(c,v){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new i(c,v,this._proxy)}};u=We([xe(0,y.IExtHostRpcService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(ve[248],we([0,1,17,21,3,6,5,2,7,16,20,48,62]),function(J,e,g,L,C,k,T,y,S,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(c,v,_){const b=c.getProxy(T.MainContext.MainThreadQuickOpen);class P{constructor(h,d){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=d}showQuickPick(h,d,w,E=L.CancellationToken.None){this._onDidSelectItem=void 0;const r=Promise.resolve(h),D=++this._instances,R=b.$show(D,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},E),x={},j=R.then(()=>x);return Promise.race([j,r]).then(te=>{if(te!==x)return r.then(Q=>{const N=[];for(let U=0;U<Q.length;U++){const F=Q[U];let V,M,O,q,B;typeof F=="string"?V=F:(V=F.label,M=F.description,O=F.detail,q=F.picked,B=F.alwaysShow),N.push({label:V,description:M,handle:U,detail:O,picked:q,alwaysShow:B})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{w.onDidSelectItem(Q[U])}),b.$setItems(D,N),R.then(U=>{if(typeof U=="number")return Q[U];if(Array.isArray(U))return U.map(F=>Q[F])})})}).then(void 0,te=>{if(!(0,A.isPromiseCanceledError)(te))return b.$setError(D,te),Promise.reject(te)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,d=L.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,b.$input(h,typeof this._validateInput=="function",d).then(void 0,w=>{if(!(0,A.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(h){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,d=L.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!w)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(r=>r.uri.toString()===w.uri.toString())}createQuickPick(h,d){const w=new o(h,d,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(h){const d=new n(h,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(h,d){const w=this._sessions.get(h);w&&w._fireDidChangeValue(d)}$onDidAccept(h){const d=this._sessions.get(h);d&&d._fireDidAccept()}$onDidChangeActive(h,d){const w=this._sessions.get(h);w instanceof o&&w._fireDidChangeActive(d)}$onDidChangeSelection(h,d){const w=this._sessions.get(h);w instanceof o&&w._fireDidChangeSelection(d)}$onDidTriggerButton(h,d){const w=this._sessions.get(h);w&&w._fireDidTriggerButton(d)}$onDidTriggerItemButton(h,d,w){const E=this._sessions.get(h);E instanceof o&&E._fireDidTriggerItemButton(d,w)}$onDidHide(h){const d=this._sessions.get(h);d&&d._fireDidHide()}}class l{constructor(h,d){this._extensionId=h,this._onDidDispose=d,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((d,w)=>{const E=d===S.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(E,d)}),this.update({buttons:h.map((d,w)=>({...s(d),tooltip:d.tooltip,handle:d===S.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const d=this._handlesToButtons.get(h);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,k.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(h){if(!this._disposed){for(const d of Object.keys(h)){const w=h[d];this._pendingUpdate[d]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function f(a){if(a instanceof S.ThemeIcon)return{id:a.id};const h=t(a),d=p(a);return{dark:typeof h=="string"?y.URI.file(h):h,light:typeof d=="string"?y.URI.file(d):d}}function p(a){return typeof a=="object"&&"light"in a?a.light:a}function t(a){return typeof a=="object"&&"dark"in a?a.dark:a}function s(a){const h=f(a.iconPath);let d,w;return"id"in h?w=u.ThemeIcon.asClassName(h):d=h,{iconPath:d,iconClass:w}}class o extends l{constructor(h,d,w){super(h,w);this.enableProposedApi=d,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((d,w)=>{this._handlesToItems.set(w,d),this._itemsToHandles.set(d,w)}),this.update({items:h.map((d,w)=>({label:d.label,description:d.description,handle:w,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons&&this.enableProposedApi?d.buttons.map((E,r)=>({...s(E),tooltip:E.tooltip,handle:r})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(h){const d=(0,i.coalesce)(h.map(w=>this._handlesToItems.get(w)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(h){const d=(0,i.coalesce)(h.map(w=>this._handlesToItems.get(w)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(h,d){const w=this._handlesToItems.get(h);if(!w||!w.buttons||!w.buttons.length)return;const E=w.buttons[d];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:w})}}class n extends l{constructor(h,d){super(h,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?I.default.Error:I.default.Ignore})}}return new P(v,_)}e.createExtHostQuickOpen=m}),define(ve[249],we([0,1,2,3,56,6,17,5,20,99,12,26,35,62,15]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(h){if(h)return typeof h.iconPath=="string"?g.URI.file(h.iconPath):g.URI.isUri(h.iconPath)||m.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function _(h,d){if(!h.iconPath&&!d.iconPath)return 0;if(h.iconPath){if(!d.iconPath)return 1}else return-1;const w=typeof h.iconPath=="string"?h.iconPath:g.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,E=typeof d.iconPath=="string"?d.iconPath:g.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,A.comparePaths)(w,E)}function b(h,d){let w=0;if(h.strikeThrough!==d.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==d.faded)return h.faded?1:-1;if(h.tooltip!==d.tooltip)return(h.tooltip||"").localeCompare(d.tooltip||"");if(w=_(h,d),w!==0)return w;if(h.light&&d.light)w=_(h.light,d.light);else{if(h.light)return 1;if(d.light)return-1}if(w!==0)return w;if(h.dark&&d.dark)w=_(h.dark,d.dark);else{if(h.dark)return 1;if(d.dark)return-1}return w}function P(h,d){if(h.command!==d.command)return h.command<d.command?-1:1;if(h.title!==d.title)return h.title<d.title?-1:1;if(h.tooltip!==d.tooltip){if(h.tooltip!==void 0&&d.tooltip!==void 0)return h.tooltip<d.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(h.arguments===d.arguments)return 0;if(h.arguments)if(d.arguments){if(h.arguments.length!==d.arguments.length)return h.arguments.length-d.arguments.length}else return 1;else return-1;for(let w=0;w<h.arguments.length;w++){const E=h.arguments[w],r=d.arguments[w];if(E!==r)return E<r?-1:1}return 0}function l(h,d){let w=(0,A.comparePaths)(h.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(w!==0)return w;if(h.command&&d.command)w=P(h.command,d.command);else{if(h.command)return 1;if(d.command)return-1}if(w!==0)return w;if(h.decorations&&d.decorations)w=b(h.decorations,d.decorations);else{if(h.decorations)return 1;if(d.decorations)return-1}return w}function f(h,d){for(let w=0;w<h.length;w++)if(h[w]!==d[w])return!1;return!0}function p(h,d){return h.command===d.command&&h.title===d.title&&h.tooltip===d.tooltip&&(h.arguments&&d.arguments?f(h.arguments,d.arguments):h.arguments===d.arguments)}function t(h,d){return(0,S.equals)(h,d,p)}class s{constructor(d,w,E){this._extension=d,this._proxy=w,this._sourceControlHandle=E,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(d){this._proxy.$setInputBoxValue(this._sourceControlHandle,d),this.updateValue(d)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(d){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,d),this._placeholder=d}get validateInput(){return(0,u.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(d){if((0,u.checkProposedApiEnabled)(this._extension),d&&typeof d!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=d,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!d)}get visible(){return this._visible}set visible(d){d=!!d,this._visible!==d&&(this._visible=d,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,d))}focus(){(0,u.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(d,w){(0,u.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,d,w)}$onInputBoxValueChange(d){this.updateValue(d)}updateValue(d){this._value=d,this._onDidChange.fire(d)}}e.ExtHostSCMInputBox=s;class o{constructor(d,w,E,r,D){this._proxy=d,this._commands=w,this._sourceControlHandle=E,this._id=r,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(d){this._label=d,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,d)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(d){this._hideWhenEmpty=d,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(d){this._resourceStates=[...d],this._onDidUpdateResourceStates.fire()}getResourceState(d){return this._resourceStatesMap.get(d)}$executeResourceCommand(d,w){const E=this._resourceStatesCommandsMap.get(d);return E?(0,T.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this._resourceStates].sort(l),E=(0,S.sortedDiff)(this._resourceSnapshot,d,l).map(R=>{const x=R.toInsert.map(j=>{const te=this._resourceHandlePool++;this._resourceStatesMap.set(te,j);const Q=j.resourceUri;let N;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const me=new k.DisposableStore;N=this._commands.converter.toInternal(j.command,me),this._resourceStatesDisposablesMap.set(te,me)}else this._resourceStatesCommandsMap.set(te,j.command);const U=v(j.decorations),F=j.decorations&&v(j.decorations.light)||U,V=j.decorations&&v(j.decorations.dark)||U,M=[F,V],O=j.decorations&&j.decorations.tooltip||"",q=j.decorations&&!!j.decorations.strikeThrough,B=j.decorations&&!!j.decorations.faded,K=j.contextValue||"";return{rawResource:[te,Q,M,O,q,B,K,N],handle:te}});return{start:R.start,deleteCount:R.deleteCount,toInsert:x}}),r=E.map(({start:R,deleteCount:x,toInsert:j})=>[R,x,j.map(te=>te.rawResource)]),D=E.reverse();for(const{start:R,deleteCount:x,toInsert:j}of D){const te=j.map(N=>N.handle),Q=this._handlesSnapshot.splice(R,x,...te);for(const N of Q)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=d,r}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class n{constructor(d,w,E,r,D,R){this._proxy=w,this._commands=E,this._id=r,this._label=D,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new k.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new k.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(d,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,r,D,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(d){this._count!==d&&(this._count=d,this._proxy.$updateSourceControl(this.handle,{count:d}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(d){this._quickDiffProvider=d,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!d})}get commitTemplate(){return this._commitTemplate}set commitTemplate(d){d!==this._commitTemplate&&(this._commitTemplate=d,this._proxy.$updateSourceControl(this.handle,{commitTemplate:d}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(d){this._acceptInputDisposables.value=new k.DisposableStore,this._acceptInputCommand=d;const w=this._commands.converter.toInternal(d,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(d){if(this._statusBarCommands&&d&&t(this._statusBarCommands,d))return;this._statusBarDisposables.value=new k.DisposableStore,this._statusBarCommands=d;const w=(d||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(d,w){const E=new o(this._proxy,this._commands,this.handle,d,w),r=L.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,r),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const d=[],w=[];for(const[E,r]of this.createdResourceGroups){r.dispose();const D=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});L.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),D.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),d.push([E.handle,E.id,E.label,E.features]);const R=E._takeResourceStateSnapshot();R.length>0&&w.push([E.handle,R]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,d,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const d=[];this.updatedResourceGroups.forEach(w=>{const E=w._takeResourceStateSnapshot();E.length!==0&&d.push([w.handle,E])}),d.length>0&&this._proxy.$spliceResourceStates(this.handle,d),this.updatedResourceGroups.clear()}getResourceGroup(d){return this._groups.get(d)}setSelectionState(d){this._selected=d,this._onDidChangeSelection.fire(d)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(d=>d.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,We([(0,C.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),We([(0,C.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let a=class xn{constructor(d,w,E){this._commands=w,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=d.getProxy(y.MainContext.MainThreadSCM),this._telemetry=d.getProxy(y.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===3){const D=this._sourceControls.get(r.sourceControlHandle);if(!D)return r;const R=D.getResourceGroup(r.groupHandle);return R?R.getResourceState(r.handle):r}else if(r&&r.$mid===4){const D=this._sourceControls.get(r.sourceControlHandle);return D?D.getResourceGroup(r.groupHandle):r}else if(r&&r.$mid===5){const D=this._sourceControls.get(r.handle);return D||r}return r}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(d,w,E,r){this.logService.trace("ExtHostSCM#createSourceControl",d.identifier.value,w,E,r),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const D=xn._handlePool++,R=new n(d,this._proxy,this._commands,w,E,r);this._sourceControls.set(D,R);const x=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(d.identifier))||[];return x.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(d.identifier),x),R}getLastInputBox(d){this.logService.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const w=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(d.identifier)),E=w&&w[w.length-1];return E&&E.inputBox}$provideOriginalResource(d,w,E){const r=g.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",d,r.toString());const D=this._sourceControls.get(d);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(r,E)).then(R=>R||null)}$onInputBoxValueChange(d,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",d);const E=this._sourceControls.get(d);return E&&E.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(d,w,E,r){this.logService.trace("ExtHostSCM#$executeResourceCommand",d,w,E);const D=this._sourceControls.get(d);if(!D)return Promise.resolve(void 0);const R=D.getResourceGroup(w);return R?R.$executeResourceCommand(E,r):Promise.resolve(void 0)}$validateInput(d,w,E){this.logService.trace("ExtHostSCM#$validateInput",d);const r=this._sourceControls.get(d);return!r||!r.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>r.inputBox.validateInput(w,E)).then(D=>{if(!D)return Promise.resolve(void 0);const R=c.MarkdownString.fromStrict(D.message);return R?Promise.resolve([R,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this._sourceControls.get(d)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=d,Promise.resolve(void 0)}};a._handlePool=0,a=We([xe(2,i.ILogService)],a),e.ExtHostSCM=a});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[250],we([0,1,7,5,166,6,15]),function(J,e,g,L,C,k,T){"use strict";var y,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(m,c,v,_,b=g.StatusBarAlignment.Left,P){y.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new k.DisposableStore,nt(this,y,m,"f"),nt(this,S,c,"f"),this._entryId=A.ID_GEN++,this._extension=v,this._id=_,this._alignment=b,this._priority=P}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!A.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:$e(this,S,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:$e(this,S,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let c;this._name?c=this._name:c=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;$e(this,y,"f").$setEntry(this._entryId,m,c,this._text,_,this._command?.internal,v,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,y=new WeakMap,S=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class i{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const c={message:m};return this._messages.unshift(c),this._update(),new g.Disposable(()=>{const v=this._messages.indexOf(c);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(m,c){this._proxy=m.getProxy(L.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new i(this)}createStatusBarEntry(m,c,v,_){return new A(this._proxy,this._commands,m,c,v,_)}setStatusBarMessage(m,c){const v=this._statusMessage.setMessage(m);let _;return typeof c=="number"?_=setTimeout(()=>v.dispose(),c):typeof c!="undefined"&&c.then(()=>v.dispose(),()=>v.dispose()),new g.Disposable(()=>{v.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=I}),define(ve[92],we([0,1,5,3,4]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class k{constructor(y){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,S){this._proxy.$registerExtensionStorageKeysToSync(y,S)}getValue(y,S,A){return this._proxy.$getValue(y,S).then(i=>i||A)}setValue(y,S,A){return this._proxy.$setValue(y,S,A)}$acceptValue(y,S,A){this._onDidChangeStorage.fire({shared:y,key:S,value:A})}}e.ExtHostStorage=k,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(ve[67],we([0,1,4,27,12,91,2]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let y=class{constructor(A,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(A){return T.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,i=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(A){if(this._value)return T.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return T.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};y=We([xe(0,L.IExtHostInitDataService),xe(1,C.ILogService),xe(2,k.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(ve[33],we([0,1,3,5,4,2,13,6,7,167,16,214,21,32,195,62,14]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class b{constructor(a,h,d,w){this._proxy=a,this._id=h,this._creationOptions=d,this._name=w,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(r=>this._pidPromiseComplete=r);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},sendText(r,D=!0){E._checkDisposed(),E._proxy.$sendText(E._id,r,D)},show(r){E._checkDisposed(),E._proxy.$show(E._id,r)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(a,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:a.name,shellPath:(0,_.withNullAsUndefined)(a.shellPath),shellArgs:(0,_.withNullAsUndefined)(a.shellArgs),cwd:(0,_.withNullAsUndefined)(a.cwd),env:(0,_.withNullAsUndefined)(a.env),icon:(0,_.withNullAsUndefined)(s(a.iconPath)),color:v.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,_.withNullAsUndefined)(a.message),strictEnv:(0,_.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(h?.useShellEnvironment),isSplitTerminal:h?.isSplitTerminal,target:h?.target})}async createExtensionTerminal(a,h,d,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:v.ThemeColor.isThemeColor(w)?w.id:void 0,isSplitTerminal:a,target:h}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(a){this._name=a}setExitCode(a){this._exitStatus=Object.freeze({code:a})}setDimensions(a,h){return a===this._cols&&h===this._rows||a===0||h===0?!1:(this._cols=a,this._rows=h,!0)}_setProcessId(a){this._pidPromiseComplete?(this._pidPromiseComplete(a),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==a&&(this._pidPromise=Promise.resolve(a))})}}e.ExtHostTerminal=b;class P{constructor(a){this._pty=a,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(a){this._pty.handleInput&&this._pty.handleInput(a)}resize(a,h){this._pty.setDimensions&&this._pty.setDimensions({columns:a,rows:h})}async processBinary(a){}acknowledgeDataEvent(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose&&this._pty.onDidClose((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(h=>this._onProcessOverrideDimensions.fire(h&&{cols:h.columns,rows:h.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(h=>this._onProcessTitleChanged.fire(h)),this._pty.open(a||void 0),this._pty.setDimensions&&a&&this._pty.setDimensions(a),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=P;let l=1,f=class extends y.Disposable{constructor(a,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=h.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(a),this._register({dispose:()=>{for(const[d,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(a=>a.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(a,h){const d=new b(this._proxy,(0,m.generateUuid)(),a,a.name),w=new P(a.pty);return d.createExtensionTerminal(h?.isSplitTerminal,h?.target,s(a.iconPath),o(a.color)).then(E=>{const r=this._setupExtHostProcessListeners(E,w);this._terminalProcessDisposables[E]=r}),this._terminals.push(d),d.value}attachPtyToTerminal(a,h){if(!this._getTerminalById(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const w=new P(h),E=this._setupExtHostProcessListeners(a,w);this._terminalProcessDisposables[a]=E}async $acceptActiveTerminalChanged(a){const h=this._activeTerminal;if(a===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(a);d&&(this._activeTerminal=d,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(a,h){const d=this._getTerminalById(a);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:h})}async $acceptTerminalDimensions(a,h,d){const w=this._getTerminalById(a);w&&w.setDimensions(h,d)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(a,h,d){this._terminalProcesses.get(a)?.resize(h,d)}async $acceptTerminalTitleChange(a,h){const d=this._getTerminalById(a);d&&(d.name=h)}async $acceptTerminalClosed(a,h){const d=this._getTerminalObjectIndexById(this._terminals,a);if(d!==null){const w=this._terminals.splice(d,1)[0];w.setExitCode(h),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(a,h,d,w){if(h){const D=this._getTerminalObjectIndexById(this._terminals,h);if(D!==null){this._terminals[D]._id=a,this._onDidOpenTerminal.fire(this.terminals[D]),this._terminals[D].isOpen=!0;return}}const E={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:k.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},r=new b(this._proxy,a,E,d);this._terminals.push(r),this._onDidOpenTerminal.fire(r.value),r.isOpen=!0}async $acceptTerminalProcessId(a,h){const d=this._getTerminalById(a);d&&d._setProcessId(h)}async $startExtensionTerminal(a,h){const d=this._getTerminalById(a);if(!d)return{message:(0,A.localize)(0,null,a)};d.isOpen||await new Promise(E=>{const r=this.onDidOpenTerminal(async D=>{D===d.value&&(r.dispose(),E())})});const w=this._terminalProcesses.get(a);w?w.startSendingEvents(h):this._extensionTerminalAwaitingStart[a]={initialDimensions:h}}_setupExtHostProcessListeners(a,h){const d=new y.DisposableStore;d.add(h.onProcessReady(E=>this._proxy.$sendProcessReady(a,E.pid,E.cwd))),d.add(h.onProcessTitleChanged(E=>this._proxy.$sendProcessTitle(a,E))),this._bufferer.startBuffering(a,h.onProcessData),d.add(h.onProcessExit(E=>this._onProcessExit(a,E))),h.onProcessOverrideDimensions&&d.add(h.onProcessOverrideDimensions(E=>this._proxy.$sendOverrideDimensions(a,E))),this._terminalProcesses.set(a,h);const w=this._extensionTerminalAwaitingStart[a];return w&&h instanceof P&&(h.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[a]),d}$acceptProcessAckDataEvent(a,h){this._terminalProcesses.get(a)?.acknowledgeDataEvent(h)}$acceptProcessInput(a,h){this._terminalProcesses.get(a)?.input(h)}$acceptProcessResize(a,h,d){try{this._terminalProcesses.get(a)?.resize(h,d)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(a,h){this._terminalProcesses.get(a)?.shutdown(h)}$acceptProcessRequestInitialCwd(a){this._terminalProcesses.get(a)?.getInitialCwd().then(h=>this._proxy.$sendProcessInitialCwd(a,h))}$acceptProcessRequestCwd(a){this._terminalProcesses.get(a)?.getCwd().then(h=>this._proxy.$sendProcessCwd(a,h))}$acceptProcessRequestLatency(a){return a}registerLinkProvider(a){return this._linkProviders.add(a),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(a),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(a,h,d){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,d),this._proxy.$registerProfileProvider(h,a.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(a,h){const d=new u.CancellationTokenSource().token,w=await this._profileProviders.get(a)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,h);return}this.createTerminalFromOptions(w.options,h)}}async $provideLinks(a,h){const d=this._getTerminalById(a);if(!d)return[];this._terminalLinkCache.delete(a);const w=this._terminalLinkCancellationSource.get(a);w&&w.dispose(!0);const E=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(a,E);const r=[],D={terminal:d.value,line:h},R=[];for(const te of this._linkProviders)R.push(new Promise(async Q=>{E.token.onCancellationRequested(()=>Q({provider:te,links:[]}));const N=await te.provideTerminalLinks(D,E.token)||[];E.token.isCancellationRequested||Q({provider:te,links:N})}));const x=await Promise.all(R);if(E.token.isCancellationRequested)return[];const j=new Map;for(const te of x)te&&te.links.length>0&&r.push(...te.links.map(Q=>{const N={id:l++,startIndex:Q.startIndex,length:Q.length,label:Q.tooltip};return j.set(N.id,{provider:te.provider,link:Q}),N}));return this._terminalLinkCache.set(a,j),r}$activateLink(a,h){const d=this._terminalLinkCache.get(a)?.get(h);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(a,h){this._bufferer.stopBuffering(a),this._terminalProcesses.delete(a),delete this._extensionTerminalAwaitingStart[a];const d=this._terminalProcessDisposables[a];d&&(d.dispose(),delete this._terminalProcessDisposables[a]),this._proxy.$sendProcessExit(a,h)}_getTerminalById(a){return this._getTerminalObjectById(this._terminals,a)}_getTerminalObjectById(a,h){const d=this._getTerminalObjectIndexById(a,h);return d!==null?a[d]:null}_getTerminalObjectIndexById(a,h){let d=null;return a.some((w,E)=>w._id===h?(d=E,!0):!1),d}getEnvironmentVariableCollection(a){let h=this._environmentVariableCollections.get(a.identifier.value);return h||(h=new p,this._setEnvironmentVariableCollection(a.identifier.value,h)),h}_syncEnvironmentVariableCollection(a,h){const d=(0,I.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(a,h.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(a){a.forEach(h=>{const d=h[0],w=new p(h[1]);this._setEnvironmentVariableCollection(d,w)})}$acceptDefaultProfile(a,h){this._defaultProfile=a,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(a,h){this._environmentVariableCollections.set(a,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(a,h)})}};f=We([xe(1,T.IExtHostRpcService)],f),e.BaseExtHostTerminalService=f;class p{constructor(a){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(a)}get persistent(){return this._persistent}set persistent(a){this._persistent=a,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(a,h){this._setIfDiffers(a,{value:h,type:S.EnvironmentVariableMutatorType.Replace})}append(a,h){this._setIfDiffers(a,{value:h,type:S.EnvironmentVariableMutatorType.Append})}prepend(a,h){this._setIfDiffers(a,{value:h,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(a,h){const d=this.map.get(a);(!d||d.value!==h.value||d.type!==h.type)&&(this.map.set(a,h),this._onDidChangeCollection.fire())}get(a){return this.map.get(a)}forEach(a,h){this.map.forEach((d,w)=>a.call(h,w,d,this))}delete(a){this.map.delete(a),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let t=class extends f{constructor(a){super(!1,a)}createTerminal(a,h,d){throw new i.NotSupportedError}createTerminalFromOptions(a,h){throw new i.NotSupportedError}};t=We([xe(0,T.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function s(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function o(n){return v.ThemeColor.isThemeColor(n)?n:void 0}});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[251],we([0,1,24,21,3,73,58,75,6,25,14,32,5,13,87,15,7,222,126,89]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(R,x){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(u.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new s(this.proxy),x.registerArgumentProcessor({processArgument:j=>j?.$mid===13?v.TestItem.toItemFromContext(j):j})}createTestController(R,x){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const j=new S.DisposableStore,te=j.add(new b.SingleUseTestCollection(R));te.root.label=x;const Q=new Map,N=this.proxy,U={items:te.root.children,get label(){return x},set label(V){x=V,te.root.label=V,N.$updateControllerLabel(R,x)},get id(){return R},createRunProfile:(V,M,O,q,B)=>{let K=(0,T.hash)(V);for(;Q.has(K);)K++;const ne=new E(this.proxy,R,K,V,M,O,q,B);return Q.set(K,ne),ne},createTestItem(V,M,O){return new c.TestItemImpl(R,V,M,O)},createTestRun:(V,M,O=!0)=>this.runTracker.createTestRun(R,te,V,M,O),set resolveHandler(V){te.resolveHandler=V},get resolveHandler(){return te.resolveHandler},dispose:()=>{j.dispose()}};U.createRunConfiguration=U.createRunProfile,N.$registerTestController(R,x),j.add((0,S.toDisposable)(()=>N.$unregisterTestController(R)));const F={controller:U,collection:te,profiles:Q};return this.controllers.set(R,F),j.add((0,S.toDisposable)(()=>this.controllers.delete(R))),j.add(te.onDidGenerateDiff(V=>N.$publishDiff(R,V))),U}createTestObserver(){return this.observer.checkout()}async runTests(R,x=L.CancellationToken.None){const j=o(R);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const te=this.controllers.get(j.controllerId);if(!te)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(Q=>Q.id)??[te.collection.root.id],profileGroup:r[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:R.exclude?.map(Q=>Q.id)},x)}$provideFileCoverage(R,x,j){return y.Iterable.find(this.runTracker.trackers,te=>te.id===R)?.getCoverage(x)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(R,x,j,te){return y.Iterable.find(this.runTracker.trackers,Q=>Q.id===R)?.getCoverage(x)?.resolveFileCoverage(j,te)??Promise.resolve([])}$configureRunProfile(R,x){this.controllers.get(R)?.profiles.get(x)?.configureHandler?.()}$getTestTags(R){const x=this.controllers.get(R);if(!x)return Promise.resolve([]);const j=new Map;for(const te of x.profiles.values())if(te.tag){const Q=v.TestTag.display(R,te.tag);j.set(Q.id,Q)}for(const te of x.collection.tags()){const Q=v.TestTag.display(R,te);j.set(Q.id,Q)}return Promise.resolve([...j.values()])}$publishTestResults(R){this.results=Object.freeze(R.map(x=>(0,A.deepFreeze)(v.TestResults.to(x))).concat(this.results).sort((x,j)=>j.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,x){const j=this.controllers.get(l.TestId.fromString(R).controllerId)?.collection;j&&(await j.expand(R,x<0?Infinity:x),j.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,x){const j=this.controllers.get(R.controllerId);if(!j)return;const{collection:te,profiles:Q}=j,N=Q.get(R.profileId);if(!N)return;const U=R.testIds.map(O=>te.tree.get(O)).filter(i.isDefined),F=R.excludeExtIds.map(O=>j.collection.tree.get(O)).filter(i.isDefined).filter(O=>U.some(q=>q.fullId.compare(O.fullId)===2));if(!U.length)return;const V=new _.TestRunRequest(U.some(O=>O.actual instanceof c.TestItemRootImpl)?void 0:U.map(O=>O.actual),F.map(O=>O.actual),N),M=this.runTracker.prepareForMainThreadTestRun(V,n.fromInternal(R,j.collection),x);try{await N.runHandler(V,x)}finally{M.isRunning&&!x.isCancellationRequested&&await C.Event.toPromise(M.onEnd),this.runTracker.cancelRunById(R.runId)}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};p=We([xe(0,m.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends S.Disposable{constructor(R,x,j){super();this.dto=R,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new L.CancellationTokenSource(j)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:te}of this.tasks.values())te.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const x=this.dto.id,j=this.dto.controllerId,te=(0,I.generateUuid)(),Q=new a(this.proxy,x,te),N=V=>(M,...O)=>{if(U){console.warn(`Setting the state of test "${M.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(M)||(this.ensureTestIsKnown(M),V(M,...O))};let U=!1;const F={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return Q.coverageProvider},set coverageProvider(V){Q.coverageProvider=V},enqueued:N(V=>{this.proxy.$updateTestStateInRun(x,te,l.TestId.fromExtHostTestItem(V,j).toString(),1)}),skipped:N(V=>{this.proxy.$updateTestStateInRun(x,te,l.TestId.fromExtHostTestItem(V,j).toString(),5)}),started:N(V=>{this.proxy.$updateTestStateInRun(x,te,l.TestId.fromExtHostTestItem(V,j).toString(),2)}),errored:N((V,M,O)=>{this.proxy.$appendTestMessagesInRun(x,te,l.TestId.fromExtHostTestItem(V,j).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(x,te,l.TestId.fromExtHostTestItem(V,j).toString(),6,O)}),failed:N((V,M,O)=>{this.proxy.$appendTestMessagesInRun(x,te,l.TestId.fromExtHostTestItem(V,j).toString(),M instanceof Array?M.map(v.TestMessage.from):[v.TestMessage.from(M)]),this.proxy.$updateTestStateInRun(x,te,l.TestId.fromExtHostTestItem(V,j).toString(),4,O)}),passed:N((V,M)=>{this.proxy.$updateTestStateInRun(x,te,l.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,M)}),appendOutput:(V,M,O)=>{U||(O&&(this.dto.isIncluded(O)?this.ensureTestIsKnown(O):O=void 0),this.proxy.$appendOutputToRun(x,te,g.VSBuffer.fromString(V),M&&v.location.from(M),O&&l.TestId.fromExtHostTestItem(O,j).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(x,te),this.tasks.delete(te),this.isRunning||this.dispose())}};return this.tasks.set(te,{run:F,coverage:Q}),this.proxy.$startedTestRunTask(x,{id:te,name:R,running:!0}),F}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof c.TestItemImpl))throw new c.InvalidTestItemError(R.id);if(this.sharedTestIds.has(R.id))return;const x=[];for(;x.unshift(v.TestItem.from(R)),!(this.sharedTestIds.has(R.id)||(this.sharedTestIds.add(R.id),!R.parent));)R=R.parent;const j=this.dto.colllection.root;this.sharedTestIds.has(j.id)||(this.sharedTestIds.add(j.id),x.unshift(v.TestItem.from(j))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class s{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,x,j){return this.getTracker(R,x,j)}cancelRunById(R){for(const x of this.tracked.values())if(x.id===R){x.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,x,j,te,Q){const N=this.tracked.get(j);if(N)return N.createRun(te);const U=n.fromPublic(R,x,j,Q),F=o(j);this.proxy.$startedExtensionTestRun({controllerId:R,profile:F&&{group:r[F.kind],id:F.profileId},exclude:j.exclude?.map(M=>M.id)??[],id:U.id,include:j.include?.map(M=>M.id)??[x.root.id],persist:Q});const V=this.getTracker(j,U);return V.onEnd(()=>this.proxy.$finishedExtensionTestRun(U.id)),V.createRun(te)}getTracker(R,x,j){const te=new t(x,this.proxy,j);return this.tracked.set(R,te),te.onEnd(()=>this.tracked.delete(R)),te}}e.TestRunCoordinator=s;const o=D=>{if(!!D.profile){if(!(D.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class n{constructor(R,x,j,te,Q,N){this.controllerId=R,this.id=x,this.isPersisted=Q,this.colllection=N,this.includePrefix=j.map(U=>U+"\0"),this.excludePrefix=te.map(U=>U+"\0")}static fromPublic(R,x,j,te){return new n(R,(0,I.generateUuid)(),j.include?.map(Q=>l.TestId.fromExtHostTestItem(Q,R).toString())??[R],j.exclude?.map(Q=>l.TestId.fromExtHostTestItem(Q,R).toString())??[],te,x)}static fromInternal(R,x){return new n(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,x)}isIncluded(R){const x=l.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const j of this.excludePrefix)if(x===j||x.startsWith(j))return!1;for(const j of this.includePrefix)if(x===j||x.startsWith(j))return!0;return!1}}e.TestRunDto=n;class a{constructor(R,x,j){this.proxy=R,this.runId=x,this.taskId=j}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(R,x){const j=await this.fileCoverage;let te=j?.[R];return!this._coverageProvider||!j||!te?[]:(te.detailedCoverage||(te=j[R]=await this._coverageProvider.resolveFileCoverage?.(te,x)??te),te.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class h extends P.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,v.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:x,removed:j}=this;return{get added(){return[...R].map(te=>te.revived)},get updated(){return[...x].map(te=>te.revived)},get removed(){return[...j].map(te=>te.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,x){return{...R,revived:v.TestItem.toPlain(R.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=d;class w{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(x=>x.revived)},dispose:(0,k.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class E{constructor(R,x,j,te,Q,N,U=!1,F=void 0){this.controllerId=x,this.profileId=j,this._label=te,this.kind=Q,this.runHandler=N,this._isDefault=U,this._tag=F,f.set(this,void 0),nt(this,f,R,"f");const V=r[Q];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);$e(this,f,"f").$publishTestRunProfile({profileId:j,controllerId:x,tag:F?v.TestTag.namespace(this.controllerId,F.id):null,label:te,group:V,isDefault:U,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,$e(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,$e(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,$e(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?v.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,$e(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){$e(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=E,f=new WeakMap;const r={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(ve[252],we([0,1,3,20,5,129,15,7]),function(J,e,g,L,C,k,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(u=>u.value)}async showTextDocument(i,I,u){let m;typeof I=="number"?m={position:T.ViewColumn.from(I),preserveFocus:u}:typeof I=="object"?m={position:T.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?T.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:m={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(i.uri,m),v=c&&this._extHostDocumentsAndEditors.getEditor(c);if(v)return v.value;throw c?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new k.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const u=this._extHostDocumentsAndEditors.getEditor(i);if(!u)throw new Error("unknown text editor");if(I.options&&u._acceptOptions(I.options),I.selections){const m=I.selections.selections.map(T.Selection.to);u._acceptSelections(m)}if(I.visibleRanges){const m=L.coalesce(I.visibleRanges.map(T.Range.to));u._acceptVisibleRanges(m)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...I.options,lineNumbers:T.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const m=y.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:c,kind:m})}if(I.visibleRanges){const m=L.coalesce(I.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:m})}}$acceptEditorPositionData(i){for(const I in i){const u=this._extHostDocumentsAndEditors.getEditor(I);if(!u)throw new Error("Unknown text editor");const m=T.ViewColumn.to(i[I]);u.value.viewColumn!==m&&(u._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:m}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S}),define(ve[253],we([0,1,2,4,5,6,7]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class y{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const m=u.uri===void 0?void 0:g.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(S(m))?.get(u.handle)}return u}})}async $getTimeline(i,I,u,m,c){return this._providers.get(i)?.provideTimeline(g.URI.revive(I),u,m,c)}registerTimelineProvider(i,I,u,m){const c=new k.DisposableStore,v=this.convertTimelineItem(I.id,m,c).bind(this);let _;I.onDidChange&&(_=I.onDidChange(P=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...P,id:I.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(P,l,f,p){p?.resetCache&&(c.clear(),b.get(I.id)?.clear());const t=await I.provideTimeline(P,l,f);if(t==null)return;const s=v(P,p);return{...t,source:I.id,items:t.items.map(s)}},dispose(){for(const P of b.values())P.get(I.id)?.clear();_?.dispose(),c.dispose()}})}convertTimelineItem(i,I,u){return(m,c)=>{let v;if(c?.cacheResults){let _=this._itemsBySourceAndUriMap.get(i);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(i,_));const b=S(m);v=_.get(b),v===void 0&&(v=new Map,_.set(b,v))}return _=>{const{iconPath:b,...P}=_,l=`${i}|${_.id??_.timestamp}`;v?.set(l,_);let f,p,t;return _.iconPath&&(b instanceof T.ThemeIcon?t={id:b.id,color:b.color}:g.URI.isUri(b)?(f=b,p=b):{light:f,dark:p}=b),{...P,id:P.id??void 0,handle:l,source:i,command:_.command?I.toInternal(_.command,u):void 0,icon:f,iconDark:p,themeIcon:t,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,k.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=y;function S(A){return A?.toString()}}),define(ve[254],we([0,1,6,10,2,5]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(S){this._openers=new Map,this._proxy=S.getProxy(k.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,A,i,I){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const u=I.schemes.find(m=>!T.supportedSchemes.has(m));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,i),this._proxy.$registerUriOpener(A,I.schemes,S,I.label),(0,g.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(S,A,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const u=C.URI.revive(A);return I.canOpenExternalUri(u,i)}async $openUri(S,A,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(C.URI.revive(A.resolvedUri),{sourceUri:C.URI.revive(A.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(ve[255],we([0,1,5,2,6,16,26]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(A,i){if(this.handles.has(T.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const I=y.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(A)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,A),(0,C.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(A)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(A,i){const I=this.handlers.get(A);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(i))}catch(u){(0,k.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(A){return L.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=y,y.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[68],we([0,1,3,2,179,204,88,5]),function(J,e,g,L,C,k,T,y){"use strict";var S,A,i,I,u,m,c,v,_,b,P,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(d,w,E,r,D,R,x){S.set(this,void 0),A.set(this,void 0),i.set(this,void 0),I.set(this,void 0),u.set(this,void 0),m.set(this,void 0),c.set(this,""),v.set(this,void 0),_.set(this,!1),b.set(this,!1),P.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new g.Emitter),this._onDidDispose=$e(this,l,"f").event,nt(this,S,d,"f"),nt(this,A,w,"f"),nt(this,v,E,"f"),nt(this,I,r,"f"),nt(this,u,D,"f"),nt(this,m,R,"f"),nt(this,P,p(R),"f"),nt(this,i,x,"f")}dispose(){nt(this,_,!0,"f"),$e(this,l,"f").fire(),$e(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return nt(this,b,!0,"f"),(0,T.asWebviewUri)(d,$e(this,I,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),$e(this,c,"f")}set html(d){this.assertNotDisposed(),$e(this,c,"f")!==d&&(nt(this,c,d,"f"),!$e(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(nt(this,b,!0,"f"),$e(this,i,"f").report("Webview vscode-resource: uris",$e(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,A,"f").$setHtml($e(this,S,"f"),d))}get options(){return this.assertNotDisposed(),$e(this,v,"f")}set options(d){this.assertNotDisposed(),$e(this,A,"f").$setOptions($e(this,S,"f"),o($e(this,m,"f"),$e(this,u,"f"),d)),nt(this,v,d,"f")}async postMessage(d){if($e(this,_,"f"))return!1;const w=(0,k.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:$e(this,P,"f")});return $e(this,A,"f").$postMessage($e(this,S,"f"),w.message,...w.buffers)}assertNotDisposed(){if($e(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,S=new WeakMap,A=new WeakMap,i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,c=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,P=new WeakMap,l=new WeakMap;function p(h){try{const d=(0,C.normalizeVersion)((0,C.parseVersion)(h.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(d,w,E,r,D){this.initData=w,this.workspace=E,this._logService=r,this._deprecationService=D,this._webviews=new Map,this._webviewProxy=d.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(d,w,...E){const r=this.getWebview(d);if(r){const{message:D}=(0,k.deserializeWebviewMessage)(w,E);r._onMessageEmitter.fire(D)}}$onMissingCsp(d,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,w,E){const r=new f(d,this._webviewProxy,n(w),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(d,r),r._onDidDispose(()=>{this._webviews.delete(d)}),r}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=t;function s(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=s;function o(h,d,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||a(h,d)}}e.serializeWebviewOptions=o;function n(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(d=>L.URI.from(d))}}e.reviveOptions=n;function a(h,d){return[...(d?.getWorkspaceFolders()||[]).map(w=>w.uri),h.extensionLocation]}}),define(ve[256],we([0,1,21,58,6,10,23,2,15,68,86,5,7]),function(J,e,g,L,C,k,T,y,S,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class c{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,o){const n=this.key(t,s.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const a=new m(s,o);return this._documents.set(n,a),a}delete(t,s){const o=this.key(t,s.uri);this._documents.delete(o)}key(t,s){return`${t}@@@${s}`}}var v;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(v||(v={}));class _{constructor(){this._providers=new Map}addTextProvider(t,s,o){return this.add(0,t,s,o)}addCustomProvider(t,s,o){return this.add(1,t,s,o)}get(t){return this._providers.get(t)}add(t,s,o,n){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:o,provider:n}),new u.Disposable(()=>this._providers.delete(s))}}class b{constructor(t,s,o,n,a){this._extHostDocuments=s,this._extensionStoragePaths=o,this._extHostWebview=n,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,o,n){const a=new C.DisposableStore;return P(o)?(a.add(this._editorProviders.addTextProvider(s,t,o)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(t),s,n.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(s,t,o)),this.supportEditing(o)&&a.add(o.onDidChangeCustomDocument(h=>{const d=this.getCustomDocumentEntry(s,h.document.uri);if(l(h)){const w=d.addEdit(h);this._proxy.$onDidEdit(h.document.uri,s,w,h.label)}else this._proxy.$onContentChange(h.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(t),s,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(t))),u.Disposable.from(a,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,o,n,a){const h=this._editorProviders.get(s);if(!h)throw new Error(`No provider found for '${s}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${s}'`);const d=y.URI.revive(t),w=await h.provider.openCustomDocument(d,{backupId:o,untitledDocumentData:n?.buffer},a);let E;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(s,w,E),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,s){const o=this._editorProviders.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const n=y.URI.revive(t),{document:a}=this.getCustomDocumentEntry(s,n);this._documents.delete(s,a),a.dispose()}async $resolveWebviewEditor(t,s,o,n,a,h){const d=this._editorProviders.get(o);if(!d)throw new Error(`No provider found for '${o}'`);const w=S.ViewColumn.to(a),E=this._extHostWebview.createNewWebview(s,n.webviewOptions,d.extension),r=this._extHostWebviewPanels.createNewWebviewPanel(s,o,n.title,w,n.panelOptions,E),D=y.URI.revive(t);switch(d.type){case 1:{const{document:R}=this.getCustomDocumentEntry(o,D);return d.provider.resolveCustomEditor(R,r,h)}case 0:{const R=this._extHostDocuments.getDocument(D);return d.provider.resolveCustomTextEditor(R,r,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,o){this.getCustomDocumentEntry(s,t).disposeEdits(o)}async $onMoveCustomEditor(t,s,o){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const h=y.URI.revive(s),d=this._extHostDocuments.getDocument(h);await n.provider.moveCustomTextEditor(d,a,g.CancellationToken.None)}async $undo(t,s,o,n){return this.getCustomDocumentEntry(s,t).undo(o,n)}async $redo(t,s,o,n){return this.getCustomDocumentEntry(s,t).redo(o,n)}async $revert(t,s,o){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(n.document,o),n.disposeBackup()}async $onSave(t,s,o){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(n.document,o),n.disposeBackup()}async $onSaveAs(t,s,o,n){const a=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(a.document,y.URI.revive(o),n)}async $backup(t,s,o){const n=this.getCustomDocumentEntry(s,t),h=await this.getCustomEditorProvider(s).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},o);return n.updateBackup(h),h.id}getCustomDocumentEntry(t,s){const o=this._documents.get(t,y.URI.revive(s));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const o=this._editorProviders.get(t)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function P(p){return typeof p.resolveCustomTextEditor=="function"}function l(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function f(p){const t=p.scheme===k.Schemas.file||p.scheme===k.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[257],we([0,1,3,6,2,32,15,68,5,7]),function(J,e,g,L,C,k,T,y,S,A){"use strict";var i,I,u,m,c,v,_,b,P,l,f,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends L.Disposable{constructor(h,d,w,E,r,D,R){super();i.set(this,void 0),I.set(this,void 0),u.set(this,void 0),m.set(this,void 0),c.set(this,void 0),v.set(this,void 0),_.set(this,void 0),b.set(this,void 0),P.set(this,!0),l.set(this,!0),f.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=$e(this,p,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,nt(this,i,h,"f"),nt(this,I,d,"f"),nt(this,u,w,"f"),nt(this,c,D,"f"),nt(this,b,r,"f"),nt(this,v,E,"f"),nt(this,m,R,"f")}dispose(){$e(this,f,"f")||(nt(this,f,!0,"f"),$e(this,p,"f").fire(),$e(this,I,"f").$disposeWebview($e(this,i,"f")),$e(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,m,"f")}get viewType(){return this.assertNotDisposed(),$e(this,u,"f")}get title(){return this.assertNotDisposed(),$e(this,v,"f")}set title(h){this.assertNotDisposed(),$e(this,v,"f")!==h&&(nt(this,v,h,"f"),$e(this,I,"f").$setTitle($e(this,i,"f"),h))}get iconPath(){return this.assertNotDisposed(),$e(this,_,"f")}set iconPath(h){this.assertNotDisposed(),$e(this,_,"f")!==h&&(nt(this,_,h,"f"),$e(this,I,"f").$setIconPath($e(this,i,"f"),C.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return $e(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,b,"f")=="number"&&$e(this,b,"f")<0))return $e(this,b,"f")}get active(){return this.assertNotDisposed(),$e(this,l,"f")}get visible(){return this.assertNotDisposed(),$e(this,P,"f")}_updateViewState(h){$e(this,f,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(nt(this,l,h.active,"f"),nt(this,P,h.visible,"f"),nt(this,b,h.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(h,d){this.assertNotDisposed(),$e(this,I,"f").$reveal($e(this,i,"f"),{viewColumn:h?T.ViewColumn.from(h):void 0,preserveFocus:!!d})}assertNotDisposed(){if($e(this,f,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,c=new WeakMap,v=new WeakMap,_=new WeakMap,b=new WeakMap,P=new WeakMap,l=new WeakMap,f=new WeakMap,p=new WeakMap,t=new WeakMap;class o{constructor(h,d,w){this.webviews=d,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,k.generateUuid)()}createWebviewPanel(h,d,w,E,r={}){const D=typeof E=="object"?E.viewColumn:E,R={viewColumn:T.ViewColumn.from(D),preserveFocus:typeof E=="object"&&!!E.preserveFocus},x=(0,y.shouldSerializeBuffersForPostMessage)(h),j=o.newHandle();this._proxy.$createWebviewPanel((0,y.toExtensionData)(h),j,d,{title:w,panelOptions:n(r),webviewOptions:(0,y.serializeWebviewOptions)(h,this.workspace,r),serializeBuffersForPostMessage:x},R);const te=this.webviews.createNewWebview(j,r,h);return this.createNewWebviewPanel(j,d,w,D,r,te)}$onDidChangeWebviewPanelViewStates(h){const d=Object.keys(h);d.sort((w,E)=>{const r=h[w],D=h[E];return r.active?1:D.active?-1:+r.visible-+D.visible});for(const w of d){const E=this.getWebviewPanel(w);if(!E)continue;const r=h[w];E._updateViewState({active:r.active,visible:r.visible,viewColumn:T.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,d,w){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:w,extension:h}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(h)}),new A.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(h,d,w,E){const r=this._serializers.get(d);if(!r)throw new Error(`No serializer found for '${d}'`);const{serializer:D,extension:R}=r,x=this.webviews.createNewWebview(h,w.webviewOptions,R),j=this.createNewWebviewPanel(h,d,w.title,E,w.panelOptions,x);await D.deserializeWebviewPanel(j,w.state)}createNewWebviewPanel(h,d,w,E,r,D){const R=new s(h,this._proxy,d,w,E,r,D);return this._webviewPanels.set(h,R),R}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=o;function n(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[258],we([0,1,3,6,68,5,7]),function(J,e,g,L,C,k,T){"use strict";var y,S,A,i,I,u,m,c,v,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends L.Disposable{constructor(f,p,t,s,o,n){super();y.set(this,void 0),S.set(this,void 0),A.set(this,void 0),i.set(this,void 0),I.set(this,!1),u.set(this,void 0),m.set(this,void 0),c.set(this,void 0),v.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=$e(this,v,"f").event,_.set(this,this._register(new g.Emitter)),this.onDidDispose=$e(this,_,"f").event,nt(this,A,t,"f"),nt(this,m,s,"f"),nt(this,y,f,"f"),nt(this,S,p,"f"),nt(this,i,o,"f"),nt(this,u,n,"f")}dispose(){$e(this,I,"f")||(nt(this,I,!0,"f"),$e(this,_,"f").fire(),$e(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,m,"f")}set title(f){this.assertNotDisposed(),$e(this,m,"f")!==f&&(nt(this,m,f,"f"),$e(this,S,"f").$setWebviewViewTitle($e(this,y,"f"),f))}get description(){return this.assertNotDisposed(),$e(this,c,"f")}set description(f){this.assertNotDisposed(),$e(this,c,"f")!==f&&(nt(this,c,f,"f"),$e(this,S,"f").$setWebviewViewDescription($e(this,y,"f"),f))}get visible(){return $e(this,u,"f")}get webview(){return $e(this,i,"f")}get viewType(){return $e(this,A,"f")}_setVisible(f){f===$e(this,u,"f")||$e(this,I,"f")||(nt(this,u,f,"f"),$e(this,v,"f").fire())}show(f){this.assertNotDisposed(),$e(this,S,"f").$show($e(this,y,"f"),!!f)}assertNotDisposed(){if($e(this,I,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,S=new WeakMap,A=new WeakMap,i=new WeakMap,I=new WeakMap,u=new WeakMap,m=new WeakMap,c=new WeakMap,v=new WeakMap,_=new WeakMap;class P{constructor(f,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,p,t,s){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(f),p,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(f,p,t,s,o){const n=this._viewProviders.get(p);if(!n)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:h}=n,d=this._extHostWebview.createNewWebview(f,{},h),w=new b(f,this._proxy,p,t,d,!0);this._webviewViews.set(f,w),await a.resolveWebviewView(w,{state:s},o)}async $onDidChangeWebviewViewVisibility(f,p){this.getWebviewView(f)._setVisible(p)}async $disposeWebviewView(f){const p=this.getWebviewView(f);this._webviewViews.delete(f),p.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const p=this._webviewViews.get(f);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=P}),define(ve[132],we([0,1,3,5,2,10,9,4,13]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class Bn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Bn.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,u){let m;if(typeof I=="string"){m=I;try{I=C.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,T.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===k.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,m,u)}async asExternalUri(I,u){if((0,T.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(I,u);return C.URI.from(m)}};A.InitialState={focused:!0},A=We([xe(0,S.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,y.createDecorator)("IExtHostWindow")}),define(ve[259],we([0,1,8,79,32,44,6,5,2,13]),function(J,e,g,L,C,k,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(u,m){super();const c=u.getProxy(y.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async v=>{const _=S.URI.file((0,g.join)((0,L.tmpdir)(),(0,C.generateUuid)()));return await c.$download(v,_),_})}};i=We([xe(0,A.IExtHostRpcService),xe(1,k.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(ve[260],we([0,1,2,8,151,28,66,27,13,6,12,115,42]),function(J,e,g,L,C,k,T,y,S,A,i,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(b,P,l){this.name=b,this.file=P,this.appender=l}static async create(b,P){const l=await(0,I.createRotatingLogger)(b,P,30*u.ByteSize.MB,1);return l.clearFormatters(),new m(b,P,l)}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class c extends T.AbstractExtHostOutputChannel{constructor(b,P,l,f){super(b,!1,g.URI.file(P.file),l,f);this._appender=P}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,P){this._appender.flush(),super.show(b,P)}clear(){this._appender.flush(),super.clear()}}let v=class extends T.ExtHostOutputService{constructor(b,P,l){super(b);this.logService=P,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new A.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(b){if(b){const P=this._channels.get(b);P&&(this._visibleChannelDisposable.value=P.onDidAppend(()=>P.update()))}}createOutputChannel(b,P){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const l=this._doCreateOutChannel(b,P);return l.then(f=>f._id.then(p=>this._channels.set(p,f))),new T.LazyOutputChannel(b,l)}async _doCreateOutChannel(b,P){try{const l=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await k.SymlinkSupport.existsDirectory(l)||await k.Promises.mkdir(l,{recursive:!0});const p=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,L.join)(l,`${p}.log`)),s=await m.create(p,t.fsPath);return new c(b,s,P.identifier.value,this._proxy)}catch(l){return this.logService.error(l),new T.ExtHostPushOutputChannel(b,P.identifier.value,this._proxy)}}};v=We([xe(0,S.IExtHostRpcService),xe(1,i.ILogService),xe(2,y.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(ve[261],we([0,1,49,292,2,67,6,10,17]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends k.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==y.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const s=t.fsPath;let o=0;do{let n;o===0?n=s:n=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${o}`:`${s}-${o}`,await i(n);const a=L.join(n,"vscode.lock"),h=await c(this._logService,a,!1);if(h)return this._workspaceStorageLock=h,process.on("exit",()=>{h.dispose()}),C.URI.file(n);o++}while(o<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function i(f){try{await g.promises.stat(f);return}catch{}try{await g.promises.mkdir(f,{recursive:!0})}catch{}}const I=1e3,u=10*60*1e3;class m extends T.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await v(p,t);(!s||s.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(o){p.error(o),p.info(`Lock '${t}': Could not update mtime.`)}},I)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function c(f,p,t){try{const o={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(p,JSON.stringify(o),{flag:"wx"})}catch(o){f.error(o)}const s=await v(f,p);return!s||s.pid!==process.pid?t?(f.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(f.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),P(f,p)):(f.info(`Lock '${p}': Lock acquired.`),new m(f,p))}async function v(f,p){let t;try{t=await g.promises.readFile(p)}catch(s){return f.error(s),null}try{return JSON.parse(String(t))}catch(s){return f.error(s),null}}async function _(f,p){let t;try{t=await g.promises.stat(p)}catch(s){return f.error(s),0}return t.mtime.getTime()}function b(f){try{return process.kill(f,0),!0}catch(p){return!1}}async function P(f,p){const t=await v(f,p);if(!t)return f.info(`Lock '${p}': Could not read pid of lock holder.`),l(f,p);if(t.willReleaseAt){let h=t.willReleaseAt-Date.now();if(h<5e3){for(h>0?f.info(`Lock '${p}': The lockfile is scheduled to be released in ${h} ms.`):f.info(`Lock '${p}': The lockfile is scheduled to have been released.`);h>0;){if(await(0,S.timeout)(Math.min(100,h)),await _(f,p)===0)return l(f,p);h=t.willReleaseAt-Date.now()}return l(f,p)}}if(!b(t.pid))return f.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),l(f,p);const s=await _(f,p),o=Date.now()-s;if(o<=u)return f.info(`Lock '${p}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;f.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const n=await _(f,p),a=Date.now()-n;return a<=u?(f.info(`Lock '${p}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(f.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),l(f,p))}async function l(f,p){f.info(`Lock '${p}': Deleting a stale lock.`);try{await g.promises.unlink(p)}catch(t){}return c(f,p,!0)}}),define(ve[262],we([0,1,32,13,33]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let k=class extends C.BaseExtHostTerminalService{constructor(y){super(!0,y)}createTerminal(y,S,A){return this.createTerminalFromOptions({name:y,shellPath:S,shellArgs:A})}createTerminalFromOptions(y,S){const A=new C.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),y,y.name);return this._terminals.push(A),A.create(y,S),A.value}};k=We([xe(0,L.IExtHostRpcService)],k),e.ExtHostTerminalService=k}),define(ve[263],we([0,1,5,13,6,27,2,39,23,28,7,11,52,3,193,76,12]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(d,w,E){this.remoteAddress=d,this.localAddress=w,this._dispose=E,this._onDispose=new m.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function P(h){const d=h.trim().split(`
`),w=[];return d.forEach(r=>{const D=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(r);D&&D.length>=3&&w.push({pid:parseInt(D[1],10),socket:parseInt(D[2],10)})}),w.reduce((r,D)=>(r[D.socket]=D,r),{})}e.getSockets=P;function l(...h){const d=[].concat(...h.map(p));return[...new Map(d.filter(w=>w.st==="0A").map(w=>{const E=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:f(E[0]),port:parseInt(E[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=l;function f(h){let d="";if(h.length===8)for(let w=h.length-2;w>=0;w-=2)d+=parseInt(h.substr(w,2),16),w!==0&&(d+=".");else for(let w=h.length-4;w>=0;w-=4)d+=parseInt(h.substr(w,4),16).toString(16),w!==0&&(d+=":");return d}e.parseIpAddress=f;function p(h){const d=h.trim().split(`
`),w=d.shift().trim().split(/\s+/).filter(r=>r!=="rx_queue"&&r!=="tm->when");return d.map(r=>r.trim().split(/\s+/).reduce((D,R,x)=>(D[w[x]||x]=R,D),{}))}e.loadConnectionTable=p;function t(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/vs/server/main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function s(h){const d=h.trim().split(`
`),w=[];return d.forEach(E=>{const r=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);r&&r.length>=4&&w.push({pid:parseInt(r[1],10),ppid:parseInt(r[2]),cmd:r[3]})}),w}e.getRootProcesses=s;async function o(h,d,w){const E=w.reduce((D,R)=>(D[R.pid]=R,D),{}),r=[];return h.forEach(({socket:D,ip:R,port:x})=>{const j=d[D]?d[D].pid:void 0,te=j?E[j]?.cmd:void 0;j&&te&&!t(te)&&r.push({host:R,port:x,detail:te,pid:j})}),r}e.findPorts=o;function n(h,d,w){const E=new Map,r=s(d);for(const D of h){const R=w.get(D.port);if(R){E.set(D.port,R);continue}const x=r.find(j=>j.cmd.includes(`${D.port}`));if(x){let j=x,te;do te=r.find(Q=>Q.ppid===j.pid),te&&(j=te);while(te);E.set(D.port,{host:D.ip,port:D.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else E.set(D.port,{host:D.ip,port:D.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=n;let a=class extends C.Disposable{constructor(d,w,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new m.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(g.MainContext.MainThreadTunnelService),I.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(w,d.displayName);if(E){const r=new b(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(r),r}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,w){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:d,provider:w}),this._proxy.$registerPortsAttributesProvider(d,E),new i.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(d,w,E,r,D){const R=[];for(const j of d){const te=this._portAttributesProviders.get(j);if(!te)return[];R.push(...await Promise.all(w.map(async Q=>te.provider.providePortAttributes(Q,E,r,D))))}const x=R.filter(j=>!!j);return x.length>0?x.map(j=>({autoForwardAction:j.autoForwardAction,port:j.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;let w=new v.MovingAverage,E;for(;this._candidateFindingEnabled;){const r=new Date().getTime(),D=(await this.findCandidatePorts()).filter(x=>(0,c.isLocalhost)(x.host)||(0,c.isAllInterfaces)(x.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${D.map(x=>x.port).join(", ")}`);const R=new Date().getTime()-r;w.update(R),(!E||JSON.stringify(E)!==JSON.stringify(D))&&(E=D,await this._proxy.$onFoundNewCandidates(E)),await new Promise(x=>setTimeout(()=>x(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(d){return d?(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory&&(this._forwardPortProvider=d.tunnelFactory,this._proxy.$setTunnelProvider(d.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,w){if(this._extensionTunnels.has(d.host)){const E=this._extensionTunnels.get(d.host);E.has(d.port)&&(w&&E.get(d.port).disposeListener.dispose(),await E.get(d.port).tunnel.dispose(),E.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(d,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const r=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const D=this._register(r.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(r.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:r,disposeListener:D}),u.TunnelDto.fromApiTunnel(r)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const w=await Promise.all(d.map(r=>this._showCandidatePort(r.host,r.port,r.detail??""))),E=d.filter((r,D)=>w[D]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(r=>r.port).join(", ")} to ${E.map(r=>r.port).join(", ")}`),E}async findCandidatePorts(){let d="",w="";try{d=await A.Promises.readFile("/proc/net/tcp","utf8"),w=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const E=l(d,w),r=await new Promise(U=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(F,V,M)=>{U(V)})}),D=P(r),R=await A.Promises.readdir("/proc"),x=[];for(let U of R)try{const F=Number(U),V=S.joinPath(T.URI.file("/proc"),U);if((await A.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(F)){const O=await A.Promises.readlink(S.joinPath(V,"cwd").fsPath),q=await A.Promises.readFile(S.joinPath(V,"cmdline").fsPath,"utf8");x.push({pid:F,cwd:O,cmd:q})}}catch(F){}const j=[],te=E.filter(U=>{const F=D[U.socket];return F||j.push(U),F}),Q=o(te,D,x);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const U=await new Promise(F=>{(0,y.exec)("ps -F -A -l | grep root",(V,M,O)=>{F(M)})});this._foundRootPorts=n(j,U,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return Q.then(U=>N?U.concat(N):U)}};a=We([xe(0,L.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,_.ILogService)],a),e.ExtHostTunnelService=a}),define(ve[264],we([0,1,17,21,16,3,6,102,228,130,24]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function u(n,a){try{return JSON.stringify(n,a)}catch(h){return"null"}}function m(n,a){return JSON.stringify(n,a)}function c(n){return n?(a,h)=>h&&h.$mid===1?n.transformOutgoing(h):h:null}var v;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},P=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class f extends T.Disposable{constructor(a,h=null,d=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=h,this._uriTransformer=d,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,E=A.ProxyIdentifier.count;w<E;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,y.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:h,sid:d}=a;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,d)),this._proxies[h]}_createProxy(a,h){let d={get:(w,E)=>(typeof E=="string"&&!w[E]&&E.charCodeAt(0)===36&&(w[E]=(...r)=>this._remoteCall(a,E,r)),E===l?h:w[E])};return new Proxy(Object.create(null),d)}set(a,h){return this._locals[a.nid]=h,h}assertRegistered(a){for(let h=0,d=a.length;h<d;h++){const w=a[h];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const h=a.byteLength,d=p.read(a,0),w=d.readUInt8(),E=d.readUInt32();switch(w){case 1:case 2:{let{rpcId:r,method:D,args:R}=t.deserializeRequestJSONArgs(d);this._uriTransformer&&(R=(0,y.transformIncomingURIs)(R,this._uriTransformer)),this._receiveRequest(h,E,r,D,R,w===2);break}case 3:case 4:{let{rpcId:r,method:D,args:R}=t.deserializeRequestMixedArgs(d);this._uriTransformer&&(R=(0,y.transformIncomingURIs)(R,this._uriTransformer)),this._receiveRequest(h,E,r,D,R,w===4);break}case 5:{this._logger&&this._logger.logIncoming(h,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(h,E);break}case 7:{this._receiveReply(h,E,void 0);break}case 9:{let r=t.deserializeReplyOKJSON(d);this._uriTransformer&&(r=(0,y.transformIncomingURIs)(r,this._uriTransformer)),this._receiveReply(h,E,r);break}case 8:{let r=t.deserializeReplyOKVSBuffer(d);this._receiveReply(h,E,r);break}case 10:{let r=t.deserializeReplyErrError(d);this._uriTransformer&&(r=(0,y.transformIncomingURIs)(r,this._uriTransformer)),this._receiveReplyErr(h,E,r);break}case 11:{this._receiveReplyErr(h,E,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,h,d,w,E,r){this._logger&&this._logger.logIncoming(a,h,1,`receiveRequest ${(0,A.getStringIdentifierForProxy)(d)}.${w}(`,E);const D=String(h);let R,x;if(r){const te=new L.CancellationTokenSource;E.push(te.token),R=this._invokeHandler(d,w,E),x=()=>te.cancel()}else R=this._invokeHandler(d,w,E),x=b;this._cancelInvokedHandlers[D]=x;const j=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(j.byteLength,h,1,"ack"),this._protocol.send(j),R.then(te=>{delete this._cancelInvokedHandlers[D];const Q=t.serializeReplyOK(h,te,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,h,1,"reply:",te),this._protocol.send(Q)},te=>{delete this._cancelInvokedHandlers[D];const Q=t.serializeReplyErr(h,te);this._logger&&this._logger.logOutgoing(Q.byteLength,h,1,"replyErr:",te),this._protocol.send(Q)})}_receiveCancel(a,h){this._logger&&this._logger.logIncoming(a,h,1,"receiveCancel");const d=String(h);this._cancelInvokedHandlers[d]&&this._cancelInvokedHandlers[d]()}_receiveReply(a,h,d){this._logger&&this._logger.logIncoming(a,h,0,"receiveReply:",d);const w=String(h);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],E.resolveOk(d)}_receiveReplyErr(a,h,d){this._logger&&this._logger.logIncoming(a,h,0,"receiveReplyErr:",d);const w=String(h);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const E=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let r;d&&(d.$isError?(r=new Error,r.name=d.name,r.message=d.message,r.stack=d.stack):r=d),E.resolveErr(r)}_invokeHandler(a,h,d){try{return Promise.resolve(this._doInvokeHandler(a,h,d))}catch(w){return Promise.reject(w)}}_doInvokeHandler(a,h,d){const w=this._locals[a];if(!w)throw new Error("Unknown actor "+(0,A.getStringIdentifierForProxy)(a));let E=w[h];if(typeof E!="function")throw new Error("Unknown method "+h+" on actor "+(0,A.getStringIdentifierForProxy)(a));return E.apply(w,d)}_remoteCall(a,h,d){if(this._isDisposed)return Promise.reject(C.canceled());let w=null;if(d.length>0&&L.CancellationToken.isCancellationToken(d[d.length-1])&&(w=d.pop()),w&&w.isCancellationRequested)return Promise.reject(C.canceled());const E=t.serializeRequestArguments(d,this._uriReplacer),r=++this._lastMessageId,D=String(r),R=new S.LazyPromise;w&&w.onCancellationRequested(()=>{const j=t.serializeCancel(r);this._logger&&this._logger.logOutgoing(j.byteLength,r,0,"cancel"),this._protocol.send(t.serializeCancel(r))}),this._pendingRPCReplies[D]=R,this._onWillSendRequest(r);const x=t.serializeRequest(r,a,h,E,!!w);return this._logger&&this._logger.logOutgoing(x.byteLength,r,0,`request: ${(0,A.getStringIdentifierForProxy)(a)}.${h}(`,d),this._protocol.send(x),R}}e.RPCProtocol=f,I=P,f.UNRESPONSIVE_TIME=3*1e3;class p{constructor(a,h){this._buff=a,this._offset=h}static alloc(a,h,d){let w=new p(i.VSBuffer.alloc(d+1+4),0);return w.writeUInt8(a),w.writeUInt32(h),w}static read(a,h){return new p(a,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const d=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,d}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const d=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,d}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,h}static sizeMixedArray(a,h){let d=0;d+=1;for(let w=0,E=a.length;w<E;w++){const r=a[w],D=h[w];switch(d+=1,D){case 1:d+=this.sizeLongString(r);break;case 2:d+=this.sizeVSBuffer(r);break;case 3:break}}return d}writeMixedArray(a,h){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let d=0,w=a.length;d<w;d++){const E=a[d];switch(h[d]){case 1:this.writeUInt8(1),this.writeLongString(E);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(a);for(let d=0;d<a;d++)switch(this.readUInt8()){case 1:h[d]=this.readLongString();break;case 2:h[d]=this.readVSBuffer();break;case 3:h[d]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(a){for(let h=0,d=a.length;h<d;h++)if(a[h]instanceof i.VSBuffer||typeof a[h]=="undefined")return!0;return!1}static serializeRequestArguments(a,h){if(this._arrayContainsBufferOrUndefined(a)){let d=[],w=[];for(let E=0,r=a.length;E<r;E++){const D=a[E];D instanceof i.VSBuffer?(d[E]=D,w[E]=2):typeof D=="undefined"?(d[E]=i.VSBuffer.alloc(0),w[E]=3):(d[E]=i.VSBuffer.fromString(m(D,h)),w[E]=1)}return{type:"mixed",args:d,argsType:w}}return{type:"simple",args:m(a,h)}}static serializeRequest(a,h,d,w,E){return w.type==="mixed"?this._requestMixedArgs(a,h,d,w.args,w.argsType,E):this._requestJSONArgs(a,h,d,w.args,E)}static _requestJSONArgs(a,h,d,w,E){const r=i.VSBuffer.fromString(d),D=i.VSBuffer.fromString(w);let R=0;R+=p.sizeUInt8(),R+=p.sizeShortString(r),R+=p.sizeLongString(D);let x=p.alloc(E?2:1,a,R);return x.writeUInt8(h),x.writeShortString(r),x.writeLongString(D),x.buffer}static deserializeRequestJSONArgs(a){const h=a.readUInt8(),d=a.readShortString(),w=a.readLongString();return{rpcId:h,method:d,args:JSON.parse(w)}}static _requestMixedArgs(a,h,d,w,E,r){const D=i.VSBuffer.fromString(d);let R=0;R+=p.sizeUInt8(),R+=p.sizeShortString(D),R+=p.sizeMixedArray(w,E);let x=p.alloc(r?4:3,a,R);return x.writeUInt8(h),x.writeShortString(D),x.writeMixedArray(w,E),x.buffer}static deserializeRequestMixedArgs(a){const h=a.readUInt8(),d=a.readShortString(),w=a.readMixedArray(),E=new Array(w.length);for(let r=0,D=w.length;r<D;r++){const R=w[r];typeof R=="string"?E[r]=JSON.parse(R):E[r]=R}return{rpcId:h,method:d,args:E}}static serializeAcknowledged(a){return p.alloc(5,a,0).buffer}static serializeCancel(a){return p.alloc(6,a,0).buffer}static serializeReplyOK(a,h,d){return typeof h=="undefined"?this._serializeReplyOKEmpty(a):h instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(a,h):this._serializeReplyOKJSON(a,u(h,d))}static _serializeReplyOKEmpty(a){return p.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,h){let d=0;d+=p.sizeVSBuffer(h);let w=p.alloc(8,a,d);return w.writeVSBuffer(h),w.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,h){const d=i.VSBuffer.fromString(h);let w=0;w+=p.sizeLongString(d);let E=p.alloc(9,a,w);return E.writeLongString(d),E.buffer}static deserializeReplyOKJSON(a){const h=a.readLongString();return JSON.parse(h)}static serializeReplyErr(a,h){return h?this._serializeReplyErrEror(a,h):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,h){const d=i.VSBuffer.fromString(u(C.transformErrorForSerialization(h),null));let w=0;w+=p.sizeLongString(d);let E=p.alloc(10,a,w);return E.writeLongString(d),E.buffer}static deserializeReplyErrError(a){const h=a.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(a){return p.alloc(11,a,0).buffer}}var s;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var o;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(o||(o={}))}),define(ve[265],we([0,1,4]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(ve[266],we([0,1,10,8,11,2,4,85,43,223,265]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let I=class $n{constructor(m,c,v,_){this.localUserHome=m,this.remoteAgentService=c,this.environmentService=v,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||m})()}get defaultUriScheme(){return $n.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,c){if(m.remoteAuthority)return g.Schemas.vscodeRemote;const v=(0,y.getVirtualWorkspaceScheme)(c.getWorkspace());if(v)return v;const _=c.getWorkspace().folders[0];if(_)return _.uri.scheme;const b=c.getWorkspace().configuration;return b?b.scheme:g.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?L.win32:L.posix)}async fileURI(m){let c="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const _=m.indexOf("/",2);_===-1?(c=m.substring(2),m="/"):(c=m.substring(2,_),m=m.substring(_)||"/")}return k.URI.from({scheme:g.Schemas.file,authority:c,path:m,query:"",fragment:""})}};I=We([xe(1,i.IRemoteAgentService),xe(2,A.IWorkbenchEnvironmentService),xe(3,S.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(ve[69],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(T,y){this.line=T,this.character=y}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,y){return new g(0,0)}with(T){return new g(0,0)}}e.Position=g;class L{constructor(T,y,S,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,y),this.end=new g(S,A)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new L(0,0,0,0)}with(T){return new L(0,0,0,0)}}e.Range=L;var C;(function(k){k[k.Information=1]="Information",k[k.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],we([0,1,20,30,25,29,9,4,8,16,69]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",u=" characters skipped \u27EB",m=(I.length+u.length+5)*2;e.ISearchService=(0,y.createDecorator)("searchService");var c;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function _(F){return!!F.preview}e.resultIsMatch=_;function b(F){return!!F.resource}e.isFileMatch=b;function P(F){return!!F.message}e.isProgressMessage=P;var l;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=f;class p{constructor(V,M,O){this.ranges=M;const q=Array.isArray(M)?M:[M];if(O&&O.matchLines===1&&t(q)){V=(0,T.getNLines)(V,O.matchLines);let B="",K=0,ne=0;const me=Math.floor(O.charsPerLine/5),Se=[];for(const Ce of q){const Te=Math.max(Ce.startColumn-me,0),je=Ce.startColumn+O.charsPerLine;if(Te>ne+me+m){const Be=I+(Te-ne)+u;B+=Be+V.slice(Te,je),K+=Te-(ne+Be.length)}else B+=V.slice(ne,je);Se.push(new o(0,Ce.startColumn-K,Ce.endColumn-K)),ne=je}this.preview={text:B,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const B=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:V,matches:(0,g.mapArrayOrNot)(M,K=>new s(K.startLineNumber-B,K.startColumn,K.endLineNumber-B,K.endColumn))}}}}e.TextSearchMatch=p;function t(F){const V=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==V||M.endLineNumber!==V)return!1;return!0}class s{constructor(V,M,O,q){this.startLineNumber=V,this.startColumn=M,this.endLineNumber=O,this.endColumn=q}}e.SearchRange=s;class o extends s{constructor(V,M,O){super(V,M,V,O)}}e.OneLineRange=o;var n;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function a(F,V=!0){const M=F&&F.files&&F.files.exclude,O=V&&F&&F.search&&F.search.exclude;if(!M&&!O)return;if(!M||!O)return M||O;let q=Object.create(null);return q=C.mixin(q,C.deepClone(M)),q=C.mixin(q,C.deepClone(O),!0),q}e.getExcludes=a;function h(F,V){return F.excludePattern&&L.match(F.excludePattern,V)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&L.match(F.includePattern,V)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const O=M.folder.fsPath;if(k.isEqualOrParent(V,O)){const q=S.relative(O,V);return!M.includePattern||!!L.match(M.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var d;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(V,M){super(V);this.code=M}}e.SearchError=w;function E(F){const V=F.message;if((0,A.isPromiseCanceledError)(F))return new w(V,d.canceled);try{const M=JSON.parse(V);return new w(M.message,M.code)}catch(M){return new w(V,d.other)}}e.deserializeSearchError=E;function r(F){const V={message:F.message,code:F.code};return new Error(JSON.stringify(V))}e.serializeSearchError=r;function D(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=D;function R(F){return F.type==="success"}e.isSerializedSearchSuccess=R;function x(F){return!!F.path}e.isSerializedFileMatch=x;function j(F,V){const M=F.searchPath?F.searchPath:F.relativePath;return(0,T.fuzzyContains)(M,V)}e.isFilePatternMatch=j;class te{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=te;function Q(F,V){const M={...F||{},...V||{}};return Object.keys(M).filter(O=>{const q=M[O];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=Q;class N{constructor(V,M){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let O=V.includePattern;M.includePattern&&(O?O={...O,...M.includePattern}:O=M.includePattern),O&&(this._parsedIncludeExpression=L.parse(O))}includedInQuerySync(V,M,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,M,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,M,O))}includedInQuery(V,M,O){return Promise.resolve(this._parsedExcludeExpression(V,M,O)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(V,M,O)).then(K=>!!K):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=N;function U(F){for(const V in F)if(typeof F[V]!="boolean")return!0;return!1}}),define(ve[36],we([0,1,20,17,21,3,22,10,76,23,9,14,2,169,4,12,189,43,63,27,13,7,31,5]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l,f,p,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(D,R,x){return new A.ExtUri(j=>d(j,x)).isEqual(D,R)}function n(D,R,x){return o(D.uri,R.uri,x)?0:(0,i.compare)(D.uri.toString(),R.uri.toString())}function a(D,R,x){return D.index!==R.index?D.index<R.index?-1:1:o(D.uri,R.uri,x)?(0,i.compare)(D.name,R.name):(0,i.compare)(D.uri.toString(),R.uri.toString())}function h(D,R,x,j){const te=D.slice(0).sort((N,U)=>x(N,U,j)),Q=R.slice(0).sort((N,U)=>x(N,U,j));return(0,g.delta)(te,Q,(N,U)=>x(N,U,j))}function d(D,R){const x=R.getCapabilities(D.scheme);return!(x&&x&1024)}class w extends b.Workspace{constructor(R,x,j,te,Q,N){super(R,j.map(U=>new b.WorkspaceFolder(U)),te,N);this._name=x,this._isUntitled=Q,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(N),j.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(R,x,j,te){if(!R)return{workspace:null,added:[],removed:[]};const{id:Q,name:N,folders:U,configuration:F,isUntitled:V}=R,M=[],O=x;x?U.forEach((ne,me)=>{const Se=u.URI.revive(ne.uri),Ce=w._findFolder(j||x,Se,te);Ce?(Ce.name=ne.name,Ce.index=ne.index,M.push(Ce)):M.push({uri:Se,name:ne.name,index:me})}):M.push(...U.map(({uri:ne,name:me,index:Se})=>({uri:u.URI.revive(ne),name:me,index:Se}))),M.sort((ne,me)=>ne.index<me.index?-1:1);const q=new w(Q,N,M,F?u.URI.revive(F):null,!!V,ne=>d(ne,te)),{added:B,removed:K}=h(O?O.workspaceFolders:[],q.workspaceFolders,n,te);return{workspace:q,added:B,removed:K}}static _findFolder(R,x,j){for(let te=0;te<R.folders.length;te++){const Q=R.workspaceFolders[te];if(o(Q.uri,x,j))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,x){return x&&this._structure.get(R)&&(R=(0,A.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let E=class{constructor(R,x,j,te){this._onDidChangeWorkspace=new k.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new k.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=te,this._extHostFileSystemInfo=j,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(s.MainContext.MainThreadMessageService);const Q=x.workspace;this._confirmedWorkspace=Q?new w(Q.id,Q.name,[],Q.configuration?u.URI.revive(Q.configuration):null,!!Q.isUntitled,N=>d(N,j)):void 0}$initializeWorkspace(R,x){this._trusted=x,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:y.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,x,j,...te){const Q=[];if(Array.isArray(te)&&te.forEach(M=>{u.URI.isUri(M.uri)&&!Q.some(O=>o(O.uri,M.uri,this._extHostFileSystemInfo))&&Q.push({uri:M.uri,name:M.name||(0,A.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[x,j].some(M=>typeof M!="number"||M<0)||j===0&&Q.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+j>N.length)return!1;const U=N.slice(0);U.splice(x,j,...Q.map(M=>({uri:M.uri,name:M.name||(0,A.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<U.length;M++){const O=U[M];if(U.some((q,B)=>B!==M&&o(O.uri,q.uri,this._extHostFileSystemInfo)))return!1}U.forEach((M,O)=>M.index=O);const{added:F,removed:V}=h(N,U,a,this._extHostFileSystemInfo);if(F.length===0&&V.length===0)return!1;if(this._proxy){const M=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(M,x,j,Q).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,M,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(R,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,x)}async getWorkspaceFolder2(R,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,x)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,x){let j,te="";if(typeof R=="string"?(j=u.URI.file(R),te=R):typeof R!="undefined"&&(j=R,te=R.fsPath),!j)return te;const Q=this.getWorkspaceFolder(j,!0);if(!Q)return te;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let N=(0,A.relativePath)(Q.uri,j);return x&&Q.name&&(N=`${Q.name}/${N}`),N}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:x,added:j,removed:te}=w.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:j,removed:te}))}findFiles(R,x,j,te,Q=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${te.value}, entryPoint: findFiles`);let N;if(x===null?N=!1:x&&(typeof x=="string"?N=x:N=x.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:F}=r(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(U),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(j),Q).then(V=>Array.isArray(V)?V.map(M=>u.URI.revive(M)):[])}async findTextInFiles(R,x,j,te,Q=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${te.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),U=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:F,folder:V}=r(x.include),M=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,O={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:U,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:F,excludePattern:M},q=!1;if(this._activeSearchCallbacks[N]=B=>{if(q)return;const K=u.URI.revive(B.resource);B.results.forEach(ne=>{(0,t.resultIsMatch)(ne)?j({uri:K,preview:{text:ne.preview.text,matches:(0,g.mapArrayOrNot)(ne.preview.matches,me=>new p.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))},ranges:(0,g.mapArrayOrNot)(ne.ranges,me=>new p.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))}):j({uri:K,text:ne.text,lineNumber:ne.lineNumber})})},Q.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(V),O,N,Q);return delete this._activeSearchCallbacks[N],B||{}}catch(B){throw delete this._activeSearchCallbacks[N],B}}$handleTextSearchResult(R,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=We([xe(0,f.IExtHostRpcService),xe(1,l.IExtHostInitDataService),xe(2,P.IExtHostFileSystemInfo),xe(3,v.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function r(D){let R,x;return D&&(typeof D=="string"?R=D:(R=D.pattern,x=D.baseFolder||u.URI.file(D.base))),{includePattern:R,folder:x}}}),define(ve[37],we([0,1,25,3,36,5,7,192,84,14,17,4,13,12,2]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(s,o){if(o){const n=o.split(".");let a=s;for(let h=0;a&&h<n.length;h++)a=a[n[h]];return a}}function _(s){return s instanceof c.URI}function b(s){return s&&s.uri instanceof c.URI&&s.languageId&&typeof s.languageId=="string"}function P(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function l(s){return s&&s.uri instanceof c.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function f(s){if(_(s))return{resource:s};if(b(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(P(s))return{overrideIdentifier:s.languageId};if(l(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(o,n,a){this._proxy=o.getProxy(k.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=a,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,n){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,n))}};p=We([xe(0,u.IExtHostRpcService),xe(1,C.IExtHostWorkspace),xe(2,m.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(o,n,a,h){this._onDidChangeConfiguration=new L.Emitter,this._proxy=o,this._logService=h,this._extHostWorkspace=n,this._configuration=y.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,n){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,a))}getConfiguration(o,n,a){const h=f(n)||{},d=this._toReadonlyValue(o?v(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,h,a?.identifier);function w(r){if(r==null)return null;if(typeof r=="boolean")return r?1:4;switch(r){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(r){return typeof v(d,r)!="undefined"},get:(r,D)=>{this._validateConfigurationAccess(o?`${o}.${r}`:r,h,a?.identifier);let R=v(d,r);if(typeof R=="undefined")R=D;else{let x;const j=(te,Q)=>{let N;const U=()=>{x=x||(0,g.deepClone)(d),N=N||v(x,Q)};return(0,A.isObject)(te)?new Proxy(te,{get:(F,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return U(),()=>N;if(x)return N=N||v(x,Q),N[V];const M=F[V];return typeof V=="string"?j(M,`${Q}.${V}`):M},set:(F,V,M)=>(U(),N&&(N[V]=M),!0),deleteProperty:(F,V)=>(U(),N&&delete N[V],!0),defineProperty:(F,V,M)=>(U(),N&&Object.defineProperty(N,V,M),!0)}):te};R=j(R,r)}return R},update:(r,D,R,x)=>{r=o?`${o}.${r}`:r;const j=w(R);return D!==void 0?this._proxy.$updateConfigurationOption(j,r,D,h,x):this._proxy.$removeConfigurationOption(j,r,h,x)},inspect:r=>{r=o?`${o}.${r}`:r;const D=(0,g.deepClone)(this._configuration.inspect(r,h,this._extHostWorkspace.workspace));if(D)return{key:r,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof d=="object"&&(0,g.mixin)(E,d,!1),Object.freeze(E)}_toReadonlyValue(o){const n=a=>(0,A.isObject)(a)?new Proxy(a,{get:(h,d)=>n(h[d]),set:(h,d,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(h,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(h,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return n(o)}_validateConfigurationAccess(o,n,a){const h=S.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),d=a?`[${a.value}] `:"";if(h===4){typeof n?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){n?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,n){const a=new y.ConfigurationChangeEvent(o,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,d)=>a.affectsConfiguration(h,f(d))})}_toMap(o){return o.reduce((n,a)=>(n.set(a[0],a[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[70],we([0,1,2,17,3,5,25,7,36,45,37,21,33,13,27,4,10,11,12,65,213,16]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l,f,p){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(N){function U(V){if(V!=null)return V}N.from=U;function F(V){if(V!=null)return V}N.to=F})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var o;(function(N){function U(V){if(V!=null)return V}N.from=U;function F(V){if(V!=null)return V}N.to=F})(o=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(N){function U(V){if(V!=null)return V}N.from=U;function F(V){if(V!=null)return V}N.to=F})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(N){function U(M){if(M){const O=M;return O&&!!O.process}else return!1}N.is=U;function F(M){if(M==null)return;const O={process:M.process,args:M.args};return M.options&&(O.options=n.from(M.options)),O}N.from=F;function V(M){if(M!=null)return new y.ProcessExecution(M.process,M.args,M.options)}N.to=V})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var h;(function(N){function U(V){if(V!=null)return V}N.from=U;function F(V){if(V!=null)return V}N.to=F})(h=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(N){function U(M){if(M){const O=M;return O&&(!!O.commandLine||!!O.command)}else return!1}N.is=U;function F(M){if(M==null)return;const O={};return M.commandLine!==void 0?O.commandLine=M.commandLine:(O.command=M.command,O.args=M.args),M.options&&(O.options=h.from(M.options)),O}N.from=F;function V(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new y.ShellExecution(M.commandLine,M.options):new y.ShellExecution(M.command,M.args?M.args:[],M.options)}N.to=V})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(N){function U(M){if(M){let O=M;return O&&O.customExecution==="customExecution"}else return!1}N.is=U;function F(M){return{customExecution:"customExecution"}}N.from=F;function V(M,O){return O.get(M)}N.to=V})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(N){function U(F,V){let M;return F.scope!==void 0&&typeof F.scope!="number"?M=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===y.TaskScope.Workspace&&V&&V.workspaceFile?M=V.workspaceFile:M=f.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:M}}N.from=U})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var r;(function(N){function U(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}N.from=U})(r=e.TaskGroupDTO||(e.TaskGroupDTO={}));var D;(function(N){function U(M,O){if(M==null)return[];const q=[];for(let B of M){const K=F(B,O);K&&q.push(K)}return q}N.fromMany=U;function F(M,O){if(M==null)return;let q;M.execution instanceof y.ProcessExecution?q=a.from(M.execution):M.execution instanceof y.ShellExecution?q=d.from(M.execution):M.execution&&M.execution instanceof y.CustomExecution&&(q=w.from(M.execution));const B=s.from(M.definition);let K;return M.scope?typeof M.scope=="number"?K=M.scope:K=M.scope.uri:K=y.TaskScope.Workspace,!B||!K?void 0:{_id:M._id,definition:B,name:M.name,source:{extensionId:O.identifier.value,label:M.source,scope:K},execution:q,isBackground:M.isBackground,group:r.from(M.group),presentationOptions:o.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}N.from=F;async function V(M,O,q){if(M==null)return;let B;a.is(M.execution)?B=a.to(M.execution):d.is(M.execution)?B=d.to(M.execution):w.is(M.execution)&&(B=w.to(M._id,q));const K=s.to(M.definition);let ne;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?ne=M.source.scope:ne=await O.resolveWorkspaceFolder(g.URI.revive(M.source.scope)):ne=y.TaskScope.Workspace),!K||!ne)return;const me=new y.Task(K,ne,M.name,M.source.label,B,M.problemMatchers);return M.isBackground!==void 0&&(me.isBackground=M.isBackground),M.group!==void 0&&(me.group=y.TaskGroup.from(M.group._id),me.group&&(me.group=T.deepClone(me.group),M.group.isDefault&&(me.group.isDefault=M.group.isDefault))),M.presentationOptions&&(me.presentationOptions=o.to(M.presentationOptions)),M._id&&(me._id=M._id),M.detail&&(me.detail=M.detail),me}N.to=V})(D=e.TaskDTO||(e.TaskDTO={}));var R;(function(N){function U(V){return V}N.from=U;function F(V){if(!!V)return Object.assign(Object.create(null),V)}N.to=F})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class x{constructor(U,F,V){this._id=F,this._task=V,t.set(this,void 0),nt(this,t,U,"f")}get task(){return this._task}terminate(){$e(this,t,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}t=new WeakMap;var j;(function(N){function U(F){return{id:F._id,task:void 0}}N.from=U})(j=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let te=class{constructor(U,F,V,M,O,q,B,K){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=U.getProxy(k.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=M,this._configurationService=O,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=B,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,F,V){if(!V)return new y.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:F,provider:V,extension:U}),this._proxy.$registerTaskProvider(M,F),new y.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(U,F){this._proxy.$registerTaskSystem(U,F)}fetchTasks(U){return this._proxy.$fetchTasks(R.from(U)).then(async F=>{const V=[];for(let M of F){const O=await D.to(M,this._workspaceProvider,this._providedCustomExecutions2);O&&V.push(O)}return V})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(F=>U.push(F)),U}terminateTask(U){if(!(U instanceof x))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,F,V){const M=this._providedCustomExecutions2.get(U.id);if(M){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,M),this._terminalService.attachPtyToTerminal(F,await M.callback(V))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const F=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:F})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const F=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:F,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const F=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:F,exitCode:U.exitCode})}$provideTasks(U,F){const V=this._handlers.get(U);if(!V)return Promise.reject(new Error("no handler found"));const M=[],O=(0,L.asPromise)(()=>V.provider.provideTasks(I.CancellationToken.None)).then(q=>this.provideTasksInternal(F,M,V,q));return new Promise(q=>{O.then(B=>{Promise.all(M).then(()=>{q(B)})})})}async $resolveTask(U,F){const V=this._handlers.get(U);if(!V)return Promise.reject(new Error("no handler found"));if(F.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${V.type}].`);const M=await D.to(F,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const O=await V.provider.resolveTask(M,I.CancellationToken.None);if(!O)return;this.checkDeprecation(O,V);const q=D.from(O,V.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(O.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(q.execution)&&await this.addCustomExecution(q,O,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,F,V){const M=await this._proxy.$createTaskId(U);!V&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,F.execution)}async getTaskExecution(U,F){if(typeof U=="string"){const O=this._taskExecutionPromises.get(U);if(!O)throw new Error("Unexpected: The specified task is missing an execution");return O}let V=this._taskExecutionPromises.get(U.id);if(V)return V;const M=new Promise(async(O,q)=>{const B=F||await D.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);B?O(new x(this,U.id,B)):q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,M),M.then(O=>(this._taskExecutions.set(U.id,O),O),O=>Promise.reject(O))}checkDeprecation(U,F){U._deprecated&&this._deprecationService.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let V=this._notProvidedCustomExecutions.values(),M=V.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=V.next()}};te=We([xe(0,m.IExtHostRpcService),xe(1,c.IExtHostInitDataService),xe(2,S.IExtHostWorkspace),xe(3,A.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,u.IExtHostTerminalService),xe(6,P.ILogService),xe(7,l.IExtHostApiDeprecationService)],te),e.ExtHostTaskBase=te;let Q=class extends te{constructor(U,F,V,M,O,q,B,K){super(U,F,V,M,O,q,B,K);this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(U,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const V=D.from(F,U);if(V===void 0)throw new Error("Task is not valid");if(w.is(V.execution))await this.addCustomExecution(V,F,!1);else throw new p.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),F);return this._proxy.$executeTask(V).catch(O=>{throw new Error(O)}),M}provideTasksInternal(U,F,V,M){const O=[];if(M)for(let q of M){this.checkDeprecation(q,V),(!q.definition||!U[q.definition.type])&&this._logService.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const B=D.from(q,V.extension);B&&w.is(B.execution)?(O.push(B),F.push(this.addCustomExecution(B,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:O,extension:V.extension}}async resolveTaskInternal(U){if(w.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,F,V){}};Q=We([xe(0,m.IExtHostRpcService),xe(1,c.IExtHostInitDataService),xe(2,S.IExtHostWorkspace),xe(3,A.IExtHostDocumentsAndEditors),xe(4,i.IExtHostConfiguration),xe(5,u.IExtHostTerminalService),xe(6,P.ILogService),xe(7,l.IExtHostApiDeprecationService)],Q),e.WorkerExtHostTask=Q,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(ve[267],we([0,1,20,55,30,78,22,10,8,23,9,14,2,145,175,119,43,127,266,31]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(w,E,r,D){this.configurationService=w,this.workspaceContextService=E,this.editorGroupsService=r,this.pathService=D}text(w,E,r={}){w=this.getContentPattern(w,r);const D=this.configurationService.getValue(),R=E&&E.some(j=>!this.configurationService.getValue({resource:j}).search.useRipgrep);return{...this.commonQuery(E?.map(_.toWorkspaceFolder),r),type:2,contentPattern:w,previewOptions:r.previewOptions,maxFileSize:r.maxFileSize,usePCRE2:D.search.usePCRE2||R||!1,beforeContext:r.beforeContext,afterContext:r.afterContext,userDisabledExcludesAndIgnoreFiles:r.disregardExcludeSettings&&r.disregardIgnoreFiles}}getContentPattern(w,E){const r=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const D={...w,wordSeparators:r.editor.wordSeparators};return this.isCaseSensitive(w,E)&&(D.isCaseSensitive=!0),this.isMultiline(w)&&(D.isMultiline=!0),D}file(w,E={}){return{...this.commonQuery(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(w,E){return w?(w=Array.isArray(w)?w.map(n):n(w),E?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],E={}){const r=this.handleIncludeExclude(E.includePattern,E.expandPatterns),D=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),R=w.length>1,x=(r.searchPaths&&r.searchPaths.length?r.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,E,D)):w.map(Q=>this.getFolderQueryForRoot(Q,E,D,R))).filter(Q=>!!Q),j={_reason:E._reason,folderQueries:x,usingSearchPaths:!!(r.searchPaths&&r.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:D.pattern,includePattern:r.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const N=g.coalesce(g.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(V=>V.resource)))).filter(F=>(0,l.pathIncludedInQuery)(j,F.fsPath)),U=this.commonQueryFromFileList(N);return{...j,...U}}const te=E.extraFileResources&&E.extraFileResources.filter(Q=>(0,l.pathIncludedInQuery)(j,Q.fsPath));return j.extraFileResources=te&&te.length?te:void 0,j}commonQueryFromFileList(w){const E=[],r=new T.ResourceMap,D={};let R=!1;return w.forEach(x=>{if(x.scheme===y.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(x)){const te=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let Q=r.get(te);Q||(R=!0,Q={folder:te,includePattern:{}},E.push(Q),r.set(te,Q));const N=S.relative(te.fsPath,x.fsPath);(0,I.assertIsDefined)(Q.includePattern)[N.replace(/\\/g,"/")]=!0}else x.fsPath&&(R=!0,D[x.fsPath]=!0)}),{folderQueries:E,includePattern:D,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(w,E){if(E.isSmartCase){if(w.isRegExp){if(i.containsUppercaseCharacter(w.pattern,!0))return!0}else if(i.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),D=(Array.isArray(w)?w:s(w)).map(U=>{const F=this.pathService.resolvedUserHome;return F?(0,k.untildify)(U,F.scheme===y.Schemas.file?F.fsPath:F.path):U}),R=L.groupBy(D,U=>E(U)?"searchPaths":"exprSegments"),x=(R.exprSegments||[]).map(U=>i.rtrim(U,"/")).map(U=>i.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),o(U))),j={},te=this.expandSearchPathPatterns(R.searchPaths||[]);te&&te.length&&(j.searchPaths=te);const Q=g.flatten(x),N=t(...Q);return N&&(j.pattern=N),j}getExcludesForFolder(w,E){return E.disregardExcludeSettings?void 0:(0,l.getExcludes)(w,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const E=g.flatten(w.map(D=>{let{pathPortion:R,globPortion:x}=p(D);x&&(x=a(x));const j=this.expandOneSearchPath(R);return g.flatten(j.map(te=>this.resolveOneSearchPathPattern(te,x)))})),r=new Map;return E.forEach(D=>{const R=D.searchPath.toString(),x=r.get(R);x?D.pattern&&(x.pattern=x.pattern||{},x.pattern[D.pattern]=!0):r.set(R,{searchPath:D.searchPath,pattern:D.pattern?t(D.pattern):void 0})}),Array.from(r.values())}expandOneSearchPath(w){if(S.isAbsolute(w)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==y.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:u.URI.file(S.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=n(w),w.startsWith("../")||w===".."){const D=S.posix.resolve(E.path,w);return[{searchPath:E.with({path:D})}]}const r=a(w);return[{searchPath:E,pattern:r}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(R=>{const x=E.match(new RegExp(`^${i.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return x?{match:x,folder:R}:null}).filter(I.isDefined);if(D.length)return D.map(R=>{const x=R.match[1];return{searchPath:R.folder.uri,pattern:x&&a(x)}});{const R=w.match(/\.[\/\\](.+)[\/\\]?/),x=R?R[1]:w,j=c.localize(0,null,x);throw new Error(j)}}}}resolveOneSearchPathPattern(w,E){const r=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,D=[{searchPath:w.searchPath,pattern:r}];return r&&!r.endsWith("**")&&D.push({searchPath:w.searchPath,pattern:r+"/**"}),D}getFolderQueryForSearchPath(w,E,r){const D=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(w.searchPath),E,r,!1);return D?{...D,includePattern:w.pattern}:null}getFolderQueryForRoot(w,E,r,D){let R;const x=u.URI.isUri(w)?w:w.uri;if(r.searchPaths){const U=r.searchPaths.filter(F=>(0,A.isEqual)(F.searchPath,x))[0];if(U&&!U.pattern)return null;U&&(R=U.pattern)}const j=this.configurationService.getValue({resource:x}),Q={...this.getExcludesForFolder(j,E)||{},...R||{}},N=u.URI.isUri(w)?(0,A.basename)(w):w.name;return{folder:x,folderName:D?N:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};f=We([xe(0,v.IConfigurationService),xe(1,_.IWorkspaceContextService),xe(2,b.IEditorGroupsService),xe(3,P.IPathService)],f),e.QueryBuilder=f;function p(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,r=d.substr(0,E).match(/[/|\\][^/\\]*$/);if(r){let D=d.substr(0,r.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:d.substr((r.index||0)+1)}}}return{pathPortion:d}}function t(...d){return d.length?d.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function s(d){return C.splitGlobAware(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(d){return[`**/${d}/**`,`**/${d}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function n(d){return d.replace(/\\/g,"/")}function a(d){return n(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(d,w){d=g.distinct(d,D=>D.toString());const E=[],r=w.getWorkspace();return d&&d.forEach(D=>{let R;if(w.getWorkbenchState()===2)R=(0,A.relativePath)(r.folders[0].uri,D),R&&R!=="."&&(R="./"+R);else{const x=w.getWorkspaceFolder(D);if(x){const j=x.name;if(r.folders.filter(Q=>Q.name===j).length===1){const Q=(0,A.relativePath)(x.uri,D);Q===""?R=`./${x.name}`:R=`./${x.name}/${Q}`}else R=D.fsPath}}R&&E.push(R)}),E}e.resolveResourcesForSearchIncludes=h}),define(ve[268],we([0,1,23,2,21,16,4,267,31,43]),function(J,e,g,L,C,k,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(v,_){const b=_.activationEvents;if(!b)return Promise.resolve(void 0);const P=[],l=[];for(const n of b)if(/^workspaceContains:/.test(n)){const a=n.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||v.forceUsingSearch?l.push(a):P.push(a)}if(P.length===0&&l.length===0)return Promise.resolve(void 0);let f;const p=new Promise((n,a)=>{f=n}),t=n=>f({activationEvent:n}),s=Promise.all(P.map(n=>u(v,n,t))).then(()=>{}),o=m(v,_.identifier,l,t);return Promise.all([s,o]).then(()=>{f(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function u(v,_,b){for(const P of v.folders)if(await v.exists(g.joinPath(L.URI.revive(P),_))){b(`workspaceContains:${_}`);return}}async function m(v,_,b,P){if(b.length===0)return Promise.resolve(void 0);const l=new C.CancellationTokenSource,f=v.checkExists(v.folders,b,l.token),p=setTimeout(async()=>{l.cancel(),P(`workspaceContainsTimeout:${b.join(",")}`)},i);let t=!1;try{t=await f}catch(s){k.isPromiseCanceledError(s)||k.onUnexpectedError(s)}l.dispose(),clearTimeout(p),t&&P(`workspaceContains:${b.join(",")}`)}function c(v,_,b,P){const l=v.get(T.IInstantiationService),f=v.get(S.ISearchService),t=l.createInstance(y.QueryBuilder).file(_.map(s=>(0,A.toWorkspaceFolder)(L.URI.revive(s))),{_reason:"checkExists",includePattern:b,exists:!0});return f.fileSearch(t,P).then(s=>!!s.limitHit,s=>k.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=c});var nt=this&&this.__classPrivateFieldSet||function(J,e,g,L,C){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?C.call(J,g):C?C.value=g:e.set(J,g),g},$e=this&&this.__classPrivateFieldGet||function(J,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(J):L?L.value:e.get(J)};define(ve[40],we([0,1,164,8,71,23,17,6,22,2,12,5,37,226,92,36,35,224,16,26,24,199,7,120,4,27,67,13,83,52,33,3,268,90,201]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l,f,p,t,s,o,n,a,h,d,w,E,r,D,R,x){"use strict";var j,te,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let N=class Wn extends y.Disposable{constructor(M,O,q,B,K,ne,me,Se,Ce,Te){super();this._onDidChangeRemoteConnectionData=this._register(new r.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=q,this._initData=me,this._extHostWorkspace=B,this._extHostConfiguration=K,this._logService=ne,this._extHostTunnelService=Ce,this._extHostTerminalService=Te,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Se,this._instaService=M.createChild(new d.ServiceCollection([c.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(Be=>je.add(l.ExtensionIdentifier.toKey(Be))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Be,Ve,W)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Be,P.transformErrorForSerialization(Ve),W)},actualActivateExtension:async(Be,Ve)=>{if(je.has(l.ExtensionIdentifier.toKey(Be)))return await this._mainThreadExtensionsProxy.$activateExtension(Be,Ve),new m.HostExtension;const W=this._registry.getExtensionDescription(Be);return this._activateExtension(W,Ve)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){P.onUnexpectedError(M)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let M=[];try{M=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(O){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,O){return this._activator.activateByEvent(M,O)}_activateById(M,O){return this._activator.activateById(M,O)}activateByIdWithErrors(M,O){return this._activateById(M,O).then(()=>{const q=this._activator.getActivatedExtension(M);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=S.TernarySearchTree.forPaths(),O=this._registry.getAllExtensionDescriptions().map(q=>{if(!!this._getEntryPoint(q))return this._hostUtils.realpath(q.extensionLocation.fsPath).then(B=>M.set(A.URI.file(B).fsPath,q))});this._extensionPathIndex=Promise.all(O).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return O;const q=this._activator.getActivatedExtension(M);if(!q)return O;try{typeof q.module.deactivate=="function"&&(O=Promise.resolve(q.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{(0,y.dispose)(q.subscriptions)}catch(B){this._logService.error(B)}return O}async _activateExtension(M,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,O).then(q=>{const B=q.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,O),this._logExtensionActivationTimes(M,O,"success",B),q},q=>{throw this._logExtensionActivationTimes(M,O,"failure"),q})}_logExtensionActivationTimes(M,O,q,B){const K=U(M,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...B||{},outcome:q})}_doActivateExtension(M,O){const q=U(M,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",q);const B=this._getEntryPoint(M);if(!B)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(O)}`),this._logService.flush();const K=new m.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,k.joinPath)(M.extensionLocation,B),K),this._loadExtensionContext(M)]).then(ne=>(C.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Wn._callActivate(this._logService,M.identifier,ne[0],ne[1],K))).then(ne=>(C.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),ne))}_loadExtensionContext(M){const O=new p.ExtensionGlobalMemento(M,this._storage),q=new p.ExtensionMemento(M.identifier.value,!1,this._storage),B=new x.ExtensionSecrets(M,this._secretState),K=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ne=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([O.whenReady,q.whenReady,this._storagePath.whenReady]).then(()=>{const me=this;let Se;return Object.freeze({globalState:O,workspaceState:q,secrets:B,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Ce){return L.join(M.extensionLocation.fsPath,Ce)},get storagePath(){return me._storagePath.workspaceValue(M)?.fsPath},get globalStoragePath(){return me._storagePath.globalValue(M).fsPath},get logPath(){return L.join(me._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return A.URI.joinPath(me._initData.logsLocation,M.identifier.value)},get storageUri(){return me._storagePath.workspaceValue(M)},get globalStorageUri(){return me._storagePath.globalValue(M)},get extensionMode(){return K},get extension(){return Se===void 0&&(Se=new F(me,M.identifier,M,ne)),Se},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(M),me.extensionRuntime},get environmentVariableCollection(){return me._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,O,q,B,K){return q=q||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,O,q,B,K).then(ne=>new m.ActivatedExtension(!1,null,K.build(),q,ne,B.subscriptions))}static _callActivateOptional(M,O,q,B,K){if(typeof q.activate=="function")try{K.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${O.value}`);const ne=typeof global=="object"?global:self,me=q.activate.apply(ne,[B]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(me).then(Se=>(K.activateResolveStop(),Se))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(q)}_activateOneStartupFinished(M,O){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:O}).then(void 0,q=>{this._logService.error(q)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const O of M.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(M,O)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],q=this._handleWorkspaceContainsEagerExtensions(O),B=Promise.all([M,q]).then(()=>{});return Promise.race([B,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(M,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,O){if(this.isActivated(O.identifier))return;const q=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:M.map(ne=>ne.uri),forceUsingSearch:q,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,me,Se)=>this._mainThreadWorkspaceProxy.$checkExists(ne,me,Se)},K=await(0,D.checkActivateWorkspaceContainsExtension)(B,O);if(!!K)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:K.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:O}=this._initData.environment;if(!M||!O)throw new Error(g.localize(0,null));const q=await this._loadCommonJSModule(null,O,new m.ExtensionActivationTimesBuilder(!1));if(!q||typeof q.run!="function")throw new Error(g.localize(1,null,O.toString()));return new Promise((B,K)=>{const ne=(Ce,Te)=>{Ce?K(Ce):B(typeof Te=="number"&&Te>0?1:0)},me=(0,k.originalFSPath)(O),Se=q.run(me,ne);Se&&Se.then&&Se.then(()=>{B(0)}).catch(Ce=>{K(Ce.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,O){return this._resolvers[M]=O,(0,y.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const O=M.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this._resolvers[q]}}async $resolveAuthority(M,O){const{authorityPrefix:q,resolver:B}=await this._activateAndGetResolver(M);if(!B)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),C.mark(`code/extHost/willResolveAuthority/${q}`);const K=await B.resolve(M,{resolveAttempt:O});C.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ne={authority:M,host:K.host,port:K.port,connectionToken:K.connectionToken},me={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:ne,options:me,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(C.mark(`code/extHost/didResolveAuthorityError/${q}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(M,O){const{authorityPrefix:q,resolver:B}=await this._activateAndGetResolver(M);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${q}`);const K=A.URI.revive(O);if(typeof B.getCanonicalURI=="undefined")return K;const ne=await(0,T.asPromise)(()=>B.getCanonicalURI(K));return ne||K}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,O){return O===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(q=>this._activateByEvent(M,!1))}async $activate(M,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,O),!0):!1}async $deltaExtensions(M,O){M.forEach(B=>B.extensionLocation=A.URI.revive(B.extensionLocation));const q=await this.getExtensionPathIndex();return await Promise.all(O.map(async B=>{const K=this._registry.getExtensionDescription(B);if(!K)return;const ne=await this._hostUtils.realpath(K.extensionLocation.fsPath);q.delete(A.URI.file(ne).fsPath)})),await Promise.all(M.map(async B=>{const K=await this._hostUtils.realpath(B.extensionLocation.fsPath);q.set(A.URI.file(K).fsPath,B)})),this._registry.deltaExtensions(M,O),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let O=f.VSBuffer.alloc(M),q=Math.random()%256;for(let B=0;B<M;B++)O.writeUInt8(q,B);return O}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};N=We([xe(0,o.IInstantiationService),xe(1,e.IHostUtils),xe(2,h.IExtHostRpcService),xe(3,v.IExtHostWorkspace),xe(4,u.IExtHostConfiguration),xe(5,i.ILogService),xe(6,n.IExtHostInitDataService),xe(7,a.IExtensionStoragePaths),xe(8,w.IExtHostTunnelService),xe(9,E.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function U(V,M){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class F{constructor(M,O,q,B){j.set(this,void 0),te.set(this,void 0),Q.set(this,void 0),nt(this,j,M,"f"),nt(this,te,O,"f"),nt(this,Q,q.identifier,"f"),this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=L.normalize((0,k.originalFSPath)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=B}get isActive(){return $e(this,j,"f").isActivated($e(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,j,"f").getExtensionExports($e(this,Q,"f"))}activate(){return $e(this,j,"f").activateByIdWithErrors($e(this,Q,"f"),{startup:!1,extensionId:$e(this,te,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,j=new WeakMap,te=new WeakMap,Q=new WeakMap}),define(ve[53],we([0,1,8,2,3,17,5,7,123,36,40,45,215,37,209,13,4,14,38,51]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let f=class{constructor(d,w,E,r,D,R){this._workspaceService=w,this._extensionService=E,this._editorsService=r,this._configurationService=D,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=d.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(j=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,w){const E=d;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let r=`debug:${encodeURIComponent(E.path||"")}`,D="?";return w&&(r+=`${D}session=${encodeURIComponent(w.id)}`,D="&"),r+=`${D}ref=${E.sourceReference}`,L.URI.parse(r)}else{if(E.path)return L.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const w=[];for(const E of d.getAllExtensionDescriptions())if(E.contributes){const r=E.contributes.debuggers;if(r&&r.length>0)for(const D of r)(0,c.isDebuggerMainContribution)(D)&&w.push(D.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(w=>d.push(w)),d}addBreakpoints(d){this.startBreakpoints();const w=d.filter(D=>{const R=D.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,D),!0)});this.fireBreakpointChanges(w,[],[]);const E=[],r=new Map;for(const D of w)if(D instanceof y.SourceBreakpoint){let R=r.get(D.location.uri.toString());R||(R={type:"sourceMulti",uri:D.location.uri,lines:[]},r.set(D.location.uri.toString(),R),E.push(R)),R.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof y.FunctionBreakpoint&&E.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(d){this.startBreakpoints();const w=d.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],w,[]);const E=w.filter(R=>R instanceof y.SourceBreakpoint).map(R=>R.id),r=w.filter(R=>R instanceof y.FunctionBreakpoint).map(R=>R.id),D=w.filter(R=>R instanceof y.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(E,r,D)}startDebugging(d,w,E){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,w,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,debugUI:E.debugUI})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,w,E){if(!w)return new y.Disposable(()=>{});const r=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:r,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,E,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,r),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(r)})}registerDebugAdapterDescriptorFactory(d,w,E){if(!E)return new y.Disposable(()=>{});if(!this.definesDebugType(d,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const r=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:r,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,r),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(r)})}registerDebugAdapterTrackerFactory(d,w){if(!w)return new y.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:E,factory:w}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(r=>r.factory!==w)})}async $runInTerminal(d,w){return Promise.resolve(void 0)}async $substituteVariables(d,w){if(!this._variableResolver){const[D,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,R)}let E;const r=await this.getFolder(d);return r&&(E={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,w)}createDebugAdapter(d,w){if(d.type==="implementation")return new n(d.implementation)}createSignService(){}async $startDASession(d,w){const E=this,r=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(r.type),r).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}' (extension might have failed to activate)`);const R=this.convertToDto(D),x=this.createDebugAdapter(R,r);if(!x)throw new Error(`Couldn't create a debug adapter for type '${r.type}'.`);const j=x;return this._debugAdapters.set(d,j),this.getDebugAdapterTrackers(r).then(te=>(te&&this._debugAdaptersTrackers.set(d,te),j.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const N=Q,U={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign(N.arguments.value);U.body={signature:F},j.sendResponse(U)}else throw new Error("no signer")}catch(F){U.success=!1,U.message=F.message,j.sendResponse(U)}}else te&&te.onDidSendMessage&&te.onDidSendMessage(Q),Q=(0,c.convertToVSCPaths)(Q,!0),E._debugServiceProxy.$acceptDAMessage(d,Q)}),j.onError(Q=>{te&&te.onError&&te.onError(Q),this._debugServiceProxy.$acceptDAError(d,Q.name,Q.message,Q.stack)}),j.onExit(Q=>{te&&te.onExit&&te.onExit((0,b.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,b.withNullAsUndefined)(Q),void 0)}),te&&te.onWillStartSession&&te.onWillStartSession(),j.startSession()))})}$sendDAMessage(d,w){w=(0,c.convertToDAPaths)(w,!1);const E=this._debugAdaptersTrackers.get(d);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(w);const r=this._debugAdapters.get(d);r&&r.sendMessage(w)}$stopDASession(d){const w=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),w&&w.onWillStopSession&&w.onWillStopSession();const E=this._debugAdapters.get(d);return this._debugAdapters.delete(d),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const w=[],E=[],r=[];if(d.added)for(const D of d.added){const R=D.id;if(R&&!this._breakpoints.has(R)){let x;if(D.type==="function")x=new y.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")x=new y.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const j=L.URI.revive(D.uri);x=new y.SourceBreakpoint(new y.Location(j,new y.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}x._id=R,this._breakpoints.set(R,x),w.push(x)}}if(d.removed)for(const D of d.removed){const R=this._breakpoints.get(D);R&&(this._breakpoints.delete(D),E.push(R))}if(d.changed){for(const D of d.changed)if(D.id){const R=this._breakpoints.get(D.id);if(R){if(R instanceof y.FunctionBreakpoint&&D.type==="function"){const x=R;x.enabled=D.enabled,x.condition=D.condition,x.hitCondition=D.hitCondition,x.logMessage=D.logMessage,x.functionName=D.functionName}else if(R instanceof y.SourceBreakpoint&&D.type==="source"){const x=R;x.enabled=D.enabled,x.condition=D.condition,x.hitCondition=D.hitCondition,x.logMessage=D.logMessage,x.location=new y.Location(L.URI.revive(D.uri),new y.Position(D.line,D.character))}r.push(R)}}}this.fireBreakpointChanges(w,E,r)}$provideDebugConfigurations(d,w,E){return(0,k.asPromise)(async()=>{const r=this.getConfigProviderByHandle(d);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(w);return r.provideDebugConfigurations(D,E)}).then(r=>{if(!r)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return r})}$resolveDebugConfiguration(d,w,E,r){return(0,k.asPromise)(async()=>{const D=this.getConfigProviderByHandle(d);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(w);return D.resolveDebugConfiguration(R,E,r)})}$resolveDebugConfigurationWithSubstitutedVariables(d,w,E,r){return(0,k.asPromise)(async()=>{const D=this.getConfigProviderByHandle(d);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(w);return D.resolveDebugConfigurationWithSubstitutedVariables(R,E,r)})}async $provideDebugAdapter(d,w){const E=this.getAdapterDescriptorFactoryByHandle(d);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const r=await this.getSession(w);return this.getAdapterDescriptor(E,r).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(d){const w=await this.getSession(d);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(d){const w=await this.getSession(d);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,w){const E=await this.getSession(d);E&&E._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(d,w){const r={session:await this.getSession(d),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(r)}convertToDto(d){if(d instanceof y.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof y.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const w=this._adapterFactories.filter(E=>E.type===d);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(d){const w=this._adapterFactories.filter(E=>E.handle===d);if(w.length>0)return w[0].factory}getConfigProviderByHandle(d){const w=this._configProviders.filter(E=>E.handle===d);if(w.length>0)return w[0].provider}definesDebugType(d,w){if(d.contributes){const E=d.contributes.debuggers;if(E&&E.length>0){for(const r of E)if(r.label&&r.type&&r.type===w)return!0}}return!1}getDebugAdapterTrackers(d){const E=d.configuration.type,r=this._trackerFactories.filter(D=>D.type===E||D.type==="*").map(D=>(0,k.asPromise)(()=>D.factory.createDebugAdapterTracker(d)).then(R=>R,R=>null));return Promise.race([Promise.all(r).then(D=>{const R=D.filter(x=>!!x);if(R.length>0)return new o(R)}),new Promise((D,R)=>{const x=setTimeout(()=>{clearTimeout(x),R(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(d,w){const E=w.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new y.DebugAdapterServer(E));if(d){const D=await this._extensionService.getExtensionRegistry();return(0,k.asPromise)(()=>d.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,D))).then(R=>{if(R)return R})}const r=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,r))}daExecutableFromPackage(d,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,w,E){(d.length>0||w.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:w,changed:E}))}async getSession(d){if(d)if(typeof d=="string"){const w=this._debugSessions.get(d);if(w)return w}else{let w=this._debugSessions.get(d.id);if(!w){const E=await this.getFolder(d.folderUri),r=d.parent?this._debugSessions.get(d.parent):void 0;w=new p(this._debugServiceProxy,d.id,d.type,d.name,E,d.configuration,r),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(d){if(d){const w=L.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};f=We([xe(0,v.IExtHostRpcService),xe(1,A.IExtHostWorkspace),xe(2,i.IExtHostExtensionService),xe(3,I.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration),xe(5,l.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class p{constructor(d,w,E,r,D,R,x){this._debugServiceProxy=d,this._id=w,this._type=E,this._name=r,this._workspaceFolder=D,this._configuration=R,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,w)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=p;class t{constructor(d){this.value=Object.freeze({append(w){d.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class s extends u.AbstractVariableResolverService{constructor(d,w,E,r,D){function R(){if(w){const x=w.activeEditor();if(x)return x.document.uri;const j=r.tabs.filter(te=>te.isActive);if(j.length>0)return j[0].resource}}super({getFolderUri:x=>{const j=d.filter(te=>te.name===x);if(j&&j.length>0)return j[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(x,j)=>E.getConfiguration(void 0,x).get(j),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=R();if(x)return g.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const x=R();if(x){const j=D.getWorkspaceFolder(x);if(j)return g.normalize(j.uri.fsPath)}}},getSelectedText:()=>{if(w){const x=w.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(w){const x=w.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(P.env))}}e.ExtHostVariableResolverService=s;class o{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(w=>w.onError?w.onError(d):void 0)}onExit(d,w){this.trackers.forEach(E=>E.onExit?E.onExit(d,w):void 0)}}class n extends S.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(d,w,E,r,D,R){super(d,w,E,r,D,R)}createVariableResolver(d,w,E){return new s(d,w,E,this._editorTabs)}};a=We([xe(0,v.IExtHostRpcService),xe(1,A.IExtHostWorkspace),xe(2,i.IExtHostExtensionService),xe(3,I.IExtHostDocumentsAndEditors),xe(4,m.IExtHostConfiguration),xe(5,l.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(ve[269],we([0,1,71,2,5,37,35,26,13,27,4,40,38,12]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(l,f,p,t,s,o,n){this._apiFactory=l,this._extensionRegistry=f,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=o,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,f,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,f,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let f of l.nodeModuleName)this._factories.set(f,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(f=>l.alternativeModuleName(f))}};c=We([xe(2,i.IInstantiationService),xe(3,k.IExtHostConfiguration),xe(4,I.IExtHostExtensionService),xe(5,A.IExtHostInitDataService),xe(6,m.ILogService)],c),e.RequireInterceptor=c;class v{constructor(l,f,p,t,s){this._apiFactory=l,this._extensionPaths=f,this._extensionRegistry=p,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,f){const p=this._extensionPaths.findSubstr(f.fsPath);if(p){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,o)=>t+=`	${o} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(l,f){this.nodeModuleName="keytar";const{environment:p}=f,t=l.getProxy(C.MainContext.MainThreadKeytar);if(p.appRoot){let s=p.appRoot.fsPath;u.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,o)=>t.$getPassword(s,o),setPassword:(s,o,n)=>t.$setPassword(s,o,n),deletePassword:(s,o)=>t.$deletePassword(s,o),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(l,f){return this._impl}alternativeModuleName(l){const f=l.length;if(f<=7||!this.alternativeNames)return;const p=f-7;if((l.charAt(p)==="/"||l.charAt(p)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};_=We([xe(0,S.IExtHostRpcService),xe(1,A.IExtHostInitDataService)],_);let b=class{constructor(l,f,p){this._extensionPaths=l,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(C.MainContext.MainThreadTelemetry);const t=p.getProxy(C.MainContext.MainThreadWindow);this._impl=(s,o)=>{const n=L.URI.parse(s);return o?this.callOriginal(s,o):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,s,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,s,{}):this.callOriginal(s,o)}}load(l,f,p){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(l),this._impl}callOriginal(l,f){return this.sendNoForwardTelemetry(),this._original(l,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=We([xe(2,S.IExtHostRpcService)],b)}),define(ve[270],we([0,1,170,11,7,210,36,40,45,37,33,13,53,194,17,211,51]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends u.ExtHostDebugServiceBase{constructor(f,p,t,s,o,n,a){super(f,p,t,s,o,a);this._terminalService=n,this._integratedTerminalInstances=new P}createDebugAdapter(f,p){switch(f.type){case"server":return new k.SocketDebugAdapter(f);case"pipeServer":return new k.NamedPipeDebugAdapter(f);case"executable":return new k.ExecutableDebugAdapter(f,p.type)}return super.createDebugAdapter(f,p)}daExecutableFromPackage(f,p){const t=k.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),f.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(f,p){if(f.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const t=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),n=f.title||g.localize(0,null),a=JSON.stringify({shell:s,shellArgs:o});let h=await this._integratedTerminalInstances.checkout(a,n),d,w=!1;if(h)d=f.cwd;else{const R={shellPath:s,shellArgs:o,cwd:f.cwd,name:n,iconPath:new C.ThemeIcon("debug")};w=!0,h=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(h,a)}h.show(!0);const E=await h.processId;w?await new Promise(R=>setTimeout(R,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?h.sendText("cls"):s.indexOf("bash")>=0?h.sendText("clear"):L.isWindows?h.sendText("cls"):h.sendText("clear"));const r=(0,v.prepareCommand)(s,f.args,d,f.env);h.sendText(r);const D=this.onDidTerminateDebugSession(R=>{R.id===p&&(this._integratedTerminalInstances.free(h),D.dispose())});return E}else if(f.kind==="external")return(0,v.runInExternalTerminal)(f,await this._configurationService.getConfigProvider());return super.$runInTerminal(f,p)}createVariableResolver(f,p,t){return new u.ExtHostVariableResolverService(f,p,t,this._editorTabs,this._workspaceService)}};b=We([xe(0,I.IExtHostRpcService),xe(1,T.IExtHostWorkspace),xe(2,y.IExtHostExtensionService),xe(3,S.IExtHostDocumentsAndEditors),xe(4,A.IExtHostConfiguration),xe(5,i.IExtHostTerminalService),xe(6,_.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;class P{constructor(){this._terminalInstances=new Map}async checkout(f,p){const s=[...this._terminalInstances.entries()].map(([o,n])=>(0,c.createCancelablePromise)(async a=>{if(o.name!==p||n.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await o.processId))return null;const h=Date.now();return n.lastUsedAt+P.minUseDelay>h||a.isCancellationRequested||n.config!==f?null:(n.lastUsedAt=h,o)}));return await(0,c.firstParallel)(s,o=>!!o)}insert(f,p){this._terminalInstances.set(f,{lastUsedAt:Date.now(),config:p})}free(f){const p=this._terminalInstances.get(f);p&&(p.lastUsedAt=-1)}onTerminalClosed(f){this._terminalInstances.delete(f)}}P.minUseDelay=1e3}),define(ve[271],we([0,1,8,2,112,36,53,45,37,43,33,13,27,70,10,12,65,51,23,79]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let f=class extends m.ExtHostTaskBase{constructor(t,s,o,n,a,h,d,w,E){super(t,s,o,n,a,h,d,w);this.workspaceService=o,this.editorTabs=E,s.remote.isRemote&&s.remote.authority?this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:s.remote.authority,platform:process.platform}):this.registerTaskSystem(c.Schemas.file,{scheme:c.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,s){const o=s;if(!s.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const n=m.TaskHandleDTO.from(o,this.workspaceService),a=await this._proxy.$getTaskExecution(n);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const h=await this.getTaskExecution(a,s);return this._proxy.$executeTask(n).catch(()=>{}),h}else{const n=m.TaskDTO.from(s,t);if(n===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,s,!1);const a=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),s);return this._proxy.$executeTask(n).catch(()=>{}),a}}provideTasksInternal(t,s,o,n){const a=[];if(n)for(let h of n){this.checkDeprecation(h,o),(!h.definition||!t[h.definition.type])&&this._logService.warn(`The task [${h.source}, ${h.name}] uses an undefined task type. The task will be ignored in the future.`);const d=m.TaskDTO.from(h,o.extension);d&&(a.push(d),m.CustomExecutionDTO.is(d.execution)&&s.push(this.addCustomExecution(d,h,!0)))}return{tasks:a,extension:o.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const s=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(t,this._editorService,s,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let s=t&&t.length>0?t[0]:void 0;if(!s){const o=L.URI.file((0,l.homedir)());s=new A.WorkspaceFolder({uri:o,name:P.basename(o),index:0})}return{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,s){const o=L.URI.revive(t),n={process:void 0,variables:Object.create(null)},a=await this._workspaceProvider.resolveWorkspaceFolder(o),h=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(h),w=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(h);for(let E of s.variables)n.variables[E]=await d.resolveAsync(w,E);if(s.process!==void 0){let E;if(s.process.path!==void 0){E=s.process.path.split(g.delimiter);for(let r=0;r<E.length;r++)E[r]=await d.resolveAsync(w,E[r])}n.process=await C.win32.findExecutable(await d.resolveAsync(w,s.process.name),s.process.cwd!==void 0?await d.resolveAsync(w,s.process.cwd):void 0,E)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(t,s,o){return C.win32.findExecutable(t,s,o)}};f=We([xe(0,I.IExtHostRpcService),xe(1,u.IExtHostInitDataService),xe(2,k.IExtHostWorkspace),xe(3,y.IExtHostDocumentsAndEditors),xe(4,S.IExtHostConfiguration),xe(5,i.IExtHostTerminalService),xe(6,v.ILogService),xe(7,_.IExtHostApiDeprecationService),xe(8,b.IExtHostEditorTabs)],f),e.ExtHostTask=f}),define(ve[272],we([0,1,17,16,71,6,2,5,264,12,81,83,27,188,13,64,40,33]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class P{constructor(f,p,t,s){this._disposables=new k.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(f,null,s),p=P._transform(p,this._rpcProtocol);const o=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());o.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...p}),o.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),o.set(v.IURITransformerService,new v.URITransformerService(s)),o.set(_.IHostUtils,t);const n=new m.InstantiationService(o,!0),a=n.invokeFunction(E=>E.get(b.IExtHostTerminalService));this._disposables.add(a),this._logService=n.invokeFunction(E=>E.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=n.invokeFunction(E=>E.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(r,D)=>{let R="",x,j;for(const te of D)R+=`
	at ${te.toString()}`,j=te.getFileName(),!x&&j&&(x=E.findSubstr(j));return h.set(r,x),`${r.name||"Error"}: ${r.message||""}${R}`}});const d=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(E=>{const r=L.transformErrorForSerialization(E),D=h.get(E);D?d.$onExtensionRuntimeError(D.identifier,r):w.$onUnexpectedError(r)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,p){f.extensions.forEach(s=>s.extensionLocation=T.URI.revive(p.transformIncomingURIs(s.extensionLocation))),f.environment.appRoot=T.URI.revive(p.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(s=>T.URI.revive(p.transformIncomingURIs(s)))),f.environment.extensionTestsLocationURI=T.URI.revive(p.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=T.URI.revive(p.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=T.URI.revive(p.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=T.URI.revive(p.transformIncomingURIs(f.logsLocation)),f.logFile=T.URI.revive(p.transformIncomingURIs(f.logFile)),f.workspace=p.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=P}),define(ve[273],we([0,1,8,21,60,30,23,46,31]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(u,m,c){this.config=u,this.provider=m,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&k.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&k.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const m=this.config.folderQueries||[];return new Promise((c,v)=>{const _=b=>{this.resultCount++,u(b)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const P=b.toString(),l=g.basename(P);this.globalExcludePattern&&this.globalExcludePattern(P,l)||this.matchFile(_,{base:b,basename:l})}),Promise.all(m.map(b=>this.searchInFolder(b,_))).then(b=>{c({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{v(new Error((0,C.toErrorMessage)(b)))})})}async searchInFolder(u,m){const c=new L.CancellationTokenSource,v=this.getSearchOptionsForFolder(u),_=this.initDirectoryTree(),b=new S.QueryGlobTester(this.config,u),P=!b.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(c),l=y.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,c.token),p=l.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(s=>{const o=g.posix.relative(u.folder.path,s.path);if(P){const n=g.basename(s.path);this.matchFile(m,{base:u.folder,relativePath:o,basename:n});return}this.addDirectoryEntries(_,u.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,b,m),{providerTime:p,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(u){const m=(0,S.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),c=(0,S.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:c,includes:m,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},m,c,v){if(c===this.filePattern){const b=g.basename(this.filePattern);this.matchFile(v,{base:m,relativePath:this.filePattern,basename:b})}function _(b){const P=g.basename(b),l=g.dirname(b);let f=u[l];f||(f=u[l]=[],_(l)),f.push({base:m,relativePath:b,basename:P})}_(c)}matchDirectoryTree({rootEntries:u,pathToEntries:m},c,v){const _=this,b=this.filePattern;function P(l){const f=k.hasSiblingFn(()=>l.map(p=>p.basename));for(let p=0,t=l.length;p<t;p++){const s=l[p],{relativePath:o,basename:n}=s;if(!c.includedInQuerySync(o,n,b!==n?f:void 0))continue;const a=m[o];if(a)P(a);else{if(o===b)continue;_.matchFile(v,s)}if(_.isLimitHit)break}}P(u)}matchFile(u,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(m))}}class i{constructor(){this.sessions=new Map}fileSearch(u,m,c,v){const _=this.getSessionTokenSource(u.cacheKey),b=new A(u,m,_&&_.token);let P=0;const l=f=>{P+=f.length,c(f.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(b,i.BATCH_SIZE,l,v).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:P,detailStats:f.stats}}))}clearCache(u){const m=this.getSessionTokenSource(u);m&&m.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new L.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:T.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,m,c,v){v.onCancellationRequested(()=>{u.cancel()});const _=P=>{P&&(b.push(P),m>0&&b.length>=m&&(c(b),b=[]))};let b=[];return u.search(_).then(P=>(b.length&&c(b),P),P=>(b.length&&c(b),Promise.reject(P)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(ve[133],we([0,1,8,20,21,60,23,30,2,31,10,14]),function(J,e,g,L,C,k,T,y,S,A,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(l,f,p){this.query=l,this.provider=f,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,f){const p=this.query.folderQueries||[],t=new C.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((s,o)=>{this.collector=new c(l);let n=!1;const a=(h,d)=>{if(!n&&!this.isLimitHit){const w=this.resultSize(h);_(h)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const E=this.resultSize(h);this.resultCount+=E,(E>0||!_(h))&&this.collector.add(h,d)}};Promise.all(p.map((h,d)=>this.searchInFolder(h,w=>a(w,d),t.token))).then(h=>{t.dispose(),this.collector.flush();const d=h.some(w=>!!w&&!!w.limitHit);s({limitHit:this.isLimitHit||d,messages:(0,L.flatten)(h.map(w=>w?.message?(0,I.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:"textSearchProvider"}})},h=>{t.dispose();const d=(0,k.toErrorMessage)(h);o(new Error(d))})})}resultSize(l){return _(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,f){const p=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:p.slice(0,f),preview:{matches:t.slice(0,f),text:l.preview.text},uri:l.uri}}async searchInFolder(l,f,p){const t=new A.QueryGlobTester(this.query,l),s=[],o={report:h=>{if(!this.validateProviderResult(h))return;const d=l.folder.scheme===i.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(h.uri))):void 0,w=T.relativePath(l.folder,h.uri);w&&s.push(t.includedInQuery(w,g.basename(w),d).then(E=>{E&&f(h)}))}},n=this.getSearchOptionsForFolder(l),a=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,o,p);return await Promise.all(s),a}validateProviderResult(l){if(_(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const f=(0,A.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),p=(0,A.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:S.URI.from(l.folder),excludes:p,includes:f,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=u;function m(P){return{isCaseSensitive:P.isCaseSensitive||!1,isRegExp:P.isRegExp||!1,isWordMatch:P.isWordMatch||!1,isMultiline:P.isMultiline||!1,pattern:P.pattern}}class c{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,f=>this.sendItems(f))}add(l,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!T.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(v(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=c;function v(P){return _(P)?{preview:{matches:(0,L.mapArrayOrNot)(P.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:P.preview.text},ranges:(0,L.mapArrayOrNot)(P.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:P.text,lineNumber:P.lineNumber}}function _(P){return!!P.preview}e.extensionResultIsMatch=_;class b{constructor(l,f){this.maxBatchSize=l,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,f){!l||this.addItemToBatch(l,f)}addItems(l,f){!l||this.addItemsToBatch(l,f)}addItemToBatch(l,f){this.batch.push(l),this.batchSize+=f,this.onUpdate()}addItemsToBatch(l,f){this.batch=this.batch.concat(l),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(ve[72],we([0,1,6,5,4,273,13,64,12,2,133]),function(J,e,g,L,C,k,T,y,S,A,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let I=class{constructor(v,_,b){this.extHostRpc=v,this._uriTransformer=_,this._logService=b,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new k.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,_){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const b=this._handlePool++;return this._textSearchProvider.set(b,_),this._proxy.$registerTextSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(v,_){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const b=this._handlePool++;return this._fileSearchProvider.set(b,_),this._proxy.$registerFileSearchProvider(b,this._transformScheme(v)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(v,_,b,P){const l=u(b),f=this._fileSearchProvider.get(v);if(f)return this._fileSearchManager.fileSearch(l,f,p=>{this._proxy.$handleFileMatch(v,_,p.map(t=>t.resource))},P);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,_,b,P){const l=this._textSearchProvider.get(v);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const f=u(b);return this.createTextSearchManager(f,l).search(t=>this._proxy.$handleTextMatch(v,_,t),P)}createTextSearchManager(v,_){return new i.TextSearchManager(v,_,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};I=We([xe(0,T.IExtHostRpcService),xe(1,y.IURITransformerService),xe(2,S.ILogService)],I),e.ExtHostSearch=I;function u(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(m),extraFileResources:c.extraFileResources&&c.extraFileResources.map(v=>A.URI.revive(v))}}e.reviveQuery=u;function m(c){return{...c,folder:A.URI.revive(c.folder)}}}),define(ve[274],we([0,1,21,16,3,48,2,113,108,146,80,42,5,232,231,44,233,37,234,235,236,217,237,45,40,238,218,241,242,243,66,220,248,249,250,92,33,252,221,15,7,255,68,132,36,35,55,206,240,85,131,70,53,72,12,64,13,27,244,203,52,65,229,253,202,67,91,258,256,257,230,63,251,254,90,51,121,246,69,247,10,190,245,200,239]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l,f,p,t,s,o,n,a,h,d,w,E,r,D,R,x,j,te,Q,N,U,F,V,M,O,q,B,K,ne,me,Se,Ce,Te,je,Be,Ve,W,Z,ie,le,Y,ae,be,Fe,He,Ee,Qe,X,se,pe,Ue,Ne,Je,ke,ye,Ie,ce,de,H,ee,ue,Le,Re,ze,Ge,et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function it(Ye){const Xe=Ye.get(ie.IExtHostInitDataService),mt=Ye.get(Je.IExtHostFileSystemInfo),vt=Ye.get(X.IExtHostConsumerFileSystem),Et=Ye.get(o.IExtHostExtensionService),ot=Ye.get(q.IExtHostWorkspace),at=Ye.get(de.IExtHostTelemetry),Dt=Ye.get(b.IExtHostConfiguration),_e=Ye.get(W.IURITransformerService),ge=Ye.get(Z.IExtHostRpcService),he=Ye.get(j.IExtHostStorage),G=Ye.get(Qe.IExtensionStoragePaths),Pe=Ye.get(Ve.ILogService),Oe=Ye.get(ae.IExtHostTunnelService),Ze=Ye.get(be.IExtHostApiDeprecationService),qe=Ye.get(O.IExtHostWindow),ft=Ye.get(Ie.IExtHostSecretState),bt=Ye.get(ce.IExtHostEditorTabs);ge.set(u.ExtHostContext.ExtHostFileSystemInfo,mt),ge.set(u.ExtHostContext.ExtHostLogService,Pe),ge.set(u.ExtHostContext.ExtHostWorkspace,ot),ge.set(u.ExtHostContext.ExtHostConfiguration,Dt),ge.set(u.ExtHostContext.ExtHostExtensionService,Et),ge.set(u.ExtHostContext.ExtHostStorage,he),ge.set(u.ExtHostContext.ExtHostTunnelService,Oe),ge.set(u.ExtHostContext.ExtHostWindow,qe),ge.set(u.ExtHostContext.ExtHostSecretState,ft),ge.set(u.ExtHostContext.ExtHostTelemetry,at),ge.set(u.ExtHostContext.ExtHostEditorTabs,bt);const kt=ge.set(u.ExtHostContext.ExtHostDecorations,Ye.get(Ce.IExtHostDecorations)),dt=ge.set(u.ExtHostContext.ExtHostDocumentsAndEditors,Ye.get(s.IExtHostDocumentsAndEditors)),ct=ge.set(u.ExtHostContext.ExtHostCommands,Ye.get(v.IExtHostCommands)),ht=ge.set(u.ExtHostContext.ExtHostTerminalService,Ye.get(te.IExtHostTerminalService)),_t=ge.set(u.ExtHostContext.ExtHostDebugService,Ye.get(je.IExtHostDebugService)),Tt=ge.set(u.ExtHostContext.ExtHostSearch,Ye.get(Be.IExtHostSearch)),It=ge.set(u.ExtHostContext.ExtHostTask,Ye.get(Te.IExtHostTask)),En=ge.set(u.ExtHostContext.ExtHostOutputService,Ye.get(E.IExtHostOutputService)),Vt=ge.set(u.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(ge)),St=ge.set(u.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ge,dt)),Xt=ge.set(u.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(ge,dt,Pe)),Yt=ge.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(Pe,St,ge.getProxy(u.MainContext.MainThreadBulkEdits))),gt=ge.set(u.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(ge,ct,dt,St,G)),jt=ge.set(u.ExtHostContext.ExtHostNotebookDocuments,new Ge.ExtHostNotebookDocuments(Pe,gt)),Wt=ge.set(u.ExtHostContext.ExtHostNotebookEditors,new ze.ExtHostNotebookEditors(Pe,ge,gt)),Jt=ge.set(u.ExtHostContext.ExtHostNotebookKernels,new H.ExtHostNotebookKernels(ge,Xe,gt,Pe)),Zt=ge.set(u.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(ge,gt)),Pt=ge.set(u.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(ge,dt)),hn=ge.set(u.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(ge.getProxy(u.MainContext.MainThreadTreeViews),ct,Pe)),en=ge.set(u.ExtHostContext.ExtHostEditorInsets,new ne.ExtHostEditorInsets(ge.getProxy(u.MainContext.MainThreadEditorInsets),Pt,Xe)),xt=ge.set(u.ExtHostContext.ExtHostDiagnostics,new P.ExtHostDiagnostics(ge,Pe)),ut=ge.set(u.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(ge,_e,St,ct,xt,Pe,Ze)),tn=ge.set(u.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(ge,ut)),Mt=ge.set(u.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(ge,Pe,dt)),Ot=ge.set(u.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(ge,ot,ct)),qt=ge.set(u.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(ge,ct,Pe)),_n=ge.set(u.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(ge,ct,St)),fn=ge.set(u.ExtHostContext.ExtHostProgress,new r.ExtHostProgress(ge.getProxy(u.MainContext.MainThreadProgress))),Sn=ge.set(u.ExtHostContext.ExtHosLabelService,new me.ExtHostLabelService(ge)),mn=ge.set(u.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(ge)),nn=ge.set(u.ExtHostContext.ExtHostAuthentication,new Fe.ExtHostAuthentication(ge)),rn=ge.set(u.ExtHostContext.ExtHostTimeline,new He.ExtHostTimeline(ge,ct)),Ht=ge.set(u.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(ge,{remote:Xe.remote},ot,Pe,Ze)),sn=ge.set(u.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(ge,Ht,ot)),yn=ge.set(u.ExtHostContext.ExtHostCustomEditors,new pe.ExtHostCustomEditors(ge,St,G,Ht,sn)),Dn=ge.set(u.ExtHostContext.ExtHostWebviewViews,new se.ExtHostWebviewViews(ge,Ht)),zt=ge.set(u.ExtHostContext.ExtHostTesting,new ke.ExtHostTesting(ge,ct)),Gt=ge.set(u.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(ge));ge.set(u.ExtHostContext.ExtHostInteractive,new et.ExtHostInteractive(ge,gt,dt,ct));const Cn=(0,K.values)(u.ExtHostContext);ge.assertRegistered(Cn);const kn=new Ne.ExtHostBulkEdits(ge,dt),on=new c.ExtHostClipboard(ge),an=new w.ExtHostMessageService(ge,Pe),Bt=new l.ExtHostDialogs(ge),Lt=new x.ExtHostStatusBar(ge,ct.converter),Kt=new d.ExtHostLanguages(ge,St);return m.ExtHostApiCommands.register(ct),function(Me,$t,gn){const pt=function(){let re=!Me.isUnderDevelopment;function fe(Ae){re||(Pe.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")fe(st);else{const wt=st;typeof wt.scheme=="undefined"&&fe(st),!Me.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,B.throwProposedApiError)(Me)}return st}}(),In={getSession(re,fe,Ae){return Ae?.forceNewSession&&(0,B.checkProposedApiEnabled)(Me),nn.getSession(Me,re,fe,Ae)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(re,fe,Ae,st){return nn.registerAuthenticationProvider(re,fe,Ae,st)}},Pn={registerCommand(re,fe,Ae){return ct.registerCommand(!0,re,fe,Ae)},registerTextEditorCommand(re,fe,Ae){return ct.registerCommand(!0,re,(...st)=>{const wt=Pt.getActiveTextEditor();if(!wt){Pe.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Ct=>{fe.apply(Ae,[wt,Ct,...st])}).then(Ct=>{Ct||Pe.warn("Edits from command "+re+" were not applied.")},Ct=>{Pe.warn("An error occurred while running command "+re,Ct)})})},registerDiffInformationCommand:(re,fe,Ae)=>((0,B.checkProposedApiEnabled)(Me),ct.registerCommand(!0,re,async(...st)=>{const wt=dt.activeEditor(!0);if(!wt){Pe.warn("Cannot execute "+re+" because there is no active text editor.");return}const Ct=await Pt.getDiffInformation(wt.id);fe.apply(Ae,[Ct,...st])})),executeCommand(re,...fe){return ct.executeCommand(re,...fe)},getCommands(re=!1){return ct.getCommands(re)}},pn={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){return Xe.environment.appRoot?.fsPath??""},get embedderIdentifier(){return Xe.environment.embedderIdentifier},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return ht.getDefaultShell(!1)},get isTelemetryEnabled(){return at.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return at.onDidChangeTelemetryEnabled},get isNewAppInstall(){const re=Date.now()-new Date(Xe.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,fe){return qe.openUri(re,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===Xe.environment.appUriScheme)return Vt.createAppUri(re);try{return await qe.asExternalUri(re,{allowTunneling:!!Xe.remote.authority})}catch(fe){if((0,Re.matchesScheme)(re,Le.Schemas.http)||(0,Re.matchesScheme)(re,Le.Schemas.https))return re;throw fe}},get remoteName(){return(0,Se.getRemoteName)(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(pn);const vn=Xe.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,An={createTestController(re,fe){return zt.createTestController(re,fe)},createTestObserver(){return(0,B.checkProposedApiEnabled)(Me),zt.createTestObserver()},runTests(re){return(0,B.checkProposedApiEnabled)(Me),zt.runTests(re)},get onDidChangeTestResults(){return(0,B.checkProposedApiEnabled)(Me),zt.onResultsChanged},get testResults(){return(0,B.checkProposedApiEnabled)(Me),zt.results}},ln={getExtension(re){const fe=$t.getExtensionDescription(re);if(fe)return new o.Extension(Et,Me.identifier,fe,vn)},get all(){return $t.getAllExtensionDescriptions().map(re=>new o.Extension(Et,Me.identifier,re,vn))},get onDidChange(){return $t.onDidChange}},Tn={createDiagnosticCollection(re){return xt.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:re=>xt.getDiagnostics(re),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(re,fe){return Kt.changeLanguage(re.uri,fe)},match(re,fe){return(0,i.score)(U.LanguageSelector.from(re),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(re,fe,Ae){return ut.registerCodeActionProvider(Me,pt(re),fe,Ae)},registerCodeLensProvider(re,fe){return ut.registerCodeLensProvider(Me,pt(re),fe)},registerDefinitionProvider(re,fe){return ut.registerDefinitionProvider(Me,pt(re),fe)},registerDeclarationProvider(re,fe){return ut.registerDeclarationProvider(Me,pt(re),fe)},registerImplementationProvider(re,fe){return ut.registerImplementationProvider(Me,pt(re),fe)},registerTypeDefinitionProvider(re,fe){return ut.registerTypeDefinitionProvider(Me,pt(re),fe)},registerHoverProvider(re,fe){return ut.registerHoverProvider(Me,pt(re),fe,Me.identifier)},registerEvaluatableExpressionProvider(re,fe){return ut.registerEvaluatableExpressionProvider(Me,pt(re),fe,Me.identifier)},registerInlineValuesProvider(re,fe){return ut.registerInlineValuesProvider(Me,pt(re),fe,Me.identifier)},registerDocumentHighlightProvider(re,fe){return ut.registerDocumentHighlightProvider(Me,pt(re),fe)},registerLinkedEditingRangeProvider(re,fe){return ut.registerLinkedEditingRangeProvider(Me,pt(re),fe)},registerReferenceProvider(re,fe){return ut.registerReferenceProvider(Me,pt(re),fe)},registerRenameProvider(re,fe){return ut.registerRenameProvider(Me,pt(re),fe)},registerDocumentSymbolProvider(re,fe,Ae){return ut.registerDocumentSymbolProvider(Me,pt(re),fe,Ae)},registerWorkspaceSymbolProvider(re){return ut.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,fe){return ut.registerDocumentFormattingEditProvider(Me,pt(re),fe)},registerDocumentRangeFormattingEditProvider(re,fe){return ut.registerDocumentRangeFormattingEditProvider(Me,pt(re),fe)},registerOnTypeFormattingEditProvider(re,fe,Ae,...st){return ut.registerOnTypeFormattingEditProvider(Me,pt(re),fe,[Ae].concat(st))},registerDocumentSemanticTokensProvider(re,fe,Ae){return ut.registerDocumentSemanticTokensProvider(Me,pt(re),fe,Ae)},registerDocumentRangeSemanticTokensProvider(re,fe,Ae){return ut.registerDocumentRangeSemanticTokensProvider(Me,pt(re),fe,Ae)},registerSignatureHelpProvider(re,fe,Ae,...st){return typeof Ae=="object"?ut.registerSignatureHelpProvider(Me,pt(re),fe,Ae):ut.registerSignatureHelpProvider(Me,pt(re),fe,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(re,fe,...Ae){return ut.registerCompletionItemProvider(Me,pt(re),fe,Ae)},registerInlineCompletionItemProvider(re,fe){return(0,B.checkProposedApiEnabled)(Me),ut.registerInlineCompletionsProvider(Me,pt(re),fe)},registerDocumentLinkProvider(re,fe){return ut.registerDocumentLinkProvider(Me,pt(re),fe)},registerColorProvider(re,fe){return ut.registerColorProvider(Me,pt(re),fe)},registerFoldingRangeProvider(re,fe){return ut.registerFoldingRangeProvider(Me,pt(re),fe)},registerSelectionRangeProvider(re,fe){return ut.registerSelectionRangeProvider(Me,re,fe)},registerCallHierarchyProvider(re,fe){return ut.registerCallHierarchyProvider(Me,re,fe)},setLanguageConfiguration:(re,fe)=>ut.setLanguageConfiguration(Me,re,fe),getTokenInformationAtPosition(re,fe){return(0,B.checkProposedApiEnabled)(Me),Kt.tokenAtPosition(re,fe)},registerInlayHintsProvider(re,fe){return(0,B.checkProposedApiEnabled)(Me),ut.registerInlayHintsProvider(Me,re,fe)},registerTypeHierarchyProvider(re,fe){return(0,B.checkProposedApiEnabled)(Me),ut.registerTypeHierarchyProvider(Me,re,fe)},createLanguageStatusItem(re){return(0,B.checkProposedApiEnabled)(Me),Kt.createLanguageStatusItem(re)}},Rn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(re,fe,Ae){const st=await(T.URI.isUri(re)?Promise.resolve(wn.openTextDocument(re)):Promise.resolve(re));return Pt.showTextDocument(st,fe,Ae)},createTextEditorDecorationType(re){return Pt.createTextEditorDecorationType(Me,re)},onDidChangeActiveTextEditor(re,fe,Ae){return Pt.onDidChangeActiveTextEditor(re,fe,Ae)},onDidChangeVisibleTextEditors(re,fe,Ae){return Pt.onDidChangeVisibleTextEditors(re,fe,Ae)},onDidChangeTextEditorSelection(re,fe,Ae){return Pt.onDidChangeTextEditorSelection(re,fe,Ae)},onDidChangeTextEditorOptions(re,fe,Ae){return Pt.onDidChangeTextEditorOptions(re,fe,Ae)},onDidChangeTextEditorVisibleRanges(re,fe,Ae){return Pt.onDidChangeTextEditorVisibleRanges(re,fe,Ae)},onDidChangeTextEditorViewColumn(re,fe,Ae){return Pt.onDidChangeTextEditorViewColumn(re,fe,Ae)},onDidCloseTerminal(re,fe,Ae){return ht.onDidCloseTerminal(re,fe,Ae)},onDidOpenTerminal(re,fe,Ae){return ht.onDidOpenTerminal(re,fe,Ae)},onDidChangeActiveTerminal(re,fe,Ae){return ht.onDidChangeActiveTerminal(re,fe,Ae)},onDidChangeTerminalDimensions(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),ht.onDidChangeTerminalDimensions(re,fe,Ae)},onDidWriteTerminalData(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),ht.onDidWriteTerminalData(re,fe,Ae)},get state(){return qe.state},onDidChangeWindowState(re,fe,Ae){return qe.onDidChangeWindowState(re,fe,Ae)},showInformationMessage(re,...fe){return an.showMessage(Me,k.default.Info,re,fe[0],fe.slice(1))},showWarningMessage(re,...fe){return an.showMessage(Me,k.default.Warning,re,fe[0],fe.slice(1))},showErrorMessage(re,...fe){return an.showMessage(Me,k.default.Error,re,fe[0],fe.slice(1))},showQuickPick(re,fe,Ae){return Ot.showQuickPick(re,!!Me.enableProposedApi,fe,Ae)},showWorkspaceFolderPick(re){return Ot.showWorkspaceFolderPick(re)},showInputBox(re,fe){return Ot.showInput(re,fe)},showOpenDialog(re){return Bt.showOpenDialog(re)},showSaveDialog(re){return Bt.showSaveDialog(re)},createStatusBarItem(re,fe,Ae){let st,wt,Ct;return typeof re=="string"?(st=re,wt=fe,Ct=Ae):(wt=re,Ct=fe),Lt.createStatusBarEntry(Me,st,wt,Ct)},setStatusBarMessage(re,fe){return Lt.setStatusBarMessage(re,fe)},withScmProgress(re){return Ze.report("window.withScmProgress",Me,"Use 'withProgress' instead."),fn.withProgress(Me,{location:F.ProgressLocation.SourceControl},(fe,Ae)=>re({report(st){}}))},withProgress(re,fe){return fn.withProgress(Me,re,fe)},createOutputChannel(re){return En.createOutputChannel(re,Me)},createWebviewPanel(re,fe,Ae,st){return sn.createWebviewPanel(Me,re,fe,Ae,st)},createWebviewTextEditorInset(re,fe,Ae,st){return(0,B.checkProposedApiEnabled)(Me),en.createWebviewEditorInset(re,fe,Ae,st,Me)},createTerminal(re,fe,Ae){return typeof re=="object"?"pty"in re?ht.createExtensionTerminal(re):ht.createTerminalFromOptions(re):ht.createTerminal(re,fe,Ae)},registerTerminalLinkProvider(re){return ht.registerLinkProvider(re)},registerTerminalProfileProvider(re,fe){return ht.registerProfileProvider(Me,re,fe)},registerTreeDataProvider(re,fe){return hn.registerTreeDataProvider(re,fe,Me)},createTreeView(re,fe){return hn.createTreeView(re,fe,Me)},registerWebviewPanelSerializer:(re,fe)=>sn.registerWebviewPanelSerializer(Me,re,fe),registerCustomEditorProvider:(re,fe,Ae={})=>yn.registerCustomEditorProvider(Me,re,fe,Ae),registerFileDecorationProvider(re){return kt.registerFileDecorationProvider(re,Me.identifier)},registerUriHandler(re){return Vt.registerUriHandler(Me.identifier,re)},createQuickPick(){return Ot.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Ot.createInputBox(Me.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(re,fe,Ae){return mn.onDidChangeActiveColorTheme(re,fe,Ae)},registerWebviewViewProvider(re,fe,Ae){return Dn.registerWebviewViewProvider(Me,re,fe,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,B.checkProposedApiEnabled)(Me),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),gt.onDidChangeActiveNotebookEditor(re,fe,Ae)},get visibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Me),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,B.checkProposedApiEnabled)(Me),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),Wt.onDidChangeNotebookEditorSelection(re,fe,Ae)},onDidChangeNotebookEditorVisibleRanges(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),Wt.onDidChangeNotebookEditorVisibleRanges(re,fe,Ae)},showNotebookDocument(re,fe){return(0,B.checkProposedApiEnabled)(Me),gt.showNotebookDocument(re,fe)},registerExternalUriOpener(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),Gt.registerExternalUriOpener(Me.identifier,re,fe,Ae)},get openEditors(){return(0,B.checkProposedApiEnabled)(Me),bt.tabs},get onDidChangeOpenEditors(){return(0,B.checkProposedApiEnabled)(Me),bt.onDidChangeTabs},getInlineCompletionItemController(re){return(0,B.checkProposedApiEnabled)(Me),h.InlineCompletionController.get(re)}},wn={get rootPath(){return Ze.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(re){throw L.readonly()},getWorkspaceFolder(re){return ot.getWorkspaceFolder(re)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(re){throw L.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(re){throw L.readonly()},updateWorkspaceFolders:(re,fe,...Ae)=>ot.updateWorkspaceFolders(Me,re,fe||0,...Ae),onDidChangeWorkspaceFolders:function(re,fe,Ae){return ot.onDidChangeWorkspace(re,fe,Ae)},asRelativePath:(re,fe)=>ot.getRelativePath(re,fe),findFiles:(re,fe,Ae,st)=>ot.findFiles(U.GlobPattern.from(re),U.GlobPattern.from(fe),Ae,Me.identifier,st),findTextInFiles:(re,fe,Ae,st)=>{let wt,Ct;return typeof fe=="object"?(wt=fe,Ct=Ae):(wt={},Ct=fe,st=Ae),ot.findTextInFiles(re,wt||{},Ct,Me.identifier,st)},saveAll:re=>ot.saveAll(re),applyEdit(re){return kn.applyWorkspaceEdit(re)},createFileSystemWatcher:(re,fe,Ae,st)=>Mt.createFileSystemWatcher(U.GlobPattern.from(re),fe,Ae,st),get textDocuments(){return St.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw L.readonly()},openTextDocument(re){let fe;const Ae=re;if(typeof re=="string")fe=Promise.resolve(T.URI.file(re));else if(T.URI.isUri(re))fe=Promise.resolve(re);else if(!Ae||typeof Ae=="object")fe=St.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(st=>St.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,fe,Ae)=>St.onDidAddDocument(re,fe,Ae),onDidCloseTextDocument:(re,fe,Ae)=>St.onDidRemoveDocument(re,fe,Ae),onDidChangeTextDocument:(re,fe,Ae)=>St.onDidChangeDocument(re,fe,Ae),onDidSaveTextDocument:(re,fe,Ae)=>St.onDidSaveDocument(re,fe,Ae),onWillSaveTextDocument:(re,fe,Ae)=>Yt.getOnWillSaveTextDocumentEvent(Me)(re,fe,Ae),get notebookDocuments(){return gt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,fe){let Ae;if(T.URI.isUri(re))Ae=re,await gt.openNotebookDocument(re);else if(typeof re=="string")Ae=T.URI.revive(await gt.createNotebookDocument({viewType:re,content:fe}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(re,fe,Ae,st){return gt.registerNotebookSerializer(Me,re,fe,Ae,Me.enableProposedApi?st:void 0)},registerNotebookContentProvider:(re,fe,Ae,st)=>((0,B.checkProposedApiEnabled)(Me),gt.registerNotebookContentProvider(Me,re,fe,Ae,Me.enableProposedApi?st:void 0)),onDidChangeConfiguration:(re,fe,Ae)=>gn.onDidChangeConfiguration(re,fe,Ae),getConfiguration(re,fe){return fe=arguments.length===1?void 0:fe,gn.getConfiguration(re,fe,Me)},registerTextDocumentContentProvider(re,fe){return Xt.registerTextDocumentContentProvider(re,fe)},registerTaskProvider:(re,fe)=>(Ze.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Me,re,fe)),registerFileSystemProvider(re,fe,Ae){return tn.registerFileSystemProvider(Me.identifier,re,fe,Ae,Me.enableProposedApi)},get fs(){return vt.value},registerFileSearchProvider:(re,fe)=>((0,B.checkProposedApiEnabled)(Me),Tt.registerFileSearchProvider(re,fe)),registerTextSearchProvider:(re,fe)=>((0,B.checkProposedApiEnabled)(Me),Tt.registerTextSearchProvider(re,fe)),registerRemoteAuthorityResolver:(re,fe)=>((0,B.checkProposedApiEnabled)(Me),Et.registerRemoteAuthorityResolver(re,fe)),registerResourceLabelFormatter:re=>((0,B.checkProposedApiEnabled)(Me),Sn.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,fe,Ae)=>Mt.onDidCreateFile(re,fe,Ae),onDidDeleteFiles:(re,fe,Ae)=>Mt.onDidDeleteFile(re,fe,Ae),onDidRenameFiles:(re,fe,Ae)=>Mt.onDidRenameFile(re,fe,Ae),onWillCreateFiles:(re,fe,Ae)=>Mt.getOnWillCreateFileEvent(Me)(re,fe,Ae),onWillDeleteFiles:(re,fe,Ae)=>Mt.getOnWillDeleteFileEvent(Me)(re,fe,Ae),onWillRenameFiles:(re,fe,Ae)=>Mt.getOnWillRenameFileEvent(Me)(re,fe,Ae),openTunnel:re=>((0,B.checkProposedApiEnabled)(Me),Oe.openTunnel(Me,re).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,B.checkProposedApiEnabled)(Me),Oe.getTunnels()},onDidChangeTunnels:(re,fe,Ae)=>((0,B.checkProposedApiEnabled)(Me),Oe.onDidChangeTunnels(re,fe,Ae)),registerPortAttributesProvider:(re,fe)=>((0,B.checkProposedApiEnabled)(Me),Oe.registerPortsAttributesProvider(re,fe)),registerTimelineProvider:(re,fe)=>((0,B.checkProposedApiEnabled)(Me),rn.registerTimelineProvider(re,fe,Me.identifier,ct.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:re=>((0,B.checkProposedApiEnabled)(Me),ot.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,fe,Ae)=>ot.onDidGrantWorkspaceTrust(re,fe,Ae)},Ln={get inputBox(){return Ze.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Me)},createSourceControl(re,fe,Ae){return qt.createSourceControl(Me,re,fe,Ae)}},Fn={createCommentController(re,fe){return _n.createCommentController(Me,re,fe)}},Mn={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(re,fe,Ae){return _t.onDidStartDebugSession(re,fe,Ae)},onDidTerminateDebugSession(re,fe,Ae){return _t.onDidTerminateDebugSession(re,fe,Ae)},onDidChangeActiveDebugSession(re,fe,Ae){return _t.onDidChangeActiveDebugSession(re,fe,Ae)},onDidReceiveDebugSessionCustomEvent(re,fe,Ae){return _t.onDidReceiveDebugSessionCustomEvent(re,fe,Ae)},onDidChangeBreakpoints(re,fe,Ae){return _t.onDidChangeBreakpoints(re,fe,Ae)},registerDebugConfigurationProvider(re,fe,Ae){return _t.registerDebugConfigurationProvider(re,fe,Ae||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,fe){return _t.registerDebugAdapterDescriptorFactory(Me,re,fe)},registerDebugAdapterTrackerFactory(re,fe){return _t.registerDebugAdapterTrackerFactory(re,fe)},startDebugging(re,fe,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?_t.startDebugging(re,fe,{parentSession:Ae}):_t.startDebugging(re,fe,Ae||{})},stopDebugging(re){return _t.stopDebugging(re)},addBreakpoints(re){return _t.addBreakpoints(re)},removeBreakpoints(re){return _t.removeBreakpoints(re)},asDebugSourceUri(re,fe){return _t.asDebugSourceUri(re,fe)}},On={registerTaskProvider:(re,fe)=>It.registerTaskProvider(Me,re,fe),fetchTasks:re=>It.fetchTasks(re),executeTask:re=>It.executeTask(Me,re),get taskExecutions(){return It.taskExecutions},onDidStartTask:(re,fe,Ae)=>It.onDidStartTask(re,fe,Ae),onDidEndTask:(re,fe,Ae)=>It.onDidEndTask(re,fe,Ae),onDidStartTaskProcess:(re,fe,Ae)=>It.onDidStartTaskProcess(re,fe,Ae),onDidEndTaskProcess:(re,fe,Ae)=>It.onDidEndTaskProcess(re,fe,Ae)},cn={createNotebookController(re,fe,Ae,st,wt){return Jt.createNotebookController(Me,re,fe,Ae,st,Me.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,fe)=>gt.registerNotebookCellStatusBarItemProvider(Me,re,fe),get onDidSaveNotebookDocument(){return(0,B.checkProposedApiEnabled)(Me),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(re){return(0,B.checkProposedApiEnabled)(Me),Wt.createNotebookEditorDecorationType(re)},createRendererMessaging(re){return Zt.createRendererMessaging(Me,re)},onDidChangeNotebookDocumentMetadata(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookDocumentMetadata(re,fe,Ae)},onDidChangeNotebookCells(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCells(re,fe,Ae)},onDidChangeNotebookCellExecutionState(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),gt.onDidChangeNotebookCellExecutionState(re,fe,Ae)},onDidChangeCellOutputs(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),gt.onDidChangeCellOutputs(re,fe,Ae)},onDidChangeCellMetadata(re,fe,Ae){return(0,B.checkProposedApiEnabled)(Me),gt.onDidChangeCellMetadata(re,fe,Ae)},createConcatTextDocument(re,fe){return(0,B.checkProposedApiEnabled)(Me),new Ee.ExtHostNotebookConcatDocument(gt,St,re,fe)}};return{version:Xe.version,authentication:In,commands:Pn,comments:Fn,debug:Mn,env:pn,extensions:ln,languages:Tn,notebooks:cn,scm:Ln,tasks:On,tests:An,window:Rn,workspace:wn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:A.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,Task2:F.Task,TaskGroup:F.TaskGroup,TaskGroup2:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:u.UIKind,Uri:T.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:ee.TextSearchCompleteMessageType,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=it}),define(ve[275],we([0,1,81,66,36,131,37,44,45,33,70,53,72,92,52,65,132,91,63,90,121,51]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,g.registerSingleton)(y.IExtHostCommands,y.ExtHostCommands),(0,g.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,g.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(k.IExtHostDecorations,k.ExtHostDecorations),(0,g.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(P.IExtHostFileSystemInfo,P.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,g.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,g.registerSingleton)(c.IExtHostTunnelService,c.ExtHostTunnelService),(0,g.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,g.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,g.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,g.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(ve[93],we([0,1,20,12,31,69]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=T;function y(I,u,m,c){const v=(0,g.mapArrayOrNot)(m,S),_=new C.TextSearchMatch(u,v,c),b=_.preview.matches;return{ranges:(0,g.mapArrayOrNot)(v,A),uri:I,preview:{text:_.preview.text,matches:(0,g.mapArrayOrNot)(b,A)}}}e.createTextSearchResult=y;function S(I){return new C.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function A(I){return new k.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(u,m){this.prefix=u,this.logService=m}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};i=We([xe(1,L.ILogService)],i),e.OutputChannel=i}),define(ve[276],we([0,1,95,24]),function(J,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const k=512,T=512,y=512*8,S=512*128;class A{constructor(s){this.iconvLiteDecoder=s}static async create(s){let o;if(s!==e.UTF8)o=(await new Promise((a,h)=>{J(["iconv-lite-umd"],a,h)})).getDecoder(m(s));else{const n=new TextDecoder;o={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new A(o)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function i(t,s){const o=s.minBytesRequiredForDetection??s.guessEncoding?y:T;return new Promise((n,a)=>{const h=(0,g.newWriteableStream)(D=>D.join("")),d=[];let w=0,E;const r=async()=>{try{const D=await p({buffer:L.VSBuffer.concat(d),bytesRead:w},s.guessEncoding);D.encoding=await s.overwriteEncoding(D.encoding),E=await A.create(D.encoding);const R=E.write(L.VSBuffer.concat(d).buffer);h.write(R),d.length=0,w=0,n({stream:h,detected:D})}catch(D){a(D)}};(0,g.listenStream)(t,{onData:async D=>{E?h.write(E.write(D.buffer)):(d.push(D),w+=D.byteLength,w>=o&&(t.pause(),await r(),setTimeout(()=>t.resume())))},onError:D=>h.error(D),onEnd:async()=>{E||await r(),h.end(E?.end())}})})}e.toDecodeStream=i;async function I(t,s,o){const a=(await new Promise((w,E)=>{J(["iconv-lite-umd"],w,E)})).getEncoder(m(s),o);let h=!1,d=!1;return{read(){if(d)return null;const w=t.read();if(typeof w!="string"){if(d=!0,!h&&o?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=a.end();return E&&E.length>0?(h=!0,L.VSBuffer.wrap(E)):null}return h=!0,L.VSBuffer.wrap(a.write(w))}}}e.toEncodeReadable=I;async function u(t){return(await new Promise((o,n)=>{J(["iconv-lite-umd"],o,n)})).encodingExists(m(t))}e.encodingExists=u;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function c(t,s){if(!t||s<e.UTF16be_BOM.length)return null;const o=t.readUInt8(0),n=t.readUInt8(1);if(o===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return o===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const v=["ascii","utf-16","utf-32"];async function _(t){const s=await new Promise((d,w)=>{J(["jschardet"],d,w)}),o=t.slice(0,S),n=l(o.buffer),a=s.detect(n);if(!a||!a.encoding)return null;const h=a.encoding.toLowerCase();return 0<=v.indexOf(h)?null:P(a.encoding)}const b={ibm866:"cp866",big5:"cp950"};function P(t){const s=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[s]||s}function l(t){let s="";for(let o=0;o<t.length;o++)s+=String.fromCharCode(t[o]);return s}function f(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const s=t.match(/windows(\d+)/);return s?"windows-"+s[1]:t}}e.toCanonicalName=f;function p({buffer:t,bytesRead:s},o){let n=c(t,s),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let h=!0,d=!0,w=!1;for(let E=0;E<s&&E<k;E++){const r=E%2==1,D=t.readUInt8(E)===0;if(D&&(w=!0),h&&(r&&!D||!r&&D)&&(h=!1),d&&(r&&D||!r&&!D)&&(d=!1),D&&!h&&!d)break}w&&(h?n=e.UTF16le:d?n=e.UTF16be:a=!0)}return o&&!a&&!n&&t?_(t.slice(0,s)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[134],we([0,1,276,28,133]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class k extends C.TextSearchManager{constructor(y,S,A=L){super(y,S,{readdir:i=>A.Promises.readdir(i.fsPath),toCanonicalName:i=>(0,g.toCanonicalName)(i)})}}e.NativeTextSearchManager=k}),define(ve[277],we([0,1,278,293,294,2,295]),function(J,e,g,L,C,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function y(I,u,m,c,v,_){const b=_.environment.useHostProxy,P=typeof b=="boolean"?b:!_.remote.isRemote,l=(0,T.createProxyResolver)({resolveProxy:p=>I.resolveProxy(p),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(p,t,...s)=>{switch(p){case T.LogLevel.Trace:c.trace(t,...s);break;case T.LogLevel.Debug:c.debug(t,...s);break;case T.LogLevel.Info:c.info(t,...s);break;case T.LogLevel.Warning:c.warn(t,...s);break;case T.LogLevel.Error:c.error(t,...s);break;case T.LogLevel.Critical:c.critical(t,...s);break;case T.LogLevel.Off:break;default:o(p,t,s);break}function o(n,a,...h){c.error("Unknown log level",n),c.error(a,...h)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:p=>{v.$publicLog2("resolveProxy",p)},useHostProxy:P,env:process.env}),f=S(u,l);return i(m,f)}e.connectProxyResolver=y;function S(I,u){const m={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(v=>{m.config=I.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(v=>{c.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"off"},c,!0)),on:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"on"},c,!0)),override:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"override"},c,!0)),onRequest:Object.assign({},g,(0,T.createHttpPatch)(g,u,m,c,!0)),default:Object.assign(g,(0,T.createHttpPatch)(g,u,m,c,!1))},https:{off:Object.assign({},L,(0,T.createHttpPatch)(L,u,{config:"off"},c,!0)),on:Object.assign({},L,(0,T.createHttpPatch)(L,u,{config:"on"},c,!0)),override:Object.assign({},L,(0,T.createHttpPatch)(L,u,{config:"override"},c,!0)),onRequest:Object.assign({},L,(0,T.createHttpPatch)(L,u,m,c,!0)),default:Object.assign(L,(0,T.createHttpPatch)(L,u,m,c,!1))},tls:Object.assign(C,(0,T.createTlsPatch)(C))}}const A=new Map;function i(I,u){return I.getExtensionPathIndex().then(m=>{const c=J.__$__nodeRequire("module"),v=c._load;c._load=function(b,P,l){if(b==="tls")return u.tls;if(b!=="http"&&b!=="https")return v.apply(this,arguments);const f=u[b],p=m.findSubstr(k.URI.file(P.filename).fsPath);let t=A.get(p);if(t||A.set(p,t={}),!t[b]){let s=f.default;p&&p.enableProposedApi&&(s=f[p.proxySupport]||f.onRequest),t[b]={...s}}return t[b]}})}}),define(ve[279],we([0,1,39,8,77,29,11,9,93,280]),function(J,e,g,L,C,k,T,y,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(l,f,p,t){const s=u(l,f,p,t),o=f.folder.fsPath;return{cmd:g.spawn(i,s.args,{cwd:o}),rgDiskPath:i,siblingClauses:s.siblingClauses,rgArgs:s,cwd:o}}e.spawnRipgrepCmd=I;function u(l,f,p,t){const s=["--files","--hidden","--case-sensitive"];c([f],p,!1).forEach(n=>{const a=(0,S.anchorGlob)(n);if(s.push("-g",a),T.isMacintosh){const h=(0,C.normalizeNFD)(a);h!==a&&s.push("-g",h)}});const o=m([f],t,void 0,!1);return o.globArgs.forEach(n=>{const a=`!${(0,S.anchorGlob)(n)}`;if(s.push("-g",a),T.isMacintosh){const h=(0,C.normalizeNFD)(a);h!==a&&s.push("-g",h)}}),f.disregardIgnoreFiles!==!1?s.push("--no-ignore"):s.push("--no-ignore-parent"),f.ignoreSymlinks||s.push("--follow"),l.exists&&s.push("--quiet"),s.push("--no-config"),f.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:o.siblingClauses}}function m(l,f,p,t=!0){const s=[];let o={};return l.forEach(n=>{const a=Object.assign({},n.excludePattern||{},f||{}),h=v(a,t?n.folder.fsPath:void 0,p);s.push(...h.globArgs),h.siblingClauses&&(o=Object.assign(o,h.siblingClauses))}),{globArgs:s,siblingClauses:o}}e.foldersToRgExcludeGlobs=m;function c(l,f,p=!0){const t=[];return l.forEach(s=>{const o=Object.assign({},f||{},s.includePattern||{}),n=v(o,p?s.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=c;function v(l,f,p){const t=[],s={};return Object.keys(l).forEach(o=>{if(p&&p.has(o)||!o)return;const n=l[o];o=b(f?_(f,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof n=="boolean"&&n?(o.startsWith("\\\\")&&(o+="**"),t.push(P(o))):n&&n.when&&(s[o]=n)}),{globArgs:t,siblingClauses:s}}function _(l,f){return L.isAbsolute(f)?f:L.join(l,f)}e.getAbsoluteGlob=_;function b(l){return l=y.rtrim(l,"\\"),y.rtrim(l,"/")}function P(l){return k.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=P}),define(ve[281],we([0,1,39,49,8,103,20,60,30,77,29,11,46,9,14,28,31,279,100]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(o=>o())});class f{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&S.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,P.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&S.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),d=a.folder.fsPath;n.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==d).forEach(w=>{(0,i.isEqualOrParent)(w,d)&&(h[C.relative(d,w)]=!0)}),this.folderExcludePatterns.set(d,new t(h,d))})}cancel(){this.isCanceled=!0}walk(n,a,h,d,w){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);a.forEach(E=>{const r=C.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,r)||this.matchFile(h,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(n,(E,r)=>{this.call(this.cmdTraversal,this,E,h,d,D=>{if(D){const R=(0,y.toErrorMessage)(D);console.error(R),this.errors.push(R),r(D,void 0)}else r(null,void 0)})},(E,r)=>{this.fileWalkSW.stop();const D=E?T.coalesce(E)[0]:null;w(D,this.isLimitHit)})}parallel(n,a,h){const d=new Array(n.length),w=new Array(n.length);let E=!1,r=0;if(n.length===0)return h(null,[]);n.forEach((D,R)=>{a(D,(x,j)=>{if(x?(E=!0,d[R]=null,w[R]=x):(d[R]=j,w[R]=null),++r===n.length)return h(E?w:null,d)})})}call(n,a,...h){try{n.apply(a,h)}catch(d){h[h.length-1](d)}}cmdTraversal(n,a,h,d){const w=n.folder.fsPath,E=I.isMacintosh;let r;const D=()=>r&&r.kill();l.add(D);let R=F=>{l.delete(D),R=()=>{},d(F)},x="";const j=this.initDirectoryTree();let te;const Q=(0,b.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);r=Q.cmd,te=!Object.keys(Q.siblingClauses).length;const N=Q.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let U=`${Q.rgDiskPath} ${N}
 - cwd: ${Q.cwd}`;Q.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(Q.rgArgs.siblingClauses)}`),h({message:U}),this.cmdResultCount=0,this.collectStdout(r,"utf8",h,(F,V,M)=>{if(F){R(F);return}if(this.isLimitHit){R();return}const q=(x+(E?A.normalizeNFC(V||""):V)).split(`
`);if(M){const B=q.length;q[B-1]=q[B-1].trim(),q[B-1]||q.pop()}else x=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,te){for(const B of q)if(this.matchFile(a,{base:w,relativePath:B,searchPath:this.getSearchPath(n,B)}),this.isLimitHit){D();break}(M||this.isLimitHit)&&R();return}this.addDirectoryEntries(n,j,w,q,a),M&&(this.matchDirectoryTree(j,w,a),R())})}spawnFindCmd(n){const a=this.folderExcludePatterns.get(n.folder.fsPath),h=a.getBasenameTerms(),d=a.getPathTerms(),w=["-L","."];if(h.length||d.length){w.push("-not","(","(");for(const E of h)w.push("-name",E),w.push("-o");for(const E of d)w.push("-path",E),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),g.spawn("find",w,{cwd:n.folder.fsPath})}readStdout(n,a,h){let d="";this.collectStdout(n,a,()=>{},(w,E,r)=>{if(w){h(w);return}d+=E,r&&h(null,d)})}collectStdout(n,a,h,d){let w=(D,R,x)=>{(D||x)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),d(D,R,x)},E=!1;n.stdout?(this.forwardData(n.stdout,a,w),n.stdout.once("data",()=>E=!0)):h({message:"stdout is null"});let r;n.stderr?r=this.collectData(n.stderr):h({message:"stderr is null"}),n.on("error",D=>{w(D)}),n.on("close",D=>{let R;!E&&(R=this.decodeData(r,a))&&s(R)?w(new Error(`command failed with error code ${D}: ${this.decodeData(r,a)}`)):(this.exists&&D===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(n,a,h){const d=new k.StringDecoder(a);return n.on("data",w=>{h(null,d.write(w))}),d}collectData(n){const a=[];return n.on("data",h=>{a.push(h)}),a}decodeData(n,a){const h=new k.StringDecoder(a);return n.map(d=>h.write(d)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:a},h,d,w){d.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const E=r=>{const D=C.basename(r),R=C.dirname(r);let x=a[R];x||(x=a[R]=[],E(R)),x.push({base:h,relativePath:r,basename:D,searchPath:this.getSearchPath(n,r)})};d.forEach(E)}matchDirectoryTree({rootEntries:n,pathToEntries:a},h,d){const w=this,E=this.folderExcludePatterns.get(h),r=this.filePattern;function D(R){w.directoriesWalked++;const x=S.hasSiblingFn(()=>R.map(j=>j.basename));for(let j=0,te=R.length;j<te;j++){const Q=R[j],{relativePath:N,basename:U}=Q;if(E.test(N,U,r!==U?x:void 0))continue;const F=a[N];if(F)D(F);else{if(w.filesWalked++,N===r)continue;w.matchFile(d,Q)}if(w.isLimitHit)break}}D(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,a,h,d,w){const E=n.folder,r=S.hasSiblingFn(()=>h);this.parallel(h,(D,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const x=a?[a,D].join(C.sep):D;if(this.folderExcludePatterns.get(n.folder.fsPath).test(x,D,this.config.filePattern!==D?r:void 0))return R(null);const j=[E.fsPath,x].join(C.sep);L.lstat(j,(te,Q)=>{if(te||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(j,Q,(N,U)=>N||this.isCanceled||this.isLimitHit?R(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(j,Q,(F,V)=>F||this.isCanceled||this.isLimitHit||(V=V||"",this.walkedPaths[V])?R(null):(this.walkedPaths[V]=!0,v.Promises.readdir(j).then(M=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(n,x,M,d,O=>R(O||null))},M=>{R(null)})))):(this.filesWalked++,x===this.filePattern||this.maxFilesize&&c.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(d,{base:E.fsPath,relativePath:x,searchPath:this.getSearchPath(n,x)}),R(null,void 0)))})},D=>{const R=D&&T.coalesce(D);return w(R&&R.length>0?R[0]:void 0)})}matchFile(n,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,C.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(a))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,a,h){return a.isSymbolicLink()?L.stat(n,h):h(null,a)}realPathIfNeeded(n,a,h){return a.isSymbolicLink()?L.realpath(n,(d,w)=>d?h(d):h(null,w)):h(null,n)}getSearchPath(n,a){return n.folderName?C.join(n.folderName,a):a}}e.FileWalker=f;class p{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new f(n)}search(n,a,h){this.walker.walk(this.folderQueries,this.extraFiles,n,a,(d,w)=>{h(d,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(n,a){this.expression=n,this.root=a,this.init(n)}init(n){let a,h;Object.keys(n).filter(d=>n[d]).forEach(d=>{C.isAbsolute(d)?(a=a||S.getEmptyExpression(),a[d]=n[d]):(h=h||S.getEmptyExpression(),h[d]=n[d])}),this.absoluteParsedExpr=a&&S.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=h&&S.parse(h,{trimForExclusions:!0})}test(n,a,h){return this.relativeParsedExpr&&this.relativeParsedExpr(n,a,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,n),a,h)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getPathTerms(this.relativeParsedExpr)),n}}function s(o){const n=o.trim().split(`
`),a=n[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return m.uppercaseFirstLetter(n[n.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=s}),define(ve[135],we([0,1,39,296,103,20,55,30,8,9,2,31,69,297,280,93]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(E){this.outputChannel=E}provideTextSearchResults(E,r,D,R){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...r,folder:r.folder.toString()})}`),new Promise((x,j)=>{R.onCancellationRequested(()=>O());const te=s(E,r),Q=r.folder.fsPath,N=te.map(me=>me.match(/^-/)?me:`'${me}'`).join(" ");this.outputChannel.appendLine(`${_} ${N}
 - cwd: ${Q}`);let U=g.spawn(_,te,{cwd:Q});U.on("error",me=>{console.error(me),this.outputChannel.appendLine("Error: "+(me&&me.message)),j((0,I.serializeSearchError)(new I.SearchError(me&&me.message,I.SearchErrorCode.rgProcessError)))});let F=!1;const V=new f(r.maxResults,Q,r.previewOptions);V.on("result",me=>{F=!0,B="",D.report(me)});let M=!1;const O=()=>{M=!0,U&&U.kill(),V&&V.cancel()};let q=!1;V.on("hitLimit",()=>{q=!0,O()});let B="";U.stdout.on("data",me=>{V.handleData(me),F||(B+=me)});let K=!1;U.stdout.once("data",()=>K=!0);let ne="";U.stderr.on("data",me=>{const Se=me.toString();this.outputChannel.appendLine(Se),ne+=Se}),U.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(F?"Got result from parser":"No result from parser"),B&&this.outputChannel.appendLine(`Got data without result: ${B}`),this.outputChannel.appendLine(""),M)x({limitHit:q});else{V.flush(),U=null;let me;ne&&!K&&(me=P(ne))?j((0,I.serializeSearchError)(new I.SearchError(me.message,me.code))):x({limitHit:q})}})})}}e.RipgrepTextSearchEngine=b;function P(w){const E=w.split(`
`),r=E[0].trim();if(E.some(R=>R.startsWith("regex parse error")))return new I.SearchError(l(E),I.SearchErrorCode.regexParseError);const D=r.match(/grep config error: unknown encoding: (.*)/);if(D)return new I.SearchError(`Unknown encoding: ${D[1]}`,I.SearchErrorCode.unknownEncoding);if(r.startsWith("error parsing glob"))return new I.SearchError(r.charAt(0).toUpperCase()+r.substr(1),I.SearchErrorCode.globParseError);if(r.startsWith("the literal"))return new I.SearchError(r.charAt(0).toUpperCase()+r.substr(1),I.SearchErrorCode.invalidLiteral);if(r.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(r,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=P;function l(w){const E=["Regex parse error"],r=w.filter(D=>D.startsWith("PCRE2:"));if(r.length>=1){const D=r[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const R=D.split(":")[1];E.push(":"+R)}}return E.join("")}e.buildRegexParseError=l;class f extends L.EventEmitter{constructor(E,r,D){super();this.maxResults=E,this.rootFolder=r,this.previewOptions=D,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,r){return super.on(E,r),this}handleData(E){if(this.isDone)return;const r=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(r)}handleDecodedData(E){let r=E.indexOf(`
`);const D=this.remainder+E;if(r>=0)r+=this.remainder.length;else{this.remainder=D;return}let R=0;for(;r>=0;)this.handleLine(D.substring(R,r).trim()),R=r+1,r=D.indexOf(`
`,R);this.remainder=D.substring(R)}handleLine(E){if(this.isDone||!E)return;let r;try{r=JSON.parse(E)}catch(D){throw new Error(`malformed line from rg: ${E}`)}if(r.type==="match"){const D=p(r.data.path),R=i.URI.file(S.join(this.rootFolder,D)),x=this.createTextSearchMatch(r.data,R);this.onResult(x),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(r.type==="context"){const D=p(r.data.path),R=i.URI.file(S.join(this.rootFolder,D));this.createTextSearchContext(r.data,R).forEach(j=>this.onResult(j))}}createTextSearchMatch(E,r){const D=E.line_number-1,R=p(E.lines),x=Buffer.from(R);let j=0,te=0,Q=D;E.submatches.length===0&&E.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const N=(0,k.coalesce)(E.submatches.map((U,F)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const V=p(U.match),M=x.slice(j,U.start).toString().length,O=te+M,q=t(V),B=Q,K=q.numLines+B,ne=q.numLines>0?q.lastLineLength:q.lastLineLength+O;return j=U.end,te=ne,Q=K,new u.Range(B,O,K,ne)}));return(0,v.createTextSearchResult)(r,R,N,this.previewOptions)}createTextSearchContext(E,r){const D=p(E.lines),R=E.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((x,j)=>({text:x,uri:r,lineNumber:R+j}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=f;function p(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const E=/\n/g;let r=0,D=-1,R;for(;R=E.exec(w);)r++,D=R.index;const x=D>=0?w.length-D-1:w.length;return{numLines:r,lastLineLength:x}}function s(w,E){const r=["--hidden"];r.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:R}=(0,T.groupBy)(E.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const j=new Set;R.forEach(te=>{j.add(te)}),r.push("-g","!*"),j.forEach(te=>{o(te).map(v.anchorGlob).forEach(Q=>{r.push("-g",Q)})})}D&&D.length&&D.forEach(j=>{r.push("-g",j)}),E.excludes.map(v.anchorGlob).forEach(j=>r.push("-g",`!${j}`)),E.maxFileSize&&r.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?r.push("--no-ignore-parent"):r.push("--no-ignore"),E.followSymlinks&&r.push("--follow"),E.encoding&&E.encoding!=="utf8"&&r.push("--encoding",E.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,A.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),E.usePCRE2&&r.push("--pcre2"),r.push("--crlf"),w.isRegExp&&(w.pattern=n(w.pattern),r.push("--auto-hybrid-regex"));let x;if(w.isWordMatch){const te=(0,A.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");r.push("--regexp",te)}else if(w.isRegExp){let j=h(w.pattern);j=d(j),r.push("--regexp",j)}else x=w.pattern,r.push("--fixed-strings");return r.push("--no-config"),E.useGlobalIgnoreFiles||r.push("--no-ignore-global"),r.push("--json"),w.isMultiline&&r.push("--multiline"),E.beforeContext&&r.push("--before-context",E.beforeContext+""),E.afterContext&&r.push("--after-context",E.afterContext+""),r.push("--"),x&&r.push(x),r.push("."),r}function o(w){const E=(0,y.splitGlobAware)(w,"/");return E.map((r,D)=>E.slice(0,D+1).join("/"))}e.spreadGlobComponents=o;function n(w){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");const r=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(r);)w=w.replace(r,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=n;const a=w=>w.type==="Assertion"&&w.kind==="lookbehind";function h(w){let E;try{E=new m.RegExpParser().parsePattern(w)}catch{return w}let r="",D=0;const R=(te,Q,N)=>{r+=w.slice(D,te)+N,D=Q},x=[];return new m.RegExpVisitor({onCharacterEnter(te){if(te.raw!=="\\n")return;const Q=x[0];if(!Q)R(te.start,te.end,"\\r?\\n");else if(!x.some(a))if(Q.type==="CharacterClass")if(Q.negate){const N=w.slice(Q.start+2,te.start)+w.slice(te.end,Q.end-1);R(Q.start,Q.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=w.slice(Q.start+1,te.start)+w.slice(te.end,Q.end-1);R(Q.start,Q.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else Q.type==="Quantifier"&&R(te.start,te.end,"(?:\\r?\\n)")},onQuantifierEnter(te){x.unshift(te)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(te){x.unshift(te)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(te){x.unshift(te)},onCharacterClassLeave(){x.shift()},onAssertionEnter(te){a(te)&&x.push(te)},onAssertionLeave(te){x[0]===te&&x.shift()}}).visit(E),r+=w.slice(D),r}e.fixRegexNewline=h;function d(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(ve[282],we([0,1,21,135,117,10]),function(J,e,g,L,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,i,I,u){const m=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===k.Schemas.userData){const c={...i,folder:i.folder.with({scheme:k.Schemas.file})},v=new C.Progress(_=>I.report({..._,uri:_.uri.with({scheme:i.folder.scheme})}));return this.withToken(u,_=>m.provideTextSearchResults(A,c,v,_))}else return this.withToken(u,c=>m.provideTextSearchResults(A,i,I,c))}async withToken(A,i){const I=y(A);this.inProgress.add(I);const u=await i(I.token);return this.inProgress.delete(I),u}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=T;function y(S){const A=new g.CancellationTokenSource;return S.onCancellationRequested(()=>A.cancel()),A}}),define(ve[283],we([0,1,28,135,134]),function(J,e,g,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class k{constructor(S){this.query=S}search(S,A,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(m){i({message:m})}},u=new C.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((m,c)=>u.search(v=>{A(v.map(T))},S).then(v=>m({limitHit:v.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=k;function T(y){return{path:y.resource&&y.resource.fsPath,results:y.results,numMatches:(y.results||[]).reduce((S,A)=>{if(A.ranges){const i=A;return S+(Array.isArray(i.ranges)?i.ranges.length:1)}else return S+1},0)}}}),define(ve[284],we([0,1,49,298,20,17,16,3,100,8,46,2,42,31,281,283]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(g);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let s;const o=l(t),n=new y.Emitter({onFirstListenerDidAdd:()=>{s=(0,k.createCancelablePromise)(a=>this.doFileSearchWithEngine(c.Engine,o,h=>n.fire(h),a)),s.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}textSearch(t){let s;const o=l(t),n=new y.Emitter({onFirstListenerDidAdd:()=>{s=(0,k.createCancelablePromise)(a=>this.ripgrepTextSearch(o,h=>n.fire(h),a)),s.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}ripgrepTextSearch(t,s,o){return t.maxFileSize=(0,u.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(o,s,s)}doFileSearch(t,s,o){return this.doFileSearchWithEngine(c.Engine,t,s,o)}doFileSearchWithEngine(t,s,o,n,a=_.BATCH_SIZE){let h=0;const d=E=>{Array.isArray(E)?(h+=E.length,o(E.map(r=>this.rawMatchToSearchItem(r)))):E.relativePath?(h++,o(this.rawMatchToSearchItem(E))):o(E)};if(s.sortByScore){let E=this.trySortedSearchFromCache(s,d,n);if(!E){const r=s.maxResults?Object.assign({},s,{maxResults:null}):s,D=new t(r);E=this.doSortedSearch(D,s,o,d,n)}return new Promise((r,D)=>{E.then(([R,x])=>{const j=x.map(te=>this.rawMatchToSearchItem(te));this.sendProgress(j,o,a),r(R)},D)})}const w=new t(s);return this.doSearch(w,d,a,n).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,A.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,s,o,n,a){const h=new y.Emitter;let d=(0,k.createCancelablePromise)(E=>{let r=[];const D=R=>{Array.isArray(R)?r=R:(n(R),h.fire(R))};return this.doSearch(t,D,-1,E).then(R=>[R,r])}),w;if(s.cacheKey){w=this.getOrCreateCache(s.cacheKey);const E={promise:d,event:h.event,resolved:!1};w.resultsToSearchCache[s.filePattern||""]=E,d.then(()=>{E.resolved=!0},r=>{delete w.resultsToSearchCache[s.filePattern||""]}),d=this.preventCancellation(d)}return d.then(([E,r])=>{const D=w?w.scorerCache:Object.create(null),R=(typeof s.maxResults!="number"||s.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(s,r,D,a).then(x=>{const j=R?R.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:j,fromCache:!1,type:"searchProcess",workspaceFolderCount:s.folderQueries.length,resultCount:x.length},messages:E.messages,limitHit:E.limitHit||typeof s.maxResults=="number"&&r.length>s.maxResults},x]})})}getOrCreateCache(t){const s=this.caches[t];return s||(this.caches[t]=new b)}trySortedSearchFromCache(t,s,o){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const a=this.getResultsFromCache(n,t.filePattern||"",s,o);if(a)return a.then(([h,d,w])=>{const E=i.StopWatch.create(!1);return this.sortResults(t,d,n.scorerCache,o).then(r=>{const D=E.elapsed(),R={fromCache:!0,detailStats:w,type:"searchProcess",resultCount:d.length,sortingTime:D};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&d.length>t.maxResults,stats:R},r]})})}sortResults(t,s,o,n){const a=(0,S.prepareQuery)(t.filePattern||""),h=(w,E)=>(0,S.compareItemsByFuzzyScore)(w,E,a,!0,P,o),d=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(s,h,d,1e4,n)}sendProgress(t,s,o){if(o&&o>0)for(let n=0;n<t.length;n+=o)s(t.slice(n,n+o));else s(t)}getResultsFromCache(t,s,o,n){const a=i.StopWatch.create(!1),h=s.indexOf(A.sep)>=0;let d;for(const D in t.resultsToSearchCache)if(s.startsWith(D)){if(h&&D.indexOf(A.sep)<0&&D!=="")continue;const R=t.resultsToSearchCache[D];d={promise:this.preventCancellation(R.promise),event:R.event,resolved:R.resolved};break}if(!d)return null;const w=a.elapsed(),E=i.StopWatch.create(!1),r=d.event(o);return n&&n.onCancellationRequested(()=>{r.dispose()}),d.promise.then(([D,R])=>{if(n&&n.isCancellationRequested)throw(0,T.canceled)();const x=[],j=(0,S.prepareQuery)(s).normalizedLowercase;for(const te of R)!(0,m.isFilePatternMatch)(te,j)||x.push(te);return[D,x,{cacheWasResolved:d.resolved,cacheLookupTime:w,cacheFilterTime:E.elapsed(),cacheEntryCount:R.length}]})}doSearch(t,s,o,n){return new Promise((a,h)=>{let d=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(o?(d.push(w),o>0&&d.length>=o&&(s(d),d=[])):s(w))},w=>{s(w)},(w,E)=>{d.length&&s(d),w?h(w):a(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,o){return t.then(s,o)}catch(s){return this.then(void 0,s)}finally(s){return t.finally(s)}}}}e.SearchService=_,_.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const P=new class{getItemLabel(p){return(0,A.basename)(p.relativePath)}getItemDescription(p){return(0,A.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(f),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>I.URI.revive(t))}}function f(p){return{...p,folder:I.URI.revive(p.folder)}}}),define(ve[285],we([0,1,6,2,28,12,31,284,282,93,13,64,27,72,10,134]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends m.ExtHostSearch{constructor(P,l,f,p){super(P,f,p);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new A.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new S.RipgrepSearchProvider(t)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const P=new A.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new S.RipgrepSearchProvider(P)),this.registerInternalFileSearchProvider(c.Schemas.file,new y.SearchService)}registerInternalFileSearchProvider(P,l){const f=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=f,this._proxy.$registerFileSearchProvider(f,this._transformScheme(P)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(P,l,f,p){const t=(0,m.reviveQuery)(f);return P===this._internalFileSearchHandle?this.doInternalFileSearch(P,l,t,p):super.$provideFileSearchResults(P,l,f,p)}doInternalFileSearch(P,l,f,p){const t=s=>{if((0,T.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(P,l,s.map(o=>L.URI.file(o.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(f,t,p)}$clearCache(P){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(P),super.$clearCache(P)}createTextSearchManager(P,l){return new v.NativeTextSearchManager(P,l)}};_=We([xe(0,i.IExtHostRpcService),xe(1,u.IExtHostInitDataService),xe(2,I.IURITransformerService),xe(3,k.ILogService)],_),e.NativeExtHostSearch=_}),define(ve[136],we([0,1,299,124,79,24,16,3,6,8,11,32,105,106,300]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(d){this.socket=d,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const w=E=>d(k.VSBuffer.wrap(E));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(d){const w=E=>{d({type:0,hadError:E,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,T.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((d,w)=>{if(this.socket.bufferSize===0){d();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),d()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=v;var _;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var b;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(b||(b={}));class P extends S.Disposable{constructor(d,w,E,r){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=r,w?(this._zlibInflate=c.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})}),this._zlibInflate.on("data",D=>{this._pendingInflateData.push(D)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=c.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",D=>{console.error(D),(0,T.onUnexpectedError)(D),this._onClose.fire({type:0,hadError:!0,error:D})}),this._zlibDeflate.on("data",D=>{this._pendingDeflateData.push(D)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(D=>this._acceptChunk(D))),this._register(this.socket.onClose(D=>this._onClose.fire(D)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(k.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,w){let E=2;d.byteLength<126?E+=0:d.byteLength<2**16?E+=2:E+=8;const r=k.VSBuffer.alloc(E);if(w?r.writeUInt8(194,0):r.writeUInt8(130,0),d.byteLength<126)r.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){r.writeUInt8(126,1);let D=1;r.writeUInt8(d.byteLength>>>8&255,++D),r.writeUInt8(d.byteLength>>>0&255,++D)}else{r.writeUInt8(127,1);let D=1;r.writeUInt8(0,++D),r.writeUInt8(0,++D),r.writeUInt8(0,++D),r.writeUInt8(0,++D),r.writeUInt8(d.byteLength>>>24&255,++D),r.writeUInt8(d.byteLength>>>16&255,++D),r.writeUInt8(d.byteLength>>>8&255,++D),r.writeUInt8(d.byteLength>>>0&255,++D)}this._totalOutgoingWireBytes+=r.byteLength+d.byteLength,this.socket.write(k.VSBuffer.concat([r,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),r=(w.readUInt8(0)&128)>>>7,D=w.readUInt8(1),R=(D&128)>>>7,x=D&127;this._state.state=2,this._state.readLen=2+(R?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=r,this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),E=w.readUInt8(1),r=(E&128)>>>7;let D=E&127,R=1;D===126?D=w.readUInt8(++R)*2**8+w.readUInt8(++R):D===127&&(D=w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*0+w.readUInt8(++R)*2**24+w.readUInt8(++R)*2**16+w.readUInt8(++R)*2**8+w.readUInt8(++R));let x=0;r&&(x=w.readUInt8(++R)*2**24+w.readUInt8(++R)*2**16+w.readUInt8(++R)*2**8+w.readUInt8(++R)),this._state.state=3,this._state.readLen=D,this._state.mask=x}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);l(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(k.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function l(h,d){if(d===0)return;let w=h.byteLength>>>2;for(let j=0;j<w;j++){const te=h.readUInt32BE(j*4);h.writeUInt32BE(te^d,j*4)}let E=w*4,r=h.byteLength-E;const D=d>>>24&255,R=d>>>16&255,x=d>>>8&255;r>=1&&h.writeUInt8(h.readUInt8(E)^D,E),r>=2&&h.writeUInt8(h.readUInt8(E+1)^R,E+1),r>=3&&h.writeUInt8(h.readUInt8(E+2)^x,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[2]:107,[1]:103};function p(){const h=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):d=(0,A.join)((0,C.tmpdir)(),`vscode-ipc-${h}.sock`),s(d),d}e.createRandomIPCHandle=p;function t(h,d,w){const E=(0,g.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${w}-${d}-sock`;let r;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?r=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${w}-${d}.sock`):r=(0,A.join)(h,`${w}-${d}.sock`),s(r),r}e.createStaticIPCHandle=t;function s(h){const d=f[i.platform];typeof d=="number"&&h.length>=d&&console.warn(`WARNING: IPC handle "${h}" is longer than ${d} chars, try a shorter --user-data-dir`)}class o extends u.IPCServer{constructor(d){super(o.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const w=y.Event.fromNodeEventEmitter(d,"connection");return y.Event.map(w,E=>({protocol:new m.Protocol(new v(E)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function n(h){return new Promise((d,w)=>{const E=(0,L.createServer)();E.on("error",w),E.listen(h,()=>{E.removeListener("error",w),d(new o(E))})})}e.serve=n;function a(h,d){return new Promise((w,E)=>{const r=(0,L.createConnection)(h,()=>{r.removeListener("error",E),w(m.Client.fromSocket(new v(r),d))});r.once("error",E)})}e.connect=a}),define(ve[286],we([0,1,136,278,49,44,2,198,12]),function(J,e,g,L,C,k,T,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(u,m,c){this._commands=u,this.logService=m,this._ipcHandlePath=c,this._server=L.createServer((v,_)=>this.onRequest(v,_)),this.setup().catch(v=>(m.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,m){const c=[];u.setEncoding("utf8"),u.on("data",v=>c.push(v)),u.on("end",()=>{const v=JSON.parse(c.join(""));switch(v.type){case"open":this.open(v,m);break;case"openExternal":this.openExternal(v,m);break;case"status":this.getStatus(v,m);break;case"extensionManagement":this.manageExtensions(v,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${v.type}`,_=>{_&&this.logService.error(_)}),m.end();break}})}open(u,m){let{fileURIs:c,folderURIs:v,forceNewWindow:_,diffMode:b,addMode:P,forceReuseWindow:l,gotoLineMode:f,waitMarkerFilePath:p}=u;const t=[];if(Array.isArray(v))for(const s of v)try{t.push({folderUri:T.URI.parse(s)})}catch(o){}if(Array.isArray(c))for(const s of c)try{(0,y.hasWorkspaceFileExtension)(s)?t.push({workspaceUri:T.URI.parse(s)}):t.push({fileUri:T.URI.parse(s)})}catch(o){}if(t.length){const s=p?T.URI.file(p):void 0,n={forceNewWindow:_,diffMode:b,addMode:P,gotoLineMode:f,forceReuseWindow:l,preferNewWindow:!l&&!s&&!P,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}m.writeHead(200),m.end()}async openExternal(u,m){for(const c of u.uris){const v=T.URI.parse(c),_=v.scheme==="file"?v:c;await this._commands.executeCommand("_remoteCLI.openExternal",_)}m.writeHead(200),m.end()}async manageExtensions(u,m){try{const c=b=>b?.map(P=>/\.vsix$/i.test(P)?T.URI.parse(P):P),v={list:u.list,install:c(u.install),uninstall:c(u.uninstall),force:u.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);m.writeHead(200),m.write(_)}catch(c){m.writeHead(500),m.write(String(c),v=>{v&&this.logService.error(v)})}m.end()}async getStatus(u,m){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(c),m.end()}catch(c){m.writeHead(500),m.write(String(c),v=>{v&&this.logService.error(v)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let i=class extends A{constructor(u,m){super(u,m,(0,g.createRandomIPCHandle)())}};i=We([xe(0,k.IExtHostCommands),xe(1,S.ILogService)],i),e.CLIServer=i}),define(ve[287],we([0,1,71,274,269,5,277,40,259,2,10,7,286,104]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends C.RequireInterceptor{_installInterceptor(){const b=this,P=J.__$__nodeRequire("module"),l=P._load;P._load=function(p,t,s){for(let o of b._alternatives){let n=o(p);if(n){p=n;break}}return b._factories.has(p)?b._factories.get(p).load(p,A.URI.file((0,m.realpathSync)(t.filename)),o=>l.apply(this,[o,t,s])):l.apply(this,arguments)}}}class v extends y.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,b,this._registry).install(),g.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const f=process.send,p=this._extHostContext.getProxy(k.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?f.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,P,l){if(P.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${P}', must be of file-scheme`);let f=null;l.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${P.toString(!0)}`),this._logService.flush();try{b&&g.mark(`code/extHost/willLoadExtensionCode/${b.value}`),f=J.__$__nodeRequire(P.fsPath)}catch(p){return Promise.reject(p)}finally{b&&g.mark(`code/extHost/didLoadExtensionCode/${b.value}`),l.codeLoadingStop()}return Promise.resolve(f)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const P in b){const l=b[P];l===null?delete process.env[P]:process.env[P]=l}}}e.ExtHostExtensionService=v}),define(ve[288],we([0,1,81,260,262,271,270,285,287,227,263,53,40,66,72,70,33,52,12,67,261]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_,b,P,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(u.IExtHostExtensionService,S.ExtHostExtensionService),(0,g.registerSingleton)(P.ILogService,A.ExtHostLogService),(0,g.registerSingleton)(l.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,g.registerSingleton)(I.IExtHostDebugService,T.ExtHostDebugService),(0,g.registerSingleton)(m.IExtHostOutputService,L.ExtHostOutputService2),(0,g.registerSingleton)(c.IExtHostSearch,y.NativeExtHostSearch),(0,g.registerSingleton)(v.IExtHostTask,k.ExtHostTask),(0,g.registerSingleton)(_.IExtHostTerminalService,C.ExtHostTerminalService),(0,g.registerSingleton)(b.IExtHostTunnelService,i.ExtHostTunnelService)}),define(ve[289],we([0,1,124,301,71,16,106,136,191,225,272,24,102,28,104,17,113,275,288]),function(J,e,g,L,C,k,T,y,S,A,i,I,u,m,c,v,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let a=0;a<process.execArgv.length;a++)process.execArgv[a]==="--inspect-port=0"&&(process.execArgv.splice(a,1),a--)}();const b=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=J.__$__nodeRequire("module"),a=n._load;n._load=function(h){if(h==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return a.apply(this,arguments)}})();const P=process.exit.bind(process);function l(n){process.exit=function(a){if(n)P(a);else{const h=new Error("An extension called process.exit() and this was prevented.");console.warn(h.stack)}},process.crash=function(){const a=new Error("An extension called process.crash() and this was prevented.");console.warn(a.stack)}}let f=function(n){P()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,a)=>{let h=null,d=setTimeout(()=>{f("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,E=3e5,r=new v.RunOnceScheduler(()=>f("renderer disconnected for too long (1)"),w),D=new v.RunOnceScheduler(()=>f("renderer disconnected for too long (2)"),E);process.on("message",(x,j)=>{if(x&&x.type==="VSCODE_EXTHOST_IPC_SOCKET"){const te=I.VSBuffer.wrap(Buffer.from(x.initialDataChunk,"base64"));let Q;if(x.skipWebSocketFrames)Q=new y.NodeSocket(j);else{const N=I.VSBuffer.wrap(Buffer.from(x.inflateBytes,"base64"));Q=new y.WebSocketNodeSocket(new y.NodeSocket(j),x.permessageDeflate,N,!1)}h?(r.cancel(),D.cancel(),h.beginAcceptReconnection(Q,te),h.endAcceptReconnection()):(clearTimeout(d),h=new T.PersistentProtocol(Q,te),h.onDidDispose(()=>f("renderer disconnected")),n(h),h.onSocketClose(()=>{r.schedule()}))}if(x&&x.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(D.isScheduled())return;r.isScheduled()&&D.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((a,h)=>{const d=g.createConnection(n,()=>{d.removeListener("error",h),a(new T.PersistentProtocol(new y.NodeSocket(d)))});d.once("error",h),d.on("close",()=>{f("renderer closed the socket")})})}}async function t(){const n=await p();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(a=>{(0,A.isMessageOfType)(a,2)?(this._terminating=!0,f("received terminate message from renderer")):this._onMessage.fire(a)})}send(a){this._terminating||n.send(a)}drain(){return n.drain()}}}function s(n){return new Promise(a=>{const h=n.onMessage(d=>{h.dispose();const w=JSON.parse(d.toString()),E=w.commit,r=S.default.commit;E&&r&&E!==r&&P(55);const D=[];process.on("unhandledRejection",(j,te)=>{D.push(te),setTimeout(()=>{const Q=D.indexOf(te);Q>=0&&te.catch(N=>{D.splice(Q,1),(0,k.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,k.onUnexpectedError)(j))})},1e3)}),process.on("rejectionHandled",j=>{const te=D.indexOf(j);te>=0&&D.splice(te,1)}),process.on("uncaughtException",function(j){(0,k.onUnexpectedError)(j)});let R=0;setInterval(function(){try{process.kill(w.parentPid,0),R=0}catch(j){j&&j.code==="EPERM"?(R++,R>=3&&f(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):f(`parent process ${w.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let x;try{x=J.__$__nodeRequire("native-watchdog"),x.start(w.parentPid)}catch(j){(0,k.onUnexpectedError)(j)}n.send((0,A.createMessageOfType)(0)),a({protocol:n,initData:w})});n.send((0,A.createMessageOfType)(1))})}async function o(){C.mark("code/extHost/willConnectToRenderer");const n=await t();C.mark("code/extHost/didConnectToRenderer");const a=await s(n);C.mark("code/extHost/didWaitForInitData");const{initData:h}=a;l(!!h.environment.extensionTestsLocationURI),h.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,h.environment.skipWorkspaceStorageLock=(0,_.boolean)(b.skipWorkspaceStorageLock,!1);const d=new class{exit(D){P(D)}exists(D){return m.Promises.exists(D)}realpath(D){return(0,c.realpath)(D)}};let w=null;if(h.remote.authority&&b.uriTransformerPath)try{const D=J.__$__nodeRequire(b.uriTransformerPath)(h.remote.authority);w=new u.URITransformer(D)}catch(r){console.error(r)}const E=new i.ExtensionHostMain(a.protocol,h,d,w);f=r=>E.terminate(r)}e.startExtensionHostProcess=o}),define(ve[302],we([0,1,289]),function(J,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/58454f7bec838f79fe2422ab5914419147d82e40/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
